<?php
// +-------------------------------------------------+
//  2002-2005 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: frame_commande.php,v 1.42 2007/11/05 15:23:22 dbellamy Exp $


//Liste les lignes d'une commande
$base_path="../../..";                            
//$base_auth = "ACQUISITION_AUTH";  
$include_path = "$base_path/includes";
$class_path = "$base_path/classes";

$current_alert="acquisition";
require_once("$include_path/init.inc.php");

// gestion des lignes de commandes
require_once("$class_path/notice.class.php");
require_once("$class_path/entites.class.php");
require_once("$class_path/types_produits.class.php");
require_once("$class_path/tva_achats.class.php");
require_once("$class_path/budgets.class.php");
require_once("$class_path/rubriques.class.php");
require_once("$class_path/actes.class.php");
require_once("$class_path/lignes_actes.class.php");
require_once("$class_path/liens_actes.class.php");
require_once("$class_path/offres_remises.class.php");
require_once("$class_path/suggestions.class.php");
require_once("$include_path/templates/commandes.tpl.php");

require_once($base_path."/acquisition/suggestions/func_suggestions.inc.php");
		

$error = false;
$error_msg = '';


//verification du formulaire
function verif_cde() {

	global $msg;
	global $max_lig;
	global $code, $lib, $qte, $prix, $tva, $rem, $dat_liv, $rub;
	global $error, $error_msg, $warning, $warning_msg;
	global $acquisition_budget, $acquisition_gestion_tva;
	global $action;


	//Si la dernire ligne n'est pas renseigne, on l'ignore pour l'enregistrement
	if ($action!='add_lig' && $max_lig>0 && !$code[$max_lig] && !$lib[$max_lig]) $max_lig--;

	//Si pas de lignes sur la commande >> Avertissement utilisateur et retour
	if ( ($action == 'update' || $action == 'valid') && ($max_lig == 0) ) {
		$error = true;
		$error_msg = $msg['acquisition_cde_vid']; 
		return;
	}
	
	for($i='1'; $i<=$max_lig; $i++) {
		//vrification libell
		if ($lib[$i] == '') {
			$error = true;		
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_lib_liv_inv'];
			break;			
		}
		
		//Vrification qt
		if (!is_numeric($qte[$i]) || $qte[$i] < '0' || $qte[$i] > '99999' ) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_qte_liv_inv'];
			break;
		}
	
		//Vrification prix
		$prix[$i] = str_replace(',','.',$prix[$i]);
		if (!is_numeric($prix[$i]) || $prix[$i] < '0' || $prix[$i] > '999999.99' ) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_prix_liv_inv'];
			break;
		}	
	
		if ($acquisition_gestion_tva) {
			//Vrification tva
			$tva[$i] = str_replace(',','.',$tva[$i]);
			if (!is_numeric($tva[$i]) || $tva[$i] < '0' || $tva[$i] > '99.99' ) {
				$error = true;
				$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_tva_liv_inv'];
				break;
			}	
		}				
		
		//Vrification remise
		$rem[$i] = str_replace(',','.',$rem[$i]);
		if (!is_numeric($rem[$i]) || $rem[$i] < '0' || $rem[$i] > '99.99' ) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_rem_liv_inv'];
			break;
		}	

		//Format date livraison
		$dat = extraitdate($dat_liv[$i]);
		$ex_dat = explode('-', $dat);
		
		if ( $dat_liv[$i]==''  ||  strlen($ex_dat[0])<>4  || !checkdate($ex_dat[1], $ex_dat[2], $ex_dat[0]) ) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_date_liv_inv'];
			break;
		} 
		
		//Vrification saisie Budget
		if ($acquisition_budget && !$rub[$i]) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_act_bud_err'];
			break;			
		}

	}
	
}


//Vrification dpassement de budget
function verif_bud() {

	global $msg, $charset;
	global $max_lig;
	global $qte, $prix, $rem, $rub;
	global $error, $error_msg;
	global $acquisition_budget;

	if ($acquisition_budget) {

		$tot_rub = array();
		$tot_bud = array();
		for ($i=1;$i<=$max_lig;$i++) {
			$tot_rub[$rub[$i]] = 0;
		}

		//rcupre le total de la commande par rubrique
		for ($i=1;$i<=$max_lig;$i++) {
			$tot_rub[$rub[$i]] = $tot_rub[$rub[$i]] + ( $qte[$i]*$prix[$i]*(1 - ($rem[$i]/100) ) );
		}

		//rcupre le total de la commande par budget
		foreach ($tot_rub as $key=>$value) {
			$r = new rubriques($key);
			if (!array_key_exists($r->num_budget, $tot_bud)) $tot_bud[$r->num_budget] = 0; 
			$tot_bud[$r->num_budget] = $tot_bud[$r->num_budget] + $value; 
		}
		
		
		//Vrifie que les budgets affects par rubrique ne sont pas dpasss		
		foreach ($tot_rub as $key=>$value) {
		
			$r = new rubriques($key);
			$b = new budgets($r->num_budget);
				
			if ( $b->type_budget == TYP_BUD_RUB ) {	//Budget affect par rubrique
				
				$seuil = $b->seuil_alerte;
				$mnt_rub = $r->montant;
				$eng_rub = rubriques::calcEngagement($key) + $value;
				//Budget rubrique dpass ?
				if ($eng_rub > $mnt_rub) {
					$error = true;
					
					$tab_rub = rubriques::listAncetres($key, true);
					
					$lib_rub = $b->libelle.":";
					foreach ($tab_rub as $dummykey=>$value) {
						$lib_rub.= $value[1];
						if($value[0] != $key) $lib_rub.= ":";
					}				
					
					$error_msg = $msg['acquisition_rub']." :\\n\\n ".$lib_rub."\\n\\n".$msg['acquisition_act_bud_dep'];
					break;			
				}
			}
		}
			
		//Vrifie que les budgets affects globalement ne sont pas dpasss
		foreach ($tot_bud as $key=>$value) {

			$b = new budgets($key);
			
			if ( $b->type_budget == TYP_BUD_GLO ) {			
				
				$seuil = $b->seuil_alerte;
				$mnt_bud = $b->montant_global;
				$eng_bud = budgets::calcEngagement($b->id_budget) + $value;
		
				//Budget dpass ?
				if ($eng_bud > $mnt_bud) {
					$error = true;
					$error_msg = $msg['acquisition_act_tab_bud']." : ".$b->libelle."\\n\\n".$msg['acquisition_act_bud_dep'];
					break;			
				}
			}
		}	
	}
}


//Affichage lignes de commande
function show_lig_cde($ajout=0) {

	global $msg, $charset;
	global $frame_modif, $frame_row, $select_typ;
	global $frame_valid, $frame_row_valid;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_exer, $id_fou, $id_cde, $num_cde;
	global $chk, $id_lig, $typ_lig, $id_prod, $id_sug, $code, $lib, $qte, $prix, $dat_liv, $typ, $lib_typ, $tva, $rem, $rub;
	global $date_pay, $num_pay, $id_adr_liv, $id_adr_fac, $comment, $id_dev, $ref;
	global $error, $error_msg;
	global $acquisition_gestion_tva;
	global $load, $valid;

	$tot_ht = 0;
	$tot_tva = 0;
	$tot_ttc = 0;
	$frame = $frame_modif;
	
	if (!$valid){	//Commande modifiable


		if (!$load) {		//Creation de commande ou actualisation lors d'une modification
	
			if (!$id_cde) {
				$frame = str_replace('!!id_cde!!', '0', $frame);
				$frame = str_replace('!!num_cde!!', '', $frame);
				$frame = str_replace('!!id_dev!!', '', $frame);
			} else {
				$frame = str_replace('!!id_cde!!', $id_cde, $frame);
				$frame = str_replace('!!num_cde!!', $num_cde, $frame);
				$frame = str_replace('!!id_dev!!', $id_dev, $frame);
			}	
			
			for($i='1'; $i<=$max_lig; $i++) {
				
				$frame = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame);
				$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);
				$frame = str_replace('<!-- select_rub -->', select_rub($rub[$i]), $frame);
				$frame = str_replace('!!no!!', $i, $frame);
				if ($id_lig[$i]) { 
					$frame = str_replace('!!id_lig!!', $id_lig[$i], $frame);
					$frame = str_replace('!!typ_lig!!', $typ_lig[$i], $frame);
				} else {
					$frame = str_replace('!!id_lig!!', '0', $frame);
					$frame = str_replace('!!typ_lig!!', '0', $frame);
				}
				$frame = str_replace('!!id_prod!!', $id_prod[$i], $frame);
				$frame = str_replace('!!id_sug!!', $id_sug[$i], $frame);
				$frame = str_replace('!!code!!', htmlentities(stripslashes($code[$i]), ENT_QUOTES, $charset), $frame);
				$frame = str_replace('!!lib!!', htmlentities(stripslashes($lib[$i]), ENT_QUOTES, $charset), $frame);
				$frame = str_replace('!!qte!!', round($qte[$i]), $frame);
				$frame = str_replace('!!prix!!', number_format(round($prix[$i],2),2,'.','' ), $frame);
				$frame = str_replace('!!dat_liv!!', $dat_liv[$i], $frame);
				
				if($typ[$i]) {
					$frame = str_replace('!!typ!!', $typ[$i], $frame);
					$typpro = new types_produits($typ[$i]);
					$frame = str_replace('!!lib_typ!!', htmlentities($typpro->libelle, ENT_QUOTES, $charset), $frame);
				} else {
					$frame = str_replace('!!typ!!', '0', $frame);
					$frame = str_replace('!!lib_typ!!', '', $frame);
				}
				$frame = str_replace('!!rem!!', number_format(round($rem[$i],2),2,'.','' ), $frame);
				
				if ($acquisition_gestion_tva) {
					$frame = str_replace('!!tva!!', $tva[$i], $frame);
				}
				
				//calcul des montants ht, ttc, tva			
				if ($acquisition_gestion_tva) {
					$lig_ht = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
					$tot_ht = $tot_ht +  $lig_ht;					
					$tot_tva = $tot_tva + ($lig_ht*($tva[$i]/100));
					$tot_ttc = $tot_ht + $tot_tva;
					$frame = str_replace('!!tva!!', number_format(round($tva->taux_tva,2),2,'.',''), $frame);						
				} else {
					$lig_ttc = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
					$tot_ttc = $tot_ttc + $lig_ttc;
					$frame = str_replace('!!tva!!', '', $frame);	
				}
			}
			
			if ($error) {	//Il y a eu Erreur ou oubli de saisie
				$frame = str_replace('<!-- error -->',"<script type='text/javascript'>alert(\"".$error_msg."\"); </script>", $frame); 
	
			} else {		//Si pas d'erreur
				
				if ($ajout) {	//On rajoute une ligne de commande vierge
					$max_lig++;							
					
					$frame = str_replace('<!-- lignes -->', $frame_row, $frame);
					$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);

					if ($max_lig > '1') {
						$frame = str_replace('<!-- select_rub -->', select_rub($rub[$max_lig-1]), $frame);
					} else {
						$frame = str_replace('<!-- select_rub -->', select_rub(), $frame);
					}

					$frame = str_replace('!!no!!', $i, $frame);
					$frame = str_replace('!!id_lig!!', '0', $frame);
					$frame = str_replace('!!typ_lig!!', '0', $frame);
					$frame = str_replace('!!id_prod!!', '0', $frame);
					$frame = str_replace('!!id_sug!!', '0', $frame);
					$frame = str_replace('!!code!!', '', $frame);
					$frame = str_replace('!!lib!!', '', $frame);
					$frame = str_replace('!!qte!!', '1', $frame);
					$frame = str_replace('!!prix!!', '0.00', $frame);
					if($max_lig <= 1) {
						$frame = str_replace('!!typ!!', '0', $frame);
						$frame = str_replace('!!lib_typ!!', '', $frame);
						$frame = str_replace('!!tva!!', '0.00', $frame);
						$frame = str_replace('!!rem!!', '0.00', $frame);
					} else {
						$frame = str_replace('!!typ!!', $typ[$i-1], $frame);
						$frame = str_replace('!!lib_typ!!', htmlentities($typpro->libelle, ENT_QUOTES, $charset), $frame);
						$frame = str_replace('!!rem!!', number_format(round($rem[$i-1],2),2,'.','' ), $frame);
						if ($acquisition_gestion_tva) {
							$frame = str_replace('!!tva!!', number_format(round($tva[$i-1],2),2,'.',''), $frame);
						} else {
							$frame = str_replace('!!tva!!', '', $frame);
						}
					}

					if ($max_lig > '1') {
						$frame = str_replace('!!dat_liv!!', $dat_liv[$max_lig-1], $frame);
					} else {
						$frame = str_replace('!!dat_liv!!', '', $frame);
					}
									
				}
				
			}
			
			
		} else {		//Rcupration des lignes en base pour modification de commande	
		
			$cde = new actes($id_cde);
			$frame = str_replace('!!id_cde!!', $id_cde, $frame);
			$frame = str_replace('!!num_cde!!', $cde->numero, $frame);
			
			$id_dev = liens_actes::getParent($id_cde);			
			$frame = str_replace('!!id_dev!!', $id_dev, $frame);
			
			$lignes = actes::getLignes($id_cde);
			$max_lig = mysql_num_rows($lignes);
			
			$i=1;	
			while ($row = mysql_fetch_object($lignes)) {
				
				$frame = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame);
				$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);
				$frame = str_replace('<!-- select_rub -->', select_rub($row->num_rubrique), $frame);
				$frame = str_replace('!!no!!', $i, $frame);
				$frame = str_replace('!!id_lig!!', $row->id_ligne, $frame);
				$frame = str_replace('!!typ_lig!!', $row->type_ligne, $frame);
				$frame = str_replace('!!id_prod!!', $row->num_produit, $frame);
				$frame = str_replace('!!id_sug!!', $row->num_acquisition, $frame);
				$frame = str_replace('!!code!!', $row->code, $frame);
				$frame = str_replace('!!lib!!', $row->libelle, $frame);
				$frame = str_replace('!!qte!!', $row->nb, $frame);
				$frame = str_replace('!!prix!!', number_format($row->prix,2,'.',''), $frame);
				$frame = str_replace('!!dat_liv!!', formatdate($row->date_ech), $frame);
				
				$tp = new types_produits($row->num_type);
				$frame = str_replace('!!typ!!', htmlentities($tp->id_produit, ENT_QUOTES, $charset), $frame);
				$frame = str_replace('!!lib_typ!!', htmlentities($tp->libelle, ENT_QUOTES, $charset), $frame);
				
				$frame = str_replace('!!rem!!', number_format($row->remise,2,'.',''), $frame);

				//calcul des montants ht, ttc, tva			
				if ($acquisition_gestion_tva) {
					$lig_ht = $row->nb * $row->prix * (1-($row->remise/100)) ;
					$tot_ht = $tot_ht + $lig_ht;
					$tot_tva = $tot_tva + ($lig_ht*($row->tva/100) );
					$tot_ttc = $tot_ht + $tot_tva;						
					$frame = str_replace('!!tva!!', number_format($row->tva,2,'.',''), $frame);						
				} else {
					$lig_ttc = $row->nb * $row->prix * (1-($row->remise/100)) ;
					$tot_ttc = $tot_ttc + $lig_ttc;
					$frame = str_replace('!!tva!!', '', $frame);											
				}
				$i++;
			}
		}

	} else {	//Commande valide, non modifiable
		$frame = $frame_valid;
		$bt_add_lig = '';
		$bt_sup_lig = '';
		
		$cde = new actes($id_cde);
		$frame = str_replace('!!id_cde!!', $id_cde, $frame);
		$frame = str_replace('!!num_cde!!', $cde->numero, $frame);
		
		$lignes = actes::getLignes($id_cde);
		$max_lig = mysql_num_rows($lignes);
				
		$i=1;	
		while ($row = mysql_fetch_object($lignes)) {
			
			$frame = str_replace('<!-- lignes -->', $frame_row_valid.'<!-- lignes -->', $frame);
			$frame = str_replace('<!-- select_rub -->', select_rub($row->num_rubrique), $frame);
			$frame = str_replace('!!no!!', $i, $frame);
			$frame = str_replace('!!id_lig!!', $row->id_ligne, $frame);
			$frame = str_replace('!!typ_lig!!', $row->type_ligne, $frame);
			$frame = str_replace('!!id_prod!!', $row->num_produit, $frame);
			$frame = str_replace('!!id_sug!!', $row->num_acquisition, $frame);
			$frame = str_replace('!!code!!', htmlentities($row->code, ENT_QUOTES, $charset), $frame);
			$frame = str_replace('!!lib!!', htmlentities($row->libelle, ENT_QUOTES, $charset), $frame);
			$frame = str_replace('!!qte!!', $row->nb, $frame);


			if ($row->type_ligne == 3) {	//Frais, non livrable
			
				$frame = str_replace('!!rec!!', '_', $frame);
			
			} else {
				
				//recherche des lignes de livraison
				$lig_liv = lignes_actes::getLivraisons($row->id_ligne);
				$rec = 0;
				while($row_liv = mysql_fetch_object($lig_liv)){
					$rec = $rec + $row_liv->nb;
				}
	
				$frame = str_replace('!!rec!!', $rec, $frame);
				
			}


			$frame = str_replace('!!prix!!', number_format($row->prix,2,'.','') , $frame);
			$frame = str_replace('!!dat_liv!!', formatdate($row->date_ech), $frame);
			
			$tp = new types_produits($row->num_type);
			$frame = str_replace('!!typ!!', $tp->id_produit, $frame);
			$frame = str_replace('!!lib_typ!!', htmlentities($tp->libelle, ENT_QUOTES, $charset), $frame);
				
			$frame = str_replace('!!rem!!', number_format($row->remise,2,'.','' ), $frame);
						
			//calcul des montants ht, ttc, tva			
			if ($acquisition_gestion_tva) {
				$lig_ht = $row->nb * $row->prix * (1-($row->remise/100)) ;
				$tot_ht = $tot_ht + $lig_ht;
				$tot_tva = $tot_tva + ($lig_ht*($row->tva/100) );
				$tot_ttc = $tot_ht + $tot_tva;						
				$frame = str_replace('!!tva!!', number_format($row->tva,2,'.',''), $frame);						
			} else {
				$lig_ttc = $row->nb * $row->prix * (1-($row->remise/100)) ;
				$tot_ttc = $tot_ttc + $lig_ttc;
				$frame = str_replace('!!tva!!', '', $frame);											
			}
			$i++;
		}		

			
	}	

	$frame = str_replace('!!tot_ht!!', number_format(round($tot_ht,2),2,'.','' ), $frame);
	$frame = str_replace('!!tot_tva!!', number_format(round($tot_tva,2),2,'.','' ), $frame);
	$frame = str_replace('!!tot_ttc!!', number_format(round($tot_ttc,2),2,'.','' ), $frame);
	$frame = str_replace('!!max_lig!!', $max_lig, $frame);	
	$frame = str_replace('<!-- bouton_add_lig -->', $bt_add_lig, $frame);	
	$frame = str_replace('<!-- bouton_sup_lig -->', $bt_sup_lig, $frame);	
	$frame = str_replace('!!id_fou!!', $id_fou, $frame);
	
	print $frame; 	

}


//Suppression de lignes
function sup_lig_cde(){

	global $msg, $charset;
	global $frame_modif, $frame_row,$select_typ;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_fou, $id_cde, $num_cde;
	global $chk, $id_lig, $typ_lig, $id_prod, $id_sug, $code, $lib, $qte, $prix, $dat_liv, $typ, $lib_typ, $tva, $rem, $rub;
	global $date_pay, $num_pay, $id_adr_liv, $id_adr_fac, $comment, $ref;
	global $acquisition_gestion_tva;
	
	
	$tot_ht = 0;
	$tot_tva = 0;
	$tot_ttc = 0;

	$frame_modif = str_replace('!!action!!', 'frame_commande.php?action=add_lig&id_bibli='.$id_bibli, $frame_modif);  
	
	if (!$id_cde) {		//Creation de commande
		
		$frame_modif = str_replace('!!id_cde!!', '0', $frame_modif);
		$frame_modif = str_replace('!!num_cde!!', '', $frame_modif);
		
	} else {	//Modification de commande	
	
		$frame_modif = str_replace('!!id_cde!!', $id_cde, $frame_modif);
		$frame_modif = str_replace('!!num_cde!!', $num_cde, $frame_modif);		
	}		
		
	$index = 1;
	for($i='1'; $i<=$max_lig; $i++) {
		
		if (!$chk[$i]) {	//Non coch, on raffiche
		
			$frame_modif = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame_modif);
			$frame_modif = str_replace('<!-- select_typ -->', $select_typ, $frame_modif);
			$frame_modif = str_replace('<!-- select_rub -->', select_rub($rub[$i]), $frame_modif);
			$frame_modif = str_replace('!!no!!', $index, $frame_modif);
			$frame_modif = str_replace('!!id_lig!!', $id_lig[$i], $frame_modif);
			$frame_modif = str_replace('!!typ_lig!!', $typ_lig[$i], $frame_modif);
			$frame_modif = str_replace('!!id_prod!!', $id_prod[$i], $frame_modif);
			$frame_modif = str_replace('!!id_sug!!', $id_sug[$i], $frame_modif);
			$frame_modif = str_replace('!!code!!', stripslashes($code[$i]), $frame_modif);
			$frame_modif = str_replace('!!lib!!', stripslashes($lib[$i]), $frame_modif);
			$frame_modif = str_replace('!!qte!!', round($qte[$i]), $frame_modif);
			$frame_modif = str_replace('!!prix!!', number_format(round($prix[$i],2),2,'.','' ), $frame_modif);
			$frame_modif = str_replace('!!dat_liv!!', $dat_liv[$i], $frame_modif);
			
			if ($typ[$i]) {
				$frame_modif = str_replace('!!typ!!', $typ[$i], $frame_modif);
				$typpro = new types_produits($typ[$i]);
				$frame_modif = str_replace('!!lib_typ!!', htmlentities($typpro->libelle, ENT_QUOTES, $charset), $frame_modif);
			} else {
				$frame_modif = str_replace('!!typ!!', '0', $frame_modif);
				$frame_modif = str_replace('!!lib_typ!!', '', $frame_modif);
			}
			$frame_modif = str_replace('!!rem!!', number_format(round($rem[$i],2),2,'.','' ), $frame_modif);
			
			//calcul des montants ht, ttc, tva, remises			
			if ($acquisition_gestion_tva) {
				$lig_ht = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
				$tot_ht = $tot_ht +  $lig_ht;					
				$tot_tva = $tot_tva + ($lig_ht*($tva[$i]/100));
				$tot_ttc = $tot_ht + $tot_tva;
				$frame_modif = str_replace('!!tva!!', number_format(round($tva[$i],2),2,'.',''), $frame_modif);						
			} else {
				$lig_ttc = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
				$tot_ttc = $tot_ttc + $lig_ttc;
				$frame_modif = str_replace('!!tva!!', '', $frame_modif);	
			}

			$index++;

		
		} else {	//Coch, on ne raffiche pas
		}
	}
	
	
	$frame_modif = str_replace('!!tot_ht!!', number_format(round($tot_ht,2),2,'.',''), $frame_modif);
	$frame_modif = str_replace('!!tot_tva!!', number_format(round($tot_tva,2),2,'.',''), $frame_modif);
	$frame_modif = str_replace('!!tot_ttc!!', number_format(round($tot_ttc,2),2,'.',''), $frame_modif);
	
	$frame_modif = str_replace('!!max_lig!!', $index-1, $frame_modif);	
	$frame_modif = str_replace('<!-- bouton_add_lig -->', $bt_add_lig, $frame_modif);	
	$frame_modif = str_replace('<!-- bouton_sup_lig -->', $bt_sup_lig, $frame_modif);	
	$frame_modif = str_replace('!!id_fou!!', $id_fou, $frame_modif);
	
	print $frame_modif; 	
	
}


//Enregistre la commande
function update_cde() {
	
	global $msg;
	global $action;
	global $frame_modif, $frame_row;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_exer, $id_fou, $id_cde, $num_cde;
	global $chk, $id_lig, $typ_lig, $id_prod, $id_sug, $code, $lib, $qte, $prix, $dat_liv, $typ, $tva, $rem, $rub;
	global $date_pay, $num_pay, $id_adr_liv, $id_adr_fac, $comment, $comment_i, $id_dev, $ref, $devise;
	global $acquisition_gestion_tva;

	if (!$id_cde) {		//Creation de commande

		//Mise  jour du statut des suggestions et envoi email suivi de suggestion
		$sug_map = new suggestions_map();
		$sug_map->doTransition('ORDERED', $id_sug);

		$cde = new actes();
		$cde->num_entite = $id_bibli;
		$cde ->type_acte = '0';
		if ($action == 'valid') {
			$cde->statut = STA_ACT_ENC;
		}
			else $cde->statut = STA_ACT_AVA;			
		if ($date_pay) $cde->date_paiement = extraitdate($date_pay);
		if ($num_pay) $cde->num_paiement = $num_pay;
		$cde->num_fournisseur = $id_fou;
		$cde->num_contact_livr = $id_adr_liv;
		$cde->num_contact_fact = $id_adr_fac;
		$cde->num_exercice = $id_exer;
		$cde->commentaires = $comment;
		$cde->commentaires_i = $comment_i;
		$cde->reference = $ref;
		$cde->devise = $devise;
		$cde->calc();
		$cde->save();
		
		$id_cde= $cde->id_acte;
		$num_cde = $cde->numero;
		
		//cration des liens entre actes
		if ($id_dev) {
			$la = new liens_actes($id_dev, $id_cde);
		}
		
		//Cration des lignes de commande
		for($i='1'; $i<=$max_lig; $i++) {

			$lig_cde = new lignes_actes();
			$lig_cde->type_ligne = $typ_lig[$i];
			$lig_cde->num_acte = $cde->id_acte;
			$lig_cde->num_rubrique = $rub[$i];
			$lig_cde->num_produit = $id_prod[$i];
			$lig_cde->num_acquisition = $id_sug[$i];
			$lig_cde->num_type = $typ[$i];
			$lig_cde->code = stripslashes($code[$i]);
			$lig_cde->libelle = stripslashes($lib[$i]);
			$lig_cde->prix = round($prix[$i],2);
			
			if ($acquisition_gestion_tva) $lig_cde->tva = round($tva[$i],2);
				else $lig_cde->tva = '0.00';
			
			$lig_cde->remise = round($rem[$i],2);		
			$lig_cde->nb = round($qte[$i]);
			$lig_cde->date_ech = extraitdate($dat_liv[$i]);
			$lig_cde->date_cre = today();			
			$lig_cde->statut = STA_ACT_AVA;
			$lig_cde->save();
			$id_lig[$i] = $lig_cde->id_ligne;
		}		
		
	
	} else {		//Modification de commande


		$cde = new actes($id_cde);
		if ($action == 'valid') { 
			$cde->statut = ($cde->statut & (~STA_ACT_AVA) | STA_ACT_ENC); //Statut commande = A valider->en cours
		}					
		if ($date_pay) $cde->date_paiement = extraitdate($date_pay);
		if ($num_pay) $cde->num_paiement = $num_pay;
		$cde->num_fournisseur = $id_fou;
		$cde->num_contact_livr = $id_adr_liv;
		$cde->num_contact_fact = $id_adr_fac;
		$cde->num_exercice = $id_exer;
		$cde->commentaires = $comment;
		$cde->commentaires_i = $comment_i;
		$cde->reference = $ref;
		$cde->devise = $devise;
		$cde->save();

		//Suppression des lignes de commande prcdentes
		actes::deleteLignes($id_cde);
				
		//Update des lignes de commande
		for($i='1'; $i<=$max_lig; $i++) {
			
			$lig_cde = new lignes_actes();
			$lig_cde->type_ligne = $typ_lig[$i];
			$lig_cde->num_acte = $cde->id_acte;
			$lig_cde->num_rubrique = $rub[$i];
			$lig_cde->num_produit = $id_prod[$i];
			$lig_cde->num_acquisition = $id_sug[$i];
			$lig_cde->num_type = $typ[$i];
			$lig_cde->code = stripslashes($code[$i]);
			$lig_cde->libelle = stripslashes($lib[$i]);
			$lig_cde->prix = round($prix[$i],2);
			
			if ($acquisition_gestion_tva) $lig_cde->tva = round($tva[$i],2);
				else $lig_cde->tva = '0.00';		
			$lig_cde->remise = round($rem[$i],2);
			$lig_cde->nb = round($qte[$i]);
			$lig_cde->date_ech = extraitdate($dat_liv[$i]);
			$lig_cde->date_cre = today();			
			$lig_cde->statut = ($lig_cde->statut | STA_ACT_AVA);
			$lig_cde->save();
			$id_lig[$i] = $lig_cde->id_ligne;
		}		
	}	
		
}


//Selection et affichage de rubrique
function select_rub($id_rubrique=0) {
	
	global $msg, $charset;
	global $select_rub, $valid ;
	

	if ($valid) {	//Commande valide, non modifiable

		$lig_rub = $select_rub[1];

		if (!$id_rubrique) {
			$id_rubrique = 0;
			$lib_rubrique = '';
		} else {
			$rub = new rubriques($id_rubrique);
			$bud = new budgets($rub->num_budget);
			$lib_bud = $bud->libelle;
			
			$tab_rub = rubriques::listAncetres($id_rubrique, true);
			$lib_rub = $lib_bud.':';
			foreach ($tab_rub as $dummykey=>$value) {
				$lib_rub.= htmlentities(addslashes($value[1]), ENT_QUOTES, $charset);
				if($value[0] != $id_rubrique) $lib_rub.= ":";
			}
		}
			$lig_rub = str_replace('!!id_rub!!',$id_rubrique , $lig_rub);
			$lig_rub = str_replace('!!lib_rub!!', $lib_rub, $lig_rub);

	} else {	//Commande modifiable		
					 
		if (!$id_rubrique) {	//Pas de rubrique slectionne

			$lig_rub = $select_rub[0];
			$lig_rub = str_replace('!!id_rub!!', 0, $lig_rub);
			$lig_rub = str_replace('!!lib_rub!!', '', $lig_rub);

		} else {	//Rubrique selectionne
		
			$user_userid = getCurrentUserId();
			$rub = new rubriques($id_rubrique);
			$bud = new budgets($rub->num_budget);
	
			if (!rubriques::getAutorisations($id_rubrique, $user_userid)) { //L'utilisateur n'a pas de droits sur la rubrique
			
				$lig_rub = $select_rub[1];
				
			} else { //L'utilisateur  des droits sur la rubrique
	
				$lig_rub = $select_rub[0];
							
			}
	
			$lig_rub = str_replace('!!id_rub!!', $rub->id_rubrique, $lig_rub);

			$lib_bud = htmlentities(addslashes($bud->libelle), ENT_QUOTES, $charset);
			
			$tab_rub = rubriques::listAncetres($id_rubrique, true);
			$lib_rub = $lib_bud.':';
			foreach ($tab_rub as $dummykey=>$value) {
				$lib_rub.= htmlentities(addslashes($value[1]), ENT_QUOTES, $charset);
				if($value[0] != $id_rubrique) $lib_rub.= ":";
			}

			$lig_rub = str_replace('!!lib_rub!!', $lib_rub, $lig_rub);			
	
		}			
	}
	return $lig_rub;
}


//Rcupration de l'utilisateur courant
function getCurrentUserId() {
	
	global $dbh;
		
 	$requete_user = "SELECT userid FROM users where username='".SESSlogin."' limit 1 ";
	$res_user = mysql_query($requete_user, $dbh);
	$row_user=mysql_fetch_row($res_user);
	$user_userid=$row_user[0];
	return $user_userid;

}

//Affichage cration commande depuis devis
function show_lig_from_devis() {

	global $msg, $charset;
	global $frame_modif, $frame_row, $select_typ;
	global $frame_valid, $frame_row_valid;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_fou, $id_dev;
	global $acquisition_gestion_tva;

	$tot_ht = 0;
	$tot_tva = 0;
	$tot_ttc = 0;
	$frame = $frame_modif;

	$frame = str_replace('!!id_cde!!', '0', $frame);
	$frame = str_replace('!!num_cde!!', '', $frame);
	$frame = str_replace('!!id_dev!!', $id_dev, $frame);
	
	$lignes = actes::getLignes($id_dev);
	$max_lig = mysql_num_rows($lignes);
	
	$i=1;	
	while ($row = mysql_fetch_object($lignes)) {
		
		$frame = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame);
		$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);
		$frame = str_replace('<!-- select_rub -->', select_rub(), $frame);		
		$frame = str_replace('!!no!!', $i, $frame);
		$frame = str_replace('!!id_lig!!', $row->id_ligne, $frame);
		$frame = str_replace('!!typ_lig!!', $row->type_ligne, $frame);
		$frame = str_replace('!!id_prod!!', $row->num_produit, $frame);
		$frame = str_replace('!!id_sug!!', '0', $frame);
		$frame = str_replace('!!code!!',  htmlentities($row->code, ENT_QUOTES, $charset), $frame);
		$frame = str_replace('!!lib!!', htmlentities($row->libelle, ENT_QUOTES, $charset), $frame);
		$frame = str_replace('!!qte!!', $row->nb, $frame);
		$frame = str_replace('!!prix!!', number_format($row->prix,2,'.',''), $frame);
		$frame = str_replace('!!dat_liv!!', '', $frame);		
		
		if($row->num_type) {
			$tp = new types_produits($row->num_type);
			$frame = str_replace('!!typ!!', $tp->id_produit, $frame);
			$frame = str_replace('!!lib_typ!!', htmlentities($tp->libelle, ENT_QUOTES, $charset), $frame);
		} else {
			$frame = str_replace('!!typ!!', '0', $frame);
			$frame = str_replace('!!lib_typ!!', '', $frame);			
		}
		
		$frame = str_replace('!!rem!!', number_format($row->remise,2,'.',''), $frame);
		
		//calcul des montants ht, ttc, tva			
		if ($acquisition_gestion_tva) {
			$lig_ht = $row->nb * $row->prix * (1-($row->remise/100)) ;
			$tot_ht = $tot_ht + $lig_ht;
			$tot_tva = $tot_tva + ($lig_ht*($row->tva/100) );
			$tot_ttc = $tot_ht + $tot_tva;						
			$frame = str_replace('!!tva!!', number_format($row->tva,2,'.',''), $frame);						
		} else {
			$lig_ttc = $row->nb * $row->prix * (1-($row->remise/100)) ;
			$tot_ttc = $tot_ttc + $lig_ttc;
			$frame = str_replace('!!tva!!', '', $frame);											
		}
		$i++;
	}

	$frame = str_replace('!!tot_ht!!', number_format(round($tot_ht,2),2,'.','' ), $frame);
	$frame = str_replace('!!tot_tva!!', number_format(round($tot_tva,2),2,'.','' ), $frame);
	$frame = str_replace('!!tot_ttc!!', number_format(round($tot_ttc,2),2,'.','' ), $frame);
	$frame = str_replace('!!max_lig!!', $max_lig, $frame);	
	$frame = str_replace('<!-- bouton_add_lig -->', $bt_add_lig, $frame);	
	$frame = str_replace('<!-- bouton_sup_lig -->', $bt_sup_lig, $frame);	
	$frame = str_replace('!!id_fou!!', $id_fou, $frame);
		
	print $frame; 	

}


function show_lig_from_sug() {

	global $msg, $charset;
	global $frame_modif, $frame_row, $select_typ;
	global $frame_valid, $frame_row_valid;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_fou, $sugchk;
	global $acquisition_gestion_tva;

	$tot_ht = 0;
	$tot_tva = 0;
	$tot_ttc = 0;
	$frame = $frame_modif;
	
	$arrchk = unserialize(rawurldecode(stripslashes($sugchk)));
	$max_lig = count($arrchk);	
	
	$i=1;	
	foreach($arrchk as $key=>$value) {

		$sug = new suggestions($value);
				
		$frame = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame);
		$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);
		$frame = str_replace('<!-- select_rub -->', select_rub(), $frame);		
		$frame = str_replace('!!no!!', $i, $frame);
		$frame = str_replace('!!id_sug!!', $sug->id_suggestion, $frame);
		$frame = str_replace('!!id_lig!!', '0', $frame);
		$frame = str_replace('!!typ_lig!!', '0', $frame);
		$frame = str_replace('!!id_prod!!', $value, $frame);
		
		$frame = str_replace('!!code!!', $sug->code, $frame);


		if ($sug->num_notice) {
			
			$notice = new notice($sug->num_notice);
			
			//recherche auteur
			$responsabilites = get_notice_authors($notice->id) ;
			$as = array_search ("0", $responsabilites["responsabilites"]);
			if ($as!== FALSE && $as!== NULL) {
				$auteur_0 = $responsabilites["auteurs"][$as] ;
				$auteur = new auteur($auteur_0["id"]);
				$lib_auteur = $auteur->display;
			} else {
				$lib_auteur = '';
			}
			
			$taec= htmlentities($notice->tit1,ENT_QUOTES,$charset);
			if ($lib_auteur!="") $taec.= "\n".htmlentities($lib_auteur,ENT_QUOTES,$charset);
			if ($notice->ed1 != "") $taec.= "\n".htmlentities($notice->ed1,ENT_QUOTES,$charset);
			if ($notice->coll != "") $taec.= "\n".htmlentities($notice->coll,ENT_QUOTES,$charset);
			
		} else {

			$taec= htmlentities($sug->titre,ENT_QUOTES,$charset);
			if ($sug->auteur!="") $taec.= "\n".htmlentities($sug->auteur,ENT_QUOTES,$charset);
			if ($sug->editeur != "") $taec.= "\n".htmlentities($sug->editeur,ENT_QUOTES,$charset);
			
		}

		$frame = str_replace('!!lib!!', $taec, $frame);
		$frame = str_replace('!!qte!!', 0, $frame);
		$frame = str_replace('!!prix!!', $sug->prix, $frame);
		$frame = str_replace('!!dat_liv!!', '', $frame);		
		
		$frame = str_replace('!!typ!!', 0, $frame);
		$frame = str_replace('!!lib_typ!!', '', $frame);
		
		$frame = str_replace('!!rem!!', '0.00', $frame);
		
		//calcul des montants ht, ttc, tva			
		$frame = str_replace('!!tva!!', '0.00', $frame);
		$i++;											

	}
	
	$frame = str_replace('!!id_cde!!', 0, $frame);
	$frame = str_replace('!!num_cde!!', '', $frame);
	$frame = str_replace('!!tot_ht!!', 0, $frame);
	$frame = str_replace('!!tot_tva!!', 0, $frame);
	$frame = str_replace('!!tot_ttc!!', 0, $frame);
	$frame = str_replace('!!max_lig!!', $max_lig, $frame);	
	$frame = str_replace('<!-- bouton_add_lig -->', $bt_add_lig, $frame);	
	$frame = str_replace('<!-- bouton_sup_lig -->', $bt_sup_lig, $frame);	
	$frame = str_replace('!!id_fou!!', $id_fou, $frame);
		
	print $frame; 	

}


// gestion des achats : commandes

switch($action) {

	case 'from_devis' :
		show_lig_from_devis();
		break;		
	
	case 'show_lig' :
		show_lig_cde(false);
		break;		
			
	case 'add_lig' :
		verif_cde();
		show_lig_cde(true);
		break;		

	case 'sup_lig' :
		sup_lig_cde();
		break;		

	case 'update' :
		verif_cde();
		if ($error) {
			show_lig_cde(false);
			break;
		}
		update_cde();
		print $retour_liste_avalid;
		break;
		
	case 'valid' :
		verif_cde();
		if ($error) {
			show_lig_cde(false);
			break;
		}
		verif_bud();
		if ($error) {
			show_lig_cde(false);
			break;
		}
		update_cde();
		print $retour_liste;
		break;				

	case 'from_sug' :
		show_lig_from_sug();
		break;		

	default:
		break;
		
}

?>
