<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: frame_devis.php,v 1.19 2006/08/01 14:46:37 dbellamy Exp $

//Liste les lignes d'un devis
$base_path="../../..";                            
//$base_auth = "ACQUISITION_AUTH";  
$include_path = "$base_path/includes";
$class_path = "$base_path/classes";

$current_alert="acquisition";
require_once("$include_path/init.inc.php");

// gestion des lignes de devis
require_once("$class_path/entites.class.php");
require_once("$class_path/types_produits.class.php");
require_once("$class_path/tva_achats.class.php");
require_once("$class_path/actes.class.php");
require_once("$class_path/lignes_actes.class.php");
require_once("$class_path/offres_remises.class.php");
include_once("$include_path/templates/devis.tpl.php");



$error = false;
$error_msg = '';


//verification du formulaire
function verif_dev() {

	global $msg;
	global $max_lig;
	global $code, $lib, $qte, $prix, $tva, $rem;
	global $error, $error_msg;
	global $acquisition_gestion_tva;
	global $action;
	

	//Si la dernire ligne n'est pas renseigne, on l'ignore pour l'enregistrement
	if ($action!='add_lig' && $max_lig>1 && !$code[$max_lig] && !$lib[$max_lig]) $max_lig--;


	for($i='1'; $i<=$max_lig; $i++) {
		//vrification libell
		if ($lib[$i] == '') {
			$error = true;		
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_lib_liv_inv'];
			break;			
		}
		
		//Vrification qt
		if (!is_numeric($qte[$i]) || $qte[$i] < '0' || $qte[$i] > '99999' ) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_qte_liv_inv'];
			break;
		}
	
		//Vrification prix
		$prix[$i] = str_replace(',','.',$prix[$i]);
		if (!is_numeric($prix[$i]) || $prix[$i] < '0' || $prix[$i] > '999999.99' ) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_prix_liv_inv'];
			break;
		}	

		if ($acquisition_gestion_tva) {
			//Vrification tva
			$tva[$i] = str_replace(',','.',$tva[$i]);
			if (!is_numeric($tva[$i]) || $tva[$i] < '0' || $tva[$i] > '99.99' ) {
				$error = true;
				$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_tva_liv_inv'];
				break;
			}	
		}
		//Vrification remise
		$rem[$i] = str_replace(',','.',$rem[$i]);
		if (!is_numeric($rem[$i]) || $rem[$i] < '0' || $rem[$i] > '99.99' ) {
			$error = true;
			$error_msg = $msg['acquisition_lig'].' '.$i.': '.$msg['acquisition_rem_liv_inv'];
			break;
		}	
	
	}
}


//Affichage lignes de devis
function show_lig_dev($ajout=0) {

	global $msg, $charset;
	global $frame_modif, $frame_row, $select_typ;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_fou, $id_dev, $num_dev;
	global $chk, $id_lig, $typ_lig, $id_prod, $code, $lib, $qte, $prix, $typ, $lib_typ, $tva, $rem;
	global $id_adr_liv, $id_adr_fac, $comment;
	global $error, $error_msg; 
	global $acquisition_gestion_tva;
	global $load;

	$tot_ht = 0;
	$tot_tva = 0;
	$tot_ttc = 0;
	$frame = $frame_modif;

		$frame = str_replace('!!action!!', 'frame_devis.php?action=add_lig&id_bibli='.$id_bibli, $frame);  
	
		if (!$load) {		//Creation de devis ou actualisation lors d'une modification
	
			if (!$id_dev) {
				$frame = str_replace('!!id_dev!!', '0', $frame);
				$frame = str_replace('!!num_dev!!', '', $frame);
			} else {
				$frame = str_replace('!!id_dev!!', $id_dev, $frame);
				$frame = str_replace('!!num_dev!!', $num_dev, $frame);
			}	
	
			for($i='1'; $i<=$max_lig; $i++) {
				
				$frame = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame);
				$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);
				$frame = str_replace('!!no!!', $i, $frame);
				if ($id_lig[$i]) {
					$frame = str_replace('!!id_lig!!', $id_lig[$i], $frame);
					$frame = str_replace('!!typ_lig!!', $typ_lig[$i], $frame);
				} else {
					$frame = str_replace('!!id_lig!!', '0', $frame);
					$frame = str_replace('!!typ_lig!!', '0', $frame);	
				}
				
				$frame = str_replace('!!id_prod!!', $id_prod[$i], $frame);
				$frame = str_replace('!!code!!', $code[$i], $frame);
				$frame = str_replace('!!lib!!', stripslashes($lib[$i]), $frame);
				$frame = str_replace('!!qte!!', round($qte[$i]), $frame);
				$frame = str_replace('!!prix!!', number_format(round($prix[$i],2),2,'.','' ), $frame);
				
				$frame = str_replace('!!typ!!', $typ[$i], $frame);
				$frame = str_replace('!!lib_typ!!', stripslashes($lib_typ[$i]), $frame);

				$frame = str_replace('!!rem!!', number_format(round($rem[$i],2),2,'.','' ), $frame);
				
				
				//calcul des montants ht, ttc, tva, remises			
				if ($acquisition_gestion_tva) {
					$lig_ht = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
					$tot_ht = $tot_ht +  $lig_ht;					
					$tot_tva = $tot_tva + ($lig_ht*($tva[$i]/100));
					$tot_ttc = $tot_ht + $tot_tva;
					$frame = str_replace('!!tva!!', number_format(round($tva[$i],2),2,'.','' ), $frame);						
				} else {
					$lig_ttc = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
					$tot_ttc = $tot_ttc + $lig_ttc;
					$frame = str_replace('!!tva!!', '', $frame);	
				}
				
			}
			
			if ($error) {	//Il y a eu Erreur ou oubli de saisie
				
				$frame = str_replace('<!-- error -->',"<script type='text/javascript'>alert(\"".$error_msg."\"); </script>", $frame); 
	
			} else {		//Si pas d'erreur
				
				if ($ajout) {	//On rajoute une ligne de devis vierge
					$max_lig++;							
					
					$frame = str_replace('<!-- lignes -->', $frame_row, $frame);
					$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);
					$frame = str_replace('!!no!!', $i, $frame);
					$frame = str_replace('!!id_lig!!', '0', $frame);
					$frame = str_replace('!!typ_lig!!', '0', $frame);
					$frame = str_replace('!!id_prod!!', '0', $frame);
					$frame = str_replace('!!code!!', '', $frame);
					$frame = str_replace('!!lib!!', '', $frame);
					$frame = str_replace('!!qte!!', '1', $frame);
					$frame = str_replace('!!prix!!', '0.00', $frame);
					if($max_lig <= 1) {
						$frame = str_replace('!!typ!!', '0', $frame);
						$frame = str_replace('!!lib_typ!!', '', $frame);
						$frame = str_replace('!!tva!!', '0.00', $frame);
						$frame = str_replace('!!rem!!', '0.00', $frame);
					} else {
						$frame = str_replace('!!typ!!', $typ[$i-1], $frame);
						$frame = str_replace('!!lib_typ!!', stripslashes($lib_typ[$i-1]), $frame);
						$frame = str_replace('!!rem!!', number_format(round($rem[$i-1],2),2,'.','' ), $frame);
						if ($acquisition_gestion_tva) {
							$frame = str_replace('!!tva!!', number_format(round($tva[$i-1],2),2,'.','' ), $frame);
						} else {
							$frame = str_replace('!!tva!!', '', $frame);
						}
					}
				}
				
			}
			
			
		} else {		//Rcupration des lignes en base pour modification de devis	
		
			$dev = new actes($id_dev);
			$frame = str_replace('!!id_dev!!', $id_dev, $frame);
			$frame = str_replace('!!num_dev!!', $dev->numero, $frame);

			$id_fou = $dev->num_fournisseur;						
			
			$lignes = actes::getLignes($id_dev);
			$max_lig = mysql_num_rows($lignes);
			
			$i=1;	
			while ($row = mysql_fetch_object($lignes)) {
				
				$frame = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame);
				$frame = str_replace('<!-- select_typ -->', $select_typ, $frame);
				$frame = str_replace('!!no!!', $i, $frame);
				$frame = str_replace('!!id_lig!!', $row->id_ligne, $frame);
				$frame = str_replace('!!typ_lig!!', $row->type_ligne, $frame);
				$frame = str_replace('!!id_prod!!', $row->num_produit, $frame);
				$frame = str_replace('!!code!!', htmlentities($row->code, ENT_QUOTES, $charset), $frame);
				$frame = str_replace('!!lib!!', htmlentities($row->libelle, ENT_QUOTES, $charset), $frame);
				$frame = str_replace('!!qte!!', $row->nb, $frame);
				$frame = str_replace('!!prix!!', number_format($row->prix,2,'.',''), $frame);
				
				if ($row->num_type) {
					$tp = new types_produits($row->num_type);
					$frame = str_replace('!!typ!!', $tp->id_produit, $frame);
					$frame = str_replace('!!lib_typ!!', htmlentities($tp->libelle, ENT_QUOTES, $charset), $frame);
				} else {
					$frame = str_replace('!!typ!!', '0', $frame);
					$frame = str_replace('!!lib_typ!!', '', $frame);
				}
				$frame = str_replace('!!rem!!', number_format($row->remise,2,'.',''), $frame);
				
				//calcul des montants ht, ttc, tva			
				if ($acquisition_gestion_tva) {
					$lig_ht = $row->nb * $row->prix * (1-($row->remise/100)) ;
					$tot_ht = $tot_ht + $lig_ht;
					$tot_tva = $tot_tva + ($lig_ht*($row->tva/100) );
					$tot_ttc = $tot_ht + $tot_tva;						
					$frame = str_replace('!!tva!!', number_format($row->tva,2,'.','') , $frame);						
				} else {
					$lig_ttc = $row->nb * $row->prix * (1-($row->remise/100)) ;
					$tot_ttc = $tot_ttc + $lig_ttc;
					$frame = str_replace('!!tva!!', '', $frame);											
				}
				
				$i++;
			}
		
		}
	

	$frame = str_replace('!!tot_ht!!', number_format(round($tot_ht,2),2,'.','' ), $frame);
	$frame = str_replace('!!tot_tva!!', number_format(round($tot_tva,2),2,'.','' ), $frame);
	$frame = str_replace('!!tot_ttc!!', number_format(round($tot_ttc,2),2,'.','' ), $frame);
	$frame = str_replace('!!max_lig!!', $max_lig, $frame);	
	$frame = str_replace('<!-- bouton_add_lig -->', $bt_add_lig, $frame);	
	$frame = str_replace('<!-- bouton_sup_lig -->', $bt_sup_lig, $frame);	
	$frame = str_replace('!!id_fou!!', $id_fou, $frame);
	
	print $frame; 	

}


//Suppression de lignes
function sup_lig_dev(){

	global $msg, $charset;
	global $frame_modif, $frame_row, $select_typ;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_fou, $id_dev, $num_dev;
	global $chk, $id_lig, $typ_lig, $id_prod, $code, $lib, $qte, $prix, $typ, $lib_typ, $tva, $rem;
	global $id_adr_liv, $id_adr_fac, $comment;
	global $acquisition_gestion_tva;
	
	$tot_ht = 0;
	$tot_tva = 0;
	$tot_ttc = 0;

	$frame_modif = str_replace('!!action!!', 'frame_devis.php?action=add_lig&id_bibli='.$id_bibli, $frame_modif);  
	
	if (!$id_dev) {		//Creation de devis
		
		$frame_modif = str_replace('!!id_dev!!', '0', $frame_modif);
		$frame_modif = str_replace('!!num_dev!!', '', $frame_modif);
		
	} else {	//Modification de devis	
	
		$frame_modif = str_replace('!!id_dev!!', $id_dev, $frame_modif);
		$frame_modif = str_replace('!!num_dev!!', $num_dev, $frame_modif);		
	}		
		
	$index = 1;
	for($i='1'; $i<=$max_lig; $i++) {
		
		if (!$chk[$i]) {	//Non coch, on ne supprime pas
		
			$frame_modif = str_replace('<!-- lignes -->', $frame_row.'<!-- lignes -->', $frame_modif);
			$frame_modif = str_replace('<!-- select_typ -->', $select_typ, $frame_modif);
			$frame_modif = str_replace('!!no!!', $index, $frame_modif);
			$frame_modif = str_replace('!!id_lig!!', $id_lig[$i], $frame_modif);
			$frame_modif = str_replace('!!typ_lig!!', $typ_lig[$i], $frame_modif);
			$frame_modif = str_replace('!!id_prod!!', $id_prod[$i], $frame_modif);
			$frame_modif = str_replace('!!code!!', stripslashes($code[$i]), $frame_modif);
			$frame_modif = str_replace('!!lib!!', stripslashes($lib[$i]), $frame_modif);
			$frame_modif = str_replace('!!qte!!', round($qte[$i]), $frame_modif);
			$frame_modif = str_replace('!!prix!!', number_format(round($prix[$i],2),2,'.','' ), $frame_modif);
			
			$frame_modif = str_replace('!!typ!!', $typ[$i], $frame_modif);
			$frame_modif = str_replace('!!lib_typ!!', stripslashes($lib_typ[$i]), $frame_modif);

			$frame_modif = str_replace('!!rem!!', number_format(round($rem[$i],2),2,'.','' ), $frame_modif);

			//calcul des montants ht, ttc, tva, remises			
			if ($acquisition_gestion_tva) {
				$lig_ht = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
				$tot_ht = $tot_ht +  $lig_ht;					
				$tot_tva = $tot_tva + ($lig_ht*($tva[$i]/100));
				$tot_ttc = $tot_ht + $tot_tva;
				$frame_modif = str_replace('!!tva!!', number_format(round($tva[$i],2),2,'.','' ), $frame_modif);						
			} else {
				$lig_ttc = $qte[$i] * $prix[$i] * (1-($rem[$i]/100)) ;
				$tot_ttc = $tot_ttc + $lig_ttc;
				$frame_modif = str_replace('!!tva!!', '', $frame_modif);	
			}

			$index++;
			
		
		} else {	//Coch, on ne raffiche pas
		}
	}
	
	$frame_modif = str_replace('!!tot_ht!!', number_format(round($tot_ht,2),2,'.','' ), $frame_modif);
	$frame_modif = str_replace('!!tot_tva!!', number_format(round($tot_tva,2),2,'.','' ), $frame_modif);
	$frame_modif = str_replace('!!tot_ttc!!', number_format(round($tot_ttc,2),2,'.','' ), $frame_modif);
	
	$frame_modif = str_replace('!!max_lig!!', $index-1, $frame_modif);	
	$frame_modif = str_replace('<!-- bouton_add_lig -->', $bt_add_lig, $frame_modif);	
	$frame_modif = str_replace('<!-- bouton_sup_lig -->', $bt_sup_lig, $frame_modif);	
	$frame_modif = str_replace('!!id_fou!!', $id_fou, $frame_modif);
	
	print $frame_modif; 	
	
}


//Enregistre le devis
function update_dev() {
	
	global $msg;
	global $action;
	global $frame_modif, $frame_row;
	global $bt_add_lig, $bt_sup_lig;
	global $max_lig;
	global $id_bibli, $id_fou, $id_dev, $num_dev;
	global $chk, $id_lig, $typ_lig, $id_prod, $code, $lib, $qte, $dat_liv, $prix, $typ, $tva, $rem, $bud;
	global $id_adr_liv, $id_adr_fac, $comment, $ref, $statut, $devise;
	global $acquisition_gestion_tva;

	if (!$id_dev) {		//Creation de devis

		$dev = new actes();
		$dev->num_entite = $id_bibli;
		$dev->type_acte = TYP_ACT_DEV;
		$dev->statut = STA_ACT_ENC;
		$dev->num_fournisseur = $id_fou;
		$dev->num_contact_livr = $id_adr_liv;
		$dev->num_contact_fact = $id_adr_fac;
		$dev->commentaires = $comment;
		$dev->reference = $ref;
		$dev->devise = $devise;
		$dev->calc();
		$dev->save();
		
		$id_dev= $dev->id_acte;
		$num_dev = $dev->numero;
		
		//Cration des lignes de devis
		for($i='1'; $i<=$max_lig; $i++) {

			$lig_dev = new lignes_actes();
			$lig_dev->type_ligne = $typ_lig[$i];
			$lig_dev->num_acte = $dev->id_acte;
			$lig_dev->num_acquisition = '0';
			$lig_dev->num_rubrique = $bud[$i];
			$lig_dev->num_produit = $id_prod[$i];
			$lig_dev->num_type = $typ[$i];
			$lig_dev->code = stripslashes($code[$i]);
			$lig_dev->libelle = stripslashes($lib[$i]);
			$lig_dev->prix = round($prix[$i],2);
			if ($acquisition_gestion_tva) $lig_dev->tva = round($tva[$i],2);
				else $lig_dev->tva = '0.00';
			$lig_dev->remise = round($rem[$i],2);
			$lig_dev->nb = round($qte[$i]);
			$lig_dev->date_cre = today();			
			$lig_dev->save();
			$id_lig[$i] = $lig_dev->id_ligne;
		}		
		
	
	} else {		//Modification de devis


		$dev = new actes($id_dev);
		$dev->num_fournisseur = $id_fou;
		$dev->num_contact_livr = $id_adr_liv;
		$dev->num_contact_fact = $id_adr_fac;
		$dev->commentaires = $comment;
		$dev->reference = $ref;
		$dev->devise = $devise;
		
		if ($statut == STA_ACT_ARC) {
			$dev->statut = ($dev->statut | STA_ACT_ARC);
		}
		else $dev->statut = $statut;
		$dev->save();
		
		
		//Suppression des lignes de devis prcdentes
		actes::deleteLignes($id_dev);
		
		//Update des lignes de devis
		for($i='1'; $i<=$max_lig; $i++) {
			
			$lig_dev = new lignes_actes();
			$lig_dev->type_ligne = $typ_lig[$i];
			$lig_dev->num_acte = $dev->id_acte;
			$lig_dev->num_acquisition = '0';
			$lig_dev->num_rubrique = $bud[$i];
			$lig_dev->num_produit = $id_prod[$i];
			$lig_dev->num_type = $typ[$i];
			$lig_dev->code = stripslashes($code[$i]);
			$lig_dev->libelle = stripslashes($lib[$i]);
			$lig_dev->prix = round($prix[$i],2);
			if ($acquisition_gestion_tva) $lig_dev->tva = round($tva[$i],2);
				else $lig_dev->tva = '0.00';		
			$lig_dev->remise = round($rem[$i],2);
			$lig_dev->nb = round($qte[$i]);
			$lig_dev->date_ech = extraitdate($dat_liv[$i]);
			$lig_dev->date_cre = today();			
			$lig_dev->save();
			$id_lig[$i] = $lig_dev->id_ligne;
		}		
	}	
		
}


// gestion des achats : devis

switch($action) {

	case 'show_lig' :
		show_lig_dev();
		break;		
			
	case 'add_lig' :
		verif_dev();
		show_lig_dev(true);
		break;		

	case 'sup_lig' :
		sup_lig_dev();
		break;		

	case 'update' :
		verif_dev();
		if ($error) {
			show_lig_dev();
			break;
		}
		update_dev();
		print $retour_liste;
		break;	

	case 'cmde' :
		verif_dev();
		if ($error) {
			show_lig_dev();
			break;
		}
		update_dev();
		print "<script type='text/javascript'>window.parent.location='../../../acquisition.php?categ=ach&sub=cmde&action=from_devis&id_bibli=".$id_bibli."&id_dev=".$id_dev."'; </script></body></html>"; 

		break;	

	
	default:
		break;
		
}

?>
