<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: amazon.class.php,v 1.4 2007/11/09 11:31:36 gueluneau Exp $

global $class_path,$base_path;
require_once($class_path."/connecteurs.class.php");
require_once($class_path."/nusoap/nusoap.php");

class amazon extends connector {
	//Variables internes pour la progression de la rcupration des notices
	var $del_old;				//Supression ou non des notices dej existantes
	
	var $searchindexes=array(
		"com"=>array("Baby","Books","Classical","DVD","Electronics","Kitchen","Magazines","Music","OfficeProducts","OutdoorLiving","PCHardware","PetSupplies","Photo","Restaurants","Software","SportingGoods","Tools","Toys","VHS","VideoGames","Wireless"),
		"co.uk"=>array("Books","Classical","DVD","Electronics","HelathPersonalCare","Kitchen","Music","OutdoorLiving","Software","SoftwareVideoGames","VHS","VideoGames"),
		"de"=>array("Books","Classical","DVD","Electronics","ForeignBooks","HelathPersonalCare","HomeGarden","Kitchen","Magazines","Music","OutdoorLiving","Photo","Software","SoftwareVideoGames","Tools","Toys","VHS","VideoGames"),
		"co.jp"=>array("Books","Classical","DVD","Electronics","ForeignBooks","Music","Software","Toys","VHS","VideoGames"),
		"fr"=>array("Books","Classical","DVD","ForeignBooks","Music","MusicTracks","Software","SoftwareVideoGames","VHS","VideoGames"),
		"ca"=>array("Books","Classical","DVD","ForeignBooks","Music","Software","SoftwareVideoGames","VHS","Video","VideoGames"),
	);
	
	var $unitoamazon=array(
		"200\$a"=>"Title",
		"7XX"=>"Author",
		"010\$a"=>"ItemId",
		"210\$c"=>"Publisher",
		"empty"=>"Keywords"
	);
	
	//Rsultat de la synchro
	var $error;					//Y-a-t-il eu une erreur	
	var $error_message;			//Si oui, message correspondant
	
    function amazon($connector_path="") {
    	parent::connector($connector_path);
    }
    
    function get_id() {
    	return "amazon";
    }
    
    //Est-ce un entrepot ?
	function is_repository() {
		return 2;
	}
    
    function unserialize_source_params($source_id) {
    	$params=$this->get_source_params($source_id);
		if ($params["PARAMETERS"]) {
			$vars=unserialize($params["PARAMETERS"]);
			$params["PARAMETERS"]=$vars;
		}
		return $params;
    }
    
    function source_get_property_form($source_id) {
    	global $charset;
    	
    	$params=$this->get_source_params($source_id);
		if ($params["PARAMETERS"]) {
			//Affichage du formulaire avec $params["PARAMETERS"]
			$vars=unserialize($params["PARAMETERS"]);
			foreach ($vars as $key=>$val) {
				global $$key;
				$$key=$val;
			}	
		}
		if (!$url) $url="com";
		$form="
		<script>var old_search_index='search_index_".$url."'</script>
		<div class='row'>
			<div class='colonne3'>
				<label for='url'>".$this->msg["amazon_site"]."</label>
			</div>
			<div class='colonne_suite'>
				<select name='url' id='url' onChange='if (old_search_index) document.getElementById(old_search_index).style.display=\"none\"; document.getElementById(\"search_index_\"+this.options[this.selectedIndex].value).style.display=\"block\"; old_search_index=\"search_index_\"+this.options[this.selectedIndex].value;'>
					<option value='com' ".($url=="com"?"selected":"").">Amazon.com US</option>
					<option value='co.uk' ".($url=="co.uk"?"selected":"").">Amazon.com UK</option>
					<option value='de' ".($url=="de"?"selected":"").">Amazon.com DE</option>
					<option value='co.jp' ".($url=="co.jp"?"selected":"").">Amazon.com JP</option>
					<option value='fr' ".($url=="fr"?"selected":"").">Amazon.com FR</option>
					<option value='ca' ".($url=="ca"?"selected":"").">Amazon.com CA</option>
				</select>
			</div>
		</div>
		<div class='row'>
			<div class='colonne3'>
				<label for='response_group'>".$this->msg["amazon_format"]."</label>
			</div>
			<div class='colonne_suite'>
				<select name='response_group' id='response_group'>
					<option value='Small' ".($response_group=="Small"?"selected":"").">Court</option>
					<option value='Medium' ".($response_group=="Medium"?"selected":"").">Moyen</option>
					<option value='Large' ".($response_group=="Large"?"selected":"").">Dtaill</option>
				</select>
			</div>
		</div>
		<div class='row'>
			<div class='colonne3'>
				<label for='search_index'>".$this->msg["amazon_search_in"]."</label>
			</div>
			<div class='colonne_suite'>";
		foreach($this->searchindexes as $country=>$values) {
			if ($search_index[$country]=="") $search_index[$country]=array();
			$form.="
					<select name='search_index[$country][]' id='search_index_$country' style='".((($url==$country)||(($url=="")&&($country=="com")))?"display:block":"display:none")."'>
						";
			for ($i=0; $i<count($values); $i++) {
				$form.="<option value='".htmlentities($values[$i],ENT_QUOTES,$charset)."' ".(array_search($values[$i],$search_index[$country])!==false?"selected":"").">".htmlentities($values[$i],ENT_QUOTES,$charset)."</option>\n";
			}
			$form.="
				</select>";
		}
		$form.="
			</div>
		</div>
		<div class='row'></div>";
		return $form;
    }
    
    function make_serialized_source_properties($source_id) {
    	global $url,$response_group,$search_index;
    	$t["url"]=stripslashes($url);
    	$t["response_group"]=$response_group;
  		$t["search_index"]=$search_index;
		$this->sources[$source_id]["PARAMETERS"]=serialize($t);
	}
	
	//Rcupration  des prorits globales par dfaut du connecteur (timeout, retry, repository, parameters)
	function fetch_default_global_values() {
		$this->timeout=5;
		$this->repository=2;
		$this->retry=3;
		$this->ttl=1800;
		$this->parameters="";
	}
	
	 //Formulaire des proprits gnrales
	function get_property_form() {
		global $charset;
		$this->fetch_global_properties();
		//Affichage du formulaire en fonction de $this->parameters
		if ($this->parameters) {
			$accesskey=$this->parameters;
		} else {
			$accesskey="";
		}	
		$r="<div class='row'>
				<div class='colonne3'><label for='accesskey'>".$this->msg["amazon_key"]."</label></div>
				<div class='colonne-suite'><input type='text' name='accesskey' value='".htmlentities($accesskey,ENT_QUOTES,$charset)."'/></div>
			</div>";
		return $r;
	}
    
    function make_serialized_properties() {
    	global $accesskey;
		//Mise en forme des paramtres  partir de variables globales (mettre le rsultat dans $this->parameters)
		$this->parameters=$accesskey;
	}
	
	function rec_record($record,$source_id,$search_id) {
		global $charset,$base_path;
		
		$date_import=date("Y-m-d H:i:s",time());
		
		//Recherche du 001
		$ref=$record["001"][0];
		//Mise  jour 
		if ($ref) {
			//Si conservation des anciennes notices, on regarde si elle existe
			if (!$this->del_old) {
				$requete="select count(*) from entrepots where connector_id='".addslashes($this->get_id())."' and source_id=".$source_id." and ref='".addslashes($ref)."' and source_id='".addslashes($search_id)."'";
				$rref=mysql_query($requete);
				if ($rref) $ref_exists=mysql_result($rref,0,0);
			}
			//Si pas de conservation des anciennes notices, on supprime
			if ($this->del_old) {
				$requete="delete from entrepots where connector_id='".addslashes($this->get_id())."' and source_id=".$source_id." and ref='".addslashes($ref)."' and source_id='".addslashes($search_id)."'";
				mysql_query($requete);
			}
			//Si pas de conservation ou refrence inexistante
			if (($this->del_old)||((!$this->del_old)&&(!$ref_exists))) {
				//Insertion de l'entte
				$n_header["rs"]="*";
				$n_header["ru"]="*";
				$n_header["el"]="1";
				$n_header["bl"]="m";
				$n_header["hl"]="0";
				$n_header["dt"]="a";
				
				foreach($n_header as $hc=>$code) {
					$requete="insert into entrepots (connector_id,source_id,ref,date_import,ufield,usubfield,field_order,subfield_order,value,i_value,recid,search_id) values(
					'".addslashes($this->get_id())."',".$source_id.",'".addslashes($ref)."','".$date_import."',
					".$hc."','',-1,0,'".addslashes($code)."','','".addslashes($this->get_id()." ".$source_id." ".$ref)."','".addslashes($search_id)."')";
					mysql_query($requete);
				}
				$field_order=0;
				foreach ($record as $field=>$val) {
					for ($i=0; $i<count($val); $i++) {
						if (is_array($val[$i])) {
							foreach ($val[$i] as $sfield=>$vals) {
								for ($j=0; $j<count($vals); $j++) {
									$requete="insert into entrepots (connector_id,source_id,ref,date_import,ufield,usubfield,field_order,subfield_order,value,i_value,recid,search_id) values(
									'".addslashes($this->get_id())."',".$source_id.",'".addslashes($ref)."','".$date_import."',
									'".addslashes($field)."','".addslashes($sfield)."',".$field_order.",".$j.",'".addslashes($vals[$j])."',
									' ".addslashes(strip_empty_words($vals[$j]))." ','".addslashes($this->get_id()." ".$source_id." ".$ref)."','".addslashes($search_id)."')";
									mysql_query($requete);
								}
							}
						} else {
							$requete="insert into entrepots (connector_id,source_id,ref,date_import,ufield,usubfield,field_order,subfield_order,value,i_value,recid) values(
							'".addslashes($this->get_id())."',".$source_id.",'".addslashes($ref)."','".$date_import."',
							'".addslashes($field)."','',".$field_order.",0,'".addslashes($val[$i])."',
							' ".addslashes(strip_empty_words($val[$i]))." ','".addslashes($this->get_id()." ".$source_id." ".$ref)."','".addslashes($search_id)."')";
							mysql_query($requete);
						}
					}
					$field_order++;
				}
			}
		}
	}
		
	function cancel_maj($source_id) {
		return false;
	}
	
	function break_maj($source_id) {
		return false;
	}
	
	function parse_query($query,&$searchattr) {
		//$r="";
		for ($i=0; $i<count($query); $i++) {
			//if (($query[$i]->inter)&&($i)) $r.=" ".$query[$i]->inter." ";
			if (!$query[$i]->sub) {
				$af=explode(":",$query[$i]->ufield);
				$isid=false;
				if (count($af)>1) {
					if ($af[0]=="id") $isid=true; 
					$amf=$af[1];
				} else $amf=$af[0];
				$amazon_field=$this->unitoamazon[$amf];
				if (!$amazon_field) $amazon_field=$this->unitoamazon["empty"];
				if ($isid) {
					$searchattr[$amazon_field][]=$this->get_values_from_id($query[$i]->values[0],$amf);
				} else $searchattr[$amazon_field][]=$query[$i]->values[0];
				//$r.=$amazon_field.":".$query[$i]->values[0];
			} else {
				$this->parse_query($query[$i]->sub,&$searchattr);
				//$r.="(".$this->parse_query($query[$i]->sub).")";
			}
		}
		//return $r;
	}
	
	function soap2array($t,$element) {
		$n=0;
		$r=array();
		foreach ($t[$element] as $elt=>$val) {
			if ($elt!=$n) {
				$r=array();
				$r[0]=$t[$element];
				break;
			}
			$r[$n]=$val;
			$n++;
		}
		return $r;
	}
	
	//Fonction de recherche
	function search($source_id,$query,$search_id) {
		$this->error=false;
		$this->error_message="";
		$params=$this->get_source_params($source_id);
		$this->fetch_global_properties();
		if ($params["PARAMETERS"]) {
			//Affichage du formulaire avec $params["PARAMETERS"]
			$vars=unserialize($params["PARAMETERS"]);
			foreach ($vars as $key=>$val) {
				global $$key;
				$$key=$val;
			}	
		}
		//Tranformation de la recherche en requete amazon
		$searchattr=array();
		$this->parse_query($query,$searchattr);
		$client=new soapclient("http://webservices.amazon.$url/AWSECommerceService/FR/AWSECommerceService.wsdl",true);
		if ($err=$client->getError()) {
			if ($err) {
				$this->error=true;
				$this->error_message=$err;
			}
		} else {
			$client->timeout = $params["TIMEOUT"];
			$client->response_timeout = $params["TIMEOUT"];
			$proxy=$client->getProxy();
			$paws["Service"]="AWSECommerceService";
			$paws["AWSAccessKeyId"]=$this->parameters;
			$paws["Request"]=array(
				"SearchIndex"=>$search_index[$url][0],
				"ResponseGroup"=>$response_group
			);
			$flag_isbn_only=1;
			foreach($searchattr as $key=>$val) {
				$flag_isbn_only*=($key=="ItemId");
				for ($i=0; $i<count($val); $i++) {
					$paws["Request"][$key]=$val[$i];
				}
			}
			if ($flag_isbn_only) $paws["Request"]["IdType"]="ISBN";
			if (!$flag_isbn_only)
				$result=$proxy->ItemSearch($paws);
			else $result=$proxy->ItemLookup($paws);
			if ($err=$client->getError()) {
					$this->error=true;
					$this->error_message=$err;
			} else {
				$items=$this->soap2array($result["Items"],"Item");
				for ($i=0; $i<count($items); $i++) {
					//print "ASIN=".$items[$i]["ASIN"]."<br/>";
					//flush();
					$nt=$items[$i]["ItemAttributes"];
					$unimarc=array();
					$unimarc["001"][0]=$items[$i]["ASIN"];
					$unimarc["010"][0]["a"][0]=$nt["ISBN"];
					$unimarc["010"][0]["a"][0]=$nt["EAN"];
					$unimarc["200"][0]["a"][0]=$nt["Title"];
					$unimarc["210"][0]["c"][0]=$nt["Publisher"];
					$unimarc["210"][0]["d"][0]=$nt["PublicationDate"];
					$unimarc["215"][0]["a"][0]=$nt["NumberOfPages"];
					$unimarc["327"][0]["a"][0]=$items[$i]["EditorialReviews"]["EditorialReview"]["Content"]." (".$items[$i]["EditorialReviews"]["EditorialReview"]["Source"].")";
					$unimarc["345"][0]["b"][0]=$nt["EAN"];
					if (is_array($nt["Author"])) {
						for ($j=0; $j<count($nt["Author"]); $j++) {
							$unimarc["70".($j>0?"1":"0")][$j]["a"][0]=$nt["Author"][$j];
						}
					} else $unimarc["700"][0]["a"][0]=$nt["Author"];
					$this->rec_record($unimarc,$source_id,$search_id);
				}
			}
		}
	}
	
	function maj_entrepot($source_id,$callback_progress="",$recover=false,$recover_env="") {
		return 0;
	}
}
?>