<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: emprunteur.class.php,v 1.75 2007/10/28 12:48:57 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once("$include_path/resa_func.inc.php");
require_once("$include_path/resa_planning_func.inc.php");
require_once($class_path."/comptes.class.php");
require_once($class_path."/amende.class.php");
require_once("$class_path/parametres_perso.class.php");
require_once("$class_path/mono_display.class.php");
require_once("$class_path/serial_display.class.php");

$selector_prop_ajout_caddie_empr = "toolbar=no, dependent=yes, width=500, height=400, resizable=yes, scrollbars=yes";

// classe emprunteur
class emprunteur {

//---------------------------------------------------------
//            Proprits
//---------------------------------------------------------

var $id		= 0		;    // id MySQL emprunteur
var $cb     = ''    ;    // code barre emprunteur
var $nom    = ''    ;    // nom emprunteur
var $prenom = ''    ;    // prnom emprunteur
var $adr1   = ''    ;    // adresse ligne 1
var $adr2   = ''    ;    // adresse ligne 2
var $cp     = ''    ;    // code postal
var $ville  = ''    ;    // ville
var $pays   = ''    ;    // pays
var $mail   = ''    ;    // adresse email
var $tel1   = ''    ;    // tlphone 1
var $tel2   = ''    ;    // tlphone 2
var $prof   = ''    ;    // profession
var $birth  = ''    ;    // anne de naissance
var $categ  = 0    	;    // catgorie emprunteur
var $cat_l  = ''    ;    // libell catgorie emprunteur
var $cstat  = 0    	;    // code statistique
var $cstat_l= 0     ;    // libell code statistique
var $cdate  = ''    ;    // date de cration
var $mdate  = ''    ;    // date de modification
var $adate  = ''    ;    // date d'abonnement
var $rdate  = ''    ;    // date de rabonnement
var $sexe   = 0    	;    // sexe de l'emprunteur
var $login  = ''    ;    // login pour services OPAC
var $pwd    = ''    ;    // mot de passe OPAC
var $ldap   = ''   	;  	 // flag pour AuthLdap
var $date_adhesion   = '';    // dbut adhsion
var $date_expiration = '';    // fin adhsion
var $aff_date_adhesion   = '';    // dbut adhsion formate
var $aff_date_expiration = '';    // fin adhsion formate
var $empr_msg     = ''    ;    // Message emprunteur
var $prets        ;    // array contenant les prts de l'emprunteur
// var $reservations    ;    // array contenant les rservations pour l'emprunteur
// supprim par ER le 29/12 : ne semble jamais utilis
var $nb_reservations ;
var $message = ''    ;    // chane contenant les messages emprunteurs
var $fiche = ''        ;    // code HTML de la fiche lecteur
var $fiche_affichage = ''        ;    // code HTML de la fiche lecteur, lecture seule, allge, pas de bouton
var $lien_nom_prenom = '' ; 		// NOM, Prnom avec lien vers ficher lecteur
var $img_ajout_empr_caddie = '' ;	// Icne ajout panier si activ.
var $serious_message=FALSE;    // niveau du message (srieux si TRUE)
var $retard = 0        ;     // le lecteur a-t-il du retard
var $perso = ""        ;     // Champs personaliss
var $header_format = "" ;	// Champs personnaliss en entte
var $compte = ""		;	//Comptes financiers
var $fiche_compte="";	// code HTML d'un compte
var $fiche_consultation=""; 	// code HTML d'un compte en visu
var $type_abt=0;	//Type d'abonnement
var $groupes = array(); //Groupes de l'emprunteur
var $empr_location = 0; //Localisation de l'emprunteur
var $empr_location_l = ""; //Localisation de l'emprunteur
var $date_blocage=""; //Date de fin de blocage du lecteur
var $blocage_active=false; //Le blocage est-il actif ?

var $empr_statut=1; // Statut de l'emprunteur
var $empr_statut_libelle=""; // Statut de l'emprunteur

var $allow_loan=1;     // Pret autoris
var $allow_book=1;     // Reservation autorise
var $allow_opac=1;     // OPAC autoris
var $allow_dsi=1;      // DSI autorise
var $allow_dsi_priv=1; // DSI prive autorise
var $allow_sugg=1;     // Suggestions autorises
var $allow_prol=1;     // Demande de prolongation autorise

var $total_loans=0; // Nb total de ses emprunts
var $type_fiche=0;  // Type de fiche

// <----------------- constructeur ------------------>
function emprunteur ($id=0, $message='', $niveau_message=FALSE, $type_fiche=0) {

	// initialisation des proprits si l'id est dfini
	if($id) {
		$this->id = $id;
		$this->type_fiche = $type_fiche;
		$this->serious_message = $niveau_message;
		$this->prets = array();
		$this->nb_reservations = 0;
		$this->fetch_info();
		if ($type_fiche>0) $this->fetch_info_suite();
		$this->message = $message;
		if ($type_fiche==1) $this->do_fiche();
		elseif ($type_fiche==2) $this->do_fiche_affichage() ;
		elseif ($type_fiche==3) $this->do_fiche_consultation() ;
	}
}

//   renseignement des proprits avec requte MySQL
function fetch_info() {

	global $dbh;
	global $msg;
	global $charset;
	global $val_list_empr;
	global $pmb_gestion_financiere, $pmb_gestion_abonnement,$pmb_gestion_tarif_prets,$pmb_gestion_amende,$empr_header_format;
	global $deflt_docs_location ;
	
	if(!$this->id || !$dbh)
		return FALSE;

	$requete = "SELECT e.*, c.libelle AS code1, s.libelle AS code2, es.statut_libelle AS empr_statut_libelle, allow_loan, allow_book, allow_opac, allow_dsi, allow_dsi_priv, allow_sugg, allow_prol, d.location_libelle as localisation, date_format(empr_date_adhesion, '".$msg["format_date"]."') as aff_empr_date_adhesion, date_format(empr_date_expiration, '".$msg["format_date"]."') as aff_empr_date_expiration FROM empr e left join docs_location as d on e.empr_location=d.idlocation, empr_categ c, empr_codestat s, empr_statut es ";
	$requete .= " WHERE e.id_empr='".$this->id."' " ;
	$requete .= " AND c.id_categ_empr=e.empr_categ";
	$requete .= " AND s.idcode=e.empr_codestat";
	$requete .= " AND es.idstatut=e.empr_statut";
	$requete .= " LIMIT 1";
	$result = mysql_query($requete, $dbh) or die (mysql_error()." ".$requete) ;
	if(!mysql_num_rows($result))
		return FALSE;

	$empr = mysql_fetch_object($result);

	// affectation des proprits
	$this->cb        = $empr->empr_cb           ;    // code barre emprunteur
	$this->nom       = $empr->empr_nom          ;    // nom emprunteur
	$this->prenom    = $empr->empr_prenom       ;    // prnom mprunteur
	$this->adr1      = $empr->empr_adr1         ;    // adresse ligne 1
	$this->adr2      = $empr->empr_adr2         ;    // adresse ligne 2
	$this->cp        = $empr->empr_cp           ;    // code postal
	$this->ville     = $empr->empr_ville        ;    // ville
	$this->pays      = $empr->empr_pays         ;    // ville
	$this->mail      = $empr->empr_mail         ;    // adresse email
	$this->tel1      = $empr->empr_tel1         ;    // tlphone 1
	$this->tel2      = $empr->empr_tel2         ;    // tlphone 2
	$this->prof      = $empr->empr_prof         ;    // profession
	$this->birth     = $empr->empr_year         ;    // anne de naissance
	$this->categ     = $empr->empr_categ        ;    // catgorie emprunteur
	$this->cstat     = $empr->empr_codestat     ;    // code statistique
	$this->cdate     = $empr->empr_creation     ;    // date de cration
	$this->mdate     = $empr->empr_modif        ;    // date de modification
	$this->sexe      = $empr->empr_sexe         ;    // sexe de l'emprunteur
	$this->login     = $empr->empr_login        ;    // login pour services OPAC
	$this->pwd       = $empr->empr_password     ;    // mot de passe OPAC
	$this->type_abt	 = $empr->type_abt;				 // type d'abonnement
	$this->empr_location	 = $empr->empr_location; // localisation
	$this->empr_location_l	 = $empr->localisation; // localisation
	$this->date_blocage= $empr->date_fin_blocage; // Date de fin de blocage de l'emprunteur
	$this->empr_statut= $empr->empr_statut;
	$this->empr_statut_libelle= $empr->empr_statut_libelle;
	$this->total_loans= $empr->total_loans;
	$this->allow_loan        =$empr->allow_loan;   
	$this->allow_book        =$empr->allow_book;   
	$this->allow_opac        =$empr->allow_opac;   
	$this->allow_dsi         =$empr->allow_dsi;    
	$this->allow_dsi_priv    =$empr->allow_dsi_priv;
	$this->allow_sugg        =$empr->allow_sugg;    
	$this->allow_prol        =$empr->allow_prol;    
	
	global $selector_prop_ajout_caddie_empr, $empr_show_caddie ;
	if ($empr_show_caddie) {
		$this->img_ajout_empr_caddie="<img src='./images/basket_empr.gif' align='middle' alt='basket' title=\"${msg[400]}\" onClick=\"window.open('./cart.php?object_type=EMPR&item=".$this->id."', 'cart', '$selector_prop_ajout_caddie_empr')\">";
		} else $this->img_ajout_empr_caddie="";
	$this->lien_nom_prenom="<a href='./circ.php?categ=pret&form_cb=".rawurlencode($this->cb)."'>$this->nom,&nbsp;$this->prenom</a>";
	
	
	$date_blocage=array();
	$date_blocage=explode("-",$this->date_blocage);
	if (mktime(0,0,0,$date_blocage[1],$date_blocage[2],$date_blocage[0])>time()) {
		$this->blocage_active=true;
	}
	
	//Groupes
	$requete="select id_groupe, libelle_groupe from groupe, empr_groupe where empr_id='".$this->id."' and id_groupe=groupe_id";
	$result=mysql_query($requete);
	if (mysql_num_rows($result)) {
		while ($grp_temp=mysql_fetch_object($result)) {
			$this->groupes[] = "<a href='./circ.php?categ=groups&action=showgroup&groupID=".$grp_temp->id_groupe."'>".htmlentities($grp_temp->libelle_groupe,ENT_QUOTES,$charset)."</a>";
			}
		} else $this->groupes=array();

	if ($empr->empr_ldap){
		$this->ldap='LDAP';    // flag AuthLdap
	} else {
		$this->ldap='MYSQL';
	}

	$this->date_adhesion     	= $empr->empr_date_adhesion        ;    // dbut adhsion
	$this->date_expiration     	= $empr->empr_date_expiration      ;    // fin adhsion
	$this->aff_date_adhesion    = $empr->aff_empr_date_adhesion    ;    // dbut adhsion
	$this->aff_date_expiration	= $empr->aff_empr_date_expiration  ;    // fin adhsion
	$this->empr_msg     		= $empr->empr_msg            ;    // message emprunteur
	$this->cat_l        		= $empr->code1               ;    // libell catgorie emprunteur
	$this->cstat_l      		= $empr->code2               ;    // libell code statistique. voir ce bug avec Eric

	//Paramtres perso
	//Liste des champs
	$p_perso=new parametres_perso("empr");
	$perso_=$p_perso->show_fields($this->id);

	$perso="";
	$header_format="";
	$class="colonne3";
	$c=0;
	if (count($perso_["FIELDS"])) {
		for ($i=0; $i<count($perso_["FIELDS"]); $i++) {
				$p=$perso_["FIELDS"][$i];
				if ($empr_header_format) {
					$s=explode(",",$empr_header_format);
					if (array_search($p["ID"],$s)!==FALSE) $header_format.=$p["TITRE"].$p["AFF"]."&nbsp;";
				}
				$perso.="<div class='$class'>";
				$perso.="<div class='row'>".$p["TITRE"];
				$perso.=$p["AFF"]."</div>";
				$perso.="</div>";
				if ($c==0) {$c=1;} else
				if ($c==1) { $class="colonne_suite"; $c=2; } else
					if ($c==2) {$class="colonne3"; $c=0; }
		}

		$reste=2-$c;
		if ($c!=0) {
				for ($i=0; $i<$reste; $i++) {
					$perso.="<div class='colonne3'>&nbsp;</div>";
					$c++;
				}
				$perso.="<div class='colonne_suite'>&nbsp;</div>";
		}
	}
	$this->header_format=$header_format;
	$this->perso=$perso;

	}
	
	
// histoire de ne pas aller chercher tout le reste
function fetch_info_suite() {

	global $dbh;
	global $msg;
	global $charset;
	global $val_list_empr;
	global $pmb_gestion_financiere, $pmb_gestion_abonnement,$pmb_gestion_tarif_prets,$pmb_gestion_amende,$empr_header_format;
	global $deflt_docs_location ;
	
	
	//Comptes si gestion financiere
	$compte="";
	$n_c=0;
	$neg="<span class='erreur'>%s</span>";
	$pos="%s";
	if ($pmb_gestion_financiere) {
		$compte.="<div class='row'><hr></div><div class='row'>";
		if ($pmb_gestion_abonnement) {
			$cpt_id=comptes::get_compte_id_from_empr($this->id,1);
			$cpt=new comptes($cpt_id);
			$solde=$cpt->update_solde();
			$novalid=$cpt->summarize_transactions("","",0,0);
			if ($cpt_id) {
				$compte.="<div class='colonne3'><div><strong><a href='./circ.php?categ=pret&sub=compte&id=".$this->id."&typ_compte=1'>".$msg["finance_solde_abt"]."</a></strong> ".comptes::format($solde)."</div>";
				if ($novalid) $compte.="<div>".$msg["finance_not_validated"]." : ".comptes::format($novalid)."</div>";
				$compte.="</div>";
			}
			$n_c++;
		}
		if ($pmb_gestion_tarif_prets) {
			$cpt_id=comptes::get_compte_id_from_empr($this->id,3);
			$cpt=new comptes($cpt_id);
			$solde=$cpt->update_solde();
			$novalid=$cpt->summarize_transactions("","",0,0);
			if ($cpt_id) {
				$compte.="<div class='colonne3'><div><strong><a href='./circ.php?categ=pret&sub=compte&id=".$this->id."&typ_compte=3'>".$msg["finance_solde_pret"]."</a></strong> ".comptes::format($solde)."</div>";
				if ($novalid) $compte.="<div>".$msg["finance_not_validated"]." : ".comptes::format($novalid)."</div>";
				$compte.="</div>";
			}
			$n_c++;
		}
		if ($pmb_gestion_amende) {
			$cpt_id=comptes::get_compte_id_from_empr($this->id,2);
			$cpt=new comptes($cpt_id);
			$solde=$cpt->update_solde();
			$novalid=$cpt->summarize_transactions("","",0,0);
			if ($cpt_id) {
				//Calcul des amendes
				$amende=new amende($this->id);
				$total_amende=$amende->get_total_amendes();
				$compte.="<div class='colonne3'><div><strong><a href='./circ.php?categ=pret&sub=compte&id=".$this->id."&typ_compte=2'>".$msg["finance_solde_amende"]."</a></strong> ".comptes::format($solde)."</div>";
				if ($novalid) $compte.="<div>".$msg["finance_not_validated"]." : ".comptes::format($novalid)."</div>";
				if ($total_amende) $compte.="<div> ".$msg["finance_pret_amende_en_cours"]." : ".comptes::format($total_amende)."</div>";
				$compte.="</div>";
			}
			$n_c++;
		}
		if ($n_c<2) for ($i=$n_c; $i<3; $i++) $compte.="<div class='colonne3'>&nbsp;</div>";
		$compte.="</div><div class='row'></div>";
	}

	$this->compte=$compte;

	// ces proprits sont absentes de la table emprunteurs pour le moment
	//    $this->adate    = $empr->empr_???    ;    // date d'abonnement
	//    $this->rdate    = $empr->empr_???    ;    // date de rabonnement
	if($this->message) $this->message = $empr->message.'<hr>'.$this->message;
		else $this->message = $empr->message;

	// rcupration du tableau des exemplaires emprunts
	// il nous faut : code barre exemplaire, titre/auteur, type doc, date de prt, date de retour
	$requete = "select e.expl_cb, e.expl_id, e.expl_notice, e.expl_bulletin, p.pret_date, p.pret_retour, t.tdoc_libelle, date_format(pret_date, '".$msg["format_date"]."') as aff_pret_date, date_format(pret_retour, '".$msg["format_date"]."') as aff_pret_retour, if (pret_retour< CURDATE(),1 ,0 ) as retard , date_format(retour_initial, '".$msg["format_date"]."') as aff_retour_initial, cpt_prolongation";
	$requete .= " from pret p, exemplaires e, docs_type t";
	$requete .= " where p.pret_idempr=".$this->id;
	$requete .= " and p.pret_idexpl=e.expl_id";
	$requete .= " and t.idtyp_doc=e.expl_typdoc";
	$requete .= " order by p.pret_retour, p.pret_date, e.expl_cb";

	$result = mysql_query($requete, $dbh);
	$this->retard=0;
	while($pret = mysql_fetch_object($result)) {
		if ($pret->expl_notice) {
				$notice = new mono_display($pret->expl_notice, 0);
				$this->prets[] = array(
						'cb' => $pret->expl_cb,
						'id' => $pret->expl_id,
						'libelle' => $notice->header,
						'typdoc' => $pret->tdoc_libelle,
						'date_pret' => $pret->aff_pret_date,
						'date_retour' => $pret->aff_pret_retour,
						'sql_date_retour' => $pret->pret_retour,
						'org_ret_date' => str_replace('-', '', $pret->pret_retour),
						'pret_retard' => $pret->retard,	
						'retour_initial' => $pret->aff_retour_initial,		
						'cpt_prolongation' => $pret->cpt_prolongation		
						);
				}
		if ($pret->expl_bulletin) {
				$bulletin = new bulletinage_display($pret->expl_bulletin);
				$this->prets[] = array(
						'cb' => $pret->expl_cb,
						'id' => $pret->expl_id,
						'libelle' => $bulletin->display,
						'typdoc' => $pret->tdoc_libelle,
						'date_pret' => $pret->aff_pret_date,
						'date_retour' => $pret->aff_pret_retour,
						'sql_date_retour' => $pret->pret_retour,
						'org_ret_date' => str_replace('-', '', $pret->pret_retour),
						'pret_retard' => $pret->retard,			
						'retour_initial' => $pret->aff_retour_initial,		
						'cpt_prolongation' => $pret->cpt_prolongation									
						);
				}
		$this->retard = $this->retard+$pret->retard;
		

	}
	$requete_resa = "select count(1) as nb_reservations ";
	$requete_resa .= " from resa ";
	$requete_resa .= " where resa_idempr=".$this->id;

	$result_resa = mysql_query($requete_resa, $dbh);
	$resa = mysql_fetch_object($result_resa);
	$this->nb_reservations = $resa->nb_reservations ;
	return TRUE;

}

// fabrication de la fiche lecteur
function do_fiche() {

	global $empr_tmpl, $empr_pret_allowed;
	global $msg,$charset;
	global $groupID;
	global $biblio_email;
	global $pmb_lecteurs_localises ;
	global $pmb_gestion_abonnement,$pmb_gestion_financiere, $pmb_gestion_tarif_prets, $pmb_gestion_amende;
	global $finance_blocage_abt,$finance_blocage_amende,$finance_blocage_pret,$pmb_blocage_retard,$pmb_blocage_retard_force;
	global $force_finance;
	global $pmb_resa_planning;
	global $dbh;
	global $pmb_blocage_retard,$pmb_blocage_coef,$pmb_blocage_max,$pmb_blocage_delai;
	global $empr_fiche_depliee;
	
	//global $cb_inpret;

	global $param_sounds, $alertsound ; // l'utilisateur veut-il les sons d'alerte

	$this->fiche = $empr_tmpl;	
	$this->fiche = str_replace('!!cb!!'        , $this->cb    , $this->fiche);
	$this->fiche = str_replace('!!nom!!'    , pmb_strtoupper($this->nom)    , $this->fiche);
	$this->fiche = str_replace('!!prenom!!'    , $this->prenom    , $this->fiche);
	$this->fiche = str_replace('!!image_caddie_empr!!', $this->img_ajout_empr_caddie, $this->fiche);
	$this->fiche = str_replace('!!info_nb_pret!!'    , sizeof($this->prets)    , $this->fiche);
	$this->fiche = str_replace('!!info_nb_resa!!'    , $this->nb_reservations    , $this->fiche);
	$this->fiche = str_replace('!!info_authldap!!'    , $this->ldap, $this->fiche);
	$this->fiche = str_replace('!!id!!'        , $this->id    , $this->fiche);
	$this->fiche = str_replace('!!adr1!!'    , $this->adr1    , $this->fiche);
	$this->fiche = str_replace('!!adr2!!'    , $this->adr2    , $this->fiche);
	$this->fiche = str_replace('!!tel1!!'    , $this->tel1    , $this->fiche);
	$this->fiche = str_replace('!!tel2!!'    , $this->tel2    , $this->fiche);
	$this->fiche = str_replace('!!cp!!'        , $this->cp    , $this->fiche);
	$this->fiche = str_replace('!!ville!!'    , $this->ville    , $this->fiche);
	$this->fiche = str_replace('!!pays!!'    , $this->pays    , $this->fiche);
	
	$emails=array();
	$email_final=array();
	$emails = explode(';',$this->mail);
	for ($i=0;$i<count($emails);$i++) $email_final[] ="<a href='mailto:".$emails[$i]."'>".$emails[$i]."</a>";
	
	$this->fiche = str_replace('!!mail_all!!'    , implode("&nbsp;",$email_final)    , $this->fiche);
	$this->fiche = str_replace('!!prof!!'    , $this->prof    , $this->fiche);
	$this->fiche = str_replace('!!date!!'    , $this->birth    , $this->fiche);
	$this->fiche = str_replace('!!categ!!'    , $this->cat_l    , $this->fiche);
	$this->fiche = str_replace('!!codestat!!'    , $this->cstat_l, $this->fiche);
	$this->fiche = str_replace('!!adhesion!!'    , $this->aff_date_adhesion, $this->fiche);
	$this->fiche = str_replace('!!expiration!!'    , $this->aff_date_expiration, $this->fiche);
	$this->fiche = str_replace('!!perso!!'    , $this->perso, $this->fiche);
	$this->fiche = str_replace('!!header_format!!'    , $this->header_format, $this->fiche);
	$this->fiche = str_replace('!!empr_login!!'    , $this->login, $this->fiche);
	if ($this->pwd) $this->fiche = str_replace('!!empr_pwd!!',"<i><strong>".$msg["empr_pwd_opac_affected"]."</strong</i>",$this->fiche);
		else $this->fiche = str_replace('!!empr_pwd!!',"",$this->fiche);
	$this->fiche = str_replace('!!comptes!!'    , $this->compte, $this->fiche);
	$this->fiche = str_replace('!!empr_statut_libelle!!', $this->empr_statut_libelle, $this->fiche);
	$this->fiche = str_replace('!!empr_picture!!', $this->picture_empr($this->cb), $this->fiche);
	if ($empr_fiche_depliee=="1") $this->fiche = str_replace('!!depliee!!'," startOpen=\"Yes\"", $this->fiche);
		else $this->fiche = str_replace('!!depliee!!',"", $this->fiche);
	
	if ($pmb_lecteurs_localises) $this->fiche = str_replace("<!-- !!localisation!! -->", "<div class='row'><strong>$msg[empr_location] : </strong>".$this->empr_location_l."</div>", $this->fiche);
	
	//Groupes
	if (count($this->groupes)) {
		$this->fiche = str_replace('!!groupes!!',"<strong>".$msg[groupes_empr]." : </strong>".implode(" / ",$this->groupes)."\n",$this->fiche);
		} else {
			$this->fiche = str_replace('!!groupes!!',"&nbsp;",$this->fiche);
			}

	//Pret autoris ou non ?
	$pret_ok=0;
	if (($pmb_gestion_financiere)&&($force_finance==0)) {
		$message_pret="";
		if ($pmb_gestion_abonnement) {
			//Vrification du compte
			$cpte_abt_id=comptes::get_compte_id_from_empr($this->id,1);
			if ($cpte_abt_id) {
				$cpte_abt=new comptes($cpte_abt_id);
				$solde_neg=$cpte_abt->get_solde();
				if (($finance_blocage_abt)&&($solde_neg*1<0)) {
					if ($pret_ok<2) $pret_ok=$finance_blocage_abt;
					$message_pret.=sprintf($msg["finance_pret_solde_abt"],comptes::format($solde_neg))."<br>";
				}
			}
		}
		
		if ($pmb_gestion_tarif_prets) {
			//Vrification du compte
			$cpte_pret_id=comptes::get_compte_id_from_empr($this->id,3);
			if ($cpte_pret_id) {
				$cpte_pret=new comptes($cpte_pret_id);
				$solde_neg=$cpte_pret->get_solde();
				if (($finance_blocage_pret)&&($solde_neg*1<0)) {
					if ($pret_ok<2) $pret_ok=$finance_blocage_pret;
					$message_pret.=sprintf($msg["finance_pret_solde_pret"],comptes::format($solde_neg))."<br>";
				}
			}
		}
		
		if ($pmb_gestion_amende) {
			//Vrification du compte
			$cpte_amende_id=comptes::get_compte_id_from_empr($this->id,2);
			if ($cpte_amende_id) {
				$cpte_amende=new comptes($cpte_amende_id);
				$solde_neg=$cpte_amende->get_solde();
				$amende=new amende($this->id);
				$amende_neg=$amende->get_total_amendes();
				if (($finance_blocage_amende)&&(($solde_neg*1<0)||($amende_neg*1))) {
					if ($pret_ok<2) $pret_ok=$finance_blocage_amende;
					if ($solde_neg*1<0)
						$message_pret.=sprintf($msg["finance_pret_solde_amende"],comptes::format($solde_neg))."<br>";
					if ($amende_neg*1)
						$message_pret.=sprintf($msg["finance_pret_amende_en_cours_blocage"],comptes::format($amende_neg))."<br>";
				}
			}
		}
	}
	if (($pmb_blocage_retard)&&($force_finance==0)) {
			if (($this->date_blocage)&&($this->blocage_active)) {
				$message_pret.=sprintf($msg["blocage_retard_pret"],formatdate($this->date_blocage))."&nbsp;<input type='button' value='".$msg["blocage_params"]."' class='bouton' onClick=\"w=window.open('./circ/blocage.php?id_empr=".$this->id."','blocage_params','toolbar=no, dependent=yes, width=400, height=150,resizable=yes'); w.focus();\"/><br>";
				if ($pret_ok<2) $pret_ok=$pmb_blocage_retard_force;
			}
	}

	
	// Ajout de l'impossibilit d'effectuer un prt si un document n'est pas rendu
	// alors qu'il a dpass la dlai de blocage (NG72) .   
	//if ($pmb_blocage_retard){
	if (($pmb_blocage_retard)&&($force_finance==0)) {
		// Recherche la date de retour du document la plus petite, soit le plus gros retard potentiel

		$requete = "select MIN(pret_retour)as pret_retour";
		$requete .= " from pret p";
		$requete .= " where p.pret_idempr=".$this->id;
		$result = mysql_query($requete, $dbh);
		
		while($bloca = mysql_fetch_object($result)) {
			if ($bloca->pret_retour){
				$pret_retour=$bloca->pret_retour;
						
				$date_debut=explode("-",$pret_retour);
				$ndays=calendar::get_open_days($date_debut[2],$date_debut[1],$date_debut[0],date("d"),date("m"),date("Y"));
			
				if ($ndays>$pmb_blocage_delai) {
					$ndays=$ndays*$pmb_blocage_coef;
						if (($ndays>$pmb_blocage_max)&&($pmb_blocage_max!=0)) {
							$ndays=$pmb_blocage_max;
						}
				} else $ndays=0;
			
				if ($ndays) {
					// Interdire alors de nouveau prt
					$pret_ok=$pmb_blocage_retard_force;			
				}
			}
		}
	}
	if (!$pret_ok && $this->allow_loan) {
		$this->fiche = str_replace("!!empr_case_pret!!", $empr_pret_allowed,$this->fiche);
		$this->fiche = str_replace('!!id!!'        , $this->id    , $this->fiche);
	} else {
		if ($pret_ok==1 && $this->allow_loan) {
			$message_pret.="<input type='button' class='bouton' value=\"".$msg["finance_pret_force_pret"]."\" onClick=\"this.form.force_finance.value=1; this.form.submit();\">";
		} elseif($this->allow_loan) {
			$message_pret.="<div class='erreur'>".$msg["finance_pret_bloque"]."</div>";
		} else $message_pret.="<div class='erreur'>".$msg["empr_no_allow_loan"]."</div>";
		$this->fiche = str_replace("!!empr_case_pret!!", $message_pret,$this->fiche);
	}
	$abonnement="";
	if (($pmb_gestion_financiere)&&($pmb_gestion_abonnement==2)) {
		if ($this->type_abt) {
			$requete="select type_abt_libelle from type_abts where id_type_abt='".$this->type_abt."'";
			$resultat_type_abt=mysql_query($requete);
			if (@mysql_num_rows($resultat_type_abt)) {
				$abonnement=mysql_result($resultat_type_abt,0,0);
			}
		}
	}
	
	if ($abonnement) {
		$this->fiche = str_replace("!!abonnement!!", "<div class='row'><strong>".$msg["finance_type_abt"]." : </strong>".htmlentities($abonnement,ENT_QUOTES,$charset)."</div>\n",$this->fiche);
	} else {
		$this->fiche = str_replace("!!abonnement!!","",$this->fiche);
	}
	
	// message
	if ($this->empr_msg) {
		$message_fiche_empr= "
				<hr>
				<div class='row'>
					<div class='colonne10'><img src='./images/info.png' /></div>
					<div class='colonne-suite'><span class='erreur'>$this->empr_msg</span></div>
					</div><br>";
		if ($param_sounds) $message_fiche_empr .= $alertsound[information] ;
		$this->fiche = str_replace('!!empr_msg!!'    ,$message_fiche_empr , $this->fiche);
	} else $this->fiche = str_replace('!!empr_msg!!', "", $this->fiche);
	
	// on distingue les messages de prts du message sur l'emprunteur
	$this->fiche = str_replace('!!pret_msg!!'    , $this->message    , $this->fiche);

	if ($this->adhesion_renouv_proche()) {
		$message_date_depassee = $msg[empr_date_renouv_proche];
		} elseif ($this->adhesion_depassee()) {
			$message_date_depassee = $msg[empr_date_depassee];
			} else {
				$message_date_depassee="";
				}
	if ($param_sounds && $message_date_depassee) $message_date_depassee .= $alertsound[critique] ;
	$this->fiche = str_replace('!!empr_date_depassee!!', $message_date_depassee, $this->fiche);

	$group_zone = "<a href='./circ.php'>$msg[64]</a>";
	if($groupID)
		$group_zone .= "&nbsp;&nbsp;&nbsp;<a href='./circ.php?categ=groups&action=showgroup&groupID=$groupID'>$msg[grp_autre_lecteur]</a>" ;

	$this->fiche = str_replace('!!group_zone!!', $group_zone, $this->fiche);

	$fsexe[0] = $msg[128];
	$fsexe[1] = $msg[126];
	$fsexe[2] = $msg[127];

	$this->fiche = str_replace('!!sexe!!'    , $fsexe[$this->sexe], $this->fiche);
	
	// valeur pour les champ hidden du prt. L'id empr est pris en charge plus haut (voir Eric)
	$this->fiche = str_replace('!!cb!!'    , $this->cb    , $this->fiche);

	// traitement liste exemplaires en prt
	$this->fiche = str_replace('!!nb_prets_encours!!'    , sizeof($this->prets)    , $this->fiche);

	//Si retard sur un document, proposer la lettre de retard ou l'email de retard
	if ($this->retard>=1) {
		$imprime_click = "onclick=\"w=window.open('./pdf.php?pdfdoc=lettre_retard&id_empr=".$this->id."', 'lettre', 'toolbar=no, dependent=yes, width=600, height=500, resizable=yes'); w.focus(); return(false) \"";
		$bouton_lettre_retard=$msg['retard']."&nbsp;<input type=\"button\" class=\"bouton\" value=\"".$msg["lettre_retard"]."\" ".$imprime_click.">";
		if (($this->mail)&&($biblio_email)) {
			$mail_click = "onclick=\"if (confirm('".$msg["mail_retard_confirm"]."')) { w=window.open('./mail.php?type_mail=mail_retard&id_empr=".$this->id."', 'mail', 'toolbar=no, dependent=yes, width=600, height=500, resizable=yes, scrollbars=yes'); w.focus(); } return(false) \"";
			$bouton_mail_retard="<input type=\"button\" class=\"bouton\" value=\"".$msg["mail_retard"]."\" ".$mail_click.">";
			} else {
				$bouton_mail_retard="";
				}
		} else {
			$bouton_lettre_retard="";
			$bouton_mail_retard="";
			}
	$this->fiche=str_replace("!!lettre_retard!!",$bouton_lettre_retard,$this->fiche);
	$this->fiche=str_replace("!!mail_retard!!",$bouton_mail_retard,$this->fiche);

	if(!count($this->prets))
		// dans ce cas, le lecteur n'a rien en prt
		$prets_list = "<tr><td colspan='6'>$msg[650]</td></tr>";
	else {
		// constitution du code HTML
		$vdr=0;
		$id_bloc=$id_inpret='';
		$odd_even = 0 ;
		while(list($cle, $valeur) = each($this->prets)) {
			//printr($valeur,'','VAL');
			$id_inpret .= $valeur['id'].'|';
			if ($valeur['pret_retard']==1) $tit_color="color='RED'";				
				else $tit_color="";				
			
			//Affichage des prolongation
			global $pmb_pret_restriction_prolongation,$pmb_pret_nombre_prolongation;
			$pret_nombre_prolongation=0;
			$forcage_prolongation=TRUE;
			$duree_prolongation=0;
			// Limitation simple du pret
			if($pmb_pret_restriction_prolongation==1) {
				$pret_nombre_prolongation=$pmb_pret_nombre_prolongation;
			} elseif($pmb_pret_restriction_prolongation==2) {
				// Limitation du pret par les quotas
				//Initialisation des quotas pour nombre de prolongations
				$qt = new quota("PROLONG_NMBR_QUOTA");
				//Tableau de passage des paramtres
				$struct["READER"] = $this->id;
				$struct["EXPL"] = $valeur['id'];			
				$pret_nombre_prolongation=$qt -> get_quota_value($struct);		
				$forcage_prolongation=$qt -> get_force_value($struct);				
			
			
				//Initialisation des quotas la dure de prolongations
				$qt = new quota("PROLONG_TIME_QUOTA");
				$struct["READER"] = $this->id;
				$struct["EXPL"] = $valeur['id'];	
				$duree_prolongation=$qt -> get_quota_value($struct);	
			
			}
			//$forcage_prolongation=FALSE;
			/* on prpare la date de dbut*/
			$pret_date = $valeur['sql_date_retour'];
			$rqt_date = "select date_add('".$pret_date."', INTERVAL '$duree_prolongation' DAY) as date_prolongation ";
			$resultatdate = mysql_query($rqt_date);
			$res = mysql_fetch_object($resultatdate) ;
			$date_prolongation=str_replace('-'    , ""    , $res->date_prolongation);		
				
			
				
			if ($odd_even==0) {
				$pair_impair = "odd";
				$odd_even=1;
			} else if ($odd_even==1) {
				$pair_impair = "even";
				$odd_even=0;
			}
					
			$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='$pair_impair'\"";			
			$prets_list .= "
				<tr class='$pair_impair' $tr_javascript>
				<form class='form-$current_module' name=prolong".$valeur['id']." action='circ.php'>
					<td class='empr-expl'><a href='./circ.php?categ=visu_ex&form_cb_expl=".$valeur['cb']."'>
						${valeur['cb']}</a>
					</td>
					<td size='70%'>
						<font $tit_color>${valeur['libelle']}</font>
					</td>
					<td>
						<center>${valeur['typdoc']}</center>
					</td>
					<td>
						<center>${valeur['date_pret']}</center>
					</td>				
					<td>
						<center>${valeur['retour_initial']}</center>
					</td>
					<td>
						<center>${valeur['cpt_prolongation']}/$pret_nombre_prolongation</center>
					</td>
					<td>
						<input type='hidden' name='categ' value='pret'>
						<input type='hidden' name='sub' value='pret_prolongation'>
						<input type='hidden' name='form_cb' value='$this->cb'>
						<input type='hidden' name='cb_doc' value='${valeur['cb']}'>
						<input type='hidden' name='id_doc' value='${valeur['id']}'>
						<input type='hidden' name='date_retour' value=\"\">";
			
			$vdr=max($vdr,$valeur['org_ret_date']);
			
			if($forcage_prolongation== FALSE && $valeur['cpt_prolongation']>=$pret_nombre_prolongation ) {
				
				$prets_list .= "<center>${valeur['date_retour']}</center>" .
						"</td>" .
						"</form></tr>";								
			} else {
				$date_clic   = " onClick=\"window.open('./select.php?what=calendrier";
				$date_clic  .= "&caller=prolong".$valeur['id'];
				//$date_clic  .= "&date_caller=${valeur['org_ret_date']}";
				$date_clic  .= "&date_caller=$date_prolongation";
				$date_clic  .= "&param1=date_retour&param2=date_retour_lib&auto_submit=YES',";
				$date_clic  .= " 'date_retour',";
				$date_clic  .= " 'toolbar=no, dependent=yes, width=250, height=260, resizable=yes')\"";
				$prets_list .= "
					<input type='button' name='date_retour_lib' class='bouton' value='${valeur['date_retour']}' ".$date_clic." />
					</td><td><center>";
				$prets_list .= "<input type='checkbox' id='prol_".$valeur['id']."' name='cbox_prol'  onClick='check_cb(this.form)'/>";								
				$prets_list .= "</center></td>
					</form></tr>";
			}			
		}
	}
	$id_inpret=substr($id_inpret,0,-1);

	$date_format_SQL = substr($vdr,0,4).'-'.substr($vdr,4,2).'-'.substr($vdr,6,2);
	$svdr=formatdate($date_format_SQL);
	
	$date_prol   = " onClick=\"window.open('./select.php?what=calendrier";
	$date_prol  .= "&caller=prolong_bloc";
	$date_prol  .= "&date_caller=$vdr";
	$date_prol  .= "&param1=date_retbloc&param2=date_retbloc_lib&auto_submit=YES',";
	$date_prol  .= " 'date_retbloc',";
	$date_prol  .= " 'toolbar=no, dependent=yes, width=250, height=260, resizable=yes')\"";
	
	$butt_prol   = "
		<input type='button' name='date_retbloc_lib' class='bouton' value='$svdr' ".$date_prol." />
		<input type='hidden' name='categ' value='pret'>
		<input type='hidden' name='sub' value='pret_prolongation_bloc'>
		<input type='hidden' name='form_cb' value='$this->cb'>
		<input type='hidden' name='date_retbloc' value=\"\">
		<input type='hidden' name='id_bloc' value=\"\">";
	
	$this->fiche = str_replace('!!id_inpret!!'    , $id_inpret    , $this->fiche);
	if ($vdr) {
		$this->fiche = str_replace('!!prol_date!!'    , $butt_prol    , $this->fiche);
		$this->fiche = str_replace('!!bouton_cocher_prolong!!'    , "<input type='button' name='bloc_all' value='+' class='bouton' title='$msg[resa_tout_cocher]'  onClick='check_allcb(this.form)'/>", $this->fiche); 
		} else {
			$this->fiche = str_replace('!!prol_date!!'    , "", $this->fiche);
			$this->fiche = str_replace('!!bouton_cocher_prolong!!'    , "", $this->fiche);
			}
	$this->fiche = str_replace('!!pret_list!!'    , $prets_list    , $this->fiche);
	// mise  jour de la liste des rservations
	$this->fiche = str_replace('!!resa_list!!', $this->fetch_resa(), $this->fiche);

	if($pmb_resa_planning) {
		// mise  jour de la liste des rservations plannifies
		$this->fiche = str_replace('!!resa_planning_list!!', $this->fetch_resa_planning(), $this->fiche);
	} else {
		$this->fiche = str_replace('!!resa_planning_list!!', '', $this->fiche);
	}
	
}

function do_fiche_compte($typ_compte) {
	global $msg,$charset;
	global $empr_comptes_tmpl;
	global $show_transactions,$date_debut;
		
	$this->fiche_compte="";
	
	$empr_comptes_tmpl=str_replace("!!nom!!",$this->nom,$empr_comptes_tmpl);
	$empr_comptes_tmpl=str_replace("!!prenom!!",$this->prenom,$empr_comptes_tmpl);
	$empr_comptes_tmpl=str_replace("!!info_nb_pret!!",sizeof($this->prets),$empr_comptes_tmpl);
	$empr_comptes_tmpl=str_replace("!!info_nb_resa!!",$this->nb_reservations,$empr_comptes_tmpl);
	
	$id_compte=comptes::get_compte_id_from_empr($this->id,$typ_compte);
	if ($id_compte) {
		$cpte=new comptes($id_compte);
		if (!$show_transactions) $show_transactions=2;
		$empr_comptes_tmpl=str_replace("!!id_compte!!",$id_compte,$empr_comptes_tmpl);
		$empr_comptes_tmpl=str_replace("!!type_compte!!",$cpte->get_typ_compte_lib($typ_compte),$empr_comptes_tmpl);
		$empr_comptes_tmpl=str_replace("!!typ_compte!!",$typ_compte,$empr_comptes_tmpl);
		$empr_comptes_tmpl=str_replace("!!solde!!",comptes::format($cpte->get_solde()),$empr_comptes_tmpl);
		$empr_comptes_tmpl=str_replace("!!non_valide!!",comptes::format($cpte->summarize_transactions("","",0,0)),$empr_comptes_tmpl);
		$empr_comptes_tmpl=str_replace("!!show_transactions!!",$show_transactions,$empr_comptes_tmpl);
		$empr_comptes_tmpl=str_replace("!!date_debut!!",htmlentities(stripslashes($date_debut),ENT_QUOTES,$charset),$empr_comptes_tmpl);
		if (!$show_transactions) $show_transactions=1;
		for ($i=1; $i<=3; $i++) {
			if ($i==$show_transactions) 
				$empr_comptes_tmpl=str_replace("!!checked$i!!","checked",$empr_comptes_tmpl);
			else
				$empr_comptes_tmpl=str_replace("!!checked$i!!","",$empr_comptes_tmpl);
		}
	}
	$this->fiche_compte=$empr_comptes_tmpl;
}

// fabrication de la fiche lecteur pour affichage uniquement, pas de bouton, allge
function do_fiche_affichage() {

	global $empr_tmpl_fiche_affichage;
	global $msg;
	global $groupID;
	global $biblio_email;

	global $param_sounds, $alertsound ; // l'utilisateur veut-il les sons d'alerte
	
	$this->fiche_affichage = $empr_tmpl_fiche_affichage;
	$this->fiche_affichage = str_replace('!!cb!!'        , $this->cb    , $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!nom!!'    , pmb_strtoupper($this->nom)    , $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!prenom!!'    , $this->prenom    , $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!info_nb_pret!!'    , sizeof($this->prets)    , $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!info_nb_resa!!'    , $this->nb_reservations    , $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!info_authldap!!'    , $this->ldap, $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!id!!'        , $this->id    , $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!date!!'    , $this->birth    , $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!adhesion!!'    , $this->aff_date_adhesion, $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!expiration!!'    , $this->aff_date_expiration, $this->fiche_affichage);
	$this->fiche_affichage = str_replace('!!empr_statut_libelle!!'    , $this->empr_statut_libelle    , $this->fiche_affichage);
	
	if ($this->empr_msg) {
		$message_fiche_empr= "
				<hr>
				<div class='row'>
					<div class='colonne10'><img src='./images/info.png' /></div>
					<div class='colonne-suite'><span class='erreur'>$this->empr_msg</span></div>
					</div><br>";
		if ($param_sounds) $message_fiche_empr .= $alertsound[information] ;
		$this->fiche_affichage = str_replace('!!empr_msg!!'    ,$message_fiche_empr , $this->fiche_affichage);
		} else $this->fiche_affichage = str_replace('!!empr_msg!!', "", $this->fiche_affichage);
	// on distingue les messages de prts du message sur l'emprunteur
	$this->fiche_affichage = str_replace('!!pret_msg!!'    , $this->message    , $this->fiche_affichage);

	if ($this->adhesion_renouv_proche()) {
		$message_date_depassee = $msg[empr_date_renouv_proche];
		} elseif ($this->adhesion_depassee()) {
			$message_date_depassee = $msg[empr_date_depassee];
			} else {
				$message_date_depassee="";
				}
	if ($param_sounds && $message_date_depassee) $message_date_depassee .= $alertsound[critique] ;
	$this->fiche_affichage = str_replace('!!empr_date_depassee!!', $message_date_depassee, $this->fiche_affichage);

	$fsexe[0] = $msg[128];
	$fsexe[1] = $msg[126];
	$fsexe[2] = $msg[127];

	$this->fiche_affichage = str_replace('!!sexe!!'    , $fsexe[$this->sexe], $this->fiche_affichage);

	// valeur pour les champ hidden du prt. L'id empr est pris en charge plus haut 
	$this->fiche_affichage = str_replace('!!cb!!'    , $this->cb    , $this->fiche_affichage);

	// traitement liste exemplaires en prt
	$this->fiche_affichage = str_replace('!!nb_prets_encours!!'    , sizeof($this->prets)    , $this->fiche_affichage);

	if(!count($this->prets))
		// dans ce cas, le lecteur n'a rien en prt
		$prets_list = "<tr><td class='ex-strip' colspan='5'>$msg[650]</td></tr>";
	else {
		// constitution du code HTML
		$odd_even = 0 ;
		while(list($cle, $valeur) = each($this->prets)) {
			if ($valeur['pret_retard']==1){
				$tit_color="color='RED'";				
			}else{
				$tit_color="";				
			}
				
			if ($odd_even==0) {
				$pair_impair = "odd";
				$odd_even=1;
			} else if ($odd_even==1) {
					$pair_impair = "even";
					$odd_even=0;
			}
			$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='$pair_impair'\"";			
			
			$prets_list .= "
				<tr class='$pair_impair' $tr_javascript>
				<form class='form-$current_module' name=prolong".$valeur['id']." action='circ.php'>
					<td class='empr-expl'><a href='./circ.php?categ=visu_ex&form_cb_expl=".$valeur['cb']."'>
						${valeur['cb']}</a>
					</td>
					<td size='70%'>
						<font $tit_color>${valeur['libelle']}</font>
					</td>
					<td class='empr-expl'>
						${valeur['typdoc']}
					</td>
					<td class='empr-expl'>
						${valeur['date_pret']}
					</td>				
					<td>
						<center>${valeur['retour_initial']}</center>
					</td>
					<td>
						<center>${valeur['cpt_prolongation']}</center>
					</td>
					<td class='date-retour'>
						<input type='hidden' name='categ' value='pret'>
						<input type='hidden' name='sub' value='pret_prolongation'>
						<input type='hidden' name='form_cb' value='$this->cb'>
						<input type='hidden' name='cb_doc' value='${valeur['cb']}'>
						<input type='hidden' name='date_retour' value=\"\">
					";
					$date_clic   = " onClick=\"window.open('./select.php?what=calendrier";
					$date_clic  .= "&caller=prolong".$valeur['id'];
					$date_clic  .= "&date_caller=${valeur['org_ret_date']}";
					$date_clic  .= "&param1=date_retour&param2=date_retour_lib&auto_submit=YES',";
					$date_clic  .= " 'date_retour',";
					$date_clic  .= " 'toolbar=no, dependent=yes, width=250, height=260, resizable=yes')\"";
					$prets_list .= "
								<input type='button' name='date_retour_lib' class='bouton' value='${valeur['date_retour']}' ".$date_clic." />
								";
					$prets_list .="    </td>
								</form></tr>
								";
					// ouf, c'est fini ;-)
		}
	}
	$this->fiche_affichage = str_replace('!!pret_list!!'    , $prets_list    , $this->fiche_affichage);
	// mise  jour de la liste des rservations
	$this->fiche_affichage = str_replace('!!resa_list!!', $this->fetch_resa(), $this->fiche_affichage);
} // fin do_fiche_affichage


//   rcupration de la liste des rservations pour l'emprunteur
function fetch_resa() {
	return resa_list (0, 0, $this->id,"","",LECTEUR_INFO_GESTION,"") ;
	// resa_list ($idnotice=0, $idbulletin=0, $idempr=0, $order, $where = "", $info_gestion=0, $url_gestion="")
	}


//   rcupration de la liste des rservations planifies pour l'emprunteur
function fetch_resa_planning() {
	return empr_planning_list ($this->id) ;
}



// fonction de vrification que la date d'adhsion est dpasse ou pas
function adhesion_depassee() {
	global $dbh ;

	$rqt_date = "select case when empr_date_expiration < now() then 1 ELSE 0 END as test_date ";
	$rqt_date .=" from empr where id_empr='".$this->id."' ";
	$resultatdate=mysql_query($rqt_date);
	$resdate=mysql_fetch_object($resultatdate);
	return $resdate->test_date;
	}

// fonction de vrification que la date d'adhsion est proche ou pas
function adhesion_renouv_proche() {
	global $pmb_relance_adhesion ;
	global $dbh ;

	$rqt_date = "select case when (((to_days(empr_date_expiration)-to_days(now()))<=$pmb_relance_adhesion) and empr_date_expiration>=now()) then 1 ELSE 0 END as test_date ";
	$rqt_date .=" from empr where id_empr='".$this->id."' ";
	$resultatdate=mysql_query($rqt_date);
	$resdate=mysql_fetch_object($resultatdate);
	return $resdate->test_date;
	}

// fonction de suppression
function del_empr($id=0) {
	global $dbh ;

	if (is_object($this) && !$id) $id=$this->id;
	
	$rqt_prets = "select 1 from pret where pret_idempr=$id ";
	$resultat_prets=mysql_query($rqt_prets);
	$resprets=mysql_num_rows($resultat_prets);
	if (mysql_num_rows($resultat_prets)) return false;
		else {
			$rqt_del = "delete from empr_caddie_content where object_id=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "delete from empr where id_empr=$id ";
			$resultat_del=mysql_query($rqt_del);

			$p_perso=new parametres_perso("empr");
			$p_perso->delete_values($id);

			$rqt_del = "delete from empr_groupe where empr_id=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "update groupe set resp_groupe=0 where resp_groupe=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "delete from recouvrements where empr_id=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "delete from resa where resa_idempr=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "delete from resa_planning where resa_idempr=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "delete from opac_sessions where empr_id=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "update suggestions_origine set origine='', type_origine=2 where origine=$id and type_origine=1 ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "delete from bannette_abon where num_empr=$id ";
			$resultat_del=mysql_query($rqt_del);

			$rqt_del = "update avis set num_empr=0 where num_empr=$id ";
			$resultat_del=mysql_query($rqt_del);

			return true;
			}
	}

// mthode qui retourne un objet <img> avec l'url de la photo de l'emprunteur
function picture_empr($empr_cb) {
	global $empr_pics_url, $empr_pics_max_size ;
	if ($empr_pics_url) {
		$code_chiffre = pmb_preg_replace('/-|\.| /', '', $empr_cb);
		$url_image = $empr_pics_url ;
		$bidon = str_replace("!!num_carte!!", $code_chiffre, $url_image) ;
		$size = @getimagesize($bidon);
		switch ($size[2]) {
			case 1:
				$src_img = imagecreatefromgif($bidon);
			 	break;
			case 2:
				$src_img = imagecreatefromjpeg($bidon);
				break;
			case 3:
				$src_img = imagecreatefrompng($bidon);
				break;
			case 6:
				$src_img = imagecreatefromwbmp($bidon);
				break;
			default:
				break;
			}
		if ($src_img) {
			if (imagesx($src_img)>$empr_pics_max_size) $maxsize="width=100px";
				elseif ($tailley=imagesy($src_img)>$empr_pics_max_size) $maxsize="height=100px";
					else  $maxsize="";
			}
		$url_image = "./getimage.php?url_image=".urlencode($url_image) ;
		$url_image_ok = str_replace("%21%21num_carte%21%21", $code_chiffre, $url_image) ;
		$image = "<img src='".$url_image_ok."' $maxsize />";
		} else $image="" ;
	return $image;
	} 


// fabrication de la fiche lecteur
function do_fiche_consultation() {

	global $empr_tmpl_consultation, $empr_pret_allowed;
	global $msg,$charset;
	global $groupID;
	global $biblio_email;
	global $pmb_lecteurs_localises ;
	global $pmb_gestion_abonnement,$pmb_gestion_financiere, $pmb_gestion_tarif_prets, $pmb_gestion_amende;
	global $finance_blocage_abt,$finance_blocage_amende,$finance_blocage_pret,$pmb_blocage_retard,$pmb_blocage_retard_force;
	global $force_finance;
	global $pmb_resa_planning;
	global $dbh;
	global $pmb_blocage_retard,$pmb_blocage_coef,$pmb_blocage_max,$pmb_blocage_delai;
	global $empr_fiche_depliee;
	
	//global $cb_inpret;

	global $param_sounds, $alertsound ; // l'utilisateur veut-il les sons d'alerte

	$this->fiche_consultation = $empr_tmpl_consultation;	
	$this->fiche_consultation = str_replace('!!cb!!'        , $this->cb    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!nom!!'    , pmb_strtoupper($this->nom)    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!prenom!!'    , $this->prenom    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!image_caddie_empr!! ', $this->img_ajout_empr_caddie, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!info_nb_pret!!'    , sizeof($this->prets)    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!info_nb_resa!!'    , $this->nb_reservations    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!info_authldap!!'    , $this->ldap, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!id!!'        , $this->id    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!adr1!!'    , $this->adr1    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!adr2!!'    , $this->adr2    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!tel1!!'    , $this->tel1    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!tel2!!'    , $this->tel2    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!cp!!'        , $this->cp    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!ville!!'    , $this->ville    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!pays!!'    , $this->pays    , $this->fiche_consultation);
	
	$emails=array();
	$email_final=array();
	$emails = explode(';',$this->mail);
	for ($i=0;$i<count($emails);$i++) $email_final[] ="<a href='mailto:".$emails[$i]."'>".$emails[$i]."</a>";
	
	$this->fiche_consultation = str_replace('!!mail_all!!'    , implode("&nbsp;",$email_final)    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!prof!!'    , $this->prof    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!date!!'    , $this->birth    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!categ!!'    , $this->cat_l    , $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!codestat!!'    , $this->cstat_l, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!adhesion!!'    , $this->aff_date_adhesion, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!expiration!!'    , $this->aff_date_expiration, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!perso!!'    , $this->perso, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!header_format!!'    , $this->header_format, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!empr_login!!'    , $this->login, $this->fiche_consultation);
	if ($this->pwd) $this->fiche_consultation = str_replace('!!empr_pwd!!',"<i><strong>".$msg["empr_pwd_opac_affected"]."</strong</i>",$this->fiche_consultation);
		else $this->fiche_consultation = str_replace('!!empr_pwd!!',"",$this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!comptes!!'    , $this->compte, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!empr_statut_libelle!!', $this->empr_statut_libelle, $this->fiche_consultation);
	$this->fiche_consultation = str_replace('!!empr_picture!!', $this->picture_empr($this->cb), $this->fiche_consultation);
	if ($empr_fiche_depliee=="1") $this->fiche_consultation = str_replace('!!depliee!!'," startOpen=\"Yes\"", $this->fiche_consultation);
		else $this->fiche_consultation = str_replace('!!depliee!!',"", $this->fiche_consultation);
	
	if ($pmb_lecteurs_localises) $this->fiche_consultation = str_replace("<!-- !!localisation!! -->", "<div class='row'><strong>$msg[empr_location] : </strong>".$this->empr_location_l."</div>", $this->fiche_consultation);
	
	//Groupes
	if (count($this->groupes)) {
		$this->fiche_consultation = str_replace('!!groupes!!',"<strong>".$msg[groupes_empr]." : </strong>".implode(" / ",$this->groupes)."\n",$this->fiche_consultation);
		} else {
			$this->fiche_consultation = str_replace('!!groupes!!',"&nbsp;",$this->fiche_consultation);
			}
	if (($pmb_gestion_financiere)&&($pmb_gestion_abonnement==2)) {
		if ($this->type_abt) {
			$requete="select type_abt_libelle from type_abts where id_type_abt='".$this->type_abt."'";
			$resultat_type_abt=mysql_query($requete);
			if (@mysql_num_rows($resultat_type_abt)) {
				$abonnement=mysql_result($resultat_type_abt,0,0);
			}
		}
	}
	
	if ($abonnement) {
		$this->fiche_consultation = str_replace("!!abonnement!!", "<div class='row'><strong>".$msg["finance_type_abt"]." : </strong>".htmlentities($abonnement,ENT_QUOTES,$charset)."</div>\n",$this->fiche_consultation);
	} else {
		$this->fiche_consultation = str_replace("!!abonnement!!","",$this->fiche_consultation);
	}
	

	if ($this->empr_msg) {
		$message_fiche_empr= "
				<hr>
				<div class='row'>
					<div class='colonne10'><img src='./images/info.png' /></div>
					<div class='colonne-suite'><span class='erreur'>$this->empr_msg</span></div>
					</div><br>";
		$this->fiche_consultation = str_replace('!!empr_msg!!'    ,$message_fiche_empr , $this->fiche_consultation);
	} else $this->fiche_consultation = str_replace('!!empr_msg!!', "", $this->fiche_consultation);

	$fsexe[0] = $msg[128];
	$fsexe[1] = $msg[126];
	$fsexe[2] = $msg[127];
	$this->fiche_consultation = str_replace('!!sexe!!'    , $fsexe[$this->sexe], $this->fiche_consultation);

	
}

} # fin de dclaration classe emprunteur


