<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: searcher.class.php,v 1.70 2007/11/11 19:49:26 gueluneau Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

//Classe de recherche en catalogage...

require_once($class_path."/analyse_query.class.php");
require_once($class_path."/thesaurus.class.php");
require_once($class_path."/sort.class.php");

//Classe gnrique de recherche

define("AUT_LIST",1);
define("NOTICE_LIST",2);
define("AUT_SEARCH",3);

class searcher {

	var $type;                    //Type de recherche
	var $etat;                    //Etat de la recherche
	var $page;                    //Page courante de la recherche
	var $nbresults;                //Nombre de rsultats de la dernire recherche
	var $nbepage;
	var $nb_per_page;
	var $id;                    //Numro d'autorit pour la recherche
	var $store_form;            //Formulaire contenant les infos de navigation plus des champs pour la recherche
	var $base_url;
	var $first_search_result;
	var $text_query;
	var $text_query_tri; //pour les tris texte de la requte d'origine modifi par la classe tri
	var $human_query;
	var $human_notice_query;
	var $human_aut_query;
	var $direct=0;
	var $rec_history=false;

	//Constructeur
	function searcher($base_url,$rec_history=false) {
		global $type,$etat,$aut_id,$page;

		$this->type=$type;
		$this->etat=$etat;
		$this->page=$page;
		$this->id=$aut_id;
		$this->base_url=$base_url;
		$this->rec_history=$rec_history;
		$this->run();
	}

	function make_store_form() {
		$this->store_form="<form name='store_search' action='".$this->base_url."' method='post' style='display:none'>
		<input type='hidden' name='type' value='".$this->type."'/>
		<input type='hidden' name='etat' value='".$this->etat."'/>
		<input type='hidden' name='page' value='".$this->page."'/>
		";
		$this->store_form.="!!first_search_variables!!
		";
		$this->store_form.="</form>";
	}

	function pager() {
		global $msg;

		if (!$this->nbresults) return;
		
		$suivante = $this->page+1;
		$precedente = $this->page-1;
		if (!$this->page) $page_en_cours=0 ;
			else $page_en_cours=$this->page ;
				
		// affichage du lien prcdent si ncssaire
		if($precedente >= 0)
				$nav_bar .= "<a href='#' onClick=\"document.store_search.page.value=$precedente; document.store_search.submit(); return false;\"><img src='./images/left.gif' border='0'  title='$msg[48]' alt='[$msg[48]]' hspace='3' align='middle'></a>";

		$deb = $page_en_cours - 10 ;
		if ($deb<0) $deb=0;
		for($i = $deb; ($i < $this->nbepage) && ($i<$page_en_cours+10); $i++) {
			if($i==$page_en_cours) $nav_bar .= "<strong>".($i+1)."</strong>";
				else $nav_bar .= "<a href='#' onClick=\"document.store_search.page.value=$i; document.store_search.submit(); return false;\">".($i+1)."</a>";
			if($i<$this->nbepage) $nav_bar .= " "; 
			}
        
		if($suivante<$this->nbepage)
				$nav_bar .= "<a href='#' onClick=\"document.store_search.page.value=$suivante; document.store_search.submit(); return false;\"><img src='./images/right.gif' border='0' title='$msg[49]' alt='[$msg[49]]' hspace='3' align='middle'></a>";

		// affichage de la barre de navigation
		print "<div align='center'>$nav_bar</div>";
	}

	function show_notice() {
	}
	
	
	function run() {
		if (!$this->etat) {
				$this->show_form();
		} else {
				switch ($this->etat) {
					case "first_search":
						$r=$this->make_first_search();
						$this->first_search_result=$r;
						switch ($r) {
								case AUT_LIST:
									$this->make_store_form();
									$this->store_search();
									$this->aut_list();
									$this->pager();
									break;
								case NOTICE_LIST:
									$this->make_store_form();
									$this->store_search();
									$this->sort_notices();
									$this->notice_list();
									$this->pager();
									break;
								case AUT_SEARCH:
									$this->etat="aut_search";
									$this->direct=1;
									$this->make_aut_search();
									$this->make_store_form();
									$this->aut_store_search();
									$this->sort_notices();
									$this->aut_notice_list();
									$this->pager();
									break;
						}
						if ($this->rec_history)
								$this->rec_env();
						break;
					case "aut_search":
						$this->make_aut_search();
						$this->make_store_form();
						$this->aut_store_search();
						$this->sort_notices();
						$this->aut_notice_list();
						$this->pager();
						if ($this->rec_history)
								$this->rec_env();
						break;
				}
		}
	}
	

	function show_form() {
		//A surcharger par la fonction qui affiche le formulaire de recherche
	}

	function make_first_search() {
		//A surcharger par la fonction qui fait la premire recherche aprs la soumission du formulaire de recherche
		//La fonction renvoie AUT_LIST (le rsultat de la recherche est une liste d'autorit)
		//ou NOTICE_LIST (le rsultat de la recherche est une liste de notices)
		//La fonction doit mettre  jour le nombre de rsultats dans $this->nbresults
	}

	function make_aut_search() {
		//A surcharger par la fonction qui fait la recherche des notices  partir d'un numro d'autorit (stoqu dans $this->id)
		//La fonction doit mettre  jour le nombre de rsultats dans $this->nbresults
	}

	function store_search() {
		//A surcharger par la fonction qui crit les variables du formulaire "store_search" pour stoquer les champs de recherche
		//En liste de rsultat de la premire recherche. Il faut remplacer la chaine "!!first_search_variables!!" dans $this->store_form
	}

	function aut_store_search() {
		//A surcharger par la fonction qui crit les variables du formulaire "store_search" pour stoquer les champs de recherche
		//En liste de rsultat de la premire recherche. Il faut remplacer la chaine "!!first_search_variables!!" dans $this->store_form
	}

	function aut_list() {
		//A surcharger par la fonction qui affiche la liste des autorits issues de la premire recherche
	}

	function notice_list() {
		//A surcharger par la fonction qui affiche la liste des notices issues de la premire recherche
	}

	function aut_notice_list() {
		//A surcharger par la fonction qui affiche la liste des notice sous l'autorit $this->id
	}

	function rec_env() {
		//A surcharger pa la fonction qui enregistre
	}

	function convert_simple_multi() {
		//A surcharger par la fonction qui convertit des recherches simples en multi-critres
	}

	function sort_notices() {
		global $dbh;
		global $msg;
		global $pmb_nb_max_tri;
		
		if ($this->nbresults<=$pmb_nb_max_tri) {
			if ($_SESSION["tri"]) {
				$this->text_query_tri=$this->text_query;
				$this->text_query_tri = str_replace("limit ".$this->page*$this->nb_per_page.",".$this->nb_per_page,"limit 0,".$this->nbresults,$this->text_query_tri);
				$creer_table_tempo="CREATE TEMPORARY TABLE tri_tempo ENGINE=MyISAM (".$this->text_query.")";
				@mysql_query ($creer_table_tempo);
				$modif_primaire="ALTER TABLE tri_tempo PRIMARY KEY notice_id";
				@mysql_query ($modif_primaire);	
				$sort=new sort('notices');
				$sort->table_tri_tempo="tri_tempo";
				$sort->table_primary_tri_tempo="notice_id";
				if ($this->nb_per_page) {
					$sort->limit="limit ".$this->page*$this->nb_per_page.",".$this->nb_per_page;
				}
				$this->text_query_tri=$sort->appliquer_tri();
				$this->t_query=@mysql_query($this->text_query_tri,$dbh);
			
				if (!$this->t_query) {
					print mysql_error();	
				}
			} else {
				if (strpos($this->text_query,"limit")===false) {
					if ($this->nb_per_page) {
						$this->text_query .= "limit ".$this->page*$this->nb_per_page.",".$this->nb_per_page;
					}
				} else {
					if ($this->nb_per_page) {
						$this->text_query = str_replace("limit 0,".$this->nbresults,"limit ".$this->page*$this->nb_per_page.",".$this->nb_per_page,$this->text_query);
					}
				}	
				$this->t_query=@mysql_query($this->text_query,$dbh);	
			}
		} else {
			if (strpos($this->text_query,"limit")===false) {
				if ($this->nb_per_page) {
					$this->text_query .= "limit ".$this->page*$this->nb_per_page.",".$this->nb_per_page;
				}
			} else {
				if ($this->nb_per_page) {
					$this->text_query = str_replace("limit 0,".$this->nbresults,"limit ".$this->page*$this->nb_per_page.",".$this->nb_per_page,$this->text_query);
				}
			}
				
			$this->t_query=@mysql_query($this->text_query,$dbh);	
		}
	}
}

require_once($include_path."/templates/searcher_templates.tpl.php");

class searcher_title extends searcher {
	var $t_query;

	function show_form() {
		global $msg;
		global $dbh;
		global $charset,$lang;
		global $NOTICE_author_query;
		global $title_query,$all_query, $author_query,$ex_query,$typdoc_query, $statut_query;
		// on commence par crer le champs de slection de document
		// rcupration des types de documents utiliss.
		$query = "SELECT count(typdoc), typdoc ";
		$query .= "FROM notices where typdoc!='' GROUP BY typdoc";
		$result = @mysql_query($query, $dbh);
		$toprint_typdocfield .= "  <option value=''>$msg[tous_types_docs]</option>\n";
		$doctype = new marc_list('doctype');
		while ($obj = @mysql_fetch_row($result)) {
				$toprint_typdocfield .= "  <option value='$obj[1]'";
				if ($typdoc_query==$obj[1]) $toprint_typdocfield.=" selected";
				$toprint_typdocfield .=">".htmlentities($doctype->table[$obj[1]]." ($obj[0])",ENT_QUOTES, $charset)."</OPTION>\n";
		}

		// rcupration des statuts de documents utiliss.
		$query = "SELECT count(statut), id_notice_statut, gestion_libelle ";
		$query .= "FROM notices, notice_statut where id_notice_statut=statut GROUP BY id_notice_statut, gestion_libelle order by gestion_libelle";
		$result = mysql_query($query, $dbh);
		$toprint_statutfield .= "  <option value=''>$msg[tous_statuts_notice]</option>\n";
		while ($obj = @mysql_fetch_row($result)) {
				$toprint_statutfield .= "  <option value='$obj[1]'";
				if ($statut_query==$obj[1]) $toprint_statutfield.=" selected";
				$toprint_statutfield .=">".htmlentities($obj[2]."  (".$obj[0].")",ENT_QUOTES, $charset)."</OPTION>\n";
		}

		$NOTICE_author_query = str_replace("!!typdocfield!!", $toprint_typdocfield, $NOTICE_author_query);
		$NOTICE_author_query = str_replace("!!statutfield!!", $toprint_statutfield, $NOTICE_author_query);
		$NOTICE_author_query = str_replace("!!title_query!!",  htmlentities(stripslashes($title_query ),ENT_QUOTES, $charset),  $NOTICE_author_query);
		$NOTICE_author_query = str_replace("!!all_query!!", htmlentities(stripslashes($all_query),ENT_QUOTES, $charset),  $NOTICE_author_query);
		$NOTICE_author_query = str_replace("!!author_query!!", htmlentities(stripslashes($author_query),ENT_QUOTES, $charset),  $NOTICE_author_query);
		$NOTICE_author_query = str_replace("!!ex_query!!",     htmlentities(stripslashes($ex_query    ),ENT_QUOTES, $charset),  $NOTICE_author_query);
		$NOTICE_author_query = str_replace("!!base_url!!",     $this->base_url,$NOTICE_author_query);
		print pmb_bidi($NOTICE_author_query);
	}

	function make_first_search() {
		global $msg,$charset,$lang,$dbh;
		global $title_query,$all_query, $author_query,$ex_query,$typdoc_query, $statut_query, $etat;
		global $nb_per_page_a_search;
		global $class_path;

		if ($nb_per_page_a_search) $this->nb_per_page=$nb_per_page_a_search; else $this->nb_per_page=3;
		$author_per_page=10;

		if ($typdoc_query) $restrict="typdoc='".$typdoc_query."'";
		if ($statut_query) {
			if ($restrict) $restrict.=" and statut='".$statut_query."'";
				else $restrict="statut='".$statut_query."'";
			}
			
		if (!$author_query && !$all_query)
				// Recherche sur le titre uniquement :
				$aq=new analyse_query(stripslashes($title_query));
		else if ($author_query && $title_query && !$all_query) {
				// Recherche sur l'auteur et le titre :
				$aq_auth=new analyse_query(stripslashes($author_query));
				if (!$aq_auth->error) {
					$aq=new analyse_query(stripslashes($title_query));
					if (!$aq->error) {
						$members_auth=$aq_auth->get_query_members("authors","concat(author_name,', ',author_rejete)","index_author","author_id");
						$members_title=$aq->get_query_members("notices","index_wew","index_sew","notice_id",$restrict);
						$requete="select distinct notice_id,".$members_title["select"]."+".$members_auth["select"]." as pert from notices,authors,responsability where (".$members_auth["where"].") and (".$members_title["where"].") and responsability_author=author_id and responsability_notice=notice_id ";
						if ($restrict) $requete.=" and ".$restrict." ";
						$requete.=" order by pert desc, index_serie, tnvol, index_sew ";
						
						$requete_count="select count(distinct notice_id) from notices,authors,responsability where (".$members_auth["where"].") and (".$members_title["where"].") and responsability_author=author_id and responsability_notice=notice_id";
						if ($restrict) $requete_count.=" and ".$restrict." ";
						$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
						$this->nbepage=ceil($this->nbresults/$this->nb_per_page);
						$this->text_query=$requete;
						//la requete et la limitation d'enregistrements seront traites et excutes dans sort_notices
						return NOTICE_LIST;
					}
				} else $aq=$aq_auth;
		} else if (!$title_query && !$all_query) {
				// Recherche sur l'auteur uniquement :
				$aq=new analyse_query(stripslashes($author_query));
				if (!$aq->error) {
					if ($typdoc_query || $statut_query) {
						if ($typdoc_query) $restrict_suite="typdoc='".$typdoc_query."'";
						if ($statut_query) {
							if ($restrict_suite) $restrict_suite.=" and statut='".$statut_query."'";
								else $restrict_suite="statut='".$statut_query."'";
							}
						$restrict="responsability_author=author_id and responsability_notice=notice_id and ".$restrict_suite;
						$members=$aq->get_query_members("authors","concat(author_name,', ',author_rejete)","index_author","author_id");
						$requete_count="select count(distinct author_id) from authors, responsability, notices where ".$members["where"]." and ".$restrict;
						$requete="select author_id,".$members["select"]." as pert from authors, responsability, notices where ".$members["where"]." and ".$restrict." group by author_id order by pert desc,author_name, author_rejete limit ".($this->page*$author_per_page).",".$author_per_page;
					} else {
						$requete_count=$aq->get_query_count("authors","concat(author_name,', ',author_rejete)","index_author","author_id");
						$t_query=$aq->get_query_members("authors","concat(author_name,', ',author_rejete)","index_author","author_id");
						$requete="select author_id,".$t_query["select"]." as pert from authors where ".$t_query["where"]." group by author_id order by pert desc,author_name, author_rejete limit ".($this->page*$author_per_page).",".$author_per_page;
					}

					$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
					$this->t_query=@mysql_query($requete,$dbh);
					$this->nbepage=ceil($this->nbresults/$author_per_page);
					return AUT_LIST;
				}
		} else if (!$title_query && !$author_query) {
			// Recherche sur tous les champs (index global) uniquement :
			$aq=new analyse_query(stripslashes($all_query));
			if (!$aq->error) {
				if ($typdoc_query || $statut_query) {
					if ($typdoc_query) $restrict="typdoc='".$typdoc_query."'";
					if ($statut_query) {
						if ($restrict) $restrict.=" and statut='".$statut_query."'";
						else $restrict="statut='".$statut_query."'";
					}
					$restrict .= " and num_notice = notice_id";
					$aq1=new analyse_query(stripslashes($all_query));
					$members1=$aq1->get_query_members("notices","index_wew","index_sew","notice_id",$restrict);
					global $pmb_title_ponderation;
					$pert1="+".$members1["select"]."*".$pmb_title_ponderation;
					$members=$aq->get_query_members("notices_global_index","infos_global","index_infos_global","num_notice");
					$requete_count="select count(distinct num_notice) from notices_global_index, notices where ".$members["where"]." and ".$restrict;
					$requete="select num_notice as notice_id,".$members["select"]."$pert1 as pert from notices_global_index, notices where ".$members["where"]." and ".$restrict." order by pert desc, index_infos_global "; 
				} else {
					$restrict .= "num_notice = notice_id";
					$aq1=new analyse_query(stripslashes($all_query));
					$members1=$aq1->get_query_members("notices","index_wew","index_sew","notice_id",$restrict);
					global $pmb_title_ponderation;
					$pert1="+".$members1["select"]."*".$pmb_title_ponderation;
					$members=$aq->get_query_members("notices_global_index","infos_global","index_infos_global","num_notice");
					$requete_count="select count(distinct num_notice) from notices_global_index,notices where ".$members["where"]." and ".$restrict;
					$requete="select num_notice as notice_id,".$members["select"]."$pert1 as pert from notices_global_index, notices where ".$members["where"]." and ".$restrict." order by pert desc, index_infos_global "; 
				}

				$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
				//la requete et la limitation d'enregistrements seront traites et excutes dans sort_notices
				$this->nbepage=ceil($this->nbresults/$this->nb_per_page);
				$this->text_query=$requete;
				return NOTICE_LIST;
			}
		} else if(!$author_query) {
			// Recherche sur le titre et l'index global :
			$aq_all=new analyse_query(stripslashes($all_query));
			if (!$aq_all->error) {
				$aq=new analyse_query(stripslashes($title_query));
				if (!$aq->error) {
					$members_all=$aq_all->get_query_members("notices_global_index","infos_global","index_infos_global","num_notice");
					$members_title=$aq->get_query_members("notices","index_wew","index_sew","notice_id",$restrict);
					$requete="select distinct notice_id,".$members_title["select"]."+".$members_all["select"]." as pert from notices, notices_global_index where (".$members_all["where"].") and (".$members_title["where"].") and num_notice = notice_id ";
					if ($restrict) $requete.=" and ".$restrict." ";
					$requete.=" order by pert desc, index_serie, tnvol, index_sew "; 
					$requete_count="select count(distinct notice_id) from notices, notices_global_index where (".$members_all["where"].") and (".$members_title["where"].") and num_notice = notice_id";
					if ($restrict) $requete_count.=" and ".$restrict." ";
					$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
					//la requete et la limitation d'enregistrements seront traites et excutes dans sort_notices
					$this->nbepage=ceil($this->nbresults/$this->nb_per_page);
					$this->text_query=$requete;
					return NOTICE_LIST;
				}
			} else $aq=$aq_all;
		} else if (!$title_query) {
			// Recherche sur l'auteur et l'index global :
			$aq_auth=new analyse_query(stripslashes($author_query));
			if (!$aq_auth->error) {
				$aq=new analyse_query(stripslashes($all_query));
				if (!$aq->error) {
					$members_auth=$aq_auth->get_query_members("authors","concat(author_name,', ',author_rejete)","index_author","author_id");
					$members_all=$aq->get_query_members("notices_global_index","infos_global","index_infos_global","num_notice",$restrict);
					$requete="select distinct num_notice as notice_id,".$members_all["select"]."+".$members_auth["select"]." as pert from notices_global_index,authors,responsability where (".$members_auth["where"].") and (".$members_all["where"].") and responsability_author=author_id and responsability_notice=num_notice";
					if ($restrict) $requete.=" and ".$restrict." ";
					$requete.=" order by pert desc, index_infos_global "; 
					$requete_count="select count(distinct num_notice) from notices_global_index,authors,responsability where (".$members_auth["where"].") and (".$members_all["where"].") and responsability_author=author_id and responsability_notice=num_notice";
					if ($restrict) $requete_count.=" and ".$restrict." ";
					$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
					//la requete et la limitation d'enregistrements seront traites et excutes dans sort_notices
					$this->nbepage=ceil($this->nbresults/$this->nb_per_page);
					$this->text_query=$requete;
					return NOTICE_LIST;
				}
			} else $aq=$aq_auth;
		} else {
			// Recherche sur l'auteur, l'index global et le titre :
			$aq_auth=new analyse_query(stripslashes($author_query));
			if (!$aq_auth->error) {
				$aq=new analyse_query(stripslashes($all_query));
				if (!$aq->error) {
					$aq_title=new analyse_query(stripslashes($title_query));
					if (!$aq_title->error) {
						$members_auth=$aq_auth->get_query_members("authors","concat(author_name,', ',author_rejete)","index_author","author_id");
						$members_all=$aq->get_query_members("notices_global_index","infos_global","index_infos_global","num_notice");
						$members_title=$aq_title->get_query_members("notices","index_wew","index_sew","notice_id",$restrict);
						$requete="select distinct notice_id,".$members_all["select"]."+".$members_auth["select"]."+".$members_title["select"]." as pert from notices_global_index,notices,authors,responsability where (".$members_auth["where"].") and (".$members_all["where"].") and (".$members_title["where"].") and responsability_author=author_id and responsability_notice=num_notice and num_notice = notice_id";
						if ($restrict) $requete.=" and ".$restrict." ";
						$requete.=" order by pert desc, index_serie, tnvol, index_sew "; 
						$requete_count="select count(distinct notice_id) from notices_global_index,notices,authors,responsability where (".$members_auth["where"].") and (".$members_all["where"].") and (".$members_title["where"].") and responsability_author=author_id and responsability_notice=num_notice and num_notice = notice_id";
						if ($restrict) $requete_count.=" and ".$restrict." ";
						$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
						//la requete et la limitation d'enregistrements seront traites et excutes dans sort_notices
						$this->nbepage=ceil($this->nbresults/$this->nb_per_page);
						$this->text_query=$requete;
						return NOTICE_LIST;
					}
				}
			} else $aq=$aq_auth;
		}

		if ($aq->error) {
				$this->show_form();
				error_message($msg["searcher_syntax_error"],sprintf($msg["searcher_syntax_error_desc"],$aq->current_car,$aq->input_html,$aq->error_message));
		} else {
				$this->nbresults=@mysql_result(@mysql_query($aq->get_query_count("notices","index_wew","index_sew","notice_id",$restrict)),0,0);
				$requete=$aq->get_query("notices","index_wew","index_sew","notice_id",$restrict,0,$this->nbresults); //$this->page*$this->nb_per_page,$this->nb_per_page
				//la requete et la limitation d'enregistrements seront traites et excutes dans sort_notices
				$this->nbepage=ceil($this->nbresults/$this->nb_per_page);
				$this->text_query=$requete;
				return NOTICE_LIST;
		}
	}

	function make_aut_search() {
		global $msg;
		global $charset;
		global $nb_per_page_a_search;
		global $typdoc_query, $statut_query;

		if ($typdoc_query) $restrict="typdoc='".$typdoc_query."'";
		if ($statut_query) {
			if ($restrict) $restrict.=" and statut='".$statut_query."'";
				else $restrict="statut='".$statut_query."'";
			}

		if ($nb_per_page_a_search) $nb_per_page=$nb_per_page_a_search; else $nb_per_page=3;
		$requete_count="select count(distinct notice_id) from notices,responsability where notice_id=responsability_notice and responsability_author=".$this->id;
		if ($restrict) $requete_count.=" and ".$restrict." ";
		$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
		$requete="select distinct notice_id from notices,responsability where notice_id=responsability_notice and responsability_author=".$this->id;
		if ($restrict) $requete.=" and ".$restrict." ";
		$requete.=" order by index_serie, tnvol, index_sew";
		$requete .=  " limit ".($this->page*$nb_per_page).",".$nb_per_page;
		$this->t_query=@mysql_query($requete);
		$this->nbepage=ceil($this->nbresults/$nb_per_page);
		$this->text_query=$requete;
	}

	function store_search() {
		global $title_query,$all_query, $author_query,$typdoc_query, $statut_query;
		global $charset;
		$champs="<input type='hidden' name='title_query' value='".htmlentities(stripslashes($title_query),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='all_query' value='".htmlentities(stripslashes($all_query),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='author_query' value='".htmlentities(stripslashes($author_query),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='typdoc_query' value='".htmlentities(stripslashes($typdoc_query),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='statut_query' value='".htmlentities(stripslashes($statut_query),ENT_QUOTES,$charset)."'/>";
		$this->store_form=str_replace("!!first_search_variables!!",$champs,$this->store_form);
		print $this->store_form;
	}

	function aut_store_search() {
		global $typdoc_query, $statut_query;
		global $charset;
		$champs="<input type='hidden' name='aut_id' value='".htmlentities(stripslashes($this->id),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='typdoc_query' value='".htmlentities(stripslashes($typdoc_query),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='statut_query' value='".htmlentities(stripslashes($statut_query),ENT_QUOTES,$charset)."'/>";
		$this->store_form=str_replace("!!first_search_variables!!",$champs,$this->store_form);
		print $this->store_form;
	}

	function aut_list() {
		global $msg;
		global $charset;
		global $author_query;
		global $typdoc_query, $statut_query;

		$research.="<b>${msg[234]}</b>&nbsp;".htmlentities(stripslashes($author_query),ENT_QUOTES,$charset);
		$this->human_query=$research;
		$this->human_aut_query=$research;

		if ($this->nbresults) {
				$research .= " => ".$this->nbresults." ".$msg["search_resultat"];
				print pmb_bidi("<div class='othersearchinfo'>$research</div>");
				$author_list="<table>\n";
				$parity = 0 ;
				while ($author=@mysql_fetch_object($this->t_query)) {
					if ($parity % 2) {
						$pair_impair = "even";
					} else {
						$pair_impair = "odd";
					}
					$parity += 1;

					$auteur = new auteur($author->author_id);

					if($auteur->see) {
						$link = $this->base_url."&aut_id=".$auteur->id."&etat=aut_search&typdoc_query=".$typdoc_query."&statut_query=".$statut_query;
						$link_see = $this->base_url."&aut_id=".$auteur->see."&etat=aut_search&typdoc_query=".$typdoc_query."&statut_query=".$statut_query;
						$forme = $auteur->display.".&nbsp;- ".$msg["see"]."&nbsp;: <a href='$link_see' class='lien_gestion'>$auteur->see_libelle</a> ";
					} else {
						$link = $this->base_url."&aut_id=".$auteur->id."&etat=aut_search&typdoc_query=".$typdoc_query."&statut_query=".$statut_query;
						$forme = $auteur->display;
					}

					$tr_javascript=" onmouseover=\"this.className='surbrillance'\" onmouseout=\"this.className='$pair_impair'\" onmousedown=\"document.location='$link';\" ";
					$author_list .= "<tr class='$pair_impair' $tr_javascript style='cursor: pointer'><td>$forme</td></tr>";
				}
				$author_list.="</table>\n";
				print pmb_bidi($author_list);
		} else {
				$this->show_form();
				$cles="<strong>".htmlentities(stripslashes($author_query),ENT_QUOTES, $charset)."</strong>";
				error_message($msg[357], $msg[363]." ".$cles, 0, "./catalog.php?categ=search&mode=0");
		}
	}

	function notice_list_common($title) {
		global $begin_result_liste;
		global $end_result_liste;
		global $msg;
		global $charset;
		global $pmb_nb_max_tri;
		global $title_query,$author_query, $all_query;
		global $link,$link_expl,$link_explnum,$link_serial,$link_analysis,$link_bulletin,$link_explnum_serial;
		global $pmb_allow_external_search;
		
		if ($this->nbresults) {
				$research=$title;
				$research .= " => ".sprintf($msg["searcher_results"],$this->nbresults);
				print pmb_bidi("<div class='othersearchinfo'>$research</div>");
				print $begin_result_liste;
				//Affichage des liens paniers et impression
				if ($this->rec_history) {
					if (($this->etat=='first_search')&&((string)$this->page==""))
						$current=count($_SESSION["session_history"]);
					else $current=$_SESSION["CURRENT"];
					if ($current!==false) {
						print "&nbsp;<a href='#' onClick=\"w=window.open('./print_cart.php?current_print=$current&action=print_prepare','print','scrollbars=yes,width=500,height=600,menubar=0,resizable=yes'); w.focus(); return false;\"><img src='./images/basket_small_20x20.gif' border='0' align='center' alt=\"".$msg["histo_add_to_cart"]."\" title=\"".$msg["histo_add_to_cart"]."\"></a>&nbsp;<a href='#' onClick=\"w=window.open('./print.php?current_print=$current&action_print=print_prepare','print','scrollbars=yes,width=500,height=600,menubar=0'); w.focus(); return false;\"><img src='./images/print.gif' border='0' align='center' alt=\"".$msg["histo_print"]."\" title=\"".$msg["histo_print"]."\"/></a>";
						if ($pmb_allow_external_search) print "&nbsp;<a href='catalog.php?categ=search&mode=7&from_mode=0&external_type=simple'><img src='./images/external_search.png' border='0' align='center' alt=\"".$msg["connecteurs_external_search_sources"]."\" title=\"".$msg["connecteurs_external_search_sources"]."\"/></a>";
						if ($this->nbresults<=$pmb_nb_max_tri) {
							// TRIS EN COURS DE DEV Florent
							print "<a href=# onClick=\"document.getElementById('history').src='./sort.php?action=0'; document.getElementById('history').style.display='';return false;\" alt=\"".$msg['tris_dispos']."\" title=\"".$msg['tris_dispos']."\"><img src=./images/orderby_az.gif align=middle hspace=3></a>";
							if ($_SESSION["tri"]) {
								$result=mysql_query("SELECT nom_tri, tri_par_texte FROM tris WHERE id_tri='".$_SESSION["tri"]."'");
								if ($result) {
									if (mysql_num_rows($result)!=0) {
										$row=mysql_fetch_array($result);
										print $msg['tri_par']." ".$row['nom_tri']." ".$row['tri_par_texte'];
									}	
								}
								mysql_free_result($result);
							}
						}
					}
				}
				// on lance la requte
				while(($nz=@mysql_fetch_object($this->t_query))) {
					$n=@mysql_fetch_object(@mysql_query("select * from notices where notice_id=".$nz->notice_id));
					switch($n->niveau_biblio) {
						case 'm' :
							// notice de monographie
							$display = new mono_display($n, 6, $link, 1, $link_expl, '', $link_explnum,1, 0, 1, 1, "", 1);
							print $display->result;
							break ;
						case 's' :
						case 'a' :
							// on a affaire  un priodique
							$serial = new serial_display($n, 6, $link_serial, $link_analysis, $link_bulletin, "", $link_explnum_serial, 0, 0, 1, 1 );
							print $serial->result;
							break;
						case 'b' :
							// on a affaire  un bulletin
							$rqt_bull_info = "select s.notice_id as id_notice_mere, bulletin_id as id_du_bulletin, b.notice_id as id_notice_bulletin from notices as s, notices as b, bulletins where b.notice_id=$n->notice_id and s.notice_id=bulletin_notice and num_notice=b.notice_id";
							$bull_ids=@mysql_fetch_object(mysql_query($rqt_bull_info));
							$link_bulletin = './catalog.php?categ=serials&sub=bulletinage&action=view&bul_id='.$bull_ids->id_du_bulletin;
							$display = new mono_display($n, 6, $link_bulletin, 1, $link_expl, '', $link_explnum,1, 0, 1, 1, "", 1);
							print $display->result;
							break;
						}
				}
				// fin de liste
				print $end_result_liste;
		} else {
				$this->show_form();
				$cles="<strong>".$title."</strong>";
				error_message($msg[357], $msg[363]." ".$cles, 0, "./catalog.php?categ=search&mode=0");
		}
	}

	function notice_list() {
		global $msg;
		global $charset;
		global $title_query,$author_query,$all_query;

		if ($title_query) $research .= "<b>${msg[233]}</b>&nbsp;".htmlentities(stripslashes($title_query),ENT_QUOTES,$charset);
		if ($all_query && !$title_query) $research.="<b>${msg[global_search]}</b>&nbsp;".htmlentities(stripslashes($all_query),ENT_QUOTES,$charset);
		else if ($all_query && $title_query) $research.= ", <b>${msg[global_search]}</b>&nbsp;".htmlentities(stripslashes($all_query),ENT_QUOTES,$charset);
		if ($author_query) $research.=", <b>${msg[234]}</b>&nbsp;".htmlentities(stripslashes($author_query),ENT_QUOTES,$charset);

		$this->human_query=$research;
		$this->human_notice_query=$research;

		$this->notice_list_common($research);
	}

	function aut_notice_list() {
		global $msg;
		global $charset;

		$auteur = new auteur($this->id);
		$research.="<b>${msg[234]}</b>&nbsp;".$auteur->display;

		$this->human_notice_query=$research;

		$this->notice_list_common($research);
	}

	function rec_env() {
		global $msg;
		switch ($this->etat) {
				case 'first_search':
					if ((string)$this->page=="") {
						$_SESSION["CURRENT"]=count($_SESSION["session_history"]);
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["URI"]=$this->base_url;
						$_POST["etat"]="";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["HUMAN_QUERY"]=$this->human_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["HUMAN_TITLE"]=$msg["354"];
					}
					if ((string)$this->page=="") { $_POST["page"]=0; $page=0; }
					if (($this->first_search_result==AUT_LIST)&&($_SESSION["CURRENT"]!==false)) {
						$_POST["etat"]="first_search";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]["HUMAN_QUERY"]=$this->human_aut_query;
					}
					if (($this->first_search_result==NOTICE_LIST)&&($_SESSION["CURRENT"]!==false)) {
						$_POST["etat"]="first_search";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['TEXT_QUERY']=$this->text_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]["HUMAN_QUERY"]=$this->human_notice_query;
					}
					break;
				case 'aut_search':
					if ($_SESSION["CURRENT"]!==false) {
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['TEXT_QUERY']=$this->text_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['HUMAN_QUERY']=$this->human_notice_query;
					}
					break;
		}
		$_SESSION["last_required"]=false;
	}
	
	function convert_simple_multi($id_champ) {
		global $search;
		
		$x=0;
		
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["title_query"]) {
			$op_="BOOLEAN";
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["title_query"];
			
			$search[$x]="f_6";
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		$$inter="";
    			    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		} 
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["all_query"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["all_query"];
			$op_="BOOLEAN";
			
			$search[$x]="f_7";
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		$$inter="";
    			    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		}
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["author_query"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["author_query"];
			
			$op_="BOOLEAN";
			$search[$x]="f_8";
			
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		if ($x>0) {
    			$$inter="and";
    		} else {
    			$$inter="";
    		}	    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		} else {
			if ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"]) {
				$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"];
							
				$op_="EQ";
				$search[$x]="f_8";
				//oprateur
    			$op="op_".$x."_".$search[$x];
    			global $$op;
    			$$op=$op_;
    		    			
    			//contenu de la recherche
    			$field="field_".$x."_".$search[$x];
    			$field_=array();
    			$field_[0]=$valeur_champ;
    			global $$field;
    			$$field=$field_;
    	    	
    			//oprateur inter-champ
    			$inter="inter_".$x."_".$search[$x];
    			global $$inter;
    			if ($x>0) {
    				$$inter="and";
    			} else {
    				$$inter="";
    			}
    			    		
    			//variables auxiliaires
    			$fieldvar_="fieldvar_".$x."_".$search[$x];
    			global $$fieldvar_;
    			$$fieldvar_="";
    			$fieldvar=$$fieldvar_;
				$x++;
			}
		}
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["typdoc_query"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["typdoc_query"];
			$op_="EQ";
			$search[$x]="f_9";
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		if ($x>0) {
    			$$inter="and";
    		} else {
    			$$inter="";
    		}	    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		} 
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["statut_query"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["statut_query"];
			$op_="EQ";
			$search[$x]="f_10";
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		if ($x>0) {
    			$$inter="and";
    		} else {
    			$$inter="";
    		}	    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
		} 
	}
	
	function convert_simple_multi_unimarc($id_champ) {
		global $search;
		
		$x=0;
		
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["title_query"]) {
			$op_="BOOLEAN";
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["title_query"];
			
			$search[$x]="f_6";
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		$$inter="";
    			    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		} 
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["all_query"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["all_query"];
			$op_="BOOLEAN";
			
			$search[$x]="f_7";
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		$$inter="";
    			    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		}
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["author_query"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["author_query"];
			
			$op_="BOOLEAN";
			$search[$x]="f_8";
			
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		if ($x>0) {
    			$$inter="and";
    		} else {
    			$$inter="";
    		}	    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		} else {
			if ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"]) {
				$author_id=$_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"];
				$requete="select concat(author_name,', ',author_rejete) from authors where author_id=".$author_id;
				$r_author=mysql_query($requete);
				if (@mysql_num_rows($r_author)) {
					$valeur_champ=mysql_result($r_author,0,0);
				}
				$op_="BOOLEAN";
				$search[$x]="f_8";
				//oprateur
    			$op="op_".$x."_".$search[$x];
    			global $$op;
    			$$op=$op_;
    		    			
    			//contenu de la recherche
    			$field="field_".$x."_".$search[$x];
    			$field_=array();
    			$field_[0]=$valeur_champ;
    			global $$field;
    			$$field=$field_;
    	    	
    			//oprateur inter-champ
    			$inter="inter_".$x."_".$search[$x];
    			global $$inter;
    			if ($x>0) {
    				$$inter="and";
    			} else {
    				$$inter="";
    			}
    			    		
    			//variables auxiliaires
    			$fieldvar_="fieldvar_".$x."_".$search[$x];
    			global $$fieldvar_;
    			$$fieldvar_="";
    			$fieldvar=$$fieldvar_;
				$x++;
			}
		}
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["typdoc_query"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["typdoc_query"];
			$op_="EQ";
			$search[$x]="f_9";
			//oprateur
    		$op="op_".$x."_".$search[$x];
    		global $$op;
    		$$op=$op_;
    		    			
    		//contenu de la recherche
    		$field="field_".$x."_".$search[$x];
    		$field_=array();
    		$field_[0]=$valeur_champ;
    		global $$field;
    		$$field=$field_;
    	    	
    		//oprateur inter-champ
    		$inter="inter_".$x."_".$search[$x];
    		global $$inter;
    		if ($x>0) {
    			$$inter="and";
    		} else {
    			$$inter="";
    		}	    		
    		//variables auxiliaires
    		$fieldvar_="fieldvar_".$x."_".$search[$x];
    		global $$fieldvar_;
    		$$fieldvar_="";
    		$fieldvar=$$fieldvar_;
			$x++;
		} 
		//Pas de statut !
	}
}

class searcher_subject extends searcher {
	var $s_query="";
	var $i_query="";
	var $id_query="";
	var $nb_s;
	var $nb_i;
	var $nb_id;
	var $t_query;


	function show_form() {
		global $search_subject;
		global $search_indexint,$search_indexint_id;
		global $msg;
		global $charset;
		global $current_module;
		global $select3_prop,$search_form_categ,$browser;
		global $browser_url;
		global $thesaurus_mode_pmb;
		global $id_thes;

		//affichage du selectionneur de thesaurus et du lien vers les thsaurus
		$liste_thesaurus = thesaurus::getThesaurusList();
		$sel_thesaurus = '';
		$lien_thesaurus = '';
		
		if ($thesaurus_mode_pmb != 0) {	 //la liste des thesaurus n'est pas affiche en mode monothesaurus
			$sel_thesaurus = "<select class='saisie-30em' id='id_thes' name='id_thes' ";
			$sel_thesaurus.= "onchange = \"document.location = '".$this->base_url."&id_thes='+document.getElementById('id_thes').value; \">" ;
			foreach($liste_thesaurus as $id_thesaurus=>$libelle_thesaurus) {
				$sel_thesaurus.= "<option value='".$id_thesaurus."' "; ;
				if ($id_thesaurus == $id_thes) $sel_thesaurus.= " selected";
				$sel_thesaurus.= ">".htmlentities($libelle_thesaurus,ENT_QUOTES,$charset)."</option>";
			}
			$sel_thesaurus.= "<option value=-1 ";
			if ($id_thes == -1) $sel_thesaurus.= "selected ";
			$sel_thesaurus.= ">".htmlentities($msg['thes_all'],ENT_QUOTES,$charset)."</option>";
			$sel_thesaurus.= "</select>&nbsp;";
		
		}	
		$search_form_categ=str_replace("<!-- sel_thesaurus -->",$sel_thesaurus,$search_form_categ);
		
		
		//affichage du choix de langue pour la recherche
		//		$sel_langue = '';
		//		$sel_langue = "<div class='row'>";
		//		$sel_langue.= "<input type='checkbox' name='lg_search' id='lg_search' value='1' />&nbsp;".htmlentities($msg['thes_sel_langue'],ENT_QUOTES, $charset);
		//		$sel_langue.= "</div><br>";
		//		$search_form_categ=str_replace("<!-- sel_langue -->",$sel_langue,$search_form_categ);
		
	
		$search_form_categ=str_replace("!!base_url!!",$this->base_url,$search_form_categ);
		$browser=str_replace("!!browser_url!!",$browser_url,$browser);
		print pmb_bidi($search_form_categ.$browser);
	}
	

	function show_error($car,$input,$error_message) {
		global $browser_url;
		global $browser,$search_form_categ;
		global $msg;
		
		
		$search_form_categ=str_replace("!!base_url!!",$this->base_url,$search_form_categ);
		print pmb_bidi($search_form_categ);
		error_message($msg["searcher_syntax_error"],sprintf($msg["searcher_syntax_error_desc"],$car,$input,$error_message));
		$browser=str_replace("!!browser_url!!",$browser_url,$browser);
		print pmb_bidi($browser);
	}

	function make_first_search() {
		
		global $search_subject;
		global $search_indexint,$search_indexint_id,$aut_type;
		global $msg;
		global $charset;
		global $browser,$search_form_categ,$browser_url;
		global $lang;
		global $dbh;
		global $id_thes;
		global $thesaurus_mode_pmb;
		
		if ($search_indexint_id) {
				$this->id=$search_indexint_id;
				$aut_type="indexint";
				return AUT_SEARCH;
		}

		$this->nbresults=0;

		if ($search_subject) {
				$aq=new analyse_query(stripslashes($search_subject));
				if (!$aq->error) {

					$members_catdef = $aq->get_query_members("catdef", "catdef.libelle_categorie", "catdef.index_categorie", "catdef.num_noeud");
					$members_catlg = $aq->get_query_members("catlg", "catlg.libelle_categorie", "catlg.index_categorie", "catlg.num_noeud");
	
					$requete = "select distinct catdef.num_noeud as categ_id, ";
					$requete.= "if (catlg.num_noeud is null, ".$members_catdef["select"].", ".$members_catlg["select"].") as pert ";
					$requete.= "from thesaurus left join noeuds on thesaurus.id_thesaurus = noeuds.num_thesaurus ";
					$requete.= "left join categories as catdef on noeuds.id_noeud = catdef.num_noeud and catdef.langue = thesaurus.langue_defaut ";
					$requete.= "left join categories as catlg on catdef.num_noeud = catlg.num_noeud and catlg.langue = '".$lang."' ";
					$requete.= "where 1 ";
					if ($id_thes !=-1) $requete.= "and thesaurus.id_thesaurus = '".$id_thes."' ";
					$requete.= "and catdef.libelle_categorie not like '~%' ";
					$requete.= "and (if (catlg.num_noeud is null, ".$members_catdef["where"].", ".$members_catlg["where"].") ) order by pert desc,catlg.index_categorie,catdef.index_categorie";
					$this->s_query = mysql_query($requete, $dbh);
					$requete = "select count(distinct catdef.num_noeud) as nb ";
					$requete.= "from thesaurus left join noeuds on thesaurus.id_thesaurus = noeuds.num_thesaurus ";
					$requete.= "left join categories as catdef on noeuds.id_noeud = catdef.num_noeud and catdef.langue = thesaurus.langue_defaut ";
					$requete.= "left join categories as catlg on catdef.num_noeud = catlg.num_noeud and catlg.langue = '".$lang."' ";
					$requete.= "where 1 ";
					if ($id_thes !=-1) $requete.= "and thesaurus.id_thesaurus = '".$id_thes."' ";
					$requete.= "and catdef.libelle_categorie not like '~%' ";
					$requete.= "and (if (catlg.num_noeud is null, ".$members_catdef["where"].", ".$members_catlg["where"].") ) ";

					$this->nb_s = @mysql_result(@mysql_query($requete, $dbh), 0, 0);

										
				} else {
					
					$this->show_error($aq->current_car,$aq->input_html,$aq->error_message);
					return;
				}
		}

		if ($search_indexint) {
				$aq=new analyse_query(stripslashes($search_indexint));
				if (!$aq->error) {
					$this->nb_id=@mysql_result(@mysql_query("select count(distinct indexint_id) from indexint where indexint_name like '".str_replace("*","%",$search_indexint)."' order by indexint_name*1"),0,0);
					if ($this->nb_id) {
						$this->id_query=@mysql_query("select indexint_id from indexint where indexint_name like '".str_replace("*","%",$search_indexint)."' order by indexint_name*1");
						if ($this->nb_id==1) {
								$id=@mysql_fetch_object($this->id_query);
								$this->id=$id->indexint_id;
								$aut_type="indexint";
								return AUT_SEARCH;
						}
					}
					$this->nb_i=@mysql_result(@mysql_query($aq->get_query_count("indexint","indexint_comment","index_indexint","indexint_id")),0,0);
					if ($this->nb_i)
						$this->i_query=@mysql_query($aq->get_query("indexint","indexint_comment","index_indexint","indexint_id"));
				} else {
					$this->show_error($aq->current_car,$aq->input_html,$aq->error_message);
					return;
				}
		}
		
		if (($this->nb_s+$this->nb_i+$this->nb_id)==0) {
			
			
			//affichage du selectionneur de thesaurus et du lien vers les thsaurus
			$liste_thesaurus = thesaurus::getThesaurusList();
			$sel_thesaurus = '';
			$lien_thesaurus = '';
			
			if ($thesaurus_mode_pmb != 0) {	 //la liste des thesaurus n'est pas affiche en mode monothesaurus
				$sel_thesaurus = "<select class='saisie-30em' id='id_thes' name='id_thes' ";
				$sel_thesaurus.= "onchange = \"document.location = '".$this->base_url."&id_thes='+document.getElementById('id_thes').value; \">" ;
				foreach($liste_thesaurus as $id_thesaurus=>$libelle_thesaurus) {
					$sel_thesaurus.= "<option value='".$id_thesaurus."' "; ;
					if ($id_thesaurus == $id_thes) $sel_thesaurus.= " selected";
					$sel_thesaurus.= ">".htmlentities($libelle_thesaurus,ENT_QUOTES,$charset)."</option>";
				}
				$sel_thesaurus.= "<option value=-1 ";
				if ($id_thes == -1) $sel_thesaurus.= "selected ";
				$sel_thesaurus.= ">".htmlentities($msg['thes_all'],ENT_QUOTES,$charset)."</option>";
				$sel_thesaurus.= "</select>&nbsp;";
			
			}	
			$search_form_categ=str_replace("<!-- sel_thesaurus -->",$sel_thesaurus,$search_form_categ);
			
			
			//affichage du choix de langue pour la recherche
			//		$sel_langue = '';
			//		$sel_langue = "<div class='row'>";
			//		$sel_langue.= "<input type='checkbox' name='lg_search' id='lg_search' value='1' />&nbsp;".htmlentities($msg['thes_sel_langue'],ENT_QUOTES, $charset);
			//		$sel_langue.= "</div><br>";
			//		$search_form_categ=str_replace("<!-- sel_langue -->",$sel_langue,$search_form_categ);
			
			
			
			$search_form_categ=str_replace("!!base_url!!",$this->base_url,$search_form_categ);
			print pmb_bidi($search_form_categ);
			error_message($msg["searcher_no_result"],$msg["searcher_no_result_desc"]);
			$browser=str_replace("!!browser_url!!",$browser_url,$browser);
			print pmb_bidi($browser);
			return;

		}

		return AUT_LIST;
	}

	function make_aut_search() {
		global $aut_type,$nb_per_page_a_search;

		if ($nb_per_page_a_search) $nb_per_page=$nb_per_page_a_search; else $nb_per_page=3;

		switch ($aut_type) {
				case "indexint":
					$requete="select notice_id from notices where indexint=".$this->id." order by index_serie,tnvol,index_sew limit ".($this->page*$nb_per_page).",".$nb_per_page;
					$requete_count="select count(distinct notice_id) from notices where indexint=".$this->id;
					break;
				case "categ":
				$requete="select notice_id from notices, notices_categories where num_noeud=".$this->id." and notcateg_notice=notice_id  order by index_serie,tnvol,index_sew limit ".($this->page*$nb_per_page).",".$nb_per_page;
				$requete_count="select count(distinct notice_id) from notices, notices_categories where num_noeud=".$this->id." and notcateg_notice=notice_id";
					break;
		}
		$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
		$this->t_query=@mysql_query($requete);
		$this->nbepage=ceil($this->nbresults/$nb_per_page);
		$this->text_query=$requete;
	}

	function store_search() {
		global $search_subject;
		global $search_indexint,$search_indexint_id,$show_empty;
		global $charset;
		$champs="<input type='hidden' name='search_subject' value='".htmlentities(stripslashes($search_subject),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='search_indexint' value='".htmlentities(stripslashes($search_indexint),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='search_indexint_id' value='".htmlentities(stripslashes($search_indexint_id),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='show_empty' value='".$show_empty."'/>";
		$this->store_form=str_replace("!!first_search_variables!!",$champs,$this->store_form);
		print pmb_bidi($this->store_form);
	}

	function aut_store_search() {
		global $charset,$aut_type;
		$champs="<input type='hidden' name='aut_id' value='".htmlentities(stripslashes($this->id),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='aut_type' value='".htmlentities(stripslashes($aut_type),ENT_QUOTES,$charset)."'/>";
		$this->store_form=str_replace("!!first_search_variables!!",$champs,$this->store_form);
		print pmb_bidi($this->store_form);
	}

	function aut_list() {
		global $search_subject;
		global $search_indexint,$search_indexint_id;
		global $msg;
		global $charset;
		global $show_empty;

		if ($search_subject) $human[]="<b>".$msg["histo_subject"]."</b> ".htmlentities(stripslashes($search_subject),ENT_QUOTES,$charset);
		if ($search_indexint) $human[]="<b>".$msg["histo_indexint"]."</b> ".htmlentities(stripslashes($search_indexint),ENT_QUOTES,$charset);
		$this->human_query=implode(", ",$human);
		$this->human_aut_query=implode(", ",$human);
		if ($this->nb_s) {
				$empty=false;
				print "<strong>${msg[23]} : ".sprintf($msg["searcher_results"],$this->nb_s)."</strong><hr><ul>";
				while($categ=@mysql_fetch_object($this->s_query)) {
					$temp = new category($categ->categ_id);
					if($temp->voir_id) {
						$cr=$temp->catalog_form;
						$temp = new category($temp->voir_id);
						$display = htmlentities($cr,ENT_QUOTES,$charset)." -> <i>".htmlentities($temp->catalog_form,ENT_QUOTES,$charset)."@</i>";
					} else {
								$display = htmlentities($temp->catalog_form,ENT_QUOTES,$charset);
					}
					if($temp->has_notices())
						$link_categ = "<a href='".$this->base_url."&aut_id=".$temp->id."&aut_type=categ&etat=aut_search'>$display</a>";
					else {
						$empty=true;
						if ($show_empty) $link_categ = $display; else $link_categ="";
					}
					if ($link_categ)
						print "<li>$link_categ</li>";
				}
				if (($empty)&&(!$show_empty)) print "<li><a href='#' onClick=\"document.store_search.show_empty.value=1; document.store_search.page.value=0; document.store_search.submit(); return false;\">".$msg["searcher_categ_empty_results"]."</a></li>";
				print "</ul>";
		}
		if (($this->nb_i)||($this->nb_id)) {
				if ($this->nb_id) {
					print "<br><strong>${msg[indexint_catal_title]} ".$msg["searcher_exact_indexint"].": ".sprintf($msg["searcher_results"],$this->nb_id)."</strong><hr><ul>";
					$id_=array();
					$empty=false;
					while($indexint=@mysql_fetch_object($this->id_query)) {
						$id_[$indexint->indexint_id]=1;
						$temp = new indexint($indexint->indexint_id);
						$display = htmlentities($temp->name." - ".$temp->comment,ENT_QUOTES,$charset);
						if($temp->has_notices())
								$link = "<a href='".$this->base_url."&aut_id=".$temp->indexint_id."&aut_type=indexint&etat=aut_search'>$display</a>";
						else {
								$empty=true;
								if ($show_empty) $link = $display; else $link="";
						}
						if ($link)
								print "<li>$link</li>";
					}
					if (($empty)&&(!$show_empty)) print "<li><a href='#' onClick=\"document.store_search.show_empty.value=1; document.store_search.page.value=0; document.store_search.submit(); return false;\">".$msg["searcher_indexint_empty_results"]."</a></li>";
					print "</ul>";
				}
				$i_="";
				if ($this->nb_i) {
					$empty=false;
					while($indexint=@mysql_fetch_object($this->i_query)) {
						if (!$id_[$indexint->indexint_id]) {
								$temp = new indexint($indexint->indexint_id);
								$display = htmlentities($temp->name." - ".$temp->comment,ENT_QUOTES,$charset);
								if($temp->has_notices())
									$link = "<a href='".$this->base_url."&aut_id=".$temp->indexint_id."&aut_type=indexint&etat=aut_search'>$display</a>";
								else {
									$empty=true;
									if ($show_empty) $link = $display; else $link="";
								}
								if ($link)
									$i_.="<li>$link</li>";
						} else $this->nb_i--;
					}
					$i_="<br><strong>${msg[indexint_catal_title]} ".$msg["searcher_descr_indexint"]." : ".sprintf($msg["searcher_results"],$this->nb_i)."</strong><hr><ul>".$i_;
					if (($empty)&&(!$show_empty)) $i_.="<li><a href='#' onClick=\"document.store_search.show_empty.value=1; document.store_search.page.value=0; document.store_search.submit(); return false;\">".$msg["searcher_indexint_empty_results"]."</a></li>";
					$i_.="</ul>";
					print $i_;
				}
		}
	}

	function notice_list_common($title) {
		global $begin_result_liste;
		global $end_result_liste;
		global $msg;
		global $charset;
		global $pmb_nb_max_tri;
		global $link,$link_expl,$link_explnum,$link_serial,$link_analysis,$link_bulletin,$link_explnum_serial;
		global $pmb_allow_external_search;
		
		$research=$title;
		$research .= " => ".sprintf($msg["searcher_results"],$this->nbresults);
		print "<div class='othersearchinfo'>$research</div>";
		print $begin_result_liste;
		//Affichage des liens paniers et impression
		if ($this->rec_history) {
				if ((($this->etat=='first_search')&&((string)$this->page==""))||($this->direct))
					$current=count($_SESSION["session_history"]);
				else $current=$_SESSION["CURRENT"];
				if ($current!==false) {
					print "&nbsp;<a href='#' onClick=\"w=window.open('./print_cart.php?current_print=$current&action=print_prepare','print','scrollbars=yes,width=500,height=600,menubar=0,resizable=yes'); w.focus(); return false;\"><img src='./images/basket_small_20x20.gif' border='0' align='center' alt=\"".$msg["histo_add_to_cart"]."\" title=\"".$msg["histo_add_to_cart"]."\"></a>&nbsp;<a href='#' onClick=\"w=window.open('./print.php?current_print=$current&action_print=print_prepare','print','scrollbars=yes,width=500,height=600,menubar=0'); w.focus(); return false;\"><img src='./images/print.gif' border='0' align='center' alt=\"".$msg["histo_print"]."\" title=\"".$msg["histo_print"]."\"></a>";
					if ($pmb_allow_external_search) print "&nbsp;<a href='catalog.php?categ=search&mode=7&from_mode=1&external_type=simple'><img src='./images/external_search.png' border='0' align='center' alt=\"".$msg["connecteurs_external_search_sources"]."\" title=\"".$msg["connecteurs_external_search_sources"]."\"/></a>";
					// TRIS EN COURS DE DEV Florent
					if ($this->nbresults<=$pmb_nb_max_tri) {
						print "<a href=# onClick=\"document.getElementById('history').src='./sort.php?action=0'; document.getElementById('history').style.display='';return false;\" alt=\"".$msg['tris_dispos']."\" title=\"".$msg['tris_dispos']."\"><img src=./images/orderby_az.gif align=middle hspace=3></a>";
						$result=mysql_query("SELECT nom_tri FROM tris WHERE id_tri='".$_SESSION["tri"]."'");
						if ($_SESSION["tri"]) {
							$result=mysql_query("SELECT nom_tri, tri_par_texte FROM tris WHERE id_tri='".$_SESSION["tri"]."'");
							if ($result) {
								if (mysql_num_rows($result)!=0) {
									$row=mysql_fetch_array($result);
									print $msg['tri_par']." ".$row['nom_tri']." ".$row['tri_par_texte'];
								}	
							}
							mysql_free_result($result);
						}
					}
				}
		}
		
		// on lance la requte
		while(($nz=@mysql_fetch_object($this->t_query))) {
				$n=@mysql_fetch_object(@mysql_query("select * from notices where notice_id=".$nz->notice_id));
				if($n->niveau_biblio != 's' && $n->niveau_biblio != 'a') {
					// notice de monographie
					$display = new mono_display($n, 6, $link, 1, $link_expl, '', $link_explnum,1, 0, 1, 1, "",1);
					print pmb_bidi($display->result);
				} else {
					// on a affaire  un priodique
					$serial = new serial_display($n, 6, $link_serial, $link_analysis, $link_bulletin, "", $link_explnum_serial, 0, 0, 1, 1 );
					print pmb_bidi($serial->result);
				}
		}
		// fin de liste
		print $end_result_liste;
	}

	function aut_notice_list() {
		global $msg;
		global $charset;
		global $aut_type;
		global $search_subject,$search_indexint;

		if ($this->direct) {
				if ($search_subject) $human[]="<b>".$msg["histo_subject"]."</b> ".htmlentities(stripslashes($search_subject),ENT_QUOTES,$charset);
				if ($search_indexint) $human[]="<b>".$msg["histo_indexint"]."</b> ".htmlentities(stripslashes($search_indexint),ENT_QUOTES,$charset);
				$this->human_query=implode(", ",$human);
				$this->human_aut_query=implode(", ",$human);
		}
		switch ($aut_type) {
				case "indexint":
					$temp = new indexint($this->id);
					$display = "<b>".$msg["searcher_indexint"]."</b>&nbsp;".htmlentities($temp->name." - ".$temp->comment,ENT_QUOTES,$charset);
					$this->human_notice_query=$display;
					break;
				case "categ":
					$display = "<b>".$msg["searcher_categ"]."</b>&nbsp;";
					$temp = new category($this->id);
					if($temp->voir_id) {
						$cr=$temp->catalog_form;
						$temp = new category($temp->voir_id);
						$display.=htmlentities($cr,ENT_QUOTES,$charset)." -> <i>".htmlentities($temp->catalog_form,ENT_QUOTES,$charset)."@</i>";
					} else {
								$display.=htmlentities($temp->catalog_form,ENT_QUOTES,$charset);
					}
					$this->human_notice_query=$display;
					break;
		}
		$this->notice_list_common($display);
	}

	function rec_env() {
		global $msg;
		switch ($this->etat) {
				case 'first_search':
					if ((string)$this->page=="") {
						$_SESSION["CURRENT"]=count($_SESSION["session_history"]);
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["URI"]=$this->base_url;
						$_POST["etat"]="";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["HUMAN_QUERY"]=$this->human_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["HUMAN_TITLE"]=$msg["355"];
					}
					if ((string)$this->page=="") { $_POST["page"]=0; $page=0; }
					if (($this->first_search_result==AUT_LIST)&&($_SESSION["CURRENT"]!==false)) {
						$_POST["etat"]="first_search";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]["HUMAN_QUERY"]=$this->human_aut_query;
					}
					if (($this->first_search_result==NOTICE_LIST)&&($_SESSION["CURRENT"]!==false)) {
						$_POST["etat"]="first_search";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['TEXT_QUERY']=$this->text_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]["HUMAN_QUERY"]=$this->human_notice_query;
					}
					break;
				case 'aut_search':
					if ($this->direct) {
						$_SESSION["CURRENT"]=count($_SESSION["session_history"]);
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["URI"]=$this->base_url;
					//	$_POST["etat"]="";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["HUMAN_QUERY"]=$this->human_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["HUMAN_TITLE"]=$msg["335"];
					}
					if ((string)$this->page=="") { $_POST["page"]=0; $page=0; }
					if ($_SESSION["CURRENT"]!==false) {
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['TEXT_QUERY']=$this->text_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['HUMAN_QUERY']=$this->human_notice_query;
					}
					
					break;
		}
		$_SESSION["last_required"]=false;
	}
	
	function convert_simple_multi($id_champ) {
		global $search;
		
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint_id"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint_id"];
			$op_="EQ";
			$search[0]="f_2";
		} elseif ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint"];
			$op_="EXACT";	
			$search[0]="f_2";
		} elseif ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_subject"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_subject"];
			$op_="EQ";
			$search[0]="f_1";
		} elseif ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"]) {
			switch ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_type"]) {
				case "indexint":
					$search[0]="f_2";
					break;
				case "categ":
					$search[0]="f_1";
					break;
			}
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"];
			$op_="EQ";	
		}
		
		//oprateur
    	$op="op_0_".$search[0];
    	global $$op;
    	$$op=$op_;
    		    			
    	//contenu de la recherche
    	$field="field_0_".$search[0];
    	$field_=array();
    	$field_[0]=$valeur_champ;
    	global $$field;
    	$$field=$field_;
    	    	
    	//oprateur inter-champ
    	$inter="inter_0_".$search[0];
    	global $$inter;
    	$$inter="";
    			    		
    	//variables auxiliaires
    	$fieldvar_="fieldvar_0_".$search[0];
    	global $$fieldvar_;
    	$$fieldvar_="";
    	$fieldvar=$$fieldvar_;
	}
	
	function convert_simple_multi_unimarc($id_champ) {
		global $search;
		
		if ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint_id"]) {
			$indexint_id=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint_id"];
			//Recherche de l'indexation
			$requete="select indexint_name from indexint where indexint_id=".$indexint_id;
			$r_indexint=mysql_query($requete);
			if (@mysql_num_rows($r_indexint)) {
				$valeur_champ=mysql_result($r_indexint,0,0);
			}
			$op_="BOOLEAN";
			$search[0]="f_2";
		} elseif ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_indexint"];
			$op_="BOOLEAN";	
			$search[0]="f_2";
		} elseif ($_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_subject"]) {
			$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["POST"]["search_subject"];
			$op_="BOOLEAN";
			$search[0]="f_1";
		} elseif ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"]) {
			switch ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_type"]) {
				case "indexint":
					$search[0]="f_2";
					//Recherche de l'indexation
					$indexint_id=$_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"];
					$requete="select indexint_name from indexint where indexint_id=".$indexint_id;
					$r_indexint=mysql_query($requete);
					if (@mysql_num_rows($r_indexint)) {
						$valeur_champ=mysql_result($r_indexint,0,0);
					}
					break;
				case "categ":
					$search[0]="f_1";
					//Recherche de la catgorie
					$categ_id=$_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"];
					$requete="select libelle_categorie from categories where num_noeud=".$categ_id;
					$r_cat=mysql_query($requete);
					if (@mysql_num_rows($r_cat)) {
						$valeur_champ=mysql_result($r_cat,0,0);
					}
					break;
			}
			$op_="BOOLEAN";	
		}
		
		//oprateur
    	$op="op_0_".$search[0];
    	global $$op;
    	$$op=$op_;
    		    			
    	//contenu de la recherche
    	$field="field_0_".$search[0];
    	$field_=array();
    	$field_[0]=$valeur_champ;
    	global $$field;
    	$$field=$field_;
    	    	
    	//oprateur inter-champ
    	$inter="inter_0_".$search[0];
    	global $$inter;
    	$$inter="";
    			    		
    	//variables auxiliaires
    	$fieldvar_="fieldvar_0_".$search[0];
    	global $$fieldvar_;
    	$$fieldvar_="";
    	$fieldvar=$$fieldvar_;
	}
}

class searcher_publisher extends searcher {
	var $p_query;
	var $c_query;
	var $s_query;
	var $nb_p;
	var $nb_c;
	var $nb_s;
	var $t_query;

	function show_form() {
		global $search_form_editeur,$browser_editeur,$browser_url;

		$search_form_editeur=str_replace("!!base_url!!",$this->base_url,$search_form_editeur);
		$browser_editeur=str_replace("!!browser_url!!",$browser_url,$browser_editeur);
		print $search_form_editeur.$browser_editeur;
	}

	function show_error($car,$input,$error_message) {
		global $browser_url;
		global $browser,$search_form_editeur;
		global $msg;
		$search_form_editeur=str_replace("!!base_url!!",$this->base_url,$search_form_editeur);
		print $search_form_editeur;
		error_message($msg["searcher_syntax_error"],sprintf($msg["searcher_syntax_error_desc"],$car,$input,$error_message));
		$browser=str_replace("!!browser_url!!",$browser_url,$browser);
		print $browser;
	}

	function make_first_search() {
		global $search_ed;
		global $msg,$charset;
		global $browser,$browser_url,$search_form_editeur;

		$aq=new analyse_query(stripslashes($search_ed));
		if (!$aq->error) {
				$this->nbresults=0;

				//Recherche dans les diteurs
				$rq_p_c=$aq->get_query_count("publishers","ed_name","index_publisher","ed_id");
				$this->nb_p=@mysql_result(@mysql_query($rq_p_c),0,0);
				if ($this->nb_p) {
					$rq_p=$aq->get_query("publishers","ed_name","index_publisher","ed_id");
					$this->p_query=@mysql_query($rq_p);
				}
				//Recherche des collections
				$rq_c_c=$aq->get_query_count("collections","collection_name","index_coll","collection_id");
				$this->nb_c=@mysql_result(@mysql_query($rq_c_c),0,0);
				if ($this->nb_c) {
					$rq_c=$aq->get_query("collections","collection_name","index_coll","collection_id");
					$this->c_query=@mysql_query($rq_c);
				}
				//Recherche des sous collections
				$rq_s_c=$aq->get_query_count("sub_collections","sub_coll_name","index_sub_coll","sub_coll_id");
				$this->nb_s=@mysql_result(@mysql_query($rq_s_c),0,0);
				if ($this->nb_s) {
					$rq_s=$aq->get_query("sub_collections","sub_coll_name","index_sub_coll","sub_coll_id");
					$this->s_query=@mysql_query($rq_s);
				}
				if (($this->nb_p+$this->nb_c+$this->nb_s)==0) {
					$search_form_editeur=str_replace("!!base_url!!",$this->base_url,$search_form_editeur);
					print $search_form_editeur;
					error_message($msg["searcher_no_result"],$msg["searcher_no_result_desc"]);
					$browser=str_replace("!!browser_url!!",$browser_url,$browser);
					print $browser;
					return;
				} else return AUT_LIST;
		} else {
				$this->show_error($aq->current_car,$aq->input_html,$aq->error_message);
		}
	}

	function make_aut_search() {
		global $aut_type,$mag,$charset,$nb_per_page_a_search;

		if ($nb_per_page_a_search) $nb_per_page=$nb_per_page_a_search; else $nb_per_page=3;

		switch ($aut_type) {
				case "publisher":
					$requete_count="select count(distinct notice_id) from notices where ed1_id='".$this->id."' or ed2_id='".$this->id."'";
					$requete="select distinct notice_id from notices where ed1_id='".$this->id."' or ed2_id='".$this->id."' order by index_serie,tnvol,index_sew limit ".($this->page*$nb_per_page).",".$nb_per_page;
					break;
				case "collection":
					$requete_count="select count(distinct notice_id) from notices where coll_id='".$this->id."'";
					$requete="select distinct notice_id from notices where coll_id='".$this->id."' order by index_serie,tnvol,index_sew limit ".($this->page*$nb_per_page).",".$nb_per_page;
					break;
				case "subcoll":
					$requete_count="select count(distinct notice_id) from notices where subcoll_id='".$this->id."'";
					$requete="select distinct notice_id from notices where subcoll_id='".$this->id."' order by index_serie,tnvol,index_sew limit ".($this->page*$nb_per_page).",".$nb_per_page;
					break;
		}
		$this->nbresults=@mysql_result(@mysql_query($requete_count),0,0);
		$this->t_query=@mysql_query($requete);
		$this->nbepage=ceil($this->nbresults/$nb_per_page);
		$this->text_query=$requete;
	}

	function store_search() {
		global $search_ed;
		global $show_empty;
		global $charset;
		$champs="<input type='hidden' name='search_ed' value='".htmlentities(stripslashes($search_ed),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='show_empty' value='".$show_empty."'/>";
		$this->store_form=str_replace("!!first_search_variables!!",$champs,$this->store_form);
		print $this->store_form;
	}

	function aut_store_search() {
		global $charset,$aut_type;
		$champs="<input type='hidden' name='aut_id' value='".htmlentities(stripslashes($this->id),ENT_QUOTES,$charset)."'/>";
		$champs.="<input type='hidden' name='aut_type' value='".htmlentities(stripslashes($aut_type),ENT_QUOTES,$charset)."'/>";
		$this->store_form=str_replace("!!first_search_variables!!",$champs,$this->store_form);
		print $this->store_form;
	}

	function aut_list() {
		global $msg,$charset;
		global $search_ed;

		$this->human_query="<b>".$msg["356"]." </b> ".htmlentities(stripslashes($search_ed),ENT_QUOTES,$charset);
		$this->human_aut_query=$this->human_query;

		if ($this->nb_p) {
				print "<strong>".$msg["searcher_publisher"]." : ".sprintf($msg["searcher_results"],$this->nb_p)."</strong><hr><ul>";
				while ($p=@mysql_fetch_object($this->p_query)) {
					$temp=new editeur($p->ed_id);
					print "<li><a href='".$this->base_url."&etat=aut_search&aut_type=publisher&aut_id=".$p->ed_id."'>".htmlentities($temp->display,ENT_QUOTES,$charset)."</a>";
					if($temp->web) {
						print "&nbsp;<a href=\"".$temp->web."\" target=\"_web\">";
						print "<img src=\"./images/globe.gif\" border=\"0\" align=\"top\"></a>";
					}
					print "</li>\n";
				}
				print "</ul>\n";
		}
		if ($this->nb_c) {
				print "<strong>".$msg["searcher_coll"]." : ".sprintf($msg["searcher_results"],$this->nb_c)."</strong><hr><ul>";
				while ($c=@mysql_fetch_object($this->c_query)) {
					$temp=new collection($c->collection_id);
					print "<li><a href='".$this->base_url."&etat=aut_search&aut_type=collection&aut_id=".$c->collection_id."'>".htmlentities($temp->display,ENT_QUOTES,$charset)."</a></li>\n";
				}
				print "</ul>\n";
		}
		if ($this->nb_s) {
				print "<strong>".$msg["searcher_subcoll"]." : ".sprintf($msg["searcher_results"],$this->nb_p)."</strong><hr><ul>";
				while ($s=@mysql_fetch_object($this->s_query)) {
					$temp=new subcollection($s->sub_coll_id);
					print "<li><a href='".$this->base_url."&etat=aut_search&aut_type=subcoll&aut_id=".$s->sub_coll_id."'>".$temp->display."</a></li>\n";
				}
				print "</ul>\n";
		}
	}

	function notice_list_common($title) {
		global $begin_result_liste;
		global $end_result_liste;
		global $msg;
		global $charset;
		global $pmb_nb_max_tri;
		global $link,$link_expl,$link_explnum,$link_serial,$link_analysis,$link_bulletin,$link_explnum_serial;
		global $pmb_allow_external_search;
		
		$research=$title;
		$research .= " => ".sprintf($msg["searcher_results"],$this->nbresults);
		print "<div class='othersearchinfo'>$research</div>";
		print $begin_result_liste;
		//Affichage des liens paniers et impression
		if ($this->rec_history) {
			$current=$_SESSION["CURRENT"];
			if ($current!==false) {
				print "&nbsp;<a href='#' onClick=\"w=window.open('./print_cart.php?current_print=$current&action=print_prepare','print','scrollbars=yes,width=500,height=600,menubar=0,resizable=yes'); w.focus(); return false;\"><img src='./images/basket_small_20x20.gif' border='0' align='center' alt=\"".$msg["histo_add_to_cart"]."\" title=\"".$msg["histo_add_to_cart"]."\"></a>&nbsp;<a href='#' onClick=\"w=window.open('./print.php?current_print=$current&action_print=print_prepare','print','scrollbars=yes,width=500,height=600,menubar=0'); w.focus(); return false;\"><img src='./images/print.gif' border='0' align='center' alt=\"".$msg["histo_print"]."\" title=\"".$msg["histo_print"]."\"/></a>";
				if ($pmb_allow_external_search) print "&nbsp;<a href='catalog.php?categ=search&mode=7&from_mode=3&external_type=simple'><img src='./images/external_search.png' border='0' align='center' alt=\"".$msg["connecteurs_external_search_sources"]."\" title=\"".$msg["connecteurs_external_search_sources"]."\"/></a>";
				// TRIS EN COURS DE DEV Florent
				if ($this->nbresults<=$pmb_nb_max_tri) {
					print "<a href=# onClick=\"document.getElementById('history').src='./sort.php?action=0'; document.getElementById('history').style.display='';return false;\" alt=\"".$msg['tris_dispos']."\" title=\"".$msg['tris_dispos']."\"><img src=./images/orderby_az.gif align=middle hspace=3></a>";
					$result=mysql_query("SELECT nom_tri FROM tris WHERE id_tri='".$_SESSION['tri']."'");
					if ($_SESSION["tri"]) {
						$result=mysql_query("SELECT nom_tri, tri_par_texte FROM tris WHERE id_tri='".$_SESSION["tri"]."'");
						if ($result) {
							if (mysql_num_rows($result)!=0) {
								$row=mysql_fetch_array($result);
								print $msg['tri_par']." ".$row['nom_tri']." ".$row['tri_par_texte'];
							}	
						}
						mysql_free_result($result);
					}
				}
			}
		}
		// on lance la requte
		while(($nz=@mysql_fetch_object($this->t_query))) {
				$n=@mysql_fetch_object(@mysql_query("select * from notices where notice_id=".$nz->notice_id));
				if($n->niveau_biblio != 's' && $n->niveau_biblio != 'a') {
					// notice de monographie
					$display = new mono_display($n, 6, $link, 1, $link_expl, '', $link_explnum,1,0,1,1,"",1);
					print pmb_bidi($display->result);
				} else {
					// on a affaire  un priodique
					$serial = new serial_display($n, 6, $link_serial, $link_analysis, $link_bulletin, "", $link_explnum_serial, 0,0,1,1 );
					print pmb_bidi($serial->result);
				}
		}
		// fin de liste
		print $end_result_liste;
	}

	function aut_notice_list() {
		global $msg;
		global $charset;
		global $aut_type;

		switch ($aut_type) {
				case "publisher":
					$temp = new editeur($this->id);
					$display = "<b>".$msg["searcher_publisher"]."</b>&nbsp;".htmlentities($temp->display,ENT_QUOTES,$charset);
					$this->human_notice_query=$display;
					break;
				case "collection":
					$display = "<b>".$msg["searcher_coll"]."</b>&nbsp;";
					$temp = new collection($this->id);
					$display.= htmlentities($temp->display,ENT_QUOTES,$charset);
					$this->human_notice_query=$display;
					break;
				case "subcoll":
					$display = "<b>".$msg["searcher_subcoll"]."</b>&nbsp;";
					$temp = new subcollection($this->id);
					$display.=$temp->display;
					$this->human_notice_query=$display;
					break;
		}
		$this->notice_list_common($display);
	}

	function rec_env() {
		global $msg;
		switch ($this->etat) {
				case 'first_search':
					if ((string)$this->page=="") {
						$_SESSION["CURRENT"]=count($_SESSION["session_history"]);
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["URI"]=$this->base_url;
						$_POST["etat"]="";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]=array();
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["HUMAN_QUERY"]=$this->human_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["QUERY"]["HUMAN_TITLE"]=$msg["356"];
					}
					if ((string)$this->page=="") { $_POST["page"]=0; $page=0; }
					if (($this->first_search_result==AUT_LIST)&&($_SESSION["CURRENT"]!==false)) {
						$_POST["etat"]="first_search";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["AUT"]["HUMAN_QUERY"]=$this->human_aut_query;
					}
					if (($this->first_search_result==NOTICE_LIST)&&($_SESSION["CURRENT"]!==false)) {
						$_POST["etat"]="first_search";
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['TEXT_QUERY']=$this->text_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]["HUMAN_QUERY"]=$this->human_notice_query;
					}
					break;
				case 'aut_search':
					if ($_SESSION["CURRENT"]!==false) {
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['URI']=$this->base_url;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['POST']=$_POST;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['GET']=$_GET;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['PAGE']=$this->page+1;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['TEXT_QUERY']=$this->text_query;
						$_SESSION["session_history"][$_SESSION["CURRENT"]]["NOTI"]['HUMAN_QUERY']=$this->human_notice_query;
					}
					break;
		}
		$_SESSION["last_required"]=false;
	}
	
	function convert_simple_multi($id_champ) {
		global $search;
		
		$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"];
		$op_="EQ";
		
		switch ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_type"]) {
			case "publisher":
				$search[0]="f_3";
			break;
			case "collection":
				$search[0]="f_4";
			break;
			case "subcoll":
				$search[0]="f_5";
			break;
		}	
				
		//oprateur
    	$op="op_0_".$search[0];
    	global $$op;
    	$$op=$op_;
    		    			
    	//contenu de la recherche
    	$field="field_0_".$search[0];
    	$field_=array();
    	$field_[0]=$valeur_champ;
    	global $$field;
    	$$field=$field_;
    	    	
    	//oprateur inter-champ
    	$inter="inter_0_".$search[0];
    	global $$inter;
    	$$inter="";
    			    		
    	//variables auxiliaires
    	$fieldvar_="fieldvar_0_".$search[0];
    	global $$fieldvar_;
    	$$fieldvar_="";
    	$fieldvar=$$fieldvar_;
	}
	
	function convert_simple_multi_unimarc($id_champ) {
		global $search;
		
		$valeur_champ=$_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_id"];
		$op_="BOOLEAN";
		
		switch ($_SESSION["session_history"][$id_champ]["NOTI"]["GET"]["aut_type"]) {
			case "publisher":
				$search[0]="f_3";
				//Recherche de l'diteur
				$publisher_id=$valeur_champ;
				$requete="select ed_name from publishers where ed_id=".$publisher_id;
				$r_pub=mysql_query($requete);
				if (@mysql_num_rows($r_pub)) {
					$valeur_champ=mysql_result($r_pub,0,0);
				}
			break;
			case "collection":
				$search[0]="f_4";
				//Recherche de l'indexation
				$coll_id=$valeur_champ;
				$requete="select collection_name from collections where collection_id=".$coll_id;
				$r_coll=mysql_query($requete);
				if (@mysql_num_rows($r_coll)) {
					$valeur_champ=mysql_result($r_coll,0,0);
				}
			break;
			case "subcoll":
				$search[0]="f_5";
				//Recherche de la sous-collection
				$subcoll_id=$valeur_champ;
				$requete="select sub_coll_name from sub_collections where sub_coll_id=".$subcoll_id;
				$r_subcoll=mysql_query($requete);
				if (@mysql_num_rows($r_subcoll)) {
					$valeur_champ=mysql_result($r_subcoll,0,0);
				}
			break;
		}	
				
		//oprateur
    	$op="op_0_".$search[0];
    	global $$op;
    	$$op=$op_;
    		    			
    	//contenu de la recherche
    	$field="field_0_".$search[0];
    	$field_=array();
    	$field_[0]=$valeur_champ;
    	global $$field;
    	$$field=$field_;
    	    	
    	//oprateur inter-champ
    	$inter="inter_0_".$search[0];
    	global $$inter;
    	$$inter="";
    			    		
    	//variables auxiliaires
    	$fieldvar_="fieldvar_0_".$search[0];
    	global $$fieldvar_;
    	$$fieldvar_="";
    	$fieldvar=$$fieldvar_;
	}
}
?>