<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: serial_display.class.php,v 1.68 2007/09/17 15:29:55 jlesaint Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once($class_path."/parametres_perso.class.php");
require_once($class_path."/marc_table.class.php");

// rcupration des codes de fonction
if (!count($fonction_auteur)) {
	$fonction_auteur = new marc_list('function');
	$fonction_auteur = $fonction_auteur->table;
	}

// rcupration des codes langues
if (!count($langue_doc)) {
	$f_lang = new marc_list('lang');
	$langue_doc = $f_lang->table;
	} 

// proprits pour le selecteur de panier (kinda template)
$selector_prop = "toolbar=no, dependent=yes, width=500, height=400, resizable=yes, scrollbars=yes";
$cart_click = "onClick=\"window.open('./cart.php?object_type=NOTI&item=!!item!!&unq=!!unique!!', 'cart', '$selector_prop')\"";

// dfinition de la classe d'affichage des priodiques
class serial_display {
	var $notice_id				= 0;	// id de la notice  afficher
  	var $notice;					// objet notice (tel que fetch dans la table 'notices'
	var $bul_id				= 0 ;	// id de bulletin rcupr pour l'ISBD
  	var $action_serial_org			= '';	// lien  activer si la notice est s1 (notice chapeau)
  	var $action_analysis_org		= '';	// lien  activer si la notice est a2 (dpouillment)
	var $action_serial			= '';	// lien modifi pour le header
	var $action_analysis			= '';	// lien modifi pour le header (ncessite !!bul_id!!)
	var $action_bulletin			= '';	// action pour la notion de bulletin
	var $header				= '';	// chaine accueillant le chapeau de notice (peut-tre cliquable)
	var $tit1				= '';	// valeur du titre 1
	var $parent_id				= 0;	// id de la notice parent
	var $parent_title			= '';	// titre de la notice parent si a2
	var $parent_numero			= '';	// mention de numrotation dans le bulletinage associ
	var $parent_date			= '';	// mention de date (txt) dans le bulletinage associ
	var $parent_date_date			= '';	// mention de date (date) dans le bulletinage associ
	var $parent_aff_date_date		= '';	// mention de date (date) dans le bulletinage associ au format correct pour affichage
	var $result				= '';	// affichage final
	var $level				= 1;	// niveau d'affichage
	var $isbd				= '';	// isbd de la notice en fonction du level dfini
	var $responsabilites 			=	array("responsabilites" => array(),"auteurs" => array());  // les auteurs
	var $categories 			=	array();// les categories
	var $lien_explnum			= '';	// Lien de gestion des documents numriques associs
	var $bouton_explnum			= 0 ;	// bouton ou pas d'ajout de doc numrique
	var $p_perso;
	var $show_explnum=1;
	var $show_statut=0;
	var $print_mode=0;
	var $langues = array();
	var $languesorg = array();
	var $aff_statut = '' ; // carr de couleur pour signaler le statut de la notice
	var $show_opac_hidden_fields=true;
	
	// constructeur
	function serial_display ($id, $level='1', $action_serial='', $action_analysis='', $action_bulletin='', $lien_suppr_cart="", $lien_explnum="", $bouton_explnum=1,$print=0,$show_explnum=1, $show_statut=0, $show_opac_hidden_fields=true ) {
		// $id = id de la notice  afficher
		// $action_serial = URL  atteindre si la notice est une notice chapeau
		// $action_analysis = URL  atteindre si la notice est un dpouillement
		// note dans ces deux variable, '!!id!!' sera remplac par l'id de cette notice
		// les deux liens s'excluent mutuellement, bien sur.  
		// $level :
		//	0 : juste le header (titre  / auteur principal avec le lien si applicable) 
		// $lien_suppr_cart = lien de suppression de la notice d'un caddie
		$this->lien_explnum = $lien_explnum ;
		$this->bouton_explnum = $bouton_explnum ;
		$this->print_mode=$print;
		$this->show_explnum=$show_explnum;
		$this->show_statut=$show_statut;
		
		if(!$id) return;
			else {
				if (is_object($id)){
					$this->notice_id = $id->notice_id;
					$this->notice = $id;
					} else {
						$this->notice_id = $id;
						$this->serial_display_fetch_data();
						}
				}
		
		$this->show_opac_hidden_fields=$show_opac_hidden_fields;
		$this->p_perso=new parametres_perso("notices");
		
		$this->responsabilites = get_notice_authors($this->notice_id) ;
	
		// mise  jour des catgories
		$this->categories = get_notice_categories($this->notice_id) ;
	
		$this->level = $level;
		$this->lien_suppr_cart = $lien_suppr_cart;
	
		// si la notice est a2 (dpouillement), on rcupre les donnes du bulletinage
		if($this->notice->niveau_biblio == 'a' && $this->notice->niveau_hierar == 2) {
			$this->get_bul_info();
			}	 
	
		// mise  jour des liens
		$this->action_serial_org = $action_serial;
		$this->action_analysis = $action_analysis;
		$this->action_bulletin = $action_bulletin;
		if ($action_serial && $this->notice->niveau_biblio == 's' && $this->notice->niveau_hierar == '1')
			$this->action_serial = str_replace('!!id!!', $this->notice_id, $action_serial);
		if ($action_analysis && $this->notice->niveau_biblio == 'a' && $this->notice->niveau_hierar == '2') {
			$this->action_analysis = str_replace('!!id!!', $this->notice_id, $this->action_analysis);
			$this->action_analysis = str_replace('!!bul_id!!', $this->bul_id, $this->action_analysis);
			}
		$this->lien_explnum = str_replace('!!serial_id!!', $this->notice_id, $this->lien_explnum);
		$this->lien_explnum = str_replace('!!analysis_id!!', $this->notice_id, $this->lien_explnum);
		$this->lien_explnum = str_replace('!!bul_id!!', $this->bul_id, $this->lien_explnum);
		$this->do_header();
	
		if($level)
			$this->init_javascript();
		$this->isbd = 'ISBD';
	
		switch($level) {
			case 0:
				// l, c'est le niveau 0 : juste le header
				$this->do_header();
				$this->result = $this->header;
				break;
			default:
				// niveau 1 et plus : header + isbd  gnrer
				$this->do_header();
				$this->do_isbd();
				$this->finalize();
				break;
			}
		return;
	
		}
	
	// rcupration des info de bulletinage (si applicable)
	function get_bul_info() {
		global $dbh;
		global $msg ;
		
		// rcupration des donnes du bulletin et de la notice apparente
		$requete = "SELECT b.tit1,b.notice_id,b.code,a.*,c.*, date_format(date_date, '".$msg["format_date"]."') as aff_date_date "; 
		$requete .= "from analysis a, notices b, bulletins c";
		$requete .= " WHERE a.analysis_notice=".$this->notice_id;
		$requete .= " AND c.bulletin_id=a.analysis_bulletin";
		$requete .= " AND c.bulletin_notice=b.notice_id";
		$requete .= " LIMIT 1";
		$myQuery = mysql_query($requete, $dbh);
		if (mysql_num_rows($myQuery)) {
			$parent = mysql_fetch_object($myQuery);
			$this->parent_title = $parent->tit1;
			$this->parent_id = $parent->notice_id;
			$this->code=$parent->code;
			$this->bul_id = $parent->bulletin_id;
			$this->parent_numero = $parent->bulletin_numero;
			$this->parent_date = $parent->mention_date;
			$this->parent_date_date = $parent->date_date;
			$this->parent_aff_date_date = $parent->aff_date_date;
			}
		}
	
	// finalisation du rsultat (criture de l'isbd)
	function finalize() {
		global $dbh;
		global $msg ;
		if ($this->show_explnum) {
			$explnum = show_explnum_per_notice($this->notice_id, 0, $this->lien_explnum);
			if ($explnum) $this->isbd .= "<br><b>$msg[explnum_docs_associes]</b><br>".$explnum ;
			if ($this->notice->niveau_biblio == 'a' && $this->notice->niveau_hierar == '2' && (SESSrights & CATALOGAGE_AUTH) && $this->bouton_explnum) $this->isbd .= "<br><input type='button' class='bouton' value=' $msg[explnum_ajouter_doc] ' onClick=\"document.location='./catalog.php?categ=serials&analysis_id=$this->notice_id&sub=analysis&action=explnum_form&bul_id=$this->bul_id'\">" ;
		}
		// Diffrence avec les monographies on affiche [priodique] et [article] devant l'ISBD
		if ($this->notice->niveau_biblio =='s') {
			$this->result = str_replace('!!serial_type!!', "<span class='fond-mere'>[".$msg['isbd_type_perio']."]</span>", $this->result);
			} else { 
				$this->result = str_replace('!!serial_type!!', "<span class='fond-article'>[".$msg['isbd_type_art']."]</span>", $this->result);
				}
		$this->result = str_replace('!!ISBD!!', $this->isbd, $this->result);
		}
	
	// gnration du template javascript
	function init_javascript() {
		global $cart_click;
		global $msg ;
		$javascript_template ="
			<div id=\"el!!id!!Parent\" class=\"notice-parent\">
					<img src=\"./images/plus.gif\" name=\"imEx\" id=\"el!!id!!Img\" title=\"".$msg['admin_param_detail']."\" border=\"0\" onClick=\"expandBase('el!!id!!', true); return false;\" hspace=\"3\" />
					<span class=\"notice-heada\">!!heada!!</span>
					<br>
				</div>
			<div id=\"el!!id!!Child\" class=\"notice-child\" style=\"margin-bottom:6px;display:none;\">
						<img src='./images/basket_small_20x20.gif' align='middle' alt='basket' title=\"${msg[400]}\" $cart_click>
						!!serial_type!! !!ISBD!!
				</div>
		";
		$this->result = str_replace('!!id!!', $this->notice_id, $javascript_template);
		$this->result = str_replace('!!item!!', $this->notice_id, $this->result);
		$this->result = str_replace('!!unique!!', md5(microtime()), $this->result);
		$this->result = str_replace('!!heada!!', $this->lien_suppr_cart.$this->header, $this->result);
		}
	
	// gnration de l'isbd
	function do_isbd() {
		global $dbh;
		global $fonction_auteur;
		global $langue_doc;
		global $msg;
		global $charset;
		global $thesaurus_mode_pmb, $thesaurus_categories_categ_in_line, $pmb_keyword_sep ;
		global $pmb_etat_collections_localise,$pmb_droits_explr_localises,$explr_visible_mod;
		
		$this->isbd = $this->notice->tit1;
		
		// constitution de la mention de titre
		$tit3 = $this->notice->tit3;
		$tit4 = $this->notice->tit4;
		if($tit3) $this->isbd .= "&nbsp;= $tit3";
		if($tit4) $this->isbd .= "&nbsp;: $tit4";
	
		// constitution de la mention de responsabilit
		
		$mention_resp = array() ;
		
		// constitution de la mention de responsabilit
		//$this->responsabilites
		$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
		if ($as!== FALSE && $as!== NULL) {
			$auteur_0 = $this->responsabilites["auteurs"][$as] ;
			$auteur = new auteur($auteur_0["id"]);
			if ($this->print_mode)
				$mention_resp_lib = $auteur->isbd_entry;
			else
				$mention_resp_lib = $auteur->isbd_entry_lien_gestion;
			if (!$this->print_mode) $mention_resp_lib .= $auteur->author_web_link ;
			if ($auteur_0["fonction"]) $mention_resp_lib .= ", ".$fonction_auteur[$auteur_0["fonction"]];
			$mention_resp[] = $mention_resp_lib ;
		}
		
		$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
		for ($i = 0 ; $i < count($as) ; $i++) {
			$indice = $as[$i] ;
			$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
			$auteur = new auteur($auteur_1["id"]);
			if ($this->print_mode)
				$mention_resp_lib = $auteur->isbd_entry;
			else
				$mention_resp_lib = $auteur->isbd_entry_lien_gestion;
			if (!$this->print_mode) $mention_resp_lib .= $auteur->author_web_link ;
			if ($auteur_1["fonction"]) $mention_resp_lib .= ", ".$fonction_auteur[$auteur_1["fonction"]];
			$mention_resp[] = $mention_resp_lib ;
		}
		
		$as = array_keys ($this->responsabilites["responsabilites"], "2" ) ;
		for ($i = 0 ; $i < count($as) ; $i++) {
			$indice = $as[$i] ;
			$auteur_2 = $this->responsabilites["auteurs"][$indice] ;
			$auteur = new auteur($auteur_2["id"]);
			if ($this->print_mode)
				$mention_resp_lib = $auteur->isbd_entry;
			else
				$mention_resp_lib = $auteur->isbd_entry_lien_gestion;
			if (!$this->print_mode) $mention_resp_lib .= $auteur->author_web_link ;
			if ($auteur_2["fonction"])
				$mention_resp_lib .= ", ".$fonction_auteur[$auteur_2["fonction"]];
			$mention_resp[] = $mention_resp_lib ;
		}
			
		$libelle_mention_resp = implode ("; ",$mention_resp) ;
		if($libelle_mention_resp)
			$this->isbd .= "&nbsp;/ ". $libelle_mention_resp ." " ;
	
		// zone de l'adresse (ne concerne que s1)
		if ($this->notice->niveau_biblio == 's' && $this->notice->niveau_hierar == 1) {
			if($this->notice->ed1_id) {
				$editeur = new editeur($this->notice->ed1_id);
				if ($this->print_mode)
					$editeurs .= $editeur->isbd_entry;
				else
					$editeurs .= $editeur->isbd_entry_lien_gestion; 
			}
			if($this->notice->ed2_id) {
				$editeur = new editeur($this->notice->ed2_id);
				if ($this->print_mode) $ed_isbd=$editeur->isbd_entry; else $ed_isbd=$editeur->isbd_entry_lien_gestion;
				if($editeurs)
					$editeurs .= '&nbsp;; '.$ed_isbd;
				else
					$editeurs .= $ed_isbd;
			}
			
		if($editeurs)
			$this->isbd .= ".&nbsp;-&nbsp;$editeurs";
			// code ici pour la gestion des diteurs 
		}
		
		// zone de la collation (ne concerne que a2, mention de pagination)
		// pour les priodiques, on rebascule en zone de note
		// avec la mention du priodique parent		
		if($this->notice->niveau_biblio == 'a' && $this->notice->niveau_hierar == 2) {
			
			$bulletin = $this->parent_title;
			if($this->parent_numero) {
				$bulletin .= ' '.$this->parent_numero;
			}
			// affichage de la mention de date utile : mention_date si existe, sinon date_date
			if ($this->parent_date)
				$date_affichee = " (".$this->parent_date.")";
			else if ($this->parent_date_date)
				$date_affichee .= " [".formatdate($this->parent_date_date)."]";
			else
				$date_affichee="" ;
			$bulletin .= $date_affichee;
	
			if($this->action_bulletin) {
				$this->action_bulletin = str_replace('!!id!!', $this->bul_id, $this->action_bulletin);
				$bulletin = "<a href=\"".$this->action_bulletin."\">".htmlentities($bulletin,ENT_QUOTES, $charset)."</a>";
			}
			$mention_parent = "in <b>$bulletin</b>";
		}
			
		if($mention_parent) {
			$this->isbd .= "<br>$mention_parent";
			$pagination = htmlentities($this->notice->npages,ENT_QUOTES, $charset);
			if($pagination)
				$this->isbd .= ".&nbsp;-&nbsp;$pagination"; 
		}
	
				
		// note gnrale
		if($this->notice->n_gen)
			$this->isbd .= '<br><br>'.nl2br(htmlentities($this->notice->n_gen,ENT_QUOTES, $charset));
	
		// fin du niveau 1
		if($this->level == 1)
			return;
			
		// dbut du niveau 2
		// rsum
		if($this->notice->n_resume)
			// $this->isbd .= "<br><b>${msg[267]}</b>&nbsp;: ".nl2br(htmlentities($this->notice->n_resume,ENT_QUOTES, $charset));
			$this->isbd .= "<br><b>${msg[267]}</b>&nbsp;: ".nl2br($this->notice->n_resume);
	
		// fin du niveau 2
		if($this->level == 2)
			return;
			
		// dbut du niveau 3
		// note de contenu : non-applicable aux priodiques
		// fin du niveau 3
		if($this->level == 3)
			return;
			
		// dbut du niveau 4
		// catgories
		$max_categ = sizeof($this->categories) ;
		$categ_repetables = array() ;
		for ($i = 0 ; $i < $max_categ ; $i++) {
			$categ_id = $this->categories[$i]["categ_id"] ;
			$categ = new category($categ_id);
			if ($thesaurus_mode_pmb) {
				$categ_repetables[$categ->thes->getLibelle()][] = $categ->isbd_entry_lien_gestion;
				} else $categ_repetables['MONOTHESAURUS'][] = $categ->isbd_entry_lien_gestion;
			}
		while (list($nom_tesaurus, $val_lib)=each($categ_repetables)) {
			asort($val_lib) ;
			if ($thesaurus_mode_pmb) {
				if (!$thesaurus_categories_categ_in_line) $categ_repetables_aff = "[".$nom_tesaurus."]".implode("<br>[".$nom_tesaurus."]",$val_lib) ;
					else $categ_repetables_aff = "<b>".$nom_tesaurus."</b><br>".implode(" $pmb_keyword_sep ",$val_lib) ;
				} else if (!$thesaurus_categories_categ_in_line) $categ_repetables_aff = implode("<br>",$val_lib) ;
					else $categ_repetables_aff = implode(" $pmb_keyword_sep ",$val_lib) ;		
			if($categ_repetables_aff) $tmpcateg_aff .= "<br>$categ_repetables_aff";
			}
		if ($tmpcateg_aff) $this->isbd .= "<br>$tmpcateg_aff";
		
		// fin du niveau 4
		if($this->level == 4)
			return;
			
		// dbut du niveau 5
		// langues
		if(count($this->langues)) {
			$langues = "<b>${msg[537]}</b>&nbsp;: ".construit_liste_langues($this->langues);
			}
		if(count($this->languesorg)) {
			$langues .= " <b>${msg[711]}</b>&nbsp;: ".construit_liste_langues($this->languesorg);
			}
		if($langues)
			$this->isbd .= "<br>$langues";
			
			
		// fin du niveau 5
		if($this->level == 5)
			return;
			
		// dbut du niveau 6
		// indexation libre
		if($this->notice->index_l)
			$this->isbd .= "<br><b>${msg[324]}</b>&nbsp;: ".htmlentities($this->notice->index_l,ENT_QUOTES, $charset);
		
		// indexation interne
		if($this->notice->indexint) {
			$indexint = new indexint($this->notice->indexint);
			if ($this->print_mode) $indexint_isbd=$indexint->display; else $indexint_isbd=$indexint->isbd_entry_lien_gestion;
			$this->isbd .= "<br><b>${msg[indexint_catal_title]}</b>&nbsp;: ".$indexint_isbd;
		}
		
		//code (ISSN,...)
		if ($this->notice->code) $this->isbd .="<br><b>${msg[165]}</b>&nbsp;: ".$this->notice->code;
			
		//Champs personaliss
		$perso_aff = "" ;
		if (!$this->p_perso->no_special_fields) {
			$perso_=$this->p_perso->show_fields($this->notice_id);
			for ($i=0; $i<count($perso_["FIELDS"]); $i++) {
				$p=$perso_["FIELDS"][$i];
				// ajout de && ($p['OPAC_SHOW']||$this->show_opac_hidden_fields) afin de masquer les champs masqu de l'POAC en diff de bannette.
				if ($p["AFF"] && ($p['OPAC_SHOW']||$this->show_opac_hidden_fields)) $perso_aff .="<br/>".$p["TITRE"]." ".$p["AFF"];
			}
		}
		if ($perso_aff) $this->isbd.="<br/>".$perso_aff ;
		
		// Si notice-mre alors on compte le nombre de numros (bulletins)
		if($this->notice->niveau_biblio=="s") {
			$requete = "SELECT * FROM bulletins WHERE bulletin_notice=".$this->notice_id;
			$Query = mysql_query($requete, $dbh);
			$bulletins=mysql_num_rows($Query);
			while ($row = mysql_fetch_array($Query)) {
				$requete2 = "SELECT count( * )  AS nb_notices FROM  analysis WHERE analysis_bulletin =".$row['bulletin_id'];
				$Query2 = mysql_query($requete2, $dbh);
				$analysis_array=mysql_fetch_array($Query2);
				$nb_notices+=$analysis_array['nb_notices'];
				$requete3 = "SELECT count( expL_id )  AS nb_expl FROM  exemplaires WHERE expl_bulletin =".$row['bulletin_id'];
				$Query3 = mysql_query($requete3, $dbh);
				$expl_array=mysql_fetch_array($Query3);
				$nb_expl+=$expl_array['nb_expl'];			
			};
				
			// Cas gnral : au moins un bulletin
			if (mysql_num_rows($Query)>0)
				{$this->isbd .="<br /><br />\n
				<b>".$msg["serial_bulletinage_etat"]."</b>
				<table border='0' class='expl-list'>
				<tr><td><strong>$bulletins</strong> ".$msg["serial_nb_bulletin"]."
				<strong>$nb_expl</strong> ".$msg["bulletin_nb_ex"]."	
				<strong>$nb_notices</strong> ".$msg["serial_nb_articles"]."	
				</td>
				</tr></table>";
									
			} else { // 0 bulletin
				$this->isbd .="<br /><br />\n
				<b>".$msg["serial_bulletinage_etat"]."</b>
				<table border='0' class='expl-list'>
				<tr><td><strong>$bulletins</strong>
				".$msg["serial_nb_bulletin"]." : <strong>";
				$this->isbd .=$msg["bull_no_expl"];
				$this->isbd .="</strong></td>
				</tr></table>";
			}
			
			//tat des collections
			
			if ($pmb_etat_collections_localise&&$pmb_droits_explr_localises&&$explr_visible_mod) {
					$restrict_location=" and location_id in (".$explr_visible_mod.") and idlocation=location_id";	
					$table_location=",docs_location";
					$select_location=",location_libelle";
			} else $restrict_location=" group by id_serial";
			$rqt="select state_collections$select_location from collections_state$table_location where id_serial=".$this->notice_id.$restrict_location;
			$execute_query=mysql_query($rqt);
			if ($execute_query) {
				if (mysql_num_rows($execute_query)) {
					$bool=false;
					$affichage="<br><strong>".$msg["4001"]."</strong><br>";
					while ($r=mysql_fetch_object($execute_query)) {
						if ($r->state_collections) {
							if ($r->location_libelle) $affichage .= "<strong>".$r->location_libelle."</strong> : ";
							$affichage .= $r->state_collections."<br>\n";
							$bool=true;
						}	
					}
					if ($bool==true) $this->isbd .= $affichage;
				}
			}
		}
		
		// fin du niveau 6
		return;
	}	
	
	// gnration du header
	function do_header() {
		global $dbh;
		global $charset;
		
		if ($this->notice->statut) {
			$rqt_st = "SELECT class_html , gestion_libelle FROM notice_statut WHERE id_notice_statut='".$this->notice->statut."' ";
			$res_st = mysql_query($rqt_st, $dbh);
			$class_html = " class='".mysql_result($res_st, 0, 0)."' ";
			if ($this->notice->statut>1) $txt = mysql_result($res_st, 0, 1) ;
				else $txt = "" ;
			} else {
				$class_html = " class='statutnot1' " ;
				$txt = "" ;
				}
		if ($this->notice->commentaire_gestion) { 
			if ($txt) $txt .= ":\r\n".$this->notice->commentaire_gestion ;
				else $txt = $this->notice->commentaire_gestion ;
			}
		if ($txt) {
			$statut = "<small><span $class_html style='margin-right: 3px;'><a href=# onmouseover=\"z=document.getElementById('zoom_statut".$this->notice_id."'); z.style.display=''; \" onmouseout=\"z=document.getElementById('zoom_statut".$this->notice_id."'); z.style.display='none'; \"><img src='./images/spacer.gif' width='10' height='10' /></a></span></small>";
			$statut .= "<div id='zoom_statut".$this->notice_id."' style='border: solid 2px #555555; background-color: #FFFFFF; position: absolute; display:none; z-index: 2000;'><b>".nl2br(htmlentities($txt,ENT_QUOTES, $charset))."</b></div>" ;
			} else $statut = "<small><span $class_html style='margin-right: 3px;'><img src='./images/spacer.gif' width='10' height='10' /></span></small>";
		$this->aff_statut = $statut ; 
		
		$this->header = htmlentities($this->notice->tit1,ENT_QUOTES, $charset);
	
		$aut1_libelle = array() ;
		//$this->responsabilites
		$as = array_search ("0", $this->responsabilites["responsabilites"]) ;
		if ($as!== FALSE && $as!== NULL) {
			$auteur_0 = $this->responsabilites["auteurs"][$as] ;
			$auteur = new auteur($auteur_0["id"]);
			if ($auteur->isbd_entry)
				$this->header .= ' / '. $auteur->isbd_entry;
		} else {
			$as = array_keys ($this->responsabilites["responsabilites"], "1" ) ;
			for ($i = 0 ; $i < count($as) ; $i++) {
				$indice = $as[$i] ;
				$auteur_1 = $this->responsabilites["auteurs"][$indice] ;
				$auteur = new auteur($auteur_1["id"]);
				$aut1_libelle[]= $auteur->isbd_entry;
			}
			$auteurs_liste = implode ("; ",$aut1_libelle) ;
			if ($auteurs_liste)
				$this->header .= ' / '. $auteurs_liste ;
		}
		
		if($this->notice->niveau_biblio == 's' && $this->notice->niveau_hierar == 1) {
			if($this->action_serial)
				$this->header = "<a href=\"".$this->action_serial."\">".$this->header.'</a>';			
		}	
		if($this->notice->niveau_biblio == 'a' && $this->notice->niveau_hierar == 2) {
			if($this->action_analysis)
				$this->header= "<a href=\"".$this->action_analysis."\">".$this->header.'</a>';
			if ($this->level!=2) 
				$this->header=$this->header." <i>in ".$this->parent_title." (".$this->parent_numero." ".($this->parent_date?$this->parent_date:$this->parent_aff_date_date).")</i> ";
		}
		if($this->notice->lien) {
			// ajout du lien pour les ressources lectroniques
			$this->header .= "<a href=\"".$this->notice->lien."\" target=\"__LINK__\">";
			global $use_opac_url_base, $opac_url_base ;
			if (!$use_opac_url_base) $this->header .= "<img src=\"./images/globe.gif\" border=\"0\" align=\"middle\" hspace=\"3\"";
				else $this->header .= "<img src=\"".$opac_url_base."images/globe.gif\" border=\"0\" align=\"middle\" hspace=\"3\"";
			$this->header .= " alt=\"";
			$this->header .= $this->notice->eformat;
			$this->header .= "\" title=\"";
			$this->header .= $this->notice->eformat;
			$this->header .= "\"></a>";
			}
		if ($this->show_statut) $this->header = $this->aff_statut.$this->header ;
	}
	  
	// rcupration des valeurs en table
	function serial_display_fetch_data() {
		global $dbh;
		$requete = "SELECT * FROM notices WHERE notice_id=".$this->notice_id.' LIMIT 1';
		$myQuery = mysql_query($requete, $dbh);
		if (mysql_num_rows($myQuery))
			$this->notice = mysql_fetch_object($myQuery);
		return mysql_num_rows($myQuery);
		}
		
	} // fin classe serial_display
	
	// -------------------------------------------------------------------
	//   classe bulletinage_display : utilise pour le prt de documents
	// -------------------------------------------------------------------
	class bulletinage_display {
	var $bul_id = 0;		// id du bulletinage  afficher
	var $display = '';		// texte  afficher
	var $parent_title = '';		// titre gnral de la revue  laquelle fait rfrence ce bulletinage
	var $bulletin_titre = '';	// titre de ce bulletin
	var $numerotation = '';		// mention de numrotation sur la revue
	var $periode	  = '';		// mention de date de la revue (txt)
	var $date_date	  = '';		// mention de date de la revue (date)
	var $header	  = '';		// pour affichage rduit
	 
	// constructeur
	function bulletinage_display($id=0) {
		if(!$id) {
			$this->display = "Error : bul_id is null";
			return $this->bul_id;
		}
	
		$this->bul_id = $id;
		
		$this->fetch_bulletinage_data();	
		$this->make_display();
	
		return $this->bul_id;	
	}
	
	// fabrication de la mention  afficher
	function make_display() {
		if ($this->parent_title) {
			$this->display = $this->parent_title;
			} else {
				$this->display = "error: unknown record";
				return;
				}
	
		if((!$this->numerotation && !$this->periode && !$this->bulletin_titre && !$this->date_date) || !$this->bul_id) {
			$this->display .= " error : missing information"; 
			}
				
		if($this->numerotation)
			$this->display .= '. '.$this->numerotation;
		
		$this->header = $this->display;
		
		// affichage de la mention de date utile : mention_date si existe, sinon date_date
		if ($this->periode)
			$date_affichee = " (".$this->periode.") ";
			else $date_affichee .= " [".$this->aff_date_date."]";
		$this->display .= $date_affichee;
		
		if ($date_affichee) $this->header .= $date_affichee ;
		}

	// rcupration des infos bulletinage en base
	function fetch_bulletinage_data() {
		global $dbh;
		global $msg ;
		
		$requete = "SELECT bulletins.*, notices.tit1, date_format(date_date, '".$msg["format_date"]."') as aff_date_date FROM bulletins, notices ";
		$requete .= " WHERE bulletins.bulletin_id=".$this->bul_id;
		$requete .= " AND notices.notice_id=bulletins.bulletin_notice";
		$requete .= " AND notices.niveau_biblio='s' AND notices.niveau_hierar='1' LIMIT 1";		
	
		$myQuery = mysql_query($requete, $dbh);
		if(mysql_num_rows($myQuery)) {
			$result = mysql_fetch_object($myQuery);
			$this->parent_title = $result->tit1;
			$this->bulletin_titre = $result->bulletin_titre;
			$this->numerotation = $result->bulletin_numero;
			$this->periode = $result->mention_date;
			$this->date_date = $result->date_date;
			$this->aff_date_date = $result->aff_date_date;
			$this->bul_id = $result->bulletin_id;
		}
		
		return;
	}
} // class serial_display

