<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// | creator : Emmanuel PACAUD < emmanuel.pacaud@univ-poitiers.fr>            |
// +-------------------------------------------------+
// $Id: z3950_notice.class.php,v 1.62 2007/11/14 15:18:52 touraine37 Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once($class_path."/parametres_perso.class.php");
require_once($class_path."/notice.class.php");

class z3950_notice {
	var $bibliographic_level;
	var $hierarchic_level;

	var $titles;
	var $serie;
	var $nbr_in_serie;
	
	var $authors;
	var $author_functions;
	
	var $editors;
	var $collection;
	var $subcollection;
	var $nbr_in_collection;
	var $mention_edition;	// mention d'dition (1re, deuxime...)
	var $isbn;

	var $page_nbr;
	var $illustration;
	var $size;
	var $prix;
	var $accompagnement;

	var $general_note;
	var $content_note;
	var $abstract_note;

	var $internal_index;
	
	var $dewey ;
	var $free_index;
	var $matieres_index;

	var $link_url;
	var $link_format;

	var $language_code;
	var $original_language_code;

	var $action;
	
	var $origine_notice = array() ;
	
	var $aut_array = array(); // tableau des auteurs
	var $categories =	array();// les categories

	var $info_600_a = array() ;
	var $info_601_a = array() ;
	var $info_602_a = array() ;
	var $info_605_a = array() ;
	var $info_606_a = array() ;
	var $info_607_a = array() ;
	var $info_600_j = array() ;
	var $info_601_j = array() ;
	var $info_602_j = array() ;
	var $info_605_j = array() ;
	var $info_606_j = array() ;
	var $info_607_j = array() ;
	var $info_600_x = array() ;
	var $info_601_x = array() ;
	var $info_602_x = array() ;
	var $info_605_x = array() ;
	var $info_606_x = array() ;
	var $info_607_x = array() ;
	var $info_600_y = array() ;
	var $info_601_y = array() ;
	var $info_602_y = array() ;
	var $info_605_y = array() ;
	var $info_606_y = array() ;
	var $info_607_y = array() ;
	var $info_600_z = array() ;
	var $info_601_z = array() ;
	var $info_602_z = array() ;
	var $info_605_z = array() ;
	var $info_606_z = array() ;
	var $info_607_z = array() ;
	
	function z3950_notice ($type, $marc = NULL) {
		$type = strtolower ($type);
		if ($type == 'form') $this->from_form ();
			else 
		 	if ($marc != NULL) {
				if ($type == 'sutrs') $type= 'unimarc';
				$this->notice_type=$type;
				$this->notice=$marc;
				$record = new iso2709_record ($marc, AUTO_UPDATE);
				if ($type == 'unimarc') $this->from_unimarc ($record);
					else $this->from_usmarc ($record);
				}
		}
				
	function substitute ($tag, $value, &$string) {
		global $charset;
		$string = str_replace ("!!$tag!!", htmlentities($value,ENT_QUOTES, $charset), $string);
		}

	function insert_in_database ($show=true) {
		global $dbh ;
		$new_notice = 0;
		$notice_retour = 0;
		$long_maxi = mysql_field_len(mysql_query ("SELECT code FROM notices limit 1") ,0);
		$isbn = rtrim (substr ($this->isbn, 0, $long_maxi));
		if ($isbn != "") {
			if (isISBN($isbn)) {
				if (strlen($isbn)==13)
					$isbn1=formatISBN($isbn,13);
				else
					$isbn1=formatISBN($isbn,10);
			}
			$sql_rech="select notice_id from notices where code = '".$isbn."' ";
			if ($isbn1) $sql_rech.=" or code='".$isbn1."' ";
			$sql_result_rech = mysql_query ($sql_rech) or die ("Couldn't select notice ! = ".$sql_rech);
			if (mysql_num_rows($sql_result_rech) == 0) $new_notice=1; 
				else {
					$new_notice=0;
					$lu = mysql_fetch_array($sql_result_rech);
					$notice_retour = $lu['notice_id'];
					}
			} else $new_notice = 1;

		if ($new_notice == 0) {
			$retour = array ($new_notice, $notice_retour);
			return $this->update_in_database($notice_retour, $show);
			//return $retour;
			}

		for ($i = 0; $i < 2; $i++) {
			$editor_ids[$i] = editeur::import ($this->editors[$i]);
			}
		
		$this->collection['parent'] = $editor_ids[0];
		$collection_id = collection::import ($this->collection);
		
		$this->subcollection['coll_parent'] = $collection_id;
		$subcollection_id = subcollection::import ($this->subcollection);
		$serie_id = serie::import(stripslashes($this->serie));

		/* traitement de Dewey */
		if ($this->internal_index=="!!indexint_id!!") $this->internal_index = indexint::import(clean_string($this->dewey[0]));
		else if (!$show) $this->internal_index = indexint::import(clean_string(stripslashes($this->dewey[0])));
				
		$title_indexes_wew = $this->serie." ".$this->nbr_in_serie ;
		for ($i = 0; $i < 4; $i++) {
			$title_indexes_wew .= " ".$this->titles[$i] ;
			}
		$title_indexes_sew = strip_empty_words ($title_indexes_wew);
		$this->serie ? $serie_index = ' '.strip_empty_words ($this->serie).' ' : $serie_index='' ;
		
		$this->free_index ? $this->matieres_index = ' '.strip_empty_words($this->free_index).' ' : $this->matieres_index = '';
		
		$this->general_note	? $index_n_gen = ' '.strip_empty_words($this->general_note).' ' : $index_n_gen = '';
		$this->content_note	? $index_n_contenu = ' '.strip_empty_words($this->content_note).' ' : $index_n_contenu = '';
		$this->abstract_note ? $index_n_resume = ' '.strip_empty_words($this->abstract_note).' ' : $index_n_resume = '';
	
		/* Origine de la notice */
		$orinot_id = origine_notice::import($this->origine_notice);
		if ($orinot_id==0) $orinot_id=1 ;
		if (!$show) $this->statut="1";

		$sql_ins = "insert into notices (
			typdoc          ,
			code        	,
			tit1            ,
			tit2            ,
			tit3            ,
			tit4            ,
			tparent_id      ,
			tnvol           ,
			ed1_id          ,
			ed2_id          ,
			year            ,
			npages          ,
			ill             ,
			size            ,
			accomp          ,
			coll_id         ,
			subcoll_id      ,
			nocoll          ,
			mention_edition ,
			n_gen           ,
			n_contenu       ,
			n_resume        ,
			indexint,
			index_serie,
			index_sew,
			index_wew,
			statut,
			commentaire_gestion,
			index_l,
			index_matieres,
			niveau_biblio,
			niveau_hierar,
			lien,
			eformat,
			origine_catalogage,
			prix,
	        index_n_gen,
			index_n_contenu,
			index_n_resume,
			create_date
			) values (
			'".$this->document_type."',	
			'".$this->isbn."',	
			'".$this->titles[0]."',
			'".$this->titles[1]."',
			'".$this->titles[2]."',
			'".$this->titles[3]."',
			'".$serie_id."',
			'".$this->nbr_in_serie."',
			".$editor_ids[0]." ,
			".$editor_ids[1]." ,
			'".$this->year."',
			'".$this->page_nbr."',
			'".$this->illustration."',
			'".$this->size."',
			'".$this->accompagnement."',
			".$collection_id." ,
			".$subcollection_id." ,
			'".$this->nbr_in_collection."',
			'".$this->mention_edition."',
			'".$this->general_note."',
			'".$this->content_note."',
			'".$this->abstract_note."',
			'".$this->internal_index."',
			'".$serie_index."',
			' ".$title_indexes_sew." ',
			'".$title_indexes_wew."',
			'".$this->statut."',
			'".$this->commentaire_gestion."',
			'".$this->free_index."',
			'".$this->matieres_index."',
			'".$this->bibliographic_level."',
			'".$this->hierarchic_level."',
			'".$this->link_url."',
			'".$this->link_format."',
			'".$this->orinot_id."',
			'".$this->prix."',
			'".$index_n_gen."',
			'".$index_n_contenu."',
			'".$index_n_resume."',
			sysdate() )";
		//echo "<pre>";
		//print_r($this->aut_array);
		//echo "</pre>";
		//echo $sql_ins."<br>";
		//echo "<pre>";
		//print_r($this->categories);
		//echo "</pre>";
		//exit;
		$sql_result_ins = mysql_query($sql_ins) or die ("Couldn't insert into table notices : ".$sql_ins);
		$notice_retour = mysql_insert_id();
		audit::insert_creation (1, $notice_retour) ;
		
		// purge de la base des responsabilits de la notice intgre...
		if ($notice_retour) {
			$rqt_del = "delete from responsability where responsability_notice='$notice_retour'" ;
			$sql_result_del = mysql_query($rqt_del) or die ("Couldn't purge table responsability : ".$rqt_del);
			}
		$rqt_ins = "insert into responsability (responsability_author, responsability_notice, responsability_fonction, responsability_type) VALUES ";
		for ($i=0 ; $i<sizeof($this->aut_array) ; $i++ ){
			$aut['name']=clean_string($this->aut_array[$i]['entree']);
			$aut['rejete']=clean_string($this->aut_array[$i]['rejete']);
			$aut['date']=clean_string($this->aut_array[$i]['date']);
			$aut['type']=$this->aut_array[$i]['type_auteur'];
			$this->aut_array[$i]["id"] = auteur::import($aut);
			if ($this->aut_array[$i]["id"]) {
				$rqt = $rqt_ins . " (".$this->aut_array[$i]["id"].",".$notice_retour.",'".$this->aut_array[$i]['fonction']."',".$this->aut_array[$i]['responsabilite'].") " ; 
				$res_ins = mysql_query($rqt, $dbh);
				}
			}

		// traitement des langues
		// langues
//-------------------------------------> L L I U R E X <--------------------------------------
		if (!$show) {
			$f_lang_form = array();
			$f_langorg_form = array() ;
			if (sizeof($this->language_code)==0) $max_lang = 1 ;
			else $max_lang = sizeof($this->language_code) ;
			if (sizeof($this->original_language_code)==0) $max_langorg = 1 ;
			else $max_langorg = sizeof($this->original_language_code) ; 
			
			for ($i=0; $i< $max_lang ; $i++) {
				$f_lang_form[] =  array ('code' => $this->language_code[$i]);
			}

			for ($i=0; $i< $max_langorg ; $i++) {
				$f_langorg_form[] =  array ('code' => $this->original_language_code[$i]);
			}

		}
		else {
			global $max_lang, $max_langorg;
			$f_lang_form = array();
			$f_langorg_form = array() ;
			for ($i=0; $i< $max_lang ; $i++) {
				$var_langcode = "f_lang_code$i" ;
				global $$var_langcode ;
				if ($$var_langcode) $f_lang_form[] =  array ('code' => $$var_langcode);
				}
			// langues originales
			for ($i=0; $i< $max_langorg ; $i++) {
				$var_langorgcode = "f_langorg_code$i" ;
				global $$var_langorgcode;
				if ($$var_langorgcode) $f_langorg_form[] =  array ('code' => $$var_langorgcode);
				}
		}
//-------------------------------------> L L I U R E X <--------------------------------------

		$rqt_del = "delete from notices_langues where num_notice='$notice_retour' ";
		$res_del = mysql_query($rqt_del, $dbh);
		$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
		while (list ($key, $val) = each ($f_lang_form)) {
			$tmpcode_langue=$val['code'];
			if ($tmpcode_langue) {
				$rqt = $rqt_ins . " ('$notice_retour',0, '$tmpcode_langue') " ; 
				$res_ins = mysql_query($rqt, $dbh);
				}
			}
	
		// traitement des langues originales
		$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
		while (list ($key, $val) = each ($f_langorg_form)) {
			$tmpcode_langue=$val['code'];
			if ($tmpcode_langue) {
				$rqt = $rqt_ins . " ('$notice_retour',1, '$tmpcode_langue') " ; 
				$res_ins = @mysql_query($rqt, $dbh);
				}
			}
	
		
		// traitement des categories
		traite_categories_enreg($notice_retour,$this->categories);
		
		//Traitement des champs personaliss
		$p_perso=new parametres_perso("notices");
		$nberrors=$p_perso->check_submited_fields();
		$p_perso->rec_fields_perso($notice_retour);
		
		//Traitement import perso
//-------------------------------------> L L I U R E X <--------------------------------------

		//Traitement import perso
		global $notice_id,$notice_org,$notice_type_org;
		if (function_exists('recup_noticeunimarc_suite')) {
			$notice_id=$notice_retour;
			if ($show) { 
				z_recup_noticeunimarc_suite($notice_org);
				z_import_new_notice_suite();
				}
			}

//-------------------------------------> L L I U R E X <--------------------------------------
		// Mise  jour de la table notices_global_index
		notice::majNoticesGlobalIndex($notice_retour);
		// Mise  jour de la table notices_mots_global_index
		notice::majNoticesMotsGlobalIndex($notice_retour);
		
		$retour = array ($new_notice, $notice_retour);	
		return $retour;
		} 

	function update_in_database ($id_notice=0, $show=true) {
		global $dbh ;
		$new_notice = 2;
		$notice_retour = $id_notice;
		
		if (!$id_notice) {
			$retour = array (2, 0);	
			return $retour;
			}

		for ($i = 0; $i < 2; $i++) {
			$editor_ids[$i] = editeur::import ($this->editors[$i]);
			}
		
		$this->collection['parent'] = $editor_ids[0];
		$collection_id = collection::import ($this->collection);
		
		$this->subcollection['coll_parent'] = $collection_id;
		$subcollection_id = subcollection::import ($this->subcollection);
		$serie_id = serie::import(stripslashes($this->serie));

		/* traitement de Dewey */
		if ($this->internal_index=="!!indexint_id!!") $this->internal_index = indexint::import(clean_string($this->dewey[0]));
		else if (!$show) $this->internal_index = indexint::import(clean_string(stripslashes($this->dewey[0])));
				
		$title_indexes_wew = $this->serie." ".$this->nbr_in_serie ;
		for ($i = 0; $i < 4; $i++) {
			$title_indexes_wew .= " ".$this->titles[$i] ;
			}
		$title_indexes_sew = strip_empty_words ($title_indexes_wew);
		$this->serie ? $serie_index = ' '.strip_empty_words ($this->serie).' ' : $serie_index='' ;
		
		$this->free_index ? $this->matieres_index = ' '.strip_empty_words($this->free_index).' ' : $this->matieres_index = '';
		
		$this->general_note	? $index_n_gen = ' '.strip_empty_words($this->general_note).' ' : $index_n_gen = '';
		$this->content_note	? $index_n_contenu = ' '.strip_empty_words($this->content_note).' ' : $index_n_contenu = '';
		$this->abstract_note ? $index_n_resume = ' '.strip_empty_words($this->abstract_note).' ' : $index_n_resume = '';
	
		/* Origine de la notice */
		$orinot_id = origine_notice::import($this->origine_notice);
		if ($orinot_id==0) $orinot_id=1 ;
		if (!$show) $this->statut="1";
				
		$sql_ins = "update notices set
			typdoc           	='".$this->document_type."',
			code        	        ='".$this->isbn."',	            
			tit1                    ='".$this->titles[0]."',             
			tit2                    ='".$this->titles[1]."',             
			tit3                    ='".$this->titles[2]."',             
			tit4                    ='".$this->titles[3]."',             
			tparent_id              ='".$serie_id."',                    
			tnvol                   ='".$this->nbr_in_serie."',          
			ed1_id                  =".$editor_ids[0]." ,                
			ed2_id                  =".$editor_ids[1]." ,                
			year                    ='".$this->year."',                  
			npages                  ='".$this->page_nbr."',              
			ill                     ='".$this->illustration."',          
			size                    ='".$this->size."',                  
			accomp                  ='".$this->accompagnement."',        
			coll_id                 =".$collection_id." ,                
			subcoll_id              =".$subcollection_id." ,             
			nocoll                  ='".$this->nbr_in_collection."',     
			mention_edition         ='".$this->mention_edition."',       
			n_gen                   ='".$this->general_note."',          
			n_contenu               ='".$this->content_note."',          
			n_resume                ='".$this->abstract_note."',         
			indexint                ='".$this->internal_index."',        
			index_serie             =' ".$serie_index." ',               
			index_sew               =' ".$title_indexes_sew." ',         
			index_wew               ='".$title_indexes_wew."',           
			statut					='".$this->statut."',
			commentaire_gestion		='".$this->commentaire_gestion."',
			index_l                 ='".$this->free_index."',            
			index_matieres          ='".$this->matieres_index."',      
			niveau_biblio           ='".$this->bibliographic_level."',   
			niveau_hierar           ='".$this->hierarchic_level."',      
			lien                    ='".$this->link_url."',              
			eformat                 ='".$this->link_format."',           
			origine_catalogage      ='".$this->orinot_id."',             
			prix                    ='".$this->prix."',                  
	        index_n_gen             ='".$index_n_gen."',               
			index_n_contenu         ='".$index_n_contenu."',           
			index_n_resume          ='".$index_n_resume."'             
			where notice_id='$id_notice' ";
		//echo "<pre>";
		//print_r($this->aut_array);
		//echo "</pre>";
		//echo $sql_ins."<br>";
		//echo "<pre>";
		//print_r($this->categories);
		//echo "</pre>";
		//exit;
		$sql_result_ins = mysql_query($sql_ins) or die ("Couldn't update notices : ".$sql_ins);
		$notice_retour = $id_notice ;
		audit::insert_modif (1, $id_notice) ;
		
		// purge de la base des responsabilits de la notice intgre...
		if ($notice_retour) {
			$rqt_del = "delete from responsability where responsability_notice='$notice_retour'" ;
			$sql_result_del = mysql_query($rqt_del) or die ("Couldn't purge table responsability : ".$rqt_del);
			}
		$rqt_ins = "insert into responsability (responsability_author, responsability_notice, responsability_fonction, responsability_type) VALUES ";
		for ($i=0 ; $i<sizeof($this->aut_array) ; $i++ ){
			$aut['name']=clean_string($this->aut_array[$i]['entree']);
			$aut['rejete']=clean_string($this->aut_array[$i]['rejete']);
			$aut['date']=clean_string($this->aut_array[$i]['date']);
			$aut['type']=$this->aut_array[$i]['type_auteur'];
			$this->aut_array[$i]["id"] = auteur::import($aut);
			if ($this->aut_array[$i]["id"]) {
				$rqt = $rqt_ins . " (".$this->aut_array[$i]["id"].",".$notice_retour.",'".$this->aut_array[$i]['fonction']."',".$this->aut_array[$i]['responsabilite'].") " ; 
				$res_ins = mysql_query($rqt, $dbh);
				}
			}
		
		// traitement des categories
		traite_categories_enreg($notice_retour,$this->categories);
		
		// traitement des langues
		// langues
//-------------------------------------> L L I U R E X <--------------------------------------
		if (!$show) {
			$f_lang_form = array();
			$f_langorg_form = array() ;
			if (sizeof($this->language_code)==0) $max_lang = 1 ;
			else $max_lang = sizeof($this->language_code) ;
			if (sizeof($this->original_language_code)==0) $max_langorg = 1 ;
			else $max_langorg = sizeof($this->original_language_code) ; 
			
			for ($i=0; $i< $max_lang ; $i++) {
				$f_lang_form[] =  array ('code' => $this->language_code[$i]);
			}

			for ($i=0; $i< $max_langorg ; $i++) {
				$f_langorg_form[] =  array ('code' => $this->original_language_code[$i]);
			}

		}
		else {
			global $max_lang, $max_langorg;
			$f_lang_form = array();
			$f_langorg_form = array() ;
			for ($i=0; $i< $max_lang ; $i++) {
				$var_langcode = "f_lang_code$i" ;
				global $$var_langcode ;
				if ($$var_langcode) $f_lang_form[] =  array ('code' => $$var_langcode);
				}
			// langues originales
			for ($i=0; $i< $max_langorg ; $i++) {
				$var_langorgcode = "f_langorg_code$i" ;
				global $$var_langorgcode;
				if ($$var_langorgcode) $f_langorg_form[] =  array ('code' => $$var_langorgcode);
				}
		}
//-------------------------------------> L L I U R E X <--------------------------------------

		$rqt_del = "delete from notices_langues where num_notice='$notice_retour' ";
		$res_del = mysql_query($rqt_del, $dbh);
		$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
		while (list ($key, $val) = each ($f_lang_form)) {
			$tmpcode_langue=$val['code'];
			if ($tmpcode_langue) {
				$rqt = $rqt_ins . " ('$notice_retour',0, '$tmpcode_langue') " ; 
				$res_ins = mysql_query($rqt, $dbh);
				}
			}
	
		// traitement des langues originales
		$rqt_ins = "insert into notices_langues (num_notice, type_langue, code_langue) VALUES ";
		while (list ($key, $val) = each ($f_langorg_form)) {
			$tmpcode_langue=$val['code'];
			if ($tmpcode_langue) {
				$rqt = $rqt_ins . " ('$notice_retour',1, '$tmpcode_langue') " ; 
				$res_ins = @mysql_query($rqt, $dbh);
				}
			}
	
		//Traitement import perso
		global $notice_id,$notice_org,$notice_type_org;
		if (function_exists('recup_noticeunimarc_suite')) {
			//Suppression des champs persos
			$requete="delete from notices_custom_values where notices_custom_origine=".$notice_retour;
			@mysql_query($requete);
			$notice_id=$notice_retour;
//-------------------------------------> L L I U R E X <--------------------------------------
			if ($show) {
				z_recup_noticeunimarc_suite($notice_org);
				z_import_new_notice_suite();
				}
//-------------------------------------> L L I U R E X <--------------------------------------
			}
		
		// Mise  jour de la table notices_global_index
		notice::majNoticesGlobalIndex($notice_retour);

		
		$retour = array ($new_notice, $notice_retour);	
		return $retour;
		} 

	function get_form ($action, $id_notice=0) {
		// construit le formulaire de catalogage pr-rempli
		global $msg;
		global $charset;
		global $include_path;
		global $base_path;
		global $dbh ;
		global $znotices_id;
		
		$fonction = new marc_list('function');

		$this->action = $action;

		include("$include_path/templates/z3950_form.tpl.php");

		// mise  jour de l'entte du formulaire
		$form_notice = str_replace('!!libelle_form!!', $this->libelle_form, $form_notice);

		// mise  jour des flags de niveau hirarchique
		$form_notice = str_replace('!!b_level!!', $this->bibliographic_level, $form_notice);
		$form_notice = str_replace('!!h_level!!', $this->hierarchic_level, $form_notice);

		for ($i = 0; $i < 4; $i++) {
			$this->substitute ("title_$i", $this->titles[$i], $ptab[0]);
			}
		$this->substitute ("serie", $this->serie, $ptab[0]);
		$this->substitute ("nbr_in_serie", $this->nbr_in_serie, $ptab[0]);
		$form_notice = str_replace('!!tab0!!', $ptab[0], $form_notice);
					 
		// mise  jour de l'onglet 1
		// constitution de la mention de responsabilit
		//echo "<pre>";
		//print_r($this->aut_array);
		//echo "</pre>";
		$nb_autres_auteurs = 0 ;
		$nb_auteurs_secondaires = 0 ;
		for ($as = 0 ; $as < sizeof($this->aut_array) ; $as++ ){
			if ($this->aut_array[$as]["responsabilite"]===0) {
				$this->substitute ("author_name_0", $this->aut_array[$as]["entree"], $ptab[1]);
				$this->substitute ("author_rejete_0", $this->aut_array[$as]["rejete"], $ptab[1]);
				$this->substitute ("author_date_0", $this->aut_array[$as]["date"], $ptab[1]);
				$this->substitute ("author_function_0", $this->aut_array[$as]["fonction"], $ptab[1]);
				$this->substitute ("author_function_label_0", $fonction->table[$this->aut_array[$as]["fonction"]], $ptab[1]);
				for ($type = 70; $type <= 71; $type++) {
					if ($this->aut_array[$as]["type_auteur"] == $type) $sel = " selected";
						else $sel = "";
					$this->substitute ("author_type_".$type."_0", $sel, $ptab[1]);
					}
				}
			if ($this->aut_array[$as]["responsabilite"]==1) {
				if ($this->aut_array[$as]["entree"] == "") continue; 
				$ptab_aut_autres = str_replace('!!iaut!!', $nb_autres_auteurs, $ptab[11]) ;
					
				$this->substitute ("author_name_1", $this->aut_array[$as]["entree"], $ptab_aut_autres);
				$this->substitute ("author_rejete_1", $this->aut_array[$as]["rejete"], $ptab_aut_autres);
				$this->substitute ("author_date_1", $this->aut_array[$as]["date"], $ptab_aut_autres);
				$this->substitute ("author_function_1", $this->aut_array[$as]["fonction"], $ptab_aut_autres);
				$this->substitute ("author_function_label_1", $fonction->table[$this->aut_array[$as]["fonction"]], $ptab_aut_autres);
				for ($type = 70; $type <= 71; $type++) {
					if ($this->aut_array[$as]["type_auteur"] == $type) $sel = " selected";
						else $sel = "";
					$this->substitute ("author_type_".$type."_1", $sel, $ptab_aut_autres);
					}
				$autres_auteurs .= $ptab_aut_autres ;
				$nb_autres_auteurs++ ;
				}
			
			if ($this->aut_array[$as]["responsabilite"]==2) {
				if ($this->aut_array[$as]["entree"] == "") continue; 
				$ptab_aut_autres = str_replace('!!iaut!!', $nb_auteurs_secondaires, $ptab[12]) ;
				
				$this->substitute ("author_name_2", $this->aut_array[$as]["entree"], $ptab_aut_autres);
				$this->substitute ("author_rejete_2", $this->aut_array[$as]["rejete"], $ptab_aut_autres);
				$this->substitute ("author_date_2", $this->aut_array[$as]["date"], $ptab_aut_autres);
				$this->substitute ("author_function_2", $this->aut_array[$as]["fonction"], $ptab_aut_autres);
				$this->substitute ("author_function_label_2", $fonction->table[$this->aut_array[$as]["fonction"]], $ptab_aut_autres);
				for ($type = 70; $type <= 71; $type++) {
					if ($this->aut_array[$as]["type_auteur"] == $type) $sel = " selected";
						else $sel = "";
					$this->substitute ("author_type_".$type."_2", $sel, $ptab_aut_autres);
					}
				$auteurs_secondaires .= $ptab_aut_autres ;
				$nb_auteurs_secondaires++ ;
				}
			}
		// au cas ou pas d'auteur principal : on fait le mnage dans le formulaire
		$this->substitute ("author_name_0", "", $ptab[1]);
		$this->substitute ("author_rejete_0", "", $ptab[1]);
		$this->substitute ("author_date_0", "", $ptab[1]);
		$this->substitute ("author_function_0", "", $ptab[1]);
		$this->substitute ("author_function_label_0", "", $ptab[1]);
				
		$ptab[1] = str_replace('!!max_aut1!!', $nb_autres_auteurs, $ptab[1]);
		$ptab[1] = str_replace('!!max_aut2!!', $nb_auteurs_secondaires, $ptab[1]);
		
		$ptab[1] = str_replace('!!autres_auteurs!!', $autres_auteurs, $ptab[1]);
		$ptab[1] = str_replace('!!auteurs_secondaires!!', $auteurs_secondaires, $ptab[1]);
		$form_notice = str_replace('!!tab1!!', $ptab[1], $form_notice);
		
		$this->substitute ("editor_name_0", $this->editors[0]['name'], $ptab[2]);
		$this->substitute ("editor_ville_0", $this->editors[0]['ville'], $ptab[2]);
		$this->substitute ("editor_name_1", $this->editors[1]['name'], $ptab[2]);
		$this->substitute ("editor_ville_1", $this->editors[1]['ville'], $ptab[2]);
		
		$this->substitute ("collection_name", $this->collection['name'], $ptab[2]);
		$this->substitute ("collection_issn", $this->collection['issn'], $ptab[2]);
		
		$this->substitute ("subcollection_name", $this->subcollection['name'], $ptab[2]);
		$this->substitute ("subcollection_issn", $this->subcollection['issn'], $ptab[2]);

		$this->substitute ("nbr_in_collection", $this->nbr_in_collection, $ptab[2]);

		$this->substitute ("year", $this->year, $ptab[2]);
		
		$this->substitute ("mention_edition", $this->mention_edition, $ptab[2]);
		
		$form_notice = str_replace('!!tab2!!', $ptab[2], $form_notice);
		
		$this->substitute ("isbn", $this->isbn, $ptab[3]);

		$form_notice = str_replace('!!tab3!!', $ptab[3], $form_notice);
		
		$this->substitute ("page_nbr", $this->page_nbr, $ptab[4]);
		$this->substitute ("illustration", $this->illustration, $ptab[4]);
		$this->substitute ("prix", $this->prix, $ptab[4]);
		$this->substitute ("accompagnement", $this->accompagnement, $ptab[4]);
		$this->substitute ("size", $this->size, $ptab[4]);
		$form_notice = str_replace('!!tab4!!', $ptab[4], $form_notice);

		$this->substitute ("general_note", $this->general_note, $ptab[5]);
		$this->substitute ("content_note", $this->content_note, $ptab[5]);
		$this->substitute ("abstract_note", $this->abstract_note, $ptab[5]);
		$form_notice = str_replace('!!tab5!!', $ptab[5], $form_notice);

		// indexation interne
		$this->substitute ("indexint", $this->dewey[0], $ptab[6]);

		// indexation libre
		$this->substitute ("f_free_index", $this->free_index, $ptab[6]);
		global $pmb_keyword_sep ;
		if (!$pmb_keyword_sep) $pmb_keyword_sep=" ";
		$ptab[6]= str_replace("!!sep!!", htmlentities($pmb_keyword_sep,ENT_QUOTES, $charset), $ptab[6]);

		// catgories
		$max_categ = 1 ;
		$ptab_categ = str_replace('!!icateg!!', 0, $ptab[60]) ;
		$ptab_categ = str_replace('!!categ_id!!', 0, $ptab_categ);
		$ptab_categ = str_replace('!!categ_libelle!!', '', $ptab_categ);		
		$ptab[6] = str_replace("!!categories_repetables!!", $ptab_categ, $ptab[6]);

		$form_notice = str_replace('!!tab6!!', $ptab[6], $form_notice);

		// mise  jour de l'onglet 7 : langues
		// langues rptables
		$lang = new marc_list('lang');
		if (sizeof($this->language_code)==0) $max_lang = 1 ;
			else $max_lang = sizeof($this->language_code) ; 
		for ($i = 0 ; $i < $max_lang ; $i++) {
			if ($i) $ptab_lang = str_replace('!!ilang!!', $i, $ptab[701]) ;
				else $ptab_lang = str_replace('!!ilang!!', $i, $ptab[70]) ;
			if ( sizeof($this->language_code)==0 ) { 
				$ptab_lang = str_replace('!!lang_code!!', '', $ptab_lang);
				$ptab_lang = str_replace('!!lang!!', '', $ptab_lang);		
				} else {
					$ptab_lang = str_replace('!!lang_code!!', $this->language_code[$i], $ptab_lang);
					$ptab_lang = str_replace('!!lang!!',htmlentities($lang->table[$this->language_code[$i]],ENT_QUOTES, $charset), $ptab_lang);
					}
			$lang_repetables .= $ptab_lang ;
			}
		$ptab[7] = str_replace('!!max_lang!!', $max_lang, $ptab[7]);
		$ptab[7] = str_replace('!!langues_repetables!!', $lang_repetables, $ptab[7]);

		// langues originales rptables
		if (sizeof($this->original_language_code)==0) $max_langorg = 1 ;
			else $max_langorg = sizeof($this->original_language_code) ; 
		for ($i = 0 ; $i < $max_langorg ; $i++) {
			if ($i) $ptab_lang = str_replace('!!ilangorg!!', $i, $ptab[711]) ;
				else $ptab_lang = str_replace('!!ilangorg!!', $i, $ptab[71]) ;
			if ( sizeof($this->original_language_code)==0 ) { 
				$ptab_lang = str_replace('!!langorg_code!!', '', $ptab_lang);
				$ptab_lang = str_replace('!!langorg!!', '', $ptab_lang);		
				} else {
					$ptab_lang = str_replace('!!langorg_code!!', $this->original_language_code[$i], $ptab_lang);
					$ptab_lang = str_replace('!!langorg!!',htmlentities($lang->table[$this->original_language_code[$i]],ENT_QUOTES, $charset), $ptab_lang);
					}
			$langorg_repetables .= $ptab_lang ;
			}
		$ptab[7] = str_replace('!!max_langorg!!', $max_langorg, $ptab[7]);
		$ptab[7] = str_replace('!!languesorg_repetables!!', $langorg_repetables, $ptab[7]);

		$form_notice = str_replace('!!tab7!!', $ptab[7], $form_notice);

		$this->substitute ("link_url", $this->link_url, $ptab[8]);
		$this->substitute ("link_format", $this->link_format, $ptab[8]);

		$form_notice = str_replace('!!tab8!!', $ptab[8], $form_notice);

		// dfinition de la page cible du form
		$form_notice = str_replace('!!action!!', $this->action, $form_notice);

		// ajout des selecteurs
		$select_doc = new marc_select('doctype', 'typdoc', $this->document_type);
		$form_notice = str_replace('!!document_type!!', $select_doc->display, $form_notice);

		$form_notice = str_replace('!!orinot_nom!!', $this->origine_notice[nom], $form_notice);
		$form_notice = str_replace('!!orinot_pays!!', $this->origine_notice[pays], $form_notice);

		// traitement des catgories : affichage dans le formulaire
		$tableau_600 = array(
								"info_600_a" => $this->info_600_a,
								"info_600_j" => $this->info_600_j,
								"info_600_x" => $this->info_600_x,
								"info_600_y" => $this->info_600_y,
								"info_600_z" => $this->info_600_z);
		$tableau_601 = array(
								"info_601_a" => $this->info_601_a,
								"info_601_j" => $this->info_601_j,
								"info_601_x" => $this->info_601_x,
								"info_601_y" => $this->info_601_y,
								"info_601_z" => $this->info_601_z);
		$tableau_602 = array(
								"info_602_a" => $this->info_602_a,
								"info_602_j" => $this->info_602_j,
								"info_602_x" => $this->info_602_x,
								"info_602_y" => $this->info_602_y,
								"info_602_z" => $this->info_602_z);
		$tableau_605 = array(
								"info_605_a" => $this->info_605_a,
								"info_605_j" => $this->info_605_j,
								"info_605_x" => $this->info_605_x,
								"info_605_y" => $this->info_605_y,
								"info_605_z" => $this->info_605_z);
		$tableau_606 = array(
								"info_606_a" => $this->info_606_a,
								"info_606_j" => $this->info_606_j,
								"info_606_x" => $this->info_606_x,
								"info_606_y" => $this->info_606_y,
								"info_606_z" => $this->info_606_z);
		$tableau_607 = array(
								"info_607_a" => $this->info_607_a,
								"info_607_j" => $this->info_607_j,
								"info_607_x" => $this->info_607_x,
								"info_607_y" => $this->info_607_y,
								"info_607_z" => $this->info_607_z);
			
		
		$traitement_rameau=traite_categories_for_form($tableau_600,$tableau_601,$tableau_602,$tableau_605,$tableau_606,$tableau_607);
		$form_notice = str_replace('!!traitement_rameau!!', $traitement_rameau, $form_notice);

		//Mise  jour de l'onglet 9
		$p_perso=new parametres_perso("notices");
		if (!$p_perso->no_special_fields) {
			$perso_=$p_perso->show_editable_fields($id_notice);
			$perso="";
			for ($i=0; $i<count($perso_["FIELDS"]); $i++) {
				$p=$perso_["FIELDS"][$i];
				$perso.="<div class='row'>
					<label for='".$p["NAME"]."' class='etiquette'>".$p["TITRE"]."</label>
					</div>
					<div class='row'>
					".$p["AFF"]."
					</div>
					";
				}
			$perso.=$perso_["CHECK_SCRIPTS"];
			$ptab[9]=str_replace("!!champs_perso!!",$perso,$ptab[9]);
		} else 
			$ptab[9]="\n<script>function check_form() { return true; }</script>\n";
		$form_notice = str_replace('!!tab9!!', $ptab[9], $form_notice);

		// champs de gestion
		global $deflt_notice_statut;
		if ($id_notice) {
			$rqt_statut="select statut from notices where notice_id='$id_notice' ";
			$res_statut=mysql_query($rqt_statut);
			$stat = mysql_fetch_object($res_statut) ;
			$select_statut = gen_liste_multiple ("select id_notice_statut, gestion_libelle from notice_statut order by 2", "id_notice_statut", "gestion_libelle", "id_notice_statut", "form_notice_statut", "", $stat->statut, "", "","","",0) ;
			} else $select_statut = gen_liste_multiple ("select id_notice_statut, gestion_libelle from notice_statut order by 2", "id_notice_statut", "gestion_libelle", "id_notice_statut", "form_notice_statut", "", $deflt_notice_statut, "", "","","",0) ;
		$ptab[10] = str_replace('!!notice_statut!!', $select_statut, $ptab[10]);
		$ptab[10] = str_replace('!!commentaire_gestion!!',htmlentities($this->commentaire_gestion,ENT_QUOTES, $charset), $ptab[10]);
		$form_notice = str_replace('!!tab10!!', $ptab[10], $form_notice);

		// maxman: le bouton "retour resultats de la recherche" devient en liens 
		$aac=explode('&',$action);
		$retact='&'.$aac[2].'&'.$aac[5].'&'.$aac[6];
		$retares="<a href='./catalog.php?categ=z3950&action=display".$retact."'>".$msg[z3950_retour_a_resultats]."</a>";
		$form_notice = str_replace('!!retour_a_resultats!!', $retares, $form_notice);
		
		if (!$id_notice) $form_notice = str_replace('!!bouton_integration!!', $msg[z3950_integr_not_seule], $form_notice);
			else $form_notice = str_replace('!!bouton_integration!!', $msg[notice_z3950_remplace_catal], $form_notice);
		$form_notice = str_replace('!!id_notice!!', $id_notice, $form_notice);
		$form_notice = str_replace('!!notice!!',$znotices_id,$form_notice);
		$form_notice = str_replace('!!notice_type!!',$this->notice_type,$form_notice);
		return $form_notice;
		}

	// Traitement retour du formulaire
	function from_form () {
		global $typdoc, $b_level, $h_level, $f_title_0, $f_title_1, $f_title_2, $f_title_3, $f_serie, $f_nbr_in_serie ;
		global $f_editor_name_0, $f_editor_ville_0, $f_editor_name_1, $f_editor_ville_1, $f_collection_name, $f_collection_issn, $f_subcollection_name, $f_subcollection_issn,
			$f_nbr_in_collection, $f_year, $f_mention_edition, $f_cb, $f_page_nbr, $f_illustration, $f_size, $f_prix, $f_accompagnement,
			$f_general_note, $f_content_note, $f_abstract_note, 
			$f_indexint, $f_indexint_id, $f_free_index,
			$f_language_code, $f_original_language_code,
			$f_link_url, $f_link_format,
			$f_orinot_nom, $f_orinot_pays,
			$form_notice_statut, $f_commentaire_gestion ;
		global $categ_pas_trouvee, $pmb_keyword_sep ; 
			
		$this->document_type = clean_string ($typdoc);

		$this->bibliographic_level = clean_string ($b_level);
		$this->hierarchic_level = clean_string ($h_level);

		$this->titles[0] = clean_string ($f_title_0);
		$this->titles[1] = clean_string ($f_title_1);
		$this->titles[2] = clean_string ($f_title_2);
		$this->titles[3] = clean_string ($f_title_3);
		$this->serie = clean_string ($f_serie);
		$this->nbr_in_serie = clean_string ($f_nbr_in_serie);

		$this->aut_array = array () ;
		global $max_aut1, $max_aut2 ;
		// auteur principal
		global $f_author_name_0, $f_author_rejete_0, $f_author_date_0, $f_author_type_0, $f_author_function_0 ;
		$this->aut_array[] = array(
			'entree' => stripslashes($f_author_name_0),
			'rejete' => stripslashes($f_author_rejete_0),
			'date' => stripslashes($f_author_date_0),
			'type_auteur' => $f_author_type_0,
			'fonction' => $f_author_function_0,
			'id' => 0,
			'responsabilite' => 0 );
		// autres auteurs
		for ($i=0; $i< $max_aut1 ; $i++) {
			$var_aut_name = "f_author_name_1$i" ;
			$var_aut_rejete = "f_author_rejete_1$i" ;
			$var_aut_date = "f_author_date_1$i" ;
			$var_aut_type_auteur = "f_author_type_1$i" ;
			$var_aut_function = "f_author_function_1$i" ;
			global $$var_aut_name, $$var_aut_rejete, $$var_aut_date, $$var_aut_type_auteur, $$var_aut_function ;
			if ($$var_aut_name) 
				$this->aut_array[] = array(
					'entree' => stripslashes($$var_aut_name),
					'rejete' => stripslashes($$var_aut_rejete),
					'date' => stripslashes($$var_aut_date),
					'type_auteur' => $$var_aut_type_auteur,
					'fonction' => $$var_aut_function,
					'id' => 0,
					'responsabilite' => 1 );
			}
		// auteurs secondaires
		for ($i=0; $i< $max_aut2 ; $i++) {
			$var_aut_name = "f_author_name_2$i" ;
			$var_aut_rejete = "f_author_rejete_2$i" ;
			$var_aut_date = "f_author_date_2$i" ;
			$var_aut_type_auteur = "f_author_type_2$i" ;
			$var_aut_function = "f_author_function_2$i" ;
			global $$var_aut_name, $$var_aut_rejete, $$var_aut_date, $$var_aut_type_auteur, $$var_aut_function ;
			if ($$var_aut_name) 
				$this->aut_array[] = array(
					'entree' => stripslashes($$var_aut_name),
					'rejete' => stripslashes($$var_aut_rejete),
					'date' => stripslashes($$var_aut_date),
					'type_auteur' => $$var_aut_type_auteur,
					'fonction' => $$var_aut_function,
					'id' => 0,
					'responsabilite' => 2 );
			}

		$this->editors[0]['name'] = clean_string (stripslashes($f_editor_name_0));
		$this->editors[0]['ville'] = clean_string (stripslashes($f_editor_ville_0));
		
		$this->editors[1]['name'] = clean_string (stripslashes($f_editor_name_1));
		$this->editors[1]['ville'] = clean_string (stripslashes($f_editor_ville_1));

		$this->collection['name'] = clean_string (stripslashes($f_collection_name));
		$this->collection['issn'] = clean_string (stripslashes($f_collection_issn));
		$this->subcollection['name'] = clean_string (stripslashes($f_subcollection_name));
		$this->subcollection['issn'] = clean_string (stripslashes($f_subcollection_issn));
		
		$this->nbr_in_collection = clean_string ($f_nbr_in_collection);

		$this->year = clean_string ($f_year);
		$this->mention_edition = clean_string ($f_mention_edition);

		$this->isbn = clean_string ($f_cb);

		$this->page_nbr = clean_string ($f_page_nbr);
		$this->illustration = clean_string ($f_illustration);
		$this->size = clean_string ($f_size);
		$this->prix = clean_string ($f_prix);
		$this->accompagnement = clean_string ($f_accompagnement);

		$this->general_note = clean_string  ($f_general_note);
		$this->content_note = clean_string  ($f_content_note);
		$this->abstract_note = clean_string ($f_abstract_note);

		// catgories
		$this->categories = traite_categories_from_form();

		$this->dewey[0] = clean_string (stripslashes($f_indexint));
		$this->internal_index = $f_indexint_id ;
		
		// $categ_pas_trouvee ; est un tableau de catgories pas trouves, 
		//		mots cls pas prsents dans $this->categories mais  conserver en zone libre
		if (!$categ_pas_trouvee) $categ_pas_trouvee=array();
		for ($i=0;$i<count($categ_pas_trouvee);$i++) if (trim($categ_pas_trouvee[$i])) $categ_pas_trouvee_pasvide[]=trim($categ_pas_trouvee[$i]);
		$categ_pas_trouvee_str[]=addslashes(implode($pmb_keyword_sep,$categ_pas_trouvee_pasvide));
		if ($f_free_index) $categ_pas_trouvee_str[]=$f_free_index;
		$f_free_index=implode($pmb_keyword_sep,$categ_pas_trouvee_str);
		$this->free_index = clean_string ($f_free_index);
		
		$this->language_code = clean_string ($f_language_code);
		$this->original_language_code = clean_string ($f_original_language_code);
		
		$this->link_url = clean_string ($f_link_url);
		$this->link_format = clean_string ($f_link_format);

		$this->origine_notice[nom] = clean_string ($f_orinot_nom);
		$this->origine_notice[pays] = clean_string ($f_orinot_pays);

		$this->statut = $form_notice_statut ;
		$this->commentaire_gestion = $f_commentaire_gestion ;
		
		}

	function process_isbn ($isbn) {
		/* We've got everything, let's have a look if ISBN already exists in notices table */
		$isbn_nettoye = preg_replace('/-|\.| |\(|\)|\[|\]|\:|\;|[A-WY-Z]/i', '', $isbn);
		$isbn_nettoye_13 = substr($isbn_nettoye,0,13);
		$isbn_nettoye_10 = substr($isbn_nettoye,0,10);
		$isbn_OK = "";
		if(isEAN($isbn_nettoye_13)) { /* it's an EAN -> convert it to ISBN */
			$isbn_OK = EANtoISBN($isbn_nettoye_13);
		} 
		if (!$isbn_OK) {
			if (isISBN($isbn_nettoye_10)) {
				$isbn_OK = formatISBN($isbn_nettoye_10);
			}
		}
		if (!$isbn_OK) $isbn_OK = clean_string($isbn);

		return $isbn_OK;
	}
		
	function process_author ($name, $rejete, $type, $date) {
		if (!$rejete) {
			$field = explode (',', $name, 2);
			$name = $field[0];
			$rejete = $field[1];
		}
		
		$name = $this->clean_field ($name);
		$rejete = $this->clean_field ($rejete);
			
		$author['name'] = $name;
		$author['rejete'] = $rejete;
		$author['type'] = $type;
		$author['date'] = $date;

		return $author;
	}
		
	function clean_field ($field) {
		return preg_replace('/-$| $|\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|([^ ].)\.$|,$/', '$1', trim ($field));
	}

	function from_usmarc ($record) {
		$this->document_type = $record->inner_guide[dt];
		$this->bibliographic_level = $record->inner_guide[bl];
		$this->hierarchic_level = $record->inner_guide[hl];
		
		if ($this->bibliographic_level=="a") $this->bibliographic_level="m";

		if ($this->hierarchic_level=="") {
			if ($this->bibliographic_level=="s") $this->hierarchic_level="1";
			if ($this->bibliographic_level=="m") $this->hierarchic_level="0";
		}
		$tit_for_2= array();

		for ($i=0;$i<count($record->inner_directory);$i++) {
			$cle=$record->inner_directory[$i]['label'];
			switch($cle) {
//-------------------------------------> L L I U R E X <--------------------------------------
				case "008": /* language */
					$subrecord = $record->get_subfield($cle);
					$subrecord[0]=trim(ereg_replace( '\|', ' ', $subrecord[0]));
					$subrecord_s = explode(" ", $subrecord[0]);
					if (strlen($subrecord_s[count($subrecord_s)-1]) == 3) $this->language_code = array( 0 => $subrecord_s[count($subrecord_s)-1]);
					else $this->language_code = array(0 => $subrecord_s[count($subrecord_s)-2]);
					break;
				case "020": /* isbn */
					$isbn = $record->get_subfield($cle,'a');
					break;
				case "041": /* language */
					$this->language_code = $record->get_subfield_array($cle,"a");
					$this->original_language_code = $record->get_subfield_array($cle,"h");
					break;
				case "245": /* titles */
					$tit = $record->get_subfield($cle, "a", "b", "c", "n", "p");
					break;
				case "246": /* titles */
					$tit_sup=$record->get_subfield($cle, "a");
					break;
				case "247": /* former title */
					$tit_for=$record->get_subfield($cle, "a");
					break;
				case "740": /* former title */
					$tit_for_2=$record->get_subfield($cle, "a");
 					break;
				case "250": /* mention_edition */
					$subfield = $record->get_subfield($cle,"a");
					$this->mention_edition = $subfield[0];
					break;
				case "260": /* publisher */
					$editor = $record->get_subfield($cle,"a","b","c");
					break;
				case "300": /* description */
					$subfield = $record->get_subfield($cle,"a");
					$this->page_nbr = $this->clean_field ($subfield[0]);
					$subfield = $record->get_subfield($cle,"b");
					$this->illustration = $this->clean_field ($subfield[0]);
					$subfield = $record->get_subfield($cle,"c");
					$this->size = $this->clean_field ($subfield[0]);
					$subfield = $record->get_subfield($cle,"e");
					$this->accompagnement = $this->clean_field ($subfield[0]);
					break;
				case "022": /* collection */
					$collection_022=$record->get_subfield($cle,"a");
					break;
				case "080": /* Dewey */
					$this->dewey=$record->get_subfield($cle,"a");
					break;
				case "222": /* collection */
					$collection_222=$record->get_subfield($cle,"a","v","x");
					break;
				case "440": /* collection */
					$collection_440=$record->get_subfield($cle,"a","v","x");
					break;
				case "500": /* inside */
					$general_note = $record->get_subfield($cle,"a");
					break;
				case "502": /* abstract */
					$content_note = $record->get_subfield($cle,"a");
					break;
				case "504": /* abstract */
					$content_note_504 = $record->get_subfield($cle,"a");
					break;
				case "505": /* abstract */
					$content_note_505 = $record->get_subfield($cle,"a");
					break;
				case "510": /* abstract */
					$content_note_510 = $record->get_subfield($cle,"a");
					break;
				case "534": /* abstract */
					$content_note_534 = $record->get_subfield($cle,"a");
					break;
				case "546": /* abstract */
					$content_note_546 = $record->get_subfield($cle,"a");
					break;
				case "520": /* abstract */
					$abstract_note = $record->get_subfield($cle,"a");
					break;
				case "530": /* abstract */
					$content_note_530 = $record->get_subfield($cle,"a");
					break;
				case "082": /* Dewey */
					$this->dewey=$record->get_subfield($cle,"a");
					break;
				case "100":
					$aut_100=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "110":
					$aut_110=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "111":
					$aut_111=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "130":
					$aut_130=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "600":
					$info_600=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "610":
					$info_610=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "611":
					$info_611=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "630":
					$info_630=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "700":
					$aut_700=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "710":
					$aut_710=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "711":
					$aut_711=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "730":
					$aut_730=$record->get_subfield($cle,"a","d","e","4");
					break;
				case "856":
					$subfield = $record->get_subfield($cle,"u","q");
					$this->ressource = $subfield[0];
					break;
				case "650":
					$info_650_a=$record->get_subfield_array_array($cle,"a");
					$info_650_j=$record->get_subfield_array_array($cle,"j");
					$info_650_x=$record->get_subfield_array_array($cle,"x");
					$info_650_y=$record->get_subfield_array_array($cle,"y");
					$info_650_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "651":
					$info_651_a=$record->get_subfield_array_array($cle,"a");
					$info_651_j=$record->get_subfield_array_array($cle,"j");
					$info_651_x=$record->get_subfield_array_array($cle,"x");
					$info_651_y=$record->get_subfield_array_array($cle,"y");
					$info_651_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "653":
					$index_sujets=$record->get_subfield($cle,"a");
					break;
				case "490":
					$info_490_a=$record->get_subfield_array_array($cle,"a");
					$info_490_v=$record->get_subfield_array_array($cle,"v");
					break;
				case "773":
					$info_773_t=$record->get_subfield_array_array($cle,"t");
					$info_773_x=$record->get_subfield_array_array($cle,"x");
					$info_773_d=$record->get_subfield_array_array($cle,"d");
					$info_773_g=$record->get_subfield_array_array($cle,"g");
					break;
				default:
					break;
//-------------------------------------> L L I U R E X <--------------------------------------
			} /* end of switch */

		} /* end of for */

		$this->isbn = $this->process_isbn ($isbn[0]);

		/* INSERT de la notice OK, on va traiter les auteurs
		10# : personnal : type auteur 70                71# : collectivits : type auteur 71
		1 seul en 700                                   idem pour les dclinaisons          
		n en 701 n en 702
		les 7#0 tombent en auteur principal : responsability_type = 0
		les 7#1 tombent en autre auteur : responsability_type = 1
		les 7#2 tombent en auteur secondaire : responsability_type = 2
		*/
		$this->aut_array = array();
		/* on compte tout de suite le nbre d'enreg dans les rptables */
		$nb_repet_700=sizeof($aut_700);
		$nb_repet_710=sizeof($aut_710);
		$nb_repet_711=sizeof($aut_711);
		$nb_repet_730=sizeof($aut_730);

		/* renseignement de aut0 */
		if ($aut_100[0][a]!="") { /* auteur principal en 100 ? */
				
			$author=$this->process_author($aut_100[0]['a'],$aut_100[0]['b'],'','');
			
			$this->aut_array[] = array(
				"entree" => $author['name'], //$aut_100[0]['a'],
				"rejete" => $author['rejete'], //$aut_100[0]['b'],
				"type_auteur" => "70",
				"fonction" => convert_usmarc_unimarc_functions($aut_100[0][4]),
				"id" => 0,
				"responsabilite" => 0 ) ;
			} elseif ($aut_110[0]['a']!="") { /* auteur principal en 110 ? */
				$author=$this->process_author($aut_110[0]['a'],$aut_110[0]['b'],'','');
				$this->aut_array[] = array(
					"entree" => $author['name'], //$aut_110[0]['a'],
					"rejete" => $author['rejete'], //$aut_110[0]['b'],
					"type_auteur" => "71",
					"fonction" => convert_usmarc_unimarc_functions($aut_110[0][4]),
					"id" => 0,
					"responsabilite" => 0 ) ;
				} elseif ($aut_111[0]['a']!="") { /* auteur principal en 111 ? */
					$author=$this->process_author($aut_111[0]['a'],$aut_111[0]['b'],'','');
					$this->aut_array[] = array(
						"entree" => $author['name'], //$aut_111[0]['a'],
						"rejete" => $author['rejete'], //$aut_111[0]['b'],
						"type_auteur" => "71",
						"fonction" => convert_usmarc_unimarc_functions($aut_111[0][4]),
						"id" => 0,
						"responsabilite" => 0 ) ;
					} elseif ($aut_130[0]['a']!="") { /* auteur principal en 130 ? */
					$author=$this->process_author($aut_130[0]['a'],$aut_130[0]['b'],'','');
					$this->aut_array[] = array(
						"entree" => $author['name'], //$aut_130[0]['a'],
						"rejete" => $author['rejete'], //$aut_130[0]['b'],
						"type_auteur" => "71",
						"fonction" => convert_usmarc_unimarc_functions($aut_130[0][4]),
						"id" => 0,
						"responsabilite" => 0 ) ;
					} 
	
		/* renseignement de aut1 */
		for ($i=0 ; $i < $nb_repet_700 ; $i++) {
			$author=$this->process_author($aut_700[$i]['a'],$aut_700[$i]['b'],'','');
			$this->aut_array[] = array(
				"entree" => $author['name'], //$aut_700[$i]['a'],
				"rejete" => $author['rejete'], //$aut_700[$i]['b'],
				"type_auteur" => "70",
				"fonction" => convert_usmarc_unimarc_functions($aut_700[$i][4]),
				"id" => 0,
				"responsabilite" => 1 ) ;
			}
		for ($i=0 ; $i < $nb_repet_710 ; $i++) {
			$author=$this->process_author($aut_710[$i]['a'],$aut_710[$i]['b'],'','');
			$this->aut_array[] = array(
				"entree" => $author['name'], //$aut_710[$i]['a'],
				"rejete" => $author['rejete'], //$aut_710[$i]['b'],
				"type_auteur" => "71",
				"fonction" => convert_usmarc_unimarc_functions($aut_710[$i][4]),
				"id" => 0,
				"responsabilite" => 1 ) ;
			}
		/* renseignement de aut2 */
		for ($i=0 ; $i < $nb_repet_711 ; $i++) {
			$author=$this->process_author($aut_711[$i]['a'],$aut_711[$i]['b'],'','');
			$this->aut_array[] = array(
				"entree" => $author['name'], //$aut_711[$i]['a'],
				"rejete" => $author['rejete'], //$aut_711[$i]['b'],
				"type_auteur" => "71",
				"fonction" => convert_usmarc_unimarc_functions($aut_711[$i][4]),
				"id" => 0,
				"responsabilite" => 2 ) ;
			}

		/* renseignement de aut2 */
		for ($i=0 ; $i < $nb_repet_730 ; $i++) {
			$author=$this->process_author($aut_730[$i]['a'],$aut_730[$i]['b'],'','');
			$this->aut_array[] = array(
				"entree" => $author['name'], //$aut_730[$i]['a'],
				"rejete" => $author['rejete'], //$aut_730[$i]['b'],
				"type_auteur" => "71",
				"fonction" => convert_usmarc_unimarc_functions($aut_730[$i][4]),
				"id" => 0,
				"responsabilite" => 2 ) ;
			}
		
		/* Editors */
		$this->year = preg_replace ("/[^0-9\[\]()]/", "", $editor[0][c]);

		$this->editors[0]['name'] = $this->clean_field ($editor[0][b]);
		$this->editors[0]['ville'] = $this->clean_field ($editor[0][a]);

		$this->editors[1]['name'] = $this->clean_field ($editor[1][b]);
		$this->editors[1]['ville'] = $this->clean_field ($editor[1][a]);
		
		/* ici traitement des collections */
		$coll_name = "";
		$subcoll_name = "";
		$coll_issn = "";
		$subcoll_issn = "";
		$nocoll = "";

		/* traitement de 222$a, si rien alors 440$a pour la collection */
		if ($collection_222[0][a]!="") {
			$coll_name = $this->clean_field($collection_222[0][a]);
			$coll_issn = $collection_022[0][a];
		} elseif ($collection_440[0][a]!="") {
			$coll_name = $this->clean_field($collection_440[0][a]);
			$coll_issn = $collection_440[0][x];
		}

		/* traitement de 222 1, si rien alors 440 1 pour la sous-collection */
		if ($collection_222[1][a]!="") {
			$subcoll_name = $this->clean_field($collection_222[1][a]);
			$subcoll_issn = $collection_022[1][a];
		} elseif ($collection_440[1][a]!="") {
			$subcoll_name = $this->clean_field($collection_440[1][a]);
			$subsubcoll_issn = $collection_440[1][x];
		}

		/* gaffe au nocoll, en principe en 440$v */
		if ($collection_440[0][v]!="") {
			$this->nbr_in_collection = $collection_440[0][v];
		} else 
		$this->nbr_in_collection = "";

		$this->collection['name']=clean_string($coll_name);
		$this->collection['issn']=clean_string($coll_issn);

		$this->subcollection['name']=clean_string($subcoll_name);
		$this->subcollection['issn']=clean_string($subcoll_issn);
		
		global $pmb_keyword_sep ;
		if (!$pmb_keyword_sep) $pmb_keyword_sep=" ";
//-------------------------------------> L L I U R E X <--------------------------------------
		/* Series */
		if (strlen($info_490_a) > 0) {
			for ($i = 0; $i < sizeof($info_490_a); $i++) {
				if (is_array($info_490_a[$i])) $this->serie .= clean_string(implode ($pmb_keyword_sep,$info_490_a[$i])." ");
				else $this->serie .= clean_string($info_490_a[$i]." ");
			}

			for ($i = 0; $i < sizeof($info_490_v); $i++) {
				if (is_array($info_490_v[$i])) $this->nbr_in_serie .= clean_string(implode ($pmb_keyword_sep,$info_490_v[$i])." ");
				else $this->nbr_in_serie .= clean_string($info_490_v[$i]." ");
			}
		} else {
			$this->serie = clean_string ($tit[0][p]);
			$this->nbr_in_serie = clean_string ($tit[0][n]);
		}

		/* traitement ressources */
		$this->link_url = $this->ressource["u"];
		if ($this->ressource["3"]) $this->link_format = $this->ressource["3"];
		else $this->link_format = $this->ressource["2"];

		/* traitement des titres */

		$this->titles[0] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$|\\$|\.+$/', '', trim($tit[0][a]));
		if (is_array($tit_sup[0][a])) $this->titles[1] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim($tit_sup[0][a]));
		elseif (is_array($tit_sup)) $this->titles[1] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim(implode(", ", $tit_sup)));
		else $this->titles[1] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim($tit_sup));

		if (is_array($tit_for[0][a])) $this->titles[2] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim($tit_for[0][a]));
		else $this->titles[2] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim($tit_for));


		if (is_array($tit_for_2[0][a])) $this->titles[2] .= preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim(implode(", ",$tit_for_2[0][a])));
		elseif (is_array($tit_for_2)) $this->titles[2] .= preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim(implode(", ",$tit_for_2)));
		else $this->titles[2] .= preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim($tit_for_2));
		$this->titles[3] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.+$/', '', trim($tit[0][b])." ".trim($tit[0][c]));
//-------------------------------------> L L I U R E X <--------------------------------------

		$this->general_note = "";
		$this->content_note = "";
		$this->abstract_note = "";

		/* prepare index_titre field for searching */				
		for ($i = 0; $i < count ($abstract_note); $i++) {
			$this->abstract_note .= $abstract_note[$i]." ";
		}
		for ($i = 0; $i < count($general_note); $i++) {
			$this->general_note .= $general_note[$i]." ";
		}
		for ($i = 0; $i < count ($content_note); $i++) {
			$this->content_note .= $content_note[$i]." ";
		}
		if (trim ($this->abstract_note) == "") 
			$this->abstract_note = $this->general_note." ".$this->content_note;


//-------------------------------------> L L I U R E X <--------------------------------------
		for ($i = 0; $i < count ($content_note_504); $i++) {
			if (strlen($this->general_note) > 0) $this->general_note .= ". ".$content_note_504[$i];
			else $this->general_note .= $content_note_504[$i];
		}

		for ($i = 0; $i < count ($content_note_510); $i++) {
			if (strlen($this->general_note) > 0) $this->general_note .= ". ".$content_note_510[$i];
			else $this->general_note .= $content_note_510[$i];
		}

		for ($i = 0; $i < count ($content_note_530); $i++) {
			if (strlen($this->general_note) > 0) $this->general_note .= ". ".$content_note_530[$i];
			else $this->general_note .= $content_note_530[$i];
		}

		$this->matieres_index = strip_empty_words ($this->content_note." ".$this->general_note." ".$this->abstract_note);

		for ($i = 0; $i < count ($content_note_505); $i++) {
			if (strlen($this->content_note) > 0) $this->content_note .= ". ".$content_note_505[$i];
			else $this->content_note .= $content_note_505[$i];
		}

		for ($i = 0; $i < count ($content_note_534); $i++) {
			if (strlen($this->content_note) > 0) $this->content_note .= ". ".$content_note_534[$i];
			else $this->content_note .= $content_note_534[$i];
		}

		for ($i = 0; $i < count ($content_note_546); $i++) {
			if (strlen($this->content_note) > 0) $this->content_note .= ". ".$content_note_546[$i];
			else $this->content_note .= $content_note_546[$i];
		}
//-------------------------------------> L L I U R E X <--------------------------------------

		global $pmb_keyword_sep ;
		if (!$pmb_keyword_sep) $pmb_keyword_sep=" ";
		if (is_array($index_sujets)) $this->free_index = implode ($pmb_keyword_sep,$index_sujets);
			else $this->free_index = $index_sujets;


//-------------------------------------> L L I U R E X <--------------------------------------
		for ($i=0 ; $i < sizeof($info_600) ; $i++) {
			$author=$this->process_author($aut_600[$i]['a'],$aut_600[$i]['b'],'','');
			if ($author['rejete'])
				$this->free_index .= $author = $author['rejete']." ".$author['name'].$pmb_keyword_sep;
			else
				$this->free_index .= $author['name'].$pmb_keyword_sep;
			}

		for ($i=0 ; $i < sizeof($info_610) ; $i++) {
			$author=$this->process_author($aut_610[$i]['a'],$aut_610[$i]['b'],'','');
			if ($author['rejete'])
				$this->free_index .= $author = $author['rejete']." ".$author['name'].$pmb_keyword_sep;
			else
				$this->free_index .= $author['name'].$pmb_keyword_sep;
			}

		for ($i=0 ; $i < sizeof($info_611) ; $i++) {
			$author=$this->process_author($aut_611[$i]['a'],$aut_611[$i]['b'],'','');
			if ($author['rejete'])
				$this->free_index .= $author = $author['rejete']." ".$author['name'].$pmb_keyword_sep;
			else
				$this->free_index .= $author['name'].$pmb_keyword_sep;
			}

		for ($i=0 ; $i < sizeof($info_630) ; $i++) {
			$author=$this->process_author($aut_630[$i]['a'],$aut_630[$i]['b'],'','');
			if ($author['rejete'])
				$this->free_index .= $author = $author['rejete']." ".$author['name'].$pmb_keyword_sep;
			else
				$this->free_index .= $author['name'].$pmb_keyword_sep;
			}

		for ($i = 0; $i < sizeof($info_650_a); $i++) {
			if (is_array($info_650_a[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_650_a[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_650_a[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_650_j); $i++) {
			if (is_array($info_650_j[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_650_j[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_650_j[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_650_x); $i++) {
			if (is_array($info_650_x[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_650_x[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_650_x[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_650_y); $i++) {
			if (is_array($info_650_y[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_650_y[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_650_y[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_650_z); $i++) {
			if (is_array($info_650_z[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_650_z[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_650_z[$i].$pmb_keyword_sep;
		}
		
		for ($i = 0; $i < sizeof($info_651_a); $i++) {
			if (is_array($info_651_a[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_651_a[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_651_a[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_651_j); $i++) {
			if (is_array($info_651_j[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_651_j[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_651_j[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_651_x); $i++) {
			if (is_array($info_651_x[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_651_x[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_651_x[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_651_y); $i++) {
			if (is_array($info_651_y[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_651_y[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_651_y[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_651_z); $i++) {
			if (is_array($info_651_z[$i])) $this->free_index .= implode ($pmb_keyword_sep,$info_651_z[$i]).$pmb_keyword_sep;
			else $this->free_index .= $info_651_z[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_773_t); $i++) {
			if (strlen($this->abstract_note) > 0) $sep=". ";
			else $sep="";
			if (is_array($info_773_t[$i])) $this->abstract_note .= $sep.implode ($pmb_keyword_sep,$info_773_t[$i]).$pmb_keyword_sep;
			else $this->abstract_note .= $sep.$info_773_t[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_773_x); $i++) {
			if (strlen($this->abstract_note) > 0) $sep=". ";
			else $sep="";
			if (is_array($info_773_x[$i])) $this->abstract_note .= $sep.implode ($pmb_keyword_sep,$info_773_x[$i]).$pmb_keyword_sep;
			else $this->abstract_note .= $sep.$info_773_x[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_773_d); $i++) {
			if (strlen($this->abstract_note) > 0) $sep=". ";
			else $sep="";
			if (is_array($info_773_d[$i])) $this->abstract_note .= $sep.implode ($pmb_keyword_sep,$info_773_d[$i]).$pmb_keyword_sep;
			else $this->abstract_note .= $sep.$info_773_d[$i].$pmb_keyword_sep;
		}

		for ($i = 0; $i < sizeof($info_773_g); $i++) {
			if (strlen($this->abstract_note) > 0) $sep=". ";
			else $sep="";
			if (is_array($info_773_g[$i])) $this->abstract_note .= $sep.implode ($pmb_keyword_sep,$info_773_g[$i]).$pmb_keyword_sep;
			else $this->abstract_note .= $sep.$info_773_g[$i].$pmb_keyword_sep;
		}

//-------------------------------------> L L I U R E X <--------------------------------------
	}

	function from_unimarc ($record) {

		$this->document_type = $record->inner_guide[dt];
		$this->bibliographic_level = $record->inner_guide[bl];
		$this->hierarchic_level = $record->inner_guide[hl];

		if ($this->hierarchic_level=="") {
			if ($this->bibliographic_level=="s") $this->hierarchic_level="1";
			if ($this->bibliographic_level=="m") $this->hierarchic_level="0";
			}

		for ($i=0;$i<count($record->inner_directory);$i++) {
			$cle=$record->inner_directory[$i]['label'];
			switch($cle) {
				case "010": /* isbn */
					$isbn = $record->get_subfield($cle,'a');
					$subfield = $record->get_subfield($cle,"d");
					$this->prix = $subfield[0];
					break;
				case "071": /* barcode */
					$cb = $record->get_subfield($cle,"a");
					break;
				case "101": /* language */
					//martizva NOTE: some server send language in UPCASE!!! 
					// $subfield = $record->get_subfield($cle,"a");
					// $this->language_code = strtolower($subfield[0]);
					// $subfield = $record->get_subfield($cle,"c");
					// $this->original_language_code = strtolower($subfield[0]);
					$this->language_code = $record->get_subfield_array($cle,"a");
					$this->original_language_code = $record->get_subfield_array($cle,"c");
					break;
				case "200": /* titles */
					$tit = $record->get_subfield($cle, 'a', 'c', 'd', 'e', 'v');
					break;
				case "205": /* mention_edition */
					$subfield = $record->get_subfield($cle,"a");
					$this->mention_edition = $subfield[0];
					break;
				case "210": /* publisher */
					$editor = $record->get_subfield($cle,"a","c","d");
					break;
				case "215": /* description */
					$subfield = $record->get_subfield($cle,"a");
					$this->page_nbr = $subfield[0];
					$subfield = $record->get_subfield($cle,"c");
					$this->illustration = $subfield[0];
					$subfield = $record->get_subfield($cle,"d");
					$this->size = $subfield[0];
					$subfield = $record->get_subfield($cle,"e");
					$this->accompagnement = $subfield[0];
					break;
				case "225": /* collection */
					$collection_225 = $record->get_subfield($cle,"a","i","v","x");
					break;
				case "300": /* inside */
					$general_note = $record->get_subfield($cle,"a");
					break;
				case "327": /* inside */
					$content_note=$record->get_subfield_array($cle,"a");
					break;
				case "330": /* abstract */
					$abstract_note = $record->get_subfield($cle,"a");
					break;
				case "345": /* EAN */
					$EAN=$record->get_subfield($cle,"b");
					break;
				case "410": /* collection */
					$collection_410 = $record->get_subfield($cle,"t","v","x");
					break;
				case "411": /* sub-collection */
					$collection_411 = $record->get_subfield($cle,"t","v","x");
					break;
				case "461": /* series */
					$serie = $record->get_subfield($cle,"t");
					break;
				case "600": // 600 PERSONAL NAME USED AS SUBJECT
					$this->info_600_a=$record->get_subfield_array_array($cle,"a");
					$this->info_600_j=$record->get_subfield_array_array($cle,"j");
					$this->info_600_x=$record->get_subfield_array_array($cle,"x");
					$this->info_600_y=$record->get_subfield_array_array($cle,"y");
					$this->info_600_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "601": // 601 CORPORATE BODY NAME USED AS SUBJECT
					$this->info_601_a=$record->get_subfield_array_array($cle,"a");
					$this->info_601_j=$record->get_subfield_array_array($cle,"j");
					$this->info_601_x=$record->get_subfield_array_array($cle,"x");
					$this->info_601_y=$record->get_subfield_array_array($cle,"y");
					$this->info_601_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "602": // 602 FAMILY NAME USED AS SUBJECT
					$this->info_602_a=$record->get_subfield_array_array($cle,"a");
					$this->info_602_j=$record->get_subfield_array_array($cle,"j");
					$this->info_602_x=$record->get_subfield_array_array($cle,"x");
					$this->info_602_y=$record->get_subfield_array_array($cle,"y");
					$this->info_602_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "605": // 605 TITLE USED AS SUBJECT
					$this->info_605_a=$record->get_subfield_array_array($cle,"a");
					$this->info_605_j=$record->get_subfield_array_array($cle,"j");
					$this->info_605_x=$record->get_subfield_array_array($cle,"x");
					$this->info_605_y=$record->get_subfield_array_array($cle,"y");
					$this->info_605_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "606": // RAMEAU / TOPICAL NAME USED AS SUBJECT
					$this->info_606_a=$record->get_subfield_array_array($cle,"a");
					$this->info_606_j=$record->get_subfield_array_array($cle,"j");
					$this->info_606_x=$record->get_subfield_array_array($cle,"x");
					$this->info_606_y=$record->get_subfield_array_array($cle,"y");
					$this->info_606_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "607": // 607 GEOGRAPHICAL NAME USED AS SUBJECT
					$this->info_607_a=$record->get_subfield_array_array($cle,"a");
					$this->info_607_j=$record->get_subfield_array_array($cle,"j");
					$this->info_607_x=$record->get_subfield_array_array($cle,"x");
					$this->info_607_y=$record->get_subfield_array_array($cle,"y");
					$this->info_607_z=$record->get_subfield_array_array($cle,"z");
					break;
				case "610": /* mots cl */
					$index_sujets=$record->get_subfield($cle,"a");
					break;
				case "676": /* Dewey */
					$this->dewey=$record->get_subfield($cle,"a");
					break;
				case "700":
					$aut_700=$record->get_subfield($cle,"a","b","4","f");
					break;
				case "701":
					$aut_701=$record->get_subfield($cle,"a","b","4","f");
					break;
				case "702":
					$aut_702=$record->get_subfield($cle,"a","b","4","f");
					break;
				case "710":
					$aut_710=$record->get_subfield($cle,"a","b","4","f");
					break;
				case "711":
					$aut_711=$record->get_subfield($cle,"a","b","4","f");
					break;
				case "712":
					$aut_712=$record->get_subfield($cle,"a","b","4","f");
					break;
				case "801": /* origine du catalogage */
					$origine_notice=$record->get_subfield($cle,"a","b");
					break;
				case "856":
					$ressource = $record->get_subfield($cle,"u","q");
					break;
				case "995": /* infos de la BDP */
					$info_995 = $record->get_subfield($cle,"a","b","c","d","f","k","m","n","o","r","u");
					break;
				default:
					break;

			} /* end of switch */

		} /* end of for */

		$this->isbn = $this->process_isbn ($isbn[0]);

		/* INSERT de la notice OK, on va traiter les auteurs
		70# : personnal : type auteur 70                71# : collectivits : type auteur 71
		1 seul en 700                                   idem pour les dclinaisons          
		n en 701 n en 702
		les 7#0 tombent en auteur principal : responsability_type = 0
		les 7#1 tombent en autre auteur : responsability_type = 1
		les 7#2 tombent en auteur secondaire : responsability_type = 2
		*/
		$this->aut_array = array();
		/* on compte tout de suite le nbre d'enreg dans les rptables */
		$nb_repet_701=sizeof($aut_701);
		$nb_repet_711=sizeof($aut_711);
		$nb_repet_702=sizeof($aut_702);
		$nb_repet_712=sizeof($aut_712);

		/* renseignement de aut0 */
		if ($aut_700[0][a]!="") { /* auteur principal en 700 ? */
			$this->aut_array[] = array(
				"entree" => $aut_700[0]['a'],
				"rejete" => $aut_700[0]['b'],
				"date" => $aut_700[0]['f'],
				"type_auteur" => "70",
				"fonction" => $aut_700[0][4],
				"id" => 0,
				"responsabilite" => 0 ) ;
			} elseif ($aut_710[0]['a']!="") { /* auteur principal en 710 ? */
				$this->aut_array[] = array(
					"entree" => $aut_710[0]['a'],
					"rejete" => $aut_710[0]['b'],
					"date" => $aut_710[0]['f'],
					"type_auteur" => "71",
					"fonction" => $aut_710[0][4],
					"id" => 0,
					"responsabilite" => 0 ) ;
				} 
	
		/* renseignement de aut1 */
		for ($i=0 ; $i < $nb_repet_701 ; $i++) {
			$this->aut_array[] = array(
				"entree" => $aut_701[$i]['a'],
				"rejete" => $aut_701[$i]['b'],
				"date" => $aut_701[$i]['f'],
				"type_auteur" => "70",
				"fonction" => $aut_701[$i][4],
				"id" => 0,
				"responsabilite" => 1 ) ;
			}
		for ($i=0 ; $i < $nb_repet_711 ; $i++) {
			$this->aut_array[] = array(
				"entree" => $aut_711[$i]['a'],
				"rejete" => $aut_711[$i]['b'],
				"date" => $aut_711[$i]['f'],
				"type_auteur" => "71",
				"fonction" => $aut_711[$i][4],
				"id" => 0,
				"responsabilite" => 1 ) ;
			}
		/* renseignement de aut2 */
		for ($i=0 ; $i < $nb_repet_702 ; $i++) {
			$this->aut_array[] = array(
				"entree" => $aut_702[$i]['a'],
				"rejete" => $aut_702[$i]['b'],
				"date" => $aut_702[$i]['f'],
				"type_auteur" => "70",
				"fonction" => $aut_702[$i][4],
				"id" => 0,
				"responsabilite" => 2 ) ;
			}
		for ($i=0 ; $i < $nb_repet_712 ; $i++) {
			$this->aut_array[] = array(
				"entree" => $aut_712[$i]['a'],
				"rejete" => $aut_712[$i]['b'],
				"date" => $aut_712[$i]['f'],
				"type_auteur" => "71",
				"fonction" => $aut_712[$i][4],
				"id" => 0,
				"responsabilite" => 2 ) ;
			}
		/*  Added for some italian z39.50 server 
		Some adjustment to clean the values from symbol like << and others */
		for ($i=0 ; $i < $nb_repet_701+$nb_repet_711+$nb_repet_702 +$nb_repet_712+1 ; $i++) {
			$this->aut_array[$i]['entree']=del_more_garbage($this->aut_array[$i]['entree']);
			$this->aut_array[$i]['rejete']=del_more_garbage($this->aut_array[$i]['rejete']);
		}
		
		/* traitement des diteurs */
		$this->year=clean_string($editor[0][d]);

		$this->editors[0]['name']=clean_string($editor[0][c]);
		$this->editors[0]['ville']=clean_string($editor[0][a]);

		$this->editors[1]['name']=clean_string($editor[1][c]);
		$this->editors[1]['ville']=clean_string($editor[1][a]);
		
		/*  Added for some italian z39.50 server 
		Some adjustment to clean the values from symbol like << and others */
		$this->editors[0]['name']=del_more_garbage($this->editors[0]['name']);
		$this->editors[1]['name']=del_more_garbage($this->editors[1]['name']);
		
		/* traitement des collections */
		$coll_name="";
		$subcoll_name="";
		$coll_issn="";
		$subcoll_issn="";
		$nocoll_ins="";

		// Collection : traitement de 225 et 410, prfrence donne au 410
		if ($collection_410[0][t]) $coll_name=$collection_410[0][t];
		elseif ($collection_225[0][a]!="") $coll_name=$collection_225[0][a];
		
		if ($collection_410[0][x]) $coll_issn=$collection_410[0][x];
		elseif ($collection_225[0][x]!="") $coll_issn=$collection_225[0][x];
		
		
		// Sous-collection : traitement de 225$i et 411, prfrence donne au 411
		if ($collection_411[0][t]) $subcoll_name=$collection_411[0][t];
		elseif ($collection_225[0][i]!="") $subcoll_name=$collection_225[0][i];
		
		if ($collection_411[0][x]) $subcoll_issn=$collection_411[0][x];

		// Numro dans la collection, prsent en 411$v, sinon en 410$v et enfin en 225$v
		if     ($collection_411[0][v]!="") $this->nbr_in_collection = $collection_411[0][v];
		elseif ($collection_410[0][v]!="") $this->nbr_in_collection = $collection_410[0][v];
		elseif ($collection_225[0][v]!="") $this->nbr_in_collection = $collection_225[0][v];
		else $this->nbr_in_collection = "";

		$this->collection['name']=clean_string($coll_name);
		$this->collection['issn']=clean_string($coll_issn);

		$this->subcollection['name']=clean_string($subcoll_name);
		$this->subcollection['issn']=clean_string($subcoll_issn);

		/*  Added for some italian z39.50 server 
		Some adjustment to clean the values from symbol like << and others */
		$this->collection['name']=del_more_garbage($this->collection['name']);
		$this->subcollection['name']=del_more_garbage($this->subcollection['name']);
		
		/* Series  TODO: Check if it's Ok */
		$this->serie = clean_string ($serie[0][t]);
		if ($this->serie)
			$this->nbr_in_serie = $serie[0][v];
		else
			$this->nbr_in_serie = "";
			
		$this->general_note = "";
		$this->content_note = "";
		$this->abstract_note = "";

		/* prepare index_titre field for searching */				
		for ($i = 0; $i < count ($abstract_note); $i++) {
			$this->abstract_note .= $abstract_note[$i]."\n";
		}
		for ($i = 0; $i < count($general_note); $i++) {
			$this->general_note .= $general_note[$i]."\n";
		}
		for ($i = 0; $i < count ($content_note); $i++) {
			$this->content_note .= $content_note[$i]."\n";
		}
		//if (trim ($this->abstract_note) == "")
		//	$this->abstract_note = $this->general_note." ".$this->content_note;

		/* traitement ressources */
		$this->link_url = $ressource[0]["u"];
		$this->link_format = $ressource[0]["q"];

		/* Titles processing */
		$this->titles[0] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.$/', '', trim($tit[0][a]));
		$this->titles[1] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.$/', '', trim($tit[0][c]));
		$this->titles[2] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.$/', '', trim($tit[0][d]));
		$this->titles[3] = preg_replace('/-$| $|\||\($|\)$|\[$|\]$|\:$|\;$|\/$\|\$|\.$/', '', trim($tit[0][e]));
		
		/*  Added for some italian z39.50 server 
		Some adjustment to clean the values from symbol like << and others */
		$this->titles[0]=del_more_garbage($this->titles[0]);
		$this->titles[1]=del_more_garbage($this->titles[1]);
		$this->titles[2]=del_more_garbage($this->titles[2]);
		$this->titles[3]=del_more_garbage($this->titles[3]);
		
		global $pmb_keyword_sep ;
		if (!$pmb_keyword_sep) $pmb_keyword_sep=" ";
		if (is_array($index_sujets)) $this->free_index = implode ($pmb_keyword_sep,$index_sujets);
			else $this->free_index = $index_sujets;
			
		$this->origine_notice['nom']=clean_string($origine_notice[0]['b']);
		$this->origine_notice['pays']=clean_string($origine_notice[0]['a']);
		
		}

	function get_isbd_display () {
		$tdoc = new marc_list('doctype');

		if ($this->aut_array[0]['rejete'])
			$author = $this->aut_array[0]['rejete']." ".$this->aut_array[0]['entree'];
		else
			$author = $this->aut_array[0]['entree'];

		$display = 
			$this->titles[0]." [".$tdoc->table[$this->document_type]."] / ".
			$author.".&nbsp;- ".
			$this->editors[0]['name'].", ".
			$this->year.".&nbsp;- ".
			$this->page_nbr." : ".
			$this->illustration." ; ".
			$this->size.".&nbsp;- (".
			$this->collection['name'].". ".
			$this->subcollection['name']." ; ".
			$this->nbr_in_collection.").<br>".
			$this->isbn.
			"<br><font size='1'>".$this->abstract_note."</font>";
		
		return array ($this->isbn, $this->titles[0], $author, $display);
	}
}

