<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: analyse_query.class.php,v 1.17 2007/10/29 13:00:07 ngantier Exp $

//Structure de stockage d'un terme
class term {
	var $word; 		//mot (si pas sous expression)
	var $operator;	//oprateur (and, or ou vide)
	var $sub;		//sous expression = tableau de term
	var $not;		//Ngation du terme (not)
	var $literal;	//Le terme est entier (il y avait des guillemets)
	var $start_with; //L'expression doit commencer par
	var $pound; 	//poids du terme
	
	//Constructeur
	function term($word,$literal,$not,$operator,$sub,$pound=1) {
		$this->word=$word;
		$this->operator=$operator;
		$this->sub=$sub;	
		$this->not=$not;		
		$this->literal=$literal;	
		$this->pound=$pound;
	}
}

//Classe d'analyse d'une requte boolenne
class analyse_query {
	var $current_car;		//Caratre courant analys
	var $parenthesis;		//Est-ce une sous expression d'une expression ?
	var $operator="";		//Oprateur du terme en cours de traitement
	var $neg=0;				//Ngation applique au terme en cours de traitement
	var $guillemet=0;		//Le terme en cours de traitement est-il entour par des guillemets
	var $input;				//Requete  analyser
	var $term="";			//Terme courant
	var $literal=0;			//Le termen en cours de traitement est-il litral ?
	var $tree=array();		//Arbre de rsultat
	var $error=0;			//Y-a-t-il eu un erreur pendant le traitement
	var $error_message="";	//Message d'erreur
	var $input_html="";		//Affichage html de la requte initiale (ventuellement avec erreur surligne)
	var $search_linked_words=1;	//rechercher les mots lis pour le mot
	
	//Constructeur
    function analyse_query($input,$debut=0,$parenthesis=0,$search_linked_words=1) {
		$this->parenthesis=$parenthesis;
		$this->current_car=$debut;
		$this->input=$input;
		$this->search_linked_words=$search_linked_words;
		$this->recurse_analyse();
    }
    
   //Stockage d'un terme dans l'arbre de rsultat
	function store_in_tree($t) {
 		//Rcupration des mots vides
 		global $empty_word;
 		//Si le terme est un mot isol et que ce n'est pas un terme litral alors on
 		//Nettoie les caratres indsirables et on supprime les mots vides
 		
 		$op_sub="";
		if (($t->sub==null) && (!$t->literal)) {
			
			if ( $this->search_linked_words) { 
				//recherche du mot et de ses synonymes ventuels
				$mot= addslashes($t->word);
				$rqt="select id_mot from mots where mot='".$mot."'";
				$execute_query=mysql_query($rqt);
				if (mysql_num_rows($execute_query)) {
					//constitution d'un tableau avec le mot et ses synonymes
					$temp_mots=array();
					$temp=array();
					$temp_mots[]=$t->word;
					$r=mysql_fetch_object($execute_query);
					$rqt1="select mot,ponderation from mots,linked_mots where type_lien=1 and num_mot=".$r->id_mot." and mots.id_mot=linked_mots.num_linked_mot";
					$execute_query1=mysql_query($rqt1);		
					
					$op_sub='or';	
					// Pour tous les synomymes associs au mot de la recherche, faire:
					while ($r1=mysql_fetch_object($execute_query1)) {
						$mot=$r1->mot;
						// Si prsence de blanc (considr alors comme terme littral) faire:
						if(strstr($mot, ' ')){
							// ajout du synonyme en litral
							$t->sub[]=new term($mot,1,0,$op_sub,"",$r1->ponderation);	
							
							//Supression des accents
							$mot = convert_diacrit($mot);
							//Remplacement de tout ce qui n'est pas a-z, 0-9, espace et * par des espaces
							$mot = pmb_alphabetic('^a-z0-9\s\*', ' ',pmb_strtolower($mot));
							// Si prsence de blanc (considr comme terme littral) faire:
							if(strstr($mot, ' ')){
								//$t->sub[]=new term($mot,1,0,$op_sub,"",$r1->ponderation);		
							} else {
								$temp[$mot]=$r1->ponderation;
								$temp_mots[]=$mot;
							}								
						} else {	
							//Supression des accents
							$mot = convert_diacrit($mot);
							//Remplacement de tout ce qui n'est pas a-z, 0-9, espace et * par des espaces
							$mot = pmb_alphabetic('^a-z0-9\s\*', ' ',pmb_strtolower($mot));
							if(strstr($mot, ' ')){
								$t->sub[]=new term($r1->mot,1,0,$op_sub,"",$r1->ponderation);		
							} else {
								$temp[$mot]=$r1->ponderation;
								$temp_mots[]=$mot;
							}
						}	
					}
					//transformation du mot et de ses synonymes en expression
					$t->word=implode(" ",$temp_mots);
				}
			}
			
			//Supression des accents
    		$string = convert_diacrit($t->word);
    		//Remplacement de tout ce qui n'est pas a-z, 0-9, espace et * par des espaces
			$string = pmb_alphabetic('^a-z0-9\s\*', ' ',pmb_strtolower($string));
			//Supression des espaces avant et aprs le terme
			$string = trim($string);
			//Dcomposition en mots du mot nettoy (ex : l'arbre devient l arbre qui donne deux mots : l et arbre)
			$words=explode(" ",$string);
			//Variable de stockage des mots restants aprs supression des mots vides
			$words_empty_free=array();
			//Pour chaque mot
			for ($i=0; $i<count($words); $i++) {
				$words[$i]=trim($words[$i]);
				//Vrification que ce n'est pas un mot vide
				if (!in_array($words[$i],$empty_word)) {
					//Si ce n'est pas un mot vide, on stock
					$words_empty_free[]=$words[$i];
				}
			}
			$t->word=implode(" ",$words_empty_free);
			
			//Reconstruction du terme et pondration des synonymes
			if(count($words_empty_free)>1) {
				for ($j=0; $j<count($words_empty_free); $j++) {				
					if ($temp_mots){
						if (array_search($words_empty_free[$j],$temp_mots)) {			
							$pound=$temp[$words_empty_free[$j]];				
						} else	$pound='';			
						$t->sub[]=new term($words_empty_free[$j],0,0,$op_sub,"",$pound);
					}
				}
			} else {
				$t->word = $words_empty_free[0];
			}		
			if (count($t->sub)){
				$t->sub[0]->operator = "";
				$t->word = '';
			}	
			//Si c'est le premier terme dans l'arbre, on supprime l'oprateur 
			if (!count($this->tree)) $t->operator="";						
			if($t->word || count($t->sub)) $this->tree[]=$t;					
    	} else {
    		//Si ce n'est pas un terme isol (sous expression) ou un terme littral
    		if (!count($this->tree)) $t->operator="";
			$this->tree[]=$t;			
		}			
	}
	
	//Affichage sous forme RPN du rsultat de l'analyse
	function show_analyse_rpn($tree="") {
		//Si tree vide alors on prend l'arbre de la classe
		if ($tree=="") $tree=$this->tree;
		$r="";
		//Pour chaque branche ou feuille de l'arbre
		for ($i=0; $i<count($tree); $i++) {
			//Si le terme est un mot
			if ($tree[$i]->sub==null) {
				//Affichage du mot avec le prfixe N pour terme Normal et L pour terme litral
				if ($tree[$i]->literal) $r.="L "; else $r.="N ";
				$r.=$tree[$i]->word."\n";
			} else
				//Sinon on analyse l'expression 
				$r.=$this->show_analyse_rpn($tree[$i]->sub);
			//Affichage ngation et oprateur si ncessaire
			if ($tree[$i]->not) $r.="not\n";
			if ($tree[$i]->operator) $r.=$tree[$i]->operator."\n";
		}
		return $r;
	}

	//Affichage sous forme mathmatique logique du rsultat de l'analyse
	function show_analyse($tree="") {
		if ($tree=="") $tree=$this->tree;
		$r="";
		for ($i=0; $i<count($tree); $i++) {
			if ($tree[$i]->operator) $r.=$tree[$i]->operator." ";
			if ($tree[$i]->not) $r.="not";
			if ($tree[$i]->sub==null) {
				if ($tree[$i]->not) $r.="(";
				if ($tree[$i]->literal) $r.="\"";
				$r.=$tree[$i]->word;
				if ($tree[$i]->literal) $r.="\"";
				if ($tree[$i]->not) $r.=")";
				$r.=" ";
			} else { $r.="( ".$this->show_analyse($tree[$i]->sub).") "; }
		}
		return $r;
	}	

	//Construction rcursive de la requte SQL
	function get_query_r($tree,&$select,&$pcount,$table,$field_l,$field_i,$id_field,$neg_parent=0,$main=1) {
		
		// Variable global permettant de choisir si l'on utilise ou non la troncature  droite du terme recherch
		
		global $opac_allow_term_troncat_search;
		$troncat = "";
		
		if ($opac_allow_term_troncat_search)
		{
			 $troncat = "%";
		}
		
		$where="";
		for ($i=0; $i<count($tree); $i++) {
			
			if ($tree[$i]->operator) $where.=$tree[$i]->operator." ";
			if ($tree[$i]->sub==null) {
				if ($tree[$i]->literal) $clause=$field_l." "; else $clause=$field_i." ";				
				if ($tree[$i]->not) $clause.="not ";
				$clause.="like '%";
				if (!$tree[$i]->literal) $clause.=" ";
				
				// Condition permettant de dtecter si on a dj une toile dans le terme
				// Si la recherche avec troncature  droite est activer dans l'administration 
				// et qu'il n'y a pas d'toiles ajout du '%'  droite du terme

				if(strpos($tree[$i]->word,"*") === false)
				{
					$clause.=addslashes(str_replace("*","%",$tree[$i]->word.$troncat));
				}
				else
				{
					$clause.=addslashes(str_replace("*","%",$tree[$i]->word));
				}
				
				if (!$tree[$i]->literal) $clause.=" ";
				$clause.="%'";
				$where.=$clause." ";
				//if ((!$tree[$i]->not)&&(!$neg_parent)) {
					if ($select) $select.="+";
					$select.="(".$clause.")";
					if ($tree[$i]->pound!=1) $select.="*".$tree[$i]->pound;
					$pcount++;
				//}
			} else { 
				if ($tree[$i]->not) $where.="not ";
				//$tree[$i]->not
				$where.="( ".$this->get_query_r($tree[$i]->sub,$select,$pcount,$table,$field_l,$field_i,$id_field,$tree[$i]->not,0).") "; 
			}
		}
		if ($main) {
			if ($select=="") $select="1";
			$q["select"]="(".$select.")";
			$q["where"]="(".$where.")";
			$q["post"]=" group by ".$id_field." order by pert desc,".$field_i." asc";

			return $q; 
		} 
		else 
			return $where; 
	} 

	//Fonction d'appel de la construction rcursive de la requte SQL
	function get_query($table,$field_l,$field_i,$id_field,$restrict="",$offset=0,$n=0) {
		$select="";
		$pcount=0;
		$q=$this->get_query_r($this->tree,&$select,&$pcount,$table,$field_l,$field_i,$id_field,0,1);
		$res="select ".$id_field.",".$q["select"]." as pert from ".$table." where (".$q["where"].")";
		if ($restrict!="") $res.=" and ".$restrict;
		$res.=$q["post"];
		if ($n!=0) $res.=" limit ".$offset.",".$n;
		return $res;
	}
	
	function get_query_members($table,$field_l,$field_i,$id_field,$restrict="",$offset=0,$n=0) {
		$select="";
		$pcount=0;
		$q=$this->get_query_r($this->tree,&$select,&$pcount,$table,$field_l,$field_i,$id_field,0,1);
		if ($restrict) $q["restrict"]=$restrict;
		return $q;
	}
	
	//Requte de comptage des rsultats
	function get_query_count($table,$field_l,$field_i,$id_field,$restrict="") {
		$select="";
		$pcount=0;
		$q=$this->get_query_r($this->tree,&$select,&$pcount,$table,$field_l,$field_i,$id_field,0,1);
		$res="select count(distinct ".$id_field.") from ".$table." where (".$q["where"].")";
		if ($restrict!="") $res.=" and ".$restrict;
		return $res;
	}
	
	//Analyse de la requte saisie (machine d'tat)
	function recurse_analyse() {
		global $msg;
		global $charset;
		global $opac_default_operator;
				
		$s="new_word";
		$end=false;
		while (!$end) {
			switch ($s) {
				//Dbut d'un nouveau terme
				case "new_word":
					if ($this->current_car>(pmb_strlen($this->input)-1)) { 
						$end=true; 
						if ($this->parenthesis) {
							$this->error=1;
							$this->error_message=$msg["aq_missing_term_and_p"];
							break;
						}
						if ($this->guillemet) {
							$this->error=1;
							$this->error_message=$msg["aq_missing_term_and_g"];
							break;
						}
						break; 
					}
					$cprec = pmb_getcar($this->current_car - 1,$this->input);			
					$c=pmb_getcar($this->current_car,$this->input);
					$this->current_car++;
					//Si terme prcd par un oprateur (+, -, ~, |) et pas d'oprateur et pas de guillemet ouvert : 
					//affectation oprateur. Nanmoins, si c'est le premier terme on n'en tient pas compte
					if ((($c=="+")||($c=="-" && $cprec == " ")||($c=="~"))&&($this->operator=="")&&(!$this->guillemet)&&(!$this->neg)) {
						if (($c=="+")&&(count($this->tree))) {
							if ($opac_default_operator == 1) {
								$this->operator="or"; 
							} else {
								$this->operator="and"; 
							}
						} else if (($c=="-" && $cprec == " ")&&(count($this->tree))) { 
							$this->operator="and"; 
							$this->neg=1; 
						} else if ((($c=="-" && $cprec == " ")&&(!count($this->tree)))||($c=="~")) $this->neg=1;
						//Aprs l'oprateur, on continue  chercher le dbut du terme
						$s="new_word"; 
						break;
					}
					//Si terme prcd par un oprateur et qu'il y a dj un oprateur et qu'on est pas 
					//dans des guillemets alors erreur !
					if ((($c=="+")||($c=="-" && $cprec == " ")||($c=="~"))&&(!$this->guillemet)&&(($this->operator!="")||($this->neg))) {
						if (($c=="~")&&($this->operator=="and")) {
							if (!$this->neg)
								$message_op=$msg["aq_and_not_error"];
							else
								$message_op=$msg["aq_minus_error"];
						} else if ((($c=="+")||($c=="-" && $cprec == " "))&&($this->neg)&&(!$this->operator)) {
							$message_op=sprintf($msg["aq_neg_error"],$c);
						} else {
							$message_op=$msg["aq_only_one"];
						}
						$end=true; $this->error_message=$message_op; $this->error=1; break;
					}
					//Si premier guillemet => terme litral
					if (($c=="\"")&&($this->guillemet==0))	{
						$this->guillemet=1;
						$this->literal=1;
						//Aprs le guillemets, on continue  chercher le dbut du terme
						break;
					}			
					//Si guillement et guillemet dj ouvert => annulation du terme litral
					if (($c=="\"")&&($this->guillemet==1)) {
						$this->guillemet=0;
						$this->literal=0;
						//Aprs le guillemets, on continue  chercher le dbut du terme
						break;
					}
					//Si il y a un espace et pas dans les guillemets, on en tient pas compte
					if (($c==" ")&&(!$this->guillemet)) break;
					//Si une parentse ouverte, alors analyse de la sous expression
					if (($c=="(")&&(!$this->guillemet)) {
						$sub_a=new analyse_query($this->input,$this->current_car,1,$this->search_linked_words);
						//Si erreur dans sous expression, erreur !
						if ($sub_a->error) {
							$this->error=1;
							//Mise  jour du caractre courant o s'est produit l'erreur
							$this->current_car=$sub_a->current_car;
							$this->error_message=$sub_a->error_message;
							$end=true;
							break;
						} else {
							//Si pas d'erreur, stockage du rsultat dans terme
							$this->term=$sub_a->tree;
							//Si il n'y a pas d'oprateur et que ce n'est pas le premier terme, 
							//oprateur par dfaut
							//if ((!$this->operator)&&(count($this->tree))) $this->operator="or";
							if ((!$this->operator)&&(count($this->tree))){
      							if ($opac_default_operator == 1) {
      								$this->operator="and";
      							} else {
      								$this->operator="or";
      							}
      						}
							$this->current_car=$sub_a->current_car;
							//Dbut Attente du prochain terme
							$s="space_first";
							break;
						}
					}
					//Si parentse fermante et parentse dj ouverte alors on s'en va
					if (($c==")")&&($this->parenthesis)&&(!$this->guillemet)) {
						$end=true;
						break;
					}
					//Si aucun des cas prcdents, c'est le dbut du terme
					$this->term.=$c;
					//Si il n'y a pas d'oprateur et que ce n'est pas le premier terme, 
					//oprateur par dfaut
					//if ((!$this->operator)&&(count($this->tree))) $this->operator="or";
					if ((!$this->operator)&&(count($this->tree))){
      							if ($opac_default_operator == 1) {
      								$this->operator="and";
      							} else {
      								$this->operator="or";
      							}
      						}
					//Lecture du terme
					$s="stockage_car";
					break;
				//Lecture d'un terme
				case "stockage_car":
					if ($this->current_car>(pmb_strlen($this->input)-1)) {
						//Si on lit une sous expression et qu'on arrive  la fin avant la parentse fermante
						//alors erreur
						//sinon, passage  l'tat attente du prochain terme (pourquoi me direz-vous alors qu'on arrive  la fin ? parceque ce cas est gr en space_first) 
						if ($this->guillemet) { $this->error_message=$msg["aq_missing_g"]; $end=true; $this->error=1; break; }
						if ($this->parenthesis) { $this->error_message=$msg["aq_missing_p"]; $end=true; $this->error=1; break; }
						$s="space_first";
					}
					//Lecture caractre	
					$cprec = pmb_getcar($this->current_car - 1,$this->input);
					$c=pmb_getcar($this->current_car,$this->input);
					$this->current_car++;
					//Si espace et terme litral : l'espace fait partie du terme
					if ((($c==" ")||($c=="+")||($c=="-" && $cprec == " "))&&($this->guillemet==1)) { $this->term.=$c; break; }
					//Si espace et terme non litral : espace = sparateur de terme => passage  Dbut Attente du prochain terme
					if ((($c==" ")||($c=="+")||($c=="-" && $cprec == " "))&&($this->guillemet==0)) { $s="space_first"; $this->current_car--; break; }
					//Si guillemet et terme litral : guillemet = fin du terme => passage  Dbut Attente du prochain terme
					if (($c=="\"")&&($this->guillemet==1)) { $s="space_first"; $this->guillemet=0; break; }
					//Si parentse fermante et sous-expression et que l'on est pas dans un terme litral, 
					//alors fin de sous expression  analyser => passage  Dbut Attente du prochain terme
					if (($c==")")&&($this->parenthesis==1)&&($this->guillemet==0)) { $s="space_first"; $this->current_car--; break; }
					//Si aucun des cas prcdent, ajout du caractre au terme... et on recommence
					$this->term.=$c;
					break;
				//Dbut Attente du prochain terme aprs la fin d'un terme
				//A ce niveau, on s'attend  un caractre sparateur et si on le trouve, on enregistre le terme dans l'arbre 
				//Ensuite on passe  l'tat attente du prochain terme ("space_wait") qui saute tous les caractres vides avant de renvoyer  new_word
				case "space_first":
					if ($this->current_car>(pmb_strlen($this->input)-1)) {
						//Si fin de chaine et parentse ouverte => erreur
						if ($this->parenthesis) { $end=true; $this->error_message=$msg["aq_missing_p"]; $this->error=1; break; }
						//Sinon c'est la fin de l'analyse : on enregistre le dernier terme et on s'arrte
						$end=true;
						if (is_array($this->term))
							$t=new term("",$this->literal,$this->neg,$this->operator,$this->term);
						else
							$t=new term($this->term,$this->literal,$this->neg,$this->operator,null);
						$this->store_in_tree($t);
						break;
					}				
					//Lecture du prochain caractre
					$c=pmb_getcar($this->current_car,$this->input);
					$this->current_car++;
					//Si parentse fermante et sous expression en cours d'analyse => fin d'analyse de la sous expression
					if (($c==")")&&($this->parenthesis)) {
						$end=true;
						//Enregistrement du dernier terme
						if (is_array($this->term))
							$t=new term("",$this->literal,$this->neg,$this->operator,$this->term);
						else
							$t=new term($this->term,$this->literal,$this->neg,$this->operator,null);
						$this->store_in_tree($t);
						break;
					}
					//Sinon, si ce n'est pas un espace, alors erreur (ce n'est pas le sparateur attendu)
					if (($c!=" ")&&($c!="+")&&($c!="-")) {
						$end=true; $this->error_message=$msg["aq_missing_space"]; $this->error=1; break;
					}
					//Si tout va bien, on attend le prochain terme
					if ($c!=" ")
						$this->current_car--;
					$s="space_wait";
					break;
				//Attente du prochain terme : on saute tous les espaces avant de renvoyer  la lecture du nouveau terme ! 
				case "space_wait":
					if ($this->current_car>(pmb_strlen($this->input)-1)) {
						//Si prentse ouverte et fin de la chaine => erreur
						if ($this->parenthesis) { $end=true; $this->error_message=$msg["aq_missing_p"]; $this->error=1; break; }
						//Sinon, si fin de la chaine, enregistrement du terme prcdent et fin d'analyse
						if (is_array($this->term))
							$t=new term("",$this->literal,$this->neg,$this->operator,$this->term);
						else
							$t=new term($this->term,$this->literal,$this->neg,$this->operator,null);
						$this->store_in_tree($t);
						$end=true;
						break;
					}
					//Lecture du caractre suivant
					$c=pmb_getcar($this->current_car,$this->input);
					$this->current_car++;
					//Si ) et sous expression en cours d'analyse, fin de l'analyse de la sous expression
					if (($c==")")&&($this->parenthesis==1))	{
						//Enregistrement du terme et fin d'analyse
						if (is_array($this->term))
							$t=new term("",$this->literal,$this->neg,$this->operator,$this->term);
						else
							$t=new term($this->term,$this->literal,$this->neg,$this->operator,null);
						$this->store_in_tree($t);
						$end=true;
						break;
					}
					//Si le caractre n'est pas un espace, alors c'est le dbut du prochain terme
					if ($c!=" ") {
						$this->current_car--;
						//Enregistrement du dernier terme
						if (is_array($this->term))
							$t=new term("",$this->literal,$this->neg,$this->operator,$this->term);
						else
							$t=new term($this->term,$this->literal,$this->neg,$this->operator,null);
						$this->store_in_tree($t);
						//Remise  zro des indicateurs
						$this->operator="";
						$this->term="";
						$this->neg=0;
						$this->literal=0;
						//Passage  nouveau terme
						$s="new_word";
						break;
					}
					//Sinon on reste en attente
					break;
			}
		}
		if ($this->error) {
			$this->input_html=pmb_substr($this->input,0,$this->current_car-1)."!!red!!".pmb_substr($this->input,$this->current_car-1,1)."!!s_red!!".pmb_substr($this->input,$this->current_car);
		} else $this->input_html=$this->input;
		if ((!$this->error)&&(!count($this->tree))) {
			$this->error=1;
			$this->error_message=$msg["aq_no_term"];			
		}
		$this->input_html=htmlentities($this->input_html,ENT_QUOTES,$charset);
		$this->input_html=str_replace("!!red!!","<font color='#DD0000'><b><u>",$this->input_html);
		$this->input_html=str_replace("!!s_red!!","</u></b></font>",$this->input_html);
	}
}

?>