<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: author.class.php,v 1.14 2007/07/25 14:31:43 touraine37 Exp $

// dfinition de la classe de gestion des 'auteurs'

if ( ! defined( 'AUTEUR_CLASS' ) ) {
  define( 'AUTEUR_CLASS', 1 );

class auteur {

	// ---------------------------------------------------------------
	//		proprits de la classe
	// ---------------------------------------------------------------

	var $id;            // MySQL id in table 'authors'
	var $type;          // author type (70 or 71)
	var $name;          // author name
	var $rejete;        // author name (rejected element)
	var $date;          // dates
	var $see;           // 'see' author MySQL id
	// var $see_libelle;  //// printable form of 'see' author (in fact 'display' of retained form)
	var $display;      //// usable form for displaying ( _name_, _rejete_ (_date_) )
	var $isbd_entry;   //// isbd like version ( _rejete_ _name_ (_date_))
	var $author_web;	// web de l'auteur
	var $author_comment; //
	var $author_web_link;	// lien web de l'auteur


// ---------------------------------------------------------------
//		auteur($id) : constructeur
// ---------------------------------------------------------------
function auteur($id)
{
	// on regarde si on a une notice-objet ou un id de notice
	if (is_object($id)) {
		$this->get_primaldatafrom($id);
	} else {
		$this->id = $id;
		$this->get_primaldata();
	}
	$this->get_otherdata();
}

// ---------------------------------------------------------------
//  get_primaldata() : rcupration infos auteur  partir de l'id
// ---------------------------------------------------------------
function get_primaldata() {
	global $dbh;
	$requete = "SELECT * FROM authors WHERE author_id=$this->id LIMIT 1 ";
	$result = @mysql_query($requete, $dbh);
	if(mysql_num_rows($result)) {
		$obj = mysql_fetch_object($result);
		mysql_free_result($result);
		$this->get_primaldatafrom($obj);
		} else {
			// pas d'auteur avec cette cl
			$this->id          = 0;
			$this->type        = '';
			$this->name        = '';
			$this->rejete      = '';
			$this->date       = '';
			$this->see         = '';
			$this->display     = '';
			$this->isbd_entry  = '';
			$this->author_web = '' ;
			$this->author_comment = '' ;
			}
	}

// ---------------------------------------------------------------
//  get_primaldatafrom($obj) : rcupration infos auteur  partir d'un auteur-objet
// ---------------------------------------------------------------
function get_primaldatafrom($obj) {
	$this->id       = $obj->author_id;
	$this->type     = $obj->author_type;
	$this->name     = $obj->author_name;
	$this->rejete   = $obj->author_rejete;
	$this->date     = $obj->author_date;
	$this->see      = $obj->author_see;
	$this->author_web = $obj->author_web;
	$this->author_comment = $obj->author_comment;
	}

// ---------------------------------------------------------------
function get_otherdata() {
	if($this->rejete) {
		$this->isbd_entry = "$this->name, $this->rejete";
		$this->display = "$this->rejete $this->name";
		} else {
			$this->isbd_entry = "$this->name";
			$this->display = "$this->name";
			}
	if($this->date) $this->isbd_entry .= ' ('.$this->date.')';

	if($this->author_web) $this->author_web_link = " <a href='$temp->author_web' target='_blank'><img src='./images/globe.gif' border='0' /></a>";
		else $this->author_web_link = "" ;
	}

// ---------------------------------------------------------------
function print_resume($level = 2,$css) {
	global $css;
	if(!$this->id)
		return;

	// adaptation par rapport au niveau de dtail souhait
	switch ($level) {
		// case x :
		case 1 :
			global $author_level1_display;
			global $author_level1_no_dates_info;

			$author_display = $author_level1_display;
			$author_no_dates_info = $author_level1_no_dates_info;
			break;

		case 2 :
		default :
			global $author_level2_display;
			global $author_level2_no_dates_info;

			$author_display = $author_level2_display;
			$author_no_dates_info = $author_level2_no_dates_info;
			break;
		}

	$print = $author_display;

	// remplacement des champs statiques
	$print = str_replace("!!id!!", $this->id, $print);
	$print = str_replace("!!name!!", $this->name, $print);
	$print = str_replace("!!rejete!!", $this->rejete, $print);
	if ($this->author_web) $print = str_replace("!!site_web!!", "<a href='$this->author_web' target='_blank'><img src='./images/globe.gif' border='0' /></a>", $print);
		else $print = str_replace("!!site_web!!", "", $print);
	$print = str_replace("!!date!!", $this->date, $print);
	$print = str_replace("!!aut_comment!!", $this->author_comment, $print);

	// remplacement des champs dynamiques
	if ((ereg("!!allname!!", $print)) || (ereg("!!allnamenc!!", $print))) {
		$remplacement = $this->name;
		if ($this->rejete != "") $remplacement = $this->rejete." ".$remplacement;

		if (ereg("!!allname!!", $print)) {
			$remplacement = "<a href='index.php?lvl=author_see&id=$this->id'>$remplacement</a>";
			$print = str_replace("!!allname!!", $remplacement, $print);
			} else $print = str_replace("!!allnamenc!!", $remplacement, $print);
		}

	if (ereg("!!dates!!", $print)) {
		if ($this->date != "") {
			$remplacement = " ($this->date)";
			} else $remplacement = $author_no_dates_info;
		$print = str_replace("!!dates!!", $remplacement, $print);
		}

	return $print;
	}
} # fin de dfinition de la classe auteur

} # fin de dlaration
