-- +-------------------------------------------------+
--  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
-- +-------------------------------------------------+
-- $Id: bibli.sql,v 1.63 2007/11/11 08:42:25 touraine37 Exp $

-- --------------------------------------------------------
-- Version PMB 3.1 / Noyau V4.45
-- --------------------------------------------------------

-- --------------------------------------------------------

-- 
-- Structure de la table `abts_abts`
-- 

CREATE TABLE abts_abts (
  abt_id int(10) unsigned NOT NULL auto_increment,
  abt_name varchar(255) NOT NULL default '',
  base_modele_name varchar(255) NOT NULL default '',
  base_modele_id int(11) NOT NULL default '0',
  num_notice int(11) NOT NULL default '0',
  date_debut date NOT NULL default '0000-00-00',
  date_fin date NOT NULL default '0000-00-00',
  fournisseur int(11) NOT NULL default '0',
  destinataire varchar(255) NOT NULL default '',
  cote varchar(255) NOT NULL default '',
  typdoc_id int(11) NOT NULL default '0',
  exemp_auto int(11) NOT NULL default '0',
  location_id int(11) NOT NULL default '0',
  section_id int(11) NOT NULL default '0',
  lender_id int(11) NOT NULL default '0',
  statut_id int(11) NOT NULL default '0',
  codestat_id int(11) NOT NULL default '0',
  type_antivol int(11) NOT NULL default '0',
  duree_abonnement int(11) NOT NULL default '0',
  PRIMARY KEY  (abt_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `abts_abts_modeles`
-- 

CREATE TABLE abts_abts_modeles (
  modele_id int(11) NOT NULL default '0',
  abt_id int(11) NOT NULL default '0',
  num int(11) NOT NULL default '0',
  vol int(11) NOT NULL default '0',
  tome int(11) NOT NULL default '0',
  delais int(11) NOT NULL default '0',
  critique int(11) NOT NULL default '0',
  PRIMARY KEY  (modele_id,abt_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `abts_grille_abt`
-- 

CREATE TABLE abts_grille_abt (
  id_bull int(11) NOT NULL auto_increment,
  num_abt int(10) unsigned NOT NULL default '0',
  date_parution date NOT NULL default '0000-00-00',
  modele_id int(11) NOT NULL default '0',
  `type` int(11) NOT NULL default '0',
  nombre int(11) NOT NULL default '0',
  numero int(11) NOT NULL default '0',
  ordre int(11) NOT NULL default '0',
  state int(11) NOT NULL default '0',
  PRIMARY KEY  (id_bull),
  KEY num_abt (num_abt)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `abts_grille_modele`
-- 

CREATE TABLE abts_grille_modele (
  num_modele int(10) unsigned NOT NULL default '0',
  date_parution date NOT NULL default '0000-00-00',
  type_serie int(11) NOT NULL default '0',
  numero varchar(50) NOT NULL default '',
  nombre_recu int(11) NOT NULL default '1',
  PRIMARY KEY  (num_modele,date_parution,type_serie),
  KEY num_modele (num_modele)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `abts_modeles`
-- 

CREATE TABLE abts_modeles (
  modele_id int(10) unsigned NOT NULL auto_increment,
  modele_name varchar(255) NOT NULL default '',
  num_notice int(10) unsigned NOT NULL default '0',
  num_periodicite int(10) unsigned NOT NULL default '0',
  duree_abonnement int(11) NOT NULL default '0',
  date_debut date default NULL,
  date_fin date default NULL,
  days varchar(7) NOT NULL default '1111111',
  day_month varchar(31) NOT NULL default '1111111111111111111111111111111',
  week_month varchar(6) NOT NULL default '111111',
  week_year varchar(54) NOT NULL default '111111111111111111111111111111111111111111111111111111',
  month_year varchar(12) NOT NULL default '111111111111',
  num_cycle int(11) NOT NULL default '0',
  num_combien int(11) NOT NULL default '0',
  num_increment int(11) NOT NULL default '0',
  num_date_unite int(11) NOT NULL default '0',
  num_increment_date int(11) NOT NULL default '0',
  num_depart int(11) NOT NULL default '0',
  vol_actif int(11) NOT NULL default '0',
  vol_increment int(11) NOT NULL default '0',
  vol_date_unite int(11) NOT NULL default '0',
  vol_increment_numero int(11) NOT NULL default '0',
  vol_increment_date int(11) NOT NULL default '0',
  vol_cycle int(11) NOT NULL default '0',
  vol_combien int(11) NOT NULL default '0',
  vol_depart int(11) NOT NULL default '0',
  tom_actif int(11) NOT NULL default '0',
  tom_increment int(11) NOT NULL default '0',
  tom_date_unite int(11) NOT NULL default '0',
  tom_increment_numero int(11) NOT NULL default '0',
  tom_increment_date int(11) NOT NULL default '0',
  tom_cycle int(11) NOT NULL default '0',
  tom_combien int(11) NOT NULL default '0',
  tom_depart int(11) NOT NULL default '0',
  format_aff varchar(255) NOT NULL default '',
  format_periode varchar(255) NOT NULL default '',
  PRIMARY KEY  (modele_id),
  KEY num_notice (num_notice),
  KEY num_periodicite (num_periodicite)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `abts_periodicites`
-- 

CREATE TABLE abts_periodicites (
  periodicite_id int(10) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  duree int(11) NOT NULL default '0',
  unite int(11) NOT NULL default '0',
  retard_periodicite int(4) default '0',
  seuil_periodicite int(4) default '0',
  PRIMARY KEY  (periodicite_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `actes`
-- 

CREATE TABLE actes (
  id_acte int(8) unsigned NOT NULL auto_increment,
  date_acte date NOT NULL default '0000-00-00',
  numero varchar(25) NOT NULL default '',
  type_acte int(3) unsigned NOT NULL default '0',
  statut int(3) unsigned NOT NULL default '0',
  date_paiement date NOT NULL default '0000-00-00',
  num_paiement varchar(255) NOT NULL default '',
  num_entite int(5) unsigned NOT NULL default '0',
  num_fournisseur int(5) unsigned NOT NULL default '0',
  num_contact_livr int(8) unsigned NOT NULL default '0',
  num_contact_fact int(8) unsigned NOT NULL default '0',
  num_exercice int(8) unsigned NOT NULL default '0',
  commentaires text NOT NULL,
  reference varchar(255) NOT NULL default '',
  index_acte text NOT NULL,
  devise varchar(25) NOT NULL default '',
  commentaires_i text NOT NULL,
  date_valid date NOT NULL default '0000-00-00',
  PRIMARY KEY  (id_acte),
  KEY num_fournisseur (num_fournisseur),
  KEY `date` (date_acte),
  KEY num_entite (num_entite),
  KEY numero (numero)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `admin_session`
-- 

CREATE TABLE admin_session (
  userid int(10) unsigned NOT NULL default '0',
  `session` blob,
  PRIMARY KEY  (userid)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `analysis`
-- 

CREATE TABLE analysis (
  analysis_bulletin int(8) unsigned NOT NULL default '0',
  analysis_notice int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (analysis_bulletin,analysis_notice),
  KEY analysis_notice (analysis_notice)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `audit`
-- 

CREATE TABLE audit (
  type_obj int(1) NOT NULL default '0',
  object_id int(10) unsigned NOT NULL default '0',
  user_id int(8) unsigned NOT NULL default '0',
  user_name varchar(20) NOT NULL default '',
  type_modif int(1) NOT NULL default '1',
  quand timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `authors`
-- 

CREATE TABLE authors (
  author_id mediumint(8) unsigned NOT NULL auto_increment,
  author_type enum('70','71') NOT NULL default '70',
  author_name varchar(255) default NULL,
  author_rejete varchar(255) default NULL,
  author_date varchar(255) NOT NULL default '',
  author_see mediumint(8) unsigned NOT NULL default '0',
  author_web varchar(255) NOT NULL default '',
  index_author text,
  author_comment text,
  PRIMARY KEY  (author_id),
  KEY author_see (author_see),
  KEY author_name (author_name),
  KEY author_rejete (author_rejete)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `avis`
-- 

CREATE TABLE avis (
  id_avis mediumint(8) NOT NULL auto_increment,
  num_empr mediumint(8) NOT NULL default '0',
  num_notice mediumint(8) NOT NULL default '0',
  note int(3) default NULL,
  sujet text,
  commentaire text,
  dateajout timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  valide int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_avis)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `bannette_abon`
-- 

CREATE TABLE bannette_abon (
  num_bannette int(9) unsigned NOT NULL default '0',
  num_empr int(9) unsigned NOT NULL default '0',
  actif int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (num_bannette,num_empr)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `bannette_contenu`
-- 

CREATE TABLE bannette_contenu (
  num_bannette int(9) unsigned NOT NULL default '0',
  num_notice int(9) unsigned NOT NULL default '0',
  date_ajout timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (num_bannette,num_notice),
  KEY date_ajout (date_ajout)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `bannette_equation`
-- 

CREATE TABLE bannette_equation (
  num_bannette int(9) unsigned NOT NULL default '0',
  num_equation int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (num_bannette,num_equation)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `bannette_exports`
-- 

CREATE TABLE bannette_exports (
  num_bannette int(11) unsigned NOT NULL default '0',
  export_format int(3) NOT NULL default '0',
  export_data longblob NOT NULL,
  export_nomfichier varchar(255) default '',
  PRIMARY KEY  (num_bannette,export_format)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `bannettes`
-- 

CREATE TABLE bannettes (
  id_bannette int(9) unsigned NOT NULL auto_increment,
  num_classement int(8) unsigned NOT NULL default '1',
  nom_bannette varchar(255) NOT NULL default '',
  comment_gestion varchar(255) NOT NULL default '',
  comment_public varchar(255) NOT NULL default '',
  entete_mail text NOT NULL,
  date_last_remplissage datetime NOT NULL default '0000-00-00 00:00:00',
  date_last_envoi datetime NOT NULL default '0000-00-00 00:00:00',
  proprio_bannette int(9) unsigned NOT NULL default '0',
  bannette_auto int(1) unsigned NOT NULL default '0',
  periodicite int(3) unsigned NOT NULL default '7',
  diffusion_email int(1) unsigned NOT NULL default '0',
  categorie_lecteurs int(8) unsigned NOT NULL default '0',
  nb_notices_diff int(4) unsigned NOT NULL default '0',
  num_panier int(8) unsigned NOT NULL default '0',
  limite_type char(1) NOT NULL default '',
  limite_nombre int(6) NOT NULL default '0',
  update_type char(1) NOT NULL default 'C',
  PRIMARY KEY  (id_bannette)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `budgets`
-- 

CREATE TABLE budgets (
  id_budget int(8) unsigned NOT NULL auto_increment,
  num_entite int(5) unsigned NOT NULL default '0',
  num_exercice int(8) unsigned NOT NULL default '0',
  libelle varchar(255) NOT NULL default '',
  commentaires text,
  montant_global float(8,2) unsigned NOT NULL default '0.00',
  seuil_alerte int(3) unsigned NOT NULL default '100',
  statut int(3) unsigned NOT NULL default '0',
  type_budget int(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_budget)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `bulletins`
-- 

CREATE TABLE bulletins (
  bulletin_id int(8) unsigned NOT NULL auto_increment,
  bulletin_numero varchar(255) NOT NULL default '',
  bulletin_notice int(8) NOT NULL default '0',
  mention_date varchar(50) NOT NULL default '',
  date_date date NOT NULL default '0000-00-00',
  bulletin_titre text,
  index_titre text,
  bulletin_cb varchar(30) default NULL,
  num_notice int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (bulletin_id),
  KEY bulletin_numero (bulletin_numero),
  KEY bulletin_notice (bulletin_notice),
  KEY date_date (date_date)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `caddie`
-- 

CREATE TABLE caddie (
  idcaddie int(8) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  `type` varchar(20) NOT NULL default 'NOTI',
  `comment` varchar(255) default NULL,
  autorisations mediumtext,
  PRIMARY KEY  (idcaddie),
  KEY caddie_type (`type`)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `caddie_content`
-- 

CREATE TABLE caddie_content (
  caddie_id int(8) unsigned NOT NULL default '0',
  object_id int(10) unsigned NOT NULL default '0',
  content blob,
  blob_type varchar(10) default NULL,
  flag varchar(10) default NULL,
  KEY caddie_id (caddie_id,object_id),
  KEY object_id (object_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `caddie_procs`
-- 

CREATE TABLE caddie_procs (
  idproc smallint(5) unsigned NOT NULL auto_increment,
  `type` varchar(20) NOT NULL default 'SELECT',
  name varchar(255) NOT NULL default '',
  requete blob NOT NULL,
  `comment` tinytext NOT NULL,
  autorisations mediumtext,
  parameters text,
  PRIMARY KEY  (idproc)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `categories`
-- 

CREATE TABLE categories (
  num_thesaurus int(3) unsigned NOT NULL default '1',
  num_noeud int(9) unsigned NOT NULL default '0',
  langue varchar(5) NOT NULL default 'fr_FR',
  libelle_categorie text NOT NULL,
  note_application text NOT NULL,
  comment_public text NOT NULL,
  comment_voir text NOT NULL,
  index_categorie text NOT NULL,
  PRIMARY KEY  (num_noeud,langue),
  KEY categ_langue (langue),
  KEY libelle_categorie (libelle_categorie(5))
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `classements`
-- 

CREATE TABLE classements (
  id_classement int(8) unsigned NOT NULL auto_increment,
  type_classement char(3) NOT NULL default 'BAN',
  nom_classement varchar(255) NOT NULL default '',
  PRIMARY KEY  (id_classement)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `collections`
-- 

CREATE TABLE collections (
  collection_id mediumint(8) unsigned NOT NULL auto_increment,
  collection_name varchar(255) NOT NULL default '',
  collection_parent mediumint(8) unsigned NOT NULL default '0',
  collection_issn varchar(12) NOT NULL default '',
  index_coll text,
  PRIMARY KEY  (collection_id),
  KEY collection_name (collection_name),
  KEY collection_parent (collection_parent)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `collections_state`
-- 

CREATE TABLE collections_state (
  id_serial mediumint(8) unsigned NOT NULL default '0',
  location_id smallint(5) unsigned NOT NULL default '0',
  state_collections text NOT NULL,
  PRIMARY KEY  (id_serial,location_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `comptes`
-- 

CREATE TABLE comptes (
  id_compte int(8) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  type_compte_id int(10) unsigned NOT NULL default '0',
  solde decimal(16,2) default '0.00',
  prepay_mnt decimal(16,2) NOT NULL default '0.00',
  proprio_id int(10) unsigned NOT NULL default '0',
  droits text NOT NULL,
  PRIMARY KEY  (id_compte)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `connectors`
-- 

CREATE TABLE connectors (
  connector_id varchar(60) NOT NULL default '',
  parameters text NOT NULL,
  repository int(11) NOT NULL default '0',
  timeout int(11) NOT NULL default '5',
  retry int(11) NOT NULL default '3',
  ttl int(11) NOT NULL default '1440',
  PRIMARY KEY  (connector_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `connectors_sources`
-- 

CREATE TABLE connectors_sources (
  source_id int(10) unsigned NOT NULL auto_increment,
  id_connector varchar(60) NOT NULL default '',
  parameters text NOT NULL,
  comment varchar(255) NOT NULL default '',
  name varchar(255) NOT NULL default '',
  repository int(11) NOT NULL default '0',
  timeout int(11) NOT NULL default '5',
  retry int(11) NOT NULL default '3',
  ttl int(11) NOT NULL default '1440',
  PRIMARY KEY  (source_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `coordonnees`
-- 

CREATE TABLE coordonnees (
  id_contact int(8) unsigned NOT NULL auto_increment,
  type_coord int(1) unsigned NOT NULL default '0',
  num_entite int(5) unsigned NOT NULL default '0',
  libelle varchar(255) NOT NULL default '',
  contact varchar(255) NOT NULL default '',
  adr1 varchar(255) NOT NULL default '',
  adr2 varchar(255) NOT NULL default '',
  cp varchar(15) NOT NULL default '',
  ville varchar(100) NOT NULL default '',
  etat varchar(100) NOT NULL default '',
  pays varchar(100) NOT NULL default '',
  tel1 varchar(100) NOT NULL default '',
  tel2 varchar(100) NOT NULL default '',
  fax varchar(100) NOT NULL default '',
  email varchar(100) NOT NULL default '',
  commentaires text,
  PRIMARY KEY  (id_contact)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `docs_codestat`
-- 

CREATE TABLE docs_codestat (
  idcode smallint(5) unsigned NOT NULL auto_increment,
  codestat_libelle varchar(255) default NULL,
  statisdoc_codage_import char(2) NOT NULL default '',
  statisdoc_owner mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (idcode),
  KEY statisdoc_owner (statisdoc_owner)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `docs_location`
-- 

CREATE TABLE docs_location (
  idlocation smallint(5) unsigned NOT NULL auto_increment,
  location_libelle varchar(255) default NULL,
  locdoc_codage_import varchar(255) NOT NULL default '',
  locdoc_owner mediumint(8) unsigned NOT NULL default '0',
  location_pic varchar(255) NOT NULL default '',
  location_visible_opac tinyint(1) NOT NULL default '1',
  name varchar(255) NOT NULL default '',
  adr1 varchar(255) NOT NULL default '',
  adr2 varchar(255) NOT NULL default '',
  cp varchar(15) NOT NULL default '',
  town varchar(100) NOT NULL default '',
  state varchar(100) NOT NULL default '',
  country varchar(100) NOT NULL default '',
  phone varchar(100) NOT NULL default '',
  email varchar(100) NOT NULL default '',
  website varchar(100) NOT NULL default '',
  logo varchar(255) NOT NULL default '',
  logosmall varchar(255) NOT NULL default '',
  commentaire text NOT NULL,
  PRIMARY KEY  (idlocation),
  KEY locdoc_owner (locdoc_owner)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `docs_section`
-- 

CREATE TABLE docs_section (
  idsection smallint(5) unsigned NOT NULL auto_increment,
  section_libelle varchar(255) default NULL,
  sdoc_codage_import varchar(255) NOT NULL default '',
  sdoc_owner mediumint(8) unsigned NOT NULL default '0',
  section_pic varchar(255) NOT NULL default '',
  section_visible_opac tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (idsection),
  KEY sdoc_owner (sdoc_owner)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `docs_statut`
-- 

CREATE TABLE docs_statut (
  idstatut smallint(5) unsigned NOT NULL auto_increment,
  statut_libelle varchar(255) default NULL,
  pret_flag tinyint(4) NOT NULL default '1',
  statusdoc_codage_import char(2) NOT NULL default '',
  statusdoc_owner mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (idstatut),
  KEY statusdoc_owner (statusdoc_owner)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `docs_type`
-- 

CREATE TABLE docs_type (
  idtyp_doc tinyint(3) unsigned NOT NULL auto_increment,
  tdoc_libelle varchar(255) default NULL,
  duree_pret smallint(6) NOT NULL default '31',
  duree_resa int(6) unsigned NOT NULL default '15',
  tdoc_owner mediumint(8) unsigned NOT NULL default '0',
  tdoc_codage_import varchar(255) NOT NULL default '',
  tarif_pret decimal(16,2) NOT NULL default '0.00',
  PRIMARY KEY  (idtyp_doc)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `docsloc_section`
-- 

CREATE TABLE docsloc_section (
  num_section int(5) unsigned NOT NULL default '0',
  num_location int(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (num_section,num_location)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr`
-- 

CREATE TABLE empr (
  id_empr int(10) unsigned NOT NULL auto_increment,
  empr_cb varchar(255) default NULL,
  empr_nom varchar(255) NOT NULL default '',
  empr_prenom varchar(255) NOT NULL default '',
  empr_adr1 varchar(255) NOT NULL default '',
  empr_adr2 varchar(255) NOT NULL default '',
  empr_cp varchar(10) NOT NULL default '',
  empr_ville varchar(255) NOT NULL default '',
  empr_pays varchar(255) NOT NULL default '',
  empr_mail varchar(255) NOT NULL default '',
  empr_tel1 varchar(255) NOT NULL default '',
  empr_tel2 varchar(255) NOT NULL default '',
  empr_prof varchar(255) NOT NULL default '',
  empr_year int(4) unsigned NOT NULL default '0',
  empr_categ smallint(5) unsigned NOT NULL default '0',
  empr_codestat smallint(5) unsigned NOT NULL default '0',
  empr_creation date NOT NULL default '0000-00-00',
  empr_modif date NOT NULL default '0000-00-00',
  empr_sexe tinyint(3) unsigned NOT NULL default '0',
  empr_login varchar(255) NOT NULL default '',
  empr_password varchar(10) NOT NULL default '',
  empr_date_adhesion date default NULL,
  empr_date_expiration date default NULL,
  empr_msg tinytext,
  empr_lang varchar(10) NOT NULL default 'fr_FR',
  empr_ldap tinyint(1) unsigned default '0',
  type_abt int(1) NOT NULL default '0',
  last_loan_date date default NULL,
  empr_location int(6) unsigned NOT NULL default '1',
  date_fin_blocage date NOT NULL default '0000-00-00',
  total_loans bigint(20) unsigned NOT NULL default '0',
  empr_statut bigint(20) unsigned NOT NULL default '1',
  PRIMARY KEY  (id_empr),
  UNIQUE KEY empr_cb (empr_cb),
  KEY empr_nom (empr_nom),
  KEY empr_date_adhesion (empr_date_adhesion),
  KEY empr_date_expiration (empr_date_expiration)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_caddie`
-- 

CREATE TABLE empr_caddie (
  idemprcaddie int(8) unsigned NOT NULL auto_increment,
  name varchar(100) default NULL,
  `comment` varchar(255) default NULL,
  autorisations mediumtext,
  PRIMARY KEY  (idemprcaddie)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_caddie_content`
-- 

CREATE TABLE empr_caddie_content (
  empr_caddie_id int(8) unsigned NOT NULL default '0',
  object_id int(10) unsigned NOT NULL default '0',
  flag varchar(10) default NULL,
  KEY empr_caddie_id (empr_caddie_id,object_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_caddie_procs`
-- 

CREATE TABLE empr_caddie_procs (
  idproc smallint(5) unsigned NOT NULL auto_increment,
  `type` varchar(20) NOT NULL default 'SELECT',
  name varchar(255) NOT NULL default '',
  requete blob NOT NULL,
  `comment` tinytext NOT NULL,
  autorisations mediumtext,
  parameters text,
  PRIMARY KEY  (idproc)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_categ`
-- 

CREATE TABLE empr_categ (
  id_categ_empr smallint(5) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  duree_adhesion int(10) unsigned default '365',
  tarif_abt decimal(16,2) NOT NULL default '0.00',
  PRIMARY KEY  (id_categ_empr)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_codestat`
-- 

CREATE TABLE empr_codestat (
  idcode smallint(5) unsigned NOT NULL auto_increment,
  libelle varchar(50) NOT NULL default 'DEFAULT',
  PRIMARY KEY  (idcode)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_custom`
-- 

CREATE TABLE empr_custom (
  idchamp int(10) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  titre varchar(255) default NULL,
  `type` varchar(10) NOT NULL default 'text',
  datatype varchar(10) NOT NULL default '',
  options text,
  multiple int(11) NOT NULL default '0',
  obligatoire int(11) NOT NULL default '0',
  ordre int(11) default NULL,
  PRIMARY KEY  (idchamp)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_custom_lists`
-- 

CREATE TABLE empr_custom_lists (
  empr_custom_champ int(10) unsigned NOT NULL default '0',
  empr_custom_list_value varchar(255) default NULL,
  empr_custom_list_lib varchar(255) default NULL,
  ordre int(11) default NULL,
  KEY empr_custom_champ (empr_custom_champ),
  KEY champ_list_value (empr_custom_champ,empr_custom_list_value)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_custom_values`
-- 

CREATE TABLE empr_custom_values (
  empr_custom_champ int(10) unsigned NOT NULL default '0',
  empr_custom_origine int(10) unsigned NOT NULL default '0',
  empr_custom_small_text varchar(255) default NULL,
  empr_custom_text text,
  empr_custom_integer int(11) default NULL,
  empr_custom_date date default NULL,
  empr_custom_float float default NULL,
  KEY empr_custom_champ (empr_custom_champ),
  KEY empr_custom_origine (empr_custom_origine)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_groupe`
-- 

CREATE TABLE empr_groupe (
  empr_id int(6) unsigned NOT NULL default '0',
  groupe_id int(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (empr_id,groupe_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empr_statut`
-- 

CREATE TABLE empr_statut (
  idstatut smallint(5) unsigned NOT NULL auto_increment,
  statut_libelle varchar(255) NOT NULL default '',
  allow_loan tinyint(4) NOT NULL default '1',
  allow_loan_hist tinyint(4) unsigned NOT NULL default '0',
  allow_book tinyint(4) NOT NULL default '1',
  allow_opac tinyint(4) NOT NULL default '1',
  allow_dsi tinyint(4) NOT NULL default '1',
  allow_dsi_priv tinyint(4) NOT NULL default '1',
  allow_sugg tinyint(4) NOT NULL default '1',
  allow_prol tinyint(4) NOT NULL default '1',
  allow_avis tinyint(4) unsigned NOT NULL default '1',
  allow_tag tinyint(4) unsigned NOT NULL default '1',
  allow_pwd tinyint(4) unsigned NOT NULL default '1',
  PRIMARY KEY  (idstatut)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `empty_words_calculs`
-- 

CREATE TABLE empty_words_calculs (
  id_calcul int(9) unsigned NOT NULL auto_increment,
  date_calcul date NOT NULL default '0000-00-00',
  php_empty_words text NOT NULL,
  nb_notices_calcul mediumint(8) unsigned NOT NULL default '0',
  archive_calcul tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (id_calcul)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `entites`
-- 

CREATE TABLE entites (
  id_entite int(5) unsigned NOT NULL auto_increment,
  type_entite int(3) unsigned NOT NULL default '0',
  num_bibli int(5) unsigned NOT NULL default '0',
  raison_sociale varchar(255) NOT NULL default '',
  commentaires text,
  siret varchar(255) NOT NULL default '',
  naf varchar(255) NOT NULL default '',
  rcs varchar(255) NOT NULL default '',
  tva varchar(255) NOT NULL default '',
  num_cp_client varchar(255) NOT NULL default '',
  num_cp_compta varchar(255) NOT NULL default '',
  site_web varchar(255) NOT NULL default '',
  logo varchar(255) NOT NULL default '',
  autorisations mediumtext NOT NULL,
  num_frais int(8) unsigned NOT NULL default '0',
  num_paiement int(8) unsigned NOT NULL default '0',
  index_entite text NOT NULL,
  PRIMARY KEY  (id_entite),
  KEY raison_sociale (raison_sociale)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `entrepots`
-- 

CREATE TABLE entrepots (
  connector_id varchar(20) NOT NULL default '',
  source_id int(11) unsigned NOT NULL default '0',
  ref varchar(220) NOT NULL default '',
  date_import datetime NOT NULL default '0000-00-00 00:00:00',
  ufield char(3) NOT NULL default '',
  usubfield char(1) NOT NULL default '',
  field_order int(10) unsigned NOT NULL default '0',
  subfield_order int(10) unsigned NOT NULL default '0',
  value text NOT NULL,
  i_value text NOT NULL,
  recid varchar(255) NOT NULL default '',
  search_id varchar(32) NOT NULL default '',
  PRIMARY KEY  (connector_id,source_id,ref,ufield,usubfield,field_order,subfield_order,search_id),
  KEY usubfield (usubfield),
  KEY ufield_2 (ufield,usubfield),
  KEY recid_2 (recid,ufield,usubfield),
  KEY source_id (source_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `equations`
-- 

CREATE TABLE equations (
  id_equation int(9) unsigned NOT NULL auto_increment,
  num_classement int(8) unsigned NOT NULL default '1',
  nom_equation varchar(255) NOT NULL default '',
  comment_equation varchar(255) NOT NULL default '',
  requete blob NOT NULL,
  proprio_equation int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_equation)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `error_log`
-- 

CREATE TABLE error_log (
  error_date timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  error_origin varchar(255) default NULL,
  error_text text
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `etagere`
-- 

CREATE TABLE etagere (
  idetagere int(8) unsigned NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  `comment` blob NOT NULL,
  validite int(1) unsigned NOT NULL default '0',
  validite_date_deb date NOT NULL default '0000-00-00',
  validite_date_fin date NOT NULL default '0000-00-00',
  visible_accueil int(1) unsigned NOT NULL default '1',
  autorisations mediumtext,
  PRIMARY KEY  (idetagere)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `etagere_caddie`
-- 

CREATE TABLE etagere_caddie (
  etagere_id int(8) unsigned NOT NULL default '0',
  caddie_id int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (etagere_id,caddie_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `exemplaires`
-- 

CREATE TABLE exemplaires (
  expl_id int(10) unsigned NOT NULL auto_increment,
  expl_cb varchar(50) NOT NULL default '',
  expl_notice int(10) unsigned NOT NULL default '0',
  expl_bulletin int(10) unsigned NOT NULL default '0',
  expl_typdoc tinyint(3) unsigned NOT NULL default '0',
  expl_cote varchar(50) NOT NULL default '',
  expl_section smallint(5) unsigned NOT NULL default '0',
  expl_statut smallint(5) unsigned NOT NULL default '0',
  expl_location smallint(5) unsigned NOT NULL default '0',
  expl_codestat smallint(5) unsigned NOT NULL default '0',
  expl_date_depot date NOT NULL default '0000-00-00',
  expl_date_retour date NOT NULL default '0000-00-00',
  expl_note tinytext NOT NULL,
  expl_prix varchar(255) NOT NULL default '',
  expl_owner mediumint(8) unsigned NOT NULL default '0',
  expl_lastempr int(10) unsigned NOT NULL default '0',
  last_loan_date date default NULL,
  create_date datetime NOT NULL default '2005-01-01 00:00:00',
  update_date timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  type_antivol int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (expl_id),
  UNIQUE KEY expl_cb (expl_cb),
  KEY expl_typdoc (expl_typdoc),
  KEY expl_cote (expl_cote),
  KEY expl_notice (expl_notice),
  KEY expl_codestat (expl_codestat),
  KEY expl_owner (expl_owner),
  KEY expl_bulletin (expl_bulletin)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `exemplaires_temp`
-- 

CREATE TABLE exemplaires_temp (
  cb varchar(50) NOT NULL default '',
  sess varchar(12) NOT NULL default '',
  UNIQUE KEY cb (cb)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `exercices`
-- 

CREATE TABLE exercices (
  id_exercice int(8) unsigned NOT NULL auto_increment,
  num_entite int(5) unsigned NOT NULL default '0',
  libelle varchar(255) NOT NULL default '',
  date_debut date NOT NULL default '2006-01-01',
  date_fin date NOT NULL default '2006-01-01',
  statut int(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (id_exercice)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `expl_custom`
-- 

CREATE TABLE expl_custom (
  idchamp int(10) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  titre varchar(255) default NULL,
  `type` varchar(10) NOT NULL default 'text',
  datatype varchar(10) NOT NULL default '',
  options text,
  multiple int(11) NOT NULL default '0',
  obligatoire int(11) NOT NULL default '0',
  ordre int(11) default NULL,
  PRIMARY KEY  (idchamp)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `expl_custom_lists`
-- 

CREATE TABLE expl_custom_lists (
  expl_custom_champ int(10) unsigned NOT NULL default '0',
  expl_custom_list_value varchar(255) default NULL,
  expl_custom_list_lib varchar(255) default NULL,
  ordre int(11) default NULL,
  KEY expl_custom_champ (expl_custom_champ),
  KEY expl_champ_list_value (expl_custom_champ,expl_custom_list_value)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `expl_custom_values`
-- 

CREATE TABLE expl_custom_values (
  expl_custom_champ int(10) unsigned NOT NULL default '0',
  expl_custom_origine int(10) unsigned NOT NULL default '0',
  expl_custom_small_text varchar(255) default NULL,
  expl_custom_text text,
  expl_custom_integer int(11) default NULL,
  expl_custom_date date default NULL,
  expl_custom_float float default NULL,
  KEY expl_custom_champ (expl_custom_champ),
  KEY expl_custom_origine (expl_custom_origine)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `explnum`
-- 

CREATE TABLE explnum (
  explnum_id int(11) unsigned NOT NULL auto_increment,
  explnum_notice mediumint(8) unsigned NOT NULL default '0',
  explnum_bulletin int(8) unsigned NOT NULL default '0',
  explnum_nom varchar(255) NOT NULL default '',
  explnum_mimetype varchar(255) NOT NULL default '',
  explnum_url text NOT NULL,
  explnum_data mediumblob,
  explnum_vignette mediumblob,
  explnum_extfichier varchar(20) default '',
  explnum_nomfichier text,
  PRIMARY KEY  (explnum_id),
  KEY explnum_notice (explnum_notice),
  KEY explnum_bulletin (explnum_bulletin)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `frais`
-- 

CREATE TABLE frais (
  id_frais int(8) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  condition_frais text NOT NULL,
  montant float(8,2) unsigned NOT NULL default '0.00',
  num_cp_compta varchar(255) NOT NULL default '',
  num_tva_achat varchar(25) NOT NULL default '0',
  PRIMARY KEY  (id_frais)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `grilles`
-- 

CREATE TABLE grilles (
  grille_typdoc char(2) NOT NULL default 'a',
  grille_niveau_biblio char(1) NOT NULL default 'm',
  grille_localisation mediumint(8) NOT NULL default '0',
  descr_format longtext,
  PRIMARY KEY  (grille_typdoc,grille_niveau_biblio,grille_localisation)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `groupe`
-- 

CREATE TABLE groupe (
  id_groupe int(6) unsigned NOT NULL auto_increment,
  libelle_groupe varchar(50) NOT NULL default '',
  resp_groupe int(6) unsigned default '0',
  lettre_rappel int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_groupe),
  UNIQUE KEY libelle_groupe (libelle_groupe)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `import_marc`
-- 

CREATE TABLE import_marc (
  id_import bigint(5) unsigned NOT NULL auto_increment,
  notice longblob NOT NULL,
  origine varchar(50) default '',
  no_notice int(10) unsigned default '0',
  PRIMARY KEY  (id_import)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `indexint`
-- 

CREATE TABLE indexint (
  indexint_id mediumint(8) unsigned NOT NULL auto_increment,
  indexint_name varchar(255) NOT NULL default '',
  indexint_comment text,
  index_indexint text,
  num_pclass int(11) NOT NULL default '1',
  PRIMARY KEY  (indexint_id),
  UNIQUE KEY indexint_name (indexint_name,num_pclass)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `lenders`
-- 

CREATE TABLE lenders (
  idlender smallint(5) unsigned NOT NULL auto_increment,
  lender_libelle varchar(30) NOT NULL default '',
  PRIMARY KEY  (idlender)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `liens_actes`
-- 

CREATE TABLE liens_actes (
  num_acte int(8) unsigned NOT NULL default '0',
  num_acte_lie int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (num_acte,num_acte_lie)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `lignes_actes`
-- 

CREATE TABLE lignes_actes (
  id_ligne int(15) unsigned NOT NULL auto_increment,
  type_ligne int(3) unsigned NOT NULL default '0',
  num_acte int(8) unsigned NOT NULL default '0',
  lig_ref int(15) unsigned NOT NULL default '0',
  num_acquisition int(12) unsigned NOT NULL default '0',
  num_rubrique int(8) unsigned NOT NULL default '0',
  num_produit int(8) unsigned NOT NULL default '0',
  num_type int(8) unsigned NOT NULL default '0',
  libelle text NOT NULL,
  code varchar(255) NOT NULL default '',
  prix float(8,2) unsigned NOT NULL default '0.00',
  tva float(8,2) unsigned NOT NULL default '0.00',
  nb int(5) unsigned NOT NULL default '1',
  date_ech date NOT NULL default '0000-00-00',
  date_cre date NOT NULL default '0000-00-00',
  statut int(3) unsigned NOT NULL default '0',
  remise float(8,2) NOT NULL default '0.00',
  index_ligne text NOT NULL,
  PRIMARY KEY  (id_ligne)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `linked_mots`
-- 

CREATE TABLE linked_mots (
  num_mot mediumint(8) unsigned NOT NULL default '0',
  num_linked_mot mediumint(8) unsigned NOT NULL default '0',
  type_lien tinyint(1) NOT NULL default '1',
  ponderation float NOT NULL default '1',
  PRIMARY KEY  (num_mot,num_linked_mot,type_lien)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `mots`
-- 

CREATE TABLE mots (
  id_mot mediumint(8) unsigned NOT NULL auto_increment,
  mot varchar(100) NOT NULL default '',
  PRIMARY KEY  (id_mot),
  UNIQUE KEY mot (mot)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `noeuds`
-- 

CREATE TABLE noeuds (
  id_noeud int(9) unsigned NOT NULL auto_increment,
  autorite varchar(255) NOT NULL default '',
  num_parent int(9) unsigned NOT NULL default '0',
  num_renvoi_voir int(9) unsigned NOT NULL default '0',
  visible char(1) NOT NULL default '1',
  num_thesaurus int(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_noeud),
  KEY num_parent (num_parent),
  KEY num_thesaurus (num_thesaurus),
  KEY autorite (autorite)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notice_statut`
-- 

CREATE TABLE notice_statut (
  id_notice_statut smallint(5) unsigned NOT NULL auto_increment,
  gestion_libelle varchar(255) default NULL,
  opac_libelle varchar(255) default NULL,
  notice_visible_opac tinyint(1) NOT NULL default '1',
  notice_visible_gestion tinyint(1) NOT NULL default '1',
  expl_visible_opac tinyint(1) NOT NULL default '1',
  class_html varchar(255) NOT NULL default '',
  notice_visible_opac_abon tinyint(1) NOT NULL default '0',
  expl_visible_opac_abon int(10) unsigned NOT NULL default '0',
  explnum_visible_opac int(1) unsigned NOT NULL default '1',
  explnum_visible_opac_abon int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_notice_statut)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices`
-- 

CREATE TABLE notices (
  notice_id mediumint(8) unsigned NOT NULL auto_increment,
  typdoc char(2) NOT NULL default 'a',
  tit1 tinytext NOT NULL,
  tit2 tinytext NOT NULL,
  tit3 tinytext NOT NULL,
  tit4 tinytext NOT NULL,
  tparent_id mediumint(8) unsigned NOT NULL default '0',
  tnvol varchar(100) NOT NULL default '',
  ed1_id mediumint(8) unsigned NOT NULL default '0',
  ed2_id mediumint(8) unsigned NOT NULL default '0',
  coll_id mediumint(8) unsigned NOT NULL default '0',
  subcoll_id mediumint(8) unsigned NOT NULL default '0',
  `year` varchar(16) default '',
  nocoll varchar(16) default '',
  mention_edition varchar(255) NOT NULL default '',
  code varchar(50) NOT NULL default '',
  npages varchar(54) NOT NULL default '',
  ill varchar(54) NOT NULL default '',
  size varchar(54) NOT NULL default '',
  accomp varchar(54) NOT NULL default '',
  n_gen text NOT NULL,
  n_contenu text NOT NULL,
  n_resume text NOT NULL,
  lien tinytext NOT NULL,
  eformat varchar(255) NOT NULL default '',
  index_l text NOT NULL,
  indexint int(8) unsigned NOT NULL default '0',
  index_serie tinytext,
  index_matieres text NOT NULL,
  niveau_biblio char(1) NOT NULL default 'm',
  niveau_hierar char(1) NOT NULL default '0',
  origine_catalogage int(8) unsigned NOT NULL default '1',
  prix varchar(255) NOT NULL default '',
  index_n_gen text,
  index_n_contenu text,
  index_n_resume text,
  index_sew text,
  index_wew text,
  statut int(5) NOT NULL default '1',
  commentaire_gestion text NOT NULL,
  create_date datetime NOT NULL default '2005-01-01 00:00:00',
  update_date timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  signature varchar(255) NOT NULL default '',
  PRIMARY KEY  (notice_id),
  KEY typdoc (typdoc),
  KEY tparent_id (tparent_id),
  KEY ed1_id (ed1_id),
  KEY ed2_id (ed2_id),
  KEY coll_id (coll_id),
  KEY subcoll_id (subcoll_id),
  KEY cb (code),
  KEY indexint (indexint),
  KEY sig_index (signature)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_categories`
-- 

CREATE TABLE notices_categories (
  notcateg_notice int(9) unsigned NOT NULL default '0',
  num_noeud int(9) unsigned NOT NULL default '0',
  num_vedette int(3) unsigned NOT NULL default '0',
  ordre_vedette int(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (notcateg_notice,num_noeud,num_vedette),
  KEY num_noeud (num_noeud)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_custom`
-- 

CREATE TABLE notices_custom (
  idchamp int(10) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  titre varchar(255) default NULL,
  `type` varchar(10) NOT NULL default 'text',
  datatype varchar(10) NOT NULL default '',
  options text,
  multiple int(11) NOT NULL default '0',
  obligatoire int(11) NOT NULL default '0',
  ordre int(11) default NULL,
  PRIMARY KEY  (idchamp)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_custom_lists`
-- 

CREATE TABLE notices_custom_lists (
  notices_custom_champ int(10) unsigned NOT NULL default '0',
  notices_custom_list_value varchar(255) default NULL,
  notices_custom_list_lib varchar(255) default NULL,
  ordre int(11) default NULL,
  KEY notices_custom_champ (notices_custom_champ),
  KEY noti_champ_list_value (notices_custom_champ,notices_custom_list_value)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_custom_values`
-- 

CREATE TABLE notices_custom_values (
  notices_custom_champ int(10) unsigned NOT NULL default '0',
  notices_custom_origine int(10) unsigned NOT NULL default '0',
  notices_custom_small_text varchar(255) default NULL,
  notices_custom_text text,
  notices_custom_integer int(11) default NULL,
  notices_custom_date date default NULL,
  notices_custom_float float default NULL,
  KEY notices_custom_champ (notices_custom_champ),
  KEY notices_custom_origine (notices_custom_origine)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_global_index`
-- 

CREATE TABLE notices_global_index (
  num_notice mediumint(8) NOT NULL default '0',
  no_index mediumint(8) NOT NULL default '0',
  infos_global text NOT NULL,
  index_infos_global text NOT NULL,
  PRIMARY KEY  (num_notice,no_index)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_langues`
-- 

CREATE TABLE notices_langues (
  num_notice int(8) unsigned NOT NULL default '0',
  type_langue int(1) unsigned NOT NULL default '0',
  code_langue char(3) NOT NULL default '',
  PRIMARY KEY  (num_notice,type_langue,code_langue)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_mots_global_index`
-- 

CREATE TABLE notices_mots_global_index (
  id_notice mediumint(8) NOT NULL default '0',
  code_champ int(2) NOT NULL default '0',
  mot varchar(100) NOT NULL default '',
  nbr_mot int(5) NOT NULL default '0',
  PRIMARY KEY  (id_notice,code_champ,mot),
  KEY code_champ (code_champ),
  KEY mot (mot)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `notices_relations`
-- 

CREATE TABLE notices_relations (
  num_notice bigint(20) unsigned NOT NULL default '0',
  linked_notice bigint(20) unsigned NOT NULL default '0',
  relation_type char(1) NOT NULL default '',
  rank int(11) NOT NULL default '0',
  PRIMARY KEY  (num_notice,linked_notice),
  KEY linked_notice (linked_notice),
  KEY relation_type (relation_type)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `offres_remises`
-- 

CREATE TABLE offres_remises (
  num_fournisseur int(5) unsigned NOT NULL default '0',
  num_produit int(8) unsigned NOT NULL default '0',
  remise float(4,2) unsigned NOT NULL default '0.00',
  condition_remise text,
  PRIMARY KEY  (num_fournisseur,num_produit)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `opac_sessions`
-- 

CREATE TABLE opac_sessions (
  empr_id int(10) unsigned NOT NULL default '0',
  `session` blob,
  date_rec timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (empr_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `origine_notice`
-- 

CREATE TABLE origine_notice (
  orinot_id int(8) unsigned NOT NULL auto_increment,
  orinot_nom varchar(255) NOT NULL default '',
  orinot_pays varchar(255) NOT NULL default 'FR',
  orinot_diffusion int(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (orinot_id),
  KEY orinot_nom (orinot_nom)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `ouvertures`
-- 

CREATE TABLE ouvertures (
  date_ouverture date NOT NULL default '0000-00-00',
  ouvert int(1) NOT NULL default '1',
  commentaire varchar(255) NOT NULL default '',
  num_location int(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (date_ouverture,num_location)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `paiements`
-- 

CREATE TABLE paiements (
  id_paiement int(8) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  commentaire text NOT NULL,
  PRIMARY KEY  (id_paiement)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `parametres`
-- 

CREATE TABLE parametres (
  id_param int(6) unsigned NOT NULL auto_increment,
  type_param varchar(20) default NULL,
  sstype_param varchar(255) default NULL,
  valeur_param text,
  comment_param longtext,
  section_param varchar(255) NOT NULL default '',
  gestion int(1) NOT NULL default '0',
  PRIMARY KEY  (id_param),
  UNIQUE KEY typ_sstyp (type_param,sstype_param)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `pclassement`
-- 

CREATE TABLE pclassement (
  id_pclass int(10) unsigned NOT NULL auto_increment,
  name_pclass varchar(255) NOT NULL default '',
  typedoc varchar(255) NOT NULL default '',
  PRIMARY KEY  (id_pclass)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `pret`
-- 

CREATE TABLE pret (
  pret_idempr int(10) unsigned NOT NULL default '0',
  pret_idexpl int(10) unsigned NOT NULL default '0',
  pret_date datetime NOT NULL default '0000-00-00 00:00:00',
  pret_retour date default NULL,
  pret_arc_id int(10) unsigned NOT NULL default '0',
  niveau_relance int(1) NOT NULL default '0',
  date_relance date default '0000-00-00',
  printed int(1) NOT NULL default '0',
  retour_initial date default '0000-00-00',
  cpt_prolongation int(1) NOT NULL default '0',
  PRIMARY KEY  (pret_idexpl)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `pret_archive`
-- 

CREATE TABLE pret_archive (
  arc_id int(10) unsigned NOT NULL auto_increment,
  arc_debut datetime default '0000-00-00 00:00:00',
  arc_fin datetime default NULL,
  arc_id_empr int(10) unsigned NOT NULL default '0',
  arc_empr_cp varchar(10) NOT NULL default '',
  arc_empr_ville varchar(255) NOT NULL default '',
  arc_empr_prof varchar(255) NOT NULL default '',
  arc_empr_year int(4) unsigned default '0',
  arc_empr_categ smallint(5) unsigned default '0',
  arc_empr_codestat smallint(5) unsigned default '0',
  arc_empr_sexe tinyint(3) unsigned default '0',
  arc_empr_statut int(10) unsigned NOT NULL default '1',
  arc_expl_typdoc tinyint(3) unsigned default '0',
  arc_expl_cote varchar(255) NOT NULL default '',
  arc_expl_statut smallint(5) unsigned default '0',
  arc_expl_location smallint(5) unsigned default '0',
  arc_expl_codestat smallint(5) unsigned default '0',
  arc_expl_owner mediumint(8) unsigned default '0',
  arc_expl_section int(5) unsigned NOT NULL default '0',
  arc_expl_id int(10) unsigned NOT NULL default '0',
  arc_expl_notice int(10) unsigned NOT NULL default '0',
  arc_expl_bulletin int(10) unsigned NOT NULL default '0',
  arc_groupe varchar(255) NOT NULL default '',
  PRIMARY KEY  (arc_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `procs`
-- 

CREATE TABLE procs (
  idproc smallint(5) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  requete blob NOT NULL,
  `comment` tinytext NOT NULL,
  autorisations mediumtext,
  parameters text,
  PRIMARY KEY  (idproc),
  KEY idproc (idproc)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `publishers`
-- 

CREATE TABLE publishers (
  ed_id mediumint(8) unsigned NOT NULL auto_increment,
  ed_name varchar(255) NOT NULL default '',
  ed_adr1 varchar(255) NOT NULL default '',
  ed_adr2 varchar(255) NOT NULL default '',
  ed_cp varchar(10) NOT NULL default '',
  ed_ville varchar(96) NOT NULL default '',
  ed_pays varchar(96) NOT NULL default '',
  ed_web varchar(255) NOT NULL default '',
  index_publisher text,
  ed_comment text,
  PRIMARY KEY  (ed_id),
  KEY ed_name (ed_name),
  KEY ed_ville (ed_ville)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `quotas`
-- 

CREATE TABLE quotas (
  quota_type int(10) unsigned NOT NULL default '0',
  constraint_type varchar(255) NOT NULL default '',
  elements int(10) unsigned NOT NULL default '0',
  `value` float default NULL,
  PRIMARY KEY  (quota_type,constraint_type,elements)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `quotas_finance`
-- 

CREATE TABLE quotas_finance (
  quota_type int(10) unsigned NOT NULL default '0',
  constraint_type varchar(255) NOT NULL default '',
  elements int(10) unsigned NOT NULL default '0',
  `value` float default NULL,
  PRIMARY KEY  (quota_type,constraint_type,elements)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `recouvrements`
-- 

CREATE TABLE recouvrements (
  recouvr_id int(16) unsigned NOT NULL auto_increment,
  empr_id int(10) unsigned NOT NULL default '0',
  id_expl int(10) unsigned NOT NULL default '0',
  date_rec date NOT NULL default '0000-00-00',
  libelle varchar(255) default NULL,
  montant decimal(16,2) default '0.00',
  PRIMARY KEY  (recouvr_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `resa`
-- 

CREATE TABLE resa (
  id_resa mediumint(8) unsigned NOT NULL auto_increment,
  resa_idempr mediumint(8) unsigned NOT NULL default '0',
  resa_idnotice mediumint(8) unsigned NOT NULL default '0',
  resa_idbulletin int(8) unsigned NOT NULL default '0',
  resa_date datetime default NULL,
  resa_date_debut date NOT NULL default '0000-00-00',
  resa_date_fin date NOT NULL default '0000-00-00',
  resa_cb varchar(255) NOT NULL default '',
  resa_confirmee int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_resa),
  KEY resa_date_fin (resa_date_fin),
  KEY resa_date (resa_date),
  KEY resa_cb (resa_cb)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `resa_planning`
-- 

CREATE TABLE resa_planning (
  id_resa mediumint(8) unsigned NOT NULL auto_increment,
  resa_idempr mediumint(8) unsigned NOT NULL default '0',
  resa_idnotice mediumint(8) unsigned NOT NULL default '0',
  resa_date datetime default NULL,
  resa_date_debut date NOT NULL default '0000-00-00',
  resa_date_fin date NOT NULL default '0000-00-00',
  resa_validee int(1) unsigned NOT NULL default '0',
  resa_confirmee int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_resa),
  KEY resa_date_fin (resa_date_fin),
  KEY resa_date (resa_date)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `resa_ranger`
-- 

CREATE TABLE resa_ranger (
  resa_cb varchar(255) NOT NULL default '',
  PRIMARY KEY  (resa_cb)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `responsability`
-- 

CREATE TABLE responsability (
  responsability_author mediumint(8) unsigned NOT NULL default '0',
  responsability_notice mediumint(8) unsigned NOT NULL default '0',
  responsability_fonction char(3) NOT NULL default '',
  responsability_type mediumint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (responsability_author,responsability_notice,responsability_fonction),
  KEY responsability_notice (responsability_notice)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `rss_content`
-- 

CREATE TABLE rss_content (
  rss_id int(10) unsigned NOT NULL default '0',
  rss_content longblob NOT NULL,
  rss_last timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (rss_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `rss_flux`
-- 

CREATE TABLE rss_flux (
  id_rss_flux int(9) unsigned NOT NULL auto_increment,
  nom_rss_flux varchar(255) NOT NULL default '',
  link_rss_flux blob NOT NULL,
  descr_rss_flux blob NOT NULL,
  lang_rss_flux varchar(255) NOT NULL default 'fr',
  copy_rss_flux blob NOT NULL,
  editor_rss_flux varchar(255) NOT NULL default '',
  webmaster_rss_flux varchar(255) NOT NULL default '',
  ttl_rss_flux int(9) unsigned NOT NULL default '60',
  img_url_rss_flux blob NOT NULL,
  img_title_rss_flux blob NOT NULL,
  img_link_rss_flux blob NOT NULL,
  format_flux blob NOT NULL,
  PRIMARY KEY  (id_rss_flux)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `rss_flux_content`
-- 

CREATE TABLE rss_flux_content (
  num_rss_flux int(9) unsigned NOT NULL default '0',
  type_contenant char(3) NOT NULL default 'BAN',
  num_contenant int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (num_rss_flux,type_contenant,num_contenant)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `rubriques`
-- 

CREATE TABLE rubriques (
  id_rubrique int(8) unsigned NOT NULL auto_increment,
  num_budget int(8) unsigned NOT NULL default '0',
  num_parent int(8) unsigned NOT NULL default '0',
  libelle varchar(255) NOT NULL default '',
  commentaires text NOT NULL,
  montant float(8,2) unsigned NOT NULL default '0.00',
  num_cp_compta varchar(255) NOT NULL default '',
  autorisations mediumtext NOT NULL,
  PRIMARY KEY  (id_rubrique)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `sauv_lieux`
-- 

CREATE TABLE sauv_lieux (
  sauv_lieu_id int(10) unsigned NOT NULL auto_increment,
  sauv_lieu_nom varchar(50) default NULL,
  sauv_lieu_url varchar(255) default NULL,
  sauv_lieu_protocol varchar(10) default 'file',
  sauv_lieu_host varchar(255) default NULL,
  sauv_lieu_login varchar(255) default NULL,
  sauv_lieu_password varchar(255) default NULL,
  PRIMARY KEY  (sauv_lieu_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `sauv_log`
-- 

CREATE TABLE sauv_log (
  sauv_log_id int(10) unsigned NOT NULL auto_increment,
  sauv_log_start_date date default NULL,
  sauv_log_file varchar(255) default NULL,
  sauv_log_succeed int(11) default '0',
  sauv_log_messages mediumtext,
  sauv_log_userid int(11) default NULL,
  PRIMARY KEY  (sauv_log_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `sauv_sauvegardes`
-- 

CREATE TABLE sauv_sauvegardes (
  sauv_sauvegarde_id int(10) unsigned NOT NULL auto_increment,
  sauv_sauvegarde_nom varchar(50) default NULL,
  sauv_sauvegarde_file_prefix varchar(20) default NULL,
  sauv_sauvegarde_tables mediumtext,
  sauv_sauvegarde_lieux mediumtext,
  sauv_sauvegarde_users mediumtext,
  sauv_sauvegarde_compress int(11) default '0',
  sauv_sauvegarde_compress_command mediumtext,
  sauv_sauvegarde_crypt int(11) default '0',
  sauv_sauvegarde_key1 varchar(32) default NULL,
  sauv_sauvegarde_key2 varchar(32) default NULL,
  PRIMARY KEY  (sauv_sauvegarde_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `sauv_tables`
-- 

CREATE TABLE sauv_tables (
  sauv_table_id int(10) unsigned NOT NULL auto_increment,
  sauv_table_nom varchar(50) default NULL,
  sauv_table_tables text,
  PRIMARY KEY  (sauv_table_id),
  UNIQUE KEY sauv_table_nom (sauv_table_nom)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `series`
-- 

CREATE TABLE series (
  serie_id mediumint(8) unsigned NOT NULL auto_increment,
  serie_name varchar(255) NOT NULL default '',
  serie_index text,
  PRIMARY KEY  (serie_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `sessions`
-- 

CREATE TABLE sessions (
  SESSID varchar(12) NOT NULL default '',
  login varchar(20) NOT NULL default '',
  IP varchar(20) NOT NULL default '',
  SESSstart varchar(12) NOT NULL default '',
  LastOn varchar(12) NOT NULL default '',
  SESSNAME varchar(25) NOT NULL default ''
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `source_sync`
-- 

CREATE TABLE source_sync (
  source_id int(10) unsigned NOT NULL default '0',
  nrecu varchar(255) NOT NULL default '',
  ntotal varchar(255) NOT NULL default '',
  message varchar(255) NOT NULL default '',
  date_sync datetime NOT NULL default '0000-00-00 00:00:00',
  percent int(10) unsigned NOT NULL default '0',
  env text NOT NULL,
  cancel int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (source_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `sub_collections`
-- 

CREATE TABLE sub_collections (
  sub_coll_id mediumint(8) unsigned NOT NULL auto_increment,
  sub_coll_name varchar(255) NOT NULL default '',
  sub_coll_parent mediumint(9) unsigned NOT NULL default '0',
  sub_coll_issn varchar(12) NOT NULL default '',
  index_sub_coll text,
  PRIMARY KEY  (sub_coll_id),
  KEY sub_coll_name (sub_coll_name)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `suggestions`
-- 

CREATE TABLE suggestions (
  id_suggestion int(12) unsigned NOT NULL auto_increment,
  titre tinytext NOT NULL,
  editeur varchar(255) NOT NULL default '',
  auteur varchar(255) NOT NULL default '',
  code varchar(255) NOT NULL default '',
  prix float(8,2) unsigned NOT NULL default '0.00',
  commentaires text,
  statut int(3) unsigned NOT NULL default '0',
  num_produit int(8) NOT NULL default '0',
  num_entite int(5) NOT NULL default '0',
  index_suggestion text NOT NULL,
  nb int(5) unsigned NOT NULL default '1',
  date_creation date NOT NULL default '0000-00-00',
  date_decision date NOT NULL default '0000-00-00',
  num_rubrique int(8) unsigned NOT NULL default '0',
  num_fournisseur int(5) unsigned NOT NULL default '0',
  num_notice int(8) unsigned NOT NULL default '0',
  url_suggestion varchar(255) NOT NULL default '',
  num_categ int(12) NOT NULL default '1',
  PRIMARY KEY  (id_suggestion)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `suggestions_categ`
-- 

CREATE TABLE suggestions_categ (
  id_categ int(12) NOT NULL auto_increment,
  libelle_categ varchar(255) NOT NULL default '',
  PRIMARY KEY  (id_categ)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `suggestions_origine`
-- 

CREATE TABLE suggestions_origine (
  origine varchar(100) NOT NULL default '',
  num_suggestion int(12) unsigned NOT NULL default '0',
  type_origine int(3) unsigned NOT NULL default '0',
  date_suggestion date NOT NULL default '0000-00-00',
  PRIMARY KEY  (origine,num_suggestion)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `tags`
-- 

CREATE TABLE tags (
  id_tag mediumint(8) NOT NULL auto_increment,
  libelle varchar(200) NOT NULL default '',
  num_notice mediumint(8) NOT NULL default '0',
  user_code varchar(50) NOT NULL default '',
  dateajout timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (id_tag)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `thesaurus`
-- 

CREATE TABLE thesaurus (
  id_thesaurus int(3) unsigned NOT NULL auto_increment,
  libelle_thesaurus varchar(255) NOT NULL default '',
  langue_defaut varchar(5) NOT NULL default 'fr_FR',
  active char(1) NOT NULL default '1',
  opac_active char(1) NOT NULL default '1',
  num_noeud_racine int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (id_thesaurus),
  UNIQUE KEY libelle_thesaurus (libelle_thesaurus)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `transactions`
-- 

CREATE TABLE transactions (
  id_transaction int(10) unsigned NOT NULL auto_increment,
  compte_id int(8) unsigned NOT NULL default '0',
  user_id int(10) unsigned NOT NULL default '0',
  user_name varchar(255) NOT NULL default '',
  machine varchar(255) NOT NULL default '',
  date_enrgt datetime NOT NULL default '0000-00-00 00:00:00',
  date_prevue date default NULL,
  date_effective date default NULL,
  montant decimal(16,2) NOT NULL default '0.00',
  sens int(1) NOT NULL default '0',
  realisee int(1) NOT NULL default '0',
  commentaire text,
  encaissement int(1) NOT NULL default '0',
  PRIMARY KEY  (id_transaction)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `tris`
-- 

CREATE TABLE tris (
  id_tri int(4) NOT NULL auto_increment,
  tri_par varchar(100) NOT NULL default '',
  nom_tri varchar(100) NOT NULL default '',
  tri_par_texte varchar(100) NOT NULL default '',
  PRIMARY KEY  (id_tri)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `tva_achats`
-- 

CREATE TABLE tva_achats (
  id_tva int(8) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  taux_tva float(4,2) unsigned NOT NULL default '0.00',
  num_cp_compta varchar(25) NOT NULL default '0',
  PRIMARY KEY  (id_tva)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `type_abts`
-- 

CREATE TABLE type_abts (
  id_type_abt int(5) unsigned NOT NULL auto_increment,
  type_abt_libelle varchar(255) default NULL,
  prepay int(1) unsigned NOT NULL default '0',
  prepay_deflt_mnt decimal(16,2) NOT NULL default '0.00',
  tarif decimal(16,2) NOT NULL default '0.00',
  commentaire text NOT NULL,
  caution decimal(16,2) NOT NULL default '0.00',
  localisations varchar(255) NOT NULL default '',
  PRIMARY KEY  (id_type_abt)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `type_comptes`
-- 

CREATE TABLE type_comptes (
  id_type_compte int(8) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  type_acces int(8) unsigned NOT NULL default '0',
  acces_id text NOT NULL,
  PRIMARY KEY  (id_type_compte)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `types_produits`
-- 

CREATE TABLE types_produits (
  id_produit int(8) unsigned NOT NULL auto_increment,
  libelle varchar(255) NOT NULL default '',
  num_cp_compta varchar(25) NOT NULL default '0',
  num_tva_achat varchar(25) NOT NULL default '0',
  PRIMARY KEY  (id_produit),
  KEY libelle (libelle)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `users`
-- 

CREATE TABLE users (
  userid int(5) NOT NULL auto_increment,
  create_dt date NOT NULL default '0000-00-00',
  last_updated_dt date NOT NULL default '0000-00-00',
  username varchar(100) NOT NULL default '',
  pwd varchar(50) NOT NULL default '',
  nom varchar(30) NOT NULL default '',
  prenom varchar(30) default NULL,
  rights int(8) unsigned NOT NULL default '0',
  user_lang varchar(5) NOT NULL default 'fr_FR',
  nb_per_page_search int(10) unsigned NOT NULL default '4',
  nb_per_page_select int(10) unsigned NOT NULL default '10',
  nb_per_page_gestion int(10) unsigned NOT NULL default '20',
  param_popup_ticket smallint(1) unsigned NOT NULL default '0',
  param_sounds smallint(1) unsigned NOT NULL default '1',
  param_licence int(1) unsigned NOT NULL default '0',
  deflt_notice_statut int(6) unsigned NOT NULL default '1',
  deflt_docs_type int(6) unsigned NOT NULL default '1',
  deflt_lenders int(6) unsigned NOT NULL default '0',
  deflt_styles varchar(20) NOT NULL default 'default',
  deflt_docs_statut int(6) unsigned default '0',
  deflt_docs_codestat int(6) unsigned default '0',
  value_deflt_lang varchar(20) default 'fre',
  value_deflt_fonction varchar(20) default '070',
  deflt_docs_location int(6) unsigned default '0',
  deflt_docs_section int(6) unsigned default '0',
  value_deflt_module varchar(30) default 'circu',
  user_email varchar(255) default '',
  user_alert_resamail int(1) unsigned NOT NULL default '0',
  deflt2docs_location int(6) unsigned NOT NULL default '0',
  deflt_empr_statut bigint(20) unsigned NOT NULL default '1',
  deflt_thesaurus int(3) unsigned NOT NULL default '1',
  value_prefix_cote tinyblob NOT NULL,
  xmlta_doctype char(2) NOT NULL default 'a',
  speci_coordonnees_etab mediumtext NOT NULL,
  value_email_bcc varchar(255) NOT NULL default '',
  explr_invisible varchar(255) default '',
  explr_visible_mod varchar(255) default '',
  explr_visible_unmod varchar(255) default '',
  PRIMARY KEY  (userid)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `voir_aussi`
-- 

CREATE TABLE voir_aussi (
  num_noeud_orig int(9) unsigned NOT NULL default '0',
  num_noeud_dest int(9) unsigned NOT NULL default '0',
  langue varchar(5) NOT NULL default '',
  comment_voir_aussi text NOT NULL,
  PRIMARY KEY  (num_noeud_orig,num_noeud_dest,langue),
  KEY num_noeud_dest (num_noeud_dest)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `z_attr`
-- 

CREATE TABLE z_attr (
  attr_bib_id int(6) unsigned NOT NULL default '0',
  attr_libelle varchar(250) NOT NULL default '',
  attr_attr varchar(250) default NULL,
  PRIMARY KEY  (attr_bib_id,attr_libelle)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `z_bib`
-- 

CREATE TABLE z_bib (
  bib_id int(6) unsigned NOT NULL auto_increment,
  bib_nom varchar(250) default NULL,
  search_type varchar(20) default NULL,
  url varchar(250) default NULL,
  port varchar(6) default NULL,
  base varchar(250) default NULL,
  format varchar(250) default NULL,
  auth_user varchar(250) NOT NULL default '',
  auth_pass varchar(250) NOT NULL default '',
  sutrs_lang varchar(10) NOT NULL default '',
  fichier_func varchar(255) NOT NULL default '',
  PRIMARY KEY  (bib_id)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `z_notices`
-- 

CREATE TABLE z_notices (
  znotices_id int(11) unsigned NOT NULL auto_increment,
  znotices_query_id int(11) default NULL,
  znotices_bib_id int(6) unsigned default '0',
  isbd text,
  isbn varchar(250) default NULL,
  titre varchar(250) default NULL,
  auteur varchar(250) default NULL,
  z_marc longblob NOT NULL,
  PRIMARY KEY  (znotices_id),
  KEY idx_z_notices_idq (znotices_query_id),
  KEY idx_z_notices_isbn (isbn),
  KEY idx_z_notices_titre (titre),
  KEY idx_z_notices_auteur (auteur)
) ;

-- --------------------------------------------------------

-- 
-- Structure de la table `z_query`
-- 

CREATE TABLE z_query (
  zquery_id int(11) unsigned NOT NULL auto_increment,
  search_attr varchar(255) default NULL,
  zquery_date timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (zquery_id),
  KEY zquery_date (zquery_date)
) ;
        