-- MySQL dump 10.9
--
-- Host: localhost    Database: bibli
-- ------------------------------------------------------
-- Server version	4.1.9-max

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES latin1 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE="NO_AUTO_VALUE_ON_ZERO" */;

--
-- Table structure for table `actes`
--

DROP TABLE IF EXISTS `actes`;
CREATE TABLE `actes` (
  `id_acte` int(8) unsigned NOT NULL auto_increment,
  `date_acte` date NOT NULL default '0000-00-00',
  `numero` varchar(25) NOT NULL default '',
  `type_acte` int(3) unsigned NOT NULL default '0',
  `statut` int(3) unsigned NOT NULL default '0',
  `date_paiement` date NOT NULL default '0000-00-00',
  `num_paiement` varchar(255) NOT NULL default '',
  `num_entite` int(5) unsigned NOT NULL default '0',
  `num_fournisseur` int(5) unsigned NOT NULL default '0',
  `num_contact_livr` int(8) unsigned NOT NULL default '0',
  `num_contact_fact` int(8) unsigned NOT NULL default '0',
  `num_exercice` int(8) unsigned NOT NULL default '0',
  `commentaires` text NOT NULL,
  `reference` varchar(255) NOT NULL default '',
  `index_acte` text NOT NULL,
  `devise` varchar(25) NOT NULL default '',
  `commentaires_i` text NOT NULL,
  `date_valid` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`id_acte`),
  KEY `num_fournisseur` (`num_fournisseur`),
  KEY `date` (`date_acte`),
  KEY `num_entite` (`num_entite`),
  KEY `numero` (`numero`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `actes`
--


/*!40000 ALTER TABLE `actes` DISABLE KEYS */;
LOCK TABLES `actes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `actes` ENABLE KEYS */;

--
-- Table structure for table `admin_session`
--

DROP TABLE IF EXISTS `admin_session`;
CREATE TABLE `admin_session` (
  `userid` int(10) unsigned NOT NULL default '0',
  `session` blob,
  PRIMARY KEY  (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `admin_session`
--


/*!40000 ALTER TABLE `admin_session` DISABLE KEYS */;
LOCK TABLES `admin_session` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `admin_session` ENABLE KEYS */;

--
-- Table structure for table `analysis`
--

DROP TABLE IF EXISTS `analysis`;
CREATE TABLE `analysis` (
  `analysis_bulletin` int(8) unsigned NOT NULL default '0',
  `analysis_notice` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`analysis_bulletin`,`analysis_notice`),
  KEY `analysis_notice` (`analysis_notice`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `analysis`
--


/*!40000 ALTER TABLE `analysis` DISABLE KEYS */;
LOCK TABLES `analysis` WRITE;
INSERT INTO `analysis` VALUES (1,21),(1,33),(1,35),(1,36),(1,37),(1,38),(1,39),(1,40),(1,41),(2,25),(2,26),(2,29),(2,30),(2,31),(2,32);
UNLOCK TABLES;
/*!40000 ALTER TABLE `analysis` ENABLE KEYS */;

--
-- Table structure for table `audit`
--

DROP TABLE IF EXISTS `audit`;
CREATE TABLE `audit` (
  `type_obj` int(1) NOT NULL default '0',
  `object_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(8) unsigned NOT NULL default '0',
  `user_name` varchar(20) NOT NULL default '',
  `type_modif` int(1) NOT NULL default '1',
  `quand` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `audit`
--


/*!40000 ALTER TABLE `audit` DISABLE KEYS */;
LOCK TABLES `audit` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `audit` ENABLE KEYS */;

--
-- Table structure for table `authors`
--

DROP TABLE IF EXISTS `authors`;
CREATE TABLE `authors` (
  `author_id` mediumint(8) unsigned NOT NULL auto_increment,
  `author_type` enum('70','71') NOT NULL default '70',
  `author_name` varchar(255) default NULL,
  `author_rejete` varchar(255) default NULL,
  `author_date` varchar(255) NOT NULL default '',
  `author_see` mediumint(8) unsigned NOT NULL default '0',
  `author_web` varchar(255) NOT NULL default '',
  `index_author` text,
  `author_comment` text,
  PRIMARY KEY  (`author_id`),
  KEY `author_see` (`author_see`),
  KEY `author_name` (`author_name`),
  KEY `author_rejete` (`author_rejete`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `authors`
--


/*!40000 ALTER TABLE `authors` DISABLE KEYS */;
LOCK TABLES `authors` WRITE;
INSERT INTO `authors` VALUES (1,'70','ຄະນະອັກສອນສາດ ມ/ຊ','','13102006',0,'',' ຄະນະອັກສອນສາດ ມ/ຊ ',''),(2,'70','ສີລາ ວິລະວົງ','','',0,'',' ສີລາ ວິລະວົງ ',''),(3,'70','ດຳດວນ ພົມດວງສີ','','13102006',0,'',' ດຳດວນ ພົມດວງສີ ',''),(4,'70','ປະທິບ ຊຸມພົນ','','13102006',0,'',' ປະທິບ ຊຸມພົນ ',''),(5,'71','ສະຖາບັນຄົນຄວ້າວັດທະນະທຳ','','13102006',0,'',' ສະຖາບັນຄົນຄວ້າວັດທະນະທຳ ',''),(6,'70','ສຸເນດ ໂພທິສານ','','13102006',0,'',' ສຸເນດ ໂພທິສານ ',''),(7,'70','ສູນກາງສະຫະພັນກຳມະບານລາວ','','13102006',0,'',' ສູນກາງສະຫະພັນກຳມະບານລາວ ',''),(8,'70','ສຸຈິດ ວົງເທບ','','13102006',0,'',' ສຸຈິດ ວົງເທບ ',''),(9,'70','ບຸນສີ ບູລົມ','','13102006',0,'',' ບຸນສີ ບູລົມ ',''),(10,'70','ບົວໄຂ ເພັງພະຈັນ','','13102006',0,'',' ບົວໄຂ ເພັງພະຈັນ ',''),(11,'70','ໂຄຈອນ ແກ້ວມະນີວົງ','','13102006',0,'',' ໂຄຈອນ ແກ້ວມະນີວົງ ',''),(12,'71','ກົມການເມືອງ ແລະ ການປົກຄອງ','','13102006',0,'',' ກົມການເມືອງ ແລະ ການປົກຄອງ ',''),(13,'71','ກົມປ່າໄມ້','','13102006',0,'',' ກົມປ່າໄມ້ ',''),(14,'70','ບຸນມີ ເທບສີເມືອງ','','13102006',0,'',' ບຸນມີ ເທບສີເມືອງ ',''),(15,'70','ພາກວິຊາພາສາລາວ-ວັນນະຄະດີ','','13102006',0,'',' ພາກວິຊາພາສາລາວ-ວັນນະຄະດີ ',''),(16,'70','ສຳລິດ ບົວສີສະຫວັດ','','13102006',0,'',' ສຳລິດ ບົວສີສະຫວັດ ',''),(17,'71','ອົງການອະນາໄມໂລກ','','13102006',0,'',' ອົງການອະນາໄມໂລກ ',''),(18,'71','ມູນນິທິຊາຊາກາວາ ເພື່ອສັນຕິພາບ','','13102006',0,'',' ມູນນິທິຊາຊາກາວາ ເພື່ອສັນຕິພາບ ',''),(19,'71','ຄະນະຈັດຕັງສູນກາງພັກ','','13102006',0,'',' ຄະນະຈັດຕັງສູນກາງພັກ ',''),(20,'70','ຄຳຜາຍ ບຸບຜາ','','13102006',0,'',' ຄຳຜາຍ ບຸບຜາ ',''),(21,'70','ທອງມາລີ ສຸລາດ','','13102006',0,'',' ທອງມາລີ ສຸລາດ ',''),(22,'70','ໃຊພອນ ສິທາລາດ','','13102006',0,'',' ໃຊພອນ ສິທາລາດ ','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `authors` ENABLE KEYS */;

--
-- Table structure for table `avis`
--

DROP TABLE IF EXISTS `avis`;
CREATE TABLE `avis` (
  `id_avis` mediumint(8) NOT NULL auto_increment,
  `num_empr` mediumint(8) NOT NULL default '0',
  `num_notice` mediumint(8) NOT NULL default '0',
  `note` int(3) default NULL,
  `sujet` text,
  `commentaire` text,
  `dateajout` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `valide` int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_avis`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `avis`
--


/*!40000 ALTER TABLE `avis` DISABLE KEYS */;
LOCK TABLES `avis` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `avis` ENABLE KEYS */;

--
-- Table structure for table `bannette_abon`
--

DROP TABLE IF EXISTS `bannette_abon`;
CREATE TABLE `bannette_abon` (
  `num_bannette` int(9) unsigned NOT NULL default '0',
  `num_empr` int(9) unsigned NOT NULL default '0',
  `actif` int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`num_bannette`,`num_empr`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `bannette_abon`
--


/*!40000 ALTER TABLE `bannette_abon` DISABLE KEYS */;
LOCK TABLES `bannette_abon` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `bannette_abon` ENABLE KEYS */;

--
-- Table structure for table `bannette_contenu`
--

DROP TABLE IF EXISTS `bannette_contenu`;
CREATE TABLE `bannette_contenu` (
  `num_bannette` int(9) unsigned NOT NULL default '0',
  `num_notice` int(9) unsigned NOT NULL default '0',
  `date_ajout` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`num_bannette`,`num_notice`),
  KEY `date_ajout` (`date_ajout`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `bannette_contenu`
--


/*!40000 ALTER TABLE `bannette_contenu` DISABLE KEYS */;
LOCK TABLES `bannette_contenu` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `bannette_contenu` ENABLE KEYS */;

--
-- Table structure for table `bannette_equation`
--

DROP TABLE IF EXISTS `bannette_equation`;
CREATE TABLE `bannette_equation` (
  `num_bannette` int(9) unsigned NOT NULL default '0',
  `num_equation` int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (`num_bannette`,`num_equation`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `bannette_equation`
--


/*!40000 ALTER TABLE `bannette_equation` DISABLE KEYS */;
LOCK TABLES `bannette_equation` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `bannette_equation` ENABLE KEYS */;

--
-- Table structure for table `bannette_exports`
--

DROP TABLE IF EXISTS `bannette_exports`;
CREATE TABLE `bannette_exports` (
  `num_bannette` int(11) unsigned NOT NULL default '0',
  `export_format` int(3) NOT NULL default '0',
  `export_data` longblob NOT NULL,
  `export_nomfichier` varchar(255) default '',
  PRIMARY KEY  (`num_bannette`,`export_format`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `bannette_exports`
--


/*!40000 ALTER TABLE `bannette_exports` DISABLE KEYS */;
LOCK TABLES `bannette_exports` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `bannette_exports` ENABLE KEYS */;

--
-- Table structure for table `bannettes`
--

DROP TABLE IF EXISTS `bannettes`;
CREATE TABLE `bannettes` (
  `id_bannette` int(9) unsigned NOT NULL auto_increment,
  `num_classement` int(8) unsigned NOT NULL default '1',
  `nom_bannette` varchar(255) NOT NULL default '',
  `comment_gestion` varchar(255) NOT NULL default '',
  `comment_public` varchar(255) NOT NULL default '',
  `entete_mail` text NOT NULL,
  `date_last_remplissage` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_last_envoi` datetime NOT NULL default '0000-00-00 00:00:00',
  `proprio_bannette` int(9) unsigned NOT NULL default '0',
  `bannette_auto` int(1) unsigned NOT NULL default '0',
  `periodicite` int(3) unsigned NOT NULL default '7',
  `diffusion_email` int(1) unsigned NOT NULL default '0',
  `categorie_lecteurs` int(8) unsigned NOT NULL default '0',
  `nb_notices_diff` int(4) unsigned NOT NULL default '0',
  `num_panier` int(8) unsigned NOT NULL default '0',
  `limite_type` char(1) NOT NULL default '',
  `limite_nombre` int(6) NOT NULL default '0',
  PRIMARY KEY  (`id_bannette`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `bannettes`
--


/*!40000 ALTER TABLE `bannettes` DISABLE KEYS */;
LOCK TABLES `bannettes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `bannettes` ENABLE KEYS */;

--
-- Table structure for table `budgets`
--

DROP TABLE IF EXISTS `budgets`;
CREATE TABLE `budgets` (
  `id_budget` int(8) unsigned NOT NULL auto_increment,
  `num_entite` int(5) unsigned NOT NULL default '0',
  `num_exercice` int(8) unsigned NOT NULL default '0',
  `libelle` varchar(255) NOT NULL default '',
  `commentaires` text,
  `montant_global` float(8,2) unsigned NOT NULL default '0.00',
  `seuil_alerte` int(3) unsigned NOT NULL default '100',
  `statut` int(3) unsigned NOT NULL default '0',
  `type_budget` int(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_budget`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `budgets`
--


/*!40000 ALTER TABLE `budgets` DISABLE KEYS */;
LOCK TABLES `budgets` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `budgets` ENABLE KEYS */;

--
-- Table structure for table `bulletins`
--

DROP TABLE IF EXISTS `bulletins`;
CREATE TABLE `bulletins` (
  `bulletin_id` int(8) unsigned NOT NULL auto_increment,
  `bulletin_numero` varchar(255) NOT NULL default '',
  `bulletin_notice` int(8) NOT NULL default '0',
  `mention_date` varchar(50) NOT NULL default '',
  `date_date` date NOT NULL default '0000-00-00',
  `bulletin_titre` text,
  `index_titre` text,
  `bulletin_cb` varchar(30) default NULL,
  PRIMARY KEY  (`bulletin_id`),
  KEY `bulletin_numero` (`bulletin_numero`),
  KEY `bulletin_notice` (`bulletin_notice`),
  KEY `date_date` (`date_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `bulletins`
--


/*!40000 ALTER TABLE `bulletins` DISABLE KEYS */;
LOCK TABLES `bulletins` WRITE;
INSERT INTO `bulletins` VALUES (1,'001',20,'ລາວອັບເດດ','2006-10-13','ຄວາມສາມັກຄີ ','  ',''),(2,'002',23,'ລາວກ້າວໜ້າ','2006-10-13','ດົນຕີພື້ນເມືອງຂອງລາວ','  ',''),(3,'003',24,'ເພື່ອທຳມະຊາດ','2006-10-13','ຮັກປ່າ','  ','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `bulletins` ENABLE KEYS */;

--
-- Table structure for table `caddie`
--

DROP TABLE IF EXISTS `caddie`;
CREATE TABLE `caddie` (
  `idcaddie` int(8) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `type` varchar(20) NOT NULL default 'NOTI',
  `comment` varchar(255) default NULL,
  `autorisations` mediumtext,
  PRIMARY KEY  (`idcaddie`),
  KEY `caddie_type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `caddie`
--


/*!40000 ALTER TABLE `caddie` DISABLE KEYS */;
LOCK TABLES `caddie` WRITE;
INSERT INTO `caddie` VALUES (1,'Notices pour exposition','NOTI','Placer dans ce panier les notices de l\'expo virtuelle','1 2'),(2,'Notices pour retour BDP','NOTI','Remplir ce panier  l\'issue du pointage des exemplaires en retour','1 2'),(3,'Exemplaires pour retour BDP','EXPL','Placer dans ce panier les exemplaires de documents  rendre  la BDP','1 2'),(4,'Notices en doublons sur titre','NOTI','Doublons sur le premier titre','1 2'),(8,'Exemple de panier d\'exemplaires','EXPL','','1 4 3 2'),(5,'Loire - Notices pour thme du mois','NOTI','','1 4'),(6,'Loire - Bulletins contenant des articles pour expo mois','BULL','','1 4'),(7,'Cochon - notices pour exposition mois prochain','NOTI','','1');
UNLOCK TABLES;
/*!40000 ALTER TABLE `caddie` ENABLE KEYS */;

--
-- Table structure for table `caddie_content`
--

DROP TABLE IF EXISTS `caddie_content`;
CREATE TABLE `caddie_content` (
  `caddie_id` int(8) unsigned NOT NULL default '0',
  `object_id` int(10) unsigned NOT NULL default '0',
  `content` blob,
  `blob_type` varchar(10) default NULL,
  `flag` varchar(10) default NULL,
  KEY `caddie_id` (`caddie_id`,`object_id`),
  KEY `object_id` (`object_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `caddie_content`
--


/*!40000 ALTER TABLE `caddie_content` DISABLE KEYS */;
LOCK TABLES `caddie_content` WRITE;
INSERT INTO `caddie_content` VALUES (5,17,NULL,NULL,NULL),(5,19,NULL,NULL,NULL),(6,1,NULL,NULL,NULL),(6,2,NULL,NULL,NULL),(5,42,NULL,NULL,NULL),(5,0,'3370000451297','EXPL_CB',NULL),(5,46,NULL,NULL,NULL),(8,0,'10','EXPL_CB','1'),(7,44,NULL,NULL,NULL),(7,47,NULL,NULL,NULL),(5,41,NULL,NULL,NULL),(5,32,NULL,NULL,NULL),(5,49,NULL,NULL,NULL),(7,50,NULL,NULL,NULL),(7,48,NULL,NULL,NULL),(7,51,NULL,NULL,NULL),(5,25,NULL,NULL,NULL),(8,22,NULL,NULL,NULL);
UNLOCK TABLES;
/*!40000 ALTER TABLE `caddie_content` ENABLE KEYS */;

--
-- Table structure for table `caddie_procs`
--

DROP TABLE IF EXISTS `caddie_procs`;
CREATE TABLE `caddie_procs` (
  `idproc` smallint(5) unsigned NOT NULL auto_increment,
  `type` varchar(20) NOT NULL default 'SELECT',
  `name` varchar(255) NOT NULL default '',
  `requete` blob NOT NULL,
  `comment` tinytext NOT NULL,
  `autorisations` mediumtext,
  `parameters` text,
  PRIMARY KEY  (`idproc`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `caddie_procs`
--


/*!40000 ALTER TABLE `caddie_procs` DISABLE KEYS */;
LOCK TABLES `caddie_procs` WRITE;
INSERT INTO `caddie_procs` VALUES (3,'SELECT','EXPL par section / propritaire','select expl_id as object_id, \'EXPL\' as object_type from exemplaires where expl_section in (!!section!!) and expl_owner=!!proprio!!','Slection d\'exemplaires par section par propritaire','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"section\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Section]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by section_libelle]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propritaire]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by lender_libelle</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(4,'SELECT','EXPL o cote commence par','select expl_id as object_id, \'EXPL\' as object_type from exemplaires where expl_cote like \'!!comme_cote!!%\'','Slection d\'exemplaire  partir du dbut de cote','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"comme_cote\" MANDATORY=\"no\">\n  <ALIAS><![CDATA[Dbut de la cote]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>20</SIZE>\r\n <MAXSIZE>20</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),(6,'ACTION','Retour BDP des exemplaires','update exemplaires set expl_statut=!!nouveau_statut!! where expl_id in (CADDIE(EXPL))','Permet de changer le statut des exemplaires d\'un panier','1 2 3','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"nouveau_statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[nouveau_statut]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idstatut, statut_libelle FROM docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(1,'SELECT','Notices par auteur','SELECT notice_id as object_id, \'NOTI\' as object_type FROM notices, authors, responsability WHERE author_name like \'%!!critere!!%\' AND author_id=responsability_author AND notice_id=responsability_notice\r\n','Slection des notices dont le nom de l\'auteur contient certaines lettres','1 2 3','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"critere\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Caractres contenus dans le nom]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>25</SIZE>\r\n <MAXSIZE>25</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(2,'SELECT','Notices en doublons','create TEMPORARY TABLE tmp SELECT tit1 FROM notices GROUP BY tit1 HAVING count(*)>1\r\nSELECT notice_id as object_id, \'NOTI\' as object_type FROM notices, tmp wHERE notices.tit1=tmp.tit1','Slection des notices en doublons sur le premier titre','1 2 3',NULL),(7,'SELECT','Jamais prts','SELECT expl_id as object_id, \'EXPL\' as object_type, concat(\"LIVRE \",tit1) as Titre FROM notices join exemplaires on expl_notice=notice_id LEFT JOIN pret_archive ON arc_expl_notice = notice_id where arc_expl_id IS NULL AND expl_id IS NOT NULL UNION SELECT expl_id as object_id, \'EXPL\' as object_type, concat(\"PERIO \",tit1, \" Numro : \",bulletin_numero) as Titre FROM (bulletins INNER JOIN notices ON bulletins.bulletin_notice = notices.notice_id) INNER JOIN exemplaires on expl_bulletin=bulletin_id LEFT JOIN pret_archive ON expl_id = arc_expl_id WHERE pret_archive.arc_id Is Null','Ajoute dans un panier les exemplaires jamais prts','1 2',NULL),(8,'SELECT','Slection d\'exemplaires par statut','select expl_id as object_id, \'EXPL\' as object_type from exemplaires where expl_statut in (!!statut!!)','','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[statut]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(9,'SELECT','Slection d\'exemplaires par localisation, section, statut, propritaire','select expl_id as object_id, \'EXPL\' as object_type from exemplaires where expl_section in (!!section!!) and expl_location in (!!location!!) and expl_statut in (!!statut!!) and expl_owner=!!proprio!!  ','','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"section\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Section]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"location\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localisation]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Statut]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propritaire]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>');
UNLOCK TABLES;
/*!40000 ALTER TABLE `caddie_procs` ENABLE KEYS */;

--
-- Table structure for table `categories`
--

DROP TABLE IF EXISTS `categories`;
CREATE TABLE `categories` (
  `num_noeud` int(9) unsigned NOT NULL default '0',
  `langue` varchar(5) NOT NULL default 'fr_FR',
  `libelle_categorie` text NOT NULL,
  `note_application` text NOT NULL,
  `comment_public` text NOT NULL,
  `comment_voir` text NOT NULL,
  `index_categorie` text NOT NULL,
  PRIMARY KEY  (`num_noeud`,`langue`),
  KEY `categ_langue` (`langue`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `categories`
--


/*!40000 ALTER TABLE `categories` DISABLE KEYS */;
LOCK TABLES `categories` WRITE;
INSERT INTO `categories` VALUES (2539,'la_LA','ປ່າໄມ້','ປ່າໄມ້','','','  '),(2539,'fr_FR','ປ່າໄມ້','ປ່າໄມ້','','','  '),(2538,'la_LA','ພູມສາດ ຕ່າງປະເທດ','ພູມສາດ ຕ່າງປະເທດ','','','  '),(2538,'fr_FR','ພູມສາດ ຕ່າງປະເທດ','ພູມສາດ ຕ່າງປະເທດ','','','  '),(2537,'la_LA','ພູມສາດ ລາວ','ພູມສາດ ລາວ','','','  '),(2537,'fr_FR','ພູມສາດ ລາວ','ພູມສາດ ລາວ','','','  '),(2536,'la_LA','ພູມສາດ','ພູມສາດ','','','  '),(2536,'fr_FR','ພູມສາດ','ພູມສາດ','','','  '),(2535,'la_LA','ປະຫວັດສາດ ຕ່າງປະເທດ','ປະຫວັດສາດ ຕ່າງປະເທດ','','','  '),(2535,'fr_FR','ປະຫວັດສາດ ຕ່າງປະເທດ','ປະຫວັດສາດ ຕ່າງປະເທດ','','','  '),(2534,'la_LA','ປະຫວັດສາດ ລາວ','ປະຫວັດສາດ ລາວ','','','  '),(2534,'fr_FR','ປະຫວັດສາດ ລາວ','ປະຫວັດສາດ ລາວ','','','  '),(2533,'la_LA','ປະຫວັດສາດ','ປະຫວັດສາດ','','','  '),(2533,'fr_FR','ປະຫວັດສາດ','ປະຫວັດສາດ','','','  '),(2532,'la_LA','ດ້ານຄອມພີວເຕີ້','ດ້ານຄອມພີວເຕີ້','','','  '),(2532,'fr_FR','ດ້ານຄອມພີວເຕີ້','ດ້ານຄອມພີວເຕີ້','','','  '),(2531,'la_LA','ດ້ານການແພດ','ດ້ານການແພດ','','','  '),(2531,'fr_FR','ດ້ານການແພດ','ດ້ານການແພດ','','','  '),(2520,'fr_FR','ວັນນະຄະດີ','ວັນນະຄະດີ','','','  '),(2520,'la_LA','ວັນນະຄະດີ','','','','  '),(2521,'fr_FR','ວິທະຍາສາດ','ວິທະຍາສາດ','','','  '),(2521,'la_LA','ວິທະຍາສາດ','','','','  '),(2522,'fr_FR','ທຳມະຊາດ','ທຳມະຊາດ','','','  '),(2522,'la_LA','ທຳມະຊາດ','','','','  '),(2523,'fr_FR','ແຮ່ທາດຕ່າງໆ','','','','  '),(2523,'la_LA','ແຮ່ທາດຕ່າງໆ','','','','  '),(2524,'fr_FR','ວັນນະຄະດີລາວ','ວັນນະຄະດີລາວ','','','  '),(2524,'la_LA','ວັນນະຄະດີລາວ','','','','  '),(2525,'fr_FR','ວັນນະຄະດີຕ່າງປະເທດ','ວັນນະຄະດີຕ່າງປະເທດ','','','  '),(2525,'la_LA','ວັນນະຄະດີຕ່າງປະເທດ','','','','  '),(2526,'fr_FR','ກົດໜາຍ','ກົດໜາຍ','','','  '),(2526,'la_LA','ກົດໜາຍ','','','','  '),(2527,'fr_FR','ກົດໜາຍ ອາຍາ','ກົດໜາຍ ອາຍາ','','','  '),(2527,'la_LA','ກົດໜາຍ ອາຍາ','','','','  '),(2528,'fr_FR','ກົດໜາຍ ແພ່ງ','ກົດໜາຍ ແພ່ງ','','','  '),(2528,'la_LA','ກົດໜາຍ ແພ່ງ','ກົດໜາຍ ແພ່ງ','','','  '),(2529,'fr_FR','ກົດໜາຍ ລາວ','ກົດໜາຍ ລາວ','','','  '),(2529,'la_LA','ກົດໜາຍ ລາວ','','','','  '),(2530,'fr_FR','ກົດໜາຍ ຕ່າງປະເທດ','ກົດໜາຍ ຕ່າງປະເທດ','','','  '),(2530,'la_LA','ກົດໜາຍ ຕ່າງປະເທດ','ກົດໜາຍ ຕ່າງປະເທດ','','','  ');
UNLOCK TABLES;
/*!40000 ALTER TABLE `categories` ENABLE KEYS */;

--
-- Table structure for table `classements`
--

DROP TABLE IF EXISTS `classements`;
CREATE TABLE `classements` (
  `id_classement` int(8) unsigned NOT NULL auto_increment,
  `type_classement` char(3) NOT NULL default 'BAN',
  `nom_classement` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_classement`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `classements`
--


/*!40000 ALTER TABLE `classements` DISABLE KEYS */;
LOCK TABLES `classements` WRITE;
INSERT INTO `classements` VALUES (1,'','_NON CLASSE_'),(2,'BAN','ທົດລອງ'),(3,'EQU','ເຄມີ'),(4,'EQU','ຟີຊິກ');
UNLOCK TABLES;
/*!40000 ALTER TABLE `classements` ENABLE KEYS */;

--
-- Table structure for table `collections`
--

DROP TABLE IF EXISTS `collections`;
CREATE TABLE `collections` (
  `collection_id` mediumint(8) unsigned NOT NULL auto_increment,
  `collection_name` varchar(255) NOT NULL default '',
  `collection_parent` mediumint(8) unsigned NOT NULL default '0',
  `collection_issn` varchar(12) NOT NULL default '',
  `index_coll` text,
  PRIMARY KEY  (`collection_id`),
  KEY `collection_name` (`collection_name`),
  KEY `collection_parent` (`collection_parent`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `collections`
--


/*!40000 ALTER TABLE `collections` DISABLE KEYS */;
LOCK TABLES `collections` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `collections` ENABLE KEYS */;

--
-- Table structure for table `comptes`
--

DROP TABLE IF EXISTS `comptes`;
CREATE TABLE `comptes` (
  `id_compte` int(8) unsigned NOT NULL auto_increment,
  `libelle` varchar(255) NOT NULL default '',
  `type_compte_id` int(10) unsigned NOT NULL default '0',
  `solde` decimal(16,2) default '0.00',
  `prepay_mnt` decimal(16,2) NOT NULL default '0.00',
  `proprio_id` int(10) unsigned NOT NULL default '0',
  `droits` text NOT NULL,
  PRIMARY KEY  (`id_compte`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `comptes`
--


/*!40000 ALTER TABLE `comptes` DISABLE KEYS */;
LOCK TABLES `comptes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `comptes` ENABLE KEYS */;

--
-- Table structure for table `coordonnees`
--

DROP TABLE IF EXISTS `coordonnees`;
CREATE TABLE `coordonnees` (
  `id_contact` int(8) unsigned NOT NULL auto_increment,
  `type_coord` int(1) unsigned NOT NULL default '0',
  `num_entite` int(5) unsigned NOT NULL default '0',
  `libelle` varchar(255) NOT NULL default '',
  `contact` varchar(255) NOT NULL default '',
  `adr1` varchar(255) NOT NULL default '',
  `adr2` varchar(255) NOT NULL default '',
  `cp` varchar(15) NOT NULL default '',
  `ville` varchar(100) NOT NULL default '',
  `etat` varchar(100) NOT NULL default '',
  `pays` varchar(100) NOT NULL default '',
  `tel1` varchar(100) NOT NULL default '',
  `tel2` varchar(100) NOT NULL default '',
  `fax` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `commentaires` text,
  PRIMARY KEY  (`id_contact`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `coordonnees`
--


/*!40000 ALTER TABLE `coordonnees` DISABLE KEYS */;
LOCK TABLES `coordonnees` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `coordonnees` ENABLE KEYS */;

--
-- Table structure for table `docs_codestat`
--

DROP TABLE IF EXISTS `docs_codestat`;
CREATE TABLE `docs_codestat` (
  `idcode` smallint(5) unsigned NOT NULL auto_increment,
  `codestat_libelle` varchar(255) default NULL,
  `statisdoc_codage_import` char(2) NOT NULL default '',
  `statisdoc_owner` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`idcode`),
  KEY `statisdoc_owner` (`statisdoc_owner`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `docs_codestat`
--


/*!40000 ALTER TABLE `docs_codestat` DISABLE KEYS */;
LOCK TABLES `docs_codestat` WRITE;
INSERT INTO `docs_codestat` VALUES (10,'ບໍ່ເຈາະຈົງ','u',0),(11,'ໄວໜຸ່ມ','j',0),(12,'ຜູ້ໃຫ່ຽ','a',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `docs_codestat` ENABLE KEYS */;

--
-- Table structure for table `docs_location`
--

DROP TABLE IF EXISTS `docs_location`;
CREATE TABLE `docs_location` (
  `idlocation` smallint(5) unsigned NOT NULL auto_increment,
  `location_libelle` varchar(255) default NULL,
  `locdoc_codage_import` varchar(255) NOT NULL default '',
  `locdoc_owner` mediumint(8) unsigned NOT NULL default '0',
  `location_pic` varchar(255) NOT NULL default '',
  `location_visible_opac` tinyint(1) NOT NULL default '1',
  `name` varchar(255) NOT NULL default '',
  `adr1` varchar(255) NOT NULL default '',
  `adr2` varchar(255) NOT NULL default '',
  `cp` varchar(50) NOT NULL default '',
  `town` varchar(100) NOT NULL default '',
  `state` varchar(100) NOT NULL default '',
  `country` varchar(100) NOT NULL default '',
  `phone` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `website` varchar(100) NOT NULL default '',
  `logo` varchar(255) NOT NULL default '',
  `logosmall` varchar(255) NOT NULL default '',
  `commentaire` text NOT NULL,
  PRIMARY KEY  (`idlocation`),
  KEY `locdoc_owner` (`locdoc_owner`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `docs_location`
--


/*!40000 ALTER TABLE `docs_location` DISABLE KEYS */;
LOCK TABLES `docs_location` WRITE;
INSERT INTO `docs_location` VALUES (1,'ຫໍສະຫມຸດເເຫ່ງຊາດ','',2,'images/site/bib_princ.jpg',1,'ຫໍສະຫມຸດເເຫ່ງຊາດ','ຖະໜົນເສດຖາທິລາດ','ບ້ານຊຽງຍືນ','ຕູ້ ປ.ນ 122','ວຽງຈັນ','','ສ.ປ.ປ.ລາວ','+85621 251 405','bnl@laosky.com','http://www.bnlaos.org/','logo_default.jpg','logo_default_small.jpg',''),(2,'ສະຫງວນໄວ້','',2,'',0,'ຫໍສະຫມຸດທົດລອງຂອງ​PMB','','','','','','','','pmb@sigb.net','http://www.sigb.net','logo_default.jpg','logo_default_small.jpg',''),(7,'ຫໍສະຫມຸດເຄື່ອນທີ່','',2,'images/site/bibliobus.jpg',1,'ຫໍສະຫມຸດທົດລອງຂອງ PMB','','','72500','','','','','pmb@sigb.net','http://www.sigb.net','logo_default.jpg','logo_default_small.jpg','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `docs_location` ENABLE KEYS */;

--
-- Table structure for table `docs_section`
--

DROP TABLE IF EXISTS `docs_section`;
CREATE TABLE `docs_section` (
  `idsection` smallint(5) unsigned NOT NULL auto_increment,
  `section_libelle` varchar(255) default NULL,
  `sdoc_codage_import` varchar(255) NOT NULL default '',
  `sdoc_owner` mediumint(8) unsigned NOT NULL default '0',
  `section_pic` varchar(255) NOT NULL default '',
  `section_visible_opac` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`idsection`),
  KEY `sdoc_owner` (`sdoc_owner`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `docs_section`
--


/*!40000 ALTER TABLE `docs_section` DISABLE KEYS */;
LOCK TABLES `docs_section` WRITE;
INSERT INTO `docs_section` VALUES (10,'ເອກະສານ','',2,'images/site/documentaire.jpg',1),(11,'ເອກະສານສຳລັບເດັກນ້ອຍ','',2,'images/site/documentaire.jpg',1),(12,'ນະວະນິຍາຍເດັກ','',2,'images/site/enfants.jpg',1),(13,'ນະວະນິຍາຍ','',2,'images/site/sec3.jpg',1),(16,'ປະຫວັດສາດ','',2,'images/site/sec1.jpg',1),(17,'ນະວະນິຍາຍກ່ຽວກັບຕຳຫຼວດ','',2,'images/site/enfants.jpg',1),(18,'ນະວະນິຍາຍຕ່າງປະເທດ','',2,'images/site/histoire.jpg',1),(20,'ເອກະສານສຳລັບໄວໝູ່ມ','',2,'images/site/sec3.jpg',1),(21,'ປື້ມຮູບເດັກນ້ອຍ','',2,'images/site/sec1.jpg',1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `docs_section` ENABLE KEYS */;

--
-- Table structure for table `docs_statut`
--

DROP TABLE IF EXISTS `docs_statut`;
CREATE TABLE `docs_statut` (
  `idstatut` smallint(5) unsigned NOT NULL auto_increment,
  `statut_libelle` varchar(255) default NULL,
  `pret_flag` tinyint(4) NOT NULL default '1',
  `statusdoc_codage_import` char(2) NOT NULL default '',
  `statusdoc_owner` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`idstatut`),
  KEY `statusdoc_owner` (`statusdoc_owner`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `docs_statut`
--


/*!40000 ALTER TABLE `docs_statut` DISABLE KEYS */;
LOCK TABLES `docs_statut` WRITE;
INSERT INTO `docs_statut` VALUES (1,'ຢູ່ໃນສະພາບດີ',1,'',0),(2,'ກຳລັງນຳເຂົ້າ',0,'',0),(11,'ໃຊ້ການບໍ່ໄດ້',0,'',0),(12,'ສູນຫາຍ',0,'',0),(13,'ໃຫ້ອ່ານເບິ່ງຢູ່ຫໍສະໝຸດເທົ່ານັ້ນ',0,'',0),(14,'ຢູ່ໃນສາງ',0,'',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `docs_statut` ENABLE KEYS */;

--
-- Table structure for table `docs_type`
--

DROP TABLE IF EXISTS `docs_type`;
CREATE TABLE `docs_type` (
  `idtyp_doc` tinyint(3) unsigned NOT NULL auto_increment,
  `tdoc_libelle` varchar(255) default NULL,
  `duree_pret` smallint(6) NOT NULL default '31',
  `duree_resa` int(6) unsigned NOT NULL default '15',
  `tdoc_owner` mediumint(8) unsigned NOT NULL default '0',
  `tdoc_codage_import` varchar(255) NOT NULL default '',
  `tarif_pret` decimal(16,2) NOT NULL default '0.00',
  PRIMARY KEY  (`idtyp_doc`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `docs_type`
--


/*!40000 ALTER TABLE `docs_type` DISABLE KEYS */;
LOCK TABLES `docs_type` WRITE;
INSERT INTO `docs_type` VALUES (1,'ປື້ມ',14,15,2,'','0.00'),(12,'ກະແຊັດວີດີໂອ',14,15,2,'','0.00'),(13,'ຊີດີຕ່າງໆ',14,15,2,'','0.00'),(14,'ວີຊີດີ',5,15,2,'','0.00'),(15,'ງານສິນລະປະ',5,15,2,'','0.00'),(16,'ບັດ ແລະ ແຜນທີ່',31,15,2,'','0.00'),(17,'ຊີດີຣ໋ອມ',10,5,2,'','0.00'),(18,'ວາລະສານ',8,5,0,'','0.00');
UNLOCK TABLES;
/*!40000 ALTER TABLE `docs_type` ENABLE KEYS */;

--
-- Table structure for table `docsloc_section`
--

DROP TABLE IF EXISTS `docsloc_section`;
CREATE TABLE `docsloc_section` (
  `num_section` int(5) unsigned NOT NULL default '0',
  `num_location` int(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`num_section`,`num_location`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `docsloc_section`
--


/*!40000 ALTER TABLE `docsloc_section` DISABLE KEYS */;
LOCK TABLES `docsloc_section` WRITE;
INSERT INTO `docsloc_section` VALUES (10,1),(10,7),(11,1),(11,7),(12,1),(12,7),(13,1),(13,7),(16,1),(16,7),(17,1),(17,7),(18,1),(18,7),(19,1),(19,7),(20,1),(20,7),(21,1),(21,7),(23,1),(23,7),(24,1),(24,7),(25,1),(25,7),(26,1),(26,7);
UNLOCK TABLES;
/*!40000 ALTER TABLE `docsloc_section` ENABLE KEYS */;

--
-- Table structure for table `empr`
--

DROP TABLE IF EXISTS `empr`;
CREATE TABLE `empr` (
  `id_empr` smallint(6) NOT NULL auto_increment,
  `empr_cb` varchar(255) default NULL,
  `empr_nom` varchar(255) NOT NULL default '',
  `empr_prenom` varchar(255) NOT NULL default '',
  `empr_adr1` varchar(255) NOT NULL default '',
  `empr_adr2` varchar(255) NOT NULL default '',
  `empr_cp` varchar(10) NOT NULL default '',
  `empr_ville` varchar(255) NOT NULL default '',
  `empr_pays` varchar(255) NOT NULL default '',
  `empr_mail` varchar(50) NOT NULL default '',
  `empr_tel1` varchar(255) NOT NULL default '',
  `empr_tel2` varchar(255) NOT NULL default '',
  `empr_prof` varchar(255) NOT NULL default '',
  `empr_year` int(4) unsigned NOT NULL default '0',
  `empr_categ` smallint(5) unsigned NOT NULL default '0',
  `empr_codestat` smallint(5) unsigned NOT NULL default '0',
  `empr_creation` date NOT NULL default '0000-00-00',
  `empr_modif` date NOT NULL default '0000-00-00',
  `empr_sexe` tinyint(3) unsigned NOT NULL default '0',
  `empr_login` varchar(255) NOT NULL default '',
  `empr_password` varchar(10) NOT NULL default '',
  `empr_date_adhesion` date default NULL,
  `empr_date_expiration` date default NULL,
  `empr_msg` tinytext,
  `empr_lang` varchar(10) NOT NULL default 'fr_FR',
  `empr_ldap` tinyint(1) unsigned default '0',
  `type_abt` int(1) NOT NULL default '0',
  `last_loan_date` date default NULL,
  `empr_location` int(6) unsigned NOT NULL default '1',
  `date_fin_blocage` date default NULL,
  PRIMARY KEY  (`id_empr`),
  UNIQUE KEY `empr_cb` (`empr_cb`),
  KEY `empr_nom` (`empr_nom`),
  KEY `empr_date_adhesion` (`empr_date_adhesion`),
  KEY `empr_date_expiration` (`empr_date_expiration`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `empr`
--


/*!40000 ALTER TABLE `empr` DISABLE KEYS */;
LOCK TABLES `empr` WRITE;
INSERT INTO `empr` VALUES (1,'1','ວິຊ່ຽນ','ແກ້ວມະນີ','ບ້ານນາແຮ່ 04/49','ເມືອງສີໂຄດ ແຂວງກຳແພງນະຄອນ','856','ສີໂຄດ','ລາວ','keomany2002@hotmailo.com','020 7 74 12 35','','ນັກຂຽນໂປແກມ',13081981,10,7,'2006-10-13','2006-10-13',1,'       1','13/08/1981','2006-10-13','2007-10-13','ເປັນນັກອ່ານປະຈຳ ທີ່ເຂົ້າມາຫໍສະໝຸດ ຢ່າງໜ້ອຍ 1 ຄັ້ງ/ອາທິດ','la_LA',0,0,'2006-10-16',1,NULL),(3,'3','ວິໄລທອງ','ວົງທະສອນ','ບ້ານທາດຂາວ','ທະໝົນທ່າເດື່ອ ເມືອງສີສະຕະນາດ ກຳແພງນະຄອນ','856','ສີສະຕະນາດ','','vthasone@hotmail.com','020 59 19 571','','ນັກຂຽນໂປແກມ',2101978,10,7,'2006-10-13','2006-10-13',1,'        12','02101978','2006-06-13','2007-06-13','ຊະມາຊິກ ທີ່ມາເປັນປະຈຳ','la_LA',0,0,'2006-10-14',1,NULL),(2,'2','ຈິນນະລາດ','ຄຳສິນ','ບ້ານດົງນາໂຊກ','ເມືອງສີໂຄດ ແຂວງກຳແພງນະຄອນ','856','ສີໂຄດ','ລາວ','touy_chinnalath@yahoo.com','020 7 60 78 07','','ນັກຂຽນໂປແກມ',25111981,10,7,'2006-10-13','2006-10-13',1,'         1','25 11 1981','2005-07-13','2007-07-13','ຊະມາຊິກເກົ່າ','la_LA',0,0,'2006-10-13',1,NULL),(4,'4','ໄຊຍະສຸກ','ທາລົມ','ບ້ານອາກາດ','ທະໝົນຫຼວງພະບາງ ເມືອງສີໂຄດ ກຳແພງນະຄອນ','856','ສີໂຄດ','ລາວ','','020 5123456','','ອອກແບບ',2071983,10,7,'2006-10-13','2006-10-13',2,'        1','02071983','2005-11-10','2006-11-10','ຊະມາຊິກປະຈຳ','fr_FR',0,0,NULL,1,NULL),(5,'5','ຂັນທະວີວັນ','ສົນໄລ','ບ້ານດອນກອຍ','ກຳແພງນະຄອນ','002','ນາຊາຍທອງ','ລາວ','ksonlay@yahoo.com','020 78 73 573','','ນັກຂຽນໂປແກມ',5031980,10,4,'2006-10-13','2006-10-13',1,'           1','05031980','2005-10-01','2007-10-01','ຊະມາຊິກປະຈຳ','fr_FR',0,0,'2006-10-13',1,NULL),(6,'6','ແສງຈັນດາວົງ','ໂພໄຊສີ','ບ້ານໜອງດ້ວງ','ເມືອງສີໂຄດ ແຂວງກຳແພງນະຄອນ','856','ສີໂຄດ','ລາວ','abrun@hotmail.com','020 78 33 876','','ນັກຂຽນໂປແກມ',7121981,10,4,'2006-10-13','2006-10-13',1,'','07121981','2006-10-13','2007-10-13','ຊະມາຊິກປະຈຳ','la_LA',0,0,'2006-10-13',1,NULL),(7,'11586-11592','ກິດຕິພັນ','ຄຳຫຼ້າ','ບ້ານທົ່ງປົ່ງ','ເມືອງສີໂຄດ ແຂວງກຳແພງນະຄອນ','856','ສີໂຄດ','ລາວ','ktpkhamla@wfp.org','020 55 21 293','','ນັກຂຽນໂປແກມ',19061980,10,7,'2006-10-13','2006-11-08',1,'         12','19061980','2005-12-07','2006-12-07','ຊະມາຊິກປະຈຳ','la_LA',0,0,'2006-10-13',1,NULL),(8,'8','ຈັນທະລັງສີ','ສຸລິວົງ','ບ້ານຊະພັງໜໍ້','ເມືອງໄຊທານີ  ກຳແພງນະຄອນ','001','ໄຊທານີ','ລາວ','soulivongch@ifmt.org','020 57 06 549','','ຜູ້ຄູມເຄືອຂ່າຍ ຄອມພີວເຕີ້',26031978,10,7,'2006-10-13','2006-10-13',1,'           12','26031978','2006-10-13','2007-10-13','ນັກອ່ານປະຳ','la_LA',0,0,NULL,1,NULL),(9,'9','ພົມມະວົງ','ຈັນທະລາ','ບ້ານໜອງແຕ່ງ','ເມືອງສີໂຄດ ແຂວງກຳແພງນະຄອນ','856','ສີໂຄດ','ລາວ','','020 71 32  567','','ນັກຂ່າວ',5071981,10,4,'2006-10-13','2006-10-13',1,'         123','05071981','2006-10-13','2007-10-13','','la_LA',0,0,'2006-11-08',1,NULL),(10,'10','ປານເພັດ','ທອງອິນ','ບ້ານສາຍລົມ','ເມືອງໄຊທານີ  ກຳແພງນະຄອນ','001','ໄຊທານີ','','','020 77 84 612','','ນັກສິກສາ',15081987,8,4,'2006-10-13','2006-10-13',2,'        123','15081987','2006-10-13','2007-10-13','ນັກສິກສາມະຫາວິທະຍາໄລແຫ່ງຊາດ','la_LA',0,0,'2006-11-08',1,NULL),(11,'11','ທອງດຳ','ດຳ','ບ້ານຊະພັງໜໍ້','','003','ສັງທອງ','','','','','ພະນັກງານ',13071985,12,4,'2006-10-16','2006-10-16',1,'      1','13071985','2006-10-02','2007-10-02','','fr_FR',0,0,NULL,1,NULL),(12,'12','ທອງແດງ','ມະນີວັນ','ບ້ານ ວັດໄຕນ້ອຍ','ກຳແພງນະຄອນ','235','ສີໂຄດ','ລາວ','','020 7 829859','','ພະນັກງານ',19121975,10,7,'2006-10-23','2006-10-23',1,'       12','19121975','2006-08-08','2007-08-08','','la_LA',0,0,NULL,1,NULL);
UNLOCK TABLES;
/*!40000 ALTER TABLE `empr` ENABLE KEYS */;

--
-- Table structure for table `empr_categ`
--

DROP TABLE IF EXISTS `empr_categ`;
CREATE TABLE `empr_categ` (
  `id_categ_empr` smallint(5) unsigned NOT NULL auto_increment,
  `libelle` varchar(255) NOT NULL default '',
  `duree_adhesion` int(10) unsigned default '365',
  `tarif_abt` decimal(16,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id_categ_empr`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `empr_categ`
--


/*!40000 ALTER TABLE `empr_categ` DISABLE KEYS */;
LOCK TABLES `empr_categ` WRITE;
INSERT INTO `empr_categ` VALUES (8,'ຜູ້ໃຫ່ຍ',365,'0.00'),(9,'ເດັກນ້ອຍ',365,'0.00'),(10,'ພະນັກງານ',365,'0.00'),(11,'ພະນັກງານບຳນານ',365,'0.00'),(12,'ຄົນຫວ່າງງານ',365,'0.00');
UNLOCK TABLES;
/*!40000 ALTER TABLE `empr_categ` ENABLE KEYS */;

--
-- Table structure for table `empr_codestat`
--

DROP TABLE IF EXISTS `empr_codestat`;
CREATE TABLE `empr_codestat` (
  `idcode` smallint(5) unsigned NOT NULL auto_increment,
  `libelle` varchar(50) NOT NULL default 'DEFAULT',
  PRIMARY KEY  (`idcode`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `empr_codestat`
--


/*!40000 ALTER TABLE `empr_codestat` DISABLE KEYS */;
LOCK TABLES `empr_codestat` WRITE;
INSERT INTO `empr_codestat` VALUES (4,'ພາກວິຊາ'),(6,'ອາຊີ'),(7,'ລາວ');
UNLOCK TABLES;
/*!40000 ALTER TABLE `empr_codestat` ENABLE KEYS */;

--
-- Table structure for table `empr_custom`
--

DROP TABLE IF EXISTS `empr_custom`;
CREATE TABLE `empr_custom` (
  `idchamp` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `titre` varchar(255) default NULL,
  `type` varchar(10) NOT NULL default 'text',
  `datatype` varchar(10) NOT NULL default '',
  `options` text,
  `multiple` int(11) NOT NULL default '0',
  `obligatoire` int(11) NOT NULL default '0',
  `ordre` int(11) default NULL,
  PRIMARY KEY  (`idchamp`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `empr_custom`
--


/*!40000 ALTER TABLE `empr_custom` DISABLE KEYS */;
LOCK TABLES `empr_custom` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `empr_custom` ENABLE KEYS */;

--
-- Table structure for table `empr_custom_lists`
--

DROP TABLE IF EXISTS `empr_custom_lists`;
CREATE TABLE `empr_custom_lists` (
  `empr_custom_champ` int(10) unsigned NOT NULL default '0',
  `empr_custom_list_value` varchar(255) default NULL,
  `empr_custom_list_lib` varchar(255) default NULL,
  `ordre` int(11) default NULL,
  KEY `empr_custom_champ` (`empr_custom_champ`),
  KEY `champ_list_value` (`empr_custom_champ`,`empr_custom_list_value`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `empr_custom_lists`
--


/*!40000 ALTER TABLE `empr_custom_lists` DISABLE KEYS */;
LOCK TABLES `empr_custom_lists` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `empr_custom_lists` ENABLE KEYS */;

--
-- Table structure for table `empr_custom_values`
--

DROP TABLE IF EXISTS `empr_custom_values`;
CREATE TABLE `empr_custom_values` (
  `empr_custom_champ` int(10) unsigned NOT NULL default '0',
  `empr_custom_origine` int(10) unsigned NOT NULL default '0',
  `empr_custom_small_text` varchar(255) default NULL,
  `empr_custom_text` text,
  `empr_custom_integer` int(11) default NULL,
  `empr_custom_date` date default NULL,
  `empr_custom_float` float default NULL,
  KEY `empr_custom_champ` (`empr_custom_champ`),
  KEY `empr_custom_origine` (`empr_custom_origine`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `empr_custom_values`
--


/*!40000 ALTER TABLE `empr_custom_values` DISABLE KEYS */;
LOCK TABLES `empr_custom_values` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `empr_custom_values` ENABLE KEYS */;

--
-- Table structure for table `empr_groupe`
--

DROP TABLE IF EXISTS `empr_groupe`;
CREATE TABLE `empr_groupe` (
  `empr_id` int(6) unsigned NOT NULL default '0',
  `groupe_id` int(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`empr_id`,`groupe_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `empr_groupe`
--


/*!40000 ALTER TABLE `empr_groupe` DISABLE KEYS */;
LOCK TABLES `empr_groupe` WRITE;
INSERT INTO `empr_groupe` VALUES (1,1),(1,2),(2,1),(2,2),(3,1),(4,1),(5,1),(10,0),(11,0),(12,0),(12,3);
UNLOCK TABLES;
/*!40000 ALTER TABLE `empr_groupe` ENABLE KEYS */;

--
-- Table structure for table `entites`
--

DROP TABLE IF EXISTS `entites`;
CREATE TABLE `entites` (
  `id_entite` int(5) unsigned NOT NULL auto_increment,
  `type_entite` int(3) unsigned NOT NULL default '0',
  `num_bibli` int(5) unsigned NOT NULL default '0',
  `raison_sociale` varchar(255) NOT NULL default '',
  `commentaires` text,
  `siret` varchar(25) NOT NULL default '',
  `naf` varchar(5) NOT NULL default '',
  `rcs` varchar(25) NOT NULL default '',
  `tva` varchar(25) NOT NULL default '',
  `num_cp_client` varchar(25) NOT NULL default '',
  `num_cp_compta` varchar(255) NOT NULL default '',
  `site_web` varchar(100) NOT NULL default '',
  `logo` varchar(255) NOT NULL default '',
  `autorisations` mediumtext NOT NULL,
  `num_frais` int(8) unsigned NOT NULL default '0',
  `num_paiement` int(8) unsigned NOT NULL default '0',
  `index_entite` text NOT NULL,
  PRIMARY KEY  (`id_entite`),
  KEY `raison_sociale` (`raison_sociale`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `entites`
--


/*!40000 ALTER TABLE `entites` DISABLE KEYS */;
LOCK TABLES `entites` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `entites` ENABLE KEYS */;

--
-- Table structure for table `equations`
--

DROP TABLE IF EXISTS `equations`;
CREATE TABLE `equations` (
  `id_equation` int(9) unsigned NOT NULL auto_increment,
  `num_classement` int(8) unsigned NOT NULL default '1',
  `nom_equation` varchar(255) NOT NULL default '',
  `comment_equation` varchar(255) NOT NULL default '',
  `requete` blob NOT NULL,
  `proprio_equation` int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_equation`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `equations`
--


/*!40000 ALTER TABLE `equations` DISABLE KEYS */;
LOCK TABLES `equations` WRITE;
INSERT INTO `equations` VALUES (1,1,'keomany','ທົດສອບເບິ່ງ','a:2:{s:6:\"SEARCH\";a:1:{i:0;s:3:\"f_1\";}i:0;a:5:{s:6:\"SEARCH\";s:3:\"f_1\";s:2:\"OP\";s:9:\"STARTWITH\";s:5:\"FIELD\";a:1:{i:0;s:1:\"a\";}s:5:\"INTER\";N;s:8:\"FIELDVAR\";N;}}',0),(2,1,'keo','tester','a:2:{s:6:\"SEARCH\";a:1:{i:0;s:3:\"f_2\";}i:0;a:5:{s:6:\"SEARCH\";s:3:\"f_2\";s:2:\"OP\";s:9:\"STARTWITH\";s:5:\"FIELD\";a:1:{i:0;s:1:\"b\";}s:5:\"INTER\";N;s:8:\"FIELDVAR\";N;}}',0),(3,1,'ແກ້ວ','','a:2:{s:6:\"SEARCH\";a:1:{i:0;s:3:\"f_2\";}i:0;a:5:{s:6:\"SEARCH\";s:3:\"f_2\";s:2:\"OP\";s:9:\"STARTWITH\";s:5:\"FIELD\";a:1:{i:0;s:1:\"b\";}s:5:\"INTER\";N;s:8:\"FIELDVAR\";N;}}',0),(4,4,'ແມ່ນຫຍັງວະ','ກດເຫກ້່ກດ້ເຫກັພິເະຳພ້ພະາ່ຳພເະໄພ່ະິສກເກດເຫກເກດເຶຫ້','a:2:{s:6:\"SEARCH\";a:1:{i:0;s:3:\"f_3\";}i:0;a:5:{s:6:\"SEARCH\";s:3:\"f_3\";s:2:\"OP\";s:9:\"STARTWITH\";s:5:\"FIELD\";a:1:{i:0;s:1:\"a\";}s:5:\"INTER\";N;s:8:\"FIELDVAR\";N;}}',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `equations` ENABLE KEYS */;

--
-- Table structure for table `error_log`
--

DROP TABLE IF EXISTS `error_log`;
CREATE TABLE `error_log` (
  `error_date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `error_origin` varchar(255) default NULL,
  `error_text` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `error_log`
--


/*!40000 ALTER TABLE `error_log` DISABLE KEYS */;
LOCK TABLES `error_log` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `error_log` ENABLE KEYS */;

--
-- Table structure for table `etagere`
--

DROP TABLE IF EXISTS `etagere`;
CREATE TABLE `etagere` (
  `idetagere` int(8) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `comment` blob NOT NULL,
  `validite` int(1) unsigned NOT NULL default '0',
  `validite_date_deb` date NOT NULL default '0000-00-00',
  `validite_date_fin` date NOT NULL default '0000-00-00',
  `visible_accueil` int(1) unsigned NOT NULL default '1',
  `autorisations` mediumtext,
  PRIMARY KEY  (`idetagere`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `etagere`
--


/*!40000 ALTER TABLE `etagere` DISABLE KEYS */;
LOCK TABLES `etagere` WRITE;
INSERT INTO `etagere` VALUES (3,'Loire','Exposition virtuelle sur la Loire',1,'0000-00-00','0000-00-00',1,'1 4 3 2');
UNLOCK TABLES;
/*!40000 ALTER TABLE `etagere` ENABLE KEYS */;

--
-- Table structure for table `etagere_caddie`
--

DROP TABLE IF EXISTS `etagere_caddie`;
CREATE TABLE `etagere_caddie` (
  `etagere_id` int(8) unsigned NOT NULL default '0',
  `caddie_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`etagere_id`,`caddie_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `etagere_caddie`
--


/*!40000 ALTER TABLE `etagere_caddie` DISABLE KEYS */;
LOCK TABLES `etagere_caddie` WRITE;
INSERT INTO `etagere_caddie` VALUES (3,5);
UNLOCK TABLES;
/*!40000 ALTER TABLE `etagere_caddie` ENABLE KEYS */;

--
-- Table structure for table `exemplaires`
--

DROP TABLE IF EXISTS `exemplaires`;
CREATE TABLE `exemplaires` (
  `expl_id` mediumint(8) unsigned NOT NULL auto_increment,
  `expl_cb` varchar(50) NOT NULL default '',
  `expl_notice` mediumint(8) unsigned NOT NULL default '0',
  `expl_bulletin` int(8) unsigned NOT NULL default '0',
  `expl_typdoc` tinyint(3) unsigned NOT NULL default '0',
  `expl_cote` varchar(50) NOT NULL default '',
  `expl_section` smallint(5) unsigned NOT NULL default '0',
  `expl_statut` smallint(5) unsigned NOT NULL default '0',
  `expl_location` smallint(5) unsigned NOT NULL default '0',
  `expl_codestat` smallint(5) unsigned NOT NULL default '0',
  `expl_date_depot` date NOT NULL default '0000-00-00',
  `expl_date_retour` date NOT NULL default '0000-00-00',
  `expl_note` tinytext NOT NULL,
  `expl_prix` varchar(255) NOT NULL default '',
  `expl_owner` mediumint(8) unsigned NOT NULL default '0',
  `expl_lastempr` int(10) unsigned NOT NULL default '0',
  `last_loan_date` date default NULL,
  `create_date` datetime NOT NULL default '2005-01-01 00:00:00',
  `update_date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`expl_id`),
  UNIQUE KEY `expl_cb` (`expl_cb`),
  KEY `expl_typdoc` (`expl_typdoc`),
  KEY `expl_cote` (`expl_cote`),
  KEY `expl_notice` (`expl_notice`),
  KEY `expl_codestat` (`expl_codestat`),
  KEY `expl_owner` (`expl_owner`),
  KEY `expl_bulletin` (`expl_bulletin`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `exemplaires`
--


/*!40000 ALTER TABLE `exemplaires` DISABLE KEYS */;
LOCK TABLES `exemplaires` WRITE;
INSERT INTO `exemplaires` VALUES (1,'000001',1,0,1,'050',10,1,1,12,'0000-00-00','0000-00-00','','7000 ກີບ',2,0,'2006-10-13','2006-10-13 15:16:43','2006-10-13 15:19:51'),(2,'000002',1,0,1,'050',10,1,1,12,'0000-00-00','0000-00-00','','7000 ກີບ',2,7,'2006-10-13','2006-10-13 15:17:14','2006-10-13 15:21:35'),(3,'000003',1,0,1,'050',10,1,1,12,'0000-00-00','0000-00-00','','7000 ກີບ',2,0,NULL,'2006-10-13 15:18:21','2006-10-13 15:18:21'),(4,'000004',1,0,1,'050',10,1,1,10,'0000-00-00','0000-00-00','','',2,0,NULL,'2006-10-13 15:18:50','2006-10-13 15:18:50'),(5,'000005',1,0,1,'050',10,1,1,12,'0000-00-00','0000-00-00','','',2,0,NULL,'2006-10-13 15:19:11','2006-10-13 15:19:11'),(6,'000011',2,0,1,'001',10,1,1,10,'0000-00-00','0000-00-00','','9600ກີບ',2,0,'2006-10-13','2006-10-13 15:29:24','2006-10-13 15:35:07'),(7,'000012',2,0,1,'001',10,1,1,10,'0000-00-00','0000-00-00','','9600ກີບ',2,0,NULL,'2006-10-13 15:30:02','2006-10-13 15:30:02'),(8,'000021',3,0,1,'000',10,1,1,10,'0000-00-00','0000-00-00','','96000ກີບ',2,0,'2006-10-13','2006-10-13 15:33:14','2006-10-13 15:35:23'),(9,'000022',3,0,1,'000',10,1,1,10,'0000-00-00','0000-00-00','','96000ກີບ',2,0,'2006-10-13','2006-10-13 15:33:52','2006-10-13 15:38:51'),(10,'000023',3,0,1,'000',10,1,1,10,'0000-00-00','0000-00-00','','96000ກີບ',2,0,NULL,'2006-10-13 15:34:28','2006-10-13 15:34:28'),(11,'000031',4,0,1,'500',10,1,1,10,'0000-00-00','0000-00-00','','82000 ກີບ',2,0,NULL,'2006-10-13 15:47:56','2006-10-13 15:48:56'),(12,'000041',5,0,1,'800',10,1,1,10,'0000-00-00','0000-00-00','','170000ກີບ',2,0,NULL,'2006-10-13 15:52:20','2006-10-13 15:52:20'),(13,'000051',6,0,1,'002',10,1,1,10,'0000-00-00','0000-00-00','','13000ກີບ',2,0,NULL,'2006-10-13 15:54:42','2006-10-13 15:54:42'),(14,'000061',7,0,1,'110',10,1,1,10,'0000-00-00','0000-00-00','','7500 ກີບ',2,0,NULL,'2006-10-13 15:58:02','2006-10-13 15:58:02'),(15,'000071',8,0,1,'009',10,1,1,10,'0000-00-00','0000-00-00','','5000 ກີບ',2,3,'2006-10-14','2006-10-13 16:00:17','2006-10-14 08:18:56'),(16,'000081',9,0,1,'789',10,1,1,10,'0000-00-00','0000-00-00','','200000 ກີບ',2,0,NULL,'2006-10-13 16:02:18','2006-10-13 16:02:18'),(17,'000080',10,0,1,'808',10,1,1,10,'0000-00-00','0000-00-00','','20000ກີບ',2,0,NULL,'2006-10-13 16:06:42','2006-10-13 16:06:42'),(18,'000091',11,0,1,'870',10,1,1,10,'0000-00-00','0000-00-00','','700000ກີບ',2,0,NULL,'2006-10-13 16:10:26','2006-10-13 16:10:26'),(19,'0001001',12,0,1,'890',10,1,1,10,'0000-00-00','0000-00-00','','5800ກີບ',2,0,NULL,'2006-10-13 16:13:07','2006-10-13 16:13:07'),(20,'0001002',13,0,1,'120',10,1,1,10,'0000-00-00','0000-00-00','','8000ກີບ',2,0,NULL,'2006-10-13 16:14:47','2006-10-13 16:14:47'),(21,'00001003',14,0,1,'450',10,1,1,10,'0000-00-00','0000-00-00','','78000ກີບ',2,0,NULL,'2006-10-13 16:18:14','2006-10-13 16:18:14'),(22,'0001003',15,0,1,'560',10,1,1,10,'0000-00-00','0000-00-00','','34000ກີບ',2,0,NULL,'2006-10-13 16:20:37','2006-10-13 16:20:37'),(23,'0001004',16,0,1,'870',10,1,1,10,'0000-00-00','0000-00-00','','12500ກີບ',2,0,NULL,'2006-10-13 16:23:11','2006-10-13 16:23:11'),(24,'0001006',17,0,1,'730',10,1,1,10,'0000-00-00','0000-00-00','','73000ກີບ',2,0,NULL,'2006-10-13 16:25:42','2006-10-13 16:25:42'),(25,'000123',0,2,1,'500',16,1,7,10,'0000-00-00','0000-00-00','','10000ກີບ',2,0,NULL,'2006-10-13 16:43:08','2006-10-13 16:43:08'),(26,'000124',0,3,1,'500',10,1,7,10,'0000-00-00','0000-00-00','','25000ກີບ',2,0,NULL,'2006-10-13 16:45:58','2006-10-13 16:46:27'),(27,'AQ3',25,0,1,'000',10,1,1,10,'0000-00-00','0000-00-00','','',2,1,'2006-10-16','2006-10-14 09:10:09','2006-10-16 16:59:54'),(28,'3370000451300',50,0,1,'JR COC',13,1,1,12,'2004-08-05','0000-00-00','','',2,0,NULL,'2005-01-01 00:00:00','2005-06-22 23:15:28'),(29,'3370000451302',51,0,1,'590 BOU',10,1,1,12,'2004-08-05','2004-08-05','','',2,0,NULL,'2005-01-01 00:00:00','2005-08-10 22:25:04'),(30,'33700004500167',53,0,1,'RK ROB',10,1,1,12,'2004-08-05','2004-08-05','','',2,0,NULL,'2005-01-01 00:00:00','2005-06-22 23:15:28'),(32,'6438646236',2,0,1,'R HER',13,1,1,12,'2004-09-13','2004-09-13','','',2,0,NULL,'2005-01-01 00:00:00','2005-06-22 23:15:28'),(33,'1005',58,0,1,'1',10,1,1,12,'0000-00-00','0000-00-00','tester ','100',2,0,NULL,'2006-08-22 17:46:35','2006-08-22 17:47:38'),(34,'11586-11592',60,0,1,'000',10,1,1,12,'0000-00-00','0000-00-00','à»€àº§àº»à»‰àº²àº?à»ˆàº½àº§àº?àº±àºšàºžàº»àº‡àºªàº²àº§àº°àº”àº²àº™','à»‘à»’à»’à»’',2,0,NULL,'2006-08-24 18:11:59','2006-08-28 14:29:04'),(35,'11586-11593',60,0,1,'009',10,1,1,12,'0000-00-00','0000-00-00','gh,jhg,jdh','100000',2,0,NULL,'2006-08-24 18:14:25','2006-08-25 10:05:57'),(41,'00111',59,0,1,'099',10,1,1,12,'0000-00-00','0000-00-00','','',2,0,NULL,'2006-10-05 17:42:20','2006-10-05 17:42:20'),(37,'PE37',63,0,1,'000',10,1,1,12,'0000-00-00','0000-00-00','àº?àº²àº™à»ƒàº«à»‰àº¢àº·àº¡àº”à»ˆàº§àº™','24000',2,9,'2006-11-08','2005-01-01 00:00:00','2006-11-08 15:50:29'),(40,'11602-03',65,0,1,'001',10,1,1,12,'0000-00-00','0000-00-00','','15000àº?àºµàºš',2,0,NULL,'2006-10-05 17:19:56','2006-10-05 17:19:56');
UNLOCK TABLES;
/*!40000 ALTER TABLE `exemplaires` ENABLE KEYS */;

--
-- Table structure for table `exercices`
--

DROP TABLE IF EXISTS `exercices`;
CREATE TABLE `exercices` (
  `id_exercice` int(8) unsigned NOT NULL auto_increment,
  `num_entite` int(5) unsigned NOT NULL default '0',
  `libelle` varchar(255) NOT NULL default '',
  `date_debut` date NOT NULL default '2006-01-01',
  `date_fin` date NOT NULL default '2006-01-01',
  `statut` int(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id_exercice`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `exercices`
--


/*!40000 ALTER TABLE `exercices` DISABLE KEYS */;
LOCK TABLES `exercices` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `exercices` ENABLE KEYS */;

--
-- Table structure for table `expl_custom`
--

DROP TABLE IF EXISTS `expl_custom`;
CREATE TABLE `expl_custom` (
  `idchamp` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `titre` varchar(255) default NULL,
  `type` varchar(10) NOT NULL default 'text',
  `datatype` varchar(10) NOT NULL default '',
  `options` text,
  `multiple` int(11) NOT NULL default '0',
  `obligatoire` int(11) NOT NULL default '0',
  `ordre` int(11) default NULL,
  PRIMARY KEY  (`idchamp`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `expl_custom`
--


/*!40000 ALTER TABLE `expl_custom` DISABLE KEYS */;
LOCK TABLES `expl_custom` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `expl_custom` ENABLE KEYS */;

--
-- Table structure for table `expl_custom_lists`
--

DROP TABLE IF EXISTS `expl_custom_lists`;
CREATE TABLE `expl_custom_lists` (
  `expl_custom_champ` int(10) unsigned NOT NULL default '0',
  `expl_custom_list_value` varchar(255) default NULL,
  `expl_custom_list_lib` varchar(255) default NULL,
  `ordre` int(11) default NULL,
  KEY `expl_custom_champ` (`expl_custom_champ`),
  KEY `expl_champ_list_value` (`expl_custom_champ`,`expl_custom_list_value`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `expl_custom_lists`
--


/*!40000 ALTER TABLE `expl_custom_lists` DISABLE KEYS */;
LOCK TABLES `expl_custom_lists` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `expl_custom_lists` ENABLE KEYS */;

--
-- Table structure for table `expl_custom_values`
--

DROP TABLE IF EXISTS `expl_custom_values`;
CREATE TABLE `expl_custom_values` (
  `expl_custom_champ` int(10) unsigned NOT NULL default '0',
  `expl_custom_origine` int(10) unsigned NOT NULL default '0',
  `expl_custom_small_text` varchar(255) default NULL,
  `expl_custom_text` text,
  `expl_custom_integer` int(11) default NULL,
  `expl_custom_date` date default NULL,
  `expl_custom_float` float default NULL,
  KEY `expl_custom_champ` (`expl_custom_champ`),
  KEY `expl_custom_origine` (`expl_custom_origine`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `expl_custom_values`
--


/*!40000 ALTER TABLE `expl_custom_values` DISABLE KEYS */;
LOCK TABLES `expl_custom_values` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `expl_custom_values` ENABLE KEYS */;

--
-- Table structure for table `explnum`
--

DROP TABLE IF EXISTS `explnum`;
CREATE TABLE `explnum` (
  `explnum_id` int(11) unsigned NOT NULL auto_increment,
  `explnum_notice` mediumint(8) unsigned NOT NULL default '0',
  `explnum_bulletin` int(8) unsigned NOT NULL default '0',
  `explnum_nom` varchar(255) NOT NULL default '',
  `explnum_mimetype` varchar(255) NOT NULL default '',
  `explnum_url` text NOT NULL,
  `explnum_data` mediumblob,
  `explnum_vignette` mediumblob,
  `explnum_extfichier` varchar(20) default '',
  `explnum_nomfichier` text,
  PRIMARY KEY  (`explnum_id`),
  KEY `explnum_notice` (`explnum_notice`),
  KEY `explnum_bulletin` (`explnum_bulletin`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `explnum`
--


/*!40000 ALTER TABLE `explnum` DISABLE KEYS */;
LOCK TABLES `explnum` WRITE;
INSERT INTO `explnum` VALUES (1,42,0,'Reproduction basse qualité','image/jpeg','','\0JFIF\0\0H\0H\0\0Exif\0\0MM\0*\0\0\0\0\0\0\0\0\0\0\0\Z\0\0\0\0\0\0\0b\0\0\0\0\0\0\0j(\0\0\0\0\0\0\01\0\0\0\0\0\0\0r2\0\0\0\0\0\0\0i\0\0\0\0\0\0\0\0\0\0\0\0\0H\0\0\0\0\0\0H\0\0\0Adobe Photoshop 7.0\02004:08:04 18:34:44\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0Q\0\0\0\0\0\0\0\0\0\0\0\0\0\0\Z\0\0\0\0\0\0\0\0\0\0\0\0(\0\0\0\0\0\0\0\0\0\0\0\0\0&\0\0\0\0\0\0\Z\0\0\0\0\0\0\0H\0\0\0\0\0\0H\0\0\0\0JFIF\0\0H\0H\0\0\0Adobe_CM\0\0Adobe\0d\0\0\0\0\0			\n\r\r\r\0\0T\0\"\0\0\0?\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0\0\0\0\0\0	\n\03\0!1AQa\"q2B#$Rb34rC%Scs5&DTdE£t6UeuF\'Vfv7GWgw\05\0!1AQaq\"2B#R3$brCScs4%&5DTdEU6teuFVfv\'7GWgw\0\0\0?\0ʻ:WꫵAWcimm~Bv\'+:\rze-Ƴ}\0gg[6Oؿ~ӬdU5RXHc\0m?\05X6۬u[7>F*;kuWn?\0\"or˹2+c3ا}_{-\0S\'ޣ4M$Yhu9ʮõ]Ogڜ\0RտLe/1cF)Ƨ}{\0\\\r!ݎXbfE\0m^G*Kn촖[anm3c15_WյI춙[5i%ln]=?uBikq[C}a{i>]k\Z~O{*ĺneXf@$cCC$hd?߫ӎ\0:Hd&[Oƶ\Zk=jc}]~~XT~͟{\0I}ERe~Y.cSi!uȢ=?K/\0{2K;CqqS}OfK\ZiƻٽDUsh{V\nEߏH\0Z+!UuxQ]PXk:ǚfON[s\0X\0f^e6Ek9\Z7mC.+{߳-}i}?^ÓGC$[zgoIZ-~^M6oQX~\0C#zzhƺ˫#6۽[K?ӻ}(S]n6YnFU[g[{5m\re:~\n~%fe})p6mua&ʘ^2w\0R(H3]\0n02AnOq\07?Hr\rnmomn/CqN~埤\"N=W`#,zhKkss=&u/em%?Ed猬5zEǤdk=O^-U\Z2썍}[=\'ƶs*uoemYWbR6O6WW[\0*\0\0n5[vluݬih{n\\W{w\0:C\Zxn^\0sMot-~ncZu5t>Oe\nBڝ:}Yޣ]wL\ZHԯѱDk1.̖,6]w~gEDفMIBꩦҁffk_Ի\0IA}KF;y/Z==V7ٷt]ЯzˤX/gjm{ُ3?X?KuhU{};1n=[E}ԷQu9W6Udcr7SWTkWeO.Ӌʩh \0K5ͩf5V3YYl\Z|8ײPks>STqn5nv#M̓HkVZW:%Ue6>m[;cn1*.mv>^MReMpz2\0lg?e21/P[H85=)m5`lg\0e}G{{\Zᑊ(>=+*w\'꫷6fm\rg7z>jS[2َ~їm>M\Z#1clg,}f\0^,i󭶆n?I]9e?kNjkCq.mNǺֆȜ]Vׇ?K/~Uؗ=.)u\'ۊij\0zL;ǳ5k]*xֻ1\0N_?%6Km\":={[w?6%omwE0盳ِS[m\0U\r+K,\"qXMeis.ul\'&7]T7u^JY.K]v\Z\0?C}4Flz5S-o&\0,7{\Z,݊_meX_Y?N,&Y9*ǻs=UGj{S\05VS[6Ϫ)Z\0zYhLZ\nq[C\\]Ez46ѿ*)ǿ\'*UvF\Zmضzή]W?Eax!gp1e8=zWM}vSg%zJ˾_Rë\'>͙f\09Mlq\03\'Ft=_c:O[zֵ\rs-slvmgЪRUKZq3h;]ҩ=;/4RIήM4~s6Z\07O~kq2I,&S4M5ϯ\032]UMv^-՟J˚Qs]gnM9Ev{\0Yn?%.elum9Es}2zhݎlnnfm5:6n}L?f,_M8;X\\˙}\"Yq.][w\0ϩ)|۱uyU<Zkk+֫\0\n3\"3M1k5_]][joٯtfc-;qhiʛe!}[\\+g?VY1:_ch{a-^?$lN^zz8=WK5egiuSSE7\r99;3}UUCk\0շ\\*6Sq\\EjcKO^\0{gimOkFM2\ZlYs̟A.]l.slf3(+(%b۱Vھmm`Cj\0X>+k27SE}k}O˺=7Gxz{Y\0L+7\"Vca{}hw?欳-oI^\rqnHak8䵡X܇\0i{F@\nllzS\0]aeٗ2r+l略Q+PmugߤO\ZWCCMl{	u~7_\'W\0	 k/Cilp}nQgoF\0{.UăzA=V{m~~+;+s\Z sX;KodَZoeVmcMVzƲ6\Z\rm\'Hȷ?z>ޣ,aļ6_oS?\03kٸ18[,$Mymu/v6X/krlK_M-fܳUgQl>6Z/{>wW[=\0{򺋝Eo:̓Qmo{on_[1ZjCR]K1Z&Yk6G]~bNG_M9e\r{>c8mYc\0Jٻqx}ױmk\0um~./3^v2sklW`cWݲoש;%βѐjfSez7_.Nʙw\ZVSZZi!^66uz???lE	.YnS~-dn\Z͞V[[?Af[\0M驰;(Xl(Scn9sjz?j{\Z}?G/\0ͪ.n^c+U2ɹ/sk{?R*e?=\\MrEӏFw:ֈ/gx6~}IIz\0[ʘ\0Q\0w\0HnMR8e]ceu\n7~E[k.Wo8Q̖+Ƚ\r[mU=6[{?K[\03,fTZEiix{Uf̯Sв=̤0XeeNcCXE+l>?I\0ZQmcѓfDakXsj1z\n-}ˢuuz\\4Ӯڽ?SmvR:ɪv]21)`Ne?QOy+Xur]hk%}4kֽ\0ū8Ϊcdё2k\\ǳ#=E=+.\ng2qoĺk趻o.X}<l6YS=l:n\0JFmñmǺ6۫o믧#ؒòFaٮ@d`eqGӫy=\'u}Uc6z8U1:s&eѴ<3aͶmv})uߓcm\n3-V_\0j.{~0pm.u\08w?\0*:u5ٝK	I>yTC}M?tzir=\nEkхWw~KjߍUi}E[#+\'=MOwC[.ؔ6\09\0IF2\'n9qcw9Ѡ3ߠߧv#WvGXsK=%tMg=?oM}M[=l7w_閕]~5xX΂ƝSz}u\0	\rWl^0Y[skoZH,?I7Mη1s2p.uS=7=oCYQ;Ul X-5oWN2^k^rm72r{Yc+ֽW\0eȡ]u\'ޝn~k:[M~.CX}xsՅϲJ~:v?,=Bmow?_l{iuhn-kW}~%uYpƹ`om=u)ߌZˎF\0\Z*5wlF/4\\|&b8X\'mփX~䆻OU~>;j\'$W{ni{cm{\0}ޕTr-ާ-6m[v[[\0q=*X5pdFp]ֻ\0\0X.uliu8\\e~lgcOnLr}\nG{ ls\"BmN6kI%\"_;k~ޖNz_!1nŭ[7ױp`e^\0j?IU*WnzT$9\rOKwS\0g3[LAs֐ּۜ{\\\0E$$CN܊1[m]WWͫc}jmŹ-6mWe^QgLq!\0fml5\0m>UXUD{_H~C+eWß+۲:V\0_?i\Z:C=z4?\'-vMLc{\'YG;1}R܋ن3\ZzJ݇cƱQuv\0;\00W.5Օks`\r>UӁ_>1c>~\\lF F q>\0\rվg}>}z6SF_߿EJ>ޟ7nv7Н\0zUl-ٷ7dzqk\0^$WE_%ߴ?\0Fg^zwz;c~>Sw\0~S_ci͏W?)^ctG=$ڡ}ԍ~?g0w}r~>}},okCQ>{~G[wGsolK{g=AFͻ{ڼM$~گ_dwD>}=oj}nϰ~i%U>w>>ɶ5G=o=77o[>׻x\0Oӟѿ_W7k\Zt>Photoshop 3.0\08BIM%\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\08BIM\0\0\0\0<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE plist PUBLIC \"-//Apple Computer//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n<plist version=\"1.0\">\n<dict>\n	<key>com.apple.print.PageFormat.PMHorizontalRes</key>\n	<dict>\n		<key>com.apple.print.ticket.creator</key>\n		<string>com.apple.printingmanager</string>\n		<key>com.apple.print.ticket.itemArray</key>\n		<array>\n			<dict>\n				<key>com.apple.print.PageFormat.PMHorizontalRes</key>\n				<real>72</real>\n				<key>com.apple.print.ticket.client</key>\n				<string>com.apple.printingmanager</string>\n				<key>com.apple.print.ticket.modDate</key>\n				<date>2004-08-04T16:32:30Z</date>\n				<key>com.apple.print.ticket.stateFlag</key>\n				<integer>0</integer>\n			</dict>\n		</array>\n	</dict>\n	<key>com.apple.print.PageFormat.PMOrientation</key>\n	<dict>\n		<key>com.apple.print.ticket.creator</key>\n		<string>com.apple.printingmanager</string>\n		<key>com.apple.print.ticket.itemArray</key>\n		<array>\n			<dict>\n				<key>com.apple.print.PageFormat.PMOrientation</key>\n				<integer>1</integer>\n				<key>com.apple.print.ticket.client</key>\n				<string>com.apple.printingmanager</string>\n				<key>com.apple.print.ticket.modDate</key>\n				<date>2004-08-04T16:32:30Z</date>\n				<key>com.apple.print.ticket.stateFlag</key>\n				<integer>0</integer>\n			</dict>\n		</array>\n	</dict>\n	<key>com.apple.print.PageFormat.PMScaling</key>\n	<dict>\n		<key>com.apple.print.ticket.creator</key>\n		<string>com.apple.printingmanager</string>\n		<key>com.apple.print.ticket.itemArray</key>\n		<array>\n			<dict>\n				<key>com.apple.print.PageFormat.PMScaling</key>\n				<real>1</real>\n				<key>com.apple.print.ticket.client</key>\n				<string>com.apple.printingmanager</string>\n				<key>com.apple.print.ticket.modDate</key>\n				<date>2004-08-04T16:32:30Z</date>\n				<key>com.apple.print.ticket.stateFlag</key>\n				<integer>0</integer>\n			</dict>\n		</array>\n	</dict>\n	<key>com.apple.print.PageFormat.PMVerticalRes</key>\n	<dict>\n		<key>com.apple.print.ticket.creator</key>\n		<string>com.apple.printingmanager</string>\n		<key>com.apple.print.ticket.itemArray</key>\n		<array>\n			<dict>\n				<key>com.apple.print.PageFormat.PMVerticalRes</key>\n				<real>72</real>\n				<key>com.apple.print.ticket.client</key>\n				<string>com.apple.printingmanager</string>\n				<key>com.apple.print.ticket.modDate</key>\n				<date>2004-08-04T16:32:30Z</date>\n				<key>com.apple.print.ticket.stateFlag</key>\n				<integer>0</integer>\n			</dict>\n		</array>\n	</dict>\n	<key>com.apple.print.PageFormat.PMVerticalScaling</key>\n	<dict>\n		<key>com.apple.print.ticket.creator</key>\n		<string>com.apple.printingmanager</string>\n		<key>com.apple.print.ticket.itemArray</key>\n		<array>\n			<dict>\n				<key>com.apple.print.PageFormat.PMVerticalScaling</key>\n				<real>1</real>\n				<key>com.apple.print.ticket.client</key>\n				<string>com.apple.printingmanager</string>\n				<key>com.apple.print.ticket.modDate</key>\n				<date>2004-08-04T16:32:30Z</date>\n				<key>com.apple.print.ticket.stateFlag</key>\n				<integer>0</integer>\n			</dict>\n		</array>\n	</dict>\n	<key>com.apple.print.subTicket.paper_info_ticket</key>\n	<dict>\n		<key>com.apple.print.PageFormat.PMAdjustedPageRect</key>\n		<dict>\n			<key>com.apple.print.ticket.creator</key>\n			<string>com.apple.printingmanager</string>\n			<key>com.apple.print.ticket.itemArray</key>\n			<array>\n				<dict>\n					<key>com.apple.print.PageFormat.PMAdjustedPageRect</key>\n					<array>\n						<real>0.0</real>\n						<real>0.0</real>\n						<real>783</real>\n						<real>559</real>\n					</array>\n					<key>com.apple.print.ticket.client</key>\n					<string>com.apple.printingmanager</string>\n					<key>com.apple.print.ticket.modDate</key>\n					<date>2004-08-04T16:32:30Z</date>\n					<key>com.apple.print.ticket.stateFlag</key>\n					<integer>0</integer>\n				</dict>\n			</array>\n		</dict>\n		<key>com.apple.print.PageFormat.PMAdjustedPaperRect</key>\n		<dict>\n			<key>com.apple.print.ticket.creator</key>\n			<string>com.apple.printingmanager</string>\n			<key>com.apple.print.ticket.itemArray</key>\n			<array>\n				<dict>\n					<key>com.apple.print.PageFormat.PMAdjustedPaperRect</key>\n					<array>\n						<real>-18</real>\n						<real>-18</real>\n						<real>824</real>\n						<real>577</real>\n					</array>\n					<key>com.apple.print.ticket.client</key>\n					<string>com.apple.printingmanager</string>\n					<key>com.apple.print.ticket.modDate</key>\n					<date>2004-08-04T16:32:30Z</date>\n					<key>com.apple.print.ticket.stateFlag</key>\n					<integer>0</integer>\n				</dict>\n			</array>\n		</dict>\n		<key>com.apple.print.PaperInfo.PMPaperName</key>\n		<dict>\n			<key>com.apple.print.ticket.creator</key>\n			<string>com.apple.print.pm.PostScript</string>\n			<key>com.apple.print.ticket.itemArray</key>\n			<array>\n				<dict>\n					<key>com.apple.print.PaperInfo.PMPaperName</key>\n					<string>iso-a4</string>\n					<key>com.apple.print.ticket.client</key>\n					<string>com.apple.print.pm.PostScript</string>\n					<key>com.apple.print.ticket.modDate</key>\n					<date>2003-07-01T17:49:36Z</date>\n					<key>com.apple.print.ticket.stateFlag</key>\n					<integer>1</integer>\n				</dict>\n			</array>\n		</dict>\n		<key>com.apple.print.PaperInfo.PMUnadjustedPageRect</key>\n		<dict>\n			<key>com.apple.print.ticket.creator</key>\n			<string>com.apple.print.pm.PostScript</string>\n			<key>com.apple.print.ticket.itemArray</key>\n			<array>\n				<dict>\n					<key>com.apple.print.PaperInfo.PMUnadjustedPageRect</key>\n					<array>\n						<real>0.0</real>\n						<real>0.0</real>\n						<real>783</real>\n						<real>559</real>\n					</array>\n					<key>com.apple.print.ticket.client</key>\n					<string>com.apple.printingmanager</string>\n					<key>com.apple.print.ticket.modDate</key>\n					<date>2004-08-04T16:32:30Z</date>\n					<key>com.apple.print.ticket.stateFlag</key>\n					<integer>0</integer>\n				</dict>\n			</array>\n		</dict>\n		<key>com.apple.print.PaperInfo.PMUnadjustedPaperRect</key>\n		<dict>\n			<key>com.apple.print.ticket.creator</key>\n			<string>com.apple.print.pm.PostScript</string>\n			<key>com.apple.print.ticket.itemArray</key>\n			<array>\n				<dict>\n					<key>com.apple.print.PaperInfo.PMUnadjustedPaperRect</key>\n					<array>\n						<real>-18</real>\n						<real>-18</real>\n						<real>824</real>\n						<real>577</real>\n					</array>\n					<key>com.apple.print.ticket.client</key>\n					<string>com.apple.printingmanager</string>\n					<key>com.apple.print.ticket.modDate</key>\n					<date>2004-08-04T16:32:30Z</date>\n					<key>com.apple.print.ticket.stateFlag</key>\n					<integer>0</integer>\n				</dict>\n			</array>\n		</dict>\n		<key>com.apple.print.PaperInfo.ppd.PMPaperName</key>\n		<dict>\n			<key>com.apple.print.ticket.creator</key>\n			<string>com.apple.print.pm.PostScript</string>\n			<key>com.apple.print.ticket.itemArray</key>\n			<array>\n				<dict>\n					<key>com.apple.print.PaperInfo.ppd.PMPaperName</key>\n					<string>A4</string>\n					<key>com.apple.print.ticket.client</key>\n					<string>com.apple.print.pm.PostScript</string>\n					<key>com.apple.print.ticket.modDate</key>\n					<date>2003-07-01T17:49:36Z</date>\n					<key>com.apple.print.ticket.stateFlag</key>\n					<integer>1</integer>\n				</dict>\n			</array>\n		</dict>\n		<key>com.apple.print.ticket.APIVersion</key>\n		<string>00.20</string>\n		<key>com.apple.print.ticket.privateLock</key>\n		<false/>\n		<key>com.apple.print.ticket.type</key>\n		<string>com.apple.print.PaperInfoTicket</string>\n	</dict>\n	<key>com.apple.print.ticket.APIVersion</key>\n	<string>00.20</string>\n	<key>com.apple.print.ticket.privateLock</key>\n	<false/>\n	<key>com.apple.print.ticket.type</key>\n	<string>com.apple.print.PageFormatTicket</string>\n</dict>\n</plist>\n8BIM\0\0\0\0\0x\0\0\0\0H\0H\0\0\0\0/8Ag{\0\0\0\0H\0H\0\0\0\0(\0\0\0\0d\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0h\0\0\0\0\0\0 \0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\08BIM\0\0\0\0\0\0H\0\0\0\0\0H\0\0\0\08BIM&\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0?\0\08BIM\r\0\0\0\0\0\0\0\08BIM\0\0\0\0\0\0\0\08BIM\0\0\0\0\0	\0\0\0\0\0\0\0\0\08BIM\n\0\0\0\0\0\0\08BIM\'\0\0\0\0\0\n\0\0\0\0\0\0\0\08BIM\0\0\0\0\0H\0/ff\0\0lff\0\0\0\0\0\0\0/ff\0\0\0\0\0\0\0\0\02\0\0\0\0Z\0\0\0\0\0\0\0\0\05\0\0\0\0-\0\0\0\0\0\0\0\08BIM\0\0\0\0\0p\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\08BIM\0\0\0\0\0\0\0\0\0\0@\0\0@\0\0\0\08BIM\0\0\0\0\0\0\0\0\08BIM\Z\0\0\0\0A\0\0\0\0\0\0\0\0\0\0\0\0\0Q\0\0\0\0\0\0c\0h\0a\0r\0t\0e\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0Q\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0null\0\0\0\0\0\0boundsObjc\0\0\0\0\0\0\0\0\0Rct1\0\0\0\0\0\0\0Top long\0\0\0\0\0\0\0\0Leftlong\0\0\0\0\0\0\0\0Btomlong\0\0Q\0\0\0\0Rghtlong\0\0\0\0\0slicesVlLs\0\0\0Objc\0\0\0\0\0\0\0\0slice\0\0\0\0\0\0sliceIDlong\0\0\0\0\0\0\0groupIDlong\0\0\0\0\0\0\0originenum\0\0\0ESliceOrigin\0\0\0\rautoGenerated\0\0\0\0Typeenum\0\0\0\nESliceType\0\0\0\0Img \0\0\0boundsObjc\0\0\0\0\0\0\0\0\0Rct1\0\0\0\0\0\0\0Top long\0\0\0\0\0\0\0\0Leftlong\0\0\0\0\0\0\0\0Btomlong\0\0Q\0\0\0\0Rghtlong\0\0\0\0\0urlTEXT\0\0\0\0\0\0\0\0\0nullTEXT\0\0\0\0\0\0\0\0\0MsgeTEXT\0\0\0\0\0\0\0\0altTagTEXT\0\0\0\0\0\0\0\0cellTextIsHTMLbool\0\0\0cellTextTEXT\0\0\0\0\0\0\0\0	horzAlignenum\0\0\0ESliceHorzAlign\0\0\0default\0\0\0	vertAlignenum\0\0\0ESliceVertAlign\0\0\0default\0\0\0bgColorTypeenum\0\0\0ESliceBGColorType\0\0\0\0None\0\0\0	topOutsetlong\0\0\0\0\0\0\0\nleftOutsetlong\0\0\0\0\0\0\0bottomOutsetlong\0\0\0\0\0\0\0rightOutsetlong\0\0\0\0\08BIM\0\0\0\0\0\08BIM\0\0\0\0\0\0\0\08BIM\0\0\0\0\Z\0\0\0\0\0\0\0\0\0T\0\0\0\0~\0\0\0\Z\0\0\0JFIF\0\0H\0H\0\0\0Adobe_CM\0\0Adobe\0d\0\0\0\0\0			\n\r\r\r\0\0T\0\"\0\0\0?\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0\0\0\0\0\0	\n\03\0!1AQa\"q2B#$Rb34rC%Scs5&DTdE£t6UeuF\'Vfv7GWgw\05\0!1AQaq\"2B#R3$brCScs4%&5DTdEU6teuFVfv\'7GWgw\0\0\0?\0ʻ:WꫵAWcimm~Bv\'+:\rze-Ƴ}\0gg[6Oؿ~ӬdU5RXHc\0m?\05X6۬u[7>F*;kuWn?\0\"or˹2+c3ا}_{-\0S\'ޣ4M$Yhu9ʮõ]Ogڜ\0RտLe/1cF)Ƨ}{\0\\\r!ݎXbfE\0m^G*Kn촖[anm3c15_WյI춙[5i%ln]=?uBikq[C}a{i>]k\Z~O{*ĺneXf@$cCC$hd?߫ӎ\0:Hd&[Oƶ\Zk=jc}]~~XT~͟{\0I}ERe~Y.cSi!uȢ=?K/\0{2K;CqqS}OfK\ZiƻٽDUsh{V\nEߏH\0Z+!UuxQ]PXk:ǚfON[s\0X\0f^e6Ek9\Z7mC.+{߳-}i}?^ÓGC$[zgoIZ-~^M6oQX~\0C#zzhƺ˫#6۽[K?ӻ}(S]n6YnFU[g[{5m\re:~\n~%fe})p6mua&ʘ^2w\0R(H3]\0n02AnOq\07?Hr\rnmomn/CqN~埤\"N=W`#,zhKkss=&u/em%?Ed猬5zEǤdk=O^-U\Z2썍}[=\'ƶs*uoemYWbR6O6WW[\0*\0\0n5[vluݬih{n\\W{w\0:C\Zxn^\0sMot-~ncZu5t>Oe\nBڝ:}Yޣ]wL\ZHԯѱDk1.̖,6]w~gEDفMIBꩦҁffk_Ի\0IA}KF;y/Z==V7ٷt]ЯzˤX/gjm{ُ3?X?KuhU{};1n=[E}ԷQu9W6Udcr7SWTkWeO.Ӌʩh \0K5ͩf5V3YYl\Z|8ײPks>STqn5nv#M̓HkVZW:%Ue6>m[;cn1*.mv>^MReMpz2\0lg?e21/P[H85=)m5`lg\0e}G{{\Zᑊ(>=+*w\'꫷6fm\rg7z>jS[2َ~їm>M\Z#1clg,}f\0^,i󭶆n?I]9e?kNjkCq.mNǺֆȜ]Vׇ?K/~Uؗ=.)u\'ۊij\0zL;ǳ5k]*xֻ1\0N_?%6Km\":={[w?6%omwE0盳ِS[m\0U\r+K,\"qXMeis.ul\'&7]T7u^JY.K]v\Z\0?C}4Flz5S-o&\0,7{\Z,݊_meX_Y?N,&Y9*ǻs=UGj{S\05VS[6Ϫ)Z\0zYhLZ\nq[C\\]Ez46ѿ*)ǿ\'*UvF\Zmضzή]W?Eax!gp1e8=zWM}vSg%zJ˾_Rë\'>͙f\09Mlq\03\'Ft=_c:O[zֵ\rs-slvmgЪRUKZq3h;]ҩ=;/4RIήM4~s6Z\07O~kq2I,&S4M5ϯ\032]UMv^-՟J˚Qs]gnM9Ev{\0Yn?%.elum9Es}2zhݎlnnfm5:6n}L?f,_M8;X\\˙}\"Yq.][w\0ϩ)|۱uyU<Zkk+֫\0\n3\"3M1k5_]][joٯtfc-;qhiʛe!}[\\+g?VY1:_ch{a-^?$lN^zz8=WK5egiuSSE7\r99;3}UUCk\0շ\\*6Sq\\EjcKO^\0{gimOkFM2\ZlYs̟A.]l.slf3(+(%b۱Vھmm`Cj\0X>+k27SE}k}O˺=7Gxz{Y\0L+7\"Vca{}hw?欳-oI^\rqnHak8䵡X܇\0i{F@\nllzS\0]aeٗ2r+l略Q+PmugߤO\ZWCCMl{	u~7_\'W\0	 k/Cilp}nQgoF\0{.UăzA=V{m~~+;+s\Z sX;KodَZoeVmcMVzƲ6\Z\rm\'Hȷ?z>ޣ,aļ6_oS?\03kٸ18[,$Mymu/v6X/krlK_M-fܳUgQl>6Z/{>wW[=\0{򺋝Eo:̓Qmo{on_[1ZjCR]K1Z&Yk6G]~bNG_M9e\r{>c8mYc\0Jٻqx}ױmk\0um~./3^v2sklW`cWݲoש;%βѐjfSez7_.Nʙw\ZVSZZi!^66uz???lE	.YnS~-dn\Z͞V[[?Af[\0M驰;(Xl(Scn9sjz?j{\Z}?G/\0ͪ.n^c+U2ɹ/sk{?R*e?=\\MrEӏFw:ֈ/gx6~}IIz\0[ʘ\0Q\0w\0HnMR8e]ceu\n7~E[k.Wo8Q̖+Ƚ\r[mU=6[{?K[\03,fTZEiix{Uf̯Sв=̤0XeeNcCXE+l>?I\0ZQmcѓfDakXsj1z\n-}ˢuuz\\4Ӯڽ?SmvR:ɪv]21)`Ne?QOy+Xur]hk%}4kֽ\0ū8Ϊcdё2k\\ǳ#=E=+.\ng2qoĺk趻o.X}<l6YS=l:n\0JFmñmǺ6۫o믧#ؒòFaٮ@d`eqGӫy=\'u}Uc6z8U1:s&eѴ<3aͶmv})uߓcm\n3-V_\0j.{~0pm.u\08w?\0*:u5ٝK	I>yTC}M?tzir=\nEkхWw~KjߍUi}E[#+\'=MOwC[.ؔ6\09\0IF2\'n9qcw9Ѡ3ߠߧv#WvGXsK=%tMg=?oM}M[=l7w_閕]~5xX΂ƝSz}u\0	\rWl^0Y[skoZH,?I7Mη1s2p.uS=7=oCYQ;Ul X-5oWN2^k^rm72r{Yc+ֽW\0eȡ]u\'ޝn~k:[M~.CX}xsՅϲJ~:v?,=Bmow?_l{iuhn-kW}~%uYpƹ`om=u)ߌZˎF\0\Z*5wlF/4\\|&b8X\'mփX~䆻OU~>;j\'$W{ni{cm{\0}ޕTr-ާ-6m[v[[\0q=*X5pdFp]ֻ\0\0X.uliu8\\e~lgcOnLr}\nG{ ls\"BmN6kI%\"_;k~ޖNz_!1nŭ[7ױp`e^\0j?IU*WnzT$9\rOKwS\0g3[LAs֐ּۜ{\\\0E$$CN܊1[m]WWͫc}jmŹ-6mWe^QgLq!\0fml5\0m>UXUD{_H~C+eWß+۲:V\0_?i\Z:C=z4?\'-vMLc{\'YG;1}R܋ن3\ZzJ݇cƱQuv\0;\00W.5Օks`\r>UӁ_>1c>~\\lF F q>\0\rվg}>}z6SF_߿EJ>ޟ7nv7Н\0zUl-ٷ7dzqk\0^$WE_%ߴ?\0Fg^zwz;c~>Sw\0~S_ci͏W?)^ctG=$ڡ}ԍ~?g0w}r~>}},okCQ>{~G[wGsolK{g=AFͻ{ڼM$~گ_dwD>}=oj}nϰ~i%U>w>>ɶ5G=o=77o[>׻x\0Oӟѿ_W7k\Zt\08BIM!\0\0\0\0\0U\0\0\0\0\0\0\0A\0d\0o\0b\0e\0 \0P\0h\0o\0t\0o\0s\0h\0o\0p\0\0\0\0A\0d\0o\0b\0e\0 \0P\0h\0o\0t\0o\0s\0h\0o\0p\0 \07\0.\00\0\0\0\08BIM\0\0\0\0\0\0\0\0\0Hhttp://ns.adobe.com/xap/1.0/\0<?xpacket begin=\'﻿\' id=\'W5M0MpCehiHzreSzNTczkc9d\'?>\n<?adobe-xap-filters esc=\"CR\"?>\n<x:xapmeta xmlns:x=\'adobe:ns:meta/\' x:xaptk=\'XMP toolkit 2.8.2-33, framework 1.5\'>\n<rdf:RDF xmlns:rdf=\'http://www.w3.org/1999/02/22-rdf-syntax-ns#\' xmlns:iX=\'http://ns.adobe.com/iX/1.0/\'>\n\n <rdf:Description about=\'uuid:bd23180e-e7d6-11d8-bc4b-eba1eb0a597d\'\n  xmlns:xapMM=\'http://ns.adobe.com/xap/1.0/mm/\'>\n  <xapMM:DocumentID>adobe:docid:photoshop:bd23180c-e7d6-11d8-bc4b-eba1eb0a597d</xapMM:DocumentID>\n </rdf:Description>\n\n</rdf:RDF>\n</x:xapmeta>\n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                                                                    \n                                                       \n<?xpacket end=\'w\'?>\0Adobe\0d\0\0\0\0\0 !!3$3Q00QB///B\'\'\"\"\"334&4\"\"\0Q\"\0\0\0 \0\0\0\0\0\0\0\0	\n\0\0\0\0\0	\n\05\0!1AQ\"aq2BR#r3bC4S$scDTd%5E&t6UeuFVfv\0\0/\0!1AQaq\"2BR#br3C$4SDcs҃T%&5dEU6teuFVfv\0\0\0?\0m$SS26l8ǓO:SSuӲ2F]\'g~3qz;5[%mɈ}Xhg$o|6b/ꫩaD#TG,C4v\r[Z@%v|0H7/GKHVһKv2 ur3b\05\r#\nh4Zs:0l	K ؾ#07HD\rG!w\0v\0[\0ot\r@^\\P3P7:fs0A)YKs*Ԛ|ޛ;POVUy	PN\'DCTӉEqiq4M h$,4rH5h\"H7QM\0e\0I/\rnH4#2	=QP Z#@\0%|D$wڃn\Zֶ{At`	KV0ǵ\0Lg`@XGxJ\0@&}9A5<:aS+Nn_\'^P3	IjMXM%e4E,D־-TbGyc:`ePBqr\0@\Zڙwށ:uyq5D\0v(jiy}0?YE*vK`\'E\0V@u`w@TiEDXD\0@&1#e\'p,K,bh&1AF@DR6p \n@2K]d	`7\0$\0\0cɸpiÌ?\rѓR*E8c NGAbY\"x$@iՖZP5sʁԯ<2J@6Ӕ3K4n\Zۦd{9	Lr3QD{CS\Zm7o?$nj43W伀%.\\9z@W@7GqH^s4o7Q|QK\rkppШ@ey<aϏw=\ZRX\0@Bde\0yL`P6J\'|GhMǩ&0$3g65h|g,A՘qD@Y\0֏4ܧdr@6)a`QLcgHbU2\'&+ J \'ayd+ r,0\0Z\Z\rZHKLCɄؐ97\Z`4<8	r{2nvł\\lqMN1f #WɁdw_\Z\nZ9=Z2F@4a=t\Z=4X=8<<ф聘Ҙ\r S#q\Z	~Ṡ47\0@ydJ~zQ\ZGl# OBp$E4\Z\0܇T]vfpBwyӱGL37ܽX%z)o͹hOxqpQ\'җ ]ȑ<J#wqizlOda9\Zsx;Ʈy1Ё1$-Xqj\\C brQb; L&b)D|C]0vcyc)(.y3痐oVOv3$̜\Z93F1p⏂TC8ڄz~QД\04L{!`Fybf`\r~yFC@$|1  \'DĀR\ZÔ\rfAV\0LF$_(!QE%ޜ9/->sdXL+ƻ{BuE8F94HTj.HԄ\0\rZ\n2pɻWC$t%\r4@j#}\"{ n.~o6!hqgL#=NQ{A6@Rb%}@ۻ$;f?\rK*Owa^w8Q5bUh\0Rm2x|w\0\r\0z6G\nг#[0ˌJ$W!N,3{4`,j8@l\\?R0N\r\01r͒&H ̝@IF*HDɳЊ\'R&tՎ>s\0f\"L\'\'FY\Z.I&cR)6а:Ϫjn18ZˋX\r*\Zѡ	h|w:k06爐\n1)KI8Ks(xѠm\05/D`Gv_R7]Î|N5>e8X:ḱ%zZ$Ǣ.\'`((\n4i$37,lď헔`\ZS(ݶh>W):\ZdP#uyp (O϶na\Z}+P:j(qd\r,^iSí9	<q86)piwv97ͦ8DMwEaH@Lr\rOf1i&  @@ԉ4ءe Z+8@b`x\n\' Q;mH|keZjڔe)DYζ.\"BdCyYs^d\00q\ZhJ:8a!ٰJ9htq(N?r]$Fh!ҙ.\r\\@@J#Zv\nM4#(<9eEkCeDh3Ki:J1#VvDHITI=oCf8\0@$#ܳ̌kOLw@4\"5@4 p]LX81N# H l3D\r/4qmTb(w/4U\0IY֑?\0%GZ@1F}o,Oft KRarvM$DUc\r4\ZBI\"@S8njˈ\\E#H퐈Mjm@U[t.qF^3*\0⋷h9de^!xK4b-2DLi\0(ːƨhx彷@Yekmj:Tl5^j٘GD\\e@/NP8~2ĤEb1\'^gQde$#ˡbځ≹F\0tMbDm<.:v\"N)蠃A\0Dr;1DP`9QLC	m2L&c4Ks\0_Q\rI?d%d!;ۤb/\n@l\\%|	Ǜ@$jG; L25\n2_f-5c|Jj 4b\n0\n}A4pFFm@㖌Wj̉׃=<1\"a}h5܈P3 Z7˧դr)|hy@-_(4AݸLyc$<^lrD~m	[P3AGP.<c1G-\0@%v_^&#u8ϡ{wŅFOwfj!#-{ND\n#vrbp<ҭW#Z[+E\rP04t.y)mirn#k2y7610YGDmD9)VR8Sb`(wb=1q$엋S\"(	WtHrm2]P4D5w-剔j05%|:h:gB\"1]r\0ϣ|Y?MP׭S{pl9bEL\\eޜ#d_\'IЇXgl)pGd]xqЈu17qB!Sx#3.QR\0(]\Z}$rxt؋@L(\"qn[u)KuxN.\0]e/bGS\0|2}NBd(1\rvE1AFrvW!ƪwN*RNX#$v	 jg*qt|@sAM80onCځRNXpR3Q}Yxr?\0/he||sYLSR1@K=K6tvq3\"m@yceC+Ga [#BBGZ;* r$vB@\\1O$  \r9\"d(qdiŹ~;z % &_=kq$ i\0Fdc\\4rOO*8ucu݂%(\"Urۓ`4AAep3m-W\0S]\0ƢL:7+\'uTr\02@\'	Ay$e0by-3\0DH6&{֔lZH! (/6\\r81(2w0B,ю9\0a8ϯg\\HYJ>	0\0Q!Ń	7D\"uY Y-F\0jŹd\rgHۗR/u\n@㺴2%%%@kéf\0\Z,;u$hD¬G}\0	2ӆ8n˽֏.9Q=Џ1ǻr%| J> <%	Li\n\"$Cl3_!>@ӻȖoɻZ@ڢ1fVijwGic!MA\0,d.zD\0S|W{BWF|@z@	<d i(oI˔BcWtrdq=hkݩGpbGE)l#L7?czcNBc4\'Gg-UU;oVOyM?=	Bocvd	bCgk!cb˦H@YAvF%\0Gvu@_f<fRR$B!AgRe\";͋|LY1;}0I$x\'`s͗ӍW|#oF2\ZX@IN h	tth;׹D.z)hƴcщ2g$ u*	_dgh`6hKb0@rB\'nhΨ@	trX\ZOH:$1쁐N${qd[bni{\'e\"	\Z	0Ҁ܀@)N3\'&ǤrF#sH0YR#!5RkO0D3֖#(hhM>^P9;Z1A:p\"K\':U\'YAQQ2\"lvD=1\"G.s\'C1[2FF͠id,Ou;\ZH[Xn6|_\'Hꋸ 9D&y1\'#,DP۬D!B*j7H\ZA\Z2gnf]9\"QȠa1aa#r쁕\Z$\"^|1/Hme\0\ZdH}zaP1#(߽\nc6ٌ@֜GVIj$ֺ e,vDgYB&^4DYd]	Lx(\Z@\0|Zs\';%\n*ZK@s]RbXKQ?P[9b+NHM14[? n\r9f\0fl>,Yܶ*1/\r39=ٌH):&7:c>P|8rPd9bx,\"\\\r\nsGtMZ.B>%E DTvщ7ZSA{㫄sN1y´@s\0[1:ldIm c7Zb@t(\" 0\Zd铌\r`$ўc\Z.\r\0ۦCZ?<DtY\rF;u:! = r\n.qwh}AZ2r8	⁮6v,;8h>)!Wqˌپ\0āGǇ7v\"k\r\0\0	_gώ6[✣@xXH\'T+W;6qQzkU-͉8헊6{fV>-,d$?F4ɁiU`@&T4旛^GJ\r#y`K]\r9H}?6I#P1Ǹ7.\'\Zjߦv6@DZx\\#\\#~.YN2:P~nRI$\r[N@;Rv hgH,Āud[B1B\'h\0.&S%L1zv耓ma#tN$$~6g\'WxxɌ\r7(FhP]/vaB7GrM_v72fY\\32[(&9H^@ҁ~>E1!nn1H\0u\rKeB hy[$SG|9y!n!\ZAg-1\0hb\Z`. eۣba?N(ęz3οiއ́5\r`wNTܠnB,NP{Z17DJ>`ڞ31@$`ݷlR$mbl #E9b\\2bL#h@@154#4B:ܶb%1\0r^3I9Hp)u%1O>8-!xIzv\"\nc<Țgn~³ΆH#!Lc\'h>oc#R-ȧ22\0s\07)N\'\0E2԰]`\\cGʡn?̿bȐS#IV;m,be%-,(d\0HiNh#*L2nQ(\"C,g)Fw\r s/Y9Fo5=g&)\0[hEIz^p\0\"9DŔȆ(FdA!ޢ{1,@@śNiLh\Z@hc\Zˌ#R NwF\'Zc\0oN#AÌq֔uo	yˣsGż4vbID16\nyctY	|g)G}`\r62)!ŇiL#@-%|mɐ>m>)l2d+H\rf@iQH(rNrkjy{Oِ\rOpSqE\0 u,E42$;ev-2%kR]72K\na2Fވ5n0\r8f\0.c\0g45]Q\Z86I%>hHüEb.Sq: 7^э`LAXw$Xc.aYfp)}<3HҖLDG(vlheڝDd\0d<{]w1Devj´F[5.4d4pf4bb\0D]N.yVږLQ+SDn Z\Z%	\rA7^SIO`xs9c%B\n=QofL\0@dk\'(GqD\0MQc&m\0	ysHDՁ4܅8jك{@ՌDuֵS\Z$O^f3kw{\r31loMA\0DYN4GW` 65 \\A9,\ny-Z	 gbLYfŠDq1/I|){@sru\0yGfZB3\07+\'GRc|Y?dt%pCpLS\0>\n)\n	\0yHtΪArNnyƽ\'Rc8i/b`̝[49rͷdT{9)2?hcM!@#J/A=3`^<铔mHZXqL\"\rG)bВG;H&bPG2PFbj1GlzpB{AFI.B[\'-<WԆި>,zB1߯D9x?\0%lS@M rEE̝܂>[x@9fW/a@n$q$DenznU;sb3 rn@(^HJ\'.%G[\'~Ѡ5h0Ǌ@_-y^dX)nLuYD s剗N,b1GrɲS$5vU;NVMH>27z7+\'	FY:Dx4fdch~lt	NѰґ$Nf;h)H%(Kwd\\H֑L)2FSB-P@Ex4{K5=ir3wTz:{ϸ`Op1pH(RbM_.@iG@H[$ gMmbI<#&NN@R|4Fǔg\"\"MkO&9@?B@(6\'#HH`32<,hE9h.9J/cGOvcKJGLAD. s܏!,wM ast\"{. D7gx\\J`2&t\"9\"\0^:[bQiNhyXb%shB2/6Lgtuz̃(ÔOC &`/h4`KR.q\"Q#XŔ8oVOn[oVOv=O\"NZQyAuݣe-U9tR!-xp6@qN5$4P;cf\0r-w\r!KPe>hz d28*enHM## h9c <\\g[`\rvƯM($hYlq.Bq\Z|@J3wz@\r\0ͭ1ȓ}޲\n)+G9܇NcgiqgM)%N^	3>\rL_	!p\'A$1;F4@%cG2ɣ@C@tu\0\\=5@5E\0̈́v oJd(AJN(2@4A\0A\r9O%0dDSAZ$mh\0NŞX\r*11>bH\n<LZGVr5H\0@qH0#R&TuF.\\H\Z qOAf\0d\07)=\0?р)Ћ\Zs !k`g]L\08Q=ˡj&`j&vI{3	(2\'Ɲ=)dE43xc(	\0S0&7Ig0(W9fENѤ2!o<z9V9OJc)Dh=[P JŹ@(Gu4\\2zvG#38w\"9Fu]Ǩߺp$Dnٓ؇r4@3>o,HRrt*Yh/$Mn2(HC i VLݼز)ؠn/`uR@\"%0t:7` g(m$\n.f@pƏȔXg9\0;n\n\Zb<[o/4B(5yd7@zGj\'>/aQ>\0,Fz1\n	< y>\'3ЛÓ/wAf\0d\07fO^y@ukJQq\040\Z1} A1m$۬M`Qn^\0]\09`&0q0e@\Z}]ydL\n\n	e6i@NC\\ 7J@o7M9|Y_r$yjܻ3o@ɴEr7trHT%KdMyh0r\rr8E91EstQC@hd*ФXh\'n˭SEk^bCŴ>ѵ e;B1u:;Bv(-\0gdA@&eGc\'d\0\"Y,ko~7)Gn(p?6&{9waRP6EY%I3v\n)F9PL0iFͽ\09z7+\'	0\0m	uf.\08ԯn(sTA-\0GKA;7u@iѴ|6#MVGb\'@P\'I\'EGBTuρ@ K5*[>Dρ@JD	 r־$J\'JEBH\Zn)Hm-\0h숟jLH\n@H!i@ҴkmArEt\"Z>b0AX\Z\Z=ÀP;7R\\#i@$(|i@jI){j^\07tlA{OA/j\\eZP4`h#Wi(h1I|QB^|\0^ݴ8y3BF\'Byo|Y?<>\0__C2:v`}TCj}x5@Ŀ|}WP\Z}TW~	P>$ީ~	XSޫJ\Z}TKJ~\rP>_TCj\Z}_TKJ}TW%@߂T','\0JFIF\0\0\0\0\0\0\0>CREATOR: gd-jpeg v1.0 (using IJG JPEG v62), default quality\n\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0\0A\0d\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\055o)]b[FJGU#(ˑ`Y!BU2&y=h&vi\\V<z\Z01\0a$H^?j(EF]Ė [-{؎X{4YHrc>V{d{:VU1lt$N=iJeyn0ĩ\0I$}9Pm Kקs)-GspZlmteF=q>}\0ZeY]w9&Mɰf@\'B})ho	\\ϐǞx!Kx#c_-TAz^HI3GHQ9N}IIg{0۳{d_Z\0eVk?V;tG{mx0	s7#чs*KƜZZϘb&E}yXBC+#BB\0#d>U9?cFD8VN>O&7peb;dn+Bxe^ݚf8c~\'ިG5S9@n:~0GSibc<0Dd})me5/1o#pOEuG$&c^=en	 }y_cPpe.\"0w8Fa<}*;eM_0*\\$pqznmSG-ĒS|t>i2#h*2lݷc7@#,J28ݤIm26Y<;mۓ{oΣRcI8,=q}q@n{#g\"yvN\'e2Xr။Nʣ`F)#I-\nB(.(玃4TFvQԑ?Z\0M4$/#t37/	ZHH8\n\\烎Ӛr\\\0}R5P}I*	|ǿjZ<M|1YNp^}b;KmLn<OJgb#u}9Ks4~ՎE+\"rQQ9	\Z\\\';,Ns$w=(C2f=vѻԬ`D9#$x|vxco4QD6eRjFxA?ýd]H|%À>IF0?oo\rU:BC<@F	|9<ri\Z%q~m->Pj+)Yٕ^Ikw\009lgovK[SI%WwMcŎ\\Jyp\nʵlm2I#@B_n<st?NʎF=:EO,,HgPW=0vGMXU6]\'ٞ$^7HpY*qڲ(=yd{vVh/u	?yʤI\"ڜߩ\Zl;ZrNp=2ǽ6ܡ9cl#,3߱^<qlrzZ/eW!;@\\@˶LL6F[co=y<-ySąmc0?\n	mHW\n}##LԚk b\\36N\0#\0{q@\n!pat J+ԃMsIK\"uXaP(^8v!m&ՠe9q1Zq$cVbmN}zc\0\022iwϳsyp2p\'x`2񪼉jg:c$ъGBx\'S>{`2c\"ĭB2LQ1GET[ Oם[rT\0ۼ֊Q6so<8\nYݽ	9Dh#P26?1ֱۈ@pL{V+Kp\ns=?^+#FIny\nҐWRM{ye	q5apH~D6,F0?\"9O#\0B;i\" @E՜wc|ƣhZ9\"\",\n sL7:)Xǧ^ր|fyC$av:\0㊜Io,ll\0	;~?U|W<c:Ԃ8nWr)\"iqqO?C?Zڜ͑m\0)dt9JFg-@Nld \0? {vePI	ps}	Lep\'\'-+ofYC(Y\\H|\0xOZλ\n#N{}(\\^qmn~qqn(d;VX#EuGR\0E%\r!R\0j}QIMƊ)zg~4Q@Z(	 QVA','jpg','charte.jpg'),(2,42,0,'Retranscription','text/plain','','Sachent touz presenz e avenir que en notre court en dreit establi Guillaume de \r\nRezay de la paroisse de Ceaux reconnut en dreit par davant nous que il a vendu e \r\noctroie et encores vent et octroie a mestouztemps perdurablement a heritage a \r\nMonsour [] de Vernee chevalier, a ses hers e a ceux qui ont ou en auront cause \r\nde par lui sept souz e seis deniers de cens d\'annuel rente desqueux Garnier \r\nMorin li devoit e soleit rendre treis souz e Jordan Perier quatre souz e seis \r\ndeniers chescun an en la feste de langevine sus prez sus terres e sus vignes que \r\nles diz Garnier e [martin] Jordan [] ont doudit Guillaume le sicomme il disseit \r\nlesqueles chouses sont sises en la paroisse de Ceaux Desqueux sept souz e seis \r\ndeniers de cens d\'annuel rente de tout le dreit de tout le destreit de toute la \r\npropriete possession obeissance e seignorie que le dit vendur y avoit e poet e \r\ndevoit avoir senz riens netenir il en a fet au dit achatour e a ses hers e a \r\nceux qui ont ou auront cause de par  lui pleniere e perdurable cession par la \r\nbaillee par la doneison e par l\'octroy de cestes presentes lettres pour le pris \r\nde seixante e deiz sous de monnaie corante que le dit vondour eust e reczut \r\ndoudit achatour si comme il reconnut en dreit par devant nous e donz il se tint \r\ndou tout en tout  pour bien paier e a oblige  audit achatour le vendour desnomme \r\nsoy et ses hers e touz ses biens meubles e immeubles presenz et avenir a li \r\ndeffendre e garent[ir] est celle dite rente quite e delivre e especiamment  de \r\ntout doare envers personne sa femme e generament de touz autres impedimenz e de \r\ntoutes autres obligacions contraires vers touz  e contre touz e toutes [segont] \r\ndict et [segont] ce [seume] de terre en rendant audit vendour e a ses hers \r\ndoudit achatour chescun an en la feste de Langevine une maille de franc devoir \r\npour toute redevance e reconnut en [for] tout le dit vendour quil deit et est \r\n[tenuz][pssere] e [oudit] la dite rente sur touz ses autres biens si ensuist \r\navenoit que les dites chouses sur lesquelles elle es assise ne [soffesoient] et \r\nnous ledit vendour en notre court  en dreit present e consentant rendant quant \r\nen cest au rente de escript et non escript a tout privilege dottez donne et a \r\ndonne a toutes costumes de terre a toute [decoustume]; toutes autres excepcions \r\n[jugeron] et [ condepemnon] pleingement de notre court a ce tenir e donna la foy \r\nde son [cel] en notre main de non venir en contre ce fut donne a Angers sauf \r\nnotre dit dreit le joedi devant la Saint Urban lan de grace mil CC quatrevinz e \r\ndeiz e noef.','','txt','charte.txt'),(3,42,0,'Sceau','image/gif','','GIF89a\0\0\0!!!)))111999BBBJJJJBB9111))B11!)J))Z11)kcc91Z1)kc{ZRkJBZ91R1)J)!cB9RBkRJcJBJ1)B)!1){{cZ{kZB9skZsZkB1ZBkZRcRJ{kJ91ΜB1){ZJ)!ZJB{kZޜ{kJ9cJR9scZRB9ΔscsRsc{sZJ絔sΜ{sZcJ{Zޜs{R9sJ1skZƥ{c֥cJ9cZB1{ZB֜sΔkB)έ{罜skƜ{sZkRcJޥ{{ZsR9έƥ޵֭ΥΥƜｔs経ޭkƔ֥{cΜs{sRcZcB{R1cZRB91kZJcRBJ9)B1!!ZRJRJB޽{kZ91)޽sֵk1)!ΥƥƜ{sZ罔ZJ9s޵kR֭Μ{cJcRB1ｌksRޭ{cƌkR9kJZcB{RcJ1{Z9kB罌)!Ɯkֵ֥޵֭{ckBƵ{kZB֜kR1{sZޭZk9skscJsZJ1ޥB9)έsZRB91!JB11)JB)ccZRRJBB999111)))!RRB!!RR9JJ1)1!JRJ)1)BJJ9BB199!))!!9BJBJR)19JJRB9JJBJB9B1)1)!)B19\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\07\0,\0\0\0\0\0\0@\0ňLQ*Uz3iң6<|ͬ7\'al&ʤ1\r%1T+L/E*ɩhQ%JܸV\'I.D#l4đc(\'y9)J\rߌ1VrdBIsܡ4N8wi&kE1FPBbQAP\Zf,dҪCV\rYhѤ5jMZS_~\"*x08Z>Q/Z$P9&hL6q4sVQ88%)\Z\r6o	IO)mKr I%cr!\n*Q(uFHiR\'A\Zqx&sQ~b,Al\0DSɒu%\",\'RɇAt1Gl@@7t#g0ܳeَyO;nIfcmЀ\03N\00â?<&B^ d0.i1i1?,@66S`JZ@+J@Y@jF+mj\\kjڲí`ӎ{=\Z/Ĳ\008(C\"7$ ?dØn \Zš6\nh$lӲS+\\.Sk@:;3|̳ͳz2,:lc\0,\r# iBzےf@Wd@2\"M`@+S\Zm̎8ڸ\n-o{7{m6>s>=:l;U[@ͪKk➯Ϟ\0(p3	\'3Ó2s&CC#wK=*+N,-<[?C\\e,t;x@C(cV\"HhH\0Z\0\00 M\ZH_RLB 6	-bǈA!f>Al[\0?l	Qe8gf\nݵ\nx@ecl`=3́Xbb7BcO~RW;\0@`\001\Z`PB\rp\0԰3!B\'hA`,\'Nj/xN\n-I1T\'?GUEխҋh8zrS;]h<ԡY,{U$^.\\3\r1i\0$T\0a!Aa\rjPC.ƙdpHB1TC\ZiLPX6ɥ3\nfPdQ㋫SD]WwmFǨ\\\0eGc^\0dLɬjS3pƵ,sU0B#hą<\'IZpBz0\n3͟;@jJ)\0[*c)EWN8ˆ-Hˉ0cWzx4Ecwp.[+JULZ4Ed:s;`DDpTplP&\"q$aU\nTuXO| ኢF9ĠU,]SyEg#\Z-(V|]`Xzuh؝9-sM%!6q\\1Vـ7BrXb \nà! Lb\0@d(o܂_AW̽<n\Zb1hD[ɳb1p8V=xbǸԍ*W9\0Ꭾip\0X\0@bPĸ}`(7Kp.<AOlbf0*̠@+$wdPT.E>p2%[o17B\0~XwB1iUNs7\0\0C\nRMQA`&@1\n\0hD+^y,8A$pbv7,h\0zu+V\'e킟R{98k*VWr@\Z\rF0o\"\0<.ZH3-ܚw߲=SeV4\03\0@@>`%PAW@*F\n4ZP\\UBh*v\n\\a	E7boF7ޔb]-kU{LSmTЉX58\0\n4P\ZЈD$t$84~-N6r۪M#/q׻t\"akxk-\"ϣ(*\nekb6Ph8#Y\'z7\"32J/w˝P#j@0d:d{X<Mҿ!C<뱀FGk\0۟OWҏ:vh.)ȭlY6fV!VǝxuV֑\0r\01p6\0p*\0h\r	1\01&( ( )(P@1p75\00PR	\r\02\n|\r7M0VPq`؇zqwYuq}Mz\0z\r5W`c]WDsRMd:DT9$-A\rݰ\r\n r\'ʰ*bou8\rC\r \0@z\r@爍舑@p\"\r 	p\r̀Sv	JpP0\0ې\r@CXpIPUGwqtR~-\\6QxШKc8Pup4R?8xS8 \0q\r0pqև\0\0/@?P8)W\r1pդ0ހ#@p@(	\r(3@\0\n%	0=`ް	xpv	nQ\neyLz7עJPluP:r\0W]cVRdCfh~*LͲS(0\"\0k\rio5\re W0В\r/\ry9/ p0\0p\r\0DPgYa\0C\00/\r@pt	v@g Tx\\@!3QQQ%b$\\-̈-\"_}x ۰t\r t?`p_Ѓ	O\0@\0cS6ސ\0I/`\r/g6)\0e\r>ioP`o˲>dQD:hoVy@3	:eE6s\0u3ED4;yqH\0Cz}*@PG\r?	y` t\rۀ`	3\r(̐}8@>TG55SB2V	uY*h$]uUK[K9S3hU:@.j<\0x(P&aSaVw80&>$\0\r`\0@ pg.	@*r\r\'0$\0\'@/2n\'^uYPԨ,z@u$43QQjJ$֮,wS\0W|KAS0\0zz%071o	\r0\0\0!~xE-@4x-ծ2h-\ZPjK%WJQ\0\0~hcc3pPbըd\0v-+;\0vMbvG\0g\0/@D\r\rOEV	hc\'vpP5\0\0#RLڸX2~7\\5S@I;׺P<E<:<]4WV4<ƭUVaEjR{2,2,r2M8kݐ!Sj\Z`Tc	bf)Z *fPd`ŀ7.z2LcbFI8\'3V҅]խT4&eQ`QQzV,RqfM`|g|הA v\0b7o	ko<#w\r\'gr4M;-#n2XS\'åPز0@JE5F_JR$RcO|nBt0ocuX{rwIzwB\'tt=&bRMX+&*Os,r+U7-Geƽר7+:3.be\\zE\\(9]!]A]A]c\\]]r,\r`tJJ|<\0mb&ms/g.2A6u$-?S?#j:vDO4\\\r\rny\0@FKRc!BK3\0bF$-fuv4W[MGS҂*h2#L2K4DuLL3X/oId:Yv;K|Qw=RwbxJ.5^/{\rѪ|x=@CX	E3W]K?K]c]V6d3eբYScnҍ*-h2?(3ёser\\V6|P,PWG].8&\\\0b\nP	QQ	0	\nq--%1uCQa  1j\0l0C%ko`0,Q	EuucB 2rP[%00B	@%t@	n` [ zK aiNieb?O@R\0G!\rTaشؗP\"8%ZD\0*9`	\0e`]	AE 0	\n`TpYE ܭ]rp=14C`	]&Pepgv	``wV	m	B ,(Z@^7(*Whu\'&X{/U+f*,v@2-hr|^|g@qw& n00{P;(u37\"g|\0csoU7Q2#<l(eLȤ6ͮħ|hu\0S,\"̿mI45ʶ+W5\0\rⰘ)ks))\0\n87#>)8Q2>o?2XFdJsPcWąXA,&<mmN52_Mb0#π6v~۳= 0\0\n=p\n>388Mֽ2e͎XTѢUE,Ǟn&A\'_΢;u&0(\Z\0\07	1\0\r*	J0\n(f pY\0)(@>po#-9|8\rh/s?sQ3A%4W543:\0-.+SNk`~`u\0\"tP@\n\0\"!`z R|\n@\n-XV`?*DjXpzSV3y:KLn25x|xc*%?h$Gs$w\r%$0\ZGPKH\Z$\r!ODV\n	KFE	\\P{p@3\naϴv j\n5:\"5Ld_KpR,	dW`T @\r40QāXX޹\r @@\0]F`֨Q\ZMfDFMZjҤ%&Y37c%&[I/[6W\r[wށօ\rvYcɞg޺zx5p\0]ȝy	^Xṉ窛7X`uH+:`Gv!\nLHPٕhb d\0(c\"&̗L.xyԨ%\0NKshJ2͘1r2B\"GNO]Ŋ,>Ůg\"yv[nl]77Rl0IL\";\0<y0**l!PB(|\r!L2	q *`--(tMd:#$#dI*@cSIO(\"+Jʰ\Zk,Z.;K>+O; s2L-?4,flh(`3\0h6pb qdSMOXLbK6e26qW=Zee2!m\ZjDG3HK͊U/.M3v+ݫ/2[[\"֠ݒ\"tA64\n\'r7PHsD*\0mEwTQ)yCvňb<1Wg52PUvŵhd`ITm4t+|7j,hBS[l7+DL6iE`2~N`+T(]	eF-FKfL<q\0 \0\0 b¦\"il*c;=Jbn=P[R:Rg 7|s@5啺 ETKӶنHy	W6qaQ/gf9+L\r/d5J#{IHZ1@b-zfcX-T1TPEVNI4HOeUT9%moY`H!nƛ׼1<0nqB~ HB߈EpX~ 4LF~jei\\ᓻ!&j$J\\\08	`\0)ZQ\0Ƒ\0@X@7		\"s?&2B` A܀`\rA<j|#f0C8		g0FP0\"y I;D4?pJ&\nME>(\"\'\0m̥[L\0*59ʤJy$;Td|$6ۆΨno`3ƳFP<cxFEƂ$9\rm2710BND1	\nhB\0H\0&b\0`7654(0E\0:hKN27a%+:ertw#-I<(-+r|h90\n\"ȍ\0lS̜Lw?d`3D0p:M`ad\r033^X	@4aZT)	%LK|3.h(,Zю,NA˺D,+!YԮVˬ$n8\0f!H8(\rb`%fAq3^nW\"^ ?\"AaxFLQA$·X##qx(e\"!X9v@VdyO1Q֚􂘾09˗\"zɲU@\'1\rHQ}:n4@\0#!`Z;pd	BH{EqHDZu\r\0(h`&I/\0̠_6@;n\0a%hAv\Z@+xvLfW-]K&,1K|Xb%`i\"RzȠ{F8\0}×6\r7 D6x4pk\Zq\rc\Zp\\ xB0f#\0E$ȈH|\0\0q6ްE%?<Vf34g?XY\rgi!pҘ۟/-W29\rJg<@(@6xb\"U6ڎRX.|kmA\05`3,\ZXXgͲgV7-8f0	4\n-hz},(D-Is5!B0PpvP\Z g)V=D\Z1<>pnSAqVj\r{a;=ui[`$\"Bx5>R{$!HK$[\0 t`@\rq@1LgtΡ!D Cd?!@!\nˇaaӐzvKZҞ/yyWԠ:=@1)t>`ə8ڸ2(5@h\\lEȅh@iMԄ;Mp$%R(Q؅ɂP`\0#?+Cz4Kch>K`xơ׀ۆ9{H1#1 66`KGhЎLP%hKAP؀7z#gȣТ2\nQD{FC-A\rpzS+Pܳ=3B\nwÌyn!n9}p+#1px2|\0IE8f`|_F`|5k1C14±é\Z⡗,.ҢY\ZiǓ</\nw?<`Šhϋ$Xz	4aCz%Rs=\n*$n]<-l(@q h1Ͱw!ty$B =ң0kBI<9묁Zz Hn!Iș$?,ʒ,ԝtaGYˣGyAu = uPx~u`\0xL0{ܹD\rJU\Zw+rsZLKZLHl:TYWēkC4j8;B!_IM,=	KXLޔ=MX37|C0HS4w;\0z:Yy\ZɐE,O[SuEAРLt4LVZLs|LM\\v)tDu,iF\0	uK#伥Øsّy0]Oʟ1p	GȄ//JI76IxG!!Q]\Z/\00+\r<DL`R=6h6PfxKK)\0086S;\r1Q<E(%-\07Cu70)KP#:LЃ!X4X>\03\0>0\rP\'x\ny\0h`hi@\\hdV`U4uIIpJP957X\n9HhMq)Q]/R]\"#R*H!v{QxK7\03u)VJ5\0I5`7CIR<u-E\"`R~=}Ճ16M80JXg8h:8+ЁP>X\0\'\0Z% \0PȂYu\n\0n(Я\07@dU;P\nZ8ԔJӥp)p_K\0K\rzzV*b[q#VG\\H\rRyW+V\Z77FXh9J\0f]#8KӈNNxJT 2<@}0c:,R`<X>@<:QQ[襃9êN.؂-.?=1&Q`H\0\0P(AOИ:x6O*&QEUA a)lAL+\0#؅v*n\'#A؅b B݅`L#BPP0rBg`R.`B0a6aib`\Z`-(g˩JE],\0	ˉ90bˁ\n3s/07ֹ3@@^Dʡc<<FmdBƙB>d\0FBJO3\"\0P#A\0L`f`bt2ŜW<cbLLqCа̞37(k!H.C1o+N`b.b\n	*f8LȀd1b1S:NV^gA98*գ2aukP8ʩJHVC\0#+AP\r>b0oh8>ًcВi=L>Fz?)(G|?i		h\0I1h\0v 1C#*\0q±q+Lf `O+\0`Pz%~u|Ntdȷ.1|LHJGp[<^詁3	pHPۣHBҶd`K`sk;;\r^r#@nec\rA^e(tB\0%)\0Iذ\Z=\'kodbNmJ.JvasH\ZaPܡP-/Dɚǩм~Ny!oUVl&	 [:#چÄD #)vӮdqP(C,ܶ<I)(?ɺrp13J2G1U^ D-|nxf.J?0\0-v+8B#\"ϳkot\\I+ѝhpĺ\n<1<h˳ǹ`\\<d{JAh\"}/]Mh1ᄨx7:O% 3؅c#?Fm֒Lάt˷p:3QhLTUH8\0G5S0Kx4鍃<PE;NP$^ó<mM	MrµK\n͊vk:i9%;hw_)vX|3?VoS6XXeEn\nZ_N0S8Se[Z-kqkGIw\nxЏIˀq%ؐy,ԡГ$Эkui )P	EY\0;|\"\n`\n`5\n_ZPX3e4	!w,d\n>:D0ΣpiyaǘCώp\Z(D_YK,ⴇuHB={(m{PXЁ<Xzi_e7@S+T=\Z|d	4o]\rg@\r;^6Wq]ǐ,9O#A$`y9z5I3^vB+`\'ѠCYTР\n|*p\Z@դg^ @2\Z3KG`ԬVՀ5,-`%Xt8S2×!z!6Hph#m@ǅ,ԼQc=@	v-C@Mh\"pV5\Z~\0R>\ntSF m,Yh0#rQJQ&aQ#0rXIG(s̡	I!Gu`\'|d`e\rg}&hu@}ej\ZuK$s[ILͣ:LlΏ[]UVE5xEU\n5h@pYh\r#F_2$m4\Z`pAUprIH,J@j@F݅a\n1\n\"AQl)$#H-n7&\0K7HXWM\'UTagTF\nQ@^WBG\0zwDPCr|Q|Q1440ؠHZb!b?tYA5)v,9jAe);.\Z0O9֔J/&GkE)\nsQCSSET$xT!9V<[|ebfQR1F%k!!#ACTiĠ6Sw\"fB~vA-40j!$!\'J[p2Sv?bs<$+1@^;\\%\0: /T肃/`BL#M%db&X:뛔Aehl{sȀ+Yhڎ :h򢒊#p8J/VF]tV;\nۻ\\7N\0?XB0CDO\"B~b4B#4\'\"2Z\0Et2	:Տ|!5\r@DD&U &G/A@hr\rR\"گc!f#,c	@8쯊[A3(+\\a	L.h]h!f؄f7\n3J[نB\"	;DyPցD}R&R^FtӒYH^\\8ޤ$%dM$!\nXi\n(;4PRI\0{ R\0\Z\"B\nX-c !3`Ɯ	10(H@BA]i@JWq%\n))Pi\nc/Q5Mt\0FO!1jqIRB* nd\'\',js2]t\"$\0\0PT\0~EdT\n\"8$T1y\'ltI`(DUlc^)*t+VڦO%Iqۿ0pe8m<?F6:5PP$A\rT	=ȭl+UmR;u 8\0\0Ai q\"WC)DQ\n<h*p>P*pWA7	F0\"R;sv۴6o+WzVGX6X< A\rq(`|\n(\ZA\\FZ|\"\"05i(]R	TVb	qb&J0ĹV%h!H0\n>DHHC+>\nU@8ZP*̠?,UmjҍX8U\0+NqU收Lf*hMqXı8CĂ/PE\r\0h@ø}@$Z):y\"\rNH{nb;\"t\0M26AQiB\Z1BB/V(!gz4ȊS5n$g,Zey1ж̥66eK\'$n7807jkercL+\09lúƙ\ndҁN(WCeY˙\0@EKT\rq2^~.e&Xć\rr8Ӛf-#Ze(<!D07#5`o\\݀,`K~@7daC#p٭\Zh$\rT\ZsɜUĆ ,iv\\p<Fj]3x}zozO}\0*\"~I_f\0(B6LbFoc\0۸3fXNp*\ntE\Zr&Ke\rb\'k*jKbb͝{[ʑZ3#Yd7ݍkC? !mӷ!Hh(g780Avl\'9l`F\"	gD\04\\c 6UP`+Ђ)F1X7E`ĩ:$=8%n}C<+ ̞e<12ȓ <k1@Ā ևS Ğ6t;\\!$8$@ \0!(\0`0B7h}\08_  !l\\0_؁(h-|ku94	-94@B^P`8M{ܕ=p㠃\0Ï\0iik)2B:9U``C0B,@7յx &Ă<05\"l&` @ \\ ]\0t |\0&97\\\"lП4\0C2AA-(aaAjmJ(r<JC0hܗE9#Y@FBʹ2@,@Y\0`6`\rLN78C%$3@\"04\0X/5l8hCXc\"$3 %BH>6 ɢ2dbd \\l(Ё)A3t--\\3$ǡ،F,\nM@$@ &5[U=:#JN8<N+-@& 4#XdCC!C7\r(_pU63,6xCIZI*C, @0%5$5B1B$@$7h3tC3\ZD_(C=4$7$B cXA\Zx!<PRFX6Ȉ@xYKTg$DQ4ITC:\0YL\\\0L,+icf%><f$C$Iހ3@7P\r@@\"$\\a6_\"\"@7C=2$ a\"\n0> a!0 <Ð\rN@03#h\"$l*́,ĀD0k4	mHHpHl(RId˥FxNL#		ض!<U8CX eŀSEy$3\n\"\0\nXd\\_X8de ހ &l^\'pUa#&mB`3DB(-3pdX=%\n<^DaI´PolM*	;\0@qB1Ֆl!e88\"Y%@Y\"@!@6(3p	;j6@!>XtC6!e68\0Vf$C\0\"81&l\'I7l7@G\0R 9\0\"(\0BBgrPIDw|ƆKlwN)DJ-kYP7,@$@thy\0_eURYe(@)\0& fzוO\nł )& j2Bkf#@17!4^jZt,6M	zH\ny`ȇ,`\'jDbxڣՈVLHUT5+\Zڎ`7P`2B0 `kDeVk9@0\0ª ,!C!\"\rL\rB\ZAP$@ ek\0\\Cܮ*7Ū(rF>pRmBhʘXzC97\0sB\n\nB(aB!zZb^6DBZFt_aU6B$B!5!\"Ʃ<Gnї6nwZ$Dznvzii,hQ0)\"z>dA[)5QB;ggVeLJh;yXpH꛵5ܤXmNyEWEy\"R0\"hTkHQrċ-GDl%,#D9$9#hmC\0gdG\"	=&R2@7\\1;Y d\Z6Vh3!qD°D GJ ofذ$=;@9Ҷ.N -XF\"(2@$<O`\0!D= f7XS$@V)@8T*075ESxj1\"kFcg=C=I4 Hq:toCit\'pL\r\n\"2^%t9k\0_n;Y*\Z3du!dW[8/y	7yu+.[{kln>ļ\\xfґ:[/yBX+4\0O\0zA^p3l6\0DA.H\ZPP1@C]\\1,Yi33lP\rv	;-1tܴw~lh>\nHf \rOOr7L\0/=i4EZqPؙm,uw[0DA#\Z4C.7`yc5H-\\%̉$,!!$3$\\\\ŕ[RlcGP\"2DܶEDIj1p*Ձ&QGaX\0dD_Ub#`@&\Z|\"(Bx+_ \"\'h|(ԁ,--A۱4sLE9=A[lDd1 [\n 2CG;Jz-\"J4y4ԪRao@\n$TA &9}$$zAiA\n4Zd)D-ApYyV1-GhMAlHl\r%mȍǅ\\tzTP5yWMy\ZTiq331\Z\'@c]WB!̀!du:FsP㾳NG\n̎)mPUT᡼K(*]{\nPYFYDq\'3CED@`܇uݝǻ誮rK!.+W@tțGj=D=)te5IiG\rpyMӆ6#σFq:LT\"wt\Z]L+||i?@3B}ݛ7@\\8}};MXSw\rEV9\0R\'u[l[76H ml\n ts=>J ̂7i0++m`Zqۭu>?4QCuMRCqPy<Quby4\rSOJ;4JK<3;?ݾc8g6Ν+𐀽I@$.p#H\n( Iȓص4%K-(``&Κ:q3u5P/(Q~=hP::UՊ\0y`d3ԧ|Eq,@[p\r\Z: V,7XW1%$G@6(3ƚ3?eg<sgۜUOi\n}5mnWEp֭^U\'{mu|n;b#oqeEn,=-YL߾=l(J*ݬ7誸²ʫ**6p0>VD8\nM>%$:ʹA&F)*ZgĪ\n!)RB@$j*)I>s!@3/;6434(+1#$iJr2)˚Ȳ*/Tkd!#<JTɰG[Ɯx)3\\鳑&/&U\rKSO\Zm9]rJvKM,.D4*+\"*2nIyTI(0@?zU-יtiN\r8WY#\r^]sV煷4=7_v4u൨Dx!\nb=ry\0zjHjy䱖䑭exg(Gc1Ɩ֩)FuvO?\0yh5Vo\rъLgBr0Yޙw\Z\nH#UGc\'JxFVW^YH	0J*$JIژ6{p\'{ţC/{01$Ȥ1DDMNY\r85คvp[0{A$9n|IDC77tJ^G=*8;88	;H#P6* \r`D_h\0dDC\Z͈F5Q@6C\rTC(a8uF\'ܠ8@\"sC&q}0]Po;1`\00ԡb3!/\0$@741uqDǆFPlx\ZGaw&$X(!Nc0$$m(h8C(B1?AnBD=,\0\r(<3,a	Z(귁\roO_f0nP\0$`3@i8pu|$$a=Iāq%`\0\nT oCAhqrya~(*pn֤$21Bc1@]Xx\nvh0Z\'E\\򲖒D`1Hq`# ڍxӅXG=э|	6hbG)1MX 	AI\'xORT,  ЉN-N>p\ry#PU\"ls\r:`nnv;加/lNsCXoUKEP\Za8OT)zHPPBu F08Ĭ(P4$%JuU\0\r<<4\\aԀL;l Щ7H ;S8āE$DhZ\",A\n\n\0i7bu$B6)DM{CiD#ZK0h{1*pRa&><\0qpAP[X`N!	Hpu-d-xOv\\\n`~FlO؀bT7t\"XBQBѢtB6Lb8֡b>bl,a	su@*Yu@XL[]+L̝\rf#B6Doe`>\"XyL$~AT\'>Va$C <P\Zxj*V>[;þ*@g2LeЂ0#W\0&,`Ƹ!q+`ֆ&3hLнMo7:u,gb8B	u%@9[eط7	7c 3	:&1`L7.\'BA\"1 \0\0e­1@: Jb#T;QHyT\\iOWRw\r	LmɆٮsmعѭ\rF0bw0tp 	<\\Avr\0F8 q8@H\"`\"ۄ|2AbGoO\"9ҡ[&%ae.<&=Axc4Mڂ3\'+_|W>oʿ@\0p@\0q&plw>F=Aob?Ww=!;\Z!@2$@ -lO}\01:3NҮO:\01;NO0D!`b@A@N:Mn&\0Jb2(PC$3\Z\"B/$4SpB\0k9ܸ /n;:\r\r0/a\'@/v>`劁`w\nMDK9\0=$;.DKNCHBX&P\Z,hq()\Z\"OXoX2c;B\0BC\0 VO`pA\0~`n`Co 10X.,1AmO@L/3qC&NV`1),@)9B*n#\"4*2\")R ( *\"-4\")#/$@\0@fAAv2m]VhULU]% 52*r$9);f\"rB<2cC\Z\Z@~%_1j\'p<a8)/ATMKTEU<d)u\r1YWF,SB*e!D2#d+p1.+J=<1R\0 f~ b@jıvt2O!\0/炲<$^D>U3:AKNbN>d\"FT:0*6e@2(j@HR#P\"0\"C#<4\n?3]3%1 !~54v!A4N\nAڍQ)$3N:eE%V1)S?V1gff#(G\Z(%7r43q\0+*!c3\"^sfNr`@4\nN!ȮV&t:-T\nS$TKcB\'ĎUX$<-,\n2(H:3F#f125+p\"$*5%CA\0a!d.b \"ۚ069۸\n8ӭ0/)GB121&>r&g|;y\\n2-pecG\":#P9Cƣ+ao#L+-4%e-]?!7@IK5@Kx1ɮ>TxC3$dC:\rg`MW:jа[?\'^&)),q\"+S=S2b\0\Z@HOncm6-5~ &[D\\@!B`/NKf^9F$dDT5dOpDWXpSab&)\0=jMDsEB>[$Q2\0Vr86tdT=֏\\\n!fZ1oY5E&1heiv]f|%T|_W`he^4r$H64Gc>ۣ=b2CS9~<J-Tunng/ o.Dv$ޔW>txOΰJbiu3YBRt<bO\'s0<8Dsr%a>65醂@vƵna814yŐ5v5biwf$V\'i{Jab!6B0=ws=7G$|	@tw\0`\0\\a0H\0@&+\r$2AwsO-KMNV2?EiFXS,\\D@6vq`&Q!33>Y-GS% \Z\0\n\'\n@6abaVH©mޱwU-ִ1g 5F4F\'6SffyrBE[@7\0c0`\r!X`hD\0.LAXSՂy9y(Q\nv O_4!EZ89CV!D.W]\0@\rpY`\r@\r`,Ī8Y@ %~MD{5擉E*uD)EY%33sG^TA8\"H ER^E`lǡ@Au92@j\nHjʐŰ=g:jv@uWh7zNQ\ZGS3W!BYG Cn:^A1_:0\0 u!ڧhIXu|\nZ5da0F*%_\rƂ\'B`d*vOA!c%H^ES>DEVm\Z:.Qp&hu\nA\Zj;H\Zau6{ux\0ICZcoĊ=yW)z+rD*Je(FS\Zl(wQ8YD%^#졯2\rS D7\n[x\n@` :N|J:\Z!;K2\0\',@S0q&E)GlV9Yk~*Q\\z,?z_zVVL-pM_-\"\Z6m\r\0E<!\Zr!!\r  4[9\nj\r;؃da:pzF7zE;X%!Ÿ@\"H¥bcA4f^BC@4U4&>K&MV,BF5a\0p`;46a\0!\Z\Z4ůtR`#2i=\'t1Jj6EUEz\"88}!87,e}n^`LC$Ub5ފ1va \n\r\Za\r$Hě\0t\0]\Z!5{`\ZzoK[ǭY5 BC!B6)d)7l^j\"7)~+1oE:<4*;e\0q\ZٰFp\0ʻWǉ@`aY0ɐ[޵k-6l;35=7ց7 EA|+\\7koGcGViVEu&q=Yx\0!o	*qn`\r!^VVuH$ZFa \rFzS;@`et ]fb\"ͳ(}8]R+rb[(g»|s\nkʊA	67hk\0KslSO6a2Mĉe31#lӨ#z[w\\iu`δrM0RO|\\7#0-𴀁P:*u*;:&^WvTأj\r)0R)G|J\"`n\nwr3%N9TIDLꈩ*E|+FrHֹ<i:gY3:i^9\'+y	!0n7LxU6T.JV+ҵMw\n:שe;G`\0e082U4iL0TJH3pG(sh	m$1Fz!GBur\'<lEtH%aZF4DPQI(VL&rZ5Vlp	uͤSnEguUUtOIsY1eXQW\\lB\'~F_PPsT	oQqB8CRh%\"jM)H#YN$N6c@bGFTQC	uQ:WYgݔPI;ERTFBהXd-坕Zߴ\0:\0!P	a|EyE1^ulIf}r&	!DDB*i\'D-yI@&[N:}d#mʭ\0WMTSQUUt\ZuOTN)eV[W\01l2엙 [.8D.Dq&ze5g\"b`\'GlܺHS(,\"q>5Lyblđ.͸N&0LTFڕW^A0WMA]fuT[\rN\0xb	:x8l&o1aԱyAe:SA:\Z|7F`M҃F/6]SK3=m?$>cm\rRR%Y7Idnk$Uy[8@/t)F_D*[Ar|x	T3+\nUha3yR*2\r$#Tjpī6ھhRݸ%*MQtjGA\02(Hb$++\0z%\01@㐅E 0/O%0\' (̠9uHA:YT\Zdx\rR\\\Z3D+ZLxqJTb|\nWJnaZհ<R@q,\00H#\"\n\"0\n)aDJT0&P26T%<rʸ49v$Yx^O2	@<𙜢Ƥj)܉!-»{@[ć	T ON\Zш>!\n)2(.va~zb\'TYU<\0\"#%E,1c5SEŬL<̪3ry>]-欤$$1LZ$ЎG\n ANΓe\".2]\\ai\'1MfP\nZC%u)Jݕ4.6j8G5yѩ%\ZIah5(,Ԧ$ٰ\0VNP\0tJA1\\@eY\npiJTH6[-\nJU˕.9m\"\"`I&fP#+~5ZP{\Z<.\0Y#>C0WN]Q1(6VVM	V(+3bx]CEC\'\ZJMmjT¸jVHU[Qő\r8\0\rvf(g?kA@V=A`)dP\"	*xK	<03\0?C*TjUb<Fp*h,He\"T1]EBK.g٣\0\08qE 20J@\':W$ԡhpk9hHpfyX*Ǝi :7\Z`;cgx (xi5aMobV#Nvǋyֲ\0.^_`  &pbc~[4&=3ȏ|5vooP&k먲\0^p@\"!\\yP\rx0I1̈́1L) KcC\0hGq,e\Z\0}e;I_dc\'.a;\rd ~HnJVjG;>i2ulu\0sc1C8``A\"\"-(M IFϧ7÷\nU`MKZI;K\\\r\nbPE,`C)P:(pQ\rG*|\0RqJ\0{%/v^\Z? i.c^Ģ8$\0\n0pFEH6#MF1K0ف`qc+|X08\0?u  ?eT Ux>}\0i\n؇0\r\r	Xjw#i~VlR(TGxx^\r@		6\n\053\0\'G%(21FSBCdS89>puW3vaK@p}if\nO\nB\n<}\r0\0\r\rw\"GugpvAx\0r^\rX\r\rc\0\n	p5^\r\rJ\nbyfMF07R1oeg;vSwnA>ȈS:	\nOهPZ\nA(Z\0\ni]u\n\rզw7qXxcv!ǑIВ5?5P:ɍ(W-=M].*H\0 Ii~GP8Ȉpj`0\r0\r\09\nY q9b)\nJF\0H78UuS9l7luC6\0\'0	h. 钟ٍА\rj6.P1uao~8\0%\0p\r\0K0(p\nfyp\0.	0rXpy\\H?sӐs  \r@0\0 8wxCB\0emș(=	y-X\ra\0ـ6p]DqHK@!oSTzx}\roP8>ƈ\0PXP֩РVs\0K3У\0Ax\r v~ K݀)Yړ@^\04ʍ:	#7tXt $*R3*nM	Ve	mXo(\0\rf8\r``34\n?ɑ\0f蹤\'Ʌq\n\0:y\0\r7\r&9oV\0 \0\0 	d*\\\0\0_ZZafhj6n^r=/X䷧|u\\Z6*ȑKiC\0\Z~\nx\r@J?	\n??eW\rP\0? 1\0\n*݀U١	?	2	s \n,Вڍʍ(];jKZz;W+[+2Hw|w#>\0U\r\nZj0JV\00\0 3 yK	jdp@s\0y?_^ \rPI\nVPqPG`Z0V\Z	;>ْ[Ks(bi56aad4ScxURu0\0\n2ʩsP;E{s\nِpϐ7y `Z\ZPF\r\0.	P\0\rp4;\0@G	`M0v	w\nݨ!${Ʌ\Z<1z2Ng4Vr*u}9\r\'Ip4 \r\r9\rK\Z\'\09ukuYxր	`jWЯF0\rp\ryW\0	W͐\0`S	p	Cy+ɅP*<0ZS=qݔvQvZC\r%\0	=ʅJa@s\n\n1P9\03U\nyd䰞~\r\ZLеxTp̀	%O߰\00?	\rKc@QvV\nw	sC<ˍҹG: RǄLo1H<+}LiS}wN9$sx0@xsy\r0Ϩhx[\rYmF	>t+/0 	I(\0pPz/	J \0\0	t\0AJ(̥k!\Z2/l0vdM)=/{Vyn\0\0J	ڠK(\rRQ=\0߉G,@:JpPjŰ	@\0\0f`O/	\r\rp@p\r0\nt	 |@e!KӋ\ZxuL85RHCD}Xѧ\rNp+;\rжtKJ)ِp	ې\0\r?\rp	@0p\rI\rp\rx\0\0V`g	@ݍy@A,5b0.Watcz́焕]G,\r;+a+w\ny	\r*;֐ݛʰ8\0D./\r\r\nQ\rMxMw=̵@I	3=h\'b.\Z\"4\\wES?PSqKQ+͵1T34\r2)\n5ɱ\nPsݰ\r:_\0L5-j\r@J`0݃`	Z:MOdʐӀ; `vv\ngP\nж,l.\ZB;0>$FXP<0@sϘ\rf0\rJ;E:@u@t(t\0\r\r`y.˘ޠpm`\rMT7p֋*0\0@@v`6\n[ W0\\\nƶg/n6 4d#<QL?4\rW4Ka%e9C,rgPQoWӨ}?9{1g~0P]{\r\0ÌѠsk	y]MpҾJpգp>7!.0QA>QGza;N7rqH;t3>R\0\Z	\n6\n\r`?P3@\r\rIDU	K~	=@:0D\0\0MZj	QԌH@(\Z.[u\rtHǊ8Xw@JNxQL(ڼȮMv6,\0E ۡ&֭[b(pMP6A	/b]m1zc\rFm\",Q\"f?&jbN`텑AW%\"4Զk 9fv\nȱ<t\niqd6a40oEr%KW1u!gӀM9u_`h;w`h-}8M+ϴ9`u0FBfHL\nL@y!&l\'HpB9@@0]n\0E!|^٦^`&\Zx;B9#,&d\Z	>H>M8~cikN֔).Λ+;h@o=g$mbq!ԁ\0\0{y*j+\ZPL4TY|aMq~uLwĀL(g14<mj:0nAZB\\3+7%5i|:e6;+j\0pCGՋe\0AnnP&m\'ޫQmqJmf#DtEqoPJ#\'L0QFrO#N\0o HB#=.825NK2:8Nj%I[e;v{I߰\nX!6A! odCIj{R0L$lvsykA$F\"b0um~a\"fsLsfm8\'<ܺ)$-H\\x:$ܲPlir;^xᆻFq@Gi_f+8e3gq)\0W(d\Z5|\0xs~!!ek	>M\nICϴ)І8\n0b=X;m\"E-ꌄ$1D|NNL4QNqc(FW8`\0o|ڈ\0b	A\nD,`@$ p;+\0fQF$vъc<D>؄2	d#iܠc4T@\r \0QF*Ѽ!1De5}q(]br22HvXh\0\n}ЗqϚz\'7193gD\"\0@A<;,І16\"j`.E IDNDoK;J/.yء3z\r42=uDl0o̴m<L٦n_ԗybŢPT9	Е凛P\0nX|d4abDF Ս?\0Q\"@EPZFaMp8;2HpM՝bǕEd^[JI{.\'%وEU\'DĚLv{`KG@?PfsD჎\n4 )	\"~ g#>\n `&As\r?F\0exīCZ)ٸ\"u[D:Bi=c&u0l)ac&&qeOmX\";:ᔪ\0/c\rm\nו7 \n\nXO\rm\Z\r(oŁŠA\rk#/ۆ=Hŋh +[*T=ɉ+okߌLֲRk7Oz2sHբSf8nY[ЄMD۰b˼B/\"aGnq	j^w)ZN#kg;.D5:S%se;g\0g_y6-**Su||Shxg\Z*alYMTakЎv~%ou̍;hf9YdEW}\'85pտ\"۲LE+;!N\0҃eϠڟCb˕| 2q$ ݸG$ļ{a=&jk`wu;iVVBS[Hۋ^m+w@q%\ru٬5IxqOJ\0wciGnボib\0	HDpUDq1D<x.=v潻B8/p8wqkŵ\rOp|XF6pKnC|yڜM1 T A\nqGw#&!{?:mq\"kyxuyH	38h52ȯ5)U{I\nII\nj57bPaë#ۘq*w\"\0q\nc7\"[B!:\"~&RT=3y@\037326+d*Aۗpm<nbcz`zpLHHP\0P\0;Q3S\0w|C:*7,=Z2t=@K]Tz08큉$,3=L7۱X#bXnßPCBhX$\0B\rЀiB)DEb̂ࢸ躔:\ZX32<5|,oHj:a\'$󀾐?\"\0МFp(M]0\ZIIMthpʡE,Ew+E*T\0뀓[2<)z	h\"TLSF|82&C%el8IIW`)ap\"Gh\\jji8\r\ZLxIh@`&:,7YڄEk3%$a\\	4H3)K@T@D\0\'BN5(NN{=ڻ+WKL$@/h5PnLn^\08p7+	xC LLIq{%<U\\Ef\"2\"C7%2PH\026L8!R+C/KNK;3k3?tl\0`OERȄ\"h\07N9[QX%3؀&	hCXU\\ЇxǺڐMS1A`/#H7\\	&32t	BN\ZѨŨKi8L\0F00G\05@fPfhEjf\0$[Ѓ1=ȄR4$;Q(`cs7fdP\"S\r,v419*Z)S<m,\Z㫎;@EJkU._;3#\00JTE5ME5P`XJ`N:% 202\Z,@}U3`Al)|:!V|J5ޜH!5xSS9c>|\nDN)8G:N)u505`6X7L2OHB0\ZЂ]V##K-N X8]]|E@=ʚN;aMVVJf@1C\n{mKHZM\0Mx}JJ@/1\nO8PB`P8DFر4\r;XȩsE\0^J	\0]	Q{H[\ZaVVU%,@	TX`L(*@9H22XbHS\0%4t$G.(z^\rT%.֙ ᴃs9tU8,=Γ5c/Kdʹ.B4\0hkI<jMdE+\0Q,X@B{cw֬KX47ج.J9J:P::;[L\0z\03HXF/ZXPo)q,_,^1\ZPPWPnHnGG`efX[Xdֻ%[G\"-Ma%V	MH<NI⬲b31C`\nK6b>?t\0K~~yvƘsh,b/+wbM1@V+@bu	Ys5W\'s\"]<SF@F\0y+9<hfttg2dx&\nKmiu=f4=bU4BwP\"L,R\\M8[YC!2U7<#\0-ii\0	К^_xz\03tTG-kIƫr:l0+5[meՉ*\"z,86\\Yd.bz084BβHK^N`[,>⸍ DGNN^GM6t<nqLeVƹuTRUbɇxns2\Zd&KEKجK /DHj\Z^^	g^m4hF.BZf,_i-F\'GJf\n#,m+ p\0|Ъq$8LYVcC(:Fα;_\\CxC6=kL+&T^Gl«%gNl<SPnŨ\'r/S\r7g61:^QNCfP73TGhB`I0pKCX_hx!M<nBtU^<0M%<n|-	qM\\0qhM<ssq\"@u\";OeFe\n-v;f_n:2O%[ è gl@k}:,Ǫӳ[Æ4>V\"	Љm,bi*gn(Ht2B)K3忖\"	pw#c5r2>oqE.<\"\\+_onvaC,ݍ%Vjn\"Wmp!7=[LôxP@^=Ip@u=\'k/..d\"+ߡ=vרjN\"!t3v\"#2۴=;cLaTC5hqͥK[S&v**s*|.*}`\rQcꍓT_SWo1\"7sJڟ2mؗx8^oq.cq)_B	5>NyXyxwX@f3pA\n\0Evx@ƌX\"H\"GLr%˖*Liƍ%bl!D>ktو8n]6JKz@T^E@֮ZiJUz]h֬Nm1^hpcϏ!QNtw/ߓ+i#͑sO|A\r:^Ьe.]WVyIQ*UU\\\"\0h\Z昡\rŨ.܋7o)dJyŷצ}УK7,^|gћ3[OCmz9y	g\0P>XGE]ETs%w`Ǡo-HQ<\r`UN	9BE!Ty[M:	i`w\Z@CE[\"瓀]T]J\Z$iF]U[L%ep	^)bّYchmGxyfyTW#z2nEX^UX`Ԑ~8%N6҃$EFlX@^*I-Z4%\ZBTRD7g:՝y5Y	@L	䟨>*Hs]]ME\Z&i$e6-hñL\0hBu\"<4^jyn%9\0e\"kF[[N\"In1VeFE\n?ma6LĄd\"(]:Q;넷;fp6W3zc<#W\0;','\0JFIF\0\0\0\0\0\0\0>CREATOR: gd-jpeg v1.0 (using IJG JPEG v62), default quality\n\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0\0d\0U\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0ȷ)ޡG󧿏=#(\0\Zv\0=M}|Bm{kN?!a:lCW}Ɓ( xێ:u(5[֒&vczzg,D[EűďZIx\'sY`{\n1kQN=?(?\"YZ\"\'Y2\0v<GGqV}^-{VfvhˌR	p.j3W*Q@OS	nU▹hW\0⨮:5RϹj18<UFfWXx#OL-c\r1,q\"OV另kƯ\'{W5omnhƬqE\0W>\"{_R-_iA\nH Nk~Ķ]Js;~ZBb}/xYe W+G4frx#ӐPnC? ׽I)PMyjG8ܬ=10P{̞M\'&|	uwڌ;d$՝UxRmH]Uce⹿[ęnYNQ5\\\0d`mvg\r̝L1Cy\\Ǳy\0Su:We;\Zql	s4)mr vwzcSR4NUbTsgKS$˘\'ؾ?XQb	%A?S;Ց@)t50\\r_r9e!#EXppO=VHXHم\0En,EF1܂9gӏY3#yq)^PH-\Z*\0dpNFNw~n>^بHY%_ê\0d\\H\0nTׯoi\Z$-AhN篡)8kM-N+2aGүwL\n*:Ԫr	5r%QZ\"l1㊊E4=*	 eiiU\0׷Cs\n˻C$cN\0^סxGᶳGֱsdGBs9x\'<t(Vk۲9[_͍!=zwNMQˡJA#,}kW<joǨByL\Z2A埌	5s#44Oc`	n.\n`szS`g9k{2PzzT֘HqE=I\\(,SAe1YlɔQZs%ctT{\ZrEUYNu$>VZVVI)n>1Ku;5,XW=)1NH%Ð9TqAz(09w\0qL`(.}3Qޢbr*68hBnPu\0\0<}h$\Z )ES','GIF','chartesceau.GIF'),(4,42,0,'contre-sceau','image/gif','','GIF89a\0\0)))111999BBBJJJRRRZZZccckkkssscZZJBBB99)!!J99!1!!!R1)RBcJBR91J1)B)!kZRJ91B1){ZJZ9)R1!!kJ9scZRB9{cƌk1!ƭsc｜sZJskRBƔscJR9)J1!ƭ޽skZƥ{cR{cޭcJ9ZB1{ZBΔkB)ֽεƭƥ{罜skƜ{sZkRcJ{ZsR9kJ1ֵέ޵֭ΥΥƜｔs経ޭkcΜsƔkνcZRֽ{ksccRBsZBJ9)B1!!޽RJB{εƭεƭ޽{kZֵscR{ƥ޽έ֭1)!ΥƥƜ{sZ罔ZJ9s޵kRk֭{cJcRB1Υ{ckR9kJsJJB9)!޵Υ֥έƔ޽έ{cckJsZcR9޵kƭƽcZJ罽{B9){scε絜kkcRJB11))!ƥskRZR9{sR{ccZRRJ祥JJBs{{kBB9kkZ11)))!ssZ!!99)!!{!){{ckcJRJ191!)!kssRZZZccJRRBJJ9BB199Zkk)119BJ!)ks{JRZBJR)19cckJJR99B119BBR!))9B9JkckB9B\0\0\0\0\0\0\0\0\0!\0\07\0,\0\0\0\0\0@\0QdJlؘ!J4LUHBS\n#T(ĠĊtl\ZRئ\r62@jD7[ʼ	\'$)RH5BhQ(Q@Ѣ\'Lzh!xʅWNZ<uIѣGj,\"1SAդPtBY=dIG3>Yx,$b	#ʉ&_vң,X^fbB$P-I*) ۔߲a͆	1*<)S:t(C$?^gOU\ndԔHNf9T(P@*Dp* (`~dE]zt#1#X`W m!ַOw*m	}$lH A_G`\0ߌ#P T3\Z&`\"	.x Bj\0)CzSRHj pƛlt DFaDC4R]/ЇN=CRPLğ@81:!\\p&bi-hWi	w\Z4^faTD!SuIYY0# ^зE\n>V\'ELppNDkT{-֢^KP|KOFoo\08hAvؒ.X\n/J*ZhZh\n!0Fq	AD\\J9~AF4{a33Sb^2	f]H~mr>FMmh;3huSm_kk\0nئͭc}nrC5p=)!\0ãaH\"Y\02+ڜEA|E`@3LN><<XC\rm]<}\0۬k<Ϝ>t\rmʍS5N[wŋ9ү;_뼶?ýs[+}ެz+7p\\3\0&}M\'߉zg0FĠFeLLL`l]2z0؝9!X\n5t0z蘖BiYzz{[k譭Y;lVĶ!rakc\\2:1\0k@\0P\\AFHCKV\0TeMp(`@k.DeMl^>\'uc$FHs%|%\'iIsГGeQY:Qe+(KW2^,*XS\Z@]ު/y/I^5*#E\\67U1a|C.RKh\0⋖;9ok^p7HꓑD@PO*1jiVĶUѡJl[\rUăRoHDgBz$](EUF+P\ZiL!\ZȩKuZLd>jN		j\Z(D ^󈇽XS9c$	-UHGAEI=vo{eX)o\0Y]XmԤu+Ig.s\ZL	6d3lX`Ѐ5N`\rJ\'g\0RZ^Uw\'\"uA*Y/^]XJ{G20\\b^㫵JyW\\-@4MT\Z4g&$О\0zl|38ܑ{J6}B\nr\"%O%lt%W\\]>OVؖ7RiZa֫\0{l\0qL6i|K_8`CE\rw;V:=XWL6OT!PP}[තvʅa|XK~ۺPʾk[b4@&Ahr7r|c!;xMw!\'a\'`+oR̾U+p\'0C!u{Y\"Px.:MuO\n/|8xKq\r`Є&)NB@tQxV\rkͫ:e%>Hs#4$-I~VTZQ|Mh,\Zɭj~ﭹ\\u\Z\02\0	,g#S#@ֱ|L\rh/x\r<<)3r|%y`ۂD0Lpq]DC\ZckHDDPtL~ŧ5\\KnvuE;ڂG8@\0<xK5q\rˆ7kiSt7M`>#a\0.{CpQr#@FB{\n;8\Z01gP+5A	kfA~g$CHE$ؠu \ZE\0{ق{</W_ETmx0{f\r-rXmxnF-F|gsA%AozBFP{\'Gp${0$<T&-.@\0SP\0$`#0C}} ;~K/\0\00`~ s/4<R耐eyR\r^K?H2_p7zekc`P0\0rhqb5/5:[I\'O\'\' ȉ\'ȉﰉX{[HB4Lpk@S\0;X\rgр#sP}!Ixxp\nz\nlgW\rY9ewb8R\rЀ	}ȋ;\rP\0}c؋^G׈e\0\0?Y_TycrW.UU$u\'u*de\'H0x|\0\'I([:,WnFxҋ\rH=tFM 	e?0yx\0\0x\rcB#DxmT\r`\r\r0VS%cX`000X\rӰ@hט\'yʄ4`&[#9PKGVIe\0	Xf`I[DI`UA46gfl*۷E\"X0\0	\0 <0l0hBsFC]\r=G\r\\	?V8\0ZI\0Ǜ\"0Ԁ\nh(Qto]IU\0I{(7pi9oyUUU=KE.WpvrehyErE\r		ǁ$ЇEB\0#َ	\nϠҰ\r~RR@\r&*މ P3\Zm@x\0`.O	VUa\0`Yp\rI	8j\0Y`ofVf:7O҂6a0ȜH \08E0q}ZY\0Ȁ	8@p81E\rx\r	W\rzrhE6{$TVd`guɉ [Xe\0\\`\\6f&f`uA˰BZe<\'/@xm`\r@q\"Ѡ4U\rX@h,Zh\0^p \r?\rs wP\r<\nO \0}ѐ	]d\rTܨ_YAi	6AWv[\'fb{W){;{V{%X{֟o[4-KkZ8ȜEgךٚ0E\ruuH%4uۀ\rbzxJqYt5zVPPBg\n\'Ta*9c\0`c:iYp\'XyuH\rF\0{9A=YEXF\\YrrLCـFɍ\0\Zm(Dd[DZH`:LJbz\0\0Y뾔H\'	7){89?{Bཅ`H6fKJXr\'Ѱm;T\rd\rF9dKE6x5a-U:%$Pp<{+\0K:雾>;{IZ5[VPf\nj&Zl=S4RT_8zFu\r\'9M:lfNNoMm7Mu@we/\r/Mz<[v|{{Pɖ|\0\n@ ,\nC=kIlkȀ{\0leA;ZѢ5hvgUkWLGnЎ92}!}2\n( 4FM0np\"\\o0\0$:	 |\\?P\0ϕÝɛ|]	0쾩7|j((ZPIu	ZPPHb5=(-.&g.*	4@Paw(!(Pm DC4`im{\0|Pՙ\0LB,@>|HNhd6f&fK$UvieCRK6B$5).ۂR2/;،\nA5ȩƉM|֠ј|١ɟäS=<lg]k\rkYuU\'4A:*[[$]|4DUV- M[Ɗn.\rf\\<ւi\n{\nמ4{ʔĝ;Лɟa]ak]9z{<p0!e\Zo%=$-U3-]ܙQuuO<TW@DC=\"B\'I{LuY&nʦګm${EސMP:PAU:	ޅ\\xQ-\\Hْ<pCTܯ_6:mH\0ݼIu̘cVA&ͱPeA&!uauNM	-\n0q01\'D\0\'2@ Ԝ2CI1\n/KGz!\0vN) \0\0\Zyr<@mNF \"2,p!\0a$q&>&N|חP}m0?`\'}Q \nP\0@(N	Mz \'(().Z	ZȒ@y1(\Zrm  FO  !0_-Yg3.\"/ו&eqk/W:\"_C\"$0$?\ZqMD^ہ2Ь@~xr!!]*\\@\Z۞BkqrQqr\"Q1 \"3P>c\"1B44,73O֒Zk>=[fbZJƅloe\0*ePv\0<pW) /ՏZ`_ ~;\\`-\"Mf\00] g]ۂ_]K)\nOwlp*ļs	;p`sP\"ŉVE!Nɍ()!JEDL7\rУrN\'\r(@\0?.d(\"M4*DQuUBOe=dR-<ڲeғ0<;0gs+-Ä;}ϋW\\0aCs3Bud	R4ϱZ2aBa~yR\'jҪ])[ΛnV\0kײ	\"ĭoYP@Y0%,%JĄI\"O:iqe}b9o뷏\0\053on65{\rjMa\ZD*mCeK0hǚ`9\nj2UlqHlE()idE$&	\0ؚNL0ih\"˫!!PMD@\':mn(B \"\\t%C{7kF\ZJ+&\n2DA:\rOs4p2$SS!s^}l1QuĴ?/srl644LVV\rmpZ8eLYl\rيfR5j*tO@\r\Z\rh7^tׅx},ʋr!b+11TSx-M\0A@s)#mu	M(nOUր,qx+\0kLF\\lI7l\0餍>t\Z]lLeP`(e+J8#ܳ!ΩW&@y3O)췧&)<~[NyAVMpI\nzp5LAtj[WL_\nZ66׷Ԝ@4\\XPnTѻ*,7yzu\Zeo\rqÞ<ofzI48k`ot]ΤjR_&ֿ6\"	H2-r`x&5-?\Z֚ʁ%N\rVtFp)2-K5̓\npIXJ%:\Z$v*E.0ЂtP8h2Ϡ\0,CytIT60gmq \rn(747LZ*\rY\0Rd 2>~rZKYjָrk\r)GJc\0F6zg׸h&:h+JSe\"\'ENr\0(I`6eaOقc 蠛fǸ!vKD@ \Z4PmFC!0@!%)N.nJ\\KxR$6\n#)F\0@\0  eӔlЀ\'Ӆ\rׁN(J#L3ŖXPF@s<4&d#Fp,r٬\0aVS?`\"Єa	x&\Z_\\&$P	|uAP5k_ׅ5e(>Qym	#Ct30A^(MӘdGiL:>#\"yMs g5TL`*P.( )th\Z$l	H\0_\"PB*}-oQyxjWR4HE\rpHCR\0 Phl\n]<hRjФ  YyV=}O{(|On21ٍw<F\0\'`9rESG]\\`@Da:	AP*֐:,Ui_F^:\0#)r\01	0Cn1!o\Z\'5JѰǦ*xĀF5j*Wk\'[	Lilw+M;<\\\rczt1OcĒ!&%pf&J\"QH\0\nlsM1&\\Rxp&\r\0xŲ\Z\0p1|	\\䚫qFQ9\r9K9T \0o\0pIHgI	]k^{w!^6cap@m7ʡ&^\ZӜִA,qh\0<&,1?\r$JB\0RDB^ڃkAz	`+ptI\Z\"_OyS\ZA6A)pT`FTʵ\rl4Yx4@J\Z6#.G6m Sk\Z9_q#\n\'ޚ0\\VyIBZlF9ΔJpkPg9rRpTk&169\Z\" \01ʹ_\0\n	@\Z:8ao(@nq1j$\0 9|٤=c0z<M[z9\"1H˃	p;D<@GihF84@0-cײ|в*+\0{0Pz( )P}ئڱ\0vJ\0uXcj\0{@p\0pj@\n|u>22vF{I-?/1w4rÿ)HcQ51@2@eC\0\0izCz5v \0v0/(\0dIPEpA/\Z+\nyÀ	Pqc86s1s-\nA\0/z@\0nXo:+9\0{Su8;)BC:4ySq):Je;[jCnhhB7?Z5i칞W{1#\n96o:=YbA\0m+@o@d3xjh\0@(f/`	^8s\\8ژw<Ls5L<F1-0cɇ:rC7ј5&S&\0\0i42\0kJ0@60K\ne+ˤ/+HY)18`<tt<dBI11,hH˔5FҒF{deI6NKb\0ijRRNir\\X2؉w+«kp1o/ɐxp<.4\0 e\\I<hFNNNN<L|N+ r,p\\;©lN7h\"ʹa\r8XAk`\nڣ$p!R-0;j<4c, %@]Qer8,CĸF8TOq?\0h	1ıt!z-C&sY:E8+W365-7 \08m\"P+i8dȰܩRMK[\0D]cHTDUcXQDGNJU\0	0NQ	8O13PLQFd sS\098kX)[J{BX\'U|§s\"\'\nPSF EhQRh7p\0I\\!Hst5u5UiPxFMTr8|ULQFO$KQЊJ\ns×r.q%*Љ!dIK29-WUYK)h6 \"!6E?<ROU}{Zr}=,J\ZN$0iBF	-@eL:K0--j@[Ġ02-[*i}\0rY\0T\rLx0Z@TEZ}сڂML?ݰ\Z)4Rfj)@ι;\r-1)0}\0Ηj˼%%\Z\00\n`݆)͔)eJCxL\r4T΁5MԂ\r1^t3$R8t+t̢ȸL\r21X189TOE!\rQ(%>͐Ld2e!q02Nʽ8Ĵh$-cO46 Šem}Y\r?_pL?jj6*4>lC(VrHEE0_,62e\Z61.392DI*ITc30>/3c2㣛c\Z06?cHY%B^dHGnRh(QpG8Ȏ\'(/XB(,HC-8e-U. .xeO - O.؂NGhGCXCNxcނP.M>X%h\'h&8\'d,,,G,HF,0C-S|-`c6fP25!1Ec!gIygݚ93:2\0ثcWc#!B. hH(F!AD) eXde\'`RAAY&pev.`g&,(c0gf@dMv/ނ@@ȂN(f\n-Ut^0NH:ޒxk|ābIgzHDy.l6s1g!0/|&S=9.?>(BFiR IfHf~NdQ&eBiM\0jNiA0R~W.eN/j(G`~nΎPBB>Na^ka&fFtR>.\\po%&WEl6l+V~c|b,16{l_J	ii(feGxmMG(kNX8j.W>eCЂ.؄WN,8n-8\n/nGGs\\Ύ\'b굎kF`C\0FiCD^\r#DDo@@jS@3p5Vl-6o,b2c\ZGc-dt/qfgފU(,\04߄W@WPeC N 2?nE^U0eRgkX\ZJ e_\'8N`GRf.Ce|\Z|!q]\ZĒ@xw!vw!	|\'K.jgbc&mQjVs>s O6/0n0 t\\?08/&GX\\\'xVk.ȂNfr+?P]\'/x1 2`njnrjߎn悶,G((Kish!7wD\0$Q++O@]HOunZ0P]>\'{~x`W&iDIpEp1G\Zx20N&g~gR;BȌA=g_.k1\nα+~`;ȁ([MHu~B`MMaKP-\Z(\'I]}Y[Tݐߋb00	s8ppB\n[DjLѣy<IR8j59Yh!<\n3	\'2i˖D@Ӂ	R8فXr=P᳃Y)w.}Y\Z43dؕkAsY|ңĄJ|c_/\Z#\'DѲ@epM\0=jakɒB:	d@YMz)KD_SLPbڪ5+x۾uۖ+[]5{hrc-# C\nT8fAVszQfT5d`=s-oPdaYt2I$b!bH\"1<3T^U]kE@䐎9j\']z鵌x!`a5cݗFQF7%f]%feXFOI	\0\0-B5E!<l!\"otH![tR^,bqQ9*VjՏwyE`[蕕\\9꒞\"_yA$AB[N9&P\Z4yZs+f0H4qO<AHM8D$\01\n $`bSk@UUY.YjcY	AUx,2 0Fa\"l]+IfQ0\n#`<8q2.d\n\"= \"1Ј`2Bl\no2xn{]j`	tEeqd[g{:\n,0I&/gSjTnqH\nMT3x5T`ш#N=H0H.gBT|RգjEĖכ\Z᝵c\\Ww/|uf(Ysgf	F3\0\\ʙ`K&Bd~&r\Z6?H*Z@fwal*S92bw;s Vc(|@i_*mmGkX\Z^Tvl^6q8ؘiC\Zb:ɯIB$KX\"@=+$\0;%Ou3]J9HEɍUd^./	=T\'Ltxlh\ZF4P.@\ru\n (ia\nH4l~Y%)밮\0EuEcIcȰ\\QyRڀ+ZH HAm	4n{=fda6iP@LG(/+WK`ĵd6! =ḀT	=3L>J}gi}F%p(4\\dB\Z 6L.2Q2hIg-ӂ/kW7$l+T3wgg(Ӂ]\'x\Zy3&\'!anVG7FrU\'Y	 zn3#\\r:1Ov|k0ӫ^zdc@ӓ ;/Ӱ,cK2@A/Le\ZE~}Nj |#(R K5;˧)~u\rz%)Vʁ2y\nf9m7ޥ\'Q/kml/.-8v$Jf`Ը\05[Ld\rkaB¡tQa*RRq +Гb!z#hu/7\nT[g2X\rֶ@LqSs7lw	:P07&5>|]4eif3:aR?!`l({=HrO\n\r+cزD\'fv\ZHYh\\!sȅr1ee4`KiqObbgj<눊<8v\nr,cݫ3Mޢ[6\0lr5`p0&4q+TӖC=e@iQBUK,sWZR/y8kJ 	;&P`8e)!\Z4\"`R @xd;OR#>MX6	M\0&7	\r晋9/m9U \Z58wQ`0d/ ю_d7Q*l|U8QbTg2>\Zt4PP\rAxgv,D3 iDR\0nk\\#{jw@Ӎ_-4\rAl̈Ht$uZ©Pi+\0ohZg=J7o9\Z \0ۇ\0g?;&cCE#ŧF{@M&@oBhzF<\\vG$9Et+3%t^%\0_\r:84P\nM \0ό$dnI9ߐh	8؃C8\r \n\r5 i\\ix5@f!A\05QH؇Ց7֕7xCa<D\r\rVM`B#\0\r8(Bx`c%K\\|@\r_z\0K`\0`ޠ% &`&r\"`Cc_\\\ZCAHvrqZ(P;(tA*\\9!AT$*V\nBB K́\Z؂3B\"D  @U@$7\\U\08Kdi\">(%\rCDUU>ȇv\'!@>\0\0Y\r&H9QYpR `@BU\ń\nС+`,00$+$\"8DmR`	>\0@#\'z?嗀I\rP5<(^b$)zYD틾NNو!@9d0.^0&;d˪[>\"n\0Έ\0&$X ,A\Z\ZBe283,4.ͅTЈhÃ@$K\0>D]OKM-.Pgp ?\nT=( @$MWP$Tݎ^E`&/&!HHEB)b\Z\0X\0.P\n@4,$\'/\\/\08\r83=VZz\"\'Ip^iid[U  P |24C3A,`h8K(K|gxV:L>gVSq)C(\\\"\"&cg\\\nLEaڞKNa\Z*\0|,B*A\nh5܎=\0(>(i\0H9h+́/(B,N48eϽ8Dd58/\0Q5J\rRp;(%!\'FL(V%b88$^%\"BhSie`$́N6*0|\"j&Z*(Zo#8(\nY@,H$T^TN;$@\nT1i\',?:؅a)_;X\0\\0X>(;g0b阎8PQd^CP]\\Ie\rҡNkO*4NfBlV\07<2@\n迺Vi dY^tFC&hH81B5,NNj\'jbpJQQZE\rB+Жnb.v9,ؔdCF\0Yȡdڝ*\ZA\ZA,Jjof\0\07(\02R\0.X@]ڞ4H V8N`*f=]*5/`\"&m0Y*V& >CDn,(9C0b`lb8L^~JRHWڙ|*@\Z\r퍛Y`\'5d@&48Pfٙ`~,Yc}D&\051.Vڃ:TęΨΒta-IXbnю\0RHy\\yC,M#\ZqX\nXo*P<rvZp/7̤a&b̫O\08P\0&ԉC\0hbV<H0\0  HěG|Jt\r\\Ma< }\0L%]8]x`E*O@o@iRXC$Xp\nxh6p|Š(i̢~53(T}\r\0AZCLq:q)BtIs\"a,\"P}nIpԁM3WPc0z/Q#?Cv.up\0h*rr2́ФV*&`pe\0;ؚR`\n\0qGY<u;@\rR;5S5;Ѓ,-nd4ϧ.Ƨi\"L2Wc\03kLL,#`#%u(5K\'>Dv¥8)@MZ4DAUBsu5FWTMC~5CBecL:0@77	vUaCAx\nLsVݎ\Z4\'cN62[Q-~1!Nᚑ+D:`F\0Cj?TQb-fZ\0KV(hT#8Vyhi*8$\'	2&|[;<+7n056ܚd\0?z9_\r-r+]\ryfQ\\N7P\\\nC~s1UFQ\\;< >FS\"\"*ߜnhFX6\\\0&843Ve#w,>\0I[_:_;X+TΖd.&2|҈l\0.*kؚ\Z(I^jJ\ZIBRTz\'D*HB4T74l5lC1eCI;95$lV,2+\0LZoHGD!<U9&~\Z{k֝`2/7J+_Iv L\rL+rPJ<j~iȇ&\0`S<p^bU|\0̼׼A\\CnA02t%{HfkbFb-bc5gE.xO0QXC7iph\0?-5^ѩPCT-%jvpFAYJLaI1Ã< C{|V=b<t+iHj#\Z`) Քy;̖Ǎięе\08țx%R\"Kd\'\nppW<VaipU0W@M\\L=}5\'+0/)4wο}a}~苡Doz\'ϛ<\07%B4\\>&\\<1߁s\rg\0eJV\Z(P \Z;p2ee.lpxjАg2d& kK)ҥX6\0\ndY^J\nP<`g\'\\[F\0r	!C 2y	,,q/qq\'K^̘āL4h;#ܰbb弙gΛFe\\Qd[НDV%Jt^ 0( ʕ\ZTϕҧM^;w^YAq߄5,8s*wnȏe4\"h5댰LB\"̱l3k:M11&:\0#:2G\\/8t~t&{#Ajk#(*I%dT4=Rp[怼.\"3!\\N<s3\Z,<mB0>dl0@F as\"4b7\Zi$3TbpG䢩&X0਩\\[ؕ]u\r\0\\jXPF̹#4KEJZ=LYN	$;|?=&@	3CD37G5/6Z	&)hUyԂ%\nnMF$F+-Nui*Ğ\nrAIQdDa00]1hfAZy\"uiAVg09`ïkz3c&g	^ Oή4Qyг\0cHRJ-\"ӂ՚$@fL6ٔ^\'OU\'\Zv,@6\\s\ZPDGN\\v9\r\0j,ڱEٶw\Z\\r=t)c^5H\Z\"\'Z?L3(?Β<\\-[ce\'ihYr\\`CA\nQDBP A07\Zob7Bnp<PA\nJ7\rp`N~ăw)滱xJ	6`Qq[شjA{^%h$B=qp\\\"1%3{\0	#F!TC$(!(B(PxDA	<j3\"Bokb3cijS>4E\"kjcgDRx*%B	 8/(%	}ˑ\\ Db\nShC%d \"\nmh0@eT:0A7pkZt\'	jPB[Le0ޒۤ|g˿}@k$0qD>BA}Re	UD\r\0*˥fL<,010ak}g8}<ٴlfc ٙdCQ&WCO֍?BdRǢshO?C}))JY&\022_Ko.ba>rR?>K!TZN:{b4ԤNbH(K7Q\0ȏ@q\n>YDP.&)C7#RKJ&L?\r6c\0aܑx5k[ʹE>AQ$)ٶ)\'DȦ?HHJ\0oh\r{zn&J\ZE\'ܲP04%j,5Er[kV!h0ל\0	Mx.t$IV/zHI,#@̈PG7}FZ<UJekA|زߔty|[T\n(\'Yt|EH^Ҵb9Q=;p)6`w!\rgD|.C@	Nj-e TH\nTW<t3(hcD>LԱh%,qg)91X^mnc,qsS,6| %sRWb).M~,p\nZ)_8pB}-9{.kam:S3~\0f|f/vmR$Tڇ`[o]\ZZ#5#$+캁S!H1Ͷ.mA˴mSқ5e+ÛgWakhD26^jcj4D5zG%5:\r77{\rUEԨO\\Mؚہ\">iJ_OtG%.N\\UN<2Lk&-?i7jX=S)`\n\ZG|i@x³l)Px9Qs4\0y|%*ax3 HȀ=$cBD\Zш(Q E@|(L!!\nNL	^XD!\n	,$\"\\>\'w?< L#K@\nA!,<߉Bq	aA`	&a!  o2  A@2t\rB&/L!A\nXO/L!\\WO0	rOh\0~`\nqH|/\no\0a:!@	PAO/aAo\0p\0V $0#p3)0\r@NM@|aolLAg|Ajql6OnZPa	]\00\n~`o\"!`	`>% \0AOKB	4%59\0\nPp1&#/oo:1p\rPJdTA~:jq*O:@T\0%*gCo;~R(o(/\Z1	sH 	\nraV`  /2֐AP8!@Lb\0.\0!`0<ӏ`+AOOS	01 a@/\r!$K1R0!SeFd\0OmqnPLtp$q%bjQv2n([O	@erF±	a	o/1Q	V23Qs,Qذ\'0208p\noPr,4<\0JfFeLP6A1ih4K\'ՈWSic6}b7Gqdo\n9ő\Zq\r\r;a,5r<0/ `8<>pI0	+RIo AsAA0ȏpdL6TrSM&qPQdR6A;@v7Y9*GsnT	esz`*~	o\0q/	s@\0,tQHpaK0$;TN1;  \0.o?23(>q#>C0@D\0V_EPedPR6S5KD1(CK$M6}1%\'[R&etH(2	1G\\!)Gd\'\0!ưA`J_4,ղ</#pIT̐s;.CN&qW1A=ֳ3 dbB\0DbemqIt,UhfՂJB\04WQPYp8cs*#VdW	2\0N2;	6\ng_!u_Au9XOrNt#M	3ij@TZ}3\rOlT}FHX^\"b}bGj%o6_,4sS[s*\0`\0\n,	`:ÐH	|@AJu 0ZV#0\0;/i!08#(Z8O\"/w@3l(F㬤(qqdIb}\\bHTVnp\ZCcr,\'.\'|O@lհ<GPxQDK}i!+/k!y;24[o	Ȁ \r!a,L%dDLL%#qV⬒̬{Dܗ|ar6_ifUaB `\0xx@\r}Wpo\nnU\"a9`RL;!O?/Oňڹ O%03A!=ioL,(E唗%ԇN}Dl}phD|+Jb<2`BavA`ajhzvav@TuaL!_)s8c&ع! TpJ=FcRٔaaHPYpdKdmY|n\0DzŃr\0t@t@fqV5u Jag1B	}%FcX}NU;\r:U	\0Vo.Ђ|:\0XG.M|Z[;.>E%FHeX*AIR\0\r	6	t	!$`ؒFAD\0FnvnGea{Y{#ږm%a|$7BG7N˴KÓhLLb:\\F\\z/ڈ\0D2`<.@r@Kaҙy#33\0\nT-(`|,F-HI-%|,\"g,nKma	{#$=.p⠡Γm.TX\ZXXVA\\@g`;RUAY/aأ.f->ɛ|j8-bƾ	ޣʳm-b.L\0->=L<gfLp\0M%;8atD**z`sP` O	s/kT`\0&\0G}{Fb$#L`&Sfr=-{ڊEւy(<Ҏ\0QJϡ7@M*7Z<(  \r~\0l!\032xi<ŤŔ2.(EFbHh4.파|B5޹Cbېݗ_IϿb&ūbR@a\n	.rt+s`N.8bf7\0?7\n?+6+HsnjC>>>:~g{nC,\Zc\0$  ۙO\rQ=P6ɀ\r,}/ޑs?q`ˠzz|4-BF\0j-vС<ͣ5y#.^\':cCcB\0*B \0֠hM-9ei#FtPGx6a8VeK4c;@9o悚;4h}`2gPNz꾨(@)S縒mT_kիf˖Zչt~+\02ϭ7v<u,XbIdʏ8ָheHi2Ω	BeG$Qd&Aoϡ)]T˭\Z`]/ٽ;8V>T|??/\0=%\0n@a&puD4 x\nH\'YtD[r\r.H$\0h#!KŤ9aaM1PGɆ\0E	gNvҝwUz煇r|%W_l]8x>&1أ=\n|iF,AK*0CDN4(P4.<CI|v\0&̈́KR0O\'qH:vxME8M:#q pd}\n\\P:פA{1${ʊ)\r:S\0 5H嗮Ē@9g~\"\nPJ)4\"CC3^u3nX)9aYXۊ7芘nzyڝާJ\Z}\\88U\nה:\\c5\\A5* *A+0 *\0pK/lч)H\"o@TIUeQգ9-4m5o=Gd]TiG5VUj{Ouz}m\n\0_s&\"Tp\r=2\\γ\n\"	.\"K,#T`0U}*5-muwI7e5rYՔdQ4/\0j\0nۍ_0JP:lkPc8҈_5\n@{yb 2.t}0(.\\U3W\'\"t-\'WoU*:ގ<E-a\\L6)epV̡XFo*o*dT` F2a\r8$\Z<~AdB\Z(b&nXDh__2&kBQ`rH$BY\Z8.ܜ3HN22756x&0G;[486P\Z4AT pXD2F$[L\Z@\'2&$%INEkQ\\Ԋl \n6깇my61<]$z;[1DC0-yCPpq#stMlx V&/x(^	SֆR5)ĬR}n+(#b&oJ(ژCU{\0#YHj0\0\\\0椆7[nrRi4!Yd`(Ջ&*n)B06Om\nXFB)*}4\0.@B7	\rh ie$75PRj<.0=}rZE`&t\ZW^H\'.YFP&0ˀG/edwD\0$ϩQ&M1q|烢%yB*$ Q&o1WF4#m\nptGkTˉ! *\Z1eE9!Z<;y*wR#JQ\rb|rX֚\"	V\0%0IqkF\nă5uvyt.KYq^;iآnjlhvM^sN^b4{<hKH\"jU+ojW\0\'DkIHS*zJjVY%;itJC;\09{t?eB*M2\rf63brg@\Zb)5MiQ퀅l\'.tNFSKZRxfg:꺮Euמ#r,ʼJ콰sޜΞyq ]#Ϻvc\\\Z5Loy!,U662&JYI(o|ˊâD\\wQ7%Tw/UOsw8!VrҐ_&\"]>8(\Z\ZH0GK\\x .qhISWE)6>)lA)D7r%s\'\\-9g	=īy<BX\"\rk(C4GhFXF6\Zh]DGyRCĀX2R2zyTG<ҥEa4_3M;m5]\ZdGADdK/iF-@qv>$Ưng\rDYWCK˨Hqx\ra׽/_y^aث|Wm~$\Z}ϟNU,y! o[Bfbv~=^^l	lh5&XK*H!A j~LS\00zy0D}TCW!]xL6X_e~N0l	-`GDqz88 \ZIs4E?\'&qa|61#\0\r+\'wj)stQOb<&%P<d+ut+Pzg\r\rF\r`[5NgN8H\rNEăWD@\0?*6!be\"#nEYadT[s +kNZzBG%twB>BCswg1Ze<;7t g-_%upcRp\02X{<i\'EmH4.!Gj#\Z3\"CE#rĀ|W7UoRiUKSb!8|cKB\ry*%HRR0(D$N<l?8N?\"W%@Tt)/\"fJK×YMχ+XwxLggox-LUgHܤRTG\rq\r\05h7hD`GXidV\Z^Q5*\Z,rwET^Zrڈ<04!Xw9}o\"HoGUugdN8H`2?Д7z68S?GCP|S|@B/_))#vb$]\0P\Z$*\0ZH}Xws]q)0U/~}=+`e\r(5HM1\ZMɔ5ȔYJQ@LՕvOs]`&nyƇ4BVE}H}\ZC~WyoBw6<\Z++ǸRDlxcv3!IIٔqHGS.@wQO8r@E*BrȀF>iE<R\ZNGyyyiLCAZrÛK\ny\r= ,-\0?c:3?@D?mj?YDGiJq \'O/Uf5$\"TTr]bXZȀPE;pcY}LX¥4zv06YcLk\Z\"! \0jAd9EN4:m5N;(E@/^pE9)_v|KzN1\Z#jzIUSŋW;+*DyaVS>I	M%	5\\|\ZT5H;XzJT\"P!#4]\0gdU׭\0+*s5	෠fv077ۥCf\ry\0JYٝ69ifSBPYiQe!_OP]p^T4~\r\r$+Ml+M(18GCKwtPSxLP\"tljtwRhu\0&uIpwN׃g?>@1F{[{!4ZJ[@E,ңRr\rTp1w;d1( M<&+ՠ1#PڲfVy8AY\0$%\0 V\rWglDzR4(N	4L4JP4^6N(?AA,ǅ\0b: rC+@\0T\0 7+t;G]e	m8K \r}x\rp\0\0A[>[leG`FzwD?S3:%ERa`O})\0eTr\0.wGv5\n<dIFp4\"0Ytɫ?hoxtCo \0AK\'%sL$\\\\_hƍ˰D\'hwX@4r.Y[|;x+Ɩ$?+\n	ܢoË4{Rif_ӭ1Z0\'L̿l[=\\XS\"%FAq[غ`bkQ[Q5Nt1JCT0 `\'\n\0@\"1# Xq{WIW!91*,ƾǾoL![p`]UиGE%|]aPD+Q\ZB]Aʀb`	@	:/(Mǻ?H`02sPqX40Z/\'\'\'al!.sDH6\r&qAk%yr[\Z.H#.(%7</%GL#\'ɀ	PEMYd1THcOM՘!p9 4i<\0|	z 1PF%4J\'L\0`\"%х]$-|-v,%=\0)UDPHNT\0w/DEY;#\rȱ`[hĥaz؄[I\n*0P2=~PO\0	+.LT.cW+ohl\Z{}\r\r2IIzM,\0DmLW3K/r)@`sak|5ZeRK\0e%I-? TMs	?t<w0\0	?@!{2&1X\Z3!5\0\Z= ]s<s\\Й*šѡrBN:XE-K<)QK~a;M\0aƆ4C>e=**`lj.p:\0	}4r\0ww)0ё^o\ZM6\09zG\r0>\'h[˄=<SZ,1SwOrj	Ob+퀲rO	0J\Z\"klUH<1Հ80ES\0 jPkhGpz ~P@\Z_^80?^[Mhսx=T<0l}»<\0C΁X(OVJ(\"wjkQΉJKą\\\0P`Jrh1KPո8\")it퀐I[L4?I17]ҳ\ZHP$hlC=\Z	``s0 <Kl&6RdJQwZHb|Pe3dZ\0r\01b,A7sRE-:9LZ\ZQ@H``^ʒ f\0gSNfBD~#H &Ѫ6CXfsUz_;=vHSI|=`|kn9\'0? dy[N`8;pNuU7:\\PR	YYiTΧ]zJ(SP:-HWS{͙y/omў-{\nU\0\'mРh*H\rPj	EnLi\'	izN:ǜ\05<@C6$LC	C+ǲpEw4ls@-4\r8\0t|P$a\0bJ:Fz\n9\\cv㎋f)N@h)Ej>*5.㎻d\'c\rz Lo/1@\n*h8bD)kSq	mp.MTSE|ǜKy[(٧|k	K* 5FBD@$\n|rU#@6$]P>D8\Zu1xj.\rl&j,4\0gnyFOt1P\Z1pjLF0x@/폀o3p!kͲ-z9\0Kmh0X,w,KlF6LSB:O2`}V5K\0Q`PeB>C6Uw15٤5˒;~ocG` +DǤ\02oLYhnnA\Zk;\00V<\\f\nuY{=1^IQ13SqsOB۞%棒\n)\\P\"	>R#Ud0s\Z80=kz{diy3`\"hF|* @@ģ$@ldJ};1\ZUTBNDjQ\nQx;^%.RB$\'X,ըqVUv `PzO2PAn[ܬG-P/,lܢJ5JQ\"\nEkT`\\7Ģs{\rfCs]J!(0~	rE+GzFj)]΁,4͆L#IDIlZ^4AP\\muW P\0\"0\\%+*C\\4c\0FDN	aiE4y8\'=L2a}P˪^*gZ*h=A4x\'1\r!:$N*\"`T%,~\\BR(Cӗ>ѩ\'\0WBB81oz4fRcj0,\Z i\rjHB\rp!)-	xPTp>	HĤHV7`Ĥ(ጇ`\"\n>b\ZDqXAŰ(\rz \n[,;&\r6Χjg7̍&\Z\06(\rHa}h\nܠ΂!K?.dx1/\Z\0Bex@<4\\UBXyk\n*j	hbȡ\n4\r`ڴiC\"v@,4*;kz \0X+LpEͯ\rK\ZnTu)> %VBC_vd!A\'+elg-\Zx!Vh!\Zd$Y4exHh|@=H\Z$] oO8{0+V\nW)BS8E>Ԉ͟*U{τJIT \"0 (jXv1Hc4/,`\"U0kvy\"`2D2d4\n:br\rtGiZa\r[<jmύYd1h4n\'O5r1ȗ=1i(mmKN@\0C\Zv;p4쑎NUCC76a~Vq$2;*٢quCIExx*yF){T<2׵a°3|tlNlblm:D7D9Yl\nwGg4	i\Zƃh*{p7oD+:\0vU\'q0\'z]	W+ƀ20l\0YQ94z)jnqs(\\\0CWfkĔN<2֐6+\Zߢ#\rK \0\nGL`oN5m:@4Xg2Hd4WkI(gi4^u1o3$c^ok(Q#ҙT	Hy$\rZ\"lspKX3 e8#:i<pژq0e3qh)xX2C4oX>$Yyۮ\\ޙ LRᾲ$QJ/AjȜp\rEAX	k0p8e_`)[h`P\0{8\\\"F;\01Xkvg:i؆KAzᑱ|At\0\\\Z>zM;Pɇ,P	(3%SL/T>|	͒EppP`EH98hP0i		~(\0hv쳵`\n:zh\03Xi=[Y EA\ZO4¨xG\0(]wJ$+!}\\At|1A+%&[E(suWćȈE|8=H^C\n\0\0ܶ	\0Fw-\n7±{\n[w\0W @hˉ\0vxKVq\ZwJ$D髻A4a9(8sx	`phŶىq8^Ț%A(\0po0i:{8\0-\04XvHlڳ&䉢\\Ӭi>c$\rIobŰzDN, cg8\0\Z}!;}Nhp	WjJ ̬op\ZP`!Ix\n((	PX2\n腁` \"{JIR[Ā>[*(Ny@!Nд2V3J28(P#qw\0~<I\0\\ qj=੐6X\0Pɀ\n8\03P7x\n\03ЁPyфbOAĠ 1h!YYyA@F]ǼxOB$yQRr\ZheK{T\\)2GQ@P\"hܘ#epByiw26{\0pHʲ\"	شYr[ѱMM\n쒫3AV>!2>O\nEԀ!QOLݲ\rLٜnkxƁ\nذuУ\0`\0ǘ\n:{P(DC/TZ9$nDSTaCE::M;BSyg`	c2hC렆D\\ȅB-jhA4򩁠	t\n4(\\-\naXx`\'3yԝ}Vש:DXYQA훋g8DET֘W845lQX ĒL	h\n\"3Hb`	ab1=s<ا|JXYڜPj8MP^Š	>겐9WACHw5Ը\rH?ט˵k\\ȄL\0DV-iXuxK:Lbjh]@\'XeWx텤iY+ɰʃD\"Mp\r\"JW+>A@\\PL0ιP8=(jhP)&:c\0eYZ)\nQׄ:!1YHʙ[.]y^mĸWBG\r(;z5t(,U0b?7D)6.rq;YLl$}a@MݬpڕHM.I?F\'d\\A:4=TP@͋<UD1I<׀{@e؉VsTAىYАA9O	r{1`MDDGb$[	Q$\\ȤxDd\0@\0dYgM1\\ٙNEjjHhBs6N?L!)8P\Z>;ͱ\"\nMՑXQ?5^wQٻLӉG+V>𱷒ͭ	8c&sV!똢)5QX:öM?O]hlmX`N%#6іhŌI̮>5-feFpْ^``SF	6v\r\088Ѐlþ۝,:l$b$eI H\nsD⻙ԋ}jM}jF$Ʈ+`Ε.aII+o@pd9O;1	tH\rXLhȅ\\p_]3;րЀ8ގ},&bKyq\\(S_Pf^qfզ\'?o<oVz+= Mo6Wm:\rτlĶH;#j	n	\"Sh\n^^\ri&H\0\'MYӇqpoaᕞr>Ө\\Srd{(7u7Ѐ=þ@nlX K#TtNh(tMuԶshoOG\0wZG!4\rrs6υ_#bg)8cd.!Z)ΜaHx	hkC+Ty\'WoL\'wLjЂttShgv4\"Qfin䨹9Bs}pLGq3L\0!,N/5NL\n~y0&gyNq\'ynt芞h$yyg٬˲FG	Yc	IzڨυΆlXׅ\0WVzOԋ\0(Qhh×H$8\'\'`~gyty?mKP{/Qe4SXCQUHDG\ryAH@?j\rPǀ\ruVmP.2IB>X`0܁!@0!&4ir,]s`f̉Lf)09Ϡ>%iʦȚ&(4rސy-d֐@.[fny|vgn+o~+[މLPZi\rRK)כjoz#B\"b9ΕKW]M[mtynaL>6,2dj\rUeVU-P@&o<.\\8͝o>3s*Bu5K\\H^3c|my7N\\zu7VP\"7\"Pl!\"*`b# #4boB\0#P@G_y@SL(qxqC9LUTsA8/qU! w7Azyd`sG<ݗ\\lU\0=	hsRD:JS\nB+2G\nRs \rR͈iA(A#d42#dnH!RIŔq\n,`\\y Wr%uHTKe7&ueeR>К5G>guZ9UnEEt5:\0᠊!$?PJ?!4oDFp6Fc~p!L0mӱQ59N9kMҤӒJb	tRL\\!`zV{f>\rE]颛r]Z!VMt@P $(\n+ˋndXso S965S72?~/=>sI]5##UU5{3}Yj`zVEkUVr-u׀TG`iࢂ)Z7@8S@I%CHCnLƶx UP&=ƓRKdqۤG4ƖTK6n^xĤ=fZe\0֕>l!jGYP\"w\\*/`&J\0Nh1@\r=C!\0nEo/cRg8$851ʖDr-lC$тV-#)Q:թu`e.j\Z\Z<Gxa3%{>bhE\nAmBl@*TH˞D,t#Nsr*j(=NPE*q*JͲ$A|Z5#jZ9řDGI.sA#1\ZDPІsF`\rI6gp#Mi\Z\\D\0¯p	Np*939X1F;ڊ(K+ƌڃFҩ.1]E1HCWh$kFCZ64\"\nRg<ISVT@\nЁG6Yr81W,OjI,K\\++(A;viVrL1`G֑F4c[8l>9&	G#4\'u9OּBD$A QPHb1rUK8bl~et\"qD.j\\̌*4.򨧀z-l=-@{FBVMv,:\nŚԮ<9/nI}֑d$\nSdG|S?R\"\'QR~$d%1kXm#C<\ry#&,e\Z{融#s}ƚ6>l9J\\ӄuXN\\t,ԫ^2K:v%p@mjy%^~j%v겘Vl+Zu0^Ca\r͍h+GZW$Z\Zҥh6PH$֒$O)CtoRP.9;\\ٜX)˵RLZK`Z#\ZGayXMq^]uL38\\1ї;e-K%.8YzWj8sJZr2?UۜĖbQzj4-^\'[e7=ڸsd~O̸U#>^͟r9vq21cbzϭ7))8]Fhens5<R6Mr{2=]m>@G4]	ȕX.֕ͽ˲*NJd%}ͯ~Zm$RTbrۄ-qYகdyz)[sݖ&p	i1j˃gz\\bSFSn/cja#hVȮvYm\nDkoZH<	,-/kְXbh-.g|IEbr_Lxe$,W(B*_$$IjKx;XoM;QE[\0F GZ	^ㅙKǘ͚@Wӭ	Gu˙	5W Z%蹊wUAqq\n)	uОv`I(XMBZ֕HuСŘQ\\Xy}\ZU~D\ZuFȈQ=K\rXJLM٬ YODI-Ĕ8!՝x%CY\rʠUa{L1Z)U`^t釈G,^|\nat@4]|xM!`@YP-^1	NSi\\Sdl \\ݝYҺ#0QrP }`ᩉ_\"Ҥ|}LE~P=LÈU9޼&zZQzxLzQK@kdQU2ǹQǹU	#{p\rۚhω SM	I~(\rcEЃ}}LNZ˙^x,Ut|RXSDH	`U$cJ\Z`\rpP=B\"\ZЬbsKV`G=\"4IsP	`!#eXxGAULXRiZUtDYYmX8G0͝Y,F޸%_ ZNbE=PαQ譗ɝXÑ	E2Eb$F6ၙe\Z1v&yԃ䘈ߍJULUL	NF!_(Qb~UHzRyCwJlUIYeŕtEV~Z9 0\Z܄(Ūf\Zs]sYr_ii\\^gڅlG_U9\0;','\0JFIF\0\0\0\0\0\0\0>CREATOR: gd-jpeg v1.0 (using IJG JPEG v62), default quality\n\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0\0d\0S\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0/&^*p?:1Q~њ+o{0.\0$5UB	qnck3ۤ.`ݣҷa.O$5J\Z^氭{ߖ?x9mLis$EQsTv\0Wkd;.fHF+.{z9lY+iLjv .SԕvB?V:\0TǡlZ4f={O?`۳n8?Ex&#k\0\0?St_֣h!=ŤsFhӮi4]`!sGbkF>kN0e\"+9-QsŝTS[99n?:R&Nj5䞽{I(4P;֝;QX,⼐\Z5b\'=4@9/jh9!Nz>GOBkfP }yq΄+7\0Z|1RjmprʤޔƝxcz浂zW=]\0IkS(IܑzjE/\'>c鞵,cJIGOʸ4d\Z	Xδ>^@}jv;-«bq%$~z<xS=k~m6;;⅋F;+$.098EB%-M\r7MY ]*\0xUi㚻\ZĦ̃0# c\'lJ\0*3=:BD/|?\nf~?٦q򚿧ʰ<S<;Ǒ2pnBT?ic*0wTDvOJ.3SQ\'򢀹RL*{S\Z\";P2wg劂}kY㊯21Lknbw&IeGq.\0=yjq\0J0ÿ {\ZR,O\rۦB0$/6->Z;YYu\0[V<lIC1@5S$YS8g!2`\0ִ#Vق0\r]$/\\G4}Pzf;ɤ2&>ZON1S;*o~J̹QsN\ZԴEڸ|#h0ZA2\':bD}~m8I5yz+χ?iF\r;ܩN\'§𢘲.G4Uٙr:\06Teuo\0g%7oޞ\0|]eƓƊ(\0\0y\0|߻\0pGh#S*S5\"s~?E_J畿EP#','GIF','chartecontresceau.GIF'),(5,46,0,'Adagio En Sol Mineur (Albinoni T.)','URL','http://multimedia.fnac.com/multimedia/asp/audio.asp?Z=L%27Adagio+d%27Albinoni&Y=346265&T=Adagio+En+Sol+Mineur+%28Albinoni+T%2E%29&N=Albinoni&P=Tomaso&M=Forlane&E=3399240165271&V=1&I=1&G=E&audio=/1/7/2/3399240165271A01.ra','','','',''),(6,46,0,'Pochette','URL','http://multimedia.fnac.com/multimedia/images_produits/grandes/1/7/2/3399240165271.JPG',NULL,'','',NULL),(7,46,0,'Canon En Re Majeur (Pachelbel J.)','URL','http://multimedia.fnac.com/multimedia/asp/audio.asp?Z=L%27Adagio+d%27Albinoni&Y=346265&T=Canon+En+Re+Majeur+%28Pachelbel+J%2E%29&N=Albinoni&P=Tomaso&M=Forlane&E=3399240165271&V=1&I=6&G=E&audio=/1/7/2/3399240165271A06.ra',NULL,'','',NULL),(8,46,0,'Choral N 6 Tire De La Cantata Bwv 147 \'\'Jesus Que Ma Joie Demeure\'\' (Bach J.S.)','URL','http://multimedia.fnac.com/multimedia/asp/audio.asp?Z=L%27Adagio+d%27Albinoni&Y=346265&T=Choral+N+6+Tire+De+La+Cantata+Bwv+147+%27%27Jesus+Que+Ma+Joie+De&N=Albinoni&P=Tomaso&M=Forlane&E=3399240165271&V=1&I=5&G=E&audio=/1/7/2/3399240165271A05.ra',NULL,'','',NULL),(9,47,0,'reproduction basse qualité','image/gif','','GIF89a\0\0\0qִ5,#qL캌׫ri٪蹮ϗjə͋VV\\7ݸuOx̧˘ٹɫǈتhȉͧئZךsͺZtcVͷ֚؈i<鼞͠A#>DSζֈɉA\\¶{nA?pkf!\0\0\0\0\0,\0\0\0\0\0\0p+xP&)\"SIzxL.O:bY8ͪ\04fYr%iWVV\\gSIpo~\"\"}z{EbNs)~ol1	\ZśKBqϚt\ZŸxw(!!%`	F0`Al)\\\ndçX8qxCgΥTe,БO 3?r$/]#T)P65*U鄫Xܚ=EԳhf6)nnܻQ-_gjp׻DB\07K6˘\'%Yf3MհVHزBcM{vϜsM\Z4oOSsELxB}vfm?ܜucONCj]XyѯUq~^Ԃ{8^|}q~!9.: Q0H\"8Hh\"(qhBը-rZ\01c\"X.9ߑ祃<&:dR\"$Weeݖ4bt*gnx_9(&=LvPV2`D+ɜzG/e@5$IbFfD(sN(BT&\0.(O0@-\\:۰T*FE\n)؞;$i\"`릹CB\Zp}Oj)PRӒ˪9X$0[¹\n0\"\\\n߼1Sa10C}(\0.l-*9%@S\'\"	\ZcmIZDC)\n]+><%ltPcl\\K.h,Ŋ\ZBrl `m[(-(/p`L<+yL\r^7t]w싁l<|0薷}.3\nVa~w[>\0+f65^5],\rO<7?\0\'K>%.\0	\n!z>kmgNuuO֩̊wIh<͢D	Lw	h\r\0\0pO}m\07[Kd\0bGaDX:@/9}cg\0HjQ.	0Xx@JX\0@1hקR\07k_8h\rBwmWK\n\"Lf!,0o:crM&cnqN$\'IJNR#@TЀa/pU<DcU\'OZ_	:1MWp8`\0`ɽ9O4+y@\0a&eӜwyv$Ѐ.\n&,Q1\0\nHYK`` %hpB=DB #<Ѵ@\\@+SHņn`lC<svS#Ғ6oq-M˹o{Y_nsw(7!PyG,j)TFKA!׃\0$( J@JHUԎmTh*ҧPrP4J1ך \0/\Z1lE\'y5!kMgDk[8~|0_rJ6]3E)VV*m4a?ׯg:DX.r ya\nf$[,b0Y\'Bz҅l*.LxVXy.,\'jF\'DdB%E_~D #0^p7\Zha_UӾ80نOY\0ܝUF7iV	8N)ƅ4	uWL\r`&\0y@n(!d	`}/ыt3sM8(!6K8*bWl#HZWgAUеhA\0QX49kG\0arUVaKeYt\"|,hptjs\'vZ\0mqNѵ͏=\r,T=6Uڰ)pQ7n9\n*pnZ8l(ܒ(|́f4xuWNHx_>-EMqi_gc<LB9K֘ZlصY^)0hLD\0XHYf|< 汑5 )sREasVwiծnfyp#1̉\\XƤdi$2,fJl,Zxv6jڡ\r2KF^\rZzXW,uorkBZɦ]b\">\Z}:\\y>[U\Z}``<ڪvb\"x)~J|\ZXOQ\0or`Jn&ï  py^@VZM}BQYG֏X;*	 |j\'\nLVi2G\n\0\n]]CwQuSJpg޷m|ig<1br7pg{w-\'7gz1Gu6ĶlqDHW7\ṅ\n9``{-\0]s|GO\"$Wx\0!c фf\0\r~%=qOB\r\0p;O8̳3s=F`(f85hV{3@1YxvPW0cRW\Z$o.gH,\"(*tH8zD]ېA%FEYH\0\0`gb:w0uR]-F;ԈAqs1ih(j\Zauaܒz9`Z\0&prÇ\\mpLR\'`8GoqP75鐣@CȄ~z|\\i5LHWKeV5t-T)Au\ZaȊ7x892HV30\ZYh4 :\n-2x|uX]<<!}S0;v+1\0C)\0kx\0v\rNI;5r*(^0-G\n\'?S\n(˨p?)RG\Z|_gqlȆ|yTTrrcsx\"[ROa$ZxfUi-wEBt]\"*(Hsj55L!Г\0Wyp噜hO|7WgB1(4YRIW}Cٞ0Cg\'Oȸ.R$<Y2(S*W8FAjpo#:0ZI0y0lڜSɑqH]|FP}-vj,XFE4<ڝP5U\n19)>eB\nmg| }#sS(sfdօ]#I4}:P\'<<:0$ZjJ\\j{Uylz8Yq3ڛ\rvل8Sduj\"WJ@e\nbyS3S\n}:(bTD_zqVOyʞ̹W؍Y{De\nj󄯗 Zsl04f\0z| Κ )ںɎڦI:iDP$9\Z/J՟/K\'󙲩y\n{	7;9Z&$]F7:́ސ#C+{7ۛ}\'ς)>\'9{,i\r@m[\nڶ5oqH*#^|~+b).;\Z4yՙ#*0;rR똕Z[bų<G֨\n=xF{Z&;MKM˱b	*#[۰}ۓh(s[&88gȺh??()[C.sh^/..zhC&;jb.g򗋬O鬜+^iL\\`	j8cwJ3iuʔL)|e\ZJ<܇u\\6 :GEToʕv:\\G(CȜ[v)^c4DL= A1E}\Z36kGCYK0 &gJĞIڰ{\rc:ކ\\cg&~t(Ǿ[;r\"l`/j|?=z;oܭeC󢿲dkry3W*R@ܺN\0ś̫ʓٛ,C<|\n+еpEdOm.˙0ʼ\ro,HάڬY5p)ωͷ|ʟk\'JeL;ˑzK.;\rϝL-e)j@,L:0ڻÛ4$Ja#\r!ͽ2\Z󺪨360ӈa{k@?~),+lu)--D;´WJ$mm\0L{bIJ-MM,ͳ<+cKV=%4]X$ט8_џ.,Mp3>~,ϐK<2@=-[8ڡ+֠ץѝnt o:Ӧܘi.؂Cܼ91-x*=Z۱E͟sm\"D6<#@p 4xbH}Ɓh(Pfc}\"$q,<܋LL|q(䇭EB-[DXf(2n1\nY= }ߞ=Sà9`-=ʢ:Ywvhu2-WBVk\rĽ-ăk<yݗ06\0}wm&\'4g#>%Enk\nͪבck~\nG<`íq}el\0)ȇ3绉<YnK$2\rq΀w?{y}&L:[,ގk}fkP|٣g\\幗w뽉7ΑC1=F%T2ȱ}wI(CķTӕ	ĲلYM/|L\n	`E$7(jIܰ\n=>f3	؋Yb*JzCP@HЀ	ps`PH<,#ۋRz[~7sbge!^N-m%s͒V$\0pԆln\0!sІXo׼4@6w:o x/\'y+w_[z<EaV%	\"O9]\\OƮ&1D_CoЏ+V\'\Z	WG,9P@_o.w&4,g NW\'/](eH$v(ҀlX` -Gj2ZaVke@ `ca![bB;5@4hz\\Brh. ##&X%9;	?AC<GKIOS100ƮN` *<ho p_\0=R)-{}Qf5QMËϡNe]/}z}/<\"H .],P\rܶnUD\rq v_a)-4aYKMU[Ma\ZxnSOsB!e<W)h<b`d?9\nPĈPޅ@ΠfyT5*KMa!hqp-k/X\'-@WeD-್GVx/3j$	[\rd̲	y0@QfXs!7v\0dX\0$V/}cŻs|@+̸Ǘ{D( gbY֝;zkE`KWoOO͛KPNa^6b零[!3|l~xmva/ڈ\"@`	 `6Cnsm	ib\ne\\\r9԰gϖ+s.㦂)xio:7@Ӏh \")\ZK=+J*	r\0B\"\r`#73Rt-:\rTQc`\n8ԪφĈN\'VpUUX\"(lqO3\rʹ\".O$M8O${ĚZ߽u(9F-#SFXuǙ3Luhyd8\\*tWuǒ7ޏs$6/6XGƜ\"\\U_=\0Xd)XWGm}ZjKx4t3;]5^BG5̯%c>\ZiWxꨧo}3$Ɗfa\\D<^<\'Sz;Tgֿ<du\"/_~s) ?Iˎnxiu7 6\'YOBBRzbNJ@lV\nXэHLHx^~Wz;L${\'ACQ.	Wp_d`[M~h;\ZiRei#<_AoWC\n:WLUbvVC0d1T3Ɖdw!yx4`ǃAp<>\'\n:P42@i&ˡKE Z^8F!LJܨ9R&+\"%1\n 96%E?摈:1\0NB]S\ZQ\'qc*<,\Z=\0WVrJV1O%e$\Z.L$Ib\"H-#vH2x^xRӋڼ(ى=Es~b_5RW>n%NPj487bN_G!.)\r$L$nI$#LJ[Z(d<(,&\ZS<DFiU6*U\00Sz<qp4<j:E:M]ě˾r_h*Z-&\03s\0iFC4	@:I\'HQAX`0ߜ\'h\0հY[CM̐]\ZlD\Z%AMmiA׸I5*Z\Z\0E\\6lrX\0@Zn֏xNg\nF\"gJަOsOq4#i@]? 8Em\Z-ܤ-\rT $iZ*@LuK_f!)\r7\r\ndiD\"E9.S$ŋ/%\0EWSɵtrhq9C([K4a6쿒<J<aDDh8,Y,`iGDA|HXUhCn wp3ތLm\\rUmʻ9\"_Xu/;t$^Wo(RKc~06\\.Xtw	L\n\"\\hҁqQB4SW.\rh\n}=ء[\nYkNdn/oRFږ>@#GD{uz`X瑇vasw\n_(Rl\rEEOx	i]|:V\'V/9C\"ǨKԾ\"I;v_<1}B=̇3AG9v/鈳4ˈקFTDg9NhDyB[I7s&۷-oT|ù\n~(WZ\\kU=CWLYcۀQA-2>m.\"^)Nbx;Wt2ps板̃kWgSkXc&%QW\0op譿Y&h\"gyq<a=@)=Ԑ\\q)m˽rSY9+2Al\0r{pe\0\r\0&`DRH#/ќԤM-\nbO\no)<(mQ\0#>^j4@\n->@s9\r\Z\00`\0*\0ƃ,>6Z6t6&<,.U\'wJh2Į`~&h~gxjAϚfBpFqN\'p̦\Zz,Nd6рɒnPƃZ(Rf$]1? \0n1O-7H]\rbpDvt@6\rikvB2=L!<hg|K~	;vQDpee#{sd0|$af\Z訲n}rmWTE\0tJA&heI\0qLw17ao%0\r\0\0#*oy )zI|LН.M.zvzVL,d ܆EM~fd\0Ӳx2#w\rXr\Za8J\'	| 	<z;T,$\"%1ŊeMhvL&s1a`\n0@OsdhVKA/i3DnMA/f@ lR !磻7B0\ZeާD&s|M -1ϯ:SuP#\r_:$P\"P:ҘCT|,~E1/q_>\0T0\0+G,z\'-ᛔS\0$:\"S:9Ps.0@.1<8AJ\0q%ak$$`-x\n`>@ղT@btlFˀB}Q2JԘ\"jCAT4&$?ES&drLRIhR%Kj0\0zB|9tL$/S@Ljp@!\rYp|ZN\0_02?{?	+a&H	tg,@$3L2\"X-2A02NQ-ÒD<o1I!\nA̽iSOVs\06	A76FF[ŘrB}1WY]mY\"DX1!-,)c!)[]ѮRTk\\}\'\05!BT.8bJќo5Y	;xSM`]D%)J%2܎s/I	(Q=]w	z\nRn*^4jP(k0fyUgMp5p§l%\Zn\'ˆWN 0%?Qc=$<D\0Z]҈h\'a:̔lPeӶmEs a65Ly6mvRWa46^\nnT4_.rpxwvoC5RWӨNskl9\0漗U:tHp`nGz0C=^qlv\r<9w6re[e,wmon*Ar!pJhABEw{W7W{{;xGLʎ|5B;P7(7P	Rqt$).c7tkdvyzWvl17X{\'0sl1OC`Wg;C8F!VhKWW..גx8@Ņx;V1GMӀ$/xμX{YmoOƘSGվ k$vE\0`5}k-v-G0\ruU\"\ZvH-=l\'*E-J@!6]8lDo3%=${v̲^فe##\0aOKDkLæwJSY{8Y9Xv2\0xw<tF]͗3%fd0$\nBzK\0̌lŏεP٠5rb2\"G@QW`zntk:?{;3j`W.禮&P\0blymcO|EQD:,uڽzyfU⨯aUtSI\"\0T\Z.i]kKybxa)QM~I`%yᒡI8~5Xj;TVZUZQԃBH%tb.f*ORm`p	\ZȦR#ΞI2e♍G\"JvlX\'nL*?c2Zkx*`1!CZ<{xAE@tn)zC!HxhERA\'Y;Iy\\0tQHOoM1vN=\nU\ZY{WZ\\Kx;x|2s:]|E#r\n; 4Eolsqz\n?4`Y	1W_\'|	k·X\Z?\'R;\n#!RX1ƸI\r9~Yڭ\'pBZeҗ!Uss,8H03-CsVuɿ0]̅/8}|w\rM߼?vw PPyN줎16XUEw&k爦RW3}uէ.Ks	ڗj<?J}gOȦta_ȱ^%8nlY=|v\'yIFv\0f5KLm;vʠ۹=e{$?gzg\Zg]ߢcLW~/\\ި=y4ݹEJ[DVL?8+[X1apw\r4fOٶoFþ^iwAQjQyg1\Z\\1tKI> 1ە\'9qq#ݬ/Oc\rP3ǢSXc޷|ޯ`Ϝ\ZGu\nVO\0Z#$>X(I%Y;&fȣe8j\"\nM\'t2H1lh\rp{d7:0t1\0^Q .,@.LN2*&)ȍ\r؝兪\Zq:HHښfV\0_\"n$WhNE=MI_i900on|ݴ;\'^5.<\nHRX\n)P$T2uĜr<\0\nZn!5WaR8\Z;q|4*\"I-aĔqpQw+\"ܵFG4V\\~\0^)^;YRԪ7%JU\"d\Zy+vsbQ9(Sh\ZYN<F$ :&Eէx<wQV+=cP@j.%;vL~,\ZPwz[\\3[VjO녦6nk^̮>s]	m=]ToCQIByCJBƛoqD!ߕt_,\\=$Rf{N{sI%X} @Ǟ0wA!\\5$8,RF3\\&\0\"ᄥd3J\rVx\r*T Q	~}8,~G@4\0Zxs7.\">]Yߐ_9Zll[RrL1Ts GhES/DX@\0aB.ة1bӎh6DCGSD醍QMAC*~xEG\"\Z{ꇥ)B%\r*NQ9\Z,vu	^ʟP6Z@5:V{*tl6n g#eɕw`bPt` 1ax|`|NxrF̢nfJ;Z͗l#P[.1dyWxQ-4!,\'oyķG95$hk*Q*JtN\\uMكlxg!hYڭ=֦p$, v~\\\"3Q,ޒ۹8yaJ \r@Nտb?yi=x,LO%ZZ@cØB2cIm\0\0#0\04X<G?\n+<\'\rLpʙ%\\uP_:g|S]X!yF$|-b81%,a`+UJ>alD$\\S=#͛4ylv)m,2O3 s#B=kEBmK3`-f	gXL `T\".l,QZj&?jqpxWP&\\8`0Y|[X#1Z[IQ[f06:Џd\"TUD\'Od*%]j8h\0[G+3~3\\ElDU>0F4:eE!\0F$#^J~[-yP6p@v#/_/2҅1B0L(\\qONs\'ph!p\'H?ctJ#ճ>tT-QO\\LSbh>44]dl*-P V)?.!ŞveʤL-1xF	13D	EϜzO~)/8jAiT`NW=& \0CjlV\'0UKfxUSy\np1NC\'\\h*a+ӽ}4k_{,˂-Prf!f#!1}\' mXXrh@vLg_z[;xRGHTm\".e+\nGZM5L 6b)>P<g;j`[\nؖ(=$oQؿMF6Zb^06eh&wh\"ioݠ\\i6b~N}9X\\^v-w9>hdL3vEuBX/gȖs-x+u2L0}c`Q^0\"Vi[ۯ׃!v	.(윥+s{fY.З\"	nhhBvVw<LkRd\0eՁDNT~Lܶ-N5V5sPrdj\0?Q#\n\r]XK[0rm>ԍ!VPuGW֙GD\"\0y˹	..17.\'.ŵLz#CIpcU:@W-Y4D	@zD^hCʫ+j/fHr\'iz<>U8c_Ny=uitGj89DU 1P?8vپ?*k82d7H1?6޹]j*&Rk)yj\"Eʩ[\0=Sz`\0P\rA\0[_uw=ھUz:{>\'^D Yκ71Z|_ĹD\nME1З@Z10L\0䔄ڡޱ]`gJyN sHў읃LgL\nYpX|mC^Áa-޻aD/I2-TUeJHp	JaPZ\0bi\r%I͋X\0a\\R	K\nwU@@	\n\n`@oAa\"*b\0ښXL!^LiEMs\\p\Zf,	\"!1y*Кa9IKH!#PE@R#\">-[t\"	(BÙ)J!rpy\0\ZgBq\\]|ʜ\0x,\0\rC%@	,@̡?#UYZYz]4b5a<lé6a#s͡@@%I0eQ`WܶV>茁cM#jRbD%^&\'5JDĥL) \rT`U;NUXBB\'@?!NZ 3b\"t&e=\\d(^E:~b[6\nWT*UM-:]|@DMM*x9Y2~S&e㷴^ОP_^z\'\\fB._AE!M/ə@(qQN7h!rPKeuThv\"\\jؑ&&5lev RAn&Gϼf[pdb,bV\"Qd^tN|cQKNʂƃB?a}Z	x<zzb\"(\')eͅN̄֩K\0纀UQ]ciuccVa&\'e\"A}]H }ƬҦ|oj`p˴L@+;ڋ\0(3׏F\ZwJW^(	jɔR)l~]\"Ɉ@&Z:銪L$CYB%Ӝ^u6g:bvajN\r2B&:̚ӣBYoz32ujX@}a\n%Ecu~M=*+\\FP2<)j\r_a*VB&i©#(a%xAvDe)*Zck+x%~=Lb.Y$\"&a*Kd.)A闫NI\03T>@gwN)gX*J},s|WҩA^h.\rP^I@;\Z0PTDdJ\"h.FቫRR-el$}Tx!QfIVڠi!`v\rQR`@zC$@M06R\\P]]yت*uiVF	G	\n*iZ3b&k*r*jJTD;Agk`Vrz>Hu$ZeROG%g6Ec{PXYSQ_v\'~`8R͂1anDuIom2)\0P@.sN\nr@hJJgrV9cRbGh4,z6p[kc,丮J&AlA|pU^@ARo4ظ$@e@D\'>b[iV9#qJ.ڥg%CB@Xȩޯ\rPMd)iڜ\r;	Ѫaٝv(q2,Rj*O+xrYG@1`ȓP1%\"Dec,׹, 3>t븊24owi,-P].=ML9,Ĩ*3qEbL6 nv\\~s˂3g2nr>t\"B+T#Q]\0!(O@\'h6Gb41BSXB/A3UUV,IC\r\r(He`=\"EF*$[U捻)M۴<=r%3+K\npYA/O3q]74)t0V_L*=״]g0bӲu\"i\"N4mP>oa(Յ1B!2dZ	m\"MhLu\"Zhe	2Zn,ReeӦEw4n\"Gj\Zvh5w4J2mƖR<;+F[T.Q˵`z,3iy\Z\'hkR6⁦KW6ysiw5ij:N}&Ee\\=ڷmw~|B#3mZBDiv+6.IӺSوZ\'\r|/b|f&sǜQ!.\n6aeWcڧiTq[GwX2x/n۝_q7\rsaLx,g7uY@iTv:e{@\ZZ-vug7x+gɀAeNo7,\0kdxs%67VsF#o`Wwښ_ezt~twW&5\Z6-6 9C7:Q,6Aw daW\"x8ӮsVhI+1fx{{&g`#>Qo̮{*Yp1*d^]kd<ߠI͍8TS3N:e>Tb;xg}	Pβ)c\\#PEsW>z=z)p0r#YN3S᢭Er3-r\0#h`_Iˡ$r<D\'sfjm޳wd8L@}}+9;?\\8N+@lUպo\0\"wC\rE{>Mg 8.6xkn#Y)u9yqZuhpB\"Ho~\n\Z܎Є:ӬzxS/i\ncսe޶\'9\0<N)H>T21lVِ4n\0\n@fqM\Zb@/?~{dyda+̫\Z[9sjд\\p(9=,Db#,jQ+qXm4\"3Brl=kUvYl[Cq-d}Ė<5-Ebhb>,EApEן8*5vD>dP\"MAeZ%R0\Z8eȕ;WKN@\"RG>\\f\"jmDgI::\\QRM2ݦPUCjYdR\"ptzg\\˗d3&h\"ϥXW]76rr,I0.\\qXf3kR\0|8H7MU@ħu=A\\c$BsW+ůjҼݴqTmW\r<\0tS@8Ee0_>3q+h%lp@/fS9YčX9΅zpZ@P<$948:O\nlm/hNb*%ɍrfi\n\ryF̕	%#F7(C{1	\rkYGFOh*NI\0\"?vS\n8Xig\'*QuE$JϮa<iaŹ2xJTj$SiM,hCDTӎfB0\"\\\\:XbCPa+z#DZaĢ0됕WY \rH\'_ 5\r&ͧfjb%I6aΉPu+al5=	$de\"p|S@\"r9ͅ@Z[zwoWf4nIvLOflH8u!\r@/	Ae\"@HKL	~q?٘vy[ndJ\\s5K)uReijЛ?AHe81Ggivz\'yS2Qp͑F0+q8Y9_\Z@\\o~*ruhA~b=dڭhrJH̉YG!pc û0J{tǈ\rґiX\Z#R:|J_\':3G3]$ 2I%<kZg$}\ZQ줮ÝEJ2	UmVSaks$~9 Ȃb%(9pZg WJPo@<F%Rqb	hD\0uK( k\0)z`(IzD\03,&&ŦTIv/㞔3)+	\rk$ c\n̈3sIE4\ZX	\Z5nOp!KiVN2dC·\'-2]\"E@p!\0 c&IK3Po<]TX\"\"Z7?ho\\D$ː|dxp@&=- 	XxAM2Ǣ`AԢSІN<-(0t6Хta(I!Y)L?}6Plu4#8*rtj:T\Zu=A,P&\\BQ3`sa\0\\.548Ѐrvi@zP@^PC\r,aWwK+bю7,d爊\nsd.[VkhAWW`\'ϙVdD13MXhӀF\\nFH%se@-/TVZI2Q{PܚVH(9-)L4n}uԾ#w_*!}W&\0v<_r1eV1$?l`>	aMp}7cfhKw0\\o{b#w=q̰<rd&9z.A`6Yd._>r&yYgo`4,sl1vf❅\\g=/>.La+v>n}~ i9sRzϒ\'ɚr\0Ȭ1GtgTWysjZy[ke\0`ˍOW7uYWjF*#P&6t̈b(	<\\X%|Z~7So~+`8{\0@v\\dY ldUw7wǻ7vywM+5ÔG?ρ-h8TCi\\/\0ˤLE\0Pka\0H17̰u\r,	N\0\Ze\'nz^C^FڅX!gߎt[k	7lui;^\0\"r>	e \0iA%䇗;`^޳(-b~>T\\sтGjAkiЅDo>|`a`6<_\r:to˟+<ὥ\0??f\0;#a,\njκʣ$(\rؾM?+ڽӫʛ[A+>8A\Z<©{b?s&\0۳BºbB,Z(!P>Cԁ4ܤA3,:\">:A+h [B\0E>>4D<D4\"BDG!G M8KdD9\Z#E8D<4E>VlC\ZE5E5eZXCMXExZF[E\"bDFeReA`th<FiEh|k_`WtVGr@kn\Z\0dtwxyz{{\0;','\0JFIF\0\0\0\0\0\0\0>CREATOR: gd-jpeg v1.0 (using IJG JPEG v62), default quality\n\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0\0d\0P\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0Bhmĳ9fJ	\'_[@fi8Rxq<T|`g{Q1-&*~x9b}hd|(X2I/Pݜ=\nq_uk6ɎrFÐ@?7L3qUu?i:;5nҌ} c[;MVܛ& q+U0g cNp5H5}OwKOdZJpUs0GRsQI*+\'cIh	\\ڜ3qA2oiYڛ3ު\0ZH8KKԘggV@9.{pV)nI2\0u͙K{L>4͵5XU,N=\'tk.\"[1t=\n<`Oi$ui+qکCe,40\\%öh\rT<O$\nF:j)UɈFCc\'sVuGhZ.l2+=T}A5Ma./bӚi\Z4PFb\"TއW,@ԭ\'NΒR6NnPw4;Y_ه8Ld?U\r`(ڧ\\j\08PH#cH3].xdQiE\\U)tƍӁqמ3҂B?*wݳq*[NqJI4ؐ9mFTα09l}|h?T?ia*\'.߼<ޟ4$KwFcwZlG2,Jddqx4\nlFD-nK4t֑gDh/ IHGHJ^gIdkA	SsϦG\'{ԶRx<pKmyG#?ZҺڕDrzT.tx	uQrzwqѝO5``H>r;mF\\uBU^7Ml`9FL]KQDԕQ9A82M-4ms!BzH/w-ePA8N3\Z[[9p7G8^0hKq(9;#GT?컷bv]\rc<]5Zh孑ȣ<u<q o5[]{	\\&z#}%O7A_*d\0C7#p)9\"}WѮl$̜D+	\0qU-R#83;\\3V8RЩ<ud\09i.)6/ʽ:\0O΢ȮgbwI<ǜ$qҙ7\ZuH2w1ӂJ_<lǂ\0p:dpBOZѕGx|M73#\0\\Qr[%6;qMjxW\\-bYWq\0P	YM\rb7t[o6\\OOOXFF8^u9\ny-r$k~-(rA;Eyof*ܛ8-.<\"AaT&aH<TڙBGbNw:89=#L6)0H&E+@r;R1#<c-,c(u8i\"hen?lUtG,\"f ,8;=N{*i\\HQ ߻\0<u0NT39JCD2Mlcr!8=0?uAQފj7S8\05JQyV󕔰~b\0lyƯN}cGEmAta[(ŞF0b%W?籑a*|eWkcs\0Fuی{cU,mQImNx\0_;ӃktJ1fb7`9*[Œlf#V:Ghd&P$xʶx$~U+A3F7\nT\029s4fh۟.Bd ec`r\0`R[]fťUr%NF	-^3#>fkYB03XSw8P33\0֭p3ІkkfK&#;FAqQC2\\Bu\0m$5I$vS\r`+g۱Н~>&ò0*\"t9Q qkžH[Xd8suëlevm \0W8Uyj&G+J¿}؅h6Y5@m<*Јp2b#\0I<o5ܲD;Snr۪ܫ1QЎ8=Xt̎=Y\r*Ʊ`02x dɦ]çD$Bz`q:#$=s֖;7Ւx\\\0YG~Φ;>ht9=\n2,2l`={Ϧ%y,JrS\0`򫫥BHFp!#ӎY4ٰ9o301x`nOqD>\"uC,tG^?<O(O$\0\\\08$;g2:*V@*ʨ3vFqZ %8 (~䎝=yA8N.7.[zҵf\\kؠgP$\0g]ZkW!P\'ۨro˯H!zAinp,:g6!Gcn|+Oi$ \rUҹcjjYQ^?N۱KS\0_Rw\\\0?J|1lbh #E;<%m԰;ßv`čGR\0QKð_DdS֚<%`ȕ_(p]{I>7<^ܘtfs~ԶNF(%kI!/3la!}VOBe&֬','gif','scan.gif'),(10,48,0,'photo','image/gif','','GIF89aZ\0\0\0\0b.*N-kRdҲЩtj*ҩqA+ÔUՉ5ǘrz-q`JĢ\\,gE,\'YA-ɽ_AGТa޹~H徆T#!\0\0\0\0\0,\0\0\0\0Z\0\0\0@pH,\ZaT)ШtJ>lr˽bڰ5:F8Y{x>χ}M] ?s;	#0h$w&R		)(~\"%Pˈ\"1å#䙎,ۭޗ냢;GV\n̴1&4fm*8qz]jE`\n70]ZdcY nB/ְ-j[xI\0eLݰt95[DN0WV.>X\0\\rc,j@ԸpԵ놵{*9P2,M{&h&PUIr6@j<N4.eS=i޾?+POޅh.L\0tI_h@swlҊ\ZyNǛ#	m4ZBʥ ]%su&:!{RE(8Sq( qXI.QWBD܀ L{5Q\"5g-&fs\\DyGX!T\\tNؐ,]`qݑش_HЍ@l%IDLn#Q9ÝKW{&f	h*47V cYyGY&Y<XJg|g jmg ڝ7\0*fS\"K+F	Đ\0f8,Yiؒataך+hA OC\"0LyY6ƯIS#\0R1(X |I[nʖVq4<t\0#o7IZ2GD|sCsN3ռ,9ҵB[o3iJwI<rO7X2轻7߬#Lxw7Oهs\0\0;ON7-[0N\0^-uw#/8ߎ{:O^[@oz<3fR?o=+b_o/!zϻ82|o>./3wq,Woq\\h,`\0}8	p\0?R\r%x8@|Gu=!\0I̓(D5Co}؄N] )\"0XD+φZ+08bS+0j(\'ڸ$QC(E8j M&쐇\Zt0Y4$%$\00`pKQvS1$%zHh?F&9X_Rv$d(:R#1Qa?O>bq$%7yEs*iM70@\r_V$Xm`\'3_-f#Q>fDXB4i#>ȵ\nl\0;xN5s0\n*RtdPzD?t!)jxSˈ!Rϟz2=DYG	4GxJL!FV\Z\nQDU ՍPl=A*Ps((h-.	5E\ZRQNSU5,Bt%K7ׅ@|s}\0<XsZ:51x2tSgWp.e`\"Vȹս&m*jf6voK7u󹖵TǇZiX\Z񵖨?n<5խB>V,f8^Omp{f-+Xyme[.\0;','\0JFIF\0\0\0\0\0\0\0>CREATOR: gd-jpeg v1.0 (using IJG JPEG v62), default quality\n\0C\0		\n\r\Z\Z $.\' \",#(7),01444\'9=82<.342\0C			\r\r2!!22222222222222222222222222222222222222222222222222\0\0d\04\"\0\0\0\0\0\0\0\0\0\0\0\0	\n\0\0\0\0}\0!1AQa\"q2#BR$3br	\n\Z%&\'()*456789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0\0\0\0\0\0	\n\0\0\0w\0!1AQaq\"2B	#3Rbr\n$4%\Z&\'()*56789:CDEFGHIJSTUVWXYZcdefghijstuvwxyz\0\0\0?\0@LXyp,{\n\0kkFyd8DLmܻƭDmXQyr2#W8q҉o.KYE,,r-i\rPGR\rp)KZNcw;1GҢmB$MKs0ѿP?_7J\0`\0lP#黋`y` 1+uuP٫dd\0^ڇuk<P\0\ZXi6ikjNzp+-<3ZZYJʄ<qg9ka@`nq5WG-+%o!=JG٭w2SRi:w[0~P??hӟV*?-Ų]o(Q|_2_J՛Úk.O=* 8ׁJX\0[Ʃ\"INFQ!}IЛzGU|?g{0d`֯1Qy{ljqz\ZN&9&wc\0a\0`\0lQGB\0Ѳ@OYƅ?`x԰V#cUN!x)ZK~=A:i>$R;,NXf?\\M6|v`0ZB\'vbygN5#]@\0a\0`\0lQF\0B\0T6Z(ց@◚\0uj\Zq.m\\G	.T@|m=W);̨ѮN8^kmώ(|VKx/{jĥNqov\0y	Rid))ݿ»N#7J\0ѲG\0%\nQ\0h@3Iޗ(Z/v+F#QA+d(p\0zp6=w8OgVq4>I<ǩ%e.w)Sk>\n\\Ii4{6$c>G\\JޫCLL9j;l>a*?-~ѿP?9ϧE\0(9#_ZM\"·ۀ;pI}I@4Q\\UJ_׈֜>\0%\nQ\0٨9','gif','scan2.gif');
UNLOCK TABLES;
/*!40000 ALTER TABLE `explnum` ENABLE KEYS */;

--
-- Table structure for table `frais`
--

DROP TABLE IF EXISTS `frais`;
CREATE TABLE `frais` (
  `id_frais` int(8) unsigned NOT NULL auto_increment,
  `libelle` varchar(255) NOT NULL default '',
  `condition_frais` text NOT NULL,
  `montant` float(8,2) unsigned NOT NULL default '0.00',
  `num_cp_compta` varchar(255) NOT NULL default '',
  `num_tva_achat` varchar(25) NOT NULL default '0',
  PRIMARY KEY  (`id_frais`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `frais`
--


/*!40000 ALTER TABLE `frais` DISABLE KEYS */;
LOCK TABLES `frais` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `frais` ENABLE KEYS */;

--
-- Table structure for table `grilles`
--

DROP TABLE IF EXISTS `grilles`;
CREATE TABLE `grilles` (
  `grille_typdoc` char(2) NOT NULL default 'a',
  `grille_niveau_biblio` char(1) NOT NULL default 'm',
  `grille_localisation` mediumint(8) NOT NULL default '0',
  `descr_format` longtext,
  PRIMARY KEY  (`grille_typdoc`,`grille_niveau_biblio`,`grille_localisation`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `grilles`
--


/*!40000 ALTER TABLE `grilles` DISABLE KEYS */;
LOCK TABLES `grilles` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `grilles` ENABLE KEYS */;

--
-- Table structure for table `groupe`
--

DROP TABLE IF EXISTS `groupe`;
CREATE TABLE `groupe` (
  `id_groupe` int(6) unsigned NOT NULL auto_increment,
  `libelle_groupe` varchar(50) NOT NULL default '',
  `resp_groupe` int(6) unsigned default '0',
  PRIMARY KEY  (`id_groupe`),
  UNIQUE KEY `libelle_groupe` (`libelle_groupe`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `groupe`
--


/*!40000 ALTER TABLE `groupe` DISABLE KEYS */;
LOCK TABLES `groupe` WRITE;
INSERT INTO `groupe` VALUES (1,'ນັກສຶກສາ',7),(2,'ພະນັກງານ',0),(3,'ນັກວິໄຈ',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `groupe` ENABLE KEYS */;

--
-- Table structure for table `import_marc`
--

DROP TABLE IF EXISTS `import_marc`;
CREATE TABLE `import_marc` (
  `id_import` bigint(5) unsigned NOT NULL auto_increment,
  `notice` longblob NOT NULL,
  `origine` varchar(50) default '',
  `no_notice` int(10) unsigned default '0',
  PRIMARY KEY  (`id_import`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `import_marc`
--


/*!40000 ALTER TABLE `import_marc` DISABLE KEYS */;
LOCK TABLES `import_marc` WRITE;
INSERT INTO `import_marc` VALUES (45,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >26</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ວັດສີສະເກດ</s>\n    <s c=\"d\">Wat Sysakhet</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">650000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"0 \">\n    <s c=\"a\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">220 ໜ້າ</s>\n    <s c=\"c\">ມີພາບປະກອບ</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ສະພານທອງການພິມ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n    <s c=\"d\">1985</s>\n  </f>\n</notice>\n','005472001161679380',19),(44,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >25</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ປື້ມທົ່ວໄປ</s>\n  </f>\n  <f c=\"101\" ind=\"0 \">\n    <s c=\"a\">lao</s>\n  </f>\n</notice>\n','005472001161679380',18),(43,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >17</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ວິທີຮັກສາຄວາມງາມ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">73000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"0 \">\n    <s c=\"a\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"c\">64ໜ້າ</s>\n  </f>\n  <f c=\"300\" ind=\"  \">\n    <s c=\"a\">ການຮັກສາຄວາມງາມ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ບົວໄຂ ເພັງພະຈັນ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ປາກປາສັກການພິມ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',17),(42,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >16</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ຕຳລາຢາພືນເມືອງ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">12500ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"0 \">\n    <s c=\"a\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">125ໜ້າ</s>\n  </f>\n  <f c=\"300\" ind=\"  \">\n    <s c=\"a\">ຕຳລາຢາພືນເມືອງ ທີ່ມີຄຸນປະໂຫຍດທາງການແພດ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ບຸນສີ ບູລົມ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ນະຄອນຫລວງ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n    <s c=\"d\">2000</s>\n  </f>\n</notice>\n','005472001161679380',16),(41,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >15</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ຮິດຄອງປະເພນີລາວ 2</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">34000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"0 \">\n    <s c=\"a\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">35ໜ້າ</s>\n  </f>\n  <f c=\"330\" ind=\"  \">\n    <s c=\"a\">ຮິດຄອງປະເພນີລາວ </s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ຄະນະອັກສອນສາດ ມ/ຊ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ສຳນັກພິມແລະຈຳໜ່າຍປືມ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',15),(40,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >14</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ຄົນຄວ້າວິທະຍາສາດທາງດ້ານວິຊາການແພດ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">78000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">785ໜ້າ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ຄຳຜາຍ ບຸບຜາ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ຂອນແກ່ນ</s>\n    <s c=\"a\">ຂອນແກ່ນ</s>\n  </f>\n</notice>\n','005472001161679380',14),(39,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >13</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ແນວທາງການດຳເນີນງານສຳລັບຄະນະກຳມະການ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">8000 ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">96ໜ້າ</s>\n  </f>\n  <f c=\"710\" ind=\" 1\">\n    <s c=\"a\">ອົງການອະນາໄມໂລກ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ສະພານທອງການພິມ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',13),(38,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >12</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ຮິດຄອງປະເພນີລາວ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">5800ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"0 \">\n    <s c=\"a\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">67ໜ້າ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ສຸເນດ ໂພທິສານ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ໂຮງພິມສຶກສາ</s>\n    <s c=\"a\">ສີສະຕະນາດ</s>\n  </f>\n</notice>\n','005472001161679380',12),(37,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >11</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ກົດໝາຍປ່າໄມ້</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">700000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">156ໜ້າ</s>\n  </f>\n  <f c=\"710\" ind=\" 1\">\n    <s c=\"a\">ກົມປ່າໄມ້</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ນະຄອນຫລວງ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',11),(36,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >10</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ການປຽບທຽບຜົນສົມທາງດ້ານຄະນິດສາດ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">20000 ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">65ໜ້າ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ບຸນສີ ບູລົມ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ສຳນັກພິມແລະຈຳໜ່າຍປືມ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',10),(35,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >9</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ປະຫວັດສາດລາວ 1946</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">200000 ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">852ໜ້າ</s>\n    <s c=\"c\">ມີພາບປະກອບ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ສຸຈິດ ວົງເທບ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ອົງການອະນາໄມໂລກ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',9),(34,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >8</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ທ້າວສຸຣະນາລີ ບາງທັດສະນະຂອງຄົນໄທ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">5000 ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">68ໜ້າ</s>\n    <s c=\"c\">ມີພາບປະກອບ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ຄຳຜາຍ ບຸບຜາ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ປາກປາສັກການພິມ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',8),(33,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >7</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ສະກຸນຕົ້ນດອກເຜິ້ງຂອງປະເທດໄທ,ລາວ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">7500 ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">450ໜ້າ</s>\n    <s c=\"c\">ມີພາບປະກອບ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ບຸນມີ ເທບສີເມືອງ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ກຸງເທບ</s>\n    <s c=\"a\">ກຸງເທບ</s>\n    <s c=\"d\">20004</s>\n  </f>\n</notice>\n','005472001161679380',7),(32,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >6</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ກາບເມືອງພວນ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">13000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">51ໜ້າ</s>\n    <s c=\"c\">ມີພາບປະກອບ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ບົວໄຂ ເພັງພະຈັນ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ສີສະຫວາດການພິມ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',6),(31,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >5</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ວິລະກຳເຈົ້າອານຸ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">170000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">900ໜ້າ</s>\n    <s c=\"c\">ມີພາບປະກອບ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ສຸເນດ ໂພທິສານ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ສະຖາບັນ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n  </f>\n</notice>\n','005472001161679380',5),(30,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >4</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ຄອງແສນແສບຢ່າຊໍ້າຮອຍ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">82000 ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">53ໜ້າ</s>\n    <s c=\"c\">ມີພາບປະກອບ</s>\n  </f>\n  <f c=\"710\" ind=\" 1\">\n    <s c=\"a\">ສະຖາບັນຄົນຄວ້າວັດທະນະທຳ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ສະຖາບັນ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n    <s c=\"d\">2000</s>\n  </f>\n</notice>\n','005472001161679380',4),(29,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >3</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ເມື່ອຂ້ອຍປິດສະໝຸດບັນທຶກ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">96000ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">277 ໝ້າ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ດຳດວນ ພົມດວງສີ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ໂຮງພິມແຫ່ງລັດ</s>\n    <s c=\"a\">ສີໂຄດຕະບອງ</s>\n    <s c=\"d\">2002</s>\n  </f>\n</notice>\n','005472001161679380',3),(28,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >2</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ພົງສາວະດານລາວ ເຖິງ 1946</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">9600ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">83 ໝ້າ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ສີລາ ວິລະວົງ</s>\n    <s c=\"4\">070</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ໂຮງພິມມັນທາຕຸລາດ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n    <s c=\"d\">2001</s>\n  </f>\n</notice>\n','005472001161679380',2),(27,'<notice>\n  <rs>n</rs>\n  <dt>a</dt>\n  <bl>m</bl>\n  <hl>*</hl>\n  <el>1</el>\n  <ru>i</ru>\n  <f c=\"001\" >1</f>\n  <f c=\"100\" ind=\"  \">\n    <s c=\"a\">20061024u        u  u0frey0103    ba</s>\n  </f>\n  <f c=\"200\" ind=\"1 \">\n    <s c=\"a\">ຊີວິດ ແລະ ຜົນງານຂອງພຣະມະຫາເຖຣະ5 ອົງ</s>\n  </f>\n  <f c=\"010\" ind=\"  \">\n    <s c=\"d\">7000 ກີບ</s>\n  </f>\n  <f c=\"101\" ind=\"1 \">\n    <s c=\"a\">lao</s>\n    <s c=\"c\">lao</s>\n  </f>\n  <f c=\"215\" ind=\"  \">\n    <s c=\"a\">52 ໜ້າ</s>\n  </f>\n  <f c=\"700\" ind=\" 1\">\n    <s c=\"a\">ຄະນະອັກສອນສາດ ມ/ຊ</s>\n    <s c=\"4\">070</s>\n    <s c=\"f\">13102006</s>\n  </f>\n  <f c=\"210\" ind=\"  \">\n    <s c=\"c\">ນະຄອນຫລວງ</s>\n    <s c=\"a\">ກຳແພງນະຄອນ</s>\n    <s c=\"d\">2001</s>\n  </f>\n  <f c=\"676\" ind=\"  \">\n    <s c=\"a\">050</s>\n  </f>\n</notice>\n','005472001161679380',1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `import_marc` ENABLE KEYS */;

--
-- Table structure for table `indexint`
--

DROP TABLE IF EXISTS `indexint`;
CREATE TABLE `indexint` (
  `indexint_id` mediumint(8) unsigned NOT NULL auto_increment,
  `indexint_name` varchar(255) NOT NULL default '',
  `indexint_comment` text,
  `index_indexint` text,
  PRIMARY KEY  (`indexint_id`),
  UNIQUE KEY `indexint_name` (`indexint_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `indexint`
--


/*!40000 ALTER TABLE `indexint` DISABLE KEYS */;
LOCK TABLES `indexint` WRITE;
INSERT INTO `indexint` VALUES (1,'000','ຂໍ້ມູນ ການຕິດຕໍ່ຊື່ສານ',' 000 '),(2,'010','ຄວາມຮູ້ກ່ຽວກັບຫໍສະໝຸດ',' 010 ຄວາມຮູ້ກ່ຽວກັບຫໍສະໝຸດ '),(3,'020','ຫໍສະໝຸດ - ແລະຜູ້ອ່ານ, ເອກະສານ',' 020 ຫໍສະໝຸດ - ແລະຜູ້ອ່ານ, ເອກະສານ '),(6,'050','ວາລະສານທົ່ວໄປ - ລາຍປີ',' 050 ວາລະສານທົ່ວໄປ - ລາຍປີ '),(11,'100','ປັດຊະຍາ',' 100 ປັດຊະຍາ '),(31,'300','ວິທະຍາສາດສັງຄົມ',' 300 ວິທະຍາສາດສັງຄົມ '),(32,'310','ສະຖິຕິ',' 310 ສະຖິຕິ '),(33,'320','ການເມືອງ',' 320 ການເມືອງ '),(35,'340','ກົດໜາຍ',' 340 ກົດໜາຍ '),(36,'350','ການຄູ້ມຄອງ',' 350 ການຄູ້ມຄອງ '),(38,'370','ການສຶກສາ',' 370 ການສຶກສາ '),(41,'400','ພາສາ',' 400 ພາສາ '),(43,'420','ພາສາ ອັງກິດ',' 420 ພາສາ ອັງກິດ '),(44,'430','ພາສາ ເຢຍລະມັນ',' 430 ພາສາ ເຢຍລະມັນ '),(45,'440','ພາສາຝຣັ່ງ - (ວັດຈະນານຸກົມ, ໄວຍາກອນ)',' 440 ພາສາຝຣັ່ງ - (ວັດຈະນານຸກົມ, ໄວຍາກອນ) '),(46,'450','ພາສາ ອີ່ຕ່າລີ້',' 450 ພາສາ ອີ່ຕ່າລີ້ '),(47,'460','ພາສາ ແອັດສະປ່າຍ ',' 460 ພາສາ ແອັດສະປ່າຍ  '),(48,'470','ພາສາ ລ່າແຕ່ງ',' 470 ພາສາ ລ່າແຕ່ງ '),(49,'480','ພາສາ ກະເລັກ',' 480 ພາສາ ກະເລັກ '),(51,'500','ວິທະຍາສາດ',' 500 ວິທະຍາສາດ '),(52,'510','ເລກ',' 510 ເລກ '),(54,'530','ຟີຊິກ',' 530 ຟີຊິກ '),(61,'600','ເຕັກນິກ\r\n',' 600 ເຕັກນິກ\r\n '),(4,'030','Encyclopédies générales',' 030 encyclopedies generales '),(5,'040','X',' 040 x '),(7,'060','Organisations générales - congrès',' 060 organisations generales congres '),(8,'070','Presse Edition',' 070 presse edition '),(9,'080','Recueils - mélanges, discours',' 080 recueils melanges discours '),(10,'090','Manuscrits Livres rares',' 090 manuscrits livres rares '),(12,'110','Métaphysique',' 110 metaphysique '),(13,'120','Connaissance',' 120 connaissance '),(14,'130','Parapsychologie - astrologie, graphologie',' 130 parapsychologie astrologie graphologie '),(15,'140','Systèmes philosophiques',' 140 systemes philosophiques '),(16,'150','Psychologie',' 150 psychologie '),(17,'160','Logique',' 160 logique '),(18,'170','Morale - ethique',' 170 morale ethique '),(19,'180','Philosophes anciens - et orientaux',' 180 philosophes anciens orientaux '),(20,'190','Philosophes modernes - (XVIe S. à nos jours)',' 190 philosophes modernes xvie s nos jours '),(21,'200','Religion',' 200 religion '),(22,'210','Religion naturelle',' 210 religion naturelle '),(23,'220','Bible Evangiles',' 220 bible evangiles '),(24,'230','Théologie doctrinale chrétienne - (dogme)',' 230 theologie doctrinale chretienne dogme '),(25,'240','Théologie spirituelle - vie religieuse',' 240 theologie spirituelle vie religieuse '),(26,'250','Théologie pastorale',' 250 theologie pastorale '),(27,'260','L\'Eglise chrétienne et la société',' 260 eglise chretienne societe '),(28,'270','Histoire de l\'Eglise chrétienne',' 270 histoire eglise chretienne '),(29,'280','Autres confessions chrétiennes',' 280 autres confessions chretiennes '),(30,'290','Autres religions et mythologies',' 290 autres religions mythologies '),(34,'330','Economie - finances, production, consommation',' 330 economie finances production consommation '),(37,'360','Aide Assistance Secours',' 360 aide assistance secours '),(39,'380','Commerce Transports Communication',' 380 commerce transports communication '),(40,'390','Costumes et folklore',' 390 costumes folklore '),(42,'410','Linguistique',' 410 linguistique '),(50,'490','Autres langues - russe, arabe, …',' 490 autres langues russe arabe '),(53,'520','Astronomie',' 520 astronomie '),(55,'540','Chimie - minéralogie',' 540 chimie mineralogie '),(56,'550','Sciences de la Terre - géologie, météorologie',' 550 sciences terre geologie meteorologie '),(57,'560','Paléontologie - (les fossiles)',' 560 paleontologie fossiles '),(58,'570','Sciences de la vie - biologie, génétique',' 570 sciences vie biologie genetique '),(59,'580','Botanique - (les plantes)',' 580 botanique plantes '),(60,'590','Zoologie - (les animaux)',' 590 zoologie animaux '),(62,'610','Médecine - hygiène, santé',' 610 medecine hygiene sante '),(63,'620','Techniques industrielles - mécanique, électricité, radio, énergie…',' 620 techniques industrielles mecanique electricite radio energie '),(64,'630','Agriculture - forêt, élevage, pêche',' 630 agriculture foret elevage peche '),(65,'640','Arts ménagers - cuisine, coutûre, soins de beauté',' 640 arts menagers cuisine couture soins beaute '),(66,'650','Entreprise - travail de bureaux, vente, publicité',' 650 entreprise travail bureaux vente publicite '),(67,'660','Industries chimiques et alimentaires',' 660 industries chimiques alimentaires '),(68,'670','Fabrications industrielles - métallurgie, bois, textile',' 670 fabrications industrielles metallurgie bois textile '),(69,'680','Articles manufacturés',' 680 articles manufactures '),(70,'690','Bâtiment - construction',' 690 batiment construction '),(71,'700','Arts et loisirs',' 700 arts loisirs '),(72,'710','Urbanisme - art du paysage',' 710 urbanisme art paysage '),(73,'720','Architecture',' 720 architecture '),(74,'730','Sculpture',' 730 sculpture '),(75,'740','Dessin - arts décoratifs',' 740 dessin arts decoratifs '),(76,'750','Peinture',' 750 peinture '),(77,'760','Arts graphiques - graphisme',' 760 arts graphiques graphisme '),(78,'770','Photographie',' 770 photographie '),(79,'780','Musique',' 780 musique '),(80,'790','Loisirs - spectacles, jeux, sports',' 790 loisirs spectacles jeux sports '),(81,'800','Littérature',' 800 litterature '),(82,'810','Littérature américaine',' 810 litterature americaine '),(83,'820','Littérature anglaise',' 820 litterature anglaise '),(84,'830','Littérature allemande',' 830 litterature allemande '),(85,'840','Littérature française',' 840 litterature francaise '),(86,'850','Littérature italienne',' 850 litterature italienne '),(87,'860','Littérature espagnole et portugaise',' 860 litterature espagnole portugaise '),(88,'870','Littérature latine',' 870 litterature latine '),(89,'880','Littérature grecque',' 880 litterature grecque '),(90,'890','Autres littératures',' 890 autres litteratures '),(91,'900','Histoire géographie',' 900 histoire geographie '),(92,'910','Géographie - voyages',' 910 geographie voyages '),(93,'920','Biographies - vie d\'un personnage, généalogie',' 920 biographies vie personnage genealogie '),(94,'930','Histoire ancienne',' 930 histoire ancienne '),(95,'940','Histoire de l\'Europe',' 940 histoire europe '),(96,'950','Histoire de l\'Asie',' 950 histoire asie '),(97,'960','Histoire de l\'Afrique',' 960 histoire afrique '),(98,'970','Histoire de l\'Amérique du Nord',' 970 histoire amerique nord '),(99,'980','Histoire de l\'Amérique du Sud',' 980 histoire amerique sud '),(100,'990','Histoire de l\'Océanie',' 990 histoire oceanie ');
UNLOCK TABLES;
/*!40000 ALTER TABLE `indexint` ENABLE KEYS */;

--
-- Table structure for table `lenders`
--

DROP TABLE IF EXISTS `lenders`;
CREATE TABLE `lenders` (
  `idlender` smallint(5) unsigned NOT NULL auto_increment,
  `lender_libelle` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`idlender`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `lenders`
--


/*!40000 ALTER TABLE `lenders` DISABLE KEYS */;
LOCK TABLES `lenders` WRITE;
INSERT INTO `lenders` VALUES (1,'ເປັນຂອງຫ້ອງສະໝຸດ'),(2,'ເປັນຂອງຫ້ອງສະໝຸດທ້ອງຖິ່ນ');
UNLOCK TABLES;
/*!40000 ALTER TABLE `lenders` ENABLE KEYS */;

--
-- Table structure for table `liens_actes`
--

DROP TABLE IF EXISTS `liens_actes`;
CREATE TABLE `liens_actes` (
  `num_acte` int(8) unsigned NOT NULL default '0',
  `num_acte_lie` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`num_acte`,`num_acte_lie`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `liens_actes`
--


/*!40000 ALTER TABLE `liens_actes` DISABLE KEYS */;
LOCK TABLES `liens_actes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `liens_actes` ENABLE KEYS */;

--
-- Table structure for table `lignes_actes`
--

DROP TABLE IF EXISTS `lignes_actes`;
CREATE TABLE `lignes_actes` (
  `id_ligne` int(15) unsigned NOT NULL auto_increment,
  `type_ligne` int(3) unsigned NOT NULL default '0',
  `num_acte` int(8) unsigned NOT NULL default '0',
  `lig_ref` int(15) unsigned NOT NULL default '0',
  `num_acquisition` int(12) unsigned NOT NULL default '0',
  `num_rubrique` int(8) unsigned NOT NULL default '0',
  `num_produit` int(8) unsigned NOT NULL default '0',
  `num_type` int(8) unsigned NOT NULL default '0',
  `libelle` text NOT NULL,
  `code` varchar(255) NOT NULL default '',
  `prix` float(8,2) unsigned NOT NULL default '0.00',
  `tva` float(8,2) unsigned NOT NULL default '0.00',
  `nb` int(5) unsigned NOT NULL default '1',
  `date_ech` date NOT NULL default '0000-00-00',
  `date_cre` date NOT NULL default '0000-00-00',
  `statut` int(3) unsigned NOT NULL default '0',
  `remise` float(8,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id_ligne`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `lignes_actes`
--


/*!40000 ALTER TABLE `lignes_actes` DISABLE KEYS */;
LOCK TABLES `lignes_actes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `lignes_actes` ENABLE KEYS */;

--
-- Table structure for table `noeuds`
--

DROP TABLE IF EXISTS `noeuds`;
CREATE TABLE `noeuds` (
  `id_noeud` int(9) unsigned NOT NULL auto_increment,
  `autorite` varchar(255) NOT NULL default '',
  `num_parent` int(9) unsigned NOT NULL default '0',
  `num_renvoi_voir` int(9) unsigned NOT NULL default '0',
  `visible` char(1) NOT NULL default '1',
  `num_thesaurus` int(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_noeud`),
  KEY `num_parent` (`num_parent`),
  KEY `num_thesaurus` (`num_thesaurus`),
  KEY `autorite` (`autorite`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `noeuds`
--


/*!40000 ALTER TABLE `noeuds` DISABLE KEYS */;
LOCK TABLES `noeuds` WRITE;
INSERT INTO `noeuds` VALUES (1,'TOP',0,0,'0',1),(2484,'ORPHELINS',1,0,'0',1),(1378,'1377',1,0,'1',1),(1379,'1378',1,0,'1',1),(1380,'1379',1,0,'1',1),(1381,'1380',1,0,'1',1),(1382,'1381',1,0,'1',1),(1383,'1382',1,0,'1',1),(1384,'1383',1,0,'1',1),(1385,'1384',1,0,'1',1),(1386,'1385',1,0,'1',1),(1387,'1386',1,0,'1',1),(1388,'1387',1378,0,'1',1),(1389,'1388',1378,0,'1',1),(1390,'1389',1378,0,'1',1),(1391,'1390',1378,0,'1',1),(1392,'1391',1378,0,'1',1),(1393,'1392',1378,0,'1',1),(1394,'1393',1378,0,'1',1),(1395,'1394',1378,0,'1',1),(1396,'1395',1378,0,'1',1),(1397,'1396',1378,0,'1',1),(1398,'1397',1378,0,'1',1),(1399,'1398',1378,0,'1',1),(1400,'1399',1378,0,'1',1),(1401,'1400',1378,0,'1',1),(1402,'1401',1390,0,'1',1),(1403,'1402',1408,0,'1',1),(1404,'1403',1390,0,'1',1),(1405,'1404',1390,0,'1',1),(1406,'1405',1390,0,'1',1),(1407,'1406',1408,0,'1',1),(1408,'1407',1390,0,'1',1),(1409,'1408',1408,0,'1',1),(1410,'1409',1406,0,'1',1),(1411,'1410',1391,0,'1',1),(1412,'1411',1391,0,'1',1),(1413,'1412',1391,0,'1',1),(1414,'1413',1391,0,'1',1),(1415,'1414',1391,0,'1',1),(1416,'1415',1391,0,'1',1),(1417,'1416',1391,0,'1',1),(1418,'1417',1391,0,'1',1),(1419,'1418',1391,0,'1',1),(1420,'1419',1394,0,'1',1),(1421,'1420',2046,0,'1',1),(1422,'1421',2045,0,'1',1),(1423,'1422',2045,0,'1',1),(1424,'1423',2045,0,'1',1),(1425,'1424',2045,0,'1',1),(1426,'1425',2045,0,'1',1),(1427,'1426',2045,0,'1',1),(1428,'1427',2045,0,'1',1),(1429,'1428',2045,0,'1',1),(1430,'1429',2045,0,'1',1),(1431,'1430',1420,0,'1',1),(1432,'1431',1420,0,'1',1),(1433,'1432',1420,0,'1',1),(1434,'1433',1420,0,'1',1),(1435,'1434',1420,0,'1',1),(1436,'1435',1420,0,'1',1),(1437,'1436',1420,0,'1',1),(1438,'1437',1420,0,'1',1),(1439,'1438',1420,0,'1',1),(1440,'1439',1420,0,'1',1),(1441,'1440',1420,0,'1',1),(1442,'1441',2046,0,'1',1),(1443,'1442',1420,0,'1',1),(1444,'1443',1420,0,'1',1),(1445,'1444',2046,0,'1',1),(1446,'1445',1422,0,'1',1),(1447,'1446',1423,0,'1',1),(1448,'1447',1424,0,'1',1),(1449,'1448',1425,0,'1',1),(1450,'1449',1426,0,'1',1),(1451,'1450',1427,0,'1',1),(1452,'1451',1428,0,'1',1),(1453,'1452',1429,0,'1',1),(1454,'1453',1430,0,'1',1),(1455,'1454',2046,0,'1',1),(1456,'1455',1422,0,'1',1),(1457,'1456',1423,0,'1',1),(1458,'1457',1424,0,'1',1),(1459,'1458',1425,0,'1',1),(1460,'1459',1426,0,'1',1),(1461,'1460',1427,0,'1',1),(1462,'1461',1428,0,'1',1),(1463,'1462',1428,0,'1',1),(1464,'1463',1429,0,'1',1),(1465,'1464',1430,0,'1',1),(1466,'1465',2046,0,'1',1),(1467,'1466',1422,0,'1',1),(1468,'1467',1423,0,'1',1),(1469,'1468',1424,0,'1',1),(1470,'1469',1425,0,'1',1),(1471,'1470',1426,0,'1',1),(1472,'1471',1427,0,'1',1),(1473,'1472',1429,0,'1',1),(1474,'1473',1428,0,'1',1),(1475,'1474',1430,0,'1',1),(1476,'1475',1426,0,'1',1),(1477,'1476',1427,0,'1',1),(1478,'1477',1429,0,'1',1),(1479,'1478',1430,0,'1',1),(1480,'1479',1422,0,'1',1),(1481,'1480',1423,0,'1',1),(1482,'1481',1424,0,'1',1),(1483,'1482',1425,0,'1',1),(1484,'1483',2160,0,'1',1),(1485,'1484',2160,0,'1',1),(1486,'1485',2160,0,'1',1),(1487,'1486',2160,0,'1',1),(1488,'1487',2160,0,'1',1),(1489,'1488',2160,0,'1',1),(1490,'1489',2160,0,'1',1),(1491,'1490',1916,0,'1',1),(1492,'1491',1399,0,'1',1),(1493,'1492',1379,0,'1',1),(1494,'1493',1379,0,'1',1),(1495,'1494',1379,0,'1',1),(1496,'1495',1379,0,'1',1),(1497,'1496',1379,0,'1',1),(1498,'1497',1379,0,'1',1),(1499,'1498',1495,0,'1',1),(1500,'1499',1495,0,'1',1),(1501,'1500',1495,0,'1',1),(1502,'1501',1495,0,'1',1),(1503,'1502',1495,0,'1',1),(1504,'1503',1495,0,'1',1),(1505,'1504',1495,0,'1',1),(1506,'1505',1382,0,'1',1),(1507,'1506',1495,0,'1',1),(1508,'1507',1495,0,'1',1),(1509,'1508',1495,0,'1',1),(1510,'1509',1495,0,'1',1),(1511,'1510',1495,0,'1',1),(1512,'1511',1497,0,'1',1),(1513,'1512',1497,0,'1',1),(1514,'1513',1497,0,'1',1),(1515,'1514',1380,0,'1',1),(1516,'1515',1380,0,'1',1),(1517,'1516',1380,0,'1',1),(1518,'1517',1380,0,'1',1),(1519,'1518',1380,0,'1',1),(1520,'1519',1380,0,'1',1),(1521,'1520',1380,0,'1',1),(1522,'1521',1380,0,'1',1),(1523,'1522',1380,0,'1',1),(1524,'1523',1525,1641,'1',1),(1525,'1524',1515,0,'1',1),(1526,'1525',1515,0,'1',1),(1527,'1526',1526,0,'1',1),(1528,'1527',1526,0,'1',1),(1529,'1528',1526,0,'1',1),(1530,'1529',1526,0,'1',1),(1531,'1530',1515,0,'1',1),(1532,'1531',1515,0,'1',1),(1533,'1532',1515,0,'1',1),(1534,'1533',1515,0,'1',1),(1535,'1534',1515,0,'1',1),(1536,'1535',1516,0,'1',1),(1537,'1536',1516,0,'1',1),(1538,'1537',1516,0,'1',1),(1539,'1538',1516,0,'1',1),(1540,'1539',1516,0,'1',1),(1541,'1540',1516,0,'1',1),(1542,'1541',1516,0,'1',1),(1543,'1542',1516,0,'1',1),(1544,'1543',1516,0,'1',1),(1545,'1544',1517,0,'1',1),(1546,'1545',1517,0,'1',1),(1547,'1546',1523,0,'1',1),(1548,'1547',1517,0,'1',1),(1549,'1548',1517,0,'1',1),(1550,'1549',1551,0,'1',1),(1551,'1550',1517,0,'1',1),(1552,'1551',1517,0,'1',1),(1553,'1552',1517,0,'1',1),(1554,'1553',1518,0,'1',1),(1555,'1554',1518,0,'1',1),(1556,'1555',1518,0,'1',1),(1557,'1556',1518,0,'1',1),(1558,'1557',1518,0,'1',1),(1559,'1558',1519,0,'1',1),(1560,'1559',1519,0,'1',1),(1561,'1560',1519,0,'1',1),(1562,'1561',1519,0,'1',1),(1563,'1562',1519,0,'1',1),(1564,'1563',1519,0,'1',1),(1565,'1564',1519,0,'1',1),(1566,'1565',1519,0,'1',1),(1567,'1566',1555,0,'1',1),(1568,'1567',2167,0,'1',1),(1569,'1568',2167,0,'1',1),(1570,'1569',2167,0,'1',1),(1571,'1570',2167,0,'1',1),(1572,'1571',2167,0,'1',1),(1573,'1572',2167,0,'1',1),(1574,'1573',2168,0,'1',1),(1575,'1574',2168,0,'1',1),(1576,'1575',2168,0,'1',1),(1577,'1576',1520,0,'1',1),(1578,'1577',1520,0,'1',1),(1579,'1578',1520,0,'1',1),(1580,'1579',1520,0,'1',1),(1581,'1580',1520,0,'1',1),(1582,'1581',1521,0,'1',1),(1583,'1582',1521,0,'1',1),(1584,'1583',1521,0,'1',1),(1585,'1584',1521,0,'1',1),(1586,'1585',1521,0,'1',1),(1587,'1586',1521,0,'1',1),(1588,'1587',1521,0,'1',1),(1589,'1588',1521,0,'1',1),(1590,'1589',1521,0,'1',1),(1591,'1590',1521,0,'1',1),(1592,'1591',1522,0,'1',1),(1593,'1592',2166,0,'1',1),(1594,'1593',2166,0,'1',1),(1595,'1594',2166,0,'1',1),(1596,'1595',1522,0,'1',1),(1597,'1596',1522,0,'1',1),(1598,'1597',1522,0,'1',1),(1599,'1598',1522,0,'1',1),(1600,'1599',1522,0,'1',1),(1601,'1600',1522,0,'1',1),(1602,'1601',1522,0,'1',1),(1603,'1602',1523,0,'1',1),(1604,'1603',1523,0,'1',1),(1605,'1604',1523,0,'1',1),(1606,'1605',1523,0,'1',1),(1607,'1606',1523,0,'1',1),(1608,'1607',1523,0,'1',1),(1609,'1608',1523,0,'1',1),(1610,'1609',1523,0,'1',1),(1611,'1610',1523,0,'1',1),(1612,'1611',1381,0,'1',1),(1613,'1612',2022,0,'1',1),(1614,'1613',1381,0,'1',1),(1615,'1614',2022,0,'1',1),(1616,'1615',2022,0,'1',1),(1617,'1616',1381,0,'1',1),(1618,'1617',1381,0,'1',1),(1619,'1618',1381,0,'1',1),(1620,'1619',1381,0,'1',1),(1621,'1620',2022,0,'1',1),(1622,'1621',1620,0,'1',1),(1623,'1622',1620,0,'1',1),(1624,'1623',1620,0,'1',1),(1625,'1624',1620,0,'1',1),(1626,'1625',1620,0,'1',1),(1627,'1626',1620,0,'1',1),(1628,'1627',1620,0,'1',1),(1629,'1628',1621,0,'1',1),(1630,'1629',1621,0,'1',1),(1631,'1630',1621,0,'1',1),(1632,'1631',1621,0,'1',1),(1633,'1632',1621,0,'1',1),(1634,'1633',1621,0,'1',1),(1635,'1634',1621,0,'1',1),(1636,'1635',1621,0,'1',1),(1637,'1636',1621,0,'1',1),(1638,'1637',1621,0,'1',1),(1639,'1638',1621,0,'1',1),(1640,'1639',1639,0,'1',1),(1641,'1640',1644,0,'1',1),(1642,'1641',1639,0,'1',1),(1643,'1642',2141,0,'1',1),(1644,'1643',1639,0,'1',1),(1645,'1644',1639,0,'1',1),(1646,'1645',1382,0,'1',1),(1647,'1646',1382,0,'1',1),(1648,'1647',1382,0,'1',1),(1649,'1648',1382,0,'1',1),(1650,'1649',1382,0,'1',1),(1651,'1650',1382,0,'1',1),(1652,'1651',1382,0,'1',1),(1653,'1652',1382,0,'1',1),(1654,'1653',1382,0,'1',1),(1655,'1654',1382,0,'1',1),(1656,'1655',1382,0,'1',1),(1657,'1656',1382,0,'1',1),(1658,'1657',1647,0,'1',1),(1659,'1658',1647,0,'1',1),(1660,'1659',1647,0,'1',1),(1661,'1660',1647,0,'1',1),(1662,'1661',1647,0,'1',1),(1663,'1662',1651,0,'1',1),(1664,'1663',1651,0,'1',1),(1665,'1664',1651,0,'1',1),(1666,'1665',1651,0,'1',1),(1667,'1666',1651,0,'1',1),(1668,'1667',1651,0,'1',1),(1669,'1668',1651,0,'1',1),(1670,'1669',1651,0,'1',1),(1671,'1670',1651,0,'1',1),(1672,'1671',1651,0,'1',1),(1673,'1672',1651,0,'1',1),(1674,'1673',1651,0,'1',1),(1675,'1674',1654,0,'1',1),(1676,'1675',1654,0,'1',1),(1677,'1676',1654,0,'1',1),(1678,'1677',1654,0,'1',1),(1679,'1678',1654,0,'1',1),(1680,'1679',1654,0,'1',1),(1681,'1680',1684,0,'1',1),(1682,'1681',1383,0,'1',1),(1683,'1682',1383,0,'1',1),(1684,'1683',1383,0,'1',1),(1685,'1684',1683,0,'1',1),(1686,'1685',1383,0,'1',1),(1687,'1686',1383,0,'1',1),(1688,'1687',1684,0,'1',1),(1689,'1688',1684,0,'1',1),(1690,'1689',1383,0,'1',1),(1691,'1690',1684,0,'1',1),(1692,'1691',1683,0,'1',1),(1693,'1692',1383,0,'1',1),(1694,'1693',1383,0,'1',1),(1695,'1694',1385,0,'1',1),(1696,'1695',1383,0,'1',1),(1697,'1696',1383,0,'1',1),(1698,'1697',1684,0,'1',1),(1699,'1698',1684,0,'1',1),(1700,'1699',1383,0,'1',1),(1701,'1700',1684,0,'1',1),(1702,'1701',1682,0,'1',1),(1703,'1702',1682,0,'1',1),(1704,'1703',1682,0,'1',1),(1705,'1704',1682,0,'1',1),(1706,'1705',1682,0,'1',1),(1707,'1706',1687,0,'1',1),(1708,'1707',1687,0,'1',1),(1709,'1708',1687,0,'1',1),(1710,'1709',1687,0,'1',1),(1711,'1710',1687,0,'1',1),(1712,'1711',1687,0,'1',1),(1713,'1712',1687,0,'1',1),(1714,'1713',1683,0,'1',1),(1715,'1714',1696,0,'1',1),(1716,'1715',1696,0,'1',1),(1717,'1716',1696,0,'1',1),(1718,'1717',1696,0,'1',1),(1719,'1718',1696,0,'1',1),(1720,'1719',1696,0,'1',1),(1721,'1720',1696,0,'1',1),(1722,'1721',1696,0,'1',1),(1723,'1722',1384,0,'1',1),(1724,'1723',1384,0,'1',1),(1725,'1724',1384,0,'1',1),(1726,'1725',1384,0,'1',1),(1727,'1726',2203,0,'1',1),(1728,'1727',1384,0,'1',1),(1729,'1728',1384,0,'1',1),(1730,'1729',1384,0,'1',1),(1731,'1730',1384,0,'1',1),(1733,'1732',1384,0,'1',1),(1734,'1733',1917,0,'1',1),(1735,'1734',1734,0,'1',1),(1736,'1735',1734,0,'1',1),(1737,'1736',1734,0,'1',1),(1738,'1737',1734,0,'1',1),(1739,'1738',1734,0,'1',1),(1740,'1739',1734,0,'1',1),(1741,'1740',1734,0,'1',1),(1742,'1741',1734,0,'1',1),(1743,'1742',1734,0,'1',1),(1744,'1743',1734,0,'1',1),(1745,'1744',1915,0,'1',1),(1746,'1745',1734,0,'1',1),(1747,'1746',1734,0,'1',1),(1748,'1747',1734,0,'1',1),(1749,'1748',1734,0,'1',1),(1750,'1749',1734,0,'1',1),(1751,'1750',1734,0,'1',1),(1752,'1751',1734,0,'1',1),(1753,'1752',1734,0,'1',1),(1754,'1753',1734,0,'1',1),(1755,'1754',1734,0,'1',1),(1756,'1755',1734,0,'1',1),(1757,'1756',1734,0,'1',1),(1758,'1757',1385,0,'1',1),(1759,'1758',1385,0,'1',1),(1760,'1759',1385,0,'1',1),(1761,'1760',1385,0,'1',1),(1762,'1761',1385,0,'1',1),(1763,'1762',1385,0,'1',1),(1764,'1763',1385,0,'1',1),(1765,'1764',1385,0,'1',1),(1766,'1765',1385,0,'1',1),(1767,'1766',1385,0,'1',1),(1768,'1767',1385,0,'1',1),(1769,'1768',1385,0,'1',1),(1770,'1769',1385,0,'1',1),(1771,'1770',1385,0,'1',1),(1772,'1771',1385,0,'1',1),(1773,'1772',1765,0,'1',1),(1774,'1773',1765,0,'1',1),(1775,'1774',1765,0,'1',1),(1776,'1775',1765,0,'1',1),(1777,'1776',1765,0,'1',1),(1778,'1777',1386,0,'1',1),(1779,'1778',1386,0,'1',1),(1780,'1779',1386,0,'1',1),(1781,'1780',1386,0,'1',1),(1782,'1781',1386,0,'1',1),(1783,'1782',1386,0,'1',1),(1784,'1783',1386,0,'1',1),(1785,'1784',1386,0,'1',1),(1786,'1785',1386,0,'1',1),(1787,'1786',1386,0,'1',1),(1788,'1787',1387,0,'1',1),(1789,'1788',1387,0,'1',1),(1790,'1789',1387,0,'1',1),(1791,'1790',1387,0,'1',1),(1792,'1791',1387,0,'1',1),(1793,'1792',1387,0,'1',1),(1794,'1793',1387,0,'1',1),(1795,'1794',1387,0,'1',1),(1796,'1795',1387,0,'1',1),(1797,'1796',1788,0,'1',1),(1798,'1797',1788,0,'1',1),(1799,'1798',1788,0,'1',1),(1800,'1799',1788,0,'1',1),(1801,'1800',1788,0,'1',1),(1802,'1801',1788,0,'1',1),(1803,'1802',1788,0,'1',1),(1804,'1803',1789,0,'1',1),(1805,'1804',1789,0,'1',1),(1806,'1805',1789,0,'1',1),(1807,'1806',1789,0,'1',1),(1808,'1807',1789,0,'1',1),(1809,'1808',1789,0,'1',1),(1810,'1809',1789,0,'1',1),(1811,'1810',1790,0,'1',1),(1812,'1811',1790,0,'1',1),(1813,'1812',1790,0,'1',1),(1814,'1813',1790,0,'1',1),(1815,'1814',1790,0,'1',1),(1816,'1815',1790,0,'1',1),(1817,'1816',1790,0,'1',1),(1818,'1817',1790,0,'1',1),(1819,'1818',1791,0,'1',1),(1820,'1819',1791,0,'1',1),(1821,'1820',1791,0,'1',1),(1822,'1821',1791,0,'1',1),(1823,'1822',1791,0,'1',1),(1824,'1823',1791,0,'1',1),(1825,'1824',1791,0,'1',1),(1826,'1825',1791,0,'1',1),(1827,'1826',1791,0,'1',1),(1828,'1827',1791,0,'1',1),(1829,'1828',1791,0,'1',1),(1830,'1829',1791,0,'1',1),(1831,'1830',1791,0,'1',1),(1832,'1831',1792,0,'1',1),(1833,'1832',1792,0,'1',1),(1834,'1833',1792,0,'1',1),(1835,'1834',1792,0,'1',1),(1836,'1835',1792,0,'1',1),(1837,'1836',1792,0,'1',1),(1838,'1837',1793,0,'1',1),(1839,'1838',1793,0,'1',1),(1840,'1839',1793,0,'1',1),(1841,'1840',1793,0,'1',1),(1842,'1841',1793,0,'1',1),(1843,'1842',1793,0,'1',1),(1844,'1843',1794,0,'1',1),(1845,'1844',1794,0,'1',1),(1846,'1845',1794,0,'1',1),(1847,'1846',1794,0,'1',1),(1848,'1847',1797,0,'1',1),(1849,'1848',1797,0,'1',1),(1850,'1849',1797,0,'1',1),(1851,'1850',1797,0,'1',1),(1852,'1851',1798,0,'1',1),(1853,'1852',1798,0,'1',1),(1854,'1853',1798,0,'1',1),(1855,'1854',1798,0,'1',1),(1856,'1855',1798,0,'1',1),(1857,'1856',1798,0,'1',1),(1858,'1857',1798,0,'1',1),(1859,'1858',1798,0,'1',1),(1860,'1859',1798,0,'1',1),(1861,'1860',1798,0,'1',1),(1862,'1861',1798,0,'1',1),(1863,'1862',1798,0,'1',1),(1864,'1863',1798,0,'1',1),(1865,'1864',1798,0,'1',1),(1866,'1865',1799,0,'1',1),(1867,'1866',1799,0,'1',1),(1868,'1867',1799,0,'1',1),(1869,'1868',1799,0,'1',1),(1870,'1869',1799,0,'1',1),(1871,'1870',1800,0,'1',1),(1872,'1871',1800,0,'1',1),(1873,'1872',1800,0,'1',1),(1874,'1873',1800,0,'1',1),(1875,'1874',1800,0,'1',1),(1876,'1875',1800,0,'1',1),(1877,'1876',1800,0,'1',1),(1878,'1877',1800,0,'1',1),(1879,'1878',1801,0,'1',1),(1880,'1879',1801,0,'1',1),(1881,'1880',1801,0,'1',1),(1882,'1881',1801,0,'1',1),(1883,'1882',1801,0,'1',1),(1884,'1883',1801,0,'1',1),(1885,'1884',1801,0,'1',1),(1886,'1885',1802,0,'1',1),(1887,'1886',1802,0,'1',1),(1888,'1887',1802,0,'1',1),(1889,'1888',1802,0,'1',1),(1890,'1889',1802,0,'1',1),(1891,'1890',1802,0,'1',1),(1892,'1891',1802,0,'1',1),(1893,'1892',1802,0,'1',1),(1894,'1893',1802,0,'1',1),(1895,'1894',1802,0,'1',1),(1896,'1895',1803,0,'1',1),(1897,'1896',1803,0,'1',1),(1898,'1897',1803,0,'1',1),(1899,'1898',1803,0,'1',1),(1900,'1899',1803,0,'1',1),(1901,'1900',1803,0,'1',1),(1902,'1901',1818,0,'1',1),(1903,'1902',1818,0,'1',1),(1904,'1903',1818,0,'1',1),(1905,'1904',1818,0,'1',1),(1906,'1905',1818,0,'1',1),(1907,'1906',1818,0,'1',1),(1908,'1907',1818,0,'1',1),(1909,'1908',1818,0,'1',1),(1910,'1909',1832,0,'1',1),(1911,'1910',1832,0,'1',1),(1912,'1911',1832,0,'1',1),(1913,'1912',1832,0,'1',1),(1914,'1913',1832,0,'1',1),(1915,'1914',1833,0,'1',1),(1916,'1915',1833,0,'1',1),(1917,'1916',1833,0,'1',1),(1918,'1917',1833,0,'1',1),(1919,'1918',1833,0,'1',1),(1920,'1919',1833,0,'1',1),(1921,'1920',1833,0,'1',1),(1922,'1921',1834,0,'1',1),(1923,'1922',1834,0,'1',1),(1924,'1923',1834,0,'1',1),(1925,'1924',1834,0,'1',1),(1926,'1925',1834,0,'1',1),(1927,'1926',1835,0,'1',1),(1928,'1927',1835,0,'1',1),(1929,'1928',1835,0,'1',1),(1930,'1929',1835,0,'1',1),(1931,'1930',1835,0,'1',1),(1932,'1931',1835,0,'1',1),(1933,'1932',1835,0,'1',1),(1934,'1933',1835,0,'1',1),(1935,'1934',1836,0,'1',1),(1936,'1935',1836,0,'1',1),(1937,'1936',1836,0,'1',1),(1938,'1937',1836,0,'1',1),(1939,'1938',1837,0,'1',1),(1940,'1939',1837,0,'1',1),(1941,'1940',1837,0,'1',1),(1942,'1941',1837,0,'1',1),(1943,'1942',1837,0,'1',1),(1944,'1943',1837,0,'1',1),(1945,'1944',1837,0,'1',1),(1946,'1945',1837,0,'1',1),(1947,'1946',1837,0,'1',1),(1948,'1947',1838,0,'1',1),(1949,'1948',1838,0,'1',1),(1950,'1949',1838,0,'1',1),(1951,'1950',1838,0,'1',1),(1952,'1951',1948,0,'1',1),(1953,'1952',1948,0,'1',1),(1954,'1953',1948,0,'1',1),(1955,'1954',1948,0,'1',1),(1956,'1955',1948,0,'1',1),(1957,'1956',1948,0,'1',1),(1958,'1957',1948,0,'1',1),(1959,'1958',1951,0,'1',1),(1960,'1959',1951,0,'1',1),(1961,'1960',1951,0,'1',1),(1962,'1961',1951,0,'1',1),(1963,'1962',1951,0,'1',1),(1964,'1963',1951,0,'1',1),(1965,'1964',1951,0,'1',1),(1966,'1965',1839,0,'1',1),(1967,'1966',1839,0,'1',1),(1968,'1967',1839,0,'1',1),(1969,'1968',1835,0,'1',1),(1970,'1969',1840,0,'1',1),(1971,'1970',1840,0,'1',1),(1972,'1971',1840,0,'1',1),(1973,'1972',1840,0,'1',1),(1974,'1973',1840,0,'1',1),(1975,'1974',1840,0,'1',1),(1976,'1975',1840,0,'1',1),(1977,'1976',1840,0,'1',1),(1978,'1977',1841,0,'1',1),(1979,'1978',1841,0,'1',1),(1980,'1979',1841,0,'1',1),(1981,'1980',1841,0,'1',1),(1982,'1981',1841,0,'1',1),(1983,'1982',1841,0,'1',1),(1984,'1983',1842,0,'1',1),(1985,'1984',1842,0,'1',1),(1986,'1985',1842,0,'1',1),(1987,'1986',1842,0,'1',1),(1988,'1987',1842,0,'1',1),(1989,'1988',1842,0,'1',1),(1990,'1989',1843,0,'1',1),(1991,'1990',1843,0,'1',1),(1992,'1991',1843,0,'1',1),(1993,'1992',1843,0,'1',1),(1994,'1993',1843,0,'1',1),(1995,'1994',1843,0,'1',1),(1996,'1995',1843,0,'1',1),(1997,'1996',1843,0,'1',1),(1998,'1997',1843,0,'1',1),(1999,'1998',1843,0,'1',1),(2000,'1999',1845,0,'1',1),(2001,'2000',1845,0,'1',1),(2002,'2001',1845,0,'1',1),(2003,'2002',1845,0,'1',1),(2004,'2003',1845,0,'1',1),(2005,'2004',1845,0,'1',1),(2006,'2005',1846,0,'1',1),(2007,'2006',1846,0,'1',1),(2008,'2007',1846,0,'1',1),(2009,'2008',1846,0,'1',1),(2010,'2009',1846,0,'1',1),(2011,'2010',1847,0,'1',1),(2012,'2011',1847,0,'1',1),(2013,'2012',1847,0,'1',1),(2014,'2013',1847,0,'1',1),(2015,'2014',1847,0,'1',1),(2016,'2015',1847,0,'1',1),(2017,'2016',1847,0,'1',1),(2018,'2017',1847,0,'1',1),(2019,'2018',1847,0,'1',1),(2020,'2019',1847,0,'1',1),(2021,'2020',1847,0,'1',1),(2022,'2021',1381,0,'1',1),(2023,'2022',1698,0,'1',1),(2024,'2023',1787,0,'1',1),(2025,'2024',1698,0,'1',1),(2026,'2025',1787,0,'1',1),(2027,'2026',1698,0,'1',1),(2028,'2027',1787,0,'1',1),(2029,'2028',1503,0,'1',1),(2030,'2029',2032,0,'1',1),(2031,'2030',2032,0,'1',1),(2032,'2031',1653,0,'1',1),(2034,'2033',1554,0,'1',1),(2035,'2034',2046,0,'1',1),(2036,'2035',2046,0,'1',1),(2037,'2036',1787,0,'1',1),(2039,'2038',1937,0,'1',1),(2040,'2039',1731,0,'1',1),(2043,'2042',1691,0,'1',1),(2044,'2043',1424,0,'1',1),(2045,'2044',1394,0,'1',1),(2046,'2045',1394,0,'1',1),(2047,'2046',2046,0,'1',1),(2048,'2047',2046,0,'1',1),(2049,'2048',2046,0,'1',1),(2050,'2049',2046,0,'1',1),(2051,'2050',2046,0,'1',1),(2052,'2051',2046,0,'1',1),(2053,'2052',2046,0,'1',1),(2054,'2053',2049,0,'1',1),(2055,'2054',1969,0,'1',1),(2056,'2055',1912,0,'1',1),(2057,'2056',1593,0,'1',1),(2058,'2057',1593,0,'1',1),(2059,'2058',1593,0,'1',1),(2060,'2059',1593,0,'1',1),(2061,'2060',1593,0,'1',1),(2062,'2061',1593,0,'1',1),(2063,'2062',1593,0,'1',1),(2064,'2063',1593,0,'1',1),(2065,'2064',1593,0,'1',1),(2066,'2065',1982,0,'1',1),(2067,'2066',1830,0,'1',1),(2068,'2067',1455,0,'1',1),(2069,'2068',1936,0,'1',1),(2070,'2069',1945,0,'1',1),(2071,'2070',1554,0,'1',1),(2072,'2071',1554,0,'1',1),(2074,'2073',2051,0,'1',1),(2075,'2074',1652,0,'1',1),(2076,'2075',2125,0,'1',1),(2077,'2076',1984,0,'1',1),(2078,'2077',1442,0,'1',1),(2079,'2078',2082,0,'1',1),(2080,'2079',2082,0,'1',1),(2081,'2080',2082,0,'1',1),(2082,'2081',1550,0,'1',1),(2083,'2082',1954,0,'1',1),(2084,'2083',2035,0,'1',1),(2085,'2084',1708,0,'1',1),(2086,'2085',1503,0,'1',1),(2087,'2086',2086,0,'1',1),(2088,'2087',1808,0,'1',1),(2089,'2088',2036,0,'1',1),(2090,'2089',2089,0,'1',1),(2092,'2091',1984,0,'1',1),(2093,'2092',1944,0,'1',1),(2094,'2093',2125,0,'1',1),(2095,'2094',1425,0,'1',1),(2096,'2095',1426,0,'1',1),(2097,'2096',1427,0,'1',1),(2098,'2097',1937,0,'1',1),(2099,'2098',1428,0,'1',1),(2100,'2099',1915,0,'1',1),(2101,'2100',1599,0,'1',1),(2102,'2101',1599,0,'1',1),(2103,'2102',1599,0,'1',1),(2104,'2103',1599,0,'1',1),(2105,'2104',1599,0,'1',1),(2106,'2105',1599,0,'1',1),(2107,'2106',1599,0,'1',1),(2108,'2107',2036,0,'1',1),(2109,'2108',1606,0,'1',1),(2110,'2109',1445,0,'1',1),(2111,'2110',2049,0,'1',1),(2112,'2111',1420,0,'1',1),(2113,'2112',2051,0,'1',1),(2114,'2113',1911,0,'1',1),(2115,'2114',1914,0,'1',1),(2116,'2115',1777,0,'1',1),(2117,'2116',1810,0,'1',1),(2118,'2117',1981,0,'1',1),(2119,'2118',1922,0,'1',1),(2120,'2119',1383,0,'1',1),(2121,'2120',2120,0,'1',1),(2122,'2121',1944,0,'1',1),(2123,'2122',1934,0,'1',1),(2124,'2123',2048,0,'1',1),(2125,'2124',1780,0,'1',1),(2126,'2125',2128,0,'1',1),(2127,'2126',2128,0,'1',1),(2128,'2127',2125,0,'1',1),(2129,'2128',1758,0,'1',1),(2130,'2129',2129,0,'1',1),(2131,'2130',2129,0,'1',1),(2132,'2131',1694,0,'1',1),(2135,'2134',1378,0,'1',1),(2136,'2135',2135,0,'1',1),(2137,'2136',1608,0,'1',1),(2138,'2137',1975,0,'1',1),(2139,'2138',2140,0,'1',1),(2140,'2139',1639,0,'1',1),(2141,'2140',1639,0,'1',1),(2142,'2141',1397,0,'1',1),(2143,'2142',1917,0,'1',1),(2144,'2143',1917,0,'1',1),(2145,'2144',1913,0,'1',1),(2146,'2145',2158,0,'1',1),(2147,'2146',1394,0,'1',1),(2148,'2147',2158,0,'1',1),(2150,'2149',2157,0,'1',1),(2151,'2150',1919,0,'1',1),(2152,'2151',2147,0,'1',1),(2153,'2152',2147,0,'1',1),(2154,'2153',2147,0,'1',1),(2155,'2154',2147,0,'1',1),(2156,'2155',2147,0,'1',1),(2157,'2156',2147,0,'1',1),(2158,'2157',2147,0,'1',1),(2159,'2158',1399,0,'1',1),(2160,'2159',1399,0,'1',1),(2161,'2160',1399,0,'1',1),(2162,'2161',1526,0,'1',1),(2163,'2162',1526,0,'1',1),(2164,'2163',1515,0,'1',1),(2165,'2164',1515,0,'1',1),(2166,'2165',1522,0,'1',1),(2167,'2166',1520,0,'1',1),(2168,'2167',1520,0,'1',1),(2169,'2168',1520,0,'1',1),(2170,'2169',1378,0,'1',1),(2171,'2170',1522,0,'1',1),(2172,'2171',2170,0,'1',1),(2173,'2172',1981,0,'1',1),(2174,'2173',1993,0,'1',1),(2175,'2174',1401,0,'1',1),(2177,'2176',1389,0,'1',1),(2179,'2178',2359,0,'1',1),(2180,'2179',1618,0,'1',1),(2181,'2180',2135,0,'1',1),(2182,'2181',1405,0,'1',1),(2183,'2182',1621,0,'1',1),(2184,'2183',1405,0,'1',1),(2185,'2184',1400,0,'1',1),(2186,'2185',1400,0,'1',1),(2188,'2187',1825,0,'1',1),(2189,'2188',1805,0,'1',1),(2190,'2189',1983,0,'1',1),(2191,'2190',1612,0,'1',1),(2192,'2191',2185,0,'1',1),(2193,'2192',2047,0,'1',1),(2194,'2193',2049,0,'1',1),(2196,'2195',1733,0,'1',1),(2197,'2196',2196,0,'1',1),(2198,'2197',2197,0,'1',1),(2200,'2199',1378,0,'1',1),(2201,'2200',2200,0,'1',1),(2203,'2202',1386,0,'1',1),(2204,'2203',1999,0,'1',1),(2205,'2204',1780,0,'1',1),(2206,'2205',2205,0,'1',1),(2207,'2206',2205,0,'1',1),(2208,'2207',1954,0,'1',1),(2209,'2208',1982,0,'1',1),(2210,'2209',1998,0,'1',1),(2211,'2210',1844,0,'1',1),(2212,'2211',2205,0,'1',1),(2213,'2212',1993,0,'1',1),(2214,'2213',1613,0,'1',1),(2215,'2214',2214,0,'1',1),(2216,'2215',2214,0,'1',1),(2217,'2216',1635,0,'1',1),(2218,'2217',1638,0,'1',1),(2219,'2218',1621,0,'1',1),(2220,'2219',2219,0,'1',1),(2221,'2220',2219,0,'1',1),(2222,'2221',1615,0,'1',1),(2223,'2222',1631,0,'1',1),(2224,'2223',2125,0,'1',1),(2225,'2224',2125,0,'1',1),(2226,'2225',1408,0,'1',1),(2227,'2226',1764,0,'1',1),(2228,'2227',2368,0,'1',1),(2229,'2228',1489,0,'1',1),(2231,'2230',1486,0,'1',1),(2232,'2231',1401,0,'1',1),(2233,'2232',1490,0,'1',1),(2235,'2234',1396,0,'1',1),(2236,'2235',1613,0,'1',1),(2237,'2236',1405,0,'1',1),(2238,'2237',1850,0,'1',1),(2239,'2238',1405,0,'1',1),(2240,'2239',1402,0,'1',1),(2242,'2241',1490,0,'1',1),(2244,'2243',1848,0,'1',1),(2245,'2244',2359,0,'1',1),(2246,'2245',1401,0,'1',1),(2248,'2247',1490,0,'1',1),(2250,'2249',1490,0,'1',1),(2252,'2251',1525,0,'1',1),(2253,'2252',2252,0,'1',1),(2254,'2253',1545,0,'1',1),(2255,'2254',1551,0,'1',1),(2256,'2255',1605,0,'1',1),(2257,'2256',1611,0,'1',1),(2258,'2257',1611,0,'1',1),(2259,'2258',1571,0,'1',1),(2260,'2259',1405,0,'1',1),(2261,'2260',1683,0,'1',1),(2262,'2261',1766,0,'1',1),(2264,'2263',1731,0,'1',1),(2265,'2264',1551,0,'1',1),(2266,'2265',2265,0,'1',1),(2267,'2266',2171,0,'1',1),(2268,'2267',1525,1643,'1',1),(2269,'2268',1525,0,'1',1),(2270,'2269',1525,0,'1',1),(2271,'2270',1551,0,'1',1),(2272,'2271',2271,0,'1',1),(2273,'2272',2275,0,'1',1),(2274,'2273',2275,0,'1',1),(2275,'2274',2277,0,'1',1),(2276,'2275',1778,1643,'1',1),(2277,'2276',1551,0,'1',1),(2278,'2277',1549,0,'1',1),(2279,'2278',1731,0,'1',1),(2280,'2279',1546,0,'1',1),(2281,'2280',1546,0,'1',1),(2282,'2281',1546,0,'1',1),(2283,'2282',1571,0,'1',1),(2284,'2283',1555,0,'1',1),(2285,'2284',1555,0,'1',1),(2286,'2285',1555,0,'1',1),(2287,'2286',1718,0,'1',1),(2288,'2287',1982,0,'1',1),(2289,'2288',2203,0,'1',1),(2290,'2289',2172,0,'1',1),(2291,'2290',1725,0,'1',1),(2292,'2291',1850,0,'1',1),(2293,'2292',1805,0,'1',1),(2294,'2293',1759,0,'1',1),(2295,'2294',1474,0,'1',1),(2297,'2296',1648,0,'1',1),(2298,'2297',1656,0,'1',1),(2299,'2298',1731,0,'1',1),(2300,'2299',1471,0,'1',1),(2302,'2301',1471,0,'1',1),(2303,'2302',1764,0,'1',1),(2304,'2303',1916,0,'1',1),(2306,'2305',1396,0,'1',1),(2307,'2306',1917,0,'1',1),(2308,'2307',1780,0,'1',1),(2309,'2308',2308,0,'1',1),(2310,'2309',1650,0,'1',1),(2311,'2310',1774,0,'1',1),(2312,'2311',1805,0,'1',1),(2313,'2312',2205,0,'1',1),(2314,'2313',1711,0,'1',1),(2315,'2314',1711,0,'1',1),(2316,'2315',1711,0,'1',1),(2317,'2316',1711,0,'1',1),(2318,'2317',1621,0,'1',1),(2319,'2318',1854,0,'1',1),(2320,'2319',1658,0,'1',1),(2321,'2320',2320,0,'1',1),(2322,'2321',1658,0,'1',1),(2324,'2323',1879,0,'1',1),(2325,'2324',1894,0,'1',1),(2326,'2325',1785,0,'1',1),(2327,'2326',1764,0,'1',1),(2328,'2327',1496,0,'1',1),(2329,'2328',1496,0,'1',1),(2330,'2329',2032,0,'1',1),(2332,'2331',1513,0,'1',1),(2335,'2334',1655,0,'1',1),(2336,'2335',1770,0,'1',1),(2337,'2336',2336,0,'1',1),(2338,'2337',2185,0,'1',1),(2339,'2338',2185,0,'1',1),(2340,'2339',2185,0,'1',1),(2341,'2340',1657,0,'1',1),(2342,'2341',1396,0,'1',1),(2343,'2342',1513,0,'1',1),(2345,'2344',1495,0,'1',1),(2346,'2345',1388,0,'1',1),(2347,'2346',1656,0,'1',1),(2348,'2347',1686,0,'1',1),(2349,'2348',1648,0,'1',1),(2350,'2349',2308,0,'1',1),(2352,'2351',1703,0,'1',1),(2353,'2352',1490,0,'1',1),(2354,'2353',1780,0,'1',1),(2356,'2355',2359,0,'1',1),(2358,'2357',1490,0,'1',1),(2359,'2358',1490,0,'1',1),(2361,'2360',2125,0,'1',1),(2362,'2361',1490,0,'1',1),(2364,'2363',1490,0,'1',1),(2366,'2365',1490,0,'1',1),(2368,'2367',1489,0,'1',1),(2369,'2368',2308,0,'1',1),(2371,'2370',1771,0,'1',1),(2372,'2371',1662,0,'1',1),(2373,'2372',1648,0,'1',1),(2374,'2373',1656,0,'1',1),(2375,'2374',1688,0,'1',1),(2376,'2375',1650,0,'1',1),(2377,'2376',2125,0,'1',1),(2378,'2377',1758,0,'1',1),(2380,'2379',1633,0,'1',1),(2381,'2380',1400,0,'1',1),(2382,'2381',2185,0,'1',1),(2383,'2382',1613,0,'1',1),(2384,'2383',2205,0,'1',1),(2385,'2384',2384,0,'1',1),(2386,'2385',2205,0,'1',1),(2387,'2386',2386,0,'1',1),(2388,'2387',2386,0,'1',1),(2389,'2388',1904,0,'1',1),(2390,'2389',1810,0,'1',1),(2391,'2390',2205,0,'1',1),(2392,'2391',1899,0,'1',1),(2393,'2392',1861,0,'1',1),(2394,'2393',1652,0,'1',1),(2395,'2394',1652,0,'1',1),(2396,'2395',2203,0,'1',1),(2397,'2396',1780,0,'1',1),(2398,'2397',1976,0,'1',1),(2399,'2398',1693,0,'1',1),(2400,'2399',2399,0,'1',1),(2402,'2401',1721,0,'1',1),(2403,'2402',1787,0,'1',1),(2404,'2403',2120,0,'1',1),(2405,'2404',1731,0,'1',1),(2406,'2405',1656,0,'1',1),(2407,'2406',1729,0,'1',1),(2408,'2407',2205,0,'1',1),(2409,'2408',1935,0,'1',1),(2410,'2409',1392,0,'1',1),(2411,'2410',2205,0,'1',1),(2412,'2411',2411,0,'1',1),(2413,'2412',1780,0,'1',1),(2414,'2413',2125,0,'1',1),(2416,'2415',2373,0,'1',1),(2418,'2417',2373,0,'1',1),(2420,'2419',1616,0,'1',1),(2422,'2421',1780,0,'1',1),(2423,'2422',2125,0,'1',1),(2424,'2423',2125,0,'1',1),(2425,'2424',2185,0,'1',1),(2426,'2425',2185,0,'1',1),(2427,'2426',2185,0,'1',1),(2428,'2427',1657,0,'1',1),(2429,'2428',2428,0,'1',1),(2430,'2429',2429,0,'1',1),(2431,'2430',1466,0,'1',1),(2432,'2431',1765,0,'1',1),(2438,'2437',1923,0,'1',1),(2439,'2438',1925,0,'1',1),(2440,'2439',1921,0,'1',1),(2441,'2440',1903,0,'1',1),(2442,'2441',1466,0,'1',1),(2443,'2442',1819,0,'1',1),(2444,'2443',1466,0,'1',1),(2445,'2444',1831,0,'1',1),(2446,'2445',1620,0,'1',1),(2447,'2446',1616,0,'1',1),(2448,'2447',2447,0,'1',1),(2449,'2448',1616,0,'1',1),(2451,'2450',2022,0,'1',1),(2452,'2451',2451,0,'1',1),(2454,'2453',2451,0,'1',1),(2456,'2455',1394,0,'1',1),(2457,'2456',1618,0,'1',1),(2458,'2457',2457,0,'1',1),(2460,'2459',1618,0,'1',1),(2461,'2460',1612,0,'1',1),(2462,'2461',2036,0,'1',1),(2463,'2462',1455,0,'1',1),(2464,'2463',1828,0,'1',1),(2465,'2464',1765,0,'1',1),(2466,'2465',2465,0,'1',1),(2467,'2466',2465,0,'1',1),(2469,'2468',2457,0,'1',1),(2471,'2470',2472,0,'1',1),(2472,'2471',1618,0,'1',1),(2473,'2472',2457,0,'1',1),(2475,'2474',1618,0,'1',1),(2476,'2475',1389,0,'1',1),(2477,'2476',1716,0,'1',1),(2478,'2477',2086,0,'1',1),(2479,'2478',1420,0,'1',1),(2480,'2479',1726,0,'1',1),(2481,'2480',1726,2480,'1',1),(2482,'2481',1726,0,'1',1),(2483,'2482',1726,2482,'1',1),(2485,'2484',1764,0,'1',1),(2486,'2485',1764,2485,'1',1),(2487,'2486',1764,0,'1',1),(2488,'2487',1379,0,'1',1),(2489,'2488',2488,0,'1',1),(2490,'2489',2489,0,'1',1),(2491,'2490',1686,0,'1',1),(2492,'2491',1684,0,'1',1),(2493,'2492',1729,0,'1',1),(2494,'2493',2488,0,'1',1),(2495,'2494',1729,0,'1',1),(2496,'2495',1686,0,'1',1),(2497,'2496',1686,0,'1',1),(2498,'2497',1684,0,'1',1),(2499,'2498',2498,0,'1',1),(2500,'2499',2498,0,'1',1),(2501,'2500',2492,2502,'1',1),(2502,'2501',1787,0,'1',1),(2503,'2502',1787,0,'1',1),(2504,'2503',2502,0,'1',1),(2505,'2504',2503,0,'1',1),(2506,'2505',2503,0,'1',1),(2507,'2506',2505,0,'1',1),(2508,'2507',1765,0,'1',1),(2509,'2508',2508,0,'1',1),(2510,'2509',1767,0,'1',1),(2511,'2510',2484,1670,'1',1),(2512,'NONCLASSES',1,0,'0',1),(2513,'',1,0,'1',1),(2514,'',1,0,'1',1),(2515,'',1,0,'1',1),(2516,'',1,0,'1',1),(2517,'',1,0,'1',1),(2518,'',1,0,'1',1),(2519,'',1,0,'1',1),(2520,'',1,0,'1',1),(2521,'',1,0,'1',1),(2522,'',1,0,'1',1),(2523,'',2522,0,'1',1),(2524,'',2520,0,'1',1),(2525,'',2520,0,'1',1),(2526,'',1,0,'1',1),(2527,'',2526,0,'1',1),(2528,'',2526,0,'1',1),(2529,'',2526,0,'1',1),(2530,'',2526,0,'1',1),(2531,'',2521,0,'1',1),(2532,'',2521,0,'1',1),(2533,'',1,0,'1',1),(2534,'',2533,0,'1',1),(2535,'',2533,0,'1',1),(2536,'',1,0,'1',1),(2537,'',2536,0,'1',1),(2538,'',2536,0,'1',1),(2539,'',2522,0,'1',1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `noeuds` ENABLE KEYS */;

--
-- Table structure for table `notice_statut`
--

DROP TABLE IF EXISTS `notice_statut`;
CREATE TABLE `notice_statut` (
  `id_notice_statut` smallint(5) unsigned NOT NULL auto_increment,
  `gestion_libelle` varchar(255) default NULL,
  `opac_libelle` varchar(255) default NULL,
  `notice_visible_opac` tinyint(1) NOT NULL default '1',
  `notice_visible_gestion` tinyint(1) NOT NULL default '1',
  `expl_visible_opac` tinyint(1) NOT NULL default '1',
  `class_html` varchar(255) NOT NULL default '',
  `notice_visible_opac_abon` tinyint(1) NOT NULL default '0',
  `expl_visible_opac_abon` int(10) unsigned NOT NULL default '0',
  `explnum_visible_opac` int(1) unsigned NOT NULL default '1',
  `explnum_visible_opac_abon` int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_notice_statut`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notice_statut`
--


/*!40000 ALTER TABLE `notice_statut` DISABLE KEYS */;
LOCK TABLES `notice_statut` WRITE;
INSERT INTO `notice_statut` VALUES (1,'ບໍ່ເຈາະຈົງສະຖານະພາບ','',1,1,1,'statutnot1',0,0,1,0),(2,'ຫ້າມໃຫ້ຢືມ','',0,1,1,'statutnot2',0,0,1,0),(3,'ສັ່ງເຂົ້າຢູ່','',1,1,1,'statutnot4',0,0,1,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `notice_statut` ENABLE KEYS */;

--
-- Table structure for table `notices`
--

DROP TABLE IF EXISTS `notices`;
CREATE TABLE `notices` (
  `notice_id` mediumint(8) unsigned NOT NULL auto_increment,
  `typdoc` char(2) NOT NULL default 'a',
  `tit1` tinytext NOT NULL,
  `tit2` tinytext NOT NULL,
  `tit3` tinytext NOT NULL,
  `tit4` tinytext NOT NULL,
  `tparent_id` mediumint(8) unsigned NOT NULL default '0',
  `tnvol` varchar(16) default '',
  `ed1_id` mediumint(8) unsigned NOT NULL default '0',
  `ed2_id` mediumint(8) unsigned NOT NULL default '0',
  `coll_id` mediumint(8) unsigned NOT NULL default '0',
  `subcoll_id` mediumint(8) unsigned NOT NULL default '0',
  `year` varchar(16) default '',
  `nocoll` varchar(16) default '',
  `mention_edition` varchar(255) NOT NULL default '',
  `code` varchar(16) NOT NULL default '',
  `npages` varchar(54) NOT NULL default '',
  `ill` varchar(54) NOT NULL default '',
  `size` varchar(54) NOT NULL default '',
  `accomp` varchar(54) NOT NULL default '',
  `n_gen` text NOT NULL,
  `n_contenu` text NOT NULL,
  `n_resume` text NOT NULL,
  `lien` tinytext NOT NULL,
  `eformat` varchar(255) NOT NULL default '',
  `index_l` text NOT NULL,
  `indexint` int(8) unsigned NOT NULL default '0',
  `index_serie` tinytext,
  `index_matieres` text NOT NULL,
  `niveau_biblio` char(1) NOT NULL default 'm',
  `niveau_hierar` char(1) NOT NULL default '0',
  `origine_catalogage` int(8) unsigned NOT NULL default '1',
  `prix` varchar(255) NOT NULL default '',
  `index_n_gen` text,
  `index_n_contenu` text,
  `index_n_resume` text,
  `index_sew` text,
  `index_wew` text,
  `statut` int(5) NOT NULL default '1',
  `commentaire_gestion` text NOT NULL,
  `create_date` datetime NOT NULL default '2005-01-01 00:00:00',
  `update_date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `notice_parent` int(9) unsigned NOT NULL default '0',
  `relation_type` char(1) NOT NULL default 'a',
  PRIMARY KEY  (`notice_id`),
  KEY `typdoc` (`typdoc`),
  KEY `tparent_id` (`tparent_id`),
  KEY `ed1_id` (`ed1_id`),
  KEY `ed2_id` (`ed2_id`),
  KEY `coll_id` (`coll_id`),
  KEY `subcoll_id` (`subcoll_id`),
  KEY `cb` (`code`),
  KEY `indexint` (`indexint`),
  KEY `notice_parent` (`notice_parent`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notices`
--


/*!40000 ALTER TABLE `notices` DISABLE KEYS */;
LOCK TABLES `notices` WRITE;
INSERT INTO `notices` VALUES (1,'a','ຊີວິດ ແລະ ຜົນງານຂອງພຣະມະຫາເຖຣະ5 ອົງ','','','',0,'',8,0,0,0,'2001','','1','','52 ໜ້າ','','','','','','','','','',6,'  ','  ','m','0',1,'7000 ກີບ','  ','  ','  ',' 5 ',' ຊີວິດ ແລະ ຜົນງານຂອງພຣະມະຫາເຖຣະ5 ອົງ   ',1,'','2006-10-13 15:15:24','2006-10-13 15:15:24',0,'a'),(2,'a','ພົງສາວະດານລາວ ເຖິງ 1946','','','',0,'',10,0,0,0,'2001','','1','','83 ໝ້າ','','','','','','','','','',0,'  ','  ','m','0',1,'9600ກີບ','  ','  ','  ',' 1946 ',' ພົງສາວະດານລາວ ເຖິງ 1946   ',1,'','2006-10-13 15:28:56','2006-10-13 15:28:56',0,'a'),(3,'a','ເມື່ອຂ້ອຍເປິດສະໝຸດບັນທຶກ','','','',0,'',9,0,0,0,'2002','','1','','277 ໝ້າ','','','','','','','','','',0,'  ','  ','m','0',1,'96000ກີບ','  ','  ','  ',' ເມື່ອຂ້ອຍເປິດສະໝຸດບັນທຶກ ',' ເມື່ອຂ້ອຍເປິດສະໝຸດບັນທຶກ   ',1,'','2006-10-13 15:32:56','2006-11-09 13:40:19',0,'a'),(4,'a','ຄອງແສນແສບຢ່າຊໍ້າຮອຍ','','','',0,'',6,0,0,0,'2000','','1','','53ໜ້າ','ມີພາບປະກອບ','','','','','','','','',0,'  ','  ','m','0',1,'82000 ກີບ','  ','  ','  ','  ',' ຄອງແສນແສບຢ່າຊໍ້າຮອຍ   ',1,'','2006-10-13 15:47:40','2006-10-13 15:47:40',0,'a'),(5,'a','ວິລະກຳເຈົ້າອານຸ','','','',0,'',6,0,0,0,'','','','','900ໜ້າ','ມີພາບປະກອບ','','','','','','','','',0,'  ','  ','m','0',1,'170000ກີບ','  ','  ','  ','  ',' ວິລະກຳເຈົ້າອານຸ   ',1,'','2006-10-13 15:52:00','2006-10-13 15:52:00',0,'a'),(6,'a','ກາບເມືອງພວນ','','','',0,'',13,0,0,0,'','','','','51ໜ້າ','ມີພາບປະກອບ','','','','','','','','',0,'  ','  ','m','0',1,'13000ກີບ','  ','  ','  ','  ',' ກາບເມືອງພວນ   ',1,'','2006-10-13 15:54:24','2006-10-13 15:54:24',0,'a'),(7,'a','ສະກຸນຕົ້ນດອກເຜິ້ງຂອງປະເທດໄທ,ລາວ','','','',0,'',17,0,0,0,'20004','','1','','450ໜ້າ','ມີພາບປະກອບ','','','','','','','','',0,'  ','  ','m','0',1,'7500 ກີບ','  ','  ','  ','  ',' ສະກຸນຕົ້ນດອກເຜິ້ງຂອງປະເທດໄທ,ລາວ   ',1,'','2006-10-13 15:57:46','2006-10-13 15:57:46',0,'a'),(8,'a','ທ້າວສຸຣະນາລີ ບາງທັດສະນະຂອງຄົນໄທ','','','',0,'',16,0,0,0,'','','','','68ໜ້າ','ມີພາບປະກອບ','','','','','','','','',0,'  ','  ','m','0',1,'5000 ກີບ','  ','  ','  ','  ',' ທ້າວສຸຣະນາລີ ບາງທັດສະນະຂອງຄົນໄທ   ',1,'','2006-10-13 15:59:50','2006-10-13 15:59:50',0,'a'),(9,'a','ປະຫວັດສາດລາວ 1946','','','',0,'',14,0,0,0,'','','','','852ໜ້າ','ມີພາບປະກອບ','','','','','','','','',0,'  ','  ','m','0',1,'200000 ກີບ','  ','  ','  ',' 1946 ',' ປະຫວັດສາດລາວ 1946   ',1,'','2006-10-13 16:02:02','2006-10-13 16:02:02',0,'a'),(10,'a','ການປຽບທຽບຜົນສົມທາງດ້ານຄະນິດສາດ','','','',0,'',20,0,0,0,'','','','','65ໜ້າ','','','','','','','','','',0,'  ','  ','m','0',1,'20000 ກີບ','  ','  ','  ','  ',' ການປຽບທຽບຜົນສົມທາງດ້ານຄະນິດສາດ   ',1,'','2006-10-13 16:06:11','2006-10-13 16:06:11',0,'a'),(11,'a','ກົດໝາຍປ່າໄມ້','','','',0,'',8,0,0,0,'','','','','156ໜ້າ','','','','','','','','','',0,'  ','  ','m','0',1,'700000ກີບ','  ','  ','  ','  ',' ກົດໝາຍປ່າໄມ້   ',1,'','2006-10-13 16:09:57','2006-10-13 16:09:57',0,'a'),(12,'a','ຮິດຄອງປະເພນີລາວ','','','',0,'',2,0,0,0,'','','','','67ໜ້າ','','','','','','','','','',0,'  ','  ','m','0',1,'5800ກີບ','  ','  ','  ','  ',' ຮິດຄອງປະເພນີລາວ   ',1,'','2006-10-13 16:12:44','2006-10-13 16:12:44',0,'a'),(13,'a','ແນວທາງການດຳເນີນງານສຳລັບຄະນະກຳມະການ','','','',0,'',19,0,0,0,'','','','','96ໜ້າ','','','','','','','','','',0,'  ','  ','m','0',1,'8000 ກີບ','  ','  ','  ','  ',' ແນວທາງການດຳເນີນງານສຳລັບຄະນະກຳມະການ   ',1,'','2006-10-13 16:14:28','2006-10-13 16:14:28',0,'a'),(14,'a','ຄົນຄວ້າວິທະຍາສາດທາງດ້ານວິຊາການແພດ','','','',0,'',18,0,0,0,'','','','','785ໜ້າ','','','','','','','','','',0,'  ','  ','m','0',1,'78000ກີບ','  ','  ','  ','  ',' ຄົນຄວ້າວິທະຍາສາດທາງດ້ານວິຊາການແພດ   ',1,'','2006-10-13 16:18:02','2006-10-13 16:18:02',0,'a'),(15,'a','ຮິດຄອງປະເພນີລາວ 2','','','',0,'',20,0,0,0,'','','','','35ໜ້າ','','','','','','ຮິດຄອງປະເພນີລາວ ','','','',0,'  ','  ','m','0',1,'34000ກີບ','  ','  ','  ',' 2 ',' ຮິດຄອງປະເພນີລາວ 2   ',1,'','2006-10-13 16:20:06','2006-10-13 16:20:06',0,'a'),(16,'a','ຕຳລາຢາພືນເມືອງ','','','',0,'',8,0,0,0,'2000','','6','','125ໜ້າ','','','','ຕຳລາຢາພືນເມືອງ ທີ່ມີຄຸນປະໂຫຍດທາງການແພດ','','','','','',0,'  ','  ','m','0',1,'12500ກີບ','  ','  ','  ','  ',' ຕຳລາຢາພືນເມືອງ   ',1,'','2006-10-13 16:21:42','2006-10-13 16:22:48',0,'a'),(17,'a','ວິທີຮັກສາຄວາມງາມ','','','',0,'',16,0,0,0,'','','','','','64ໜ້າ','','','ການຮັກສາຄວາມງາມ','','','','','',0,'  ','  ','m','0',1,'73000ກີບ','  ','  ','  ','  ',' ວິທີຮັກສາຄວາມງາມ   ',1,'','2006-10-13 16:25:15','2006-10-13 16:25:15',0,'a'),(18,'a','ຊີວິດ ແລະ ຜົນງານ','','','',0,'',6,0,0,0,'','','','','','','','','','','','','','',0,NULL,'','s','1',1,'',NULL,NULL,NULL,'  ','ຊີວິດ ແລະ ຜົນງານ   ',1,'','2006-10-13 16:27:45','2006-10-13 16:27:45',0,'a'),(19,'a','ຄູ່ມືສຳລັບຄູ່ສອນ','','','',0,'',2,0,0,0,'','','','','','','','','','','','','','',0,NULL,'','s','1',1,'',NULL,NULL,NULL,'  ','ຄູ່ມືສຳລັບຄູ່ສອນ   ',1,'','2006-10-13 16:31:07','2006-10-13 16:31:07',0,'a'),(20,'a','ເອກະສານເພີ່ມທະວີຄວາມສາມັກຄີ','','','',0,'',16,0,0,0,'','','','','','','','','','','','','','',0,NULL,'','s','1',1,'',NULL,NULL,NULL,' ເອກະສານເພີ່ມທະວີຄວາມສາມັກຄີ    ','ເອກະສານເພີ່ມທະວີຄວາມສາມັກຄີ   ',1,'','2006-10-13 16:34:39','2006-10-14 16:36:47',0,'a'),(21,'a','ເອກະສານເພີ່ມທະວີຄວາມສາມັກຄີ','','','',0,'',0,0,0,0,'','','','','','','','','','','','','','',35,'','  ','a','2',1,'','  ','  ','  ','  ','ເອກະສານເພີ່ມທະວີຄວາມສາມັກຄີ   ',1,'','2006-10-13 16:37:54','2006-10-13 16:37:54',0,'a'),(22,'a','ພູມປັນຍາບູຮານລາວ','','','',0,'',12,0,0,0,'','','','','','','','','','','','','','',33,NULL,'','s','1',1,'',NULL,NULL,NULL,'  ','ພູມປັນຍາບູຮານລາວ   ',1,'','2006-10-13 16:39:48','2006-10-13 16:39:48',0,'a'),(23,'a','ແຄນ ແລະ ສຽງແຄນ','','','',0,'',13,0,0,0,'','','','','','','','','','','','','','',0,NULL,'','s','1',1,'',NULL,NULL,NULL,'  ','ແຄນ ແລະ ສຽງແຄນ   ',1,'','2006-10-13 16:41:12','2006-10-13 16:41:12',0,'a'),(24,'a','ບົດລາຍງານສະພາບແວດລ້ອມ ສປປ ລາວ','','','',0,'',15,0,0,0,'','','','','','','','','','','','','','',0,NULL,'','s','1',1,'',NULL,NULL,NULL,'  ','ບົດລາຍງານສະພາບແວດລ້ອມ ສປປ ລາວ   ',1,'','2006-10-13 16:44:23','2006-10-13 16:44:23',0,'a'),(25,'a','ປື້ມທົ່ວໄປ','','','',0,'',0,0,0,0,'','','','','','','','','','','','','','',0,'  ','  ','m','0',1,'','  ','  ','  ','  ປື້ມທົ່ວໄປ    ',' ປື້ມທົ່ວໄປ   ',1,'','2006-10-14 09:09:03','2006-10-16 07:23:21',0,'a'),(27,'a','ບົດສະເໜີກ່ຽວກັບວິທະຍາສາດສິ່ງແວດລ້ອມ','','','',0,'',12,0,0,0,'','','','','121ໜ້າ','ມີພາບປະກອບ','','','','','','','','',2,'  ','  ','m','0',1,'12500ກີບ','  ','  ','  ','  ບົດສະເໜີກ່ຽວກັບວິທະຍາສາດສິ່ງແວດລ້ອມ    ',' ບົດສະເໜີກ່ຽວກັບວິທະຍາສາດສິ່ງແວດລ້ອມ   ',1,'','2006-10-27 15:39:29','2006-10-27 15:39:29',0,'a'),(28,'a','ການ','','','',0,'',0,0,0,0,'','','','','','','','','','','','','','',0,'  ','  ','m','0',1,'','  ','  ','  ','  ການ    ',' ການ   ',1,'','2006-11-03 18:59:28','2006-11-03 18:59:28',0,'a');
UNLOCK TABLES;
/*!40000 ALTER TABLE `notices` ENABLE KEYS */;

--
-- Table structure for table `notices_categories`
--

DROP TABLE IF EXISTS `notices_categories`;
CREATE TABLE `notices_categories` (
  `notcateg_notice` int(9) unsigned NOT NULL default '0',
  `num_noeud` int(9) unsigned NOT NULL default '0',
  `num_vedette` int(3) unsigned NOT NULL default '0',
  `ordre_vedette` int(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`notcateg_notice`,`num_noeud`,`num_vedette`),
  KEY `num_noeud` (`num_noeud`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notices_categories`
--


/*!40000 ALTER TABLE `notices_categories` DISABLE KEYS */;
LOCK TABLES `notices_categories` WRITE;
INSERT INTO `notices_categories` VALUES (1,2520,0,1),(2,2533,0,1),(3,2045,0,1),(4,2533,0,1),(5,2533,0,1),(6,2520,0,1),(7,2522,0,1),(8,2520,0,1),(9,2533,0,1),(10,2520,0,1),(11,2522,0,1),(12,2521,0,1),(14,2526,0,1),(15,2520,0,1),(18,2520,0,1),(19,2520,0,1),(19,2524,0,1),(20,2529,0,1),(21,2534,0,1),(22,2533,0,1),(23,2521,0,1),(24,2539,0,1),(1,2112,0,1),(2,2045,0,1),(3,2520,0,1),(4,1436,0,1),(5,1936,0,1),(6,2045,0,1),(6,2279,0,1),(7,1445,0,1),(8,1414,0,1),(9,1414,0,1),(10,1414,0,1),(11,1391,0,1),(12,1391,0,1),(13,1599,0,1),(14,1655,0,1),(15,2214,0,1),(16,1884,0,1),(17,1748,0,1),(18,1828,0,1),(19,1423,0,1),(19,1447,0,1),(24,1406,0,1),(25,1648,0,1),(25,1830,0,1),(25,2297,0,1),(26,1844,0,1),(29,1899,0,1),(30,1545,0,1),(31,1410,0,1),(32,1748,0,1),(33,1976,0,1),(35,1976,0,1),(36,1976,0,1),(37,1976,0,1),(38,1976,0,1),(39,1721,0,1),(39,1976,0,1),(41,1545,0,1),(41,1748,0,1),(42,1748,0,1),(44,1525,0,1),(47,1525,0,1),(47,1639,0,1),(48,1401,0,1),(49,1740,0,1),(50,1596,0,1),(51,2125,0,1),(53,2110,0,1),(54,1748,0,1),(58,2514,0,1),(27,2520,0,1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `notices_categories` ENABLE KEYS */;

--
-- Table structure for table `notices_custom`
--

DROP TABLE IF EXISTS `notices_custom`;
CREATE TABLE `notices_custom` (
  `idchamp` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `titre` varchar(255) default NULL,
  `type` varchar(10) NOT NULL default 'text',
  `datatype` varchar(10) NOT NULL default '',
  `options` text,
  `multiple` int(11) NOT NULL default '0',
  `obligatoire` int(11) NOT NULL default '0',
  `ordre` int(11) default NULL,
  PRIMARY KEY  (`idchamp`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notices_custom`
--


/*!40000 ALTER TABLE `notices_custom` DISABLE KEYS */;
LOCK TABLES `notices_custom` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `notices_custom` ENABLE KEYS */;

--
-- Table structure for table `notices_custom_lists`
--

DROP TABLE IF EXISTS `notices_custom_lists`;
CREATE TABLE `notices_custom_lists` (
  `notices_custom_champ` int(10) unsigned NOT NULL default '0',
  `notices_custom_list_value` varchar(255) default NULL,
  `notices_custom_list_lib` varchar(255) default NULL,
  `ordre` int(11) default NULL,
  KEY `notices_custom_champ` (`notices_custom_champ`),
  KEY `noti_champ_list_value` (`notices_custom_champ`,`notices_custom_list_value`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notices_custom_lists`
--


/*!40000 ALTER TABLE `notices_custom_lists` DISABLE KEYS */;
LOCK TABLES `notices_custom_lists` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `notices_custom_lists` ENABLE KEYS */;

--
-- Table structure for table `notices_custom_values`
--

DROP TABLE IF EXISTS `notices_custom_values`;
CREATE TABLE `notices_custom_values` (
  `notices_custom_champ` int(10) unsigned NOT NULL default '0',
  `notices_custom_origine` int(10) unsigned NOT NULL default '0',
  `notices_custom_small_text` varchar(255) default NULL,
  `notices_custom_text` text,
  `notices_custom_integer` int(11) default NULL,
  `notices_custom_date` date default NULL,
  `notices_custom_float` float default NULL,
  KEY `notices_custom_champ` (`notices_custom_champ`),
  KEY `notices_custom_origine` (`notices_custom_origine`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notices_custom_values`
--


/*!40000 ALTER TABLE `notices_custom_values` DISABLE KEYS */;
LOCK TABLES `notices_custom_values` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `notices_custom_values` ENABLE KEYS */;

--
-- Table structure for table `notices_global_index`
--

DROP TABLE IF EXISTS `notices_global_index`;
CREATE TABLE `notices_global_index` (
  `num_notice` mediumint(8) NOT NULL default '0',
  `no_index` mediumint(8) NOT NULL default '0',
  `infos_global` text NOT NULL,
  `index_infos_global` text NOT NULL,
  PRIMARY KEY  (`num_notice`,`no_index`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notices_global_index`
--


/*!40000 ALTER TABLE `notices_global_index` DISABLE KEYS */;
LOCK TABLES `notices_global_index` WRITE;
INSERT INTO `notices_global_index` VALUES (1,1,'   ຊີວິດ ແລະ ຜົນງານຂອງພຣະມະຫາເຖຣະ5 ອົງ        ຄະນະອັກສອນສາດ ມ/ຊ  ວັນນະຄະດີ 050 ວາລະສານທົ່ວໄປ - ລາຍປີ ນະຄອນຫລວງ ','     5               ຄະນະອັກສອນສາດ ມ/ຊ      050 ວາລະສານທົ່ວໄປ - ລາຍປີ   ນະຄອນຫລວງ  '),(2,1,'   ພົງສາວະດານລາວ ເຖິງ 1946        ສີລາ ວິລະວົງ  ປະຫວັດສາດ ໂຮງພິມມັນທາຕຸລາດ ','     1946               ສີລາ ວິລະວົງ      ໂຮງພິມມັນທາຕຸລາດ  '),(3,1,'   ເມື່ອຂ້ອຍເປິດສະໝຸດບັນທຶກ        ດຳດວນ ພົມດວງສີ  ວັນນະຄະດີ ໂຮງພິມແຫ່ງລັດ ','     ເມື່ອຂ້ອຍເປິດສະໝຸດບັນທຶກ               ດຳດວນ ພົມດວງສີ      ໂຮງພິມແຫ່ງລັດ  '),(4,1,'   ຄອງແສນແສບຢ່າຊໍ້າຮອຍ        ສະຖາບັນຄົນຄວ້າວັດທະນະທຳ  ປະຫວັດສາດ ສະຖາບັນ ','                    ສະຖາບັນຄົນຄວ້າວັດທະນະທຳ      ສະຖາບັນ  '),(5,1,'   ວິລະກຳເຈົ້າອານຸ        ສຸເນດ ໂພທິສານ  ປະຫວັດສາດ ສະຖາບັນ ','                    ສຸເນດ ໂພທິສານ      ສະຖາບັນ  '),(6,1,'   ກາບເມືອງພວນ        ບົວໄຂ ເພັງພະຈັນ  ວັນນະຄະດີ ສີສະຫວາດການພິມ ','                    ບົວໄຂ ເພັງພະຈັນ      ສີສະຫວາດການພິມ  '),(7,1,'   ສະກຸນຕົ້ນດອກເຜິ້ງຂອງປະເທດໄທ,ລາວ        ບຸນມີ ເທບສີເມືອງ  ທຳມະຊາດ ກຸງເທບ ','                    ບຸນມີ ເທບສີເມືອງ      ກຸງເທບ  '),(8,1,'   ທ້າວສຸຣະນາລີ ບາງທັດສະນະຂອງຄົນໄທ        ຄຳຜາຍ ບຸບຜາ  ວັນນະຄະດີ ປາກປາສັກການພິມ ','                    ຄຳຜາຍ ບຸບຜາ      ປາກປາສັກການພິມ  '),(9,1,'   ປະຫວັດສາດລາວ 1946        ສຸຈິດ ວົງເທບ  ປະຫວັດສາດ ອົງການອະນາໄມໂລກ ','     1946               ສຸຈິດ ວົງເທບ      ອົງການອະນາໄມໂລກ  '),(10,1,'   ການປຽບທຽບຜົນສົມທາງດ້ານຄະນິດສາດ        ບຸນສີ ບູລົມ  ວັນນະຄະດີ ສຳນັກພິມແລະຈຳໜ່າຍປືມ ','                    ບຸນສີ ບູລົມ      ສຳນັກພິມແລະຈຳໜ່າຍປືມ  '),(11,1,'   ກົດໝາຍປ່າໄມ້        ກົມປ່າໄມ້  ທຳມະຊາດ ນະຄອນຫລວງ ','                    ກົມປ່າໄມ້      ນະຄອນຫລວງ  '),(12,1,'   ຮິດຄອງປະເພນີລາວ        ສຸເນດ ໂພທິສານ  ກົມການເມືອງ ແລະ ການປົກຄອງ  ໂຄຈອນ ແກ້ວມະນີວົງ  ວິທະຍາສາດ ໂຮງພິມສຶກສາ ','                    ສຸເນດ ໂພທິສານ   ກົມການເມືອງ ແລະ ການປົກຄອງ   ໂຄຈອນ ແກ້ວມະນີວົງ      ໂຮງພິມສຶກສາ  '),(13,1,'   ແນວທາງການດຳເນີນງານສຳລັບຄະນະກຳມະການ        ອົງການອະນາໄມໂລກ  ສະພານທອງການພິມ ','                    ອົງການອະນາໄມໂລກ   ສະພານທອງການພິມ  '),(14,1,'   ຄົນຄວ້າວິທະຍາສາດທາງດ້ານວິຊາການແພດ        ຄຳຜາຍ ບຸບຜາ  ກົດໜາຍ ຂອນແກ່ນ ','                    ຄຳຜາຍ ບຸບຜາ      ຂອນແກ່ນ  '),(15,1,'   ຮິດຄອງປະເພນີລາວ 2    ຮິດຄອງປະເພນີລາວ     ຄະນະອັກສອນສາດ ມ/ຊ  ວັນນະຄະດີ ສຳນັກພິມແລະຈຳໜ່າຍປືມ ','     2               ຄະນະອັກສອນສາດ ມ/ຊ      ສຳນັກພິມແລະຈຳໜ່າຍປືມ  '),(16,1,'   ຕຳລາຢາພືນເມືອງ     ຕຳລາຢາພືນເມືອງ ທີ່ມີຄຸນປະໂຫຍດທາງການແພດ   ບຸນສີ ບູລົມ  ນະຄອນຫລວງ ','                    ບຸນສີ ບູລົມ   ນະຄອນຫລວງ  '),(17,1,'   ວິທີຮັກສາຄວາມງາມ     ການຮັກສາຄວາມງາມ   ບົວໄຂ ເພັງພະຈັນ  ປາກປາສັກການພິມ ','                    ບົວໄຂ ເພັງພະຈັນ   ປາກປາສັກການພິມ  '),(18,1,'  ຊີວິດ ແລະ ຜົນງານ        ສີລາ ວິລະວົງ  ວັນນະຄະດີ ສະຖາບັນ ','          ສີລາ ວິລະວົງ      ສະຖາບັນ  '),(19,1,'  ຄູ່ມືສຳລັບຄູ່ສອນ        ມູນນິທິຊາຊາກາວາ ເພື່ອສັນຕິພາບ  ວັນນະຄະດີ ວັນນະຄະດີລາວ ໂຮງພິມສຶກສາ ','          ມູນນິທິຊາຊາກາວາ ເພື່ອສັນຕິພາບ         ໂຮງພິມສຶກສາ  '),(20,1,'  ເອກະສານເພີ່ມທະວີຄວາມສາມັກຄີ        ດຳດວນ ພົມດວງສີ  ກົດໜາຍ ລາວ ປາກປາສັກການພິມ ','   ເອກະສານເພີ່ມທະວີຄວາມສາມັກຄີ          ດຳດວນ ພົມດວງສີ      ປາກປາສັກການພິມ  '),(22,1,'  ພູມປັນຍາບູຮານລາວ        ຄະນະຈັດຕັງສູນກາງພັກ  ປະຫວັດສາດ 320 ການເມືອງ ການປົກຄອງ ','          ຄະນະຈັດຕັງສູນກາງພັກ      320 ການເມືອງ   ການປົກຄອງ  '),(23,1,'  ແຄນ ແລະ ສຽງແຄນ        ທອງມາລີ ສຸລາດ  ວິທະຍາສາດ ສີສະຫວາດການພິມ ','          ທອງມາລີ ສຸລາດ      ສີສະຫວາດການພິມ  '),(26,1,'   dfhsdfh        ','      dfhsdfh                 '),(25,1,'   ປື້ມທົ່ວໄປ        ','      ປື້ມທົ່ວໄປ                 '),(24,1,'  ບົດລາຍງານສະພາບແວດລ້ອມ ສປປ ລາວ        ກົມປ່າໄມ້  ປ່າໄມ້ ມູນນິທິຊາຊາກາວາ ','          ກົມປ່າໄມ້      ມູນນິທິຊາຊາກາວາ  '),(29,1,'   Bagnes  Madagascar         Go   Un nouveau monde : la Terre Madagascar 910 Gographie - voyages ','  jojo   bagnes madagascar               geo nouveau monde terre   madagascar   910 geographie voyages  '),(30,1,'   Tatars de Crime         Go   Un nouveau monde : la Terre Voyage 910 Gographie - voyages ','  jojo   tatars crimee               geo nouveau monde terre   voyage   910 geographie voyages  '),(31,1,'   Marigot africain         Go   Un nouveau monde : la Terre Afrique ','  jojo   marigot africain               geo nouveau monde terre   afrique  '),(32,1,'   Chateaux de la Loire (2)         Go   Un nouveau monde : la Terre Pays de la Loire 910 Gographie - voyages ','  jojo   chateaux loire 2               geo nouveau monde terre   pays loire   910 geographie voyages  '),(33,1,'   Paysages afghans         Go   Un nouveau monde : la Terre Afghanistan 910 Gographie - voyages ','  jojo   paysages afghans               geo nouveau monde terre   afghanistan   910 geographie voyages  '),(35,1,'   Peuples d\'Afghanistan         Go   Un nouveau monde : la Terre Afghanistan 910 Gographie - voyages ','  jojo   peuples afghanistan               geo nouveau monde terre   afghanistan   910 geographie voyages  '),(36,1,'   Tribus Pachtounes         Go   Un nouveau monde : la Terre Afghanistan 910 Gographie - voyages ','  jojo   tribus pachtounes               geo nouveau monde terre   afghanistan   910 geographie voyages  '),(37,1,'   femmes afghanes         Go   Un nouveau monde : la Terre Afghanistan ','  jojo   femmes afghanes               geo nouveau monde terre   afghanistan  '),(38,1,'   Histoire de l\'Afghanistan         Go   Un nouveau monde : la Terre Afghanistan 910 Gographie - voyages ','  jojo   histoire afghanistan               geo nouveau monde terre   afghanistan   910 geographie voyages  '),(39,1,'   Islam afghan         Go   Un nouveau monde : la Terre Islam Afghanistan ','  jojo   islam afghan               geo nouveau monde terre   islam   afghanistan  '),(40,1,'   Famille Allix         Go   Un nouveau monde : la Terre ','  jojo   famille allix               geo nouveau monde terre  '),(41,1,'   Chateaux de la Loire (1)       chateau loire chenonceau chambord cheverny  Go   Un nouveau monde : la Terre Voyage Pays de la Loire 910 Gographie - voyages ','  jojo   chateaux loire 1            chateau loire chenonceau chambord cheverny   geo nouveau monde terre   voyage   pays loire   910 geographie voyages  '),(42,1,'   Charte du XIIIe sicle, par laquelle Guillaume de Rezay de la paroisse de Ceaux (Maine et Loire) vend  Messire de Verne, chevalier, sept sous et six deniers de rente.   Acte pass en la cour d\'Angers le jeudi avant la Saint Urbain l\'an mille deux cent quatre vingt dix neuf.  excellent tat de conservation date en vieux style (V.ST.) - M. DU POUGET, archiviste-palographe de l\'Indre, a bien voulu attirer mon attention sur le fait que cette charte tait date du joedi devant la Saint Alban (Saint Aubin d\'Angers, qui se fte le 1er mars - Pques tombant en 1299 le 19 avril, il y a effectivement bien lieu de considrer que cette charte est du 25 fvrier 1300, nouveau style (N.ST.) charte rente archive Ceaux paroisse cens Angers Maine-et-Loire Rezay Guillaume de Pays de la Loire 940 Histoire de l\'Europe ','  jojo   charte xiiie siecle par laquelle guillaume rezay paroisse ceaux maine loire vend messire vernee chevalier sept sous six deniers rente acte passe cour angers jeudi avant saint urbain an mille deux cent quatre vingt dix neuf      excellent etat conservation   date vieux style v st m pouget archiviste paleographe indre bien voulu attirer mon attention sur fait que cette charte etait datee joedi devant saint alban saint aubin angers qui se fete 1er mars paques tombant 1299 19 avril il y effectivement bien lieu considerer que cette charte est 25 fevrier 1300 nouveau style n st   charte rente archive ceaux paroisse cens angers maine loire   rezay guillaume   pays loire   940 histoire europe  '),(44,1,'   Bruit de cochon     Bruitage courts. Bonne qualit d\'enregistrement.  cochon porc truie verrat porcelet goret cochette suids artiodactyles groin sound-fishing.net  Mammifres 590 Zoologie - (les animaux) sound-fishing.net ','  jojo   bruit cochon      bruitage courts bonne qualite enregistrement      cochon porc truie verrat porcelet goret cochette suides artiodactyles groin   sound fishing net   mammiferes   590 zoologie animaux   sound fishing net  '),(48,1,'   Canne    pommeau en forme de cochon  canne en bois prcieux, bichromie, pommeau sculpt et peint  canne cochon pied porc pommeau argent ouvrage prcieux sculpture\r\n Favulier Jacques Sculpture 680 Articles manufacturs ','  jojo   canne pommeau forme cochon      canne bois precieux bichromie pommeau sculpte peint      canne cochon pied porc pommeau argent ouvrage precieux sculpture   favulier jacques   sculpture   680 articles manufactures  '),(46,1,'   L\'adagio d\'Albinoni    Canon de Pachelbel, Jsus que ma joie demeure de J.S. Bach, Andante pour mandoline de Vivaldi, Menuet de Mozart, Menuet de Boccherini  On connat mal ce compositeur vnitien exactement contemporain de Vivaldi, mais une seule uvre, pourtant, a assur sa notorit, lAdagio pour cordes, extrait en fait du Concerto en r majeur. Cette longue cantilne plaintive a servi au film Quatre mariages et un enterrement.  Marion Alain Bride Philip 780 Musique Forlane ','     adagio albinoni   canon pachelbel jesus que ma joie demeure j s bach andante pour mandoline vivaldi menuet mozart menuet boccherini      on connait mal ce compositeur venitien exactement contemporain vivaldi mais seule uvre pourtant assure sa notoriete adagio pour cordes extrait fait concerto re majeur cette longue cantilene plaintive servi film quatre mariages enterrement      marion alain   bride philip   780 musique   forlane  '),(47,1,'   Couverture du magazine rustica   Ce que doit tre le porc parfait \" Ce que doit tre le porc parfait \" mentionn en couverture    Mammifres Mammifres 590 Zoologie - (les animaux) Rustica ','  jojo   couverture magazine rustica ce que doit etre porc parfait   \" ce que doit etre porc parfait \" mentionne couverture            mammiferes   mammiferes   590 zoologie animaux   rustica  '),(49,1,'   Tours. N65. Flle 78     Carte de Cassini Cote : Ge FF 18595 (65) BNF Richelieu Cartes et Plans Reprod. Sc 96/614\r\n. - Carte leve entre 1760 et 1762 par Bottin, Langelay, vrifie en 1763 et 1764 par La Briffe Ponsan. Lettre par Chambon. 78e feuille publie. Tours Indre-et-Loire France Cassini de Thury Csar-Franois Centre 910 Gographie - voyages Dpt de la Guerre ','  jojo   tours n 65 flle 78      carte cassini   cote ge ff 18595 65 bnf richelieu cartes plans reprod sc 96 614 carte levee entre 1760 1762 par bottin langelay verifiee 1763 1764 par briffe ponsan lettre par chambon 78e feuille publiee   tours indre loire france   cassini thury cesar francois   centre   910 geographie voyages   depot guerre  '),(50,1,'   Le Cochon d\'Hollywood       cochon porc hollywood acteur studio cinma Fraxler Hans Livre Collection Folio benjamin Gallimard ','  jojo   cochon hollywood            cochon porc hollywood acteur studio cinema   fraxler hans   livre   collection folio benjamin   gallimard  '),(51,1,'   Le Porc et les produits de la charcuterie, hygine, inspection, rglementation, par Th. Bourrier,..      Exemples illustrs, gravures reprsentant une ferme en Indre-et-Loire Indre-et-Loire ferme porc levage verrat truie porcelet cochelle Bourrier Thodore Aliments 640 Arts mnagers - cuisine, coutre, soins de beaut Asselin et Houzeau ','  jojo   porc produits charcuterie hygiene inspection reglementation par th bourrier         exemples illustres gravures representant ferme indre loire   indre loire ferme porc elevage verrat truie porcelet cochelle   bourrier theodore   aliments   640 arts menagers cuisine couture soins beaute   asselin houzeau  '),(53,1,'   Nimitz   roman     Langlois-Chassaignon Claudie Robinson Patrick Roman et nouvelle 800 Littrature A. Michel ','  jojo   nimitz roman               langlois chassaignon claudie   robinson patrick   roman nouvelle   800 litterature   michel  '),(54,1,'   tudes archologiques dans la Loire-Infrieure, ...   Arrondissements de Nantes et de Paimboeuf    Loire-Atlantique Orieux Eugne Pays de la Loire 910 Gographie - voyages impr. de Mme Vve Mellinet ','  jojo   etudes archeologiques dans loire inferieure arrondissements nantes paimboeuf            loire atlantique   orieux eugene   pays loire   910 geographie voyages   impr mme vve mellinet  '),(57,1,'   Germinal        Pichard Georges Zola mile BD adultes Mdia 1000 ','  jojo   germinal               pichard georges   zola emile   bd adultes   media 1000  '),(58,1,'   ພົງສາວະດານລາວ ເຖິງ 1946     ກ່ຽວກັບປະຫວັດສາດ, ໆລໆ   ສິນລະປະ ແລະວັດທະນະທຳ ໂຮງພິມມັນທາຕຸລາດ ','     1946                    '),(65,1,'   ຄອງແສນແສບຢ່າຊຳຮອຍ        ສະຖາບັນຄົນຄວ້າວັດທະນະທຳ  ສະຖາບັນ ','                         '),(59,1,'   ທົດລອງ        ສູນກາງສະຫະພັນກຳມະບານລາວ  ສະຖາບັນ ','                         '),(60,1,'   ກອງປະຊຸມສະຫະພັນກຳມະບານລາວ IV    ສະຫຼຸບຜົນສຳເລັດຂອງກອງປະຊູມ ກອງປະຊູມ  ກ່ຽວກັບກອງປະຊູມ ສູນກາງສະຫະພັນກຳມະບານລາວ  000 ຂໍ້ມູນ ການຕິດຕໍ່ຊື່ສານ ນະຄອນຫລວງ ','     iv                  000     '),(64,1,'   ຂໍ້ມູນສຳຮອງ        ຄະນະອັກສອນສາດ ມ/ຊ  ຫໍພິພິທະພັນ ','                         '),(61,1,'  ວິລະກຳເຈົ້າອະນຸ     ປະຫວັດເຈົ້າອານຸ  ປະຫວັດ ສຸເນດ ໂພທິສານ  000 ຂໍ້ມູນ ການຕິດຕໍ່ຊື່ສານ ສະຖາບັນ ','      bravo test reusi             000     '),(63,1,'   ກາບເມືອງພວນ     ກາບກອນ   ຄະນະອັກສອນສາດ ມ/ຊ  000 ຂໍ້ມູນ ການຕິດຕໍ່ຊື່ສານ ຫໍພິພິທະພັນ ','                       000     '),(27,1,'   ບົດສະເໜີກ່ຽວກັບວິທະຍາສາດສິ່ງແວດລ້ອມ        ຄຳຜາຍ ບຸບຜາ  ວັນນະຄະດີ 010 ຄວາມຮູ້ກ່ຽວກັບຫໍສະໝຸດ ການປົກຄອງ ','      ບົດສະເໜີກ່ຽວກັບວິທະຍາສາດສິ່ງແວດລ້ອມ                  ຄຳຜາຍ ບຸບຜາ      010 ຄວາມຮູ້ກ່ຽວກັບຫໍສະໝຸດ   ການປົກຄອງ  '),(28,1,'   ການ        ','      ການ                 ');
UNLOCK TABLES;
/*!40000 ALTER TABLE `notices_global_index` ENABLE KEYS */;

--
-- Table structure for table `notices_langues`
--

DROP TABLE IF EXISTS `notices_langues`;
CREATE TABLE `notices_langues` (
  `num_notice` int(8) unsigned NOT NULL default '0',
  `type_langue` int(1) unsigned NOT NULL default '0',
  `code_langue` char(3) NOT NULL default '',
  PRIMARY KEY  (`num_notice`,`type_langue`,`code_langue`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `notices_langues`
--


/*!40000 ALTER TABLE `notices_langues` DISABLE KEYS */;
LOCK TABLES `notices_langues` WRITE;
INSERT INTO `notices_langues` VALUES (1,0,'lao'),(1,1,'lao'),(2,0,'lao'),(2,1,'lao'),(3,0,'lao'),(3,1,'lao'),(4,0,'lao'),(4,1,'lao'),(5,0,'lao'),(5,1,'lao'),(6,0,'lao'),(6,1,'lao'),(7,0,'lao'),(7,1,'lao'),(8,0,'lao'),(8,1,'lao'),(9,0,'lao'),(9,1,'lao'),(10,0,'lao'),(10,1,'lao'),(11,0,'lao'),(11,1,'lao'),(12,0,'lao'),(13,0,'lao'),(13,1,'lao'),(14,0,'lao'),(14,1,'lao'),(15,0,'lao'),(16,0,'lao'),(17,0,'lao'),(18,0,'lao'),(19,0,'lao'),(20,0,'lao'),(21,0,'lao'),(21,1,'lao'),(22,0,'lao'),(23,0,'lao'),(24,0,'lao'),(25,0,'lao'),(27,0,'lao'),(27,1,'lao'),(28,0,'lao');
UNLOCK TABLES;
/*!40000 ALTER TABLE `notices_langues` ENABLE KEYS */;

--
-- Table structure for table `offres_remises`
--

DROP TABLE IF EXISTS `offres_remises`;
CREATE TABLE `offres_remises` (
  `num_fournisseur` int(5) unsigned NOT NULL default '0',
  `num_produit` int(8) unsigned NOT NULL default '0',
  `remise` float(4,2) unsigned NOT NULL default '0.00',
  `condition_remise` text,
  PRIMARY KEY  (`num_fournisseur`,`num_produit`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `offres_remises`
--


/*!40000 ALTER TABLE `offres_remises` DISABLE KEYS */;
LOCK TABLES `offres_remises` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `offres_remises` ENABLE KEYS */;

--
-- Table structure for table `opac_sessions`
--

DROP TABLE IF EXISTS `opac_sessions`;
CREATE TABLE `opac_sessions` (
  `empr_id` int(10) unsigned NOT NULL default '0',
  `session` blob,
  `date_rec` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`empr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `opac_sessions`
--


/*!40000 ALTER TABLE `opac_sessions` DISABLE KEYS */;
LOCK TABLES `opac_sessions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `opac_sessions` ENABLE KEYS */;

--
-- Table structure for table `origine_notice`
--

DROP TABLE IF EXISTS `origine_notice`;
CREATE TABLE `origine_notice` (
  `orinot_id` int(8) unsigned NOT NULL auto_increment,
  `orinot_nom` varchar(255) NOT NULL default '',
  `orinot_pays` varchar(255) NOT NULL default 'FR',
  `orinot_diffusion` int(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`orinot_id`),
  KEY `orinot_nom` (`orinot_nom`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `origine_notice`
--


/*!40000 ALTER TABLE `origine_notice` DISABLE KEYS */;
LOCK TABLES `origine_notice` WRITE;
INSERT INTO `origine_notice` VALUES (1,'Catalogage interne','FR',1),(2,'BnF','FR',1),(3,'ກະຊວງສຶກສາທິການ','LA',1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `origine_notice` ENABLE KEYS */;

--
-- Table structure for table `ouvertures`
--

DROP TABLE IF EXISTS `ouvertures`;
CREATE TABLE `ouvertures` (
  `date_ouverture` date NOT NULL default '0000-00-00',
  `ouvert` int(1) NOT NULL default '1',
  `commentaire` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`date_ouverture`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `ouvertures`
--


/*!40000 ALTER TABLE `ouvertures` DISABLE KEYS */;
LOCK TABLES `ouvertures` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `ouvertures` ENABLE KEYS */;

--
-- Table structure for table `paiements`
--

DROP TABLE IF EXISTS `paiements`;
CREATE TABLE `paiements` (
  `id_paiement` int(8) unsigned NOT NULL auto_increment,
  `libelle` varchar(255) NOT NULL default '',
  `commentaire` text NOT NULL,
  PRIMARY KEY  (`id_paiement`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `paiements`
--


/*!40000 ALTER TABLE `paiements` DISABLE KEYS */;
LOCK TABLES `paiements` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `paiements` ENABLE KEYS */;

--
-- Table structure for table `parametres`
--

DROP TABLE IF EXISTS `parametres`;
CREATE TABLE `parametres` (
  `id_param` int(6) unsigned NOT NULL auto_increment,
  `type_param` varchar(20) default NULL,
  `sstype_param` varchar(255) default NULL,
  `valeur_param` text,
  `comment_param` varchar(255) default NULL,
  `section_param` varchar(255) NOT NULL default '',
  `gestion` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id_param`),
  UNIQUE KEY `typ_sstyp` (`type_param`,`sstype_param`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `parametres`
--


/*!40000 ALTER TABLE `parametres` DISABLE KEYS */;
LOCK TABLES `parametres` WRITE;
INSERT INTO `parametres` VALUES (1,'pmb','bdd_version','v4.26','Version de noyau de la base de donnes,  ne changer qu\'en version infrieure si un paramtre tait mal pass et relancer la mise  jour. En gnral, contactez plutt la mailing liste pmb.user@sigb.net','',0),(2,'z3950','accessible','1','Z3950 accessible ?\r\n 0 : non, menu inaccessible\r\n 1 : Oui, la librairie PHP_YAZ est active, la recherche z3950 est possible','',0),(3,'pmb','nb_lastautorities','10','Nombre de dernires autorites affiches en gestion d\'autorits','',0),(4,'pdflettreretard','1before_list','ຍົກເວັ້ນຂໍ້ຜິດພາດຂອງທາງເຮົາ, ທ່ານມີສິດໃນໜຶ່ງຫຼືຫຼາຍເອກະສານ ເຊິ່ງໄລຍະເວລາຂອງການໃຫ້ຢືມແມ່ນໄດ້ກາຍກຳນົດມື້ນີ້','Texte apparaissant avant la liste des ouvrages en retard dans le courrier de relance de retard','',0),(5,'pdflettreretard','1after_list','ພວກເຮົາຂໍຂອບໃຈນຳທ່ານທີ່ຈະຕິດຕໍ່ພວກເຮົາໂດຍທາງໂທລະສັບ ໜາຍເລກ $biblio_phone ຫຼື ໂດຍ email $biblio_email ເພື່ອສຶກສາຄວາມເປັນໄປໄດ້ຂອງການຕໍ່ເວລາການໃຫ້ຢືມ ຫຼືສົ່ງເອກະສານຄືນ','Texte apparaissant apr�s la liste des ouvrages en retard dans le courrier','',0),(6,'pdflettreretard','1fdp','ຜູ້ຮັບຜິດຊອບ.','Signataire de la lettre.','',0),(7,'pdflettreretard','1madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ ,','Ent�te de la lettre','',0),(8,'pdflettreretard','1nb_par_page','7','Nombre d\'ouvrages en retard imprim sur les pages suivantes.','',0),(9,'pdflettreretard','1nb_1ere_page','4','Nombre d\'ouvrages en retard imprim sur la premire page','',0),(10,'pdflettreretard','1taille_bloc_expl','16','Taille d\'un bloc (2 lignes) d\'ouvrage en retard. Le dbut de chaque ouvrage en retard sera espac de cette valeur sur la page','',0),(11,'pdflettreretard','1debut_expl_1er_page','160','Dbut de la liste des exemplaires sur la premire page, en mm depuis le bord suprieur de la page. Doit tre rgl en fonction du texte qui prcde la liste des ouvrages, lequel peut tre plus ou moins long.','',0),(12,'pdflettreretard','1debut_expl_page','15','Dbut de la liste des exemplaires sur les pages suivantes, en mm depuis le bord suprieur de la page.','',0),(13,'pdflettreretard','1limite_after_list','270','Position limite en bas de page. Si un lment imprim tente de dpasser cette limite, il sera imprim sur la page suivante.','',0),(14,'pdflettreretard','1marge_page_gauche','10','Marge de gauche en mm','',0),(15,'pdflettreretard','1marge_page_droite','10','Marge de droite en mm','',0),(16,'pdflettreretard','1largeur_page','210','Largeur de la page en mm','',0),(17,'pdflettreretard','1hauteur_page','297','Hauteur de la page en mm','',0),(18,'pdflettreretard','1format_page','P','Format de la page : \r\n P : Portrait\r\n L : Landscape = paysage','',0),(19,'pdfcartelecteur','pos_h','20','Position horizontale en mm  partir du bord gauche de la page','',0),(20,'pdfcartelecteur','pos_v','20','Position verticale en mm  partir du bord suprieur de la page','',0),(21,'pdfcartelecteur','biblio_name','$biblio_name','Nom de la bibliothque ou du centre de ressources imprim sur la carte de lecteur. Mettre $biblio_name pour reprendre le nom spcifi en localisation d\'exemplaire ou bien mettre autre chose.','',0),(22,'pdfcartelecteur','largeur_nom','80','Largeur accorde  l\'impression du nom du lecteur en mm','',0),(23,'pdfcartelecteur','valabledu','ໃຊ້ໄດ້ວັນທີ່','\'Valable du\' dans \"VALABLE DU ##/##/#### au ##/##/####\"','',0),(24,'pdfcartelecteur','valableau','ຫາ','\'au\' dans \"valable du ##/##/#### AU ##/##/####\"','',0),(25,'pdfcartelecteur','carteno','ເລກບັດ :','Mention pr�c�dant le num�ro de la carte','',0),(26,'sauvegarde','cle_crypt1','9b4a840d790eadc71b9064c9a843719b','','',0),(27,'sauvegarde','cle_crypt2','51580d4fd5f1ad2d981c91ddb04095ec','','',0),(28,'pmb','resa_dispo','1','Rservation de documents disponibles possible ?\r\n 0 : Non\r\n 1 : Oui','',0),(29,'mailretard','1objet','$biblio_name : ເອກະສານສົ່ງຊ້າ','Objet du mail de relance de retard','',0),(30,'mailretard','1before_list','ຍົກເວັ້ນຂໍ້ຜິດພາດຂອງທາງເຮົາ, ທ່ານມີສິດໃນໜຶ່ງຫຼືຫຼາຍເອກະສານ ເຊິ່ງໄລຍະເວລາຂອງການໃຫ້ຢືມແມ່ນໄດ້ກາຍກຳນົດມື້ນີ້ :','Texte apparaissant avant la liste des ouvrages en retard dans le mail de relance de retard','',0),(31,'mailretard','1after_list','ພວກເຮົາຂໍຂອບໃຈນຳທ່ານທີ່ຈະຕິດຕໍ່ພວກເຮົາໂດຍທາງໂທລະສັບ ໜາຍເລກ $biblio_phone ຫຼື ໂດຍ email $biblio_email ເພື່ອສຶກສາຄວາມເປັນໄປໄດ້ຂອງການຕໍ່ເວລາການໃຫ້ຢືມ ຫຼືສົ່ງເອກະສານຄືນ.','Texte apparaissant apr�s la liste des ouvrages en retard dans le mail','',0),(32,'mailretard','1madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ','Ent�te du mail','',0),(33,'mailretard','1fdp','ຜູ້ຮັບຜິດຊອບ.','Signataire du mail de relance de retard','',0),(34,'pmb','serial_link_article','0','Prremplissage du lien des dpouillements avec le lien de la notice mre en catalogage des priodiques ?\r\n 0 : Non\r\n 1 : Oui','',0),(35,'pmb','num_carte_auto','1','Numro de carte de lecteur automatique ? \r\n 1 : Oui\r\n 0 : Non (si utilisation de cartes pr-imprimes)','',0),(36,'opac','modules_search_title','2','Recherche simple dans les titres:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(37,'opac','modules_search_author','2','Recherche simple dans les auteurs:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(38,'opac','modules_search_publisher','1','Recherche simple dans les diteurs:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(39,'opac','modules_search_collection','1','Recherche simple dans les collections:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(40,'opac','modules_search_subcollection','1','Recherche simple dans les sous-collections:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(41,'opac','modules_search_category','1','Recherche simple dans les catgories:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(42,'opac','modules_search_keywords','1','Recherche simple dans les indexations libres (mots cl):\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(43,'opac','modules_search_abstract','1','Recherche simple dans le champ rsum :\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(44,'opac','modules_search_content','0','Recherche simple dans les notes de contenu:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut\r\nINUTILISE POUR L\'INSTANT','c_recherche',0),(45,'opac','categories_categ_path_sep','>','Sparateur pour les catgories','i_categories',0),(46,'opac','categories_columns','3','Nombre de colonnes du sommaire gnral des catgories','i_categories',0),(47,'opac','categories_categ_rec_per_page','6','Nombre de notices  afficher par page dans l\'exploration des catgories','i_categories',0),(48,'opac','categories_categ_sort_records','index_serie, tnvol, index_sew','Explorateur de catgories : mode de tri des notices :\r\n index_serie, tnvol, index_sew > par titre de srie, numro dans la srie et index des titres\r\n rand() : alatoire','i_categories',0),(49,'opac','search_results_first_level','4','Nombre de rsulats affichs sur la premire page','z_unused',0),(50,'opac','search_results_per_page','10','Nombre de rsulats affichs sur les pages suivantes','d_aff_recherche',0),(51,'opac','authors_aut_rec_per_page','1','Nombre d\'auteurs affichs par page','d_aff_recherche',0),(52,'opac','categories_sub_display','3','Nombre de sous-categories sur la premire page','i_categories',0),(53,'opac','categories_sub_mode','libelle_categorie','Mode affichage des sous-categories : \r\n rand() > alatoire\r\n libelle_categorie > ordre alpha','i_categories',0),(54,'opac','authors_aut_sort_records','index_serie, tnvol, index_sew','Visu auteurs : tri des notices','d_aff_recherche',0),(55,'opac','default_lang','la_LA','Langue de l\'opac : fr_FR ou en_US ou es_ES ou ar ou la_LA','a_general',0),(56,'opac','show_categ_browser','1','Affichage des catgories en page d\'accueil OPAC 1: oui  ou 0: non','f_modules',0),(57,'opac','show_book_pics','1','Afficher les vignettes de livres dans les fiches ouvrages :\r\n 0 : Non\r\n 1 : Oui','e_aff_notice',0),(58,'opac','resa','1','Rservations possibles par l\'OPAC 1: oui  ou 0: non','a_general',0),(59,'opac','resa_dispo','1','Rservations possibles de documents disponibles par l\'OPAC \r\n 1: oui \r\n 0: non','a_general',0),(60,'opac','show_meteo','0','Affichage de la mto dans l\'OPAC 1: oui  ou 0: non','f_modules',0),(61,'opac','duration_session_auth','1200','Dure de la session lecteur dans l\'OPAC en secondes','a_general',0),(62,'pmb','relance_adhesion','31','Nombre de jours avant expiration adhsion pour relance','',0),(63,'pmb','pret_adhesion_depassee','1','Prts si adhsion dpasse : 0 INTERDIT incontournable, 1 POSSIBLE','',0),(64,'pdflettreadhesion','fdp','ຜູ້ຮັບຜິດຊອບ.','Formule de politesse en bas de page','',0),(65,'pdflettreadhesion','madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ ,','Civilit� du destinataire','',0),(66,'pdflettreadhesion','texte','Votre abonnement arrive  chance le !!date_fin_adhesion!!. Nous vous remercions de penser  le renouveller lors de votre prochaine visite.\r\n\r\nNous vous prions de recevoir, Madame, Monsieur, l\'expression de nos meilleures salutations.\r\n\r\n\r\n','Phrase d\'introduction de l\'chance de l\'abonnement','',0),(67,'pdflettreadhesion','marge_page_gauche','10','Marge gauche de la page en mm','',0),(68,'pdflettreadhesion','marge_page_droite','10','Marge droite de la page en mm','',0),(69,'pdflettreadhesion','largeur_page','210','Largeur de la page en mm','',0),(70,'pdflettreadhesion','hauteur_page','297','Hauteur de la page en mm','',0),(71,'pdflettreadhesion','format_page','P','P pour Portrait, L pour paysage (Landscape)','',0),(72,'mailrelanceadhesion','objet','$biblio_name : ການເປັນຊະມາຊິກຂອງທ່ານ','Objet du courrier de relance d\'adh�sion. Utilisez biblio_name pour reprendre le nom pr�cis� dans la localisation des exemplaires.','',0),(73,'mailrelanceadhesion','texte','ການເປັນຊະມາຊິກຂອງທ່ານຈະໜົດກຳນົດວັນທີ່ !!date_fin_adhesion!!. ພວກເຮົາຈະຂອບໃຈທ່ານຫຼາຍໆ ທີ່ ທ່ານຈະເຂົ້າມາຕໍ່ບັດຊະມາຊິກຂອງທ່ານ.\r\n\r\nດ້ວຍຄວາມນັບຖື,\r\n\r\n','Texte de la relance, !!date_fin_adhesion!! sera remplac� � l\'�dition par la date de fin d\'adh�sion du lecteur','',0),(74,'mailrelanceadhesion','madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ,','Ent�te du courrier de relance d\'adh�sion','',0),(75,'mailrelanceadhesion','fdp','ດ້ວຍຄວາມເຄົາລົບ','Formule de politesse en bas de page','',0),(76,'opac','show_marguerite_browser','0','0 ou 1 : marguerite des catgories','f_modules',0),(77,'opac','show_100cases_browser','0','0 ou 1 : affichage de 100 catgories','f_modules',0),(78,'pmb','indexint_decimal','1','0 ou 1 : l\'indexation interne est-elle une cotation dcimale type Dewey','',0),(79,'opac','modules_search_indexint','1','Recherche simple dans les indexations internes:\r\n 0 : interdite\r\n 1 : autorise\r\n 2 : autorise et valide par dfaut','c_recherche',0),(80,'empr','birthdate_optional','1','Anne de naissance facultative : \r\n 0 > non:elle est obligatoire \r\n 1 Oui','',0),(81,'categories','show_empty_categ','1','Affichage des catgories ne contenant aucune notice :\r\n0=non, 1=oui','',0),(82,'categories','term_search_n_per_page','50','Nombre de termes affichs par page lors d\'une recherche par terme dans les catgories','',0),(83,'opac','show_loginform','1','Affichage du login lecteur dans l\'OPAC \r\n 0 > non\r\n 1 Oui','f_modules',0),(84,'opac','default_style','bueil','Style graphique de l\'OPAC, 1 style par dfaut, nomargin : sans affichage du bandeau de gauche','a_general',0),(85,'opac','show_exemplaires','1','Afficher les exemplaires dans l\'OPAC\n 1 Oui,\n 0 : Non','e_aff_notice',0),(86,'pmb','import_modele','func_bdp.inc.php','Quel script de fonctions d\'import utiliser pour personnaliser l\'import ?','',0),(87,'pmb','quotas_avances','0','Quotas de prts avances ? \r\n 0 : Non\r\n 1 : Oui','',0),(88,'opac','logo','logo_default.jpg','Nom du fichier de l\'image logo','z_unused',0),(89,'opac','logosmall','images/site/livre.png','Nom du fichier de l\'image petit logo','b_aff_general',0),(90,'opac','show_bandeaugauche','1','Affichage du bandeau de gauche ? \n 0 : Non\n 1 : Oui','f_modules',0),(91,'opac','show_liensbas','1','Affichage des liens(pmb, google, bibli) en bas de page ? \n 0 : Non\n 1 : Oui','f_modules',0),(92,'opac','show_homeontop','0','Affichage du lien HOME (retour accueil) sous le nom de la bibliothque ou du centre de ressources (ncessaire si masquage bandeau gauche) ? \r\n 0 : Non\r\n 1 : Oui','f_modules',0),(93,'pmb','resa_quota_pret_depasse','1','Rservation possible mme si quota de prt dpass ? \n 0 : Non\n 1 : Oui','',0),(94,'pmb','import_limit_read_file','100','Limite de taille de lecture du fichier en import, en gnral 100 ou 200 doit fonctionner, si problme de time out : fixer plus bas, 50 par exemple.','',0),(95,'pmb','import_limit_record_load','100','Limite de taille de traitement de notices en import, en gnral 100 ou 200 doit fonctionner, si problme de time out : fixer plus bas, 50 par exemple.','',0),(96,'opac','biblio_preamble_p1','ຫໍສະໝຸດຂອງການທົດສອບ PMB ສະເໜີທ່ານ 60 ເອກະສານ ເພື່ອທົດສອບລະບົບ, ໜ້ານີ້ສະເໜີຫຼາຍທາງເລືອກຂອງການຊອກ ແລະ ການ ເຄື່ອນທີ່ຈາກໜ້ານີ້ຫາໜ້າອື່ນ, ສິ່ງເຫຼົ່ານີ້ ແມ່ນສາມາດດັດແປງໄດ້ .','Paragraphe 1 d\'informations (par exemple, description du fonds)','b_aff_general',0),(97,'opac','biblio_preamble_p2','ການບໍລິການ PMB ແມ່ນເປັນຂອງທ່ານແລ້ວ ເພື່ອຊ່ວຍທ່ານໃນການດັດແກ້ ຫຼື ເຮັດໃຫ້  PMB ຂອງທ່ານແທດເໝາະກັບການນຳໃຊ້.','Paragraphe 2 d\'informations : accueil du public.','b_aff_general',0),(98,'opac','biblio_quicksummary_p1','','Paragraphe 1 de rsum, est masqu par dfaut dans la feuille de style, voir id quickSummary.p1','z_unused',0),(99,'opac','biblio_quicksummary_p2','','Paragraphe 2 de rsum, est masqu par dfaut dans la feuille de style, voir id quickSummary.p2','z_unused',0),(100,'opac','show_dernieresnotices','0','Affichage des dernires notices cres en bas de page ? \n 0 : Non\n 1 : Oui','f_modules',0),(101,'opac','show_etageresaccueil','1','Affichage des tagres dans la page d\'accueil en bas de page ? \n 0 : Non\n 1 : Oui','f_modules',0),(102,'opac','biblio_important_p1','','Infos importantes 1, dans la feuille de style, voir id important.p1','b_aff_general',0),(103,'opac','biblio_important_p2','','Infos importantes, dans la feuille de style, voir id important.p2','b_aff_general',0),(104,'opac','biblio_name','ຫໍສະໝຸດແຫ່ງຊາດ','Nom de la biblioth�que ou du centre de ressources dans l\'opac','b_aff_general',0),(105,'opac','biblio_website','www.bnlaos.org','Site web de la biblioth�que ou du centre de ressources dans l\'opac','b_aff_general',0),(106,'opac','biblio_adr1','ຖະໜົນ ເສດຖາທິລາດ','Adresse 1 de la biblioth�que ou du centre de ressources dans l\'opac','b_aff_general',0),(107,'opac','biblio_town','ວຽງຈັນ','Ville dans l\'opac','b_aff_general',0),(108,'opac','biblio_cp','ຕູ້ ປ.ນ 122 ບ້ານຊຽງຍືນ','Code postal dans l\'opac','b_aff_general',0),(109,'opac','biblio_country','ສປປລາວ ','Pays dans l\'opac','b_aff_general',0),(110,'opac','biblio_phone','(+85621) 251 405','Tlphone dans l\'opac','b_aff_general',0),(111,'opac','biblio_dep','37','Dpartement dans l\'opac pour la mto','b_aff_general',0),(112,'opac','biblio_email','bnl@laosky.com','Email de contact dans l\'opac','b_aff_general',0),(113,'opac','etagere_notices_order','index_serie, tnvol, index_sew','Ordre d\'affichage des notices dans les tagres dans l\'opac \n  index_serie, tit1 : tri par titre de srie et titre \n rand()  : alatoire','j_etagere',0),(114,'opac','etagere_notices_format','4','Format d\'affichage des notices dans les tagres de l\'cran d\'accueil \r\n 1 : ISBD seul \r\n 2 : Public seul \r\n 4 : ISBD et Public \r\n 8 : Rduit (titre+auteurs) seul','j_etagere',0),(115,'opac','etagere_notices_depliables','1','Affichage dpliable des notices dans les tagres de l\'cran d\'accueil \r\n 0 : Non \r\n 1 : Oui','j_etagere',0),(116,'opac','etagere_nbnotices_accueil','5','Nombre de notices affiches dans les tagres de l\'cran d\'accueil \r\n 0 : Toutes \r\n -1 : Aucune \r\n x : x notices affiches au maximum','j_etagere',0),(117,'opac','nb_aut_rec_per_page','15','Nombre de notices affiches pour une autorit donne','d_aff_recherche',0),(118,'opac','notices_format','4','Format d\'affichage des notices dans les tagres de l\'cran d\'accueil \n 1 : ISBD seul \n 2 : Public seul \n 4 : ISBD et Public \n 5 : ISBD et Public avec ISBD en premier \n 8 : Rduit (titre+auteurs) seul','e_aff_notice',0),(119,'opac','notices_depliable','1','Affichage dpliable des notices en rsultat de recherche  0 : Non  1 : Oui','e_aff_notice',0),(120,'opac','term_search_n_per_page','50','Nombre de termes affichs par page en recherche par terme','c_recherche',0),(121,'opac','show_empty_categ','1','En recherche par terme, affichage des catgories ne contenant aucun ouvrage :\r\n 0 : Non \r\n 1 : Oui','i_categories',0),(122,'opac','allow_extended_search','1','Autorisation ou non de la recherche avance dans l\'OPAC \n 0 : Non \n 1 : Oui','c_recherche',0),(123,'opac','allow_term_search','1','Autorisation ou non de la recherche par termes dans l\'OPAC \n 0 : Non \n 1 : Oui','c_recherche',0),(124,'opac','term_search_height','350','Hauteur en pixels de la frame de recherche par termes (si pas prcis ou zro : par dfaut 200 pixels)','c_recherche',0),(125,'opac','categories_nb_col_subcat','3','Nombre de colonnes de sous-catgories en navigation dans les catgories \n 3 par dfaut','i_categories',0),(126,'opac','max_resa','5','Nombre maximum de rservation sur un document \r\n 5 par dfaut \r\n 0 pour illimit','a_general',0),(127,'pmb','show_help','1','Affichage de l\'aide contextuelle dans PMB en partie gestion \r\n 1 Oui \r\n 0 Non','',0),(128,'opac','show_help','1','Affichage de l\'aide en ligne dans l\'OPAC de PMB  \n 1 Oui \n 0 Non','f_modules',0),(129,'opac','cart_allow','1','Paniers possibles dans l\'OPAC de PMB  \n 1 Oui \n 0 Non','f_modules',0),(130,'opac','max_cart_items','200','Nombre maximum de notices dans un panier utilisateur.','h_cart',0),(131,'opac','show_section_browser','1','Afficher le butineur de localisation et de sections ?\n 0 : Non\n 1 : Oui','f_modules',0),(132,'opac','nb_localisations_per_line','6','Nombre de localisations affiches par ligne en page d\'accueil (si show_section_browser=1)','k_section',0),(133,'opac','nb_sections_per_line','6','Nombre de sections affiches par ligne en visualisation de localisation (si show_section_browser=1)','k_section',0),(134,'opac','cart_only_for_subscriber','1','Paniers de notices rservs aux adhrents de la bibliothque ou du centre de ressources ?\r\n 1: Oui\r\n 0: Non, autoris pour tout internaute','h_cart',0),(135,'opac','notice_reduit_format','0','Format d\'affichage des rduits des notices :\r\n 0 normal = titre+auteurs principaux\r\n P 1,2,3: Perso. : tit+aut+champs persos id 1 2 3\r\n E 1,2,3: Perso. : tit+aut+dit+champs persos id 1 2 3 \r\n T : tit1+tit4','e_aff_notice',0),(136,'pdflettreresa','before_list','Suite  votre demande de rservation, nous vous informons que le ou les ouvrages ci-dessous sont  votre disposition  la bibliothque.','Texte apparaissant avant la liste des ouvrages en rsa dans le courrier de confirmation de rsa','',0),(137,'pdflettreresa','after_list','Pass le dlai de rservation, ces ouvrages seront remis en circulation, vous priant de les retirer dans les meilleurs dlais.','Texte apparaissant aprs la liste des ouvrages','',0),(138,'pdflettreresa','fdp','Le responsable.','Signataire de la lettre, utiliser $biblio_name pour reprendre le paramtre \"biblio name\" ou bien mettre autre chose.','',0),(139,'pdflettreresa','madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ ','Ent�te de la lettre','',0),(140,'pdflettreresa','nb_par_page','7','Nombre d\'ouvrages en retard imprim sur les pages suivantes.','',0),(141,'pdflettreresa','nb_1ere_page','4','Nombre d\'ouvrages en retard imprim sur la premire page','',0),(142,'pdflettreresa','taille_bloc_expl','16','Taille d\'un bloc (2 lignes) d\'ouvrage en rservation. Le dbut de chaque ouvrage en rsa sera espac de cette valeur sur la page','',0),(143,'pdflettreresa','debut_expl_1er_page','160','Dbut de la liste des ouvrages sur la premire page, en mm depuis le bord suprieur de la page. Doit tre rgl en fonction du texte qui prcde la liste des ouvrages, lequel peut tre plus ou moins long.','',0),(144,'pdflettreresa','debut_expl_page','15','Dbut de la liste des ouvrages sur les pages suivantes, en mm depuis le bord suprieur de la page.','',0),(145,'pdflettreresa','limite_after_list','270','Position limite en bas de page. Si un lment imprim tente de dpasser cette limite, il sera imprim sur la page suivante.','',0),(146,'pdflettreresa','marge_page_gauche','10','Marge de gauche en mm','',0),(147,'pdflettreresa','marge_page_droite','10','Marge de droite en mm','',0),(148,'pdflettreresa','largeur_page','210','Largeur de la page en mm','',0),(149,'pdflettreresa','hauteur_page','297','Hauteur de la page en mm','',0),(150,'pdflettreresa','format_page','P','Format de la page : \r\n P : Portrait\r\n L : Landscape = paysage','',0),(151,'opac','categories_max_display','200','Pour la page d\'accueil, nombre maximum de catgories principales affiches','i_categories',0),(152,'opac','search_other_function','','Fonction complmentaire pour les recherches en page d\'accueil','c_recherche',0),(153,'opac','lien_bas_supplementaire','<a href=\'http://www.sigb.net.com/poomble.php\' target=_blank>ລິ້ງຕໍ່ຫາເວັບອື່ນ\r\n</a>','Lien suppl�mentaire en bas de page d\'accueil, � renseigner compl�tement : a href= lien /a','b_aff_general',0),(154,'z3950','import_modele','func_other.inc.php','Quel script de fonctions d\'import utiliser pour personnaliser l\'import en intgration z3950 ?','',0),(155,'ldap','server','chinon','Serveur LDAP, IP ou host','',0),(156,'ldap','basedn','','Racine du nom de domaine LDAP','',0),(157,'ldap','port','389','Port du serveur LDAP','',0),(158,'ldap','filter','(&(objectclass=person)(gidnumber=GID))','Serveur LDAP, IP ou host','',0),(159,'ldap','fields','uid,gecos,departmentnumber','Champs du serveur LDAP','',0),(160,'ldap','lang','fr_FR','Langue du serveur LDAP','',0),(161,'ldap','groups','','Groupes du serveur LDAP','',0),(162,'ldap','accessible','0','LDAP accessible ?','',0),(163,'opac','categories_show_only_last','0','Dans la fiche d\'une notice : \n 0 tout afficher \n 1 : afficher uniquement la dernire feuille de l\'arbre de la catgorie','i_categories',0),(164,'categories','show_only_last','0','Dans la fiche d\'une notice : \n 0 tout afficher \n 1 : afficher uniquement la dernire feuille de l\'arbre de la catgorie','',0),(165,'pmb','prefill_cote','custom_cote_02.inc.php','Script personnalis de construction de la cote de l\'exemplaire','',0),(166,'ldap','proto','3','Version du protocole LDAP : 3 ou 2','',0),(167,'ldap','binddn','uid=UID,ou=People','Description de la liaison : construction de la chaine binddn pour lier l\'authentification au serveur LDAP dans l\'OPAC','',0),(168,'empr','corresp_import','','Table de correspondances colonnes/champs en import de lecteurs  partir d\'un fichier ASCII','',0),(169,'pmb','type_audit','0','Gestion/affichage des dates de cration/modification \n 0: Rien\n 1: Cration et dernire modification\n 2: Cration et toutes les dates de modification','',0),(170,'pmb','gestion_abonnement','0','Utiliser la gestion des abonnements des lecteurs ? \n 0 : Non\n 1 : Oui, gestion simple, \n 2 : Oui, gestion avance','',0),(171,'pmb','utiliser_calendrier','0','Utiliser le calendrier des jours d\'ouverture ? \n 0 : Non\n 1 : Oui','',0),(172,'pmb','gestion_financiere','0','Utiliser le module gestion financire ? \n 0 : Non\n 1 : Oui','',0),(173,'pmb','gestion_tarif_prets','0','Utiliser la gestion des tarifs de prts ? \n 0 : Non\n 1 : Oui, gestion simple, \n 2 : Oui, gestion avance','',0),(174,'pmb','gestion_amende','0','Utiliser la gestion des amendes:\n 0 = Non\n 1 = Gestion simple\n 2 = Gestion avance','',0),(175,'finance','amende_jour','0.15','Amende par jour de retard pour tout type de document. Attention, le sparateur dcimal est le point, pas la virgule','',1),(176,'finance','delai_avant_amende','15','Dlai avant dclenchement de l\'amende, en jour','',1),(177,'finance','delai_recouvrement','7','Dlai entre 3eme relance et mise en recouvrement officiel de l\'amende, en jour','',1),(178,'finance','amende_maximum','0','Amende maximum, quel que soit le retard l\'amende est plafonne  ce montant. 0 pour dsactiver ce plafonnement.','',1),(179,'pdflettreresa','priorite_email','1','Priorit des lettres de confirmation de rservation par mail lors de la validation d\'une rservation:\n 0 : Lettre seule \n 1 : Mail,  dfaut lettre\n 2 : Mail ET lettre\n 3 : Aucune alerte','',0),(180,'pdflettreresa','priorite_email_manuel','1','Priorit des lettres de confirmation de rservation par mail lors de l\'impression  partir du bouton :\n 0 : Lettre seule \n 1 : Mail,  dfaut lettre\n 2 : Mail ET lettre\n 3 : Aucune alerte','',0),(181,'finance','blocage_abt','1','Blocage du prt si le compte abonnement est dbiteur\n 0 : pas de blocage \n 1 : blocage avec forage possible  : blocage incontournable.','',1),(182,'finance','blocage_pret','1','Blocage du prt si le compte prt est dbiteur\n 0 : pas de blocage \n 1 : blocage avec forage possible  : blocage incontournable.','',1),(183,'finance','blocage_amende','1','Blocage du prt si le compte amende est dbiteur\n 0 : pas de blocage \n 1 : blocage avec forage possible  : blocage incontournable.','',1),(184,'pmb','gestion_devise','&euro;','Devise de la gestion financire, ce qui va tre affich en code HTML','',0),(185,'opac','book_pics_url','','URL des vignettes des notices, dans le chemin fourni, !!isbn!! sera remplac par le code ISBN ou EAN de la notice purg de tous les tirets ou points. \n exemple : http://www.monsite/opac/images/vignettes/!!isbn!!.jpg','e_aff_notice',0),(186,'opac','lien_moteur_recherche','<a href=http://www.google.fr target=_blank>&#3735;&#3763;&#3713;&#3762;&#3737;&#3722;&#3757;&#3713;&#3713;&#3761;&#3738;&#3776;&#3751;&#3761;&#3738; &#3713;&#3769;&#3784;&#3778;&#3713;&#3785;  </a>','Lien supplmentaire en bas de page d\'accueil,  renseigner compltement : a href= lien /a','b_aff_general',0),(187,'pmb','pret_express_statut','2','Statut de notice  utiliser en cration d\'exemplaires en prts express','',0),(188,'opac','notice_affichage_class','','Nom de la classe d\'affichage pour personnalisation de l\'affichage des notices','e_aff_notice',0),(189,'pmb','confirm_retour','0','En retour de documents, le retour doit-il tre confirm ? \n 0 : Non, on peut passer les codes-barres les uns aprs les autres \n 1 : Oui, il faut valider le retour aprs chaque code-barre','',0),(190,'opac','show_meteo_url','<img src=\"http://perso0.free.fr/cgi-bin/meteo.pl?dep=72\" alt=\"\" border=\"0\" hspace=0>','URL de la mto affiche','f_modules',0),(191,'pmb','limitation_dewey','0','Nombre maximum de caractres dans la Dewey (676) en import : \n 0 aucune limitation \n 3 : limitation de 000  999 \n 5 (exemple) limitation 000.0 \n -1 : aucune importation','',0),(192,'finance','delai_1_2','15','Dlai entre 1ere et 2eme relance','',1),(193,'finance','delai_2_3','15','Dlai entre 2eme et 3eme relance','',1),(194,'pmb','lecteurs_localises','0','Lecteurs localiss ? \n 0: Non \n 1: Oui','',0),(195,'dsi','active','1','D.S.I active ? \n 0: Non \n 1: Oui','',0),(196,'dsi','auto','0','D.S.I automatique active ? \n 0: Non \n 1: Oui','',0),(197,'dsi','insc_categ','0','Inscription automatique dans les bannettes de la catgorie du lecteur en cration ? \n 0: Non \n 1: Oui','',0),(198,'opac','allow_bannette_priv','0','Possibilit pour les lecteurs de crer ou modifier leurs bannettes prives \n 0: Non \n 1: Oui','l_dsi',0),(199,'opac','allow_resiliation','0','Possibilit pour les lecteurs de rsilier leur abonnement aux bannettes pro \n 0: Non \n 1: Oui','l_dsi',0),(200,'opac','show_categ_bannette','0','Affichage des bannettes de la catgorie du lecteur et possibilit de s\'y abonner \n 0: Non \n 1: Oui','l_dsi',0),(201,'opac','url_base','./','URL de base de l\'opac : typiquement mettre l\'url publique web http://monsite/opac/ ne pas oublier le / final','a_general',0),(202,'finance','relance_1','0.53','Frais de la premire lettre de relance','',1),(203,'finance','relance_2','0.53','Frais de la deuxime lettre de relance','',1),(204,'finance','relance_3','2.50','Frais de la troisime lettre de relance','',1),(205,'finance','statut_perdu','','Statut (d\'exemplaire) perdu pour des ouvrages non rendus','',1),(206,'pdflettreretard','2after_list','ພວກເຮົາຂໍຂອບໃຈນຳທ່ານທີ່ຈະຕິດຕໍ່ພວກເຮົາໂດຍທາງໂທລະສັບ ໜາຍເລກ $biblio_phone ຫຼື ໂດຍ email $biblio_email ເພື່ອສຶກສາຄວາມເປັນໄປໄດ້ຂອງການຕໍ່ເວລາການໃຫ້ຢືມ ຫຼືສົ່ງເອກະສານຄືນ.','Texte apparaissant apr�s la liste des ouvrages en retard dans le courrier','',0),(207,'pdflettreretard','2before_list','ຍົກເວັ້ນຂໍ້ຜິດພາດຂອງທາງເຮົາ, ທ່ານມີສິດໃນໜຶ່ງຫຼືຫຼາຍເອກະສານ ເຊິ່ງໄລຍະເວລາຂອງການໃຫ້ຢືມແມ່ນໄດ້ກາຍກຳນົດມື້ນີ້','Texte apparaissant avant la liste des ouvrages en retard dans le courrier de relance de retard','',0),(208,'pdflettreretard','2debut_expl_1er_page','160','Dbut de la liste des exemplaires sur la premire page, en mm depuis le bord suprieur de la page. Doit tre rgl en fonction du texte qui prcde la liste des ouvrages, lequel peut tre plus ou moins long.','',0),(209,'pdflettreretard','2debut_expl_page','15','Dbut de la liste des exemplaires sur les pages suivantes, en mm depuis le bord suprieur de la page.','',0),(210,'pdflettreretard','2fdp','ຜູ້ຮັບຜິດຊອບ.','Signataire de la lettre.','',0),(211,'pdflettreretard','2format_page','P','Format de la page : \r\n P : Portrait\r\n L : Landscape = paysage','',0),(212,'pdflettreretard','2hauteur_page','297','Hauteur de la page en mm','',0),(213,'pdflettreretard','2largeur_page','210','Largeur de la page en mm','',0),(214,'pdflettreretard','2limite_after_list','270','Position limite en bas de page. Si un lment imprim tente de dpasser cette limite, il sera imprim sur la page suivante.','',0),(215,'pdflettreretard','2madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ,','Ent�te de la lettre','',0),(216,'pdflettreretard','2marge_page_droite','10','Marge de droite en mm','',0),(217,'pdflettreretard','2marge_page_gauche','10','Marge de gauche en mm','',0),(218,'pdflettreretard','2nb_1ere_page','4','Nombre d\'ouvrages en retard imprim sur la premire page','',0),(219,'pdflettreretard','2nb_par_page','7','Nombre d\'ouvrages en retard imprim sur les pages suivantes.','',0),(220,'pdflettreretard','2taille_bloc_expl','16','Taille d\'un bloc (2 lignes) d\'ouvrage en retard. Le dbut de chaque ouvrage en retard sera espac de cette valeur sur la page','',0),(221,'pdflettreretard','3after_list','ພວກເຮົາຂໍຂອບໃຈນຳທ່ານທີ່ຈະຕິດຕໍ່ພວກເຮົາໂດຍທາງໂທລະສັບ ໜາຍເລກ $biblio_phone ຫຼື ໂດຍ email $biblio_email ເພື່ອສຶກສາຄວາມເປັນໄປໄດ້ຂອງການຕໍ່ເວລາການໃຫ້ຢືມ ຫຼືສົ່ງເອກະສານຄືນ.','Texte apparaissant apr�s la liste des ouvrages en retard dans le courrier','',0),(222,'pdflettreretard','3before_list','ຍົກເວັ້ນຂໍ້ຜິດພາດຂອງທາງເຮົາ, ທ່ານມີສິດໃນໜຶ່ງຫຼືຫຼາຍເອກະສານ ເຊິ່ງໄລຍະເວລາຂອງການໃຫ້ຢືມແມ່ນໄດ້ກາຍກຳນົດມື້ນີ້:','Texte apparaissant avant la liste des ouvrages en retard dans le courrier de relance de retard','',0),(223,'pdflettreretard','3debut_expl_1er_page','160','Dbut de la liste des exemplaires sur la premire page, en mm depuis le bord suprieur de la page. Doit tre rgl en fonction du texte qui prcde la liste des ouvrages, lequel peut tre plus ou moins long.','',0),(224,'pdflettreretard','3debut_expl_page','15','Dbut de la liste des exemplaires sur les pages suivantes, en mm depuis le bord suprieur de la page.','',0),(225,'pdflettreretard','3fdp','ຜູ້ຮັບຜິດຊອບ.','Signataire de la lettre.','',0),(226,'pdflettreretard','3format_page','P','Format de la page : \r\n P : Portrait\r\n L : Landscape = paysage','',0),(227,'pdflettreretard','3hauteur_page','297','Hauteur de la page en mm','',0),(228,'pdflettreretard','3largeur_page','210','Largeur de la page en mm','',0),(229,'pdflettreretard','3limite_after_list','270','Position limite en bas de page. Si un lment imprim tente de dpasser cette limite, il sera imprim sur la page suivante.','',0),(230,'pdflettreretard','3madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ,','Ent�te de la lettre','',0),(231,'pdflettreretard','3marge_page_droite','10','Marge de droite en mm','',0),(232,'pdflettreretard','3marge_page_gauche','10','Marge de gauche en mm','',0),(233,'pdflettreretard','3nb_1ere_page','4','Nombre d\'ouvrages en retard imprim sur la premire page','',0),(234,'pdflettreretard','3nb_par_page','7','Nombre d\'ouvrages en retard imprim sur les pages suivantes.','',0),(235,'pdflettreretard','3taille_bloc_expl','16','Taille d\'un bloc (2 lignes) d\'ouvrage en retard. Le dbut de chaque ouvrage en retard sera espac de cette valeur sur la page','',0),(236,'pdflettreretard','3before_recouvrement','Sans nouvelles de votre part dans les sept jours, nous nous verrons contraints de dlguer au trsor public le recouvrement des ouvrages suivants :','Texte avant la liste des ouvrages en recouvrement','',0),(237,'opac','bannette_notices_order',' index_serie, tnvol, index_sew ','Ordre d\'affichage des notices dans les bannettes dans l\'opac \n  index_serie, tnvol, index_sew : tri par titre de srie et titre \n rand()  : alatoire','l_dsi',0),(238,'opac','bannette_notices_format','8','Format d\'affichage des notices dans les bannettes \n 1 : ISBD seul \n 2 : Public seul \n 4 : ISBD et Public \n 8 : Rduit (titre+auteurs) seul','l_dsi',0),(239,'opac','bannette_notices_depliables','1','Affichage dpliable des notices dans les bannettes \n 0 : Non \n 1 : Oui','l_dsi',0),(240,'opac','bannette_nb_liste','0','Nbre de notices par bannettes en affichage de la liste des bannettes \n 0 Toutes \n N : maxi N\n -1 : aucune','l_dsi',0),(241,'opac','dsi_active','0','DSI, bannettes accessibles par l\'OPAC ? \n 0 : Non \n 1 : Oui','l_dsi',0),(242,'mailretard','2after_list','ພວກເຮົາຂໍຂອບໃຈນຳທ່ານທີ່ຈະຕິດຕໍ່ພວກເຮົາໂດຍທາງໂທລະສັບ ໜາຍເລກ $biblio_phone ຫຼື ໂດຍ email $biblio_email ເພື່ອສຶກສາຄວາມເປັນໄປໄດ້ຂອງການຕໍ່ເວລາການໃຫ້ຢືມ ຫຼືສົ່ງເອກະສານຄືນ.','Texte apparaissant apr�s la liste des ouvrages en retard dans le mail','',0),(243,'mailretard','2before_list','ຍົກເວັ້ນຂໍ້ຜິດພາດຂອງທາງເຮົາ, ທ່ານມີສິດໃນໜຶ່ງຫຼືຫຼາຍເອກະສານ ເຊິ່ງໄລຍະເວລາຂອງການໃຫ້ຢືມແມ່ນໄດ້ກາຍກຳນົດມື້ນີ້ :','Texte apparaissant avant la liste des ouvrages en retard dans le mail de relance de retard','',0),(244,'mailretard','2fdp','ຜູ້ຮັບຜິດຊອບ.','Signataire du mail de relance de retard','',0),(245,'mailretard','2madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ,','Ent�te du mail','',0),(246,'mailretard','2objet','$biblio_name : ເອກະສານກາຍກຳນົດສົ່ງ','Objet du mail de relance de retard','',0),(247,'mailretard','3after_list','ພວກເຮົາຂໍຂອບໃຈນຳທ່ານທີ່ຈະຕິດຕໍ່ພວກເຮົາໂດຍທາງໂທລະສັບ ໜາຍເລກ $biblio_phone ຫຼື ໂດຍ email $biblio_email ເພື່ອສຶກສາຄວາມເປັນໄປໄດ້ຂອງການຕໍ່ເວລາການໃຫ້ຢືມ ຫຼືສົ່ງເອກະສານຄືນ.','Texte apparaissant apr�s la liste des ouvrages en retard dans le mail','',0),(248,'mailretard','3before_list','ຍົກເວັ້ນຂໍ້ຜິດພາດຂອງທາງເຮົາ, ທ່ານມີສິດໃນໜຶ່ງຫຼືຫຼາຍເອກະສານ ເຊິ່ງໄລຍະເວລາຂອງການໃຫ້ຢືມແມ່ນໄດ້ກາຍກຳນົດມື້ນີ້ :','Texte apparaissant avant la liste des ouvrages en retard dans le mail de relance de retard','',0),(249,'mailretard','3fdp','ຜູ້ຮັບຜິດຊອບ.','Signataire du mail de relance de retard','',0),(250,'mailretard','3madame_monsieur','ທ່ານຍິງ, ທ່ານຊາຍ,','Ent�te du mail','',0),(251,'mailretard','3objet','$biblio_name : ເອກະສານການກຳນົດສົ່ງ','Objet du mail de relance de retard','',0),(252,'mailretard','3before_recouvrement','Sans nouvelles de votre part dans les sept jours, nous nous verrons contraints de dlguer au trsor public le recouvrement des ouvrages suivants :','Texte avant la liste des ouvrages en recouvrement','',0),(253,'mailretard','priorite_email','1','Priorit des lettres de retard lors des relances :\n 0 : Lettre seule \n 1 : Mail,  dfaut lettre\n 2 : Mail ET lettre','',0),(254,'pmb','import_modele_lecteur','','Modle d\'import des lecteurs','',0),(255,'pmb','blocage_retard','0','Bloquer le prt d\'une dure quivalente au retard ? 0=non, 1=oui','',0),(256,'pmb','blocage_delai','7','Dlai  partir duquel le retard est pris en compte','',0),(257,'pmb','blocage_max','60','Nombre maximum de jours bloqus (0 = pas de limite)','',0),(258,'pmb','blocage_coef','1','Coefficient de proportionnalit des jours de retard pour le blocage','',0),(259,'pmb','blocage_retard_force','1','1 = Le prt peut-tre forc lors d\'un blocage du compte, 2 = Pas de forage possible','',0),(260,'opac','etagere_order',' name ','Tri des tagres dans l\'cran d\'accueil, \n name = par nom\n name DESC = par nom dcroissant','j_etagere',0),(261,'pmb','book_pics_show','0','Affichage des couvertures de livres en gestion\n 1: oui  \n 0: non','',0),(262,'pmb','book_pics_url','','URL des vignettes des notices, dans le chemin fourni, !!isbn!! sera remplac par le code ISBN ou EAN de la notice purg de tous les tirets ou points. \r\n exemple : http://www.monsite/opac/images/vignettes/!!isbn!!.jpg','',0),(263,'pmb','opac_url','./opac_css/','URL de l\'OPAC vu depuis la partie gestion, par dfaut ./opac_css/','',0),(264,'opac','resa_popup','1','Demande de connexion sous forme de popup ? :\n 0 : Non\n 1 : Oui','a_general',0),(265,'pmb','vignette_x','100','Largeur de la vignette cre pour un exemplaire numrique image','',0),(266,'pmb','vignette_y','100','Hauteur de la vignette cre pour un exemplaire numrique image','',0),(267,'pmb','vignette_imagemagick','','Chemin de l\'excutable ImageMagick (/usr/bin/imagemagick par exemple)','',0),(268,'opac','show_rss_browser','0','Affichage des flux RSS du catalogue en page d\'accueil OPAC 1: oui  ou 0: non','f_modules',0),(269,'pmb','mail_methode','php','Mthode d\'envoi des mails : \n php : fonction mail() de php\n smtp,hote:port,auth,user,pass : en smtp, mettre O ou 1 pour l\'authentification...','',0),(270,'opac','mail_methode','php','Mthode d\'envoi des mails dans l\'opac : \n php : fonction mail() de php\n smtp,hote:port,auth,user,pass : en smtp, mettre O ou 1 pour l\'authentification...','a_general',0),(271,'opac','search_show_typdoc','1','Affichage de la restriction par type de document pour les recherches en page d\'accueil','c_recherche',0),(272,'pmb','verif_on_line','0','Dans le menu Administration > Outils > Maj Base : vrification d\'une version plus rcente de PMB en ligne ? \r\n0 : non : si vous n\'tes pas connect  internet \r\n 1 : Oui : si vous avez une connexion  internet','',0),(273,'opac','show_languages','1 fr_FR,it_IT,es_ES,ca_ES,en_UK,nl_NL,oc_FR,la_LA','Afficher la liste droulante de slection de la langue ?','a_general',0),(274,'pmb','pdf_font','Saysettha','Police de caract�res � chasse variable pour les �ditions en pdf - Police Arial','',0),(275,'pmb','pdf_fontfixed','Courier','Police de caract�res � chasse fixe pour les �ditions en pdf - Police Courier','',0),(276,'z3950','debug','0','Debugage (export fichier) des notices lues en Z3950 \r\n 0: Non \r\n 1: 0ui','',0),(277,'pmb','nb_lastnotices','10','Nombre de dernires notices affiches en Catalogue - Dernires notices','',0),(278,'opac','show_dernieresnotices_nb','10','Nombre de dernires notices affiches en Catalogue - Dernires notices','f_modules',0),(279,'pmb','recouvrement_auto','0','Par dfaut passage en recouvrement propos en gestion des relances si niveau=3 et devrait tre en 4: \r\n 1: Oui, recouvrement propos par dfaut \r\n 0: Ne rien faire par dfaut','',0),(280,'pmb','keyword_sep',' ','Sparateur des mots cls dans la partie indexation libre, espace ou ; ou , ou ...','',0),(281,'thesaurus','mode_pmb','0','Niveau d\'utilisation des thsaurus.\n 0 : Un seul thsaurus par dfaut.\n 1 : Choix du thsaurus possible.','',0),(282,'thesaurus','defaut','1','Identifiant du thsaurus par dfaut.','',0),(283,'thesaurus','liste_trad','la_LA','Liste des langues affiches dans les thsaurus.','',0),(284,'opac','thesaurus','0','Niveau d\'utilisation des thsaurus.\n 0 : Un seul thsaurus par dfaut.\n 1 : Choix du thsaurus possible.','a_general',0),(285,'acquisition','active','0','Module acquisitions activ.\n 0 : Non.\n 1 : Oui.','',0),(286,'acquisition','gestion_tva','0','Gestion de la TVA.\n 0 : Non.\n 1 : Oui.','',0),(287,'acquisition','poids_sugg','U=1.00,E=0.70,V=0.00','Pondration des suggestions par dfaut en pourcentage.\n U=Utilisateurs, E=Emprunteurs, V=Visiteurs.\n ex : U=1.00,E=0.70,V=0.00 \n','',0),(288,'acquisition','format','8,CA,DD,BL,FA','Taille du Numro et Prfixes des actes d\'achats.\nex : 8,CA,DD,BL,FA \n8 = Prfixe + 8 Chiffres\nCA=Commande Achat, DD=Demande de Devis,BL=Bon de Livraison, FA=Facture Achat \n','',0),(289,'acquisition','budget','0','Utilisation d\'un budget pour les commandes.\n 0:optionnel\n 1:obligatoire','',0),(290,'acquisition','pdfcde_format_page','210x297','Largeur x Hauteur de la page en mm','pdfcde',0),(291,'acquisition','pdfcde_orient_page','P','Orientation de la page: P=Portrait, L=Paysage','pdfcde',0),(292,'acquisition','pdfcde_marges_page','10,20,10,10','Marges de page en mm : Haut,Bas,Droite,Gauche','pdfcde',0),(293,'acquisition','pdfcde_pos_logo','10,10,20,20','Position du logo: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur','pdfcde',0),(294,'acquisition','pdfcde_pos_raison','35,10,100,10,16','Position Raison sociale: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfcde',0),(295,'acquisition','pdfcde_pos_date','150,10,0,6,8','Position Date: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfcde',0),(296,'acquisition','pdfcde_pos_adr_fac','10,35,60,5,10','Position Adresse de facturation: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfcde',0),(297,'acquisition','pdfcde_pos_adr_liv','10,75,60,5,10','Position Adresse de livraison: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfcde',0),(298,'acquisition','pdfcde_pos_adr_fou','100,55,100,6,14','Position Adresse fournisseur: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfcde',0),(299,'acquisition','pdfcde_pos_num','10,110,0,10,16','Position numro de commande: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfcde',0),(300,'acquisition','pdfcde_text_size','10','Taille de la police texte','pdfcde',0),(301,'acquisition','pdfcde_text_before','','Texte avant le tableau de commande','pdfcde',0),(302,'acquisition','pdfcde_text_after','','Texte aprs le tableau de commande','pdfcde',0),(303,'acquisition','pdfcde_tab_cde','5,10','Table de commandes: Hauteur ligne,Taille police','pdfcde',0),(304,'acquisition','pdfcde_pos_tot','10,40,5,10','Position total de commande: Distance par rapport au bord gauche de la page, Largeur, Hauteur ligne,Taille police','pdfcde',0),(305,'acquisition','pdfcde_pos_footer','15,8','Position bas de page: Distance par rapport au bas de page, Taille police','pdfcde',0),(306,'acquisition','pdfcde_pos_sign','10,60,5,10','Position signature: Distance par rapport au bord gauche de la page, Largeur, Hauteur ligne,Taille police','pdfcde',0),(307,'acquisition','pdfcde_text_sign','ຜູ້ຮັບຜິດຊອບຫໍສະໝຸດ.','Texte signature','pdfcde',0),(308,'acquisition','pdfdev_format_page','210x297','Largeur x Hauteur de la page en mm','pdfdev',0),(309,'acquisition','pdfdev_orient_page','P','Orientation de la page: P=Portrait, L=Paysage','pdfdev',0),(310,'acquisition','pdfdev_marges_page','10,20,10,10','Marges de page en mm : Haut,Bas,Droite,Gauche','pdfdev',0),(311,'acquisition','pdfdev_pos_logo','10,10,20,20','Position du logo: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur','pdfdev',0),(312,'acquisition','pdfdev_pos_raison','35,10,100,10,16','Position Raison sociale: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfdev',0),(313,'acquisition','pdfdev_pos_date','150,10,0,6,8','Position Date: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfdev',0),(314,'acquisition','pdfdev_pos_adr_fac','10,35,60,5,10','Position Adresse de facturation: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfdev',0),(315,'acquisition','pdfdev_pos_adr_liv','10,75,60,5,10','Position Adresse de livraison: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfdev',0),(316,'acquisition','pdfdev_pos_adr_fou','100,55,100,6,14','Position Adresse fournisseur: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfdev',0),(317,'acquisition','pdfdev_pos_num','10,110,0,10,16','Position numro de commande: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfdev',0),(318,'acquisition','pdfdev_text_size','10','Taille de la police texte','pdfdev',0),(319,'acquisition','pdfdev_text_before','','Texte avant le tableau de commande','pdfdev',0),(320,'acquisition','pdfdev_comment','0','Affichage des commentaires : 0=non, 1=oui','pdfdev',0),(321,'acquisition','pdfdev_text_after','','Texte aprs le tableau de commande','pdfdev',0),(322,'acquisition','pdfdev_tab_dev','5,10','Table de commandes: Hauteur ligne,Taille police','pdfdev',0),(323,'acquisition','pdfdev_pos_footer','15,8','Position bas de page: Distance par rapport au bas de page, Taille police','pdfdev',0),(324,'acquisition','pdfdev_pos_sign','10,60,5,10','Position signature: Distance par rapport au bord gauche de la page, Largeur, Hauteur ligne,Taille police','pdfdev',0),(325,'acquisition','pdfdev_text_sign','ຜູ້ຮັບຜິດຊອບຫໍສະໝຸດ.','Texte signature','pdfdev',0),(326,'opac','export_allow','1','Export de notices  partir de l\'opac : \n 0 : interdit \n 1 : pour tous \n 2 : pour les abonns uniquement','a_general',0),(327,'opac','resa_planning','0','Utiliser un planning de rservation ? \n 0: Non \n 1: Oui','a_general',0),(328,'opac','resa_contact','<a href=\'mailto:pmb@sigb.net\'>bnl@laosky.com</a>','Code HTML d\'information sur la personne � contacter par exemple en cas de probl�me de r�servation.','a_general',0),(329,'opac','default_operator','0','Oprateur par dfaut. 0 : OR, 1 : AND.','c_recherche',0),(330,'opac','modules_search_all','2','Recherche simple dans l\'ensemble des champs :0 : interdite,  1 : autorise,  2 : autorise et valide par dfaut','c_recherche',0),(331,'acquisition','pdfliv_format_page','210x297','Largeur x Hauteur de la page en mm','pdfliv',0),(332,'acquisition','pdfliv_orient_page','P','Orientation de la page: P=Portrait, L=Paysage','pdfliv',0),(333,'acquisition','pdfliv_marges_page','10,20,10,10','Marges de page en mm : Haut,Bas,Droite,Gauche','pdfliv',0),(334,'acquisition','pdfliv_pos_raison','10,10,100,10,16','Position Raison sociale: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfliv',0),(335,'acquisition','pdfliv_pos_adr_liv','10,20,60,5,10','Position Adresse de livraison: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfliv',0),(336,'acquisition','pdfliv_pos_adr_fou','110,20,100,5,10','Position lments fournisseur: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfliv',0),(337,'acquisition','pdfliv_pos_num','10,60,0,6,14','Position numro Commande/Livraison: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfliv',0),(338,'acquisition','pdfliv_tab_liv','5,10','Table de livraisons: Hauteur ligne,Taille police','pdfliv',0),(339,'acquisition','pdfliv_pos_footer','15,8','Position bas de page: Distance par rapport au bas de page, Taille police','pdfliv',0),(340,'pmb','default_operator','0','Oprateur par dfaut. \n 0 : OR, \n 1 : AND.','',0),(341,'mailretard','priorite_email_3','0','Faire le troisime niveau de relance par mail :\n 0 : Non, lettre \n 1 : Oui, par mail','',0),(342,'opac','show_suggest','0','Proposer de faire des suggestions dans l\'OPAC.\n 0 : Non.\n 1 : Oui, avec authentification.\n 2 : Oui, sans authentification.','f_modules',0),(343,'acquisition','email_sugg','0','Information par email de l\'volution des suggestions.\n 0 : Non\n 1 : Oui','',0),(344,'acquisition','pdfliv_text_size','10','Taille de la police texte','pdfliv',0),(345,'acquisition','pdfliv_pos_date','170,10,0,6,8','Position Date: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfliv',0),(346,'acquisition','pdffac_text_size','10','Taille de la police texte','pdffac',0),(347,'acquisition','pdffac_format_page','210x297','Largeur x Hauteur de la page en mm','pdffac',0),(348,'acquisition','pdffac_orient_page','P','Orientation de la page: P=Portrait, L=Paysage','pdffac',0),(349,'acquisition','pdffac_marges_page','10,20,10,10','Marges de page en mm : Haut,Bas,Droite,Gauche','pdffac',0),(350,'acquisition','pdffac_pos_raison','10,10,100,10,16','Position Raison sociale: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdffac',0),(351,'acquisition','pdffac_pos_date','170,10,0,6,8','Position Date: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdffac',0),(352,'acquisition','pdffac_pos_adr_fac','10,20,60,5,10','Position Adresse de facturation: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdffac',0),(353,'acquisition','pdffac_pos_adr_fou','110,20,100,5,10','Position lments fournisseur: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdffac',0),(354,'acquisition','pdffac_pos_num','10,60,0,6,14','Position numro Commande/Facture: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdffac',0),(355,'acquisition','pdffac_tab_fac','5,10','Table de facturation: Hauteur ligne,Taille police','pdffac',0),(356,'acquisition','pdffac_pos_tot','10,40,5,10','Position total de commande: Distance par rapport au bord gauche de la page, Largeur, Hauteur ligne,Taille police','pdffac',0),(357,'acquisition','pdffac_pos_footer','15,8','Position bas de page: Distance par rapport au bas de page, Taille police','pdffac',0),(358,'acquisition','pdfsug_text_size','8','Taille de la police texte','pdfsug',0),(359,'acquisition','pdfsug_format_page','210x297','Largeur x Hauteur de la page en mm','pdfsug',0),(360,'acquisition','pdfsug_orient_page','P','Orientation de la page: P=Portrait, L=Paysage','pdfsug',0),(361,'acquisition','pdfsug_marges_page','10,20,10,10','Marges de page en mm : Haut,Bas,Droite,Gauche','pdfsug',0),(362,'acquisition','pdfsug_pos_titre','10,10,100,10,16','Position titre: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfsug',0),(363,'acquisition','pdfsug_pos_date','170,10,0,6,8','Position Date: Distance par rapport au bord gauche de la page,Distance par rapport au haut de la page,Largeur,Hauteur,Taille police','pdfsug',0),(364,'acquisition','pdfsug_tab_sug','5,10','Table de suggestions: Hauteur ligne,Taille police','pdfsug',0),(365,'acquisition','pdfsug_pos_footer','15,8','Position bas de page: Distance par rapport au bas de page, Taille police','pdfsug',0),(366,'acquisition','mel_rej_obj','Rejet suggestion','Objet du mail de rejet de suggestion','mel',0),(367,'acquisition','mel_rej_cor','Votre suggestion du !!date!! est rejete.\n\n','Corps du mail de rejet de suggestion','mel',0),(368,'acquisition','mel_con_obj','Confirmation suggestion','Objet du mail de confirmation de suggestion','mel',0),(369,'acquisition','mel_con_cor','Votre suggestion du !!date!! est retenue pour un prochain achat.\n\n','Corps du mail de confirmation de suggestion','mel',0),(370,'acquisition','mel_aba_obj','Abandon suggestion','Objet du mail d\'abandon de suggestion','mel',0),(371,'acquisition','mel_aba_cor','Votre suggestion du !!date!! n\'est pas retenue ou n\'est pas disponible  la vente.\n\n','Corps du mail d\'abandon de suggestion','mel',0),(372,'acquisition','mel_cde_obj','Commande suggestion','Objet du mail de commande de suggestion','mel',0),(373,'acquisition','mel_cde_cor','Votre suggestion du !!date!! est en commande.\n\n','Corps du mail de commande de suggestion','mel',0),(374,'acquisition','mel_rec_obj','Rception suggestion','Objet du mail de rception de suggestion','mel',0),(375,'acquisition','mel_rec_cor','Votre suggestion du !!date!! a t reue et sera bientt disponible en rservation.\n\n','Corps du mail de rception de suggestion','mel',0),(376,'opac','allow_tags_search','0','Recherche par tag (mots cls utilisateurs) \n 1 = oui \n 0 = non','c_recherche',0),(377,'opac','allow_add_tag','0','Permettre aux utilisateurs d\'ajouter un tag  une notice.\n 0 : non\n 1 : oui\n 2 : identification obligatoire pour ajouter','a_general',0),(378,'opac','avis_allow','0','Permet de consulter/ajouter un avis pour les notices \n 0 : non \n 1 : sans tre identifi : consultation possible, ajout impossible \n 2 : identification obligatoire pour consulter et ajouter','a_general',0),(379,'opac','avis_nb_max','30','Nombre maximal de commentaires conserv par notice. Les plus vieux sont effacs au profit des plus rcent quand ce nombre est atteint.','a_general',0),(380,'pmb','show_rtl','0','Affichage possible de droite a gauche \n 0 non \n 1 oui','',0),(381,'opac','avis_show_writer','0','Afficher le rdacteur de l\'avis \n 0 : non \n 1 : Prnom NOM \n 2 : login OPAC uniquement','a_general',0),(382,'pmb','form_editables','0','Grilles de notices ditables \n 0 non \n 1 oui','',0),(383,'acquisition','sugg_to_cde','0','Transfert des suggestions en commande.\n 0 : Non.\n 1 : Oui.','',0),(384,'categories','categ_in_line','0','Affichage des catgories en ligne.\n 0 : Non.\n 1 : Oui.','',0),(385,'opac','categories_categ_in_line','0','Affichage des catgories en ligne.\n 0 : Non.\n 1 : Oui.','i_categories',0),(386,'pmb','label_construct_script','','Script de construction d\'tiquette de cote','',0),(387,'dsi','func_after_diff','','Script  excuter aprs diffusion d\'une bannette','',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `parametres` ENABLE KEYS */;

--
-- Table structure for table `pret`
--

DROP TABLE IF EXISTS `pret`;
CREATE TABLE `pret` (
  `pret_idempr` smallint(6) unsigned NOT NULL default '0',
  `pret_idexpl` smallint(6) unsigned NOT NULL default '0',
  `pret_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `pret_retour` date default NULL,
  `pret_arc_id` int(10) unsigned NOT NULL default '0',
  `niveau_relance` int(1) NOT NULL default '0',
  `date_relance` date default '0000-00-00',
  `printed` int(1) NOT NULL default '0',
  PRIMARY KEY  (`pret_idexpl`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pret`
--


/*!40000 ALTER TABLE `pret` DISABLE KEYS */;
LOCK TABLES `pret` WRITE;
INSERT INTO `pret` VALUES (7,1,'2006-10-13 15:19:51','2006-10-27',1,0,'0000-00-00',0),(2,2,'2006-10-13 15:25:18','2006-10-27',3,0,'0000-00-00',0),(5,6,'2006-10-13 15:35:07','2006-10-27',4,0,'0000-00-00',0),(5,8,'2006-10-13 15:35:23','2006-10-27',5,0,'0000-00-00',0),(6,9,'2006-10-13 15:38:51','2006-10-27',6,0,'0000-00-00',0),(11,24,'2006-08-28 14:35:57','2006-09-11',5,0,'0000-00-00',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `pret` ENABLE KEYS */;

--
-- Table structure for table `pret_archive`
--

DROP TABLE IF EXISTS `pret_archive`;
CREATE TABLE `pret_archive` (
  `arc_id` int(10) unsigned NOT NULL auto_increment,
  `arc_debut` datetime default '0000-00-00 00:00:00',
  `arc_fin` datetime default NULL,
  `arc_empr_cp` varchar(5) default '',
  `arc_empr_ville` varchar(40) default '',
  `arc_empr_prof` varchar(50) default '',
  `arc_empr_year` int(4) unsigned default '0',
  `arc_empr_categ` smallint(5) unsigned default '0',
  `arc_empr_codestat` smallint(5) unsigned default '0',
  `arc_empr_sexe` tinyint(3) unsigned default '0',
  `arc_expl_typdoc` tinyint(3) unsigned default '0',
  `arc_expl_cote` varchar(20) NOT NULL default '',
  `arc_expl_statut` smallint(5) unsigned default '0',
  `arc_expl_location` smallint(5) unsigned default '0',
  `arc_expl_codestat` smallint(5) unsigned default '0',
  `arc_expl_owner` mediumint(8) unsigned default '0',
  `arc_expl_section` int(5) unsigned NOT NULL default '0',
  `arc_expl_id` int(10) unsigned NOT NULL default '0',
  `arc_expl_notice` int(10) unsigned NOT NULL default '0',
  `arc_expl_bulletin` int(10) unsigned NOT NULL default '0',
  `arc_groupe` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`arc_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pret_archive`
--


/*!40000 ALTER TABLE `pret_archive` DISABLE KEYS */;
LOCK TABLES `pret_archive` WRITE;
INSERT INTO `pret_archive` VALUES (1,'2006-08-24 18:42:53','2006-11-08 15:50:29','856','ສີໂຄດ','ນັກຂ່າວ',5071981,10,4,1,1,'000',1,1,12,2,10,37,63,0,''),(2,'2006-08-24 18:47:30','2006-11-08 15:51:52','001','ໄຊທານີ','ນັກສິກສາ',15081987,8,4,2,1,'',1,1,12,0,10,38,60,0,''),(3,'2006-08-24 18:54:00','2006-11-08 15:54:41','001','ໄຊທານີ','ນັກສິກສາ',15081987,8,4,2,1,'',1,1,12,0,10,39,64,0,''),(4,'2006-10-13 15:35:07','2006-10-27 00:00:00','002','ນາຊາຍທອງ','ນັກຂຽນໂປແກມ',5031980,10,4,1,1,'001',1,1,10,2,10,6,2,0,''),(5,'2006-10-13 15:35:23','2006-10-27 00:00:00','002','ນາຊາຍທອງ','ນັກຂຽນໂປແກມ',5031980,10,4,1,1,'000',1,1,10,2,10,8,3,0,''),(6,'2006-10-13 15:38:51','2006-10-27 00:00:00','856','ສີໂຄດ','ນັກຂຽນໂປແກມ',7121981,10,4,1,1,'000',1,1,10,2,10,9,3,0,''),(7,'2006-10-14 08:17:42','2006-10-14 08:18:56','856','ສີສະຕະນາດ','ນັກຂຽນໂປແກມ',2101978,10,7,1,1,'009',1,1,10,2,10,15,8,0,''),(8,'2006-10-14 09:10:37','2006-10-14 09:13:35','001','ໄຊທານີ','ນັກສິກສາ',15081987,8,4,2,1,'000',1,1,10,2,10,27,25,0,''),(9,'2006-10-14 09:14:21','2006-10-16 16:59:54','856','ສີໂຄດ','ນັກຂຽນໂປແກມ',13081981,10,7,1,1,'000',1,1,10,2,10,27,25,0,''),(10,'2006-10-27 15:48:04','2006-10-27 15:51:09','001','ໄຊທານີ','ນັກສິກສາ',15081987,8,4,2,1,'010',1,1,10,2,13,29,27,0,'');
UNLOCK TABLES;
/*!40000 ALTER TABLE `pret_archive` ENABLE KEYS */;

--
-- Table structure for table `procs`
--

DROP TABLE IF EXISTS `procs`;
CREATE TABLE `procs` (
  `idproc` smallint(5) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `requete` blob NOT NULL,
  `comment` tinytext NOT NULL,
  `autorisations` mediumtext,
  `parameters` text,
  PRIMARY KEY  (`idproc`),
  KEY `idproc` (`idproc`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `procs`
--


/*!40000 ALTER TABLE `procs` DISABLE KEYS */;
LOCK TABLES `procs` WRITE;
INSERT INTO `procs` VALUES (1,'Liste expl/statut','select expl_cote, expl_cb, tit1 from exemplaires, notices where expl_statut=!!param1!! and expl_notice=notice_id order by expl_cote','Liste paramtre d\'exemplaires par statut ','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Statut]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut,statut_libelle from docs_statut]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[Choisissez un statut]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(2,'Comptage expl /statut','select statut_libelle from exemplaires, docs_statut, count(*) as Nbre where idstatut=expl_statut group by statut_libelle order by idstatut','Nombre d\'exemplaires par statut d\'exmplaire','1 2',NULL),(3,'Comptage expl /prteur','select lender_libelle, count(*) as Nbre from exemplaires, lenders where expl_owner=idlender group by lender_libelle order by lender_libelle ','Nombre d\'exemplaires par prteur','1 2',NULL),(4,'Comptage  expl /prteur /statut','select lender_libelle, idstatut, statut_libelle , count(*) as Nbre from exemplaires, lenders, docs_statut where expl_owner=idlender and expl_statut=idstatut group by lender_libelle,statut_libelle order by lender_libelle,statut_libelle ','Nombre d\'exemplaires par prteur et par statut d\'exmplaire','1 2',NULL),(5,'Liste expl d\'un prteur /statut','select lender_libelle, statut_libelle, expl_cote, expl_cb, tit1 from exemplaires, notices, docs_statut, lenders where expl_statut=!!statut!! and expl_owner=!!Proprietaire!! and expl_notice=notice_id and expl_statut=idstatut and expl_owner=idlender order by lender_libelle, statut_libelle, expl_cote, expl_cb ','Liste d\'exemplaires d\'un propritaire par statut, cote, code-barre, titre (pratique pour lister les documents non points aprs l\'import)','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Statut]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut, statut_libelle from docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"Proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietaire]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(6,'Comptage expl /section','select idsection, section_libelle, count(*) as Nbre from exemplaires, docs_section where idsection=expl_section group by idsection, section_libelle order by idsection','Nombre d\'exemplaires par section','1 2',NULL),(7,'Liste expl pour une ou plusieurs sections par prteur','select section_libelle, expl_cote, expl_cb, tit1 from exemplaires, notices, docs_section, lenders where idsection in (!!sections!!) and expl_owner=!!preteur!! and expl_notice=notice_id and expl_section=idsection and expl_owner=idlender order by section_libelle, expl_cote, expl_cb ','Liste des exemplaires ayant une ou plusieurs sections particulires pour un prteur','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sections\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Section(s)]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"preteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Prteur]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by idlender]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[Choisissez un prteur]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(8,'Stat : Compte expl /propritaire','select lender_libelle as Proprio, count(*) as Nbre from exemplaires, lenders where idlender=expl_owner group by expl_owner, lender_libelle','Nbre d\'exemplaires par propritaire d\'exemplaire','1 2',NULL),(9,'Liste expl du fonds propre','select statut_libelle, expl_cote, expl_cb, tit1 from exemplaires, notices, docs_statut where expl_owner=0 and expl_notice=notice_id and expl_statut=idstatut order by statut_libelle, expl_cote, expl_cb ','Liste des exemplaires du fonds propre par statut, cote, code-barre, titre','1 2',NULL),(10,'Liste expl pour un prteur','select expl_cote, expl_cb, tit1 from exemplaires, notices, docs_statut, lenders where expl_owner=!!proprietaire!! and expl_notice=notice_id and expl_statut=idstatut and expl_owner=idlender order by  expl_cote, expl_cb ','Liste des exemplaires pour 1 propritaire tri par cote et code-barre','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propritaire]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by idlender</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Choisissez un prteur</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(11,'Comptage lecteurs /categ','select libelle, count(*) as \'Nbre lecteurs\' from empr, empr_categ where id_categ_empr=empr_categ group by libelle order by libelle','Nombre de lecteurs par catgorie','1 2',NULL),(13,'Liste lecteurs /catgories','select libelle as Catgorie, empr_nom as Nom, empr_prenom as Prnom, empr_year as DateNaissance from empr, empr_categ where id_categ_empr=empr_categ order by libelle, empr_nom, empr_prenom','Liste des lecteurs par catgorie de lecteur, lecteur','1 2',NULL),(14,'Prts par catgories','SELECT empr_categ.libelle as Catgorie, empr.empr_nom as Nom, empr.empr_prenom as Prnom, empr.empr_cb as Numro, exemplaires.expl_cb as CodeBarre, notices.tit1 as Titre FROM pret,empr,empr_categ,exemplaires,notices WHERE empr_categ.id_categ_empr in (!!categorie!!) and empr.empr_categ = empr_categ.id_categ_empr and pret.pret_idempr = empr.id_empr and pret.pret_idexpl = exemplaires.expl_id and exemplaires.expl_notice = notices.notice_id order by 1,2,3,6','Liste des exemplaires en prt pour une ou plusieurs catgories de lecteurs','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categorie]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select id_categ_empr, libelle from empr_categ order by libelle]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(20,'Liste fonds propre / statut','select statut_libelle, expl_cote, expl_cb, tit1 from exemplaires, notices, docs_statut where expl_owner=0 and expl_notice=notice_id and expl_statut=idstatut order by statut_libelle, expl_cote, expl_cb ','Pointage fonds propre','1 2',NULL),(21,'Stat : Compte lecteurs /age','SELECT count(*), CASE WHEN  (!!param1!! - empr_year) <= 13 THEN \'Jusque 13 ans\' WHEN (!!param1!! - empr_year) >13 and (!!param1!! - empr_year)<=24 THEN \'14  24 ans\' WHEN (!!param1!! - empr_year)>24 and (!!param1!! - empr_year)<=59 THEN \'25  29 ans\' WHEN (!!param1!! - empr_year)>59 THEN \'60 ans et plus\'  ELSE \'erreur sur age\' END as categ_age from empr where empr_categ in (!!categorie!!) and (year(empr_date_expiration)=!!param1!! or year(empr_date_adhesion)=!!param1!!) group by categ_age','Nbre de lecteurs par tranche d\'age pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Catgorie]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(22,'Stat : Compte lecteurs /sexe /age','SELECT count(*), case when empr_sexe=\'1\' then \'Hommes\' when empr_sexe=\'2\' then \'Femmes\' else \'erreur sur sexe\' end as Sexe, CASE WHEN  (!!param1!! - empr_year) <= 13 THEN \'Jusque 13 ans\' WHEN (!!param1!! - empr_year) >13 and (!!param1!! - empr_year) <= 24 THEN \'14  24 ans\' WHEN (!!param1!! - empr_year) >24 and (!!param1!! - empr_year) <= 59 THEN \'25  59 ans\' WHEN (!!param1!! - empr_year) >59 THEN \'60 ans et plus\'  ELSE \'erreur sur age\' END as categ_age from empr where empr_categ in (!!categorie!!) and (year(empr_date_expiration)=!!param1!! or year(empr_date_adhesion)=!!param1!!) group by sexe, categ_age','Nbre de lecteurs par sexe et tranche d\'age pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Catgorie]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(23,'Stat : Compte lecteurs /ville /catgorie','select empr_ville as Ville, count(*) as Nbre from empr where empr_categ in (!!categorie!!) and (year(empr_date_expiration)=!!annee!! or year(empr_date_adhesion)=!!annee!!) group by empr_ville order by empr_ville','Nbre de lecteurs par ville de rsidence pour une ou plusieurs catgorie','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Catgorie]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(24,'Stat : Compte lves','SELECT count(*) as nbre_eleve from empr where empr_categ in (!!categorie!!) and and (year(empr_date_expiration)=!!annee!! or year(empr_date_adhesion)=!!annee!!)','Nbre de lecteurs \'Elve\' = catgorie  slectionner ','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Catgorie de lecteurs]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select id_categ_empr, libelle from empr_categ order by libelle]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(25,'Stat : Compte prts pour lve ou profs','SELECT count(*) as nbre_pret_eleve from pret_archive where arc_empr_categ in (!!categorie!!) and year(arc_debut) = \'!!param1!!\'\r\n','Nbre de prts pour les lves de l\'cole ou pour les profs (prts pour la classe) pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Catgorie]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select id_categ_empr, libelle from empr_categ order by libelle]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),(26,'Stat : Compte prts Documentaires E','SELECT year(arc_debut) as annee, month (arc_debut) as mois, count(*) nb_pret_Docu_E FROM pret_archive where (left (arc_expl_cote,2)=\'E \' or left (arc_expl_cote,3)=\'EB \' or left (arc_expl_cote,2)=\'E.\')and year(arc_debut) = \'!!param1!!\' group by annee, mois order by annee, mois','Nbre de prts de documentaires Enfants pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),(27,'Stat : Compte prts Fictions E','SELECT year(arc_debut) as annee, month (arc_debut) as mois, count(*) nb_prets_fiction_E FROM pret_archive where (left (arc_expl_cote,3)=\'EA \' or left (arc_expl_cote,3)=\'EBD\' or left (arc_expl_cote,3)=\'EC \' or left (arc_expl_cote,3)=\'ER \') and year(arc_debut) = \'!!param1!!\' group by annee, mois order by annee, mois','Nbre de prts de fictions Enfants pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),(28,'Stat : Compte prts Fictions A','SELECT year(arc_debut) as annee, month (arc_debut) as mois, count(*) nb_prets_fiction_A FROM pret_archive where (left (arc_expl_cote,1)=\'R\' or left (arc_expl_cote,3)=\'BD \' or left (arc_expl_cote,2)=\'JR\' or left (arc_expl_cote,3)=\'JBD\') and left (arc_expl_cote,3)<>\'RE \' and year(arc_debut) = \'!!param1!!\' group by annee, mois order by annee, mois','Nbre de prts de fictions Jeunes ou Adultes pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),(29,'Stat : Compte prts Documentaires A & J','SELECT year(arc_debut) as annee, month (arc_debut) as mois, count(*) nb_prets_Docu_A FROM pret_archive where (left (arc_expl_cote,2)=\'H \' or left (arc_expl_cote,2)=\'B \' or left (arc_expl_cote,3)=\'FR \' or left (arc_expl_cote,2)=\'J \' or left (arc_expl_cote,2)=\'J.\' or left(arc_expl_cote,1) between \'0\' and \'9\') and year(arc_debut) = \'!!param1!!\' group by annee, mois order by annee, mois','Nbre de prts de documentaires Jeunes ou Adultes pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),(30,'Stat : Compte prts TOTAL (hors Prio)','SELECT year(arc_debut) as annee, month (arc_debut) as mois, count(*) nb_prets_TOTAL FROM pret_archive where arc_expl_cote not like \'P %\' and year(arc_debut) = \'!!param1!!\' group by annee, mois order by annee, mois','Nbre total de prts hors priodiques pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),(31,'Stat : Compte prts Priodiques','SELECT year(arc_debut) as annee, month (arc_debut) as mois, count(*) nb_prets_TOTAL FROM pret_archive where arc_expl_cote like \'P %\' and year(arc_debut) = \'!!param1!!\' group by annee, mois order by annee, mois','Nbre de prts de priodiques pour une anne','1 2','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anne de calcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>');
UNLOCK TABLES;
/*!40000 ALTER TABLE `procs` ENABLE KEYS */;

--
-- Table structure for table `publishers`
--

DROP TABLE IF EXISTS `publishers`;
CREATE TABLE `publishers` (
  `ed_id` mediumint(8) unsigned NOT NULL auto_increment,
  `ed_name` varchar(255) NOT NULL default '',
  `ed_adr1` varchar(255) NOT NULL default '',
  `ed_adr2` varchar(255) NOT NULL default '',
  `ed_cp` varchar(10) NOT NULL default '',
  `ed_ville` varchar(96) NOT NULL default '',
  `ed_pays` varchar(96) NOT NULL default '',
  `ed_web` varchar(255) NOT NULL default '',
  `index_publisher` text,
  `ed_comment` text,
  PRIMARY KEY  (`ed_id`),
  KEY `ed_name` (`ed_name`),
  KEY `ed_ville` (`ed_ville`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `publishers`
--


/*!40000 ALTER TABLE `publishers` DISABLE KEYS */;
LOCK TABLES `publishers` WRITE;
INSERT INTO `publishers` VALUES (1,'ຫົ່ງກ່າລີ້ ມ່າຍ','909 third Avenue','Newyork NY 10022','01','New York','ອາເມລິກາ','www.hungryminds.com',' ຫົ່ງກ່າລີ້ ມ່າຍ ',''),(2,'ໂຮງພິມສຶກສາ','ກຳແພງນະຄອນ','','123','ສີສະຕະນາດ','ລາວ','',' ໂຮງພິມສຶກສາ ',''),(3,'ໂຮງພິມມັນທາຕຸລາດ','ກຳແພງນະຄອນ','','125','ສີໂຄດຕະບອງ','ລາວ','',' ໂຮງພິມມັນທາຕຸລາດ ',''),(4,'ໂຮງພິມດາວວິໄລ','ກຳແພງນະຄອນ','','1024','ສັງທອງ','ລາວ','',' ໂຮງພິມດາວວິໄລ ',''),(5,'ອະດິດ','ຫຼວງພະບາງ','','','ຫຼວງພະບາງ','ລາວ','',' ອະດິດ ',''),(6,'ສະຖາບັນ','ກຳແພງນະຄອນ','','','ກຳແພງນະຄອນ','ລາວ','',' ສະຖາບັນ ',''),(7,'ຫໍພິພິທະພັນ','ກຳແພງນະຄອນ','','','ກຳແພງນະຄອນ','ລາວ','',' ຫໍພິພິທະພັນ ',''),(8,'ນະຄອນຫລວງ','ກຳແພງນະຄອນ','','','ກຳແພງນະຄອນ','ລາວ','',' ນະຄອນຫລວງ ',''),(9,'ໂຮງພິມແຫ່ງລັດ','ກຳແພງນະຄອນ','','','ສີໂຄດຕະບອງ','ສປປລາວ','',' ໂຮງພິມແຫ່ງລັດ ',''),(10,'ໂຮງພິມມັນທາຕຸລາດ','','','','ກຳແພງນະຄອນ','ລາວ','',' ໂຮງພິມມັນທາຕຸລາດ ',''),(11,'ສູນຝຶກປ່າໄມ້','','','','ກຳແພງນະຄອນ','ສປປລາວ','',' ສູນຝຶກປ່າໄມ້ ',''),(12,'ການປົກຄອງ','','','','ກຳແພງນະຄອນ','ລາວ','',' ການປົກຄອງ ',''),(13,'ສີສະຫວາດການພິມ','','','','ກຳແພງນະຄອນ','ສປປລາວ','',' ສີສະຫວາດການພິມ ',''),(14,'ອົງການອະນາໄມໂລກ','','','','ກຳແພງນະຄອນ','ສປປລາວ','',' ອົງການອະນາໄມໂລກ ',''),(15,'ມູນນິທິຊາຊາກາວາ','','','','ກຳແພງນະຄອນ','ສປປລາວ','',' ມູນນິທິຊາຊາກາວາ ',''),(16,'ປາກປາສັກການພິມ','','','','ກຳແພງນະຄອນ','ສປປລາວ','',' ປາກປາສັກການພິມ ',''),(17,'ກຸງເທບ','','','','ກຸງເທບ','ໄທ','',' ກຸງເທບ ',''),(18,'ຂອນແກ່ນ','','','','ຂອນແກ່ນ','ໄທ','',' ຂອນແກ່ນ ',''),(19,'ສະພານທອງການພິມ','','','','ກຳແພງນະຄອນ','ສປປລາວ','',' ສະພານທອງການພິມ ',''),(20,'ສຳນັກພິມແລະຈຳໜ່າຍປືມ','','','','ກຳແພງນະຄອນ','ສປປລາວ','',' ສຳນັກພິມແລະຈຳໜ່າຍປືມ ','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `publishers` ENABLE KEYS */;

--
-- Table structure for table `quotas`
--

DROP TABLE IF EXISTS `quotas`;
CREATE TABLE `quotas` (
  `quota_type` int(10) unsigned NOT NULL default '0',
  `constraint_type` varchar(255) NOT NULL default '',
  `elements` int(10) unsigned NOT NULL default '0',
  `value` float default NULL,
  PRIMARY KEY  (`quota_type`,`constraint_type`,`elements`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `quotas`
--


/*!40000 ALTER TABLE `quotas` DISABLE KEYS */;
LOCK TABLES `quotas` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `quotas` ENABLE KEYS */;

--
-- Table structure for table `quotas_finance`
--

DROP TABLE IF EXISTS `quotas_finance`;
CREATE TABLE `quotas_finance` (
  `quota_type` int(10) unsigned NOT NULL default '0',
  `constraint_type` varchar(255) NOT NULL default '',
  `elements` int(10) unsigned NOT NULL default '0',
  `value` float default NULL,
  PRIMARY KEY  (`quota_type`,`constraint_type`,`elements`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `quotas_finance`
--


/*!40000 ALTER TABLE `quotas_finance` DISABLE KEYS */;
LOCK TABLES `quotas_finance` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `quotas_finance` ENABLE KEYS */;

--
-- Table structure for table `recouvrements`
--

DROP TABLE IF EXISTS `recouvrements`;
CREATE TABLE `recouvrements` (
  `recouvr_id` int(16) unsigned NOT NULL auto_increment,
  `empr_id` int(10) unsigned NOT NULL default '0',
  `id_expl` int(10) unsigned NOT NULL default '0',
  `date_rec` date NOT NULL default '0000-00-00',
  `libelle` varchar(255) default NULL,
  `montant` decimal(16,2) default '0.00',
  PRIMARY KEY  (`recouvr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `recouvrements`
--


/*!40000 ALTER TABLE `recouvrements` DISABLE KEYS */;
LOCK TABLES `recouvrements` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `recouvrements` ENABLE KEYS */;

--
-- Table structure for table `resa`
--

DROP TABLE IF EXISTS `resa`;
CREATE TABLE `resa` (
  `id_resa` mediumint(8) unsigned NOT NULL auto_increment,
  `resa_idempr` mediumint(8) unsigned NOT NULL default '0',
  `resa_idnotice` mediumint(8) unsigned NOT NULL default '0',
  `resa_idbulletin` int(8) unsigned NOT NULL default '0',
  `resa_date` datetime default NULL,
  `resa_date_debut` date NOT NULL default '0000-00-00',
  `resa_date_fin` date NOT NULL default '0000-00-00',
  `resa_cb` varchar(14) NOT NULL default '',
  `resa_confirmee` int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_resa`),
  KEY `resa_date_fin` (`resa_date_fin`),
  KEY `resa_date` (`resa_date`),
  KEY `resa_cb` (`resa_cb`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `resa`
--


/*!40000 ALTER TABLE `resa` DISABLE KEYS */;
LOCK TABLES `resa` WRITE;
INSERT INTO `resa` VALUES (3,4,3,0,'2006-10-14 09:39:39','0000-00-00','0000-00-00','',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `resa` ENABLE KEYS */;

--
-- Table structure for table `resa_ranger`
--

DROP TABLE IF EXISTS `resa_ranger`;
CREATE TABLE `resa_ranger` (
  `resa_cb` varchar(14) NOT NULL default '',
  PRIMARY KEY  (`resa_cb`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `resa_ranger`
--


/*!40000 ALTER TABLE `resa_ranger` DISABLE KEYS */;
LOCK TABLES `resa_ranger` WRITE;
INSERT INTO `resa_ranger` VALUES ('PE38');
UNLOCK TABLES;
/*!40000 ALTER TABLE `resa_ranger` ENABLE KEYS */;

--
-- Table structure for table `responsability`
--

DROP TABLE IF EXISTS `responsability`;
CREATE TABLE `responsability` (
  `responsability_author` mediumint(8) unsigned NOT NULL default '0',
  `responsability_notice` mediumint(8) unsigned NOT NULL default '0',
  `responsability_fonction` char(3) NOT NULL default '',
  `responsability_type` mediumint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`responsability_author`,`responsability_notice`,`responsability_fonction`),
  KEY `responsability_notice` (`responsability_notice`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `responsability`
--


/*!40000 ALTER TABLE `responsability` DISABLE KEYS */;
LOCK TABLES `responsability` WRITE;
INSERT INTO `responsability` VALUES (1,1,'070',0),(2,2,'070',0),(3,3,'070',0),(5,4,'070',0),(6,5,'070',0),(10,6,'070',0),(14,7,'070',0),(20,8,'070',0),(8,9,'070',0),(9,10,'070',0),(13,11,'070',0),(6,12,'070',0),(17,13,'070',0),(20,14,'070',0),(1,15,'070',0),(9,16,'070',0),(10,17,'070',0),(2,18,'070',0),(18,19,'070',0),(3,20,'070',0),(20,21,'070',0),(19,22,'070',0),(21,23,'070',0),(13,24,'070',0),(4,4,'070',0),(5,5,'070',0),(6,6,'070',0),(8,7,'068',2),(7,7,'070',0),(9,8,'070',0),(9,9,'070',0),(10,11,'070',0),(12,12,'440',1),(11,12,'070',0),(13,13,'070',0),(15,14,'044',2),(14,14,'340',2),(17,15,'007',1),(16,15,'070',0),(18,16,'070',0),(19,17,'650',0),(20,18,'061',2),(21,18,'017',2),(22,18,'017',2),(23,18,'017',2),(26,19,'070',2),(27,19,'',1),(25,19,'070',1),(24,19,'723',0),(28,42,'720',0),(30,44,'370',0),(32,46,'545',2),(31,46,'250',0),(33,48,'705',0),(34,49,'180',0),(35,50,'070',0),(36,51,'070',0),(38,53,'068',2),(37,53,'070',0),(39,54,'070',0),(40,57,'070',0),(41,57,'007',2),(63,60,'070',0),(63,59,'070',0),(62,63,'070',0),(60,65,'070',0),(61,61,'070',0),(62,64,'070',0),(20,27,'160',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `responsability` ENABLE KEYS */;

--
-- Table structure for table `rss_content`
--

DROP TABLE IF EXISTS `rss_content`;
CREATE TABLE `rss_content` (
  `rss_id` int(10) unsigned NOT NULL default '0',
  `rss_content` longblob NOT NULL,
  `rss_last` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`rss_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `rss_content`
--


/*!40000 ALTER TABLE `rss_content` DISABLE KEYS */;
LOCK TABLES `rss_content` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `rss_content` ENABLE KEYS */;

--
-- Table structure for table `rss_flux`
--

DROP TABLE IF EXISTS `rss_flux`;
CREATE TABLE `rss_flux` (
  `id_rss_flux` int(9) unsigned NOT NULL auto_increment,
  `nom_rss_flux` varchar(255) NOT NULL default '',
  `link_rss_flux` blob NOT NULL,
  `descr_rss_flux` blob NOT NULL,
  `lang_rss_flux` varchar(255) NOT NULL default 'fr',
  `copy_rss_flux` blob NOT NULL,
  `editor_rss_flux` varchar(255) NOT NULL default '',
  `webmaster_rss_flux` varchar(255) NOT NULL default '',
  `ttl_rss_flux` int(9) unsigned NOT NULL default '60',
  `img_url_rss_flux` blob NOT NULL,
  `img_title_rss_flux` blob NOT NULL,
  `img_link_rss_flux` blob NOT NULL,
  `format_flux` blob NOT NULL,
  PRIMARY KEY  (`id_rss_flux`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `rss_flux`
--


/*!40000 ALTER TABLE `rss_flux` DISABLE KEYS */;
LOCK TABLES `rss_flux` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `rss_flux` ENABLE KEYS */;

--
-- Table structure for table `rss_flux_content`
--

DROP TABLE IF EXISTS `rss_flux_content`;
CREATE TABLE `rss_flux_content` (
  `num_rss_flux` int(9) unsigned NOT NULL default '0',
  `type_contenant` char(3) NOT NULL default 'BAN',
  `num_contenant` int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (`num_rss_flux`,`type_contenant`,`num_contenant`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `rss_flux_content`
--


/*!40000 ALTER TABLE `rss_flux_content` DISABLE KEYS */;
LOCK TABLES `rss_flux_content` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `rss_flux_content` ENABLE KEYS */;

--
-- Table structure for table `rubriques`
--

DROP TABLE IF EXISTS `rubriques`;
CREATE TABLE `rubriques` (
  `id_rubrique` int(8) unsigned NOT NULL auto_increment,
  `num_budget` int(8) unsigned NOT NULL default '0',
  `num_parent` int(8) unsigned NOT NULL default '0',
  `libelle` varchar(255) NOT NULL default '',
  `commentaires` text NOT NULL,
  `montant` float(8,2) unsigned NOT NULL default '0.00',
  `num_cp_compta` varchar(255) NOT NULL default '',
  `autorisations` mediumtext NOT NULL,
  PRIMARY KEY  (`id_rubrique`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `rubriques`
--


/*!40000 ALTER TABLE `rubriques` DISABLE KEYS */;
LOCK TABLES `rubriques` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `rubriques` ENABLE KEYS */;

--
-- Table structure for table `sauv_lieux`
--

DROP TABLE IF EXISTS `sauv_lieux`;
CREATE TABLE `sauv_lieux` (
  `sauv_lieu_id` int(10) unsigned NOT NULL auto_increment,
  `sauv_lieu_nom` varchar(50) default NULL,
  `sauv_lieu_url` varchar(255) default NULL,
  `sauv_lieu_protocol` varchar(10) default 'file',
  `sauv_lieu_host` varchar(255) default NULL,
  `sauv_lieu_login` varchar(20) default NULL,
  `sauv_lieu_password` varchar(20) default NULL,
  PRIMARY KEY  (`sauv_lieu_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sauv_lieux`
--


/*!40000 ALTER TABLE `sauv_lieux` DISABLE KEYS */;
LOCK TABLES `sauv_lieux` WRITE;
INSERT INTO `sauv_lieux` VALUES (1,'sauvegarde','d:\\temp\\','file','','','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `sauv_lieux` ENABLE KEYS */;

--
-- Table structure for table `sauv_log`
--

DROP TABLE IF EXISTS `sauv_log`;
CREATE TABLE `sauv_log` (
  `sauv_log_id` int(10) unsigned NOT NULL auto_increment,
  `sauv_log_start_date` date default NULL,
  `sauv_log_file` varchar(255) default NULL,
  `sauv_log_succeed` int(11) default '0',
  `sauv_log_messages` mediumtext,
  `sauv_log_userid` int(11) default NULL,
  PRIMARY KEY  (`sauv_log_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sauv_log`
--


/*!40000 ALTER TABLE `sauv_log` DISABLE KEYS */;
LOCK TABLES `sauv_log` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `sauv_log` ENABLE KEYS */;

--
-- Table structure for table `sauv_sauvegardes`
--

DROP TABLE IF EXISTS `sauv_sauvegardes`;
CREATE TABLE `sauv_sauvegardes` (
  `sauv_sauvegarde_id` int(10) unsigned NOT NULL auto_increment,
  `sauv_sauvegarde_nom` varchar(50) default NULL,
  `sauv_sauvegarde_file_prefix` varchar(20) default NULL,
  `sauv_sauvegarde_tables` mediumtext,
  `sauv_sauvegarde_lieux` mediumtext,
  `sauv_sauvegarde_users` mediumtext,
  `sauv_sauvegarde_compress` int(11) default '0',
  `sauv_sauvegarde_compress_command` mediumtext,
  `sauv_sauvegarde_crypt` int(11) default '0',
  `sauv_sauvegarde_key1` varchar(32) default NULL,
  `sauv_sauvegarde_key2` varchar(32) default NULL,
  PRIMARY KEY  (`sauv_sauvegarde_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sauv_sauvegardes`
--


/*!40000 ALTER TABLE `sauv_sauvegardes` DISABLE KEYS */;
LOCK TABLES `sauv_sauvegardes` WRITE;
INSERT INTO `sauv_sauvegardes` VALUES (1,'tout','bibli','7','','1,3',0,'internal::',0,'',''),(2,'notice','bibli','5','','1',0,'internal::',0,'','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `sauv_sauvegardes` ENABLE KEYS */;

--
-- Table structure for table `sauv_tables`
--

DROP TABLE IF EXISTS `sauv_tables`;
CREATE TABLE `sauv_tables` (
  `sauv_table_id` int(10) unsigned NOT NULL auto_increment,
  `sauv_table_nom` varchar(50) default NULL,
  `sauv_table_tables` text,
  PRIMARY KEY  (`sauv_table_id`),
  UNIQUE KEY `sauv_table_nom` (`sauv_table_nom`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sauv_tables`
--


/*!40000 ALTER TABLE `sauv_tables` DISABLE KEYS */;
LOCK TABLES `sauv_tables` WRITE;
INSERT INTO `sauv_tables` VALUES (1,'Biblio','analysis,bulletins,docs_codestat,docs_location,docs_section,docs_statut,docs_type,exemplaires,notices,etagere_caddie,notices_custom,notices_custom_lists,notices_custom_values'),(2,'Autorits','authors,categ_assoc,categories,collections,noeuds,publishers,responsability,series,sub_collections,thesaurus,voir_aussi'),(3,'Aucune utilit','error_log,import_marc,old_categories,old_notices_categories,sessions'),(4,'Z3950','z_attr,z_bib,z_notices,z_query'),(5,'Emprunteurs','empr,empr_categ,empr_codestat,empr_custom,empr_custom_lists,empr_custom_values,empr_groupe,expl_custom_values,groupe,pret,pret_archive,resa'),(6,'Application','categories,lenders,parametres,procs,sauv_lieux,sauv_log,sauv_sauvegardes,sauv_tables,users,categ_assoc,explnum,indexint,notices_categories,origine_notice,quotas,etagere,resa_ranger,admin_session,opac_sessions,audit,notice_statut,ouvertures'),(7,'TOUT','actes,admin_session,analysis,audit,authors,bannette_abon,bannette_contenu,bannette_equation,bannette_exports,bannettes,budgets,bulletins,caddie,caddie_content,caddie_procs,categ_assoc,categories,classements,collections,comptes,coordonnees,docs_codestat,docs_location,docs_section,docs_statut,docs_type,docsloc_section,empr,empr_categ,empr_codestat,empr_custom,empr_custom_lists,empr_custom_values,empr_groupe,entites,equations,error_log,etagere,etagere_caddie,exemplaires,exercices,expl_custom,expl_custom_lists,expl_custom_values,explnum,frais,groupe,import_marc,indexint,lenders,liens_actes,lignes_actes,noeuds,notice_statut,notices,notices_categories,notices_custom,notices_custom_lists,notices_custom_values,notices_global_index,offres_remises,opac_sessions,origine_notice,ouvertures,paiements,parametres,pret,pret_archive,procs,publishers,quotas,quotas_finance,recouvrements,resa,resa_ranger,responsability,rss_content,rss_flux,rss_flux_content,rubriques,sauv_lieux,sauv_log,sauv_sauvegardes,sauv_tables,series,sessions,sub_collections,suggestions,suggestions_origine,thesaurus,transactions,tva_achats,type_abts,type_comptes,types_produits,users,voir_aussi,z_attr,z_bib,z_notices,z_query'),(9,'Caddies','caddie_procs,caddie,caddie_content'),(10,'DSI','bannette_abon,bannette_contenu,bannette_equation,bannettes,classements,equations,rss_content,rss_flux,rss_flux_content'),(11,'Finance','comptes,quotas_finance,recouvrements,transactions,type_abts,type_comptes'),(12,'',NULL);
UNLOCK TABLES;
/*!40000 ALTER TABLE `sauv_tables` ENABLE KEYS */;

--
-- Table structure for table `series`
--

DROP TABLE IF EXISTS `series`;
CREATE TABLE `series` (
  `serie_id` mediumint(8) unsigned NOT NULL auto_increment,
  `serie_name` varchar(255) NOT NULL default '',
  `serie_index` text,
  PRIMARY KEY  (`serie_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `series`
--


/*!40000 ALTER TABLE `series` DISABLE KEYS */;
LOCK TABLES `series` WRITE;
INSERT INTO `series` VALUES (1,'Dayak',' dayak '),(2,'Le pithécantrope dans la valise',' pithecantrope dans valise '),(3,'Mange-coeur',' mange coeur '),(4,'Jojo',' jojo '),(5,'à»?àº?à»‰àº§','  ');
UNLOCK TABLES;
/*!40000 ALTER TABLE `series` ENABLE KEYS */;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `SESSID` varchar(12) NOT NULL default '',
  `login` varchar(20) NOT NULL default '',
  `IP` varchar(20) NOT NULL default '',
  `SESSstart` varchar(12) NOT NULL default '',
  `LastOn` varchar(12) NOT NULL default '',
  `SESSNAME` varchar(25) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sessions`
--


/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
LOCK TABLES `sessions` WRITE;
INSERT INTO `sessions` VALUES ('1179204990','admin','127.0.0.1','1163749428','1163753279','PhpMyBibli'),('1216318863','admin','127.0.0.1','1163669698','1163670482','PhpMyBibli');
UNLOCK TABLES;
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;

--
-- Table structure for table `sub_collections`
--

DROP TABLE IF EXISTS `sub_collections`;
CREATE TABLE `sub_collections` (
  `sub_coll_id` mediumint(8) unsigned NOT NULL auto_increment,
  `sub_coll_name` varchar(255) NOT NULL default '',
  `sub_coll_parent` mediumint(9) unsigned NOT NULL default '0',
  `sub_coll_issn` varchar(12) NOT NULL default '',
  `index_sub_coll` text,
  PRIMARY KEY  (`sub_coll_id`),
  KEY `sub_coll_name` (`sub_coll_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sub_collections`
--


/*!40000 ALTER TABLE `sub_collections` DISABLE KEYS */;
LOCK TABLES `sub_collections` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `sub_collections` ENABLE KEYS */;

--
-- Table structure for table `suggestions`
--

DROP TABLE IF EXISTS `suggestions`;
CREATE TABLE `suggestions` (
  `id_suggestion` int(12) unsigned NOT NULL auto_increment,
  `titre` tinytext NOT NULL,
  `editeur` varchar(255) NOT NULL default '',
  `auteur` varchar(255) NOT NULL default '',
  `code` varchar(255) NOT NULL default '',
  `prix` float(8,2) unsigned NOT NULL default '0.00',
  `commentaires` text,
  `statut` int(3) unsigned NOT NULL default '0',
  `num_produit` int(8) NOT NULL default '0',
  `num_entite` int(5) NOT NULL default '0',
  `index_suggestion` text NOT NULL,
  `nb` int(5) unsigned NOT NULL default '1',
  `date_creation` date NOT NULL default '0000-00-00',
  `date_decision` date NOT NULL default '0000-00-00',
  `num_rubrique` int(8) unsigned NOT NULL default '0',
  `num_fournisseur` int(5) unsigned NOT NULL default '0',
  `num_notice` int(8) unsigned NOT NULL default '0',
  `url_suggestion` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_suggestion`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `suggestions`
--


/*!40000 ALTER TABLE `suggestions` DISABLE KEYS */;
LOCK TABLES `suggestions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `suggestions` ENABLE KEYS */;

--
-- Table structure for table `suggestions_origine`
--

DROP TABLE IF EXISTS `suggestions_origine`;
CREATE TABLE `suggestions_origine` (
  `origine` varchar(100) NOT NULL default '',
  `num_suggestion` int(12) unsigned NOT NULL default '0',
  `type_origine` int(3) unsigned NOT NULL default '0',
  `date_suggestion` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`origine`,`num_suggestion`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `suggestions_origine`
--


/*!40000 ALTER TABLE `suggestions_origine` DISABLE KEYS */;
LOCK TABLES `suggestions_origine` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `suggestions_origine` ENABLE KEYS */;

--
-- Table structure for table `tags`
--

DROP TABLE IF EXISTS `tags`;
CREATE TABLE `tags` (
  `id_tag` mediumint(8) NOT NULL auto_increment,
  `libelle` varchar(200) NOT NULL default '',
  `num_notice` mediumint(8) NOT NULL default '0',
  `user_code` varchar(50) NOT NULL default '',
  `dateajout` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id_tag`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `tags`
--


/*!40000 ALTER TABLE `tags` DISABLE KEYS */;
LOCK TABLES `tags` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `tags` ENABLE KEYS */;

--
-- Table structure for table `thesaurus`
--

DROP TABLE IF EXISTS `thesaurus`;
CREATE TABLE `thesaurus` (
  `id_thesaurus` int(3) unsigned NOT NULL auto_increment,
  `libelle_thesaurus` varchar(255) NOT NULL default '',
  `langue_defaut` varchar(5) NOT NULL default 'fr_FR',
  `active` char(1) NOT NULL default '1',
  `opac_active` char(1) NOT NULL default '1',
  `num_noeud_racine` int(9) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_thesaurus`),
  UNIQUE KEY `libelle_thesaurus` (`libelle_thesaurus`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `thesaurus`
--


/*!40000 ALTER TABLE `thesaurus` DISABLE KEYS */;
LOCK TABLES `thesaurus` WRITE;
INSERT INTO `thesaurus` VALUES (1,'Agneaux','fr_FR','1','1',1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `thesaurus` ENABLE KEYS */;

--
-- Table structure for table `transactions`
--

DROP TABLE IF EXISTS `transactions`;
CREATE TABLE `transactions` (
  `id_transaction` int(10) unsigned NOT NULL auto_increment,
  `compte_id` int(8) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `user_name` varchar(255) NOT NULL default '',
  `machine` varchar(255) NOT NULL default '',
  `date_enrgt` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_prevue` date default NULL,
  `date_effective` date default NULL,
  `montant` decimal(16,2) NOT NULL default '0.00',
  `sens` int(1) NOT NULL default '0',
  `realisee` int(1) NOT NULL default '0',
  `commentaire` text,
  `encaissement` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id_transaction`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `transactions`
--


/*!40000 ALTER TABLE `transactions` DISABLE KEYS */;
LOCK TABLES `transactions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `transactions` ENABLE KEYS */;

--
-- Table structure for table `tva_achats`
--

DROP TABLE IF EXISTS `tva_achats`;
CREATE TABLE `tva_achats` (
  `id_tva` int(8) unsigned NOT NULL auto_increment,
  `libelle` varchar(255) NOT NULL default '',
  `taux_tva` float(4,2) unsigned NOT NULL default '0.00',
  `num_cp_compta` varchar(25) NOT NULL default '0',
  PRIMARY KEY  (`id_tva`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `tva_achats`
--


/*!40000 ALTER TABLE `tva_achats` DISABLE KEYS */;
LOCK TABLES `tva_achats` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `tva_achats` ENABLE KEYS */;

--
-- Table structure for table `type_abts`
--

DROP TABLE IF EXISTS `type_abts`;
CREATE TABLE `type_abts` (
  `id_type_abt` int(5) unsigned NOT NULL auto_increment,
  `type_abt_libelle` varchar(255) default NULL,
  `prepay` int(1) unsigned NOT NULL default '0',
  `prepay_deflt_mnt` decimal(16,2) NOT NULL default '0.00',
  `tarif` decimal(16,2) NOT NULL default '0.00',
  `commentaire` text NOT NULL,
  `caution` decimal(16,2) NOT NULL default '0.00',
  `localisations` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_type_abt`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `type_abts`
--


/*!40000 ALTER TABLE `type_abts` DISABLE KEYS */;
LOCK TABLES `type_abts` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `type_abts` ENABLE KEYS */;

--
-- Table structure for table `type_comptes`
--

DROP TABLE IF EXISTS `type_comptes`;
CREATE TABLE `type_comptes` (
  `id_type_compte` int(8) unsigned NOT NULL auto_increment,
  `libelle` varchar(255) NOT NULL default '',
  `type_acces` int(8) unsigned NOT NULL default '0',
  `acces_id` text NOT NULL,
  PRIMARY KEY  (`id_type_compte`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `type_comptes`
--


/*!40000 ALTER TABLE `type_comptes` DISABLE KEYS */;
LOCK TABLES `type_comptes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `type_comptes` ENABLE KEYS */;

--
-- Table structure for table `types_produits`
--

DROP TABLE IF EXISTS `types_produits`;
CREATE TABLE `types_produits` (
  `id_produit` int(8) unsigned NOT NULL auto_increment,
  `libelle` varchar(255) NOT NULL default '',
  `num_cp_compta` varchar(25) NOT NULL default '0',
  `num_tva_achat` varchar(25) NOT NULL default '0',
  PRIMARY KEY  (`id_produit`),
  KEY `libelle` (`libelle`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `types_produits`
--


/*!40000 ALTER TABLE `types_produits` DISABLE KEYS */;
LOCK TABLES `types_produits` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `types_produits` ENABLE KEYS */;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `userid` int(5) NOT NULL auto_increment,
  `create_dt` date NOT NULL default '0000-00-00',
  `last_updated_dt` date NOT NULL default '0000-00-00',
  `username` varchar(20) NOT NULL default '',
  `pwd` varchar(50) NOT NULL default '',
  `nom` varchar(30) NOT NULL default '',
  `prenom` varchar(30) default NULL,
  `rights` int(8) unsigned NOT NULL default '0',
  `user_lang` varchar(5) NOT NULL default 'fr_FR',
  `nb_per_page_search` int(10) unsigned NOT NULL default '4',
  `nb_per_page_select` int(10) unsigned NOT NULL default '10',
  `nb_per_page_gestion` int(10) unsigned NOT NULL default '20',
  `param_popup_ticket` smallint(1) unsigned NOT NULL default '0',
  `param_sounds` smallint(1) unsigned NOT NULL default '1',
  `param_licence` int(1) unsigned NOT NULL default '0',
  `deflt_notice_statut` int(6) unsigned NOT NULL default '1',
  `deflt_docs_type` int(6) unsigned NOT NULL default '1',
  `deflt_lenders` int(6) unsigned NOT NULL default '0',
  `deflt_styles` varchar(20) NOT NULL default 'default',
  `deflt_docs_statut` int(6) unsigned default '0',
  `deflt_docs_codestat` int(6) unsigned default '0',
  `value_deflt_lang` varchar(20) default 'fre',
  `value_deflt_fonction` varchar(20) default '070',
  `deflt_docs_location` int(6) unsigned default '0',
  `deflt_docs_section` int(6) unsigned default '0',
  `value_deflt_module` varchar(30) default 'circu',
  `user_email` varchar(255) default '',
  `user_alert_resamail` int(1) unsigned NOT NULL default '0',
  `deflt2docs_location` int(6) unsigned NOT NULL default '0',
  `deflt_thesaurus` int(3) unsigned NOT NULL default '1',
  `value_prefix_cote` tinyblob NOT NULL,
  `xmlta_doctype` char(2) NOT NULL default 'a',
  PRIMARY KEY  (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `users`
--


/*!40000 ALTER TABLE `users` DISABLE KEYS */;
LOCK TABLES `users` WRITE;
INSERT INTO `users` VALUES (1,'2002-07-28','2006-11-15','admin','43e9a4ab75570f5b','Super User','',255,'la_LA',20,10,20,0,1,1,1,1,2,'couleurs_onglets',1,10,'lao','070',1,10,'admin','pmb@sigb.net',1,1,1,'','a'),(2,'2004-01-21','2006-10-16','circ','3f3df3af7d72f2fb','Agent de prêt','',1,'fr_FR',10,10,20,0,1,0,1,1,1,'vert_et_parme',1,10,'fre','070',1,13,'circu','',0,1,1,'','a'),(3,'2004-01-21','2006-10-16','cat','7b4ed80e2270250a','Bibliothècaire-adjoint','',7,'fr_FR',10,10,20,0,1,0,1,1,1,'default',1,10,'fre','070',1,13,'catal','',0,1,1,'','a'),(4,'2004-01-21','2006-10-16','bib','7c99ea71225fa75a','Bibliothècaire','',23,'fr_FR',10,10,20,0,1,0,1,1,1,'default',13,12,'fre','070',7,13,'circu','',0,1,1,'','a');
UNLOCK TABLES;
/*!40000 ALTER TABLE `users` ENABLE KEYS */;

--
-- Table structure for table `voir_aussi`
--

DROP TABLE IF EXISTS `voir_aussi`;
CREATE TABLE `voir_aussi` (
  `num_noeud_orig` int(9) unsigned NOT NULL default '0',
  `num_noeud_dest` int(9) unsigned NOT NULL default '0',
  `langue` varchar(5) NOT NULL default '',
  `comment_voir_aussi` text NOT NULL,
  PRIMARY KEY  (`num_noeud_orig`,`num_noeud_dest`,`langue`),
  KEY `num_noeud_dest` (`num_noeud_dest`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `voir_aussi`
--


/*!40000 ALTER TABLE `voir_aussi` DISABLE KEYS */;
LOCK TABLES `voir_aussi` WRITE;
INSERT INTO `voir_aussi` VALUES (1390,1602,'fr_FR',''),(1391,1599,'fr_FR',''),(1392,1600,'fr_FR',''),(1394,2166,'fr_FR',''),(1395,1596,'fr_FR',''),(1398,1597,'fr_FR',''),(1399,1592,'fr_FR',''),(1400,1601,'fr_FR',''),(1401,1592,'fr_FR',''),(1411,2105,'fr_FR',''),(1413,2106,'fr_FR',''),(1414,2104,'fr_FR',''),(1415,2103,'fr_FR',''),(1416,2102,'fr_FR',''),(1417,2101,'fr_FR',''),(1431,2058,'fr_FR',''),(1435,2060,'fr_FR',''),(1545,2491,'fr_FR',''),(1553,1612,'fr_FR',''),(1563,2493,'fr_FR',''),(1592,1399,'fr_FR',''),(1592,1401,'fr_FR',''),(1595,2479,'fr_FR',''),(1596,1395,'fr_FR',''),(1597,1398,'fr_FR',''),(1598,2200,'fr_FR',''),(1599,1391,'fr_FR',''),(1600,1392,'fr_FR',''),(1601,1400,'fr_FR',''),(1602,1390,'fr_FR',''),(1607,2407,'fr_FR',''),(1612,1553,'fr_FR',''),(1623,1795,'fr_FR',''),(1623,1796,'fr_FR',''),(1628,1737,'fr_FR',''),(1670,2494,'fr_FR',''),(1672,2494,'fr_FR',''),(1726,2491,'fr_FR',''),(1729,2496,'fr_FR',''),(1737,1628,'fr_FR',''),(1760,2280,'fr_FR',''),(1795,1623,'fr_FR',''),(1796,1623,'fr_FR',''),(2057,2112,'fr_FR',''),(2058,1431,'fr_FR',''),(2060,1435,'fr_FR',''),(2101,1417,'fr_FR',''),(2102,1416,'fr_FR',''),(2103,1415,'fr_FR',''),(2104,1414,'fr_FR',''),(2105,1411,'fr_FR',''),(2106,1413,'fr_FR',''),(2112,2057,'fr_FR',''),(2166,1394,'fr_FR',''),(2184,2485,'fr_FR',''),(2184,2486,'fr_FR',''),(2200,1598,'fr_FR',''),(2280,1760,'fr_FR',''),(2407,1607,'fr_FR',''),(2467,2510,'fr_FR',''),(2479,1595,'fr_FR',''),(2485,2184,'fr_FR',''),(2486,2184,'fr_FR',''),(2490,2495,'fr_FR',''),(2491,1545,'fr_FR',''),(2491,1726,'fr_FR',''),(2491,2496,'fr_FR',''),(2491,2499,'fr_FR',''),(2491,2500,'fr_FR',''),(2492,2491,'fr_FR',''),(2493,2490,'fr_FR',''),(2493,2495,'fr_FR',''),(2494,1670,'fr_FR',''),(2494,1672,'fr_FR',''),(2494,2490,'fr_FR',''),(2495,2493,'fr_FR',''),(2496,2491,'fr_FR',''),(2496,2497,'fr_FR',''),(2497,2496,'fr_FR',''),(2499,1689,'fr_FR',''),(2499,2491,'fr_FR',''),(2499,2496,'fr_FR',''),(2500,1689,'fr_FR',''),(2500,2491,'fr_FR',''),(2500,2492,'fr_FR',''),(2502,2492,'fr_FR',''),(2504,2503,'fr_FR',''),(2507,2509,'fr_FR',''),(2508,1764,'fr_FR',''),(2509,2507,'fr_FR',''),(2510,1672,'fr_FR','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `voir_aussi` ENABLE KEYS */;

--
-- Table structure for table `z_attr`
--

DROP TABLE IF EXISTS `z_attr`;
CREATE TABLE `z_attr` (
  `attr_bib_id` int(6) unsigned NOT NULL default '0',
  `attr_libelle` varchar(250) NOT NULL default '',
  `attr_attr` varchar(250) default NULL,
  PRIMARY KEY  (`attr_bib_id`,`attr_libelle`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `z_attr`
--


/*!40000 ALTER TABLE `z_attr` DISABLE KEYS */;
LOCK TABLES `z_attr` WRITE;
INSERT INTO `z_attr` VALUES (2,'sujet','21'),(2,'titre','4'),(2,'auteur','1003'),(2,'isbn','7'),(3,'sujet','21'),(3,'titre','4'),(3,'isbn','7'),(3,'auteur','1003'),(5,'auteur','1004'),(5,'titre','4'),(5,'isbn','7'),(5,'sujet','21'),(7,'isbn','7'),(7,'auteur','1003'),(7,'titre','4'),(7,'sujet','21'),(8,'auteur','1'),(8,'titre','4'),(8,'isbn','7'),(8,'sujet','21'),(8,'mots','1016'),(10,'auteur','1003'),(10,'titre','4'),(10,'isbn','7'),(10,'sujet','21'),(12,'sujet','21'),(12,'auteur','1003'),(12,'titre','4'),(12,'isbn','7'),(11,'sujet','21'),(11,'auteur','1003'),(11,'isbn','7'),(11,'titre','4'),(15,'auteur','1003'),(15,'titre','4'),(15,'isbn','7'),(15,'sujet','21'),(17,'sujet','21'),(17,'auteur','1003'),(17,'isbn','7'),(17,'titre','4'),(21,'sujet','21'),(21,'auteur','1003'),(21,'isbn','7'),(21,'titre','4');
UNLOCK TABLES;
/*!40000 ALTER TABLE `z_attr` ENABLE KEYS */;

--
-- Table structure for table `z_bib`
--

DROP TABLE IF EXISTS `z_bib`;
CREATE TABLE `z_bib` (
  `bib_id` int(6) unsigned NOT NULL auto_increment,
  `bib_nom` varchar(250) default NULL,
  `search_type` varchar(20) default NULL,
  `url` varchar(250) default NULL,
  `port` varchar(6) default NULL,
  `base` varchar(250) default NULL,
  `format` varchar(250) default NULL,
  `auth_user` varchar(250) NOT NULL default '',
  `auth_pass` varchar(250) NOT NULL default '',
  `sutrs_lang` varchar(10) NOT NULL default '',
  `fichier_func` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`bib_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `z_bib`
--


/*!40000 ALTER TABLE `z_bib` DISABLE KEYS */;
LOCK TABLES `z_bib` WRITE;
INSERT INTO `z_bib` VALUES (2,'ENS Cachan','CATALOG','138.231.48.2','21210','ADVANCE','unimarc','','','',''),(3,'BN France','CATALOG','z3950.bnf.fr','2211','ABCDEFGHIJKLMNOPQRSTUVWXYZ1456','UNIMARC','Z3950','Z3950_BNF','',''),(5,'Univ Lyon 2 SCD','CATALOG','scdinf.univ-lyon2.fr','21210','ouvrages','unimarc','','','',''),(7,'Univ Oxford','CATALOG','library.ox.ac.uk','210','ADVANCE','usmarc','','','',''),(10,'Univ Laval (QC)','CATALOG','ariane2.ulaval.ca','2200','UNICORN','USMARC','','','',''),(11,'Univ Lib Edinburgh','CATALOG','catalogue.lib.ed.ac.uk','7090','voyager','USMARC','','','',''),(12,'Library Of Congress','CATALOG','z3950.loc.gov','7090','Voyager','USMARC','','','',''),(15,'ENS Paris','CATALOG','halley.ens.fr','210','INNOPAC','UNIMARC','','','',''),(17,'Polytechnique Montral','CATALOG','advance.biblio.polymtl.ca','210','ADVANCE','USMARC','','','',''),(21,'SUDOC','CATALOG','carmin.sudoc.abes.fr','210','ABES-Z39-PUBLIC','UNIMARC','','','',''),(8,'Univ Valenciennes','CATALOG','195.221.187.151','210','INNOPAC','UNIMARC','','','','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `z_bib` ENABLE KEYS */;

--
-- Table structure for table `z_notices`
--

DROP TABLE IF EXISTS `z_notices`;
CREATE TABLE `z_notices` (
  `znotices_id` int(11) unsigned NOT NULL auto_increment,
  `znotices_query_id` int(11) default NULL,
  `znotices_bib_id` int(6) unsigned default '0',
  `isbd` text,
  `isbn` varchar(250) default NULL,
  `titre` varchar(250) default NULL,
  `auteur` varchar(250) default NULL,
  `z_marc` longblob NOT NULL,
  PRIMARY KEY  (`znotices_id`),
  KEY `idx_z_notices_idq` (`znotices_query_id`),
  KEY `idx_z_notices_isbn` (`isbn`),
  KEY `idx_z_notices_titre` (`titre`),
  KEY `idx_z_notices_auteur` (`auteur`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `z_notices`
--


/*!40000 ALTER TABLE `z_notices` DISABLE KEYS */;
LOCK TABLES `z_notices` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `z_notices` ENABLE KEYS */;

--
-- Table structure for table `z_query`
--

DROP TABLE IF EXISTS `z_query`;
CREATE TABLE `z_query` (
  `zquery_id` int(11) unsigned NOT NULL auto_increment,
  `search_attr` varchar(255) default NULL,
  `zquery_date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`zquery_id`),
  KEY `zquery_date` (`zquery_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `z_query`
--


/*!40000 ALTER TABLE `z_query` DISABLE KEYS */;
LOCK TABLES `z_query` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `z_query` ENABLE KEYS */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;

